#include <iostream>
#include <vector>
#include <map>
#include <queue>
#include <bitset>

using namespace std;

const int K = 26;
const int N = 2001;

int A[K][K];
string s;

bitset<N> dp[N];
string sdp[N];

signed main() {
	int k, n;
	cin >> k >> n;
	for (int i = 0; i < k; i++) {
		for (int j = 0; j < k; j++) {
			char c;
			cin >> c;
			A[i][j] = (c - '0');
		}
	}
	cin >> s;
	for (int i = n - 1; i >= 0; i--) {
		dp[i][i + 1] = 1;
		for (int j = i + 1; j < n; j++) {
			if (A[s[i] - 'a'][s[j] - 'a'] && (dp[i][j])) {
				dp[i] |= dp[j];
			}
		}
	}
	for (int i = n - 1; i >= 0; i--) {
		sdp[i] = string(n, 'z' + 1);
		for (int j = i + 1; j <= n; j++) {
			if (dp[i][j]) {
				if (sdp[i] > sdp[j]) {
					sdp[i] = sdp[j]; 
				}
			}
		}
	//	cerr << "sdp " << sdp[i] << endl;
		sdp[i].insert(sdp[i].begin(), s[i]);
	//	cerr << sdp[i] << endl;
	}
	//cout << sdp[n - 1] << endl;
	cout << sdp[0] << endl;
}