#include <bits/stdc++.h>

#define int long long
#define ll long long
#define ld long double
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define pii pair<int, int>
#define ff first
#define ss second

#define left left666
#define right right666
#define dist dist666
#define prev prev666
#define tm tm666

using namespace std;

mt19937 rnd(time(nullptr));

const ll INF = 1e18;
const int inf = 1.5e9, P = 1e9 + 7,  X = 2007, N = 5e5 + 10;
int n, m, cnt[N], killed[N], good[N];
string s;
vector<int> ans;
vector<pair<char, int> > sas[N];
vector<int> bad[N];

void solve() {
    cin >> n >> m >> s;
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        for (int j = 0; j < k; j++) {
            int p;
            char c;
            cin >> p >> c;
            p--;
            sas[i].push_back({c, p});
            if (s[p] != c) {
                cnt[i]++;
                bad[p].push_back(i);
            } else {
                good[p] = 1;
            }
        }
    }
    for (int i = 0; i < m; i++) {
        if (!good[i]) {
            cout << -1;
            return;
        }
    }
    deque<int> st;
    for (int i = 0; i < n; i++) {
        if (!cnt[i]) {
            st.push_back(i);
        }
    }
    while (st.size() > 0) {
        int i = st.front();
        st.pop_front();
        ans.push_back(i + 1);
        for (pair<char, int> elem : sas[i]) {
            int id = elem.ss;
            if (!killed[id]) {
                killed[id] = 1;
                for (int q : bad[id]) {
                    cnt[q]--;
                    if (cnt[q] == 0) {
                        st.push_back(q);
                    }
                }
            }
        }
    }
    if (ans.size() != n) {
        cout << -1;
        return;
    }
    for (int elem : ans) {
        cout << elem << ' ';
    }
    cout << "\n";
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    //freopen("input.txt", "r", stdin);

    //cout << setprecision(15) << fixed;
    solve();
    return 0;
}
