#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

int main() {
	ios_base::sync_with_stdio(false); cin.tie(0);
	#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	#endif
	int n, m;
	cin >> n >> m;
	string s;
	cin >> s;
	vector <map <int, char>> gs(n);
	vector <vector <int>> who(m);
	vector <int> cnt_bad(n);
	for (int i = 0; i < n; ++i) {
		int k;
		cin >> k;
		for (int j = 0; j < k; ++j) {
			int pos; char c;
			cin >> pos >> c;
			--pos;
			who[pos].push_back(i);
			gs[i][pos] = c;
			if (s[pos] != c) {
				++cnt_bad[i];
			}
		}
	}
	set <pair <int, int>> q;
	vector <int> used(n);
	for (int i = 0; i < n; ++i) {
		q.insert({cnt_bad[i], i});
	}
	vector <int> ans;
	vector <int> used_pos(m);
	while (!q.empty()) {
		int i = q.begin()->second;
		q.erase(q.begin());
		used[i] = 1;
		ans.push_back(i);
		if (cnt_bad[i] != 0) {
			cout << "-1\n";
			return 0;
		}
		for (auto p : gs[i]) {
			int pos = p.first;
			if (!used_pos[pos] && s[pos] == p.second) {
				used_pos[pos] = 1;
				for (int j : who[pos]) {
					if (!used[j] && gs[j][pos] != s[pos]) {
						q.erase({cnt_bad[j], j});
						--cnt_bad[j];
						q.insert({cnt_bad[j], j});
					}
				}
			}
		}
	}
	int ok = 1;
	for (int i = 0; i < m; ++i) ok &= used_pos[i];
	if (!ok) {
		cout << "-1\n";
		return 0;
	}
	for (int i : ans) cout << i + 1 << ' ';
}