#ifdef _MSC_VER
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <iomanip>
#include <string>
#include <vector>
#include <algorithm>
#include <cassert>
#include <random>
#include <ctime>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <deque>
#else
#include <bits/stdc++.h>
#include <bits/extc++.h>
#endif

#define all(q) q.begin(), q.end()

using namespace std;
constexpr int MAXN = (int)1e5;
vector<pair<int, char>> sym[MAXN];
int used_sym[MAXN], used_line[MAXN], cnt_bad[MAXN];
vector<pair<int, char>> conn[MAXN];

int main(int argc, char *argv[]) {
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);
	if (argc > 1)
		freopen(argv[1], "r", stdin);
	if (argc > 2)
		freopen(argv[2], "w", stdout);

	int n, m;
	cin >> n >> m;
	string s;
	cin >> s;
	for (int i = 0; i < n; ++i) {
		int k;
		cin >> k;
		for (int j = 0; j < k; ++j) {
			int a;
			char c;
			cin >> a >> c;
			sym[i].emplace_back(a - 1, c);
			conn[a - 1].emplace_back(i, c);
		}
	}

	for (int i = 0; i < n; ++i)
		for (auto [j, c] : sym[i])
			if (s[j] != c)
				++cnt_bad[i];

	int cnt_set_symb = 0;
	vector<int> ans;
	while (cnt_set_symb < m) {
		int good_ind = -1;
		for (int i = 0; i < n; ++i) {
			if (!used_line[i] && cnt_bad[i] == 0) {
				good_ind = i;
				break;
			}
		}

		if (good_ind == -1)
			break;

		for (auto [i, c] : sym[good_ind]) {
			if (used_sym[i])
				continue;
			used_sym[i] = true;
			++cnt_set_symb;
			for (auto [j, d] : conn[i])
				if (c != d && j != good_ind)
					--cnt_bad[j];
		}

		ans.push_back(good_ind);
		used_line[good_ind] = true;
	}

	if (cnt_set_symb < m) {
		cout << -1;
	} else {
		for (int i = 0; i < n; ++i)
			if (!used_line[i])
				ans.push_back(i);
		for (int x : ans)
			cout << x + 1 << ' ';
	}

	return 0;
}

/*
3 4
glhf
3 1 r 3 h 4 i
3 1 r 2 l 3 o
2 1 g 4 f
*/