#include <iostream>
#include <string>
#include <algorithm>
#include <vector>
#include <set>
#include <cstring>
using namespace std;
#define pb push_back
#define cap(x) (int)x.size()
#define all(x) (x).begin(), (x).end()
const int N = 21;
int X[N];
vector<int> g[N];
vector<int> ord[N];
vector<int> dfs(int v) {
	if (X[v] != -1) {
		return { X[v] };
	}
	vector<pair<int, vector<int>>> q;
	for (int to : g[v]) q.pb({ to, dfs(to) });
	sort(all(q), [&](pair<int, vector<int>>& a, pair<int, vector<int>>& b) {
		if (a.second.empty() || b.second.empty()) return true;
		return a.second[0] < b.second[0];
		});
	vector<int> res;
	for (auto e : q) {
		for (int i : e.second) res.pb(i);
		ord[v].pb(e.first);
	}
	return res;
}
int main() {
	ios::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);
	int n;
	cin >> n;
	vector<pair<int, int>> upd;
	vector<int> h;
	for (int i = 1; i <= n; i++) {
		int t, k;
		cin >> t;
		if (t == 1) {
			cin >> k;
			while (k--) {
				int x;
				cin >> x;
				g[i].pb(x);
			}
		}
		else {
			h.pb(i);
			int m;
			cin >> m;
			while (m--) {
				int x;
				cin >> x;
				upd.pb({ x, i });
			}
		}
	}
	int m = cap(upd);
	for (int msk = 0; msk < (1 << m); msk++) {
		memset(X, -1, sizeof X);
		for (int i = 1; i <= n; i++) ord[i].clear();
		bool ok = true;
		for (int i = 0; i < m; i++) if (msk & (1 << i)) {
			int x = upd[i].first, y = upd[i].second;
			if (X[y] != -1) {
				ok = false;
				break;
			}
			X[y] = x;
		}
		for (int i : h) if (X[i] == -1) {
			ok = false;
			break;
		}
		if (!ok) continue;
		auto v = dfs(1);
		if (!is_sorted(all(v))) continue;
		cout << "Yes\n";
		return 0;
	}
	cout << "No\n";
	return 0;
}
/*
3 7
010
001
100
abacaba
*/

/*
6
1 3 5 4 6
2 3 10 61 60
2 2 80 20
2 2 40 70
1 2 3 2
2 4 30 90 91 92
*/