#include <iostream>
#include <string>
#include <queue>
#include <set>

using namespace std;

string ans;

void solve(string s, int i, const vector<vector<bool>>& t) {
    if (i == s.size()) i--;
    while (i != 0) {
        if (t[s[i-1]-'a'][s[i]-'a']) break;
        i--;
    }
    if (i == 0) {
        ans = min(ans, s);
    } else {
        solve(s, i-1, t);
        solve(string(s.begin(), s.begin()+i) + string(s.begin()+i+1, s.end()), i, t);
    }
}

int main() {
    int k, n; cin >> k >> n;
    vector<int> len(n);
    vector t(k, vector<bool>(k));
    for (int i = 0; i < k; ++i) {
        string s; cin >> s;
        for (int j = 0; j < k; ++j) t[i][j] = s[j] == '1';
    }

    string s; cin >> s;
    ans = s;
    solve(s, s.size()-1, t);

    cout << ans << endl;
}