#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#define all(a) (a).begin(), (a).end()
#define int long long
typedef long long ll;
using namespace std;

const int INF = 1e18;

vector<string> a;

string f(string s, char c) {
    reverse(all(s));
    while (!s.empty() && a[c - 'a'][s.back() - 'a']) {
        s.pop_back();
    }
    reverse(all(s));
    return s;
}

signed main() {
#ifdef LOCAL
    freopen("input", "r", stdin);
    freopen("output", "w", stdout);
#else
    ios_base::sync_with_stdio(0);cin.tie(0);
#endif

    int k, n;
    cin >> k >> n;
    a.resize(k);
    for (int i = 0; i < k; ++i) {
        cin >> a[i];
        for (char &j : a[i]) {
            j -= '0';
        }
    }
    string s;
    cin >> s;
    vector<string> suff(n + 1);
    suff[n] = "";
    for (int i = n - 1; i >= 0; --i) {
        string best = f(suff[i + 1], s[i]);
        for (int j = i + 1; j < n && a[s[i] - 'a'][s[j] - 'a'] == 1; ++j) {
            best = min(best, f(suff[j + 1], s[i]));
        }
        suff[i] = s[i] + best;
        //cout << i << ' ' << suff[i] << endl;
    }
    cout << suff[0];
    return 0;
}
