#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#define all(a) (a).begin(), (a).end()
#define int long long
typedef long long ll;
using namespace std;

const int INF = 1e18;

vector<string> a;

bool check(string s) {

    int n = s.size();
    vector<int> nxt(n, -1), del(n, 0);
    for (int i = 0; i < n - 1; ++i) {
        nxt[i] = i + 1;
    }
    for (int i = n - 1; i >= 0; --i) {
        if (del[i]) continue;
        for (int j = nxt[i]; j != -1; j = nxt[j]) {
            if (a[s[i] - 'a'][s[j] - 'a'] == 0) {
                break;
            }
            del[j] = 1;
            nxt[i] = nxt[j];
        }
    }
    //cout << s << ' ' << (nxt[0] == -1) << endl;
    return nxt[0] == -1;
}



signed main() {
#ifdef LOCAL
    freopen("input", "r", stdin);
    freopen("output", "w", stdout);
#else
    ios_base::sync_with_stdio(0);cin.tie(0);
#endif

    int k, n;
    cin >> k >> n;
    a.resize(k);
    for (int i = 0; i < k; ++i) {
        cin >> a[i];
        for (char &j : a[i]) {
            j -= '0';
        }
    }
    string s;
    cin >> s;
    vector<string> dp(n + 1);

    for (int i = 1; i <= n; ++i) {
        string best = "z";
        for (int sz = 1; sz <= i; ++sz) {
            if (check(s.substr(i - sz, sz))) {
                best = min(best, dp[i - sz]) + s[i - sz];
            }
        }
        dp[i] = best;
        //cout << i << ' ' << dp[i] << endl;
    }
    cout << dp[n];
    return 0;
}
