#pragma GCC optimize("Ofast")

#include <unordered_set>
#include <algorithm>
#include <iostream>
#include <set>
#include <vector>
#include <string>
#include <map>

using namespace std;

const int MAXK = 26;
const int INF = (int)1e9;

char a[MAXK][MAXK];
bool canDelete[501][501];

struct segTree
{
	vector<int> arr;

	segTree(const vector<int>& a)
	{
		arr.resize(a.size() * 4);
		build(0, 0, a.size(), a);
	}

	void build(int i, int l, int r, const vector<int>& a)
	{
		if (l + 1 == r)
		{
			arr[i] = a[l];
			return;
		}

		int m = (l + r) >> 1;
		build((i << 1) + 1, l, m, a);
		build((i << 1) + 2, m, r, a);
		arr[i] = min(arr[(i << 1) + 1], arr[(i << 1) + 2]);
	}

	int getMax(int i, int l, int r, int ql, int qr) //getMin
	{
		if (ql >= r || qr <= l)
			return INF;
		if (ql <= l && r <= qr)
			return arr[i];

		int m = (l + r) >> 1;
		return min(getMax((i << 1) + 1, l, m, ql, qr), getMax((i << 1) + 2, m, r, ql, qr));
	}
};

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	int k = 0, n = 0;
	cin >> k >> n;

	for (int i = 0; i < k; ++i)
	{
		for (int j = 0; j < k; ++j)
		{
			cin >> a[i][j];
			a[i][j] -= '0';
		}
	}

	string s;
	cin >> s;

	for (int i = 0; i < n; ++i)
		s[i] -= 'a';

	/*vector<vector<int>> prv(n, vector<int>(k, -INF));
	vector<int> last(k, -INF);
	for (int i = 0; i < n; ++i)
	{
		for (int c = 0; c < k; ++c)
			if (a[c][s[i]])
				prv[i][c] = max(prv[i][c], last[c]);
		last[s[i]] = i;
	}*/

	//vector<vector<int>> canDelete(n, vector<int>(n + 1));
	for (int i = 0; i < n; ++i)
		canDelete[i][i] = canDelete[i][i + 1] = true;

	for (int len = 2; len <= n; ++len)
	{
		for (int i = 0; i + len <= n; ++i)
		{
			for (int j = i + 1; j < i + len; ++j)
			{
				if (a[s[i]][s[j]] && canDelete[i][j] && canDelete[j][i + len])
				{
					canDelete[i][i + len] = true;
					break;
				}
			}
		}
	}

	string ans;
	ans.push_back(s[0] + 'a');
	unordered_set<int> vars;
	vars.insert(0);
	for (int t = 0; t < n; ++t)
	{
		map<char, int> nextVar;
		for (auto x : vars)
		{
			if (canDelete[x][n])
			{
				cout << ans;
				return 0;
			}
			for (int i = x + 1; i < n; ++i)
			{
				if (canDelete[x][i])
					nextVar.emplace(s[i], i);
			}
		}

		vars.clear();
		for (const auto& [cc, ii] : nextVar)
		{
			if (cc == nextVar.begin()->first)
				vars.insert(ii);
			else
				break;
		}
		ans.push_back('a' + nextVar.begin()->first);
	}

	/*vector<int> maxNext(n + 1);
	for (int i = 0; i < n; ++i)
		maxNext[i + 1] = max(maxNext[i], nxt[i]);

	vector<vector<int>> posOfC(k);
	for (int i = 0; i < n; ++i)
		posOfC[s[i]].push_back(i);

	string ans;
	int curPos = -1;
	segTree segTree(nxt);

	vector*/

	cout << ans;

	return 0;
}