//#pragma GCC optimize("unroll-loops,avx,avx2,no-stack-protector,Ofast")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4.1,sse4.2")
#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>

int n;
const int MAXN = 10;
std::vector<int> g[MAXN];

std::vector<int> chosen[MAXN];

void dfs(int v) {
    if (g[v].empty()) return;
    std::vector<std::vector<int>> nowV;
    for (auto &i : g[v]) {
        dfs(i);
    }
    std::vector<int> order;
    for (auto &i : g[v]) {
        order.push_back(i);
    }
    do {
        bool good = true;
        int last = 0;
        for (int i = 0; good && i < order.size(); i++) {
            if(chosen[order[i]].empty()) continue;
            if (last > chosen[order[i]][0]) good = false;
            last = chosen[order[i]].back();
        }
        if (good) {
            for (auto &i : order) {
                for (auto &k : chosen[i]) chosen[v].push_back(k);
                chosen[i].clear();
            }
            break;
        }
    } while (std::next_permutation(order.begin(), order.end()));
}

int main() {
    std::cin >> n;
    std::vector<std::pair<int, int>> upds;
    for (int i = 0; i < n; i++) {
        int type;
        std::cin >> type;
        int c;
        std::cin >> c;
        if (type == 2) {
            for (int j = 0; j < c; j++) {
                int t;
                std::cin >> t;
                upds.emplace_back(i, t);
            }
        } else {
            for (int j = 0; j < c; j++) {
                int t;
                std::cin >> t;
                t--;
                g[i].push_back(t);
            }
        }
    }

    for (int mask = 0; mask < (1 << upds.size()); mask++) {
        for(auto &i : chosen) i.clear();
        for (int i = 0; i < upds.size(); i++) {
            if (mask & (1 << i)) {
                chosen[upds[i].first] = {upds[i].second};
            }
        }
        bool good = true;
        for (auto &i : upds) {
            if (chosen[i.first].empty()) {
                good = false;
            }
        }
        if (!good) continue;

        dfs(0);
        if(chosen[0].empty()) continue;
        std::cout << "Yes\n";
        return 0;
    }
    std::cout << "No\n";
}
