#define _CRT_SECURE_NO_WARNINGS



#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <iomanip>
#include <cstdlib>
#include <ctime>
#include <queue>



#define ll long long
#define all(a) a.begin(), a.end()


using namespace std;


int n, k, m;
int wrkt;
vector<bool> a;
vector<vector<bool>> usd;
bool ndd;


void prpr_game() {
	usd.resize(n, vector<bool>(n));
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			usd[i][j] = false;
		}
	}
}


void paint(int i1, int j1) {
	for (int i = i1; i < n; ++i) {
		for (int j = j1; j < n; ++j) {
			if (usd[i][j]) {
				break;
			}
			usd[i][j] = true;
		}
	}
	if (i1 == 0 && j1 == 0) {
		ndd = true;
	}
}


const int bts = 4;


int get_data(int &bgn, int _bts = bts) {
	int data = 0;
	for (int i = 0; i < _bts; ++i) {
		data = (data << 1);
		if (bgn + i < m) {
			data += a[bgn + i];
		}
	}
	bgn += bts;
	return data;
}


void set_data(int& bgn, int data, int _bts = bts) {
	for (int i = _bts - 1; i >= 0; --i) {
		if (bgn + i < m) {
			a[bgn + i] = (data & 1);
		}
		data = (data >> 1);
	}
	bgn += bts;
}


int get_data_by_ij(int i, int j) {
	return ((j) % (1 << bts));
}


void get_bot_mv() {
	int i, j;
	cin >> i >> j;
	--i;
	--j;
	paint(i, j);
}


void play1(bool go_frst, int &bgn) {
	prpr_game();
	ndd = false;
	if (!go_frst) {
		get_bot_mv();
	}
	while (!ndd) {
		int data = get_data(bgn);
		int resi = 0;
		int resj = 0;
		for (int i = 0; i < n; ++i) {
			for (int j = 0; j < n; ++j) {
				int ndata = get_data_by_ij(i, j);
				if (!usd[i][j] && ndata == data) {
					resi = i;
					resj = j;
				}
			}
		}
		if (resi == 0 && resj == 0) {
			bgn -= bts;
		}
		cout << resi + 1 << " " << resj + 1 << endl;
		paint(resi, resj);
		if (!ndd) {
			get_bot_mv();
		}
		
	}
}


void play1() {
	int bgn = 0;
	bool go_first = true;
	while (bgn < m) {
		play1(go_first, bgn);
		go_first = (!go_first);
	}
	cout << 0 << endl;
}


void ans1(bool go_frst, int& bgn) {
	prpr_game();
	ndd = false;
	if (!go_frst) {
		get_bot_mv();
	}
	while (!ndd) {
		int resi;
		int resj;
		cin >> resi >> resj;
		--resi;
		--resj;
		paint(resi, resj);
		int data = get_data_by_ij(resi, resj);
		if (!(resi == 0 && resj == 0)) {
			set_data(bgn, data);
		}
		if (!ndd) {
			get_bot_mv();
		}

	}
}


void ans1() {
	a.resize(m);
	int bgn = 0;
	bool go_first = true;
	int q;
	cin >> q;
	while (q--) {
		ans1(go_first, bgn);
		go_first = (!go_first);
	}
	for (auto c : a) {
		cout << c;
	}
	cout << endl;
}


int32_t main() {
	int tp_pl = 0;
	if (tp_pl == 1) {
		freopen("\\\\.\\pipe\\game.in", "r", stdin);
		freopen("\\\\.\\pipe\\game.out", "w", stdout);
	}
	else if(tp_pl == 2) {
		freopen("data.txt", "r", stdin);
	}
	cin >> wrkt;
	cin >> n >> k >> m;
	if (wrkt == 1) {
		a.resize(m);
		for (int i = 0; i < m; ++i) {
			char c;
			cin >> c;
			a[i] = (c == '1');
		}
		play1();
	}
	else {
		ans1();
	}
	return 0;
}

/*
1
32 8 16
1111000011110000
*/

/*
..\..\..\work\ 1\C\C\data.txt
..\..\..\work\ 1\C\C\ans.txt
*/