#include <bits/stdc++.h>

using namespace std;

const int MAXN = 1e5 + 10;

array<map<int, int>, MAXN> poses;
array<vector<int>, MAXN> to_better;
array<int, MAXN> cnt;
array<int, MAXN> betterised;

struct cmp {
    bool operator()(int i, int j) const {
        if (cnt[i] != cnt[j]) {
            return cnt[i] < cnt[j];
        } else {
            return i < j;
        }
    }
};

set<int, cmp> indexes;

signed main() {
    int n, m;
    cin >> n >> m;
    string s;
    cin >> s;
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        // poses[i].resize(k);
        for (int j = 0; j < k; ++j) {
            int a;
            char c;
            cin >> a >> c;
            a--;
            // cout << a << ' ' << c << endl;
            if (c == s[a]) {
                poses[i][a] =  1;
            } else {
                poses[i][a] = 2;
                cnt[i]++;
                to_better[a].push_back(i);
            }
        }
    }
    // cout << "HELLO" << endl;
    for (int i = 0; i < n; ++i) {
        indexes.insert(i);
    }
    vector<int> ans;
    while (ans.size() < n) {
        int i = *indexes.begin();//cout << i << endl;
        if (cnt[i] == 0) {
            indexes.erase(indexes.begin());
            for (auto [ind, t] : poses[i]) {
                // cout << ind << ' ' << t << endl;
                if (t == 1 && !betterised[ind]) {
                    betterised[ind] = 1; 
                    // cout << ind << endl;
                    for (auto elem : to_better[ind]) {
                    //     cout << elem << endl;
                        poses[elem][ind] = 0;
                        indexes.erase(elem);
                        cnt[elem]--;
                        indexes.insert(elem);
                    }
                }
            }
            ans.push_back(i);
        } else {
            cout << -1;
            return 0;
        }
    }
    for (int i = 0; i < m; ++i) {
        if (!betterised[i]) {
            cout << -1;
            return 0;
        }
    }
    for (auto elem : ans) {
        cout << elem + 1 << ' ';
    }
    cout << endl;
    return 0;
}