#include <bits/stdc++.h>

//#pragma GCC optimize("O3")
//#pragma GCC optimize("unrool-loops")

using namespace std;

void IO() {
#ifdef DIVAN
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
}

typedef long long ll;

template<typename T>
istream& operator>>(istream& in, vector<T>& a) {
    for (auto &u : a) {
        in >> u;
    }
    return in;
}

template<typename T>
ostream& operator<<(ostream& out, const vector<T>& a) {
    for (auto &u : a) {
        out << u << ' ';
    }
    return out;
}

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define sz(x) ((int)x.size())
#define forn(i, n) for (int i = 0; i < (n); ++i)
#define eb emplace_back
#define vi vector<int>
#define pi pair<int,int>
#define vpi vector<pi>

auto seed = chrono::high_resolution_clock::now().time_since_epoch().count();
mt19937 rnd(seed);

const int MAXN = 26;
const int MAXE = 5e5 + 15;

bool can[MAXN][MAXN];
vi adj[MAXE];
bool canEnd[MAXE];
vi a;
int cnt[MAXE];

string dp[MAXN];

bool CanDelete(int l, int r) {
    if (l >= r) {
        return true;
    }
    if (!can[a[l]][a[l + 1]]) {
        return false;
    }
    vi poses;
    for (int i = l + 1; i <= r;++i) {
        poses.eb(i);
    }
    for (int i = sz(poses) - 1; i > 0; --i) {
        if (can[a[poses[i - 1]]][a[poses[i]]]) {
            poses.erase(poses.begin() + i);
            i = min(i, sz(poses) - 1) + 1;
        }
    }
    for (auto u : poses) {
        if (!can[a[l]][a[u]]) {
            return false;
        }
    }
    return true;
}

string ans;

void DFS(int from) {
    ans += char(a[from] + 'a');
    vi now, nxt = {from};
point:
    swap(now, nxt);
    nxt.clear();
    if (now.empty()) {
        return;
    }
    int to = 300;
    for (auto v : now) {
        if (canEnd[v]) {
            return;
        }
        for (auto u : adj[v]) {
            to = min(to, a[u]);
        }
    }
    ans += char(to + 'a');
    for (auto v : now) {
        for (auto u : adj[v]) {
            if (a[u] == to) {
                nxt.eb(u);
            }
        }
    }
    sort(all(nxt));
    nxt.resize(unique(all(nxt)) - nxt.begin());
    goto point;
}

void Solve() {
    int k, n;
    cin >> k >> n;
    forn(i, k) {
        forn(j, k) {
            char x;
            cin >> x;
            can[i][j] = (x - '0');
        }
    }
    forn(i, n) {
        char x;
        cin >> x;
        a.eb(x - 'a');
    }
    forn(i, n) {
        cnt[i] = 1;
        if (CanDelete(i, n - 1)) {
            canEnd[i] = 1;
        }
        for (int j = i + 1; j < n; ++j) {
            if (CanDelete(i, j - 1)) {
//                cout << i << ' ' << j << '\n';
                adj[i].eb(j);
            }
        }
    }
    DFS(0);
    cout << ans;
}

signed main() {
//    freopen("/tmp/game.in", "r", stdin);
//    freopen("/tmp/game.out", "w", stdout);
    int start = clock();
    IO();
    Solve();
#ifdef DIVAN
    int Timeme = (clock() - start + 999) / 1000;
    cout << '\n' << "TIME: " << Timeme;
#endif
    return 0;
}