#include<iostream>
#include<stdio.h>
#include<string>
#include<vector>
#include<deque>
#include<set>
#include<algorithm>
#define mp make_pair
using namespace std;
bool arr[26][26];

void deleteSimilarSymbols(char tgt, string& s)
{
	string sTmp;

	bool WasTgt = false;

	for (auto ch : s)
	{
		if (ch != tgt || !WasTgt)
			sTmp += ch;

		WasTgt = (ch == tgt);
	}

	s = sTmp;
}

vector<pair<char, int>> getDevidedString(string s)
{
	char l = '1';
	int curCnt = 0;

	vector<pair<char, int>> ans;

	for (int i = 0; i < s.size(); i++)
	{
		if (l != s[i])
		{
			if (l != '1')
			{
				ans.push_back(mp(l, curCnt));
			}

			curCnt = 1;
			l = s[i];
		}
		else
		{
			curCnt++;
		}
	}

	ans.push_back(mp(l, curCnt));
	return ans;
}

vector<pair<char, pair<int, int>>> getSortedCharList(vector<pair<char, int>> v)
{
	vector<pair<char, pair<int, int>>> ans;

	for (int i = 0; i < v.size(); i++)
	{
		ans.push_back(mp(v[i].first, mp(-i, v[i].second)));
	}

	ans.push_back(mp('1', mp(-(int)v.size(), 1)));
	sort(ans.begin(), ans.end());
	return ans;
}

bool isPossibleToBeFirst(vector<pair<char, int>> v, int pos, int leftBorder)
{
	deque<int> stack;
	stack.push_back(leftBorder);

	for (int i = 0; i < pos; i++)
	{
		int curChar = v[i].first - 'a';

		while (true)
		{
			if (curChar < 0 || arr[stack.back()][curChar])
			{
				stack.push_back(curChar);
				break;
			}
			else
			{
				stack.pop_back();

				if (stack.empty())
					return false;
			}
		}
	}

	return true;
}

vector<pair<char, int>> getSubVector(vector<pair<char, int>> v, int start, int finish)
{
	vector<pair<char, int>> ans;

	for (int i = start; i <= finish; i++)
		ans.push_back(v[i]);

	return ans;
}

int main()
{
	int k, n;
	cin >> k >> n;

	for (int i = 0; i < k; i++)
		for (int j = 0; j < k; j++)
		{
			char a;
			cin >> a;
			arr[i][j] = a - '0';
		}

	string s;
	cin >> s;

	/*for (int ch = 0; ch < k; ch++)
	{
		if (arr[ch][ch])
			deleteSimilarSymbols(ch + 'a', s);
	}*/

	/*if (k <= 2)
	{
		if (k == 1)
		{
			cout << s;
			return 0;
		}

		if (arr[1].find(0) == arr[1].end())
		{
			cout << s;
			return 0;
		}



		if (s[0] == 'b')
			cout << 'b';

		int cnt = 0;

		for (auto ch : s)
			if (ch == 'a')
				cout << 'a';

		return 0;

	}*/
	
	auto sDevided = getDevidedString(s);
	vector<pair<char, int>> ans;
	ans.push_back(sDevided[0]);
	int leftBorder = 0;
	
	while (true)
	{
		auto vTmp = getSubVector(sDevided, leftBorder + 1, sDevided.size() - 1);
		auto v = getSortedCharList(vTmp);

		for (auto p : v)
		{
			if (isPossibleToBeFirst(vTmp, -p.second.first, sDevided[leftBorder].first - 'a'))
			{
				if (p.first != '1')
					ans.push_back(mp(p.first, p.second.second));

				leftBorder += (-p.second.first + 1);
				break;
			}
		}

		if (leftBorder >= sDevided.size() - 1)
			break;
	}

	vector<pair<char, int>> ansTmp;
	char l = '1';
	int curCnt = 0;

	for (int i = 0; i < ans.size(); i++)
	{
		if (ans[i].first != l)
		{
			if (l != '1')
			{
				ansTmp.push_back(mp(l, curCnt));
			}

			l = ans[i].first;
			curCnt = ans[i].second;
		}
		else
		{
			curCnt += ans[i].second;
		}
	}

	ansTmp.push_back(mp(l, curCnt));
	ans = ansTmp;

	for (int i = 0; i < ans.size(); i++)
	{
		if (!arr[ans[i].first - 'a'][ans[i].first - 'a'])
			continue;

		bool isSmallest = true;

		for (int j = i + 1; j < ans.size(); j++)
			isSmallest &= (ans[i].first < ans[j].first);

		if (!isSmallest || i == ans.size() - 1)
			ans[i].second = 1;
	}

	for (auto p : ans)
		for (int i = 0; i < p.second; i++)
			cout << p.first;
}