#include <bits/extc++.h>

using namespace std;

typedef long long ll;
typedef double dl;
typedef vector<int> vi;

#define nl '\n'
#define all(a) (a).begin(), (a).end()
#define minq(a, b) (a) = min(a, b)
#define maxq(a, b) (a) = max(a, b)
#define sz(a) (int((a).size()))
#define forn(i, n) for (int i = 0; i < (n); i++)

void IO() {
#ifdef SEVA
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#else
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
#endif
}

const int N = (int) 1e5 + 10;

vi ans;
map<int, char> cards[N];
bool used[N];
set<int> badPos[N], badCard[N];
bool usedCard[N];

void Rec(int id) {
    ans.emplace_back(id);
    usedCard[id] = true;
    vi nxt;
    for (auto& [pos, val] : cards[id]) {
        if (used[pos])
            continue;
        used[pos] = true;
        for (auto& c : badCard[pos]) {
            badPos[c].erase(pos);
            if (badPos[c].empty())
                nxt.emplace_back(c);
        }
    }
    for (auto& i : nxt) {
        Rec(i);
    }
}

void Solve() {
    int n, m;
    cin >> n >> m;
    string s;
    cin >> s;
    forn(j, n) {
        auto &mp = cards[j];
        int k;
        cin >> k;
        forn(i, k) {
            int a;
            char c;
            cin >> a >> c;
            a--;
            mp[a] = c;
        }
    }
    forn(i, n) {
        for (auto&[pos, val] : cards[i]) {
            bool b = s[pos] == val;
            if (b)
                continue;
            badCard[pos].emplace(i);
            badPos[i].emplace(pos);
        }
    }
    forn(i, n) {
        if (badPos[i].empty() && !usedCard[i]) {
            Rec(i);
        }
    }
    if (count(used, used + m, false) == 0) {
        for (auto& i : ans) {
            cout << i + 1 << ' ';
        }
        forn(i, n) {
            if (!usedCard[i])
                cout << i + 1 << ' ';
        }
    }
    else {
        cout << -1 << nl;
    }
}

signed main() {
    IO();
    Solve();
    return 0;
}