#include <iostream>
#include <vector>
#include <string>
#include <set>

using namespace std;

const int maxn = 1e5;
std::string s;
set <int> a[maxn];
vector <int> b[maxn];

int main() {
	int n, m;
	cin >> n >> m >> s;
	for (int i = 0; i < n; i++) {
		int t;
		cin >> t;
		while (t--) {
			int f; char sec;
			cin >> f >> sec;
			if (s[f - 1] != sec) 
				a[i].insert(f);
			else b[i].push_back(f);
		}
	}
	int used[maxn];
	int color_used[maxn];
	memset(used, 0, sizeof(used));
	memset(color_used, 0, sizeof(used));
	vector <int> que;
	int q = 0;
	for (int i = 0; i < n; i++) {
		if (a[i].size() == 0) { que.push_back(i); used[i] = 1; }
	}
	vector <int> ans;
	while (q < que.size()) {
		int p = que[q];
		ans.push_back(p);
		for (auto c : b[p]) {
			if (color_used[c]) continue;
			for (int i = 0; i < n; i++) {
				if (used[i]) continue;
				a[i].erase(c);
			}
			color_used[c] = 1;
		}
		for (int i = 0; i < n; i++) {
			if (used[i]) continue;
			if (a[i].size() == 0) {
				used[i] = 1;
				que.push_back(i);
			}
		}
		q++;
	}
	bool f = 0;
	for (int i = 0; i < m; i++) {
		if (color_used[i] == 0) f = 1;
	}
	if (ans.size() < n || f) {
		cout << -1;
		return 0;
	}
	for (auto i : ans) cout << i + 1 << " ";
	return 0;
}