#include <iostream>
#include <bitset>
#include <vector>

using namespace std;

int main()
{
	int n, m;
	cin >> n >> m;
	string s;
	cin >> s;
	bitset<100000> set_bs;
	for (int i = 0; i < m; i++)
		set_bs[i] = 1;
	vector<pair<bitset<100000>, bitset<100000>>> cards(m);
	for (int i = 0; i < n; i++)
	{
		cards[i].second |= set_bs;
		cards[i].first.reset();
		int k;
		cin >> k;
		for (int j = 0; j < k; j++)
		{
			int a;
			char c;
			cin >> a >> c;
			cards[i].second[a - 1] = 0;
			if (s[a - 1] == c)
				cards[i].first[a - 1] = 1;
		}
	}

	vector<bool> used(n, false);
	vector<int> ans;
	bool f = true;
	pair<bitset<100000>, bitset<100000>> t;
	t.second |= set_bs;
	while (f)
	{
		f = false;

		for (int i = 0; i < n; i++)
		{

			if (used[i]) continue;

			if ((t.first | (cards[i].first & t.second) | (t.second & cards[i].second)).count() == m)
			{
				ans.push_back(i);
				used[i] = true;
				f = true;
				t.first |= cards[i].first & t.second;
				t.second &= cards[i].second;
			}

		}
	}

	for (int i = 0; i < n; i++)
	{
		if (!used[i])
			ans.push_back(i);
	}

	if (t.first.count() == m)
	{
		for (auto& x : ans)
			cout << x + 1 << " ";
	}
	else cout << "-1\n";
}