#include <bits/stdc++.h>
using namespace std;
const int INF=1e9;
struct SegmentTree{
    vector<int> tree;
    int n,val;
    SegmentTree(int n,int val):n(n),val(val){
        tree.assign(4*n,val);
    }
    void set(int v,int l,int r,int i,int x){
        tree[i]=x;
        /*
        if(r-l==1){
            tree[v]=x;
            return;
        }
        int m=(r+l)/2;
        if(i<m)
            set(2*v+1,l,m,i,x);
        else
            set(2*v+2,m,r,i,x);
        tree[v]=min(tree[2*v+1],tree[2*v+2]);*/
    }
    int get(int v,int l,int r,int lq,int rq){
        int ans=val;
        for(int i=lq;i<rq;++i){
            ans=min(ans,tree[i]);
        }
        return ans;
            /*
        if(l>=rq || r<=lq)
            return val;
        if(l>=lq && r<=rq)
            return tree[v];
        int m=(r+l)/2;
        return min(get(2*v+1,l,m,lq,rq),get(2*v+2,m,r,lq,rq));*/
    }
};

signed main() {
    int k;
    int n;
    cin>>k>>n;

    vector<vector<int>> A(k+1,vector<int>(k+1,0));
    for(int i=0;i<k;++i){
        for(int j=0;j<k;++j){
            char c;
            cin>>c;
            A[i+1][j+1]=c-'0';
        }
    }
    string str;
    cin>>str;
    vector<int>s(n);
    for(int i=0;i<n;++i){
        s[i]=str[i]-'a'+1;
    }
    s.push_back(0);
    n++;
    k++;


    SegmentTree seg(n,INF);
    for(int i=1;i<n;++i){
        seg.set(0,0,n,i,-1);
        for(int j=i-1;j>=0;--j){
            int t=seg.get(0,0,n,j+1,i);
            if(A[s[j]][s[i]] && ((t!=INF && t>=j) || j==i-1)){
                seg.set(0,0,n,i,j);
                break;
            }
        }
    }


    vector<int> nextL(k,INF);
    vector<int> nxt(n,INF);
    for(int i=n-1;i>=0;--i){
        for(int j=0;j<s[i];++j)
            nxt[i]=min(nxt[i],nextL[j]);

        nextL[s[i]]=i;
    }


    vector<int> ans={0};
    for(int i=1;i<n-1;++i){
        int j=nxt[i];
        assert(j>i);

//        if(j!=INF){
            int g=seg.get(0,0,n,ans.back()+1,j);
            if(g>=ans.back()){
                i=j-1;
                continue;
            }
//        }
        ans.push_back(i);
    }

    assert(!ans.empty());
    for(int i:ans){
        cout<<(char)('a'+s[i]-1);
    }

}
