#include <iostream> 
#include <vector>
#include <algorithm>
#include <string>
#define int long long
#define all(a) a.begin(), a.end()
#define vi vector<int>
using namespace std;
const int N = 1e5;

vi g[N + N];
vi ord;
int n, m, used[N + N];

void dfs(int v) {
	used[v] = 1;
	for (int to : g[v])
		if (!used[to])
			dfs(to);
	ord.push_back(v);
}

int32_t main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);
	cin >> n >> m;
	string s;
	cin >> s;
	vi cnt(m);
	for (int i = 0; i < n; ++i) {
		int k;
		cin >> k;
		for (int j = 0; j < k; ++j) {
			int ind;
			char c;
			cin >> ind >> c;
			cnt[ind - 1]++;
			if (c != s[ind - 1]) {
				g[ind - 1 + n].push_back(i);
			}
			else
				g[i].push_back(ind - 1 + n);
		}
	}
	for (int i  =0; i < m; ++i)
		if (!cnt[i]) {
			cout << -1;
			return 0;
		}
	for (int i = 0; i < n + m; ++i)
		if (!used[i])
			dfs(i);
	reverse(all(ord));
	vi obr(n + m);
	for (int i = 0; i < n + m; ++i)
		ord[ord[i]] = i;
	for (int i = 0; i < n + m; ++i) {
		for (int to : g[i])
			if (obr[to] < i) {
				cout << -1;
				return 0;
			}
	}
	for (int x : ord)
		if (x < n)
			cout << x + 1 << " ";
}