#include <iostream> 
#include <vector>
#include <algorithm>
#include <string>
#define int long long
#define all(a) a.begin(), a.end()
#define vi vector<int>
using namespace std;
const int N = 1e5;

vi g[N + N], ord;
int n, m, used[N + N], indeg[N];

void obr(int i) {
	used[i] = 1;
	if (i < n) {
		if (indeg[i] == 0) {
			ord.push_back(i);
			for (int to : g[i])
				if (!used[to]) {
					obr(to);
				}
		}
	}
	else {
		for (int to : g[i]) {
			indeg[to]--;
			if (indeg[to] == 0)
				obr(to);
		}
	}
}

int32_t main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);
	cin >> n >> m;
	string s;
	cin >> s;
	vi cnt(m);
	for (int i = 0; i < n; ++i) {
		int k;
		cin >> k;
		for (int j = 0; j < k; ++j) {
			int ind;
			char c;
			cin >> ind >> c;
			cnt[ind - 1]++;
			if (c != s[ind - 1])
				g[ind - 1 + n].push_back(i), indeg[i]++;
			else
				g[i].push_back(ind - 1 + n);

		}
	}
	for (int i  =0; i < m; ++i)
		if (!cnt[i]) {
			cout << -1;
			return 0;
		}
	for (int i = 0; i < n; ++i)
		if (!used[i])
			obr(i);
	if (ord.size() < n) {
		cout << -1;
	}
	else {
		for (int x : ord)
			cout << x + 1 << " ";
	}
}