#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <list>
#include <stack>
#include <cassert>

using namespace std;

#define range(i, n) for (int i = 0; i < (n); ++i)
#define rrange(i, n) for (int i = (n) - 1; i >= 0; --i)
#define prange(i, n) for (int i = 1; i <= (n); ++i)

#define all(a) a.begin(), a.end()

typedef pair<int, int> pii;
#define fi first
#define se second
#define pb push_back

void setup() {
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#endif
//    ios_base::sync_with_stdio(false);
//    cin.tie(nullptr);
}

void solve();
int main() {
//    setup();
    solve();
    return 0;
}

#ifdef LOCAL
const int MAXN = 100 + 10;
#else
const int MAXN = 1e5 + 10;
#endif

int n, k, m;
void solve1();
void solve2();
void solve() {
    int t; cin >> t;
    cin >> n >> k >> m;
    if (t == 1) {
        solve1();
    } else {
        solve2();
    }
}

void pans(int y, int x) {
    cout << y << ' ' << x << endl;
}
void rans() {
    int a, b; cin >> a >> b;
}

void solve1() {
    string x; cin >> x;
    range(i, m) {
        if (i & 1) rans();
        if (x[i] == '1') {
            pans(30, 30);
            rans();
        }
        pans(1, 2);
        rans();
        pans(2, 1);
        rans();
    }
    cout << 0 << endl;
}

void solve2() {
    int q; cin >> q;
    string x; x.resize(m);
    range(i, m) {
        int a, b;
        int cnt = 0;
        while (true) {
            ++cnt;
            cin >> a >> b;
            if (a == 1 && b == 1) break;
        }
        if (cnt >= 6) {
            x[i] = '1';
        } else {
            x[i] = '0';
        }
    }
    cout << x << endl;
}