#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;

typedef long long ll;

//#define int ll
#define loop(i, n) for (int i = 0; i < n; ++i)
#define loop1(i, n) for (int i = 1; i <= n; ++i)
#define all(x) begin(x), end(x)
#define pi pair <int, int> 
#define ti tuple <int, int, int>
#define mkp make_pair
#define mkt make_tuple
#define F first
#define S second

const int K = 27, N = 10007;

bool ed[K][K];
int bor[K][K][N];
string ans;

void go(int R, int lay, int v, int k) {
	if (bor[k][v][lay] <= R)
		return;
	loop(i, k)
		if (bor[i][v][lay] <= R) {
			ans.push_back(i + 'a');
			go(R, lay + 1, i, k);
			return;
		}
}

void add(int lay, int v, int val, int k) {
	if (lay == ans.size()) {
		bor[k][v][lay] = val;
		return;
	}
	bor[ans[lay] - 'a'][v][lay] = val;
	add(lay + 1, ans[lay] - 'a', val, k);
}

void solve() {
	int k, n;
	cin >> k >> n;
	loop(i, K)
		loop(j, K)
			loop(k, N)
				bor[i][j][k] = n;
	loop(i, k) 
		loop(j, k) {
			char c; cin >> c;
			ed[i][j] = c - '0';
		}
	string s; cin >> s;
	for (int i = n - 1; i >= 0; --i) {
		int R = i + 1;
		string cur = ""; 
		cur.push_back(s[i]);
		for (; R < n; ++R) {
			while (cur.size() > 1 && !ed[cur.back() - 'a'][s[R] - 'a'])
				cur.pop_back();
			if (cur.size() == 1 && !ed[s[i] - 'a'][s[R] - 'a'])
				break;
			cur.push_back(s[R]);
		}
		ans.clear();
		ans.push_back(s[i]);
		go(R, 0, 0, k);
		add(0, 0, i, k);
	}
	cout << ans;
}

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	solve();
	return 0;
}

