#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <map>
#include <assert.h>
//#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
//using namespace __gnu_pbds;

typedef long long ll;

//#define int ll
//#define map gp_hash_table
#define loop(i, n) for (int i = 0; i < n; ++i)
#define loop1(i, n) for (int i = 1; i <= n; ++i)
#define all(x) begin(x), end(x)
#define pi pair <int, int> 
#define ti tuple <int, int, int>
#define mkp make_pair
#define mkt make_tuple
#define F first
#define S second

const int N = 32, K = 8, M = 100000;

string s;
int pos, row[N];

bool our() {
	if (row[1] == 0 || s[pos] == '1' && row[0] == 1) {
		cout << "1 1" << endl;
		return false;
	}
	bool ok = 0;
	for (int i = N - 1; i >= 0; --i) {
		if (s[pos] == '0' && row[i] || s[pos] == '1' && row[i] > 1) {
			int x = ((row[i] - 1 & 1) == (s[pos] - '0' & 1) ? row[i] - 1 : row[i] - 2);
			cout << x + 1 << " " << i + 1 << endl;
			for (int j = i; j < N; ++j)
				row[j] = min(row[j], x);
			ok = 1; break;
		}
	}
	if (ok)
		return true;
	else {
		cout << "1 1" << endl;
		return false;
	}
}

bool jury() {
	int x, y;
	cin >> x >> y;
	--x, --y;
	for (int j = y; j < N; ++j)
		row[j] = min(row[j], x);
	return x || y;
}

void play_game(bool f) {
	if (!f) {
		while (1) {
			if (!our())
				return;
			if (!jury())
				return;
		}
	}
	else {
		while (1) {
			if (!jury())
				return;
			if (!our())
				return;
		}
	}
}

void solve1() {
	cin >> s;
	bool f = 0;
	while (pos < M) {
		loop(i, N)
			row[i] = N;
		play_game(f);
		f = !f;
	}
	cout << 0 << endl;
}

void solve2() {
	assert(0);
	int sz; cin >> sz;
	string ans;
	loop(k, sz) {
		int x = -1, y = -1, cnt = 0;
		while (x != 0 || y != 0) {
			cin >> x >> y;
			--x, --y;
			if ((k & 1) == (cnt & 1) && (x != 0 || y != 0))
				ans.push_back((x & 1) + '0');
		}
	}
	cout << ans << endl;
}

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int type, usls; 
	cin >> type >> usls >> usls >> usls;
	if (type == 1)
		solve1();
	if (type == 2)
		solve2();
	return 0;
}

