#include <bits/stdc++.h>

using namespace std;

//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("fast-math")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC target("tune=native")

#define ios ios_base::sync_with_stdio(true);cin.tie(0);cout.tie(0);
#define ll long long
#define len(x) (int)(x.size())

const ll INF = 2e18;

int k, n;
vector<int> s;
vector<vector<bool>> del;
vector<bool> possibleToDelete;
vector<int> ans;

void read(){
    cin >> k >> n;
    s.resize(n);
    del.resize(k, vector<bool>(k));
    string ss;
    for (int i = 0; i < k; ++i) {
        cin >> ss;
        for (int j = 0; j < k; ++j) {
            del[i][j] = ss[j] == '1';
        }
    }
    cin >> ss;
    for (int i = 0; i < n; ++i) {
        s[i] = ss[i] - 'a';
    }
}

void calcDeletable(){
    possibleToDelete.resize(n);
    vector<vector<int>> prev(n, vector<int>(k, -1));
    prev[0][s[0]] = 0;
    for (int i = 1; i < n; ++i) {
        int max_prev = -1;
        for (int j = 0; j < k; ++j) {
            if(del[j][s[i]]){
                max_prev = max(max_prev, prev[i-1][j]);
            }
        }
        if(max_prev != -1){
            possibleToDelete[i] = true;
            prev[i] = prev[max_prev];
        }
        prev[i][s[i]] = i;
    }
}

void calc_dp(){
    int first = 0;
    for (int i = n-1; i >= 0; --i) {
        if(possibleToDelete[i])continue;
        first = i;
        break;
    }
    int last_char = s[first];
    for (int i = first-1; i >= 0; --i) {
        if(!possibleToDelete[i]){
            ans.push_back(last_char);
            last_char = s[i];
            continue;
        }
        if(s[i] <= last_char){
            ans.push_back(last_char);
            last_char = s[i];
        }
    }
    ans.push_back(last_char);
}

void solve(){
    read();
    calcDeletable();
    calc_dp();
    while(!ans.empty()){
        cout << (char)(ans.back() + 'a');
        ans.pop_back();
    }
    cout << endl;
}

int main(){
    //freopen("input.txt", stdin, "r")
    //freopen("output.txt", stdout, "w")
    ios;
    solve();
    return 0;
}