#include <bits/stdc++.h>

using namespace std;

//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("fast-math")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC target("tune=native")

#define ios ios_base::sync_with_stdio(true);cin.tie(0);cout.tie(0);
#define ll long long
#define len(x) (int)(x.size())

const ll INF = 2e18;

int k, n;
vector<int> s;
vector<vector<bool>> del;
deque<int> ans;

void read(){
    cin >> k >> n;
    s.resize(n);
    del.resize(k, vector<bool>(k));
    string ss;
    for (int i = 0; i < k; ++i) {
        cin >> ss;
        for (int j = 0; j < k; ++j) {
            del[i][j] = ss[j] == '1';
        }
    }
    cin >> ss;
    for (int i = 0; i < n; ++i) {
        s[i] = ss[i] - 'a';
    }
}

void calc_dp(){
    s.push_back(-1);
    vector<int> next(n);
    next[n-1] = n;
    for (int i = n-2; i >= 0; --i) {
        int nx = i+1;
        int best = i+1;
        while(nx != n && del[s[i]][s[nx]]){
            nx = next[nx];
            if(s[nx] < s[best] || s[nx] == s[best] && s[next[nx]] < s[next[best]]){
                best = nx;
            }
        }
        next[i] = best;
    }
    int i = 0;
    while(i != n){
        ans.push_back(i);
        i = next[i];
    }
}

void solve(){
    read();
    calc_dp();
    while(!ans.empty()){
        cout << (char)(s[ans.front()] + 'a');
        ans.pop_front();
    }
    cout << endl;
}

int main(){
    //freopen("input.txt", stdin, "r")
    //freopen("output.txt", stdout, "w")
    ios;
    solve();
    return 0;
}