#include <bits/stdc++.h>

using namespace std;

bool a[26][26];


int n;
string s;

vector<int> dp_lexmin_next;

int lexmin(int i, int j) {
	int origi = i;
	int origj = j;
	while(i < n && j < n) {
		if(s[i] < s[j]) {
			return origi;
		}
		if(s[i] > s[j]) {
			return origj;
		}
		i = dp_lexmin_next[i];
		j = dp_lexmin_next[j];
	}
	return i < j ? origj : origi;
}


signed main() {
	int k;
	cin >> k >> n;

	for(int i = 0; i < k; i++) {
		string s;
		cin >> s;
		for(int j = 0; j < k; j++) {
			a[i][j] = s[j] - '0';
		}
	}

	cin >> s;

	vector<int> dp_can_delete_r(n);
	dp_can_delete_r[n - 1] = n - 1;

	dp_lexmin_next.resize(n);
	dp_lexmin_next[n - 1] = n;

	for(int l = n - 2; l >= 0; l--) {
		dp_lexmin_next[l] = l + 1;
		int r = l;
		while(r + 1 < n && a[s[l] - 'a'][s[r + 1] - 'a']) {
			dp_lexmin_next[l] = lexmin(dp_lexmin_next[l], dp_lexmin_next[r + 1]);
			r = dp_can_delete_r[r + 1];
		}
		dp_can_delete_r[l] = r;
	}

	int i = 0;
	while(i < n) {
		cout << s[i];
		i = dp_lexmin_next[i];
	}
	cout << endl;

	return 0;
}