#include <bits/stdc++.h>

using namespace std;


bool i_start = true;

bool field[33][33];
int n, k, m;

void mark(int x, int y) {
	for(int x1 = x; x1 <= n; x1++) {
		for(int y1 = y; y1 <= n; y1++) {
			field[x1][y1] = true;
		}
	}
}

void newgame() {
	memset(field, 0, sizeof(field));
	i_start = !i_start;
	if(!i_start) {
		int x, y;
		scanf("%d%d", &x, &y);
		mark(x, y);
	}
}


void go(int x, int y) {
	mark(x, y);
	printf("%d %d\n", x, y);
	fflush(stdout);
	if(x == 1 && y == 1) {
		newgame();
		return;
	}
	scanf("%d%d", &x, &y);
	mark(x, y);
	if(x == 1 && y == 1) {
		newgame();
	}
}


pair<int, int> readin() {
	int x, y;
	scanf("%d%d", &x, &y);
	return {x, y};
}


bool is_my_move = true;

pair<int, int> readmymove() {
	pair<int, int> move{1, 1};
	while(move == make_pair(1, 1)) {
		while(!is_my_move) {
			if(readin() == make_pair(1, 1)) {
				i_start = !i_start;
				is_my_move = i_start;
			} else {
				is_my_move = true;
			}
		}
		is_my_move = false;
		move = readin();
		if(move == make_pair(1, 1)) {
			i_start = !i_start;
			is_my_move = i_start;
		}
	}
	return move;
}


signed main() {
	ios_base::sync_with_stdio(0);

	int t;
	scanf("%d", &t);
	scanf("%d%d%d", &n, &k, &m);

	if(t == 1) {
		char* s = new char[m + 1];
		scanf("%s", s);

		for(int i = 0; i < m; i++) {
			pair<int, int> best{1, 1};
			for(int x = 1; x <= n; x++) {
				for(int y = 1; y <= n; y++) {
					if(!field[x][y] && (x + y) % 2 == s[i] - '0') {
						if(x + y > best.first + best.second) {
							best = {x, y};
						}
					}
				}
			}
			if(best == make_pair(1, 1)) {
				go(1, 1);
				for(int x = 1; x <= n; x++) {
					for(int y = 1; y <= n; y++) {
						if(!field[x][y] && (x + y) % 2 == s[i] - '0') {
							if(x + y > best.first + best.second) {
								best = {x, y};
							}
						}
					}
				}
			}

			go(best.first, best.second);
		}

		go(1, 1);
		printf("0\n");
		fflush(stdout);
	} else {
		int cnt;
		scanf("%d", &cnt);

		for(int i = 0; i < m; i++) {
			auto [x, y] = readmymove();
			printf("%d", (x + y) % 2);
		}
		printf("\n");
	}

	return 0;
}