#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <string> 
#include <cassert>
#include <map>

using namespace std;

#define ll long long
#define FOR(i, Left, Right) for (int i = (Left); i <= Right; ++i)
#define FOR_DOWN(i, Right, Left) for(int i = (Right); i >= (Left); --i)
#define pii pair <int, int>



short int check[11234][11234];
const int cnt = 1 << 18;
int n, k;
string s;
bool can[50][50];
int last[cnt];
int val[cnt];
int it[cnt];

int DO[cnt];


bool srav(int x, int y)
{
	if (check[x][y] == 1)
		return 0;
	if (check[x][y] == 2)
		return 1;
	if (y == -1)
		return 1;
	if (x == -1)
		return 0;
	while ((val[x] == val[y]) && 1)
	{
		if (x > n || y > n)
			break;
		x = it[x];
		y = it[y];
	}
	if (val[x] < val[y]) {
		check[x][y] = 2;
		check[y][x] = 1;
		return 1;
	}
	else {
		check[x][y] = 1;
		check[y][x] = 2;
		return 0;
	}
}

void add(int pos, int v)
{
	pos += cnt / 2;
	DO[pos] = v;
	while (pos > 0)
	{
		pos /= 2;
		int x, y;
		x = DO[pos * 2];
		y = DO[pos * 2 + 1];
		if (srav(x, y))
		{
			DO[pos] = x;
		}
		else
		{
			DO[pos] = y;
		}
	}
}

int ans(int node, int l1, int r1, int l = 1, int r = cnt / 2)
{
	if (l + 1 == r)
		return DO[node];
	if (r1 < l || l1 > r)
	{
		return -1;
	}

	if (l >= l1 && r <= r1)
	{
		return DO[node];
	}
	int m = (l + r) / 2;
	int t1 = -1, t2 = -1;
	if (l1 < m)
		t1 = ans(node * 2, l1, r1, l, m);
	if (r1 > m)
		t2 = ans(node * 2 + 1, l1, r1, m, r);
	if (t1 == -1)
		return t2;
	if (t2 == -1)
		return t1;
	if (srav(t1, t2))
		return t1;
	return t2;

}

int main()
{
#ifdef _DEBUG
	freopen("Text.txt", "r", stdin);
#endif // _DEBUG

	for (int i = 0; i < cnt; ++i)
		DO[i] = -1;
	cin >> k >> n;
	FOR(i, 1, k)
	{
		cin >> s;
		FOR(j, 1, k)
		{
			can[i][j] = (s[j - 1] - '0');
		}
	}
	cin >> s;


	s += char('A');
	FOR(i, 1, n)
		val[i] = s[i - 1] - 'a' + 1;
	bool used;
	FOR(num, 1, n)
	{
		last[num] = num;
		used = 0;
		int pos = -1;
		FOR_DOWN(i, num - 1, 1)
		{

			if (can[val[i]][val[num]] && last[i] == num - 1) {
				used = 1;
				pos = i;
			}
			if (last[i] >= pos && used)
				last[i]++;
		}
	}

	add(n + 1, n + 1);
	FOR_DOWN(i, n, 1)
	{
		it[i] = ans(1, i + 1, last[i] + 2);
		add(i, i);
	}

	int num = 1;
	while (num <= n)
	{
		cout << s[num - 1];
		num = it[num];
	}

}