#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <string> 
#include <cassert>
#include <map>

using namespace std;

#define ll long long
#define FOR(i, Left, Right) for (int i = (Left); i <= Right; ++i)
#define FOR_DOWN(i, Right, Left) for(int i = (Right); i >= (Left); --i)
#define pii pair <int, int>


int n, m, k;
int p[100];
vector <int> upgrades[100];
vector <int> g[100];
int typ[100];

vector <int> answer[100];


int sel[100];

int next()
{
	FOR_DOWN(i, n, 1)
	{
		if (upgrades[i].size() > 0)
		{
			if (sel[i] + 1 < upgrades[i].size()) {
				sel[i]++;
				return 1;
			}
			else
			{
				sel[i] = 0;
			}
		}
		if (i == 1)
			return 0;
	}
}


vector<int> dfs(int v)
{
	vector <int> ans, s1, s2;
	ans.push_back(-1);
	//return ans;
	if (typ[v] == 2)
	{
		ans.clear();
		ans.push_back(upgrades[v][sel[v]]);
		return ans;
	}
	else
	{
		if (g[v].size() == 1)
		{
			answer[v].clear();
			answer[v].push_back(g[v][0]);
			return dfs(g[v][0]);
		}
		if (g[v].size() == 2)
		{
			s1 = dfs(g[v][0]);
			s2 = dfs(g[v][1]);
			if (s1[0] == -1 || s2[0] == -1)
				return ans;
			if (s1[0] > s2[0]) {
				swap(s1, s2);
				swap(g[v][0], g[v][1]);
			}
			if (*s1.rbegin() > s2[0])
			{
				return ans;
			}
			else
			{
				ans.clear();
				for (auto u : s1)
					ans.push_back(u);
				for (auto u : s2)
					ans.push_back(u);
				answer[v].clear();
				answer[v].push_back(g[v][0]);
				answer[v].push_back(g[v][1]);
				return ans;
			}
		}
	}
}

void print()
{
	cout << "Yes\n";
	FOR(i, 1, n)
	{
		if (typ[i] == 1)
		{
			for (auto u : answer[i])
				cout << u << " ";
			cout << '\n';
		}
		else
			cout << upgrades[i][sel[i]] << '\n';
	}
	return;
}

int main()
{
#ifdef _DEBUG
	freopen("Text.txt", "r", stdin);
#endif // _DEBUG

	cin >> n;
	FOR(i, 1, n)
	{
		cin >> typ[i];
		cin >> k;
		int v;
		FOR(j, 1, k)
		{
			cin >> v;
			if (typ[i] == 1)
				g[i].push_back(v);
			else
				upgrades[i].push_back(v);
		}
	}
	
	auto p = dfs(1);
	if (p[0] != -1)
	{
		print();
		return 0;
	}

	while (next())
	{
		p = dfs(1);
		if (p[0] != -1)
		{
			print();
			return 0;
		}
	}
	cout << "No";
	return 0;
}