#include <iostream>
#include <vector>
#include <set>

int main() {
    int32_t n, m;
    std::cin >> n >> m;

    std::string str;
    std::cin >> str;

    std::vector<std::pair<int32_t, bool> >* cards = new  std::vector<std::pair<int32_t, bool> >[n];
    for(int32_t i = 0; i < n; i++) {
        int32_t k;
        std::cin >> k;

        for(int32_t j = 0; j < k; j++) {
            int32_t pos;
            char val;
            std::cin >> pos >> val;
            pos--;

            cards[i].emplace_back(pos, val == str[pos]);
        }
    }

    std::vector<int32_t> answer;
    std::set<int32_t> remains;
    for(int32_t i = 0; i < n; i++)
        remains.insert(i);
    bool* states = new bool[m];
    for(int32_t i = 0; i < m; i++)
        states[i] = false;
    for(int32_t i = 0; i < n; i++) {
        int32_t improving = -1;
        for(auto it = remains.begin(); it != remains.end(); it++) {
            bool ok = true;
            for(int32_t j = 0; j < cards[*it].size(); j++)
                if(!states[cards[*it][j].first] && !cards[*it][j].second) {
                    ok = false;
                    break;
                }
            if(ok) {
                improving = *it;
                break;
            }
        }
        if(improving == -1) {
            std::cout << -1;
            return 0;
        }
        for(int32_t j = 0; j < cards[improving].size(); j++)
            states[cards[improving][j].first] = true;
        remains.erase(improving);
        answer.push_back(improving);
    }

    for(int32_t i = 0; i < m; i++)
        if(!states[i]) {
            std::cout << -1;
            return 0;
        }

    for(int32_t i = 0 ;i < n; i++)
        std::cout << answer[i] + 1 << " ";
    return 0;
}
