#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <stack>
#define int long long

using namespace std;


bool mn(string a, string b)
{
    for (int i(0); i < min((int) b.size(), (int) a.size()); ++i)
    {
        if (a[i] < b[i]) return true;
        if (b[i] < a[i]) return false;
    }
    if (a.size() < b.size()) return true;
    return false;
}


bool mnt(string a, string b)
{
    for (int i(0); i < min((int) b.size(), (int) a.size()); ++i)
    {
        if (a[i] < b[i]) return true;
        if (b[i] < a[i]) return false;
    }
    if (a.size() > b.size()) return true;
    return false;
}


int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int k, n;
    cin >> k >> n;
    vector<vector<bool>> g(k, vector<bool> (k));
    for (int i(0); i < k; ++i)
    {
        string now;
        cin >> now;
        for (int j(0); j < k; ++j)
        {
            if (now[j] == '1') g[i][j] = true;
        }
    }
    string as;
    cin >> as;
    vector<int> a(n);
    for (int i(0); i < n; ++i) a[i] = as[i] - 'a';
    vector<vector<bool>> can(n, vector<bool> (n));
    for (int i(1); i < n; ++i)
    {
        stack<int> st;
        for (int j(i); j > 0; --j)
        {
            st.push(j);
            while (!st.empty() && g[a[j - 1]][a[st.top()]]) st.pop();
            if (st.empty()) can[j][i] = true;
        }
    }
    vector<string> dpf(n);
    vector<string> dpt(n);
    dpf[0] = as[0];
    dpt[0] = as[0];
    string strinf = "";
    for (int i(0); i < n + 1; ++i) strinf += '{';
    for (int i(1); i < n; ++i) dpt[i] = strinf;
    for (int i(1); i < n; ++i)
    {
        for (int j(0); j < i; ++j)
        {
            if (j != i - 1 && !can[j + 1][i - 1]) continue;
            string newstrt;
            newstrt = dpt[j] + as[i];
            if (mnt(newstrt, dpt[i])) dpt[i] = newstrt;
        }
    }
    string result = dpf[n - 1];
    if (mn(dpt[n - 1], result)) result = dpt[n - 1];
    for (int i(0); i < n - 1; ++i)
    {
        if (can[i + 1][n - 1])
        {
            if (mn(dpt[i], result)) result = dpt[i];
        }
    }
    cout << result << endl;
    return 0;
}
