#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <stack>
#define int long long

using namespace std;

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int k, n;
    cin >> k >> n;
    vector<vector<bool>> g(k, vector<bool> (k));
    for (int i(0); i < k; ++i)
    {
        string now;
        cin >> now;
        for (int j(0); j < k; ++j)
        {
            if (now[j] == '1') g[i][j] = true;
        }
    }
    string as;
    cin >> as;
    vector<int> a(n);
    for (int i(0); i < n; ++i) a[i] = as[i] - 'a';
    vector<vector<bool>> can(n, vector<bool> (n));
    for (int i(1); i < n; ++i)
    {
        stack<int> st;
        for (int j(i); j > 0; --j)
        {
            st.push(j);
            while (!st.empty() && g[a[j - 1]][a[st.top()]]) st.pop();
            if (st.empty()) can[j][i] = true;
        }
    }
    vector<int> p(n);
    for (int i(n - 2); i > -1; --i)
    {
        int mn = 1000;
        for (int j(i + 1); j < n; ++j)
        {
            if (a[j] > mn) continue;
            mn = a[j];
            if (i == j - 1 || can[i + 1][j - 1]) p[i] = j;
        }
    }
    for (int i(0); i < n - 1; ++i)
    {
        if (can[i + 1][n - 1]) p[i] = -1;
    }
    p[n - 1] = -1;
    string result = "";
    int u = 0;
    while (u != -1)
    {
        result += as[u];
        u = p[u];
    }
    cout << result << endl;
    return 0;
}
