#include <bits/stdc++.h>

#define range(i, n) for(int i = 0; i < (n); ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define ar array


typedef long long ll;
using namespace std;

const int md = 1e9 + 7;

inline int mul(const int &a, const int &b) {
    return (1ll * a * b) % md;
}

inline int sub(const int &a, const int &b) {
    return a - b < 0 ? a - b + md : a - b;
}

inline int add(const int &a, const int &b) {
    return a + b >= md ? a + b - md : a + b;
}

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

int P = -1;
const int maxN = 5e5 + 100;
int stP[maxN];
void init() {
    while(P < 1000) {
        P = rng() % md;
    }
    stP[0] = 1;
    for(int i = 1; i < maxN; ++i) stP[i] = mul(stP[i - 1], P);
}

void solve() {
    init();
    int k, n; cin >> k >> n;
    vector<vector<bool>> a(k, vector<bool> (k));
    range(i, k) {
        range(j, k) {
            char x; cin >> x;
            if (x == '1') a[i][j] = 1;
        }
    }
    string s; cin >> s;
    vector<int> nxt(n);
    vector<int> stk;
    for(int i = n - 1; i >= 0; --i) {
        while(!stk.empty() && a[s[i]-'a'][s[stk.back()]-'a']) {
            stk.pop_back();
        }
        if (stk.empty()) {
            nxt[i] = n;
        } else {
            nxt[i] = stk.back();
        }
        stk.push_back(i);
    }
    stk.clear();

    vector<vector<int>> hup(n, vector<int> (20, -1));
    vector<vector<int>> mup(n, vector<int> (20, -1));
    vector<int> pos(n);

    auto check = [&] (int u, int w) {
        if (w == u) return false;
        int i = pos[u];
        int j = pos[w];
        for(int k = 19; k >= 0; --k) {
            if (i - (1 << k) < -1 || j - (1 << k) < -1) continue;
            if (hup[stk[i]][k] == hup[stk[j]][k]) {
                i -= (1 << k);
                j -= (1 << k);
            }
        }
        if (i == -1) return true;
        if (j == -1) return false;
        return hup[stk[i]][0] < hup[stk[j]][0];
    };
    for(int i = n - 1; i >= 0; --i) {
        int e = stk.size();
        int r = nxt[i];
        if (!stk.empty() && stk[0] >= r) {
            int lst = e - 1;
            int mn = -1;
            for (int p = 19; p >= 0; --p) {
                if (lst - (int) (1 << p) < -1) continue;
                if (stk[lst + 1 - (int) (1 << p)] > r) continue;
                if (mn == -1) {
                    mn = mup[stk[lst]][p];
                } else if (check(mup[stk[lst]][p], mn)) {
                    mn = mup[stk[lst]][p];
                }
                lst -= (int) (1 << p);
            }
            if (mn != -1) {
                while (stk.back() != mn) {
                    stk.pop_back();
                }
            }
        } else {
            stk.clear();
        }
        e = stk.size();
        hup[i][0] = s[i];
        mup[i][0] = i;
        for(int j = 1; j < 20; ++j) {
            if (e - (int)(1 << j) < -1) break;
            hup[i][j] = add(mul(hup[stk[e - (int)(1 << (j-1))]][j - 1], stP[1<<(j-1)]), hup[i][j - 1]);
        }
        for(int j = 1; j < 20; ++j) {
            if (e - (int)(1 << j) < -1) break;
            if (check(mup[i][j - 1], mup[stk[e - (int)(1 << (j-1))]][j - 1])) {
                mup[i][j] = mup[i][j - 1];
            } else {
                mup[i][j] = mup[stk[e - (int)(1 << (j-1))]][j - 1];
            }
        }
        pos[i] = e;
        stk.push_back(i);
    }
    reverse(all(stk));
    for(auto &i : stk) cout << s[i];
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int tests = 1;
    range(_, tests) {
        solve();
    }
    return 0;
}