#include <bits/stdc++.h>

#define range(i, n) for(int i = 0; i < (n); ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define ar array


typedef long long ll;
using namespace std;

const int maxN = 1e5 + 5;
const int INFi = 2e9;
vector<int> g[maxN];
bool emp[maxN];
vector<int> here[maxN];
vector<int> dp[maxN];
vector<vector<int>> orddp[maxN];
int sp[maxN];
int m;

void dfs(int v) {
    dp[v].resize(m + 1, INFi);
    orddp[v].resize(m + 1);
    if (emp[v]) {
        if (here[v].empty()) {
            range(i, m + 1) dp[v][i] = i;
        }
        for (auto &i : here[v]) {
            dp[v][i] = i + 1;
        }
        for (int i = m - 1; i >= 0; --i) dp[v][i] = min(dp[v][i], dp[v][i + 1]);
        return;
    }
    for(auto &u : g[v]) {
        dfs(u);
    }
    vector<int> ord = g[v];
    sort(all(ord));
    do {
        for(int s = 0; s <= m; ++s) {
            int cur = s;
            for(auto &u : ord) {
                if (cur == INFi) break;
                cur = dp[u][cur];
            }
            if (cur == INFi) continue;
            if (cur < dp[v][s]) {
                dp[v][s] = cur;
                orddp[v][s] = ord;
            }
        }
    } while (next_permutation(all(ord)));
}

void dfs2(int v) {
    int cur = sp[v];
    for(auto &u : orddp[v][sp[v]]) {
        sp[u] = cur;
        dfs2(u);
        cur = dp[u][cur];
    }
}

void solve() {
    int n; cin >> n;
    vector<int> xx;
    for(int i = 1; i <= n; ++i) {
        int t; cin >> t;
        if (t == 1) {
            int k; cin >> k;
            g[i].resize(k);
            range(j, k) cin >> g[i][j];
        } else {
            int mm; cin >> mm;
            emp[i] = true;
            here[i].resize(mm);
            range(j, mm) cin >> here[i][j];
            for(auto &x : here[i]) xx.push_back(x);
        }
    }
    sort(all(xx));
    xx.resize(unique(all(xx)) - xx.begin());
    for(int i = 1; i <= n; ++i) {
        for(auto &x : here[i]) {
            x = lower_bound(all(xx), x) - xx.begin();
        }
    }
    m = xx.size() + 2;
    dfs(1);
    if (dp[1][0] == INFi) {
        cout << "No\n";
        return;
    }
    dfs2(1);
    cout << "Yes\n";
    for(int i = 1; i <= n; ++i) {
        if (emp[i]) {
            if (!here[i].empty()) {
                cout << xx[dp[i][sp[i]] - 1];
            }
        } else {
            for(auto &u : orddp[i][sp[i]]) {
                cout << u << ' ';
            }
        }
        cout << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int tests = 1;
    range(_, tests) {
        solve();
    }
    return 0;
}