#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
using namespace std;

bool check (vector<pair<int64_t, vector<char>>> a, string s) {
    vector<bool> c(s.size(), false);
    for (int64_t i = 0; i < a.size(); ++i) {
        for (int64_t j = 0; j < a[0].second.size(); ++j) {
            if (i == 0) {
                if (a[i].second[j] == s[j]) {
                    c[j] = true;
                } else if (a[i].second[j] == 0) {
                    continue;
                } else {
                   return false;
                }
            } else {
                if (c[j]) {
                    continue;;
                }
                if (a[i].second[j] == s[j]) {
                    c[j] = true;
                } else if (a[i].second[j] == 0) {
                    continue;
                } else {
                    return false;
                }
            }
        }
    }
    return true;
}
int64_t factorial(int64_t n) {
    int64_t ans = 1;
    for (int i = 2; i <= n; ++i) {
        ans *= i;
    }
    return ans;
}

int main() {
    int64_t n, m;
    cin >> n >> m;
    string s;
    cin >> s;
    vector<pair<int64_t, vector<char>>> a(n, pair<int64_t, vector<char>>(m, '0'));
    for (int64_t i = 0; i < n; ++i) {
        int64_t k;
        cin >> k;
        a[i].first = i;
        a[i].second.resize(m);
        for (int64_t j = 0; j < k; ++j) {
            int64_t index;
            char w;
            cin >> index;
            cin >> w;
            a[i].second[index - 1] = w;
        }
    }
    int64_t i = factorial(n);
    while(i--) {
        next_permutation(a.begin(), a.end());
        if (check(a, s)) {
            for (auto i : a) {
                cout << i.first + 1 << " ";
            }
            return 0;
        }
    }
    cout << -1;
    return 0;
}
