#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <vector>
#include <math.h>
#include <set>
#include <queue>
#include <string>
#include <cassert>
#include <stack>

using namespace std;

typedef long long ll;

const ll N = 2e5;
const ll inf = 1e18;
const ll sz = (1 << 18);

ll A[30][30];
ll B[N];
vector <ll> nv[N];
ll nxt[N][30];
vector <pair <ll, char>> v;
ll num[N];
string ans[N];
ll D[2 * sz];

void upd(ll v) {
	D[v] = v - sz;
	v /= 2;
	while (v >= 1) {
		if (ans[D[2 * v]] < ans[D[2 * v + 1]]) {
			D[v] = 2 * v;
		}
		else {
			D[v] = 2 * v + 1;
		}
		v /= 2;
	}
}

ll get(ll l1, ll r1, ll l, ll r, ll v) {
	if (l1 > r || r1 < l) {
		return -1;
	}
	if (l1 <= l && r1 >= r) {
		return D[v];
	}
	ll k1 = get(l1, r1, l, (l + r) / 2, 2 * v);
	ll k2 = get(l1, r1, (l + r) / 2 + 1, r, 2 * v + 1);
	if (k1 == -1) {
		return k2;
	}
	if (k2 == -1) {
		return k1;
	}
	if (ans[k1] < ans[k2]){
		return k1;
	}
	return k2;
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	ll k, n;
	cin >> k >> n;
	for (ll i = 0; i < k; i++) {
		for (ll j = 0; j < k; j++) {
			char a; cin >> a;
			A[i][j] = a - '0';
		}
	}
	string s;
	cin >> s;
	for (ll i = 0; i < 30; i++) {
		nxt[n - 1][i] = inf;
	}
	for (ll i = n - 2; i >= 0; i--) {
		for (ll j = 0; j < 30; j++) {
			nxt[i][j] = nxt[i + 1][j];
		}
		nxt[i][s[i + 1] - 'a'] = i + 1;
	}
	num[0] = -inf;
	stack <ll> st;
	for (ll i = 0; i < n; i++) {
		if (i == 0 || B[i - 1] == 1) {
			while (!st.empty()) {
				nv[st.top()].clear();
				st.pop();
			}
			ll cur = i + 1;
			while (1) {
				if (cur == n) {
					cur--;
					break;
				}
				ll prev = cur - 1;
				bool f = 0;
				while (prev >= i) {
					if (A[s[prev] - 'a'][s[cur] - 'a'] == 1) {
						num[cur] = prev;
						nv[prev].push_back(cur);
						if (nv[prev].size() == 1) {
							st.push(prev);
						}
						f = 1;
						break;
					}
					prev = num[prev];
				}
				if (!f) {
					cur--;
					break;
				}
				cur++;
			}
			B[i] = cur - i + 1;
		}
		else {
			if (nv[i - 1].size() > 1) {
				B[i] = (nv[i - 1][1] - i);
			}
			else {
				B[i] = B[i - 1] - 1;
			}
		}
	}
	ll cur = 0;
	ans[n] = "";
	upd(n + sz);
	for (ll i = n - 1; i >= 0; i--) {
		string mina = ans[get(i + 1 + sz, B[i] + i + sz, sz, 2 * sz - 1, 1)];
		mina.insert(mina.begin(), s[i]);
		ans[i] = mina;
		upd(i + sz);
	}
	cout << ans[0];
}