#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

#define all(v) v.begin(), v.end()
#define ios ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

vector<vector<int> > g;
vector<vector<int> > a;
vector<vector<int> > dp;
vector<int> s;
int last;

const int inf = (int)1e9 + 7;

void dfs(int v)
{
    if(g[v].empty())
    {
        s[v] = 1;
        for(int x : a[v])
        {
            dp[v][x] = x;
        }
        for(int j = last - 1; j >= 0; --j)
        {
            dp[v][j] = min(dp[v][j], dp[v][j + 1]);
        }
        return;
    }
    for(int u : g[v])
    {
        dfs(u);
        s[v] += s[u];
    }
    sort(all(g[v]));
    do
    {
        for(int l = last; l >= 0; --l)
        {
            int cur = l;
            int j = 0;
            while(cur < inf && j < g[v].size())
            {
                cur = dp[g[v][j]][cur];
                ++j;
                ++cur;
            }
            if(cur < inf)
                --cur;
            dp[v][l] = min(dp[v][l], cur);
        }
        for(int l = last - 1; l >= 0; --l)
            dp[v][l] = min(dp[v][l], dp[v][l + 1]);
    }while(next_permutation(all(g[v])));
}

signed main()
{
    ios;
    int n;
    cin >> n;
    a.resize(n);
    g.resize(n);
    s.assign(n, 0);
    vector<int> upd;
    for(int i = 0; i < n; ++i)
    {
        int t;
        cin >> t;
        if(t == 1)
        {
            int k;
            cin >> k;
            g[i].resize(k);
            for(int &u : g[i])
            {
                cin >> u;
                --u;
            }
        }
        else
        {
            int m;
            cin >> m;
            a[i].resize(m);
            for(int &x : a[i])
            {
                cin >> x;
                upd.push_back(x);
            }
        }
    }
    sort(all(upd));
    map<int, int> mp;
    mp[upd[0]] = 0;
    last = 0;
    for(int i = 1; i < upd.size(); ++i)
    {
        if(upd[i] != upd[i - 1])
        {
            last = mp[upd[i]] = mp[upd[i - 1]] + 1;
        }
    }
    for(int v = 0; v < n; ++v)
    {
        for(int &x : a[v])
            x = mp[x];
    }
    dp.assign(n, vector<int>(last + 1, inf));
    dfs(0);
    if(dp[0][0] < inf)
    {
        cout << "Yes";
    }
    else
    {
        cout << "No";
    }
    return 0;
}
