#define _CRT_SECURE_NO_WARNINGS

#pragma GCC optimize("Ofast")

#include <iostream>
#include <algorithm>
#include <fstream>
#include <cmath>
#include <math.h>
#include <vector>
#include <string>
#include <set>
#include <queue>
#include <iomanip>
#include <bitset>
#include <random>

using namespace std;

#define ll long long
#define pii pair<int,int>
#define BE(v) v.begin(), v.end()
#define endl '\n'
#define pb push_back

const int N = 3e5;
const int bes = 2e9;

vector<int> p[N];
vector<int> v[N];

set<int> s[N];
int cnt[N];

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int n, m;
	cin >> n >> m;
	string str;
	cin >> str;
	vector<int> now;
	for (int i = 0; i < n; i++)
	{
		int k;
		cin >> k;
		for (int j = 0; j < k; j++)
		{
			int pos;
			cin >> pos;
			pos--;
			char sim;
			cin >> sim;
			v[i].pb(pos);
			if (sim != str[pos])
			{
				s[i].insert(pos);
				p[pos].push_back(i);
				cnt[i]++;
			}
		}
		if (!cnt[i])
		{
			now.push_back(i);
		}
	}
	vector<int> ans;
	bitset<N> b;
	while (ans.size() != n)
	{
		if (now.empty())
		{
			cout << -1;
			return 0;
		}
		int i = now.back();
		now.pop_back();
		ans.pb(i);
		for (int j : v[i])
		{
			//if (!b[j])
			{
				b[j] = 1;
				for (int u : p[j])
				{
					if (s[u].count(j))
					{
						s[u].erase(j);
						cnt[u]--;
						if (!cnt[u])
						{
							now.pb(u);
						}
					}
				}
			}
		}
	}
	for (int i : ans)
	{
		cout << i + 1 << " ";
	}
}