#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <fstream>
#include <algorithm>
#include <vector>
#include <string>
#include <queue>
#include <stack>

using namespace std;

typedef long long ll;

const int N = 500010;
const int ALP = 28;

bool del[500][500];

bool del_otr[500][500];

string s;

stack < int > st;

string best;

string dp[N];

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
#ifdef _DEBUG
	freopen("Test.txt", "r", stdin);
#endif

	int n, k;

	cin >> k >> n;
	
	best = best + char('z' + 1);

	for (int i = 1; i <= k; ++i) {
		string s;
		cin >> s;
		s = '0' + s;
		for (int j = 1; j < s.size(); ++j) {
			if (s[j] == '0')
				del[i + 'a' - 1][j + 'a' - 1] = 0;
			else
				del[i + 'a' - 1][j + 'a' - 1] = 1;
		}
	}
	
	cin >> s;

	for (int j = n; j >= 0; --j) {
		while (!st.empty())
			st.pop();
		for (int i = j - 1; i >= 0; --i) {
			while (!st.empty() && del[s[i]][s[st.top()]])
				st.pop();
			st.push(i);
			if (st.size() == 1)
				del_otr[i][j] = true;
		}
	}

	dp[n - 1] += s[n - 1];

	for (int i = n - 2; i >= 0; --i) {
		dp[i] += char('z' + 1);
		for (int j = i + 1; j < n; ++j) {
			if (del_otr[i][j] && dp[i] > (s[i] + dp[j]))
				dp[i] = (s[i] + dp[j]);
		}
		if (del_otr[i][n])
			dp[i] = s[i];
	}

	cout << dp[0];

}