#pragma GCC optimize ("O3")
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <vector>

using namespace std;

const int N = 2e6;

typedef long long ll;

vector<int> g[N];

vector<int> can[N];

int sz[N];
bool men[N];

int choose[N];

vector<int> por[N];
vector<int> por2[N];

int n;

bool check(int v, int p)
{
	vector<pair<vector<int>,int>> all;
	if (men[v] == false)
	{
		por[v].push_back(choose[v]);
		return true;
	}
	for (int q = 0; q < g[v].size(); q++)
	{
		if (g[v][q] != p)
		{
			if (check(g[v][q], v) == false)
			{
				return false;
			}
			all.push_back({ por[g[v][q]],g[v][q] });
		}
	}
	sort(all.begin(), all.end());
	for (int q = 0; q < all.size() - 1; q++)
	{
		if (all[q].first[all[q].first.size() - 1] > all[q + 1].first[0])
		{
			return false;
		}
	}
	for (int q = 0; q < all.size(); q++)
	{
		for (int w = 0; w < all[q].first.size(); w++)
		{
			por[v].push_back(all[q].first[w]);
		}
		por2[v].push_back(all[q].second);
	}
	return true;
}

void clear()
{
	for (int q = 0; q < n; q++)
	{
		por2[q].clear();
		por[q].clear();
	}
}

void gen(int q)
{
	if (q == n)
	{
		if (check(0,-1) == true)
		{
			cout << "YES" << '\n';
			for (int w = 0; w < n; w++)
			{
				if (men[w] == false)
				{
					cout << choose[w] << '\n';
				}
				else
				{
					for (int e = 0; e < por2[w].size(); e++)
					{
						cout << por2[w][e] + 1 << " ";
					}
					cout << '\n';
				}
			}
			exit(0);
		}
		else
		{
			clear();
		}
	}
	if (men[q] == true)
	{
		gen(q + 1);
	}
	else
	{
		for (int w = 0; w < can[q].size(); w++)
		{
			choose[q] = can[q][w];
			gen(q + 1);
		}
	}
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	//freopen("\\\\.\\pipe\\game.in", "r", stdin);
	//freopen("\\\\.\\pipe\\game.out", "w", stdout);
	cin >> n;
	for (int q = 0; q < n; q++)
	{
		int fl = 0;
		cin >> fl;
		if (fl == 1)
		{
			men[q] = true;
			cin >> sz[q];
			for (int w = 0; w < sz[q]; w++)
			{
				int c;
				cin >> c; c--;
				g[c].push_back(q);
				g[q].push_back(c);
			}
		}
		else
		{
			men[q] = false;
			cin >> sz[q];
			for (int w = 0; w < sz[q]; w++)
			{
				int x;
				cin >> x;
				can[q].push_back(x);
			}
		}
	}
	gen(0);
	cout << "NO";
}