#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
#define sz(x) int(x.size())

const int K = 26;
const int N = 20 + 10;

int k, n;
int c[K][K];
string s;

char can[N];

bool check(const vector <int>& a) {
    fill(can, can + N, 1);

    for (int x : a) {
        can[x] = 0;
    }

    vector <pair <char, int>> v;
    for (int i = 0; i < n; i++) {
        v.push_back({ s[i], i });
    }

    while (true) {
        bool flag = false;
        for (int i = sz(v) - 1; i > 0; i--) {
            auto [ch, id] = v[i];
            if (!can[id]) continue;

            int x = ch - 'a';
            int y = v[i - 1].first - 'a';

            if (c[y][x]) {
                v.erase(v.begin() + i);
                flag = true;
                break;
            }
        }

        if (!flag) {
            break;
        }
    }

    return sz(a) == sz(v);
}

signed main() {
#ifdef CHOPPAWONTMISS
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    cin >> k >> n;
    for (int i = 0; i < k; i++) {
        for (int j = 0; j < k; j++) {
            char x;
            cin >> x;

            c[i][j] = x - '0';
        }
    }

    cin >> s;

    string ans = s;
    vector <int> p(n);
    iota(p.begin(), p.end(), 0);

    while (true) {
        vector <pair <string, vector <int>>> v;
        for (int i = 0; i < sz(ans); i++) {
            string t = ans;
            vector <int> u = p;

            t.erase(i, 1);
            u.erase(u.begin() + i);
            v.push_back({ t, u });
        }

        sort(v.begin(), v.end());

        bool flag = false;
        for (auto& [t, u] : v) {
            if (check(u) && t < ans) {
                ans = t, p = u;
                flag = true;
                break;
            }
        }

        if (!flag) {
            break;
        }
    }

    cout << ans << endl;

    return 0;
}
