#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
using namespace std;

bool all[30][30];
vector<int>e[10001];
vector<int>good[10001];
bool used[10001];
string ans[10001];
string s;
bool kon[10001];
void dfs(int v) {
	used[v] = 1;
	if (kon[v]) {
		string x;
		x += s[v];
		ans[v] = x;
		return;
	}
	string f="A";
	for (auto c : good[v]) {
		if (used[c] == 0)
			dfs(c);
		string x;
		x += s[v];
		x += ans[c];
		if (f == "A")
			f = x;
		else
		f = min(f, x);
	}
	ans[v] = f;
	return;
}

void solve() {
	int n, k;
	cin >> k >> n;
	for (int i = 0; i < k; i++) {
		for (int y = 0; y < k; y++) {
			char c;
			cin >> c;
			if (c == '1')
				all[i][y] = 1;
		}
	}
	
	cin >> s;
	string best = s;
	vector<int>last(26, -1);
	vector<int>mx(n,-1);
	for (int i = 0; i < n; i++) {
		int ans = -1;
		for (int j = 0; j < 26; j++) {
			if (last[j] == -1)
				continue;
			if (all[j][s[i] - 'a'] == 1)
				ans = max(ans, last[j]);
		}
		mx[i] = ans;
		last[s[i] - 'a'] = i;
	}
	vector<int>cn;
	for (int i = 0; i < n; i++) {
		int mn = 100000;
		for (int y = i - 1; y >= 0; y--) {
			if (y == i - 1) {
				e[y].push_back(i);
			}
			else {
				mn = min(mn, mx[y+1]);
				if (mn == y)
					e[y].push_back(i);
			}
		}
	}
	kon[n - 1] = 1;
	int mn = 100000;
	for (int i = n - 2; i >= 0; i--) {
		mn = min(mn, mx[i + 1]);
		if (mn == i)
			kon[i] = 1;
		else
			break;
	}
	for (int i = 0; i < n; i++) {
		char x = '#';
		for (auto c : e[i]) {
			if (x == '#' || s[c] < x)
				x = s[c];
		}
		for (auto c : e[i]) {
			if (x == s[c]) {
				good[i].push_back(c);
			}
		}
	}
	dfs(0);
	cout << ans[0];
}


int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif 
	int t;
	//cin >> t;
	t = 1;
	while (t) {
		t--;
		solve();
	}
}
//vector<pair<int, char>> all[100001];
//vector<int>bad[100001];
//
//int n, m;
//string s;
//cin >> n >> m >> s;
//for (int i = 0; i < n; i++) {
//	int k;
//	cin >> k;
//	int a;
//	char c;
//	cin >> a >> c;
//	a--;
//	all[i].push_back({ a,c });
//}
//for (int i = 0; i < n; i++) {
//	if (all[i].size() == 0 || all[i][0].first != 0)
//		continue;
//	if (all[i][0].second != s[0])
//		bad[i].push_back(i);
//}
//bool ok = 0;
//for (int i = 0; i < n; i++) {
//	if (bad[i].size())
//		continue;
//	ok = 1;
//}