#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
using namespace std;

const int M = 2001;
bool all[30][30];
vector<int>e[M];
vector<int>good[M];
bool used[M];
string ans[M];
string s;
bool kon[M];
//bool dp[M][M];
int t[4 * M];
bool dp[M + 1][M + 1];
bool answ[M + 1][M + 1];
void build(int v, int l, int r, vector<int>& mx) {
	if (l == r) {
		t[v] = mx[l];
		return;
	}
	int m = (l + r) / 2;
	build(2 * v, l, m, mx);
	build(2 * v + 1, m + 1, r, mx);
	t[v] = min(t[2 * v], t[2 * v + 1]);
}
int get(int v, int l, int r, int l1, int r1) {
	if (l >= l1 && r <= r1)
		return t[v];
	if (l > r1 || l1 > r)
		return 5 * M;
	int m = (l + r) / 2;
	return min(get(2 * v, l, m, l1, r1), get(2 * v + 1, m + 1, r, l1, r1));
}
void dfs(int v) {
	used[v] = 1;
	if (kon[v]) {
		string x;
		x += s[v];
		ans[v] = x;
		return;
	}
	string f = "A";
	for (auto c : good[v]) {
		if (used[c] == 0)
			dfs(c);
		string x;
		x += s[v];
		x += ans[c];
		if (f == "A")
			f = x;
		else
			f = min(f, x);
	}
	ans[v] = f;
	return;
}
bool cnt(int l, int r, vector<int>& mx,vector<int>& ml) {
	if (dp[l][r] == 1)
		return answ[l][r];
	dp[l][r] = 1;
	for (int i = r; i > l; i--) {
		if (mx[i] < l)
			return false;
		for (int y = i + 1; y <= r; y++) {
			bool r = 0;
			for (int z = y - 1; z >= l; z--) {
				if (z > mx[i] && z < i)
					continue;
				if (all[s[z] - 'a'][s[y] - 'a'] == 1) {
					r = 1;
					break;
				}
			}
			if (!r) {
				return false;
			}
		}
	}
	answ[l][r] = 1;
	return true;
}

void solve() {
	int n, k;
	cin >> k >> n;
	for (int i = 0; i < k; i++) {
		for (int y = 0; y < k; y++) {
			char c;
			cin >> c;
			if (c == '1')
				all[i][y] = 1;
		}
	}
	cin >> s;
	string best = s;
	vector<int>last(26, -1);
	vector<int>mx(n, -1);
	for (int i = 0; i < n; i++) {
		int ans = -1;
		for (int j = 0; j < 26; j++) {
			if (last[j] == -1)
				continue;
			if (all[j][s[i] - 'a'] == 1)
				ans = max(ans, last[j]);
		}
		mx[i] = ans;
		last[s[i] - 'a'] = i;
	}
	vector<int>ml(n, 100000);
	for (int i = 0; i < n; i++) {
		ml[i] = mx[i];
		for (int y = mx[i]; y >= 0; y--){
			if (all[s[y] - 'a'][s[i] - 'a'] == 1)
				ml[i] = y;
	    }
	}
	//build(1, 0, n - 1, mx);
	vector<int>cn;
	for (int i = 0; i < n; i++) {
		int mn = 100000;
		for (int y = i - 1; y >= 0; y--) {
			if (y == i - 1) {
				e[y].push_back(i);
			}
			else {
				if (cnt(y, i - 1, mx,ml))
					e[y].push_back(i);
			}
		}
	}
	kon[n - 1] = 1;
	int mn = 100000;
	for (int i = n - 2; i >= 0; i--) {
		if (cnt(i, n - 1, mx,ml))
			kon[i] = 1;
	}
	for (int i = 0; i < n; i++) {
		char x = '#';
		for (auto c : e[i]) {
			if (x == '#' || s[c] < x)
				x = s[c];
		}
		for (auto c : e[i]) {
			if (x == s[c]) {
				good[i].push_back(c);
			}
		}
	}
	dfs(0);
	cout << ans[0];
}


int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif 
	int t;
	//cin >> t;
	t = 1;
	while (t) {
		t--;
		solve();
	}
}