#include <algorithm>
#include <iostream>
#include <vector>
#include <bitset>
#include <math.h>
#include <queue>
#include <set>
#include <map>

using namespace std;

#define ll long long
#define int ll

#define vi vector<int>
#define pii pair<int, int>

bool w[26][26];
string dp[10005];
int maxx[10005];
int n, m;
string s;
bool ok(int i, int j) {
	if (j == m) return 0;
	string f = s.substr(i, j - i + 1);
	for (int i = f.size() - 1; i >= 0; --i) {
		while (i + 1 < f.size() && w[f[i] - 'a'][f[i + 1] - 'a']) f.erase(f.begin() + i + 1);
	}
	return f.size() == 1;
}
signed main() {

	ios::sync_with_stdio(false);
	cin.tie(nullptr); cout.tie(nullptr);

	cin >> n >> m;
	for (int i = 0; i < n; ++i) {
		string s; cin >> s;
		for (int j = 0; j < n; ++j) {
			w[i][j] = s[j] - '0';
		}
	}
	cin >> s;
	
	for (int i = 0; i < m; ++i) {
		int l = i, r = m;
		while (r - l > 1) {
			int c = (l + r) / 2;
			if (ok(i, c)) l = c;
			else r = c;
		}
		maxx[i] = l;
	}


	dp[m] = "";
	for (int i = m - 1; i >= 0; --i) {
		dp[i] = s[i] + dp[i + 1];
		for (int j = i + 1; j <= maxx[i] + 1; ++j) {
			dp[i] = min(dp[i], s[i] + dp[j]);
		}
	}

	cout << dp[0] << '\n';

}

/*

3 7
010
001
100
abacaba

3 5
010
001
100
bcacb

*/