#include <algorithm>
#include <iostream>
#include <vector>
#include <bitset>
#include <math.h>
#include <queue>
#include <set>
#include <map>

using namespace std;

#define ll long long
#define int ll

#define vi vector<int>
#define pii pair<int, int>

const int N = 1e5 + 5;
const ll INF = 1e18 + 5;

signed main() {

	ios::sync_with_stdio(false);
	cin.tie(nullptr); cout.tie(nullptr);

	int x; cin >> x;
	int n, k, m; cin >> n >> k >> m;
	if (x == 1) {
		string s; cin >> s;
		set<pii> z, o;
		for (int i = 0; i < n; ++i) {
			for (int j = 0; j < n; ++j) {
				if ((i + j) % 2) o.insert({ i, j });
				else z.insert({ i, j });
			}
		}
		int id = 0;
		int t = 0;
		while (id < m) {
			if (t == 0) {
				while (1) {
					pair<int, pii> best = { INF, {-1, -1} };
					if (id == s.size()) {
						cout << "1 1";
						break;
					}
					if (s[id] == '0') {
						for (auto el : z) {
							int x = 0;
							for (auto el1 : z) {
								if (el.first <= el1.first && el.second <= el1.second) {
									++x;
								}
							}
							for (auto el1 : o) {
								if (el.first <= el1.first && el.second <= el1.second) {
									++x;
								}
							}
							best = min(best, { x, el });
						}
					}
					else {
						for (auto el : o) {
							int x = 0;
							for (auto el1 : z) {
								if (el.first <= el1.first && el.second <= el1.second) {
									++x;
								}
							}
							for (auto el1 : o) {
								if (el.first <= el1.first && el.second <= el1.second) {
									++x;
								}
							}
							best = min(best, { x, el });
						}
					}
					if (best.first == INF) {
						cout << "1 1";
						break;
					}
					else {
						cout << best.second.first + 1 << ' ' << best.second.second + 1 << endl;
						set<pii> z2, o2;
						auto el = best.second;
						for (auto el1 : z) {
							if (el.first > el1.first && el.second > el1.second) {
								z2.insert(el1);
							}
						}
						for (auto el1 : o) {
							if (el.first > el1.first && el.second > el1.second) {
								o2.insert(el1);
							}
						}
						z = z2, o = o2;
					}
					++id;
					int x, y; cin >> x >> y;
					--x, --y;
					if (x == 0 && y == 0) {
						break;
					}
					else {
						set<pii> z2, o2;
						pii el = { x, y };
						for (auto el1 : z) {
							if (el.first > el1.first && el.second > el1.second) {
								z2.insert(el1);
							}
						}
						for (auto el1 : o) {
							if (el.first > el1.first && el.second > el1.second) {
								o2.insert(el1);
							}
						}
						z = z2, o = o2;
					}
				}
			}
			else {
				while (1) {
					if (id == s.size()) {
						cout << "1 1";
						break;
					}
					int x, y; cin >> x >> y;
					--x, --y;
					if (x == 0 && y == 0) {
						break;
					}
					else {
						set<pii> z2, o2;
						pii el = { x, y };
						for (auto el1 : z) {
							if (el.first > el1.first && el.second > el1.second) {
								z2.insert(el1);
							}
						}
						for (auto el1 : o) {
							if (el.first > el1.first && el.second > el1.second) {
								o2.insert(el1);
							}
						}
						z = z2, o = o2;
					}
					pair<int, pii> best = { INF, {-1, -1} };
					if (s[id] == '0') {
						for (auto el : z) {
							int x = 0;
							for (auto el1 : z) {
								if (el.first <= el1.first && el.second <= el1.second) {
									++x;
								}
							}
							for (auto el1 : o) {
								if (el.first <= el1.first && el.second <= el1.second) {
									++x;
								}
							}
							best = min(best, { x, el });
						}
					}
					else {
						for (auto el : o) {
							int x = 0;
							for (auto el1 : z) {
								if (el.first <= el1.first && el.second <= el1.second) {
									++x;
								}
							}
							for (auto el1 : o) {
								if (el.first <= el1.first && el.second <= el1.second) {
									++x;
								}
							}
							best = min(best, { x, el });
						}
					}
					if (best.first == INF) {
						cout << "1 1";
						break;
					}
					else {
						cout << best.second.first + 1 << ' ' << best.second.second + 1 << endl;
						set<pii> z2, o2;
						auto el = best.second;
						for (auto el1 : z) {
							if (el.first > el1.first && el.second > el1.second) {
								z2.insert(el1);
							}
						}
						for (auto el1 : o) {
							if (el.first > el1.first && el.second > el1.second) {
								o2.insert(el1);
							}
						}
						z = z2, o = o2;
					}
					++id;
				}
			}
			t = 1 - t;
		}
		cout << "0" << endl;
	}
	else {
		int k; cin >> k;
		for (int i = 0; i < k; ++i) {
			int x, y; cin >> x >> y;
			int j = 0;
			while (--x || --y) {

				if (i % 2 == j % 2) {
					cout << char('0' + (x + y) % 2);
				}

				cin >> x >> y;
				++j;
			}
		}
		cout << endl;
	}

}