#include <algorithm>
#include <iostream>
#include <vector>
#include <bitset>
#include <math.h>
#include <queue>
#include <set>
#include <map>

using namespace std;

#define ll long long
#define int ll

#define vi vector<int>
#define pii pair<int, int>

const int N = 1e5 + 5;
const ll INF = 1e18 + 5;

vi ma(N, INF), mi(N, -INF);
vi a[N];
vi bad(N, 0);
vector<vi> s(N);
pii pr[20];
int n;

bool dfs(int v) {
	if (a[v].size() == 0) {
	}
	if (a[v].size() == 1) {
		pr[v] = pr[a[v][0]];		
	}
	if (a[v].size() == 2) {
		int i = a[v][0], j = a[v][1];
		if (!dfs(i) || !dfs(j)) return 0;

		if (pr[i].second < pr[j].first) {
			pr[v] = { pr[i].first, pr[j].second };
		}
		else if (pr[j].second < pr[i].first) {
			pr[v] = { pr[j].first, pr[i].second };
		}
		else {
			return 0;
		}

	}


	if (v == 0) {
		cout << "Yes\n";
		exit(0);
	}
	return 1;
}

void gen(int id) {
	if (id == n + 1) {
		dfs(0);
		return;
	}
	if (bad[id + 1]) {
		for (auto u : s[id + 1]) {
			pr[id + 1] = { u, u };
			gen(id + 1);
		}
	}
	else {
		gen(id + 1);
	}
}

signed main() {

	ios::sync_with_stdio(false);
	cin.tie(nullptr); cout.tie(nullptr);
	
	cin >> n;
	for (int i = 0; i < n; ++i) {
		int x; cin >> x;
		if (x == 1) {
			int k; cin >> k;
			for (int j = 0; j < k; ++j) {
				int f; cin >> f;
				--f;
				a[i].push_back(f);
			}
		}
		else {
			int k; cin >> k;
			bad[i] = 1;
			for (int j = 0; j < k; ++j) {
				int v; cin >> v;
				s[i].push_back(v);
			}
		}
	}
	gen(-1);
	cout << "No\n";
}

/*

7
1 2 2 3
1 2 4 5
1 2 6 7
2 1 8
2 1 9
2 1 1
2 1 7

3
1 2 2 3
2 1 1
2 1 2

5
1 2 2 3
2 1 2
1 2 4 5
2 1 1
2 1 3

*/