#include<bits/stdc++.h>

using namespace std;

vector<int> dsu, rank_;

int get(int u) {
    if (dsu[u] != u)
        dsu[u] = get(dsu[u]);
    return dsu[u];
}

void merge_(int u, int v) {
    u = get(u);
    v = get(v);
    if (u == v) return;
    if (rank_[u] < rank_[v]) {
        dsu[u] = v;
    } else if (rank_[v] < rank_[u]) {
        dsu[v]  = u;
    } else {
        dsu[u] = v;
        ++rank_[v];
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int k, n;
    cin >> k >> n;
    vector<string> lol;
    lol.resize(k);
    for (int i = 0; i < k; ++i)
        cin >> lol[i];
    string s; cin >> s;

    dsu.resize(n);
    for (int i = 0; i < n; ++i)
        dsu[i] = i;
    rank_.assign(n, 1);
    vector<int> mx(n);
    vector<string> mn_(n, string (10000, 'z'));
    for (int i = 0; i < n; ++i)
        mx[i] = i;
    vector<string> dp(n+1);
    for (int i = n-1; i >= 0; --i) {
        int j = i, MX = i;
        string mn = dp[i+1];
        while (j+1 < n && lol[s[i]-'a'][s[j+1]-'a']-'0') {
            if (mn > mn_[get(j+1)])
                mn = mn_[get(j+1)];
            MX = mx[get(j+1)];
            merge_(i, j+1);
            mx[get(j+1)] = MX;
            j = MX;
        }
        if (mn > dp[j+1])
            mn = dp[j+1];
        dp[i] = s[i] + mn;
        mn_[get(j+1)] = min(mn_[get(j+1)], dp[i]);
    }
    cout << dp[0] << '\n';

    return 0;
}
