#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <numeric>
#include <utility>
#include <set>
#include <map>

using namespace std;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m;
    cin >> n >> m;
    string s;
    cin >> s;
    vector<int> nesov(n, 0);
    vector<bool> banned(m, false), can(m, false);
    set<pair<int, int>> bestvar;
    vector<vector<pair<int, char>>> perf(n);
    vector<vector<int>> badhere(m);
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        perf[i].resize(k);
        for (int j = 0; j < k; ++j) {
            cin >> perf[i][j].first >> perf[i][j].second;
            --perf[i][j].first;
            if (s[perf[i][j].first] == perf[i][j].second) {
                can[perf[i][j].first] = true;
            }
            else {
                nesov[i]++;
                badhere[perf[i][j].first].emplace_back(i);
            }
        }
    }
    bool canans = true;
    for (int i = 0; i < m; ++i) {
        canans = (canans && can[i]);
    }
    if (!canans) {
        cout << "-1\n";
    }
    else {
        for (int i = 0; i < n; ++i) {
            bestvar.insert({nesov[i], i});
        }
        vector<int> ans;
        while (!bestvar.empty()) {
            pair<int, int> pairnow = *bestvar.begin();
            bestvar.erase(bestvar.begin());
            if (pairnow.first != 0) {
                canans = false;
                break;
            }
            ans.emplace_back(pairnow.second);
            for (int i = 0; i < perf[pairnow.second].size(); ++i) {
                if (!banned[perf[pairnow.second][i].first]) {
                    banned[perf[pairnow.second][i].first] = true;
                    for (int j : badhere[perf[pairnow.second][i].first]) {
                        bestvar.erase({nesov[j], j});
                        nesov[j]--;
                        bestvar.insert({nesov[j], j});
                    }
                }
            }
        }
        if (!canans) {
            cout << "-1\n";
        }
        else {
            for (int elem : ans) {
                cout << elem + 1 << " ";
            }
            cout << "\n";
        }
    }

    return 0;
}
