#include <iostream>
#include <vector>

using namespace std;

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

int can[26][26];
vector<int> a;

bool can_del(int l, int r) {
	vector<int> now;
	for (int i = r; i >= l; --i) {
		while (now.size()) {
			if (can[a[i]][now.back()])
				now.pop_back();
			else
				break;
		}
		if (i != l)
			now.push_back(a[i]);
	}
	return now.size() == 0;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int k, n;
	cin >> k >> n;
	for (int i = 0; i < k; ++i) {
		string s;
		cin >> s;
		for (int j = 0; j < k; ++j) {
			can[i][j] = (s[j] - '0');
		}
	}
	vector<int> last(k);
	string res;
	a.resize(n);
	for (int i = 0; i < n; ++i) {
		char c;
		cin >> c;
		a[i] = (c - 'a');
		last[a[i]] = i;
	}	
	string ans;
	ans += (char) (k + 1 + 'a');
	string bad;
	bad += 'a' + k + 1;
	vector<string> dp(n, bad);
	dp[0] = a[0] + 'a';
	for (int pos = 0; pos < n; ++pos) {
		for (int j = -1; j < k; ++j) {
			vector<int> now;
			for (int i = n - 1; i >= pos; --i) {
				while (now.size()) {
					if (now.back() != j && can[a[i]][now.back()])
						now.pop_back();
					else
						break;
				}
				if (i != pos)
					now.push_back(a[i]);
			}
			if (!now.size() && j == -1) {
				// cout << dp[pos] << ' ' << pos << ' ' << j << '\n';
				ans = min(ans, dp[pos]);
			} else if (now.size() && now.back() == j) {
				for (int i = pos + 1; i < n; ++i) {
					if (a[i] == j) {
						string tmp;
						tmp += ('a' + j);
						dp[i] = min(dp[i], dp[pos] + tmp);
						break;
					}
				}
			}
		}
	}
	cout << ans << '\n';
	// return 1;
}