#include <iostream>
#include <vector>
#include <array>

using namespace std;

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

int can[26][26];
vector<int> a;

bool can_del(int l, int r) {
	vector<int> now;
	for (int i = r; i >= l; --i) {
		while (now.size()) {
			if (can[a[i]][now.back()])
				now.pop_back();
			else
				break;
		}
		if (i != l)
			now.push_back(a[i]);
	}
	return now.size() == 0;
}

string char_to(int a) {
	string res;
	res += (a + 'a');
	return res;
}

string _min(string a, string b) {
	a += 'z' + 1, b += 'z' + 1;
	auto res = min(a, b);
	res.pop_back();
	return res;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int k, n;
	cin >> k >> n;
	for (int i = 0; i < k; ++i) {
		string s;
		cin >> s;
		for (int j = 0; j < k; ++j) {
			can[i][j] = (s[j] - '0');
		}
	}
	a.resize(n);
	for (int i = 0; i < n; ++i) {
		char c;
		cin >> c;
		a[i] = (c - 'a');
	}
	string bad;
	bad += 'a' + k + 1;

	vector<vector<int>> del(n, vector<int> (n));
	for (int i = 0; i < n; ++i) {
		for (int j = i; j < n; ++j) {
			del[i][j] = can_del(i, j);
			// cout << del[i][j] << ' ';
		}
		// cout << '\n';
	}
	vector<pair<string, string>> dp(n, make_pair(bad, bad));
	dp[0].first = dp[0].second = char_to(a[0]);
	for (int i = 1; i < n; ++i) {
		for (int j = 0; j < i; ++j) {
			if (del[j][i]) {
				dp[i].first = min(dp[i].first, dp[j].first);
				dp[i].second = _min(dp[i].second, dp[j].second);
				dp[i].second = _min(dp[i].second, dp[j].first);
				dp[i].first = min(dp[i].first, dp[j].second);
			}
		}
		dp[i].first = min(dp[i].first, dp[i - 1].first + char_to(a[i]));
		dp[i].second = _min(dp[i].second, dp[i - 1].second + char_to(a[i]));
		dp[i].second = _min(dp[i].second, dp[i - 1].first + char_to(a[i]));
		dp[i].first = min(dp[i].first, dp[i - 1].second + char_to(a[i]));
		// dp[i].first = min(dp[i].first, dp[i - 1].first + char_to(a[i]));
		// dp[i].second = min(dp[i].first, dp[i - 1].first + char_to(a[i]));
		// dp[i].second = min(dp[i].first, dp[i - 1].second + char_to(a[i]));
	}
	// for (auto i : dp)
	// 	cout << i.first << ':' << i.second << ' ';
	// cout << '\n';
	cout << dp[n - 1].first << '\n';
}