#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <random>

using namespace std;

bool operator>(string& a, string& b) {
	for (int i = 0; i < min(a.length(), b.length()); i++) {
		if (a[i] > b[i]) return true;
		else if (a[i] < b[i]) return false;
	}
	return a.length() > b.length();
}

int main() {
	int k, n;
	cin >> k >> n;
	vector<vector<int>> can_del(k, vector<int>(k));
	for (auto& line : can_del) {
		string s;
		cin >> s;
		for (int i = 0; i < k; i++) line[i] = s[i] - '0';
	}
	string s;
	cin >> s;
	string best = s;
	mt19937 rnd(1232);
	for (int i = 0; i < 10000; i++) {
		string copy = s;
		for (int j = 0; j < copy.size() * copy.size(); j++) {
			int targ = rnd() % (copy.size() - 1);
			if (can_del[copy[targ] - 'a'][copy[targ + 1] - 'a']) copy.erase(copy.begin() + targ + 1);
		}
		if (best > copy) best = copy;
	}
	cout << best << endl;
}