#include <iostream>
#include <iomanip>
#include <cstdlib>
#include <cstdio>
#include <algorithm>
#include <cmath>
#include <string>
#include <vector>
#include <map>
#include <set>
#include <random>
#include <queue>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> pll;
typedef vector<ll> vi;
typedef vector<vi> vvi;

const ll mx1 = 500, mx2 = 26;

#define ff first
#define ss second
#define vec vector
#define all(a) a.begin(), a.end()
#define pb push_back
#define rall(a) a.rbegin(), a.rend()

ll dp[mx1][mx1];
ll to[mx2][mx2];

void run() {
	ll k, n;
	cin >> k >> n;
	for (ll i = 0; i < k; ++i)
		for (ll j = 0; j < k; ++j) {
			char ch;
			cin >> ch;
			to[i][j] = ch - '0';
		}
	string s;
	cin >> s;
	for (ll len = 0; len < n; ++len) {
		for (ll i = 0, j; i < n - len; ++i) {
			if (len == 0) {
				dp[i][i] = 1;
				continue;
			}
			j = i + len;
			for (ll w = i + 1; w <= j; ++w) {
				if (to[s[i] - 'a'][s[w] - 'a'] && dp[i][w - 1] && dp[w][j]) {
					dp[i][j] = 1;
					break;
				}
			}
		}
	}
	if (dp[0][n - 1]) {
		cout << s[0];
		return;
	}
	vec<string> ans(n + 1, "");
	ans[0] = s[0];
	for (ll i = 0; i < n; ++i) {
		//ans[i] = ans[i];
		for (ll j = i; j < n; ++j) {
			if (dp[i][j]) {
				if (ans[j + 1].empty()) {
					ans[j + 1] = ans[i];
					if (j + 1 != n)
						ans[j + 1] += s[j + 1];
				}
				else if (ans[i] + s[j + 1] < ans[j + 1])
					ans[j + 1] = ans[i] + s[j + 1];
			}
		}
	}
	cout << ans[n];
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	ll tkk = 1, kk = 0;
	while (kk++ < tkk) {
		run();
		cout << '\n';
	}
	return 0;
}

/*
3 7
010
001
100
abacaba

3 5
010
001
100
bcacb
*/