#include <iostream>
#include <iomanip>
#include <cstdlib>
#include <cstdio>
#include <algorithm>
#include <cmath>
#include <string>
#include <vector>
#include <map>
#include <set>
#include <random>
#include <queue>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> pll;
typedef vector<ll> vi;
typedef vector<vi> vvi;

const ll mx1 = 2000, mx2 = 26;

#define ff first
#define ss second
#define vec vector
#define all(a) a.begin(), a.end()
#define pb push_back
#define rall(a) a.rbegin(), a.rend()

ll dp[mx1][mx1];
ll to[mx2][mx2];

void run() {
	ll k, n;
	cin >> k >> n;
	for (ll i = 0; i < k; ++i)
		for (ll j = 0; j < k; ++j) {
			char ch;
			cin >> ch;
			to[i][j] = ch - '0';
		}
	string s;
	cin >> s;
	for (ll len = 0; len < n; ++len) {
		for (ll i = 0, j; i < n - len; ++i) {
			if (len == 0) {
				dp[i][i] = 1;
				continue;
			}
			j = i + len;
			for (ll w = i + 1; w <= i + 1; ++w) {
				if (to[s[i] - 'a'][s[w] - 'a'] && dp[i][w - 1] && dp[w][j]) {
					dp[i][j] = 1;
					break;
				}
			}
		}
	}
	if (dp[0][n - 1]) {
		cout << s[0];
		return;
	}
	vec<string> ans(n + 1, "");
	vi used(n + 1, 0);
	used[n] = 1;
	for (ll i = n; i >= 0; --i) {
		//ans[i] = ans[i];
		if (i != n)
			ans[i] = s[i] + ans[i];
		for (ll j = i - 1; j >= 0; --j) {
			if (dp[j][i - 1]) {
				if (!used[j]) {
					ans[j] = ans[i];
				}
				else if (ans[i] < ans[j])
					ans[j] = ans[i];
				used[j] = 1;
			}
		}
	}
	cout << ans[0];
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	ll tkk = 1, kk = 0;
	while (kk++ < tkk) {
		run();
		cout << '\n';
	}
	return 0;
}

/*
3 7
010
001
100
abacaba

3 5
010
001
100
bcacb
*/