#include <iostream>
#include <vector>

using namespace std;

int k, n;
string s;

string min(string s1, string s2) {
    int n1 = s1.size(), n2 = s2.size(), i = 0;
    while (i < n1 && i < n2 && s1[i] == s2[i])
        i++;
    if (i == n1)
        return s1;
    if (i == n2)
        return s2;
    if (s1[i] < s2[i])
        return s1;
    else
        return s2;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie();
    cout.tie();

    cin >> k >> n;
    char can[k][k];
    for (int i = 0; i < k; i++)
        for (int j = 0; j < k; j++)
            cin >> can[i][j];
    cin >> s;
    s += 'a';
    vector <string> dp(n + 1);
    vector <vector <int>> link(n + 1);
    link[0] = {0};
    dp[0] = s[0];
    for (int i = 1; i <= n; i++) {
        dp[i] = "{";
        for (auto &to: link[i - 1])
            dp[i] = min(dp[i], dp[to] + s[i]);
        link[i].push_back(i);
        for (auto &to: link[i - 1])
            if (can[s[to] - 'a'][s[i] - 'a'] == '1' || can[s[i - 1] - 'a'][s[i] - 'a'] == '1')
                link[i].push_back(to);
    }
    dp[n].pop_back();
    cout << dp[n] << endl;

    return 0;
}
