#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <iomanip>
#include <cstring>
#include <bitset>
#include <queue>
#include <deque>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <cassert>
#include <random>

//#pragma GCC target("avx2")

//#define int long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define ld long double

using namespace std;
inline void fastio() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void solve() {
    int c, n;
    cin >> c >> n;

    /*string s1 = "aaaa";
    string s2 = "aa";
    cout << (s1 < s2) << '\n';*/


    vector<string> matrix(c);
    for (int i = 0; i < c; ++i) {
        cin >> matrix[i];
    }
    string s;
    cin >> s;
    vector<int> v(n);
    for (int i = 0; i < n; ++i) {
        v[i] = s[i] - 'a';
    }

    vector<int> go_right(n, 0);
    go_right[n - 1] = n;
    for (int i = n - 2; i >= 0; --i) {
        go_right[i] = i + 1;
        while (go_right[i] < n && matrix[v[i]][v[go_right[i]]] == '1') {
            go_right[i] = go_right[go_right[i]];
        }
    }

    /*for (int i = 0; i < n; ++i) {
        cout << go_right[i] << ' ';
    } cout << '\n';*/

    /*vector<string> dp(n + 1, {(char) (((int) 'z') + 1)});
    dp[0] = s[0];
    for (int i = 1; i <= n; ++i) {
        for (int j = i - 1; j >= 0; --j) {
            if (go_right[j] >= i) {
                if (i < n) {
                    dp[j].push_back(s[i]);
                    dp[i] = min(dp[i], dp[j]);
                    dp[j].pop_back();
                } else {
                    dp[i] = min(dp[i], dp[j]);
                }
            }
        }
    }
    cout << dp[n] << '\n';*/

    string ans = "{";
    // 1 + 4 + 8
    for (int mask = 0; mask < (1 << n); ++mask) {
        if ((mask & 1) == 0) continue;
        vector<int> vec;
        for (int i = 0; i < n; ++i) {
            if ((mask >> i) & 1) {
                vec.push_back(i);
            }
        }
        bool good = true;
        for (int i = 0; i < (int) vec.size() - 1; ++i) {
            if (go_right[vec[i]] < vec[i + 1]) {
                good = false;
                break;
            }
        }
        if (go_right[vec.back()] < n) {
            good = false;
        }
        if (good) {
            string ss = "";
            for (auto i : vec) {
                ss.push_back(s[i]);
            }
            ans = min(ans, ss);
        }
    }
    cout << ans << '\n';
}

signed main() {
#ifdef lolipop
    freopen("input.txt", "r", stdin);
#else
    fastio();
#endif
    int T = 1;
    // cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}