#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <iomanip>
#include <cstring>
#include <bitset>
#include <queue>
#include <deque>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <cassert>
#include <random>

// #pragma GCC target("avx2")

#define int long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define ld long double

using namespace std;
inline void fastio() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

bool matrix[32][32];

int bx, by;

void inp() {
    cin >> bx >> by;
}

void win_now() {
    cout << "1 2\n";
    cout.flush();
    inp();
    cout << "2 1\n";
    cout.flush();
    inp();
}

void win_slow() {
    cout << "1 2\n";
    cout.flush();
    inp();
    cout << "15 1\n";
    cout.flush();
    inp();
    cout << "2 1\n";
    inp();
    cout.flush();
}

void solve1() {
    int n, k, m;
    cin >> n >> k >> m;
    string s;
    cin >> s;
    int now_move = 0;
    for (int i = 0; i < m; ++i) {
        if (now_move == 1) {
            inp();
        }
        if (s[i] == '0') {
            win_slow();
        } else {
            win_now();
        }
        now_move ^= 1;
    }
    if (now_move) inp();
    cout << "0\n";
    cout.flush();
}

void solve2() {
    int n, k, m;
    cin >> n >> k >> m;
    int t;
    cin >> t;
    vector<bool> ans;
    for (int _ = 0; _ < t; ++_) {
        int x, y;
        bool bit = true;
        while (cin >> x >> y) {
            if (x == 1 && y == 1) break;
            if (x == 15 && y == 1) {
                bit = false;
            }
        }
        ans.push_back(bit);
    }
    for (auto i : ans) {
        cout << i;
    }
    cout << '\n';
    cout.flush();
}

signed main() {
#ifdef lolipop
//    freopen("input.txt", "r", stdin);
#else
    fastio();
#endif
    int T = 1;
     cin >> T;
     if (T == 1) {
         solve1();
     } else {
         solve2();
     }
    return 0;
}