#include <iostream>
#include <cstdio>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <utility>
#define int long long
#define all(z) z.begin(), z.end()
#define rall(z) z.rbegin(), z.rend()
#define pb push_back
#define eb emplace_back
using namespace std;
using vi = vector<int>;
using pii = pair<int, int>;

int n, k, m;
int lev[32];

inline void reg(int x, int y)
{
    for (int i = 0; i <= x; i++)
        lev[i] = max(lev[i], y+1);
}

inline void do_move(int x, int y)
{
    reg(x, y);
    cout << n-x << ' ' << n-y << endl;
}

inline void re_move()
{
    int x0, y0;
    cin >> x0 >> y0;

    int x = n-x0, y = n-y0;
    reg(x, y);
}

inline bool is_fin()
{
    return lev[n-1] == n;
}

inline bool need_fin()
{
    for (int i = 0; i < n; i++)
        if (lev[i] == n)
            return true;
    return false;
}

inline void do_fin(int t)
{
    //cout << "do_fin" << endl;
    if (t == 0)
        re_move();

    if (!is_fin())
        do_move(n-1, n-1);
}


inline void solve1()
{
    string s;
    cin >> s; // code

    int t0 = 1;

    int pos = 0;
    while (pos < m)
    {
        fill_n(lev, n, 0);

        int t = t0;
        while (!is_fin())
        {
            if (need_fin() || pos >= m)
            {
                do_fin(t);
                break;
            }

            if (t == 0)
                re_move();
            else
            {
                int x = 0;
                for (int i = 0; i < 5; i++)
                    x = 2*x + s[pos+i]-'0';
                pos += 5;
                do_move(x, lev[x]);
            }

            t ^= 1;
        }

        t0 ^= 1;
    }

    if (!t0)
        re_move();

    cout << "0" << endl;
}


inline void solve2()
{
    int q;
    cin >> q;

    vi ans;
    ans.reserve(m);

    int t0 = 1;
    int qq = 0;
    int pos = 0;

    while (qq < q)
    {
        fill_n(lev, n, 0);

        int t = t0;
        while (!is_fin())
        {
            if (need_fin() || pos >= m)
            {
                if (!t)
                    re_move(), qq++;
                if (!is_fin())
                    re_move(), qq++;
                break;
            }

            if (t == 0)
                re_move(), qq++;
            else
            {
                int x0, y0;
                cin >> x0 >> y0, qq++;
                int x = n-x0, y = n-y0;
                reg(x, y);

                for (int i = 0; i < 5; i++)
                {
                    ans.pb(x & 1);
                    x /= 2;
                }
                pos += 5;
            }

            t ^= 1;
        }

        t0 ^= 1;
    }

    for (int i : ans)
         cout << i;
}


signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    //freopen("\\\\.\\pipe\\game.in", "r", stdin);
    //freopen("\\\\.\\pipe\\game.out", "w", stdout);

    int com;
    cin >> com >> n >> k >> m;

    if (com == 1)
        solve1(); // encode
    else // com == 2
        solve2(); // decode

    return 0;
}

/*
1
32 8 10
0111010001
1 10

2
32 8 5
3
22 32
23 32
1 1

2
32 8 10
5
18 32
1 10
15 9
2 2
1 1
*/
