#include <bits/stdc++.h>

using namespace std;

const int MAXN = 105;

vector<vector<int>> g(MAXN);
vector<vector<int>> a(MAXN);

map<int, int> num;

int used[MAXN];

int dp[MAXN][MAXN][MAXN];

void dfs(int u)
{
    used[u] = true;
    vector<int> cur;
    for (auto v : g[u])
    {
        if (!used[v])
        {
            dfs(v);
            cur.push_back(v);
        }
    }
    if (cur.size() == 0)
    {
        for (auto el : a[u])
        {
            for (int i = 0; i <= num[el]; ++i)
            {
                for (int j = num[el]; j < MAXN; ++j)
                {
                    dp[u][i][j] = true;
                }
            }
        }
        return;
    }
    if (cur.size() == 1)
    {
        for (int i = 0; i < MAXN; ++i)
        {
            for (int j = 0; j < MAXN; ++j)
            {
                dp[u][i][j] = dp[cur[0]][i][j];
            }
        }
        return;
    }
    else
    {
        int x = cur[0];
        int y = cur[1];
        for (int i = 0; i < MAXN; ++i)
        {
            for (int j = i; j < MAXN; ++j)
            {
                for (int k = i; k <= j; ++k)
                {
                    dp[u][i][j] |= (dp[x][i][k] & dp[y][k][j]);
                    dp[u][i][j] |= (dp[y][i][k] & dp[x][k][j]);
                }
            }
        }
    }
}

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n;
    cin >> n;
    vector<int> x;
    for (int i = 0; i < n; ++i)
    {
        int t;
        cin >> t;
        if (t == 1)
        {
            int k;
            cin >> k;
            for (int _ = 0; _ < k; ++_)
            {
                int u;
                cin >> u;
                --u;
                g[i].push_back(u);
            }
        }
        else
        {
            int k;
            cin >> k;
            for (int _ = 0; _ < k; ++_)
            {
                int u;
                cin >> u;
                a[i].push_back(u);
                x.push_back(u);
            }
        }
    }
    sort(x.begin(), x.end());
    num[x[0]] = 0;
    for (int i = 1; i < x.size(); ++i)
    {
        if (x[i] == x[i - 1])
        {
            num[x[i]] = num[x[i - 1]];
        }
        else
        {
            num[x[i]] = num[x[i - 1]] + 1;
        }
    }
    dfs(0);
    if (dp[0][0][MAXN - 1])
    {
        cout << "Yes" << endl;
    }
    else
    {
        cout << "No" << endl;
    }
    return 0;
}


