#define _CRT_SECURE_NO_WARNINGS
//#pragma comment(linker, "/stack:100000000")

#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <set>
#include <map>

using namespace std;

signed main()
{
	ios::sync_with_stdio(0);
	cin.tie();
	cout.tie();
	//freopen("input.txt", "r", stdin);
	
	int n, m;
	cin >> n >> m;
	string s;
	cin >> s;
	vector <vector <pair <int, char> > > a(n);
	vector <int> mis(n);
	vector <vector <int> > misi(m);
	set <pair <int, int> > dynmis;
	vector <bool> check(m);
	
	for (int i = 0; i < n; ++i)
	{
		int k;
		cin >> k;
		a[i].resize(k);
		for (int j = 0; j < k; ++j)
		{
			cin >> a[i][j].first >> a[i][j].second;
			a[i][j].first--;
			if (a[i][j].second != s[a[i][j].first])
			{
				mis[i]++;
				misi[a[i][j].first].push_back(i);
			}
			else
			{
				check[a[i][j].first] = true;
			}
		}
		dynmis.insert({ mis[i], i });
	}

	for (int i = 0; i < m; ++i)
	{
		if (!check[i])
		{
			cout << -1;
			return 0;
		}
	}

	vector <int> ans;
	while (dynmis.size())
	{
		pair <int, int> p = (*dynmis.begin());
		dynmis.erase(dynmis.begin());
		int ind = p.second;
		ans.push_back(ind);
		if (p.first != 0)
		{
			cout << -1;
			return 0;
		}
		for (int i = 0; i < a[ind].size(); ++i)
		{
			for (int j : misi[a[ind][i].first])
			{
				dynmis.erase({ mis[j], j });
				mis[j]--;
				dynmis.insert({ mis[j], j });
			}
			misi[a[ind][i].first].clear();
		}
	}

	for (int i = 0; i < n; ++i)
	{
		cout << ans[i] + 1 << ' ';
	}
	
	return 0;
}