#include <bits/stdc++.h>

using namespace std;

int n, k, m;
vector<string> arr;
bool fin;
//int last;
int A, B;
int upx, upy;
int dox, doy;

//set<pair<int, int>> aval;


void moveup() {
  for (int y = upy; y >= 0; --y) {
    if (arr[upx][upy] == '0') {
      upy = y;
      return;
    }
  }
  for (int x = upx - 1; x >= 0; --x) {
    for (upy = n - 1; upy >= 0; --upy) {
      if (arr[x][upy] == '0') {
        upx = x;
        return;
      }
    }
  }
}

void movedo() {
  for (int x = dox; x >= 0; --x) {
    if (arr[dox][doy] == '0') {
      dox = x;
      return;
    }
  }
  for (int y = upy - 1; y >= 0; --y) {
    for (dox = n - 1; dox >= 0; --dox) {
      if (arr[dox][y] == '0') {
        upy = y;
        return;
      }
    }
  }
}

int paint(int x, int y) {
  int res = 0;
  for (int i = x; i < n; ++i) {
    if (arr[i][y] == '1')
      break;
    for (int j = y; j < n; ++j) {
      if (arr[i][j] == '1')
        break;
      res += arr[i][j] == '0';
      arr[i][j] = '1';
    }
  }
  moveup();
  movedo();
  return res;
}

void get() {
  int a = 0, b = 0;
  if (!(cin >> a)) {
    a = 0, b = 0;
  } else
    cin >> b;
  a--, b--;
  A = a, B = b;
  if (a < 0 || (a == 0 && b == 0)) {
    fin = true;
  }
  paint(a, b);
}


//int getarea(int x, int y) {
//  int res = 0;
//  for (int i = x; i < n; ++i) {
//    if (arr[i][y] == '1')
//      break;
//    for (int j = y; j < n; ++j) {
//      if (arr[i][x] == '1')
//        break;
//      res += arr[i][j] == '0';
//    }
//  }
//  return res;
//}

//bool fset(int a) {
//  for (int i = 0; i < n; ++i) {
//    if (arr[i][0] == '1')
//      break;
//    for (int j = 0; j < n; ++j) {
//      if (i == 0 && j == 0)
//        continue;
//      if (arr[i][j] == '1')
//        break;
//      if (getarea(i, j) == a) {
//        cout << i + 1 << ' ' << j + 1 << endl;
//        paint(i, j);
//        return true;
//      }
//    }
//  }
//  return false;
//}

void startgame() {
  fin = false;
  A = 0, B = 0;
  upx = 0;
  upy = 0;
  dox = 0;
  doy = 0;
}

void solve1() {
  string s;
  cin >> s;
  int game = 1;
  int p = 0;
  fin = true;
  while (p < m) {
    game ^= 1;
    startgame();
    if (game) {
      get();
    }
    if (p == m) {
      cout << 0 << endl;
      return;
    }
    while (!fin && p < m) {
      if (upx == dox && upy == doy) {
        if (s[p] == '0') {
          cout << upx + 1 << ' ' << upy + 1 << endl;
          paint(upx, upy);
        } else {
          if (upx - 1 < 0) {
            cout << "1 1" << endl;
            fin = true;
            continue;
          }
          cout << upx << ' ' << upy + 1 << endl;
          paint(upx - 1, upy);
        }
        p++;
        get();
      } else {
        if (s[p] == '0') {
          cout << upx + 1 << ' ' << upy + 1 << endl;
          paint(upx, upy);
        } else {
          cout << dox + 1 << ' ' << doy + 1 << endl;
          paint(dox, doy);
        }
        p++;
        get();
      }
    }
    if (p == m && !fin) {
      cout << "1 1" << endl;
      fin = true;
      break;
    }
  }
  cout << 0 << endl;
}

void solve2() {
  int games;
  cin >> games;
  string s;
  for (int g = 0; g < games && A != -1; ++g) {
    startgame();
    bool fst = g & 1;
    if (fst) {
      get();
    }
    while (!fin) {
      if (upx == dox && upy == doy) {
        int ux = upx, uy = upy;
        int dx = dox, dy = doy;
        get();
        if (fin)
          continue;
        if (A == ux && B == uy) {
          s.push_back('0');
        } else {
          s.push_back('1');
        }
        get();
      } else {
        int ux = upx, uy = upy;
        int dx = dox, dy = doy;
        get();
        if (!fin) {
          if (A == ux && B == uy)
            s.push_back('0');
          else
            s.push_back('1');
          get();
        }
      }
    }
  }
  cout << s << endl;
}

signed main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  int t;
  cin >> t;
  cin >> n >> k >> m;
  if (t == 1)
    solve1();
  else
    solve2();
}

