#include <bits/stdc++.h>

using namespace std;

#define pb emplace_back
#define fi first
#define se second
#define all(x) (x).begin(), (x).end()
#define ll long long
#define ld long double
#define pii pair<int, int>

const int INF = 1e9 + 1;
const int K = 1;

vector<vector<int>> a;

int get(string s) {
    int ans = 0;
    for (auto &c : s) {
        ans *= 2;
        ans += c - '0';
    }
    return ans;
}

string get1(int x) {
    string ans = "";
    while (x) {
        ans += ('0' + x % 2);
        x /= 2;
    }
    reverse(all(ans));
    return ans;
}

set<pii> cur;

void color(int i, int j) {
    i--; j--;
    int n = 32;
    for (int i1 = i; i1 < n; i1++) {
        if (a[i1][j]) break;
        for (int j1 = j; j1 < n; j1++) {
            if (a[i1][j1]) break;
            a[i1][j1] = 1;
            cur.erase({i1, j1});
        }
    }
}

int main() {
    /*
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    */
    int g;
    cin >> g;
    int n, k, m;
    cin >> n >> k >> m;
    if (g == 1) {
        string s;
        cin >> s;
        int i = 0;
        int cnt = 0;
        while (i < m) {
            a.assign(n, vector<int>(n, 0));
            cur.clear();
            for (int i = 0; i < n; i++) {
                for (int j = 0; j < n; j++) {
                    cur.insert({i, j});
                }
            }
            int a, b;
            if (cnt % 2 == 1) {
                cin >> a >> b;
                color(a, b);
            }
            for (; i < m; i += K) {
                int c = get(s.substr(i, K));
                auto it = cur.end();
                bool ok = 0;
                while (it == cur.end() || (it->fi + it->se) % (1 << K) != c) {
                    if (it == cur.begin()) break;
                    it--;
                    if ((it->fi + it->se) % (1 << K) == c) {
                        ok = 1;
                        cout << it->fi + 1 << " " << it->se + 1 << endl;
                        color(it->fi, it->se);
                        break;
                    }
                }
                if (!ok) {
                    cout << 1 << " " << 1 << endl;
                    break;
                }
                int a, b;
                cin >> a >> b;
                color(a, b);
                if (a == 1 && b == 1) break;
            }
            cnt++;
        }
        cout << 0 << endl;
    } else {
        int t;
        cin >> t;
        string s = "";
        for (int i = 0; i < t; i++) {
            int a, b;
            if (i % 2 == 1) cin >> a >> b;
            while (1) {
                cin >> a >> b;
                if (a == 1 && b == 1) break;
                s += get1((a + b - 2) % (1 << K));
                cin >> a >> b;
                if (a == 1 && b == 1) break;
            }
        }
        cout << s << endl;
    }
    return 0;
}
