#include <bits/stdc++.h>

using namespace std;

const int MAXN = 100000;

set<int> ban[MAXN], cards[MAXN], est[MAXN];

void solve() {
    int n, m;
    cin >> n >> m;
    string s;
    cin >> s;
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        for (int j = 0; j < k; ++j) {
            int pos;
            char res;
            cin >> pos >> res;
            --pos;
            if (res == s[pos]) {
                est[i].insert(pos);
            } else {
                ban[i].insert(pos);
                cards[pos].insert(i);
            }
        }
    }
    set<int> bad_pos, good;
    for (int i = 0; i < m; ++i)
        bad_pos.insert(i);
    for (int i = 0; i < n; ++i)
        if (ban[i].size() == 0) {
            good.insert(i);
        }
    vector<int> ans;
    set<int> used;
    while (good.size()) {
        int v = *good.begin();
        ans.push_back(v);
        good.erase(v);
        used.insert(v);
        for (auto x : est[v]) {
            bad_pos.erase(x);
            if (cards[x].size()) {
                for (auto y : cards[x]) {
                    ban[y].erase(x);
                    if (ban[y].size() == 0 && used.find(y) == used.end()) {
                        good.insert(y);
                    }
                }
                cards[x].clear();
            }
        }
    }
    if (bad_pos.size()) {
        cout << "-1\n";
    } else {
        for (auto x : ans)
            cout << x + 1 << ' ';
        cout << '\n';
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
#endif
    int t = 1; // cin >> t;
    while (t--)
        solve();
    return 0;
}
