#include <iostream>
#include <vector>
#include <string>
#include <set>

using namespace std;


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);



    int n, m;
    string s;
    cin >> n >> m >> s;
    vector<vector<char>> a(n, vector<char> (m, ' '));
    set<int> emp, lines;
    for (int i = 0; i < n; ++i) {
        lines.insert(i);
        int k;
        cin >> k;
        for (int j = 0; j < k; ++j) {
            int ind;
            char ch;
            cin >> ind >> ch;
            a[i][ind - 1] = ch;
        }
    }
    for (int i = 0; i < m; ++i) {
        emp.insert(i);
    }



    vector<int> ans(n, -1);
    int cur = 0;

    while (!emp.empty()) {
        int best_id = -1, best_cnt = 0;
        for (auto i: lines) {
            int cnt = 0;
            for (auto j: emp) {
                if (a[i][j] == ' ')
                    continue;
                if (a[i][j] != s[j]) {
                    cnt = -1;
                    break;
                }
                else
                    ++cnt;
            }


            if (cnt > best_cnt) {
                best_id = i;
                best_cnt = cnt;
            }
        }
        if (best_id == -1) {
            cout << -1;
            return 0;
        }


        vector<int> er;
        for (auto j: emp) {
            if (a[best_id][j] == s[j])
                er.push_back(j);
        }
        for (auto x: er)
            emp.erase(x);
        lines.erase(best_id);


        ans[cur] = best_id;
        ++cur;
    }

    if (!lines.empty()) {
        for (auto i: lines) {
            ans[cur] = i;
            ++cur;
        }
    }




    for (int i = 0; i < n; ++i) {
        cout << ans[i] + 1 << " ";
    }
}
