#define ll long long

#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <map>

using namespace std;

struct el {
	ll p = 0;
	char c = '1';
	ll cnt = 0;
};

void cln(vector<ll>& v, set<pair<ll ,ll>> &st, vector<ll> &cnt, ll x) {
	for (int i = 0; i < v.size(); i++) {
		st.erase({ cnt[v[i]], v[i] });
		--cnt[v[i]];
		st.insert({ cnt[v[i]], v[i] });
	}
}

void solve(){
	ll n, m;
	cin >> n >> m;
	string s;
	cin >> s;
	map<ll, vector<ll>> mp;
	vector<vector<el>> a(n);
	vector<ll> cnt(n, 0);
	for (int i = 0; i < n; i++) {
		ll q;
		cin >> q;
		for (int j = 0; j < q; j++) {
			ll t;
			char h;
			cin >> t >> h;
			t--;
			if (s[t] != h) {
				if (mp.find(t) == mp.end()) {
					mp[t] = {};
				}
				mp[t].push_back(i);
				cnt[i]++;
			}
			a[i].push_back({ t, h });
		}
	}
	vector<ll >ans;
	vector<bool> b(m, 0), used(n, 0);
	for (int i = 0; i < n; i++) {
		bool f = 0;
		for (int j = 0; j < n; j++) {
			if (cnt[j] == 0 && !used[j]) {
				ans.push_back(j);
				used[j] = 1;
				f = 1;
				for (int k = 0; k < a[j].size(); k++) {
					b[a[j][k].p] = 1;
				}
				break;
			}
		}
		if (f == 0) {
			cout << -1;
			return;
		}
		for (int j = 0; j < n; j++) {
			if (used[j]) {
				continue;
			}
			for (int k = 0; k < a[j].size(); k++) {
				if (b[a[j][k].p] && s[a[j][k].p] != a[j][k].c) {
					a[j].erase(a[j].begin() + k);
					cnt[j]--;
					k--;
				}
			}
		}
	}
	for (int i = 0; i < m; i++) {
		if (!b[i]) {
			cout << -1;
			return;
		}
	}
	for (int i = 0; i < n; i++) {
		cout << ans[i] + 1 << " ";
	}
}

signed main() {
	// solve(); return 0;
	ll n, m;
	cin >> n >> m;
	string s;
	cin >> s;
	map<ll, vector<ll>> mp;
	vector<vector<el>> a(n);
	vector<ll> cnt(n, 0);
	for (int i = 0; i < n; i++) {
		ll q;
		cin >> q;
		for (int j = 0; j < q; j++) {
			ll t;
			char h;
			cin >> t >> h;
			t--;
			if (s[t] != h) {
				if (mp.find(t) == mp.end()) {
					mp[t] = {};
				}
				mp[t].push_back(i);
				cnt[i]++;
			}
			a[i].push_back({ t, h });
		}
	}

	set<pair<ll, ll>> st;
	for (int i = 0; i < n; i++) {
		st.insert({ cnt[i], i });
	}

	vector<ll> ans(n);
	ll uk = 0;
	vector<bool> b(m, 0);

	while (st.size()) {
		if (st.begin()->first != 0) {
			cout << -1;
			return 0;
		}
		ans[uk] = st.begin()->second + 1;
		uk++;
		ll pz = st.begin()->second;
		st.erase(st.begin());
		for (int i = 0; i < a[pz].size(); i++) {
			if (!b[a[pz][i].p] && a[pz][i].c == s[a[pz][i].p]) {
				b[a[pz][i].p] = 1;
				cln(mp[a[pz][i].p], st, cnt, a[pz][i].p);
			}
		}
	}
	for (int i = 0; i < m; i++) {
		if (!b[i]) {
			cout << -1;
			return 0;
		}
	}
	for (int i = 0; i < n; i++) {
		cout << ans[i] << " ";
	}


}


/*
4 5
adndb
2 1 a 4 d
3 1 a 2 d 4 c
4 1 h 2 f 3 n 5 b
1 1 a


3 4
glhf
3 1 r 3 h 4 i
3 1 r 2 l 3 o
2 1 g 4 f
*/