#include <iostream>
#include <string>
#include <vector>
#include <array>
#include <cstdio>
#include <climits>
int main()
{
	int n, m; std::cin >> n >> m;;
	std::string s; std::cin >> s;
	std::vector<std::vector<std::pair<int,char>>> cards(n);
	for(int i = 0; i < n; i++)
	{
		int k; std::cin >> k;
		for(int j = 0; j < k; j++)
		{
			int a; char buf[5];
			scanf("%d%s", &a, buf);
			a--;
			cards[i].push_back({a, buf[0]});
		}
	}
	//first card must have no mismatches. find such a card and place it
	std::vector<char> alive(m, true);
	std::vector<char> used(n, false);
	std::vector<int> ans;
	for(int i = 0; i < m; i++)
	{
		for(int ci = 0; ci < n; ci++)
		{
			if(used[ci]) continue;
			bool ok = true;
			for(auto[j, c] : cards[ci])
			{
				if(alive[j] && c != s[j])
				{
					ok = false;
					break;
				}
			}
			//printf("i=%d, ci=%d, ok=%d\n", i, ci, ok);
			if(!ok) continue;
			ans.push_back(ci);
			for(auto[j, c] : cards[ci])
				alive[j] = false;
			used[ci] = true;
			break;
		}
	}
	for(int i = 0; i < n; i++)
		if(!used[i]) ans.push_back(i);
	for(int i = 0; i < m; i++)
	{
		if(!alive[i]) continue;
		printf("-1\n");
		return 0;
	}
	for(int x : ans)
		printf("%d ", x + 1);
	printf("\n");
}
