#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main() {
    int n, m;
    cin >> n >> m;
    string s;
    cin >> s;
    vector<vector<pair<int, char>>> a(n);
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        a[i].resize(k);
        for (int j = 0; j < k; ++j) {
            int ind;
            char c;
            cin >> ind >> c;
            a[i][j] = {ind, c};
        }
    }
    vector<bool> pos(m);
    vector<bool> used(n);
    vector<int> ans;
    for (int elem = 0; elem < n; ++elem) {
        for (int i = 0; i < n; ++i) {
            if (!used[i]) {
                bool flag = false;
                for (auto j : a[i]) {
                    if (!pos[j.first - 1] && s[j.first - 1] != j.second) {
                        flag = true;
                        break;
                    }
                }
                if (!flag) {
                    ans.push_back(i + 1);
                    for (auto j : a[i]) {
                        pos[j.first - 1] = true;
                    }
                    used[i] = true;
                    break;
                }
            }
        }
        if (ans.size() - 1 != elem) {
            cout << -1;
            return 0;
        }
    }
    if (count(pos.begin(), pos.end(), false) > 0){
        cout << -1;
        return 0;
    }
    for (auto i : ans){
        cout << i << " ";
    }
}
