class game:
    def __init__(self, n):
        self.field = [[0] * n for _ in range(n)]
        self.n = n
        self.rest = n * n

    def make_move(self, x, y):
        x, y = x - 1, y - 1
        for i in range(x, self.n):
            if self.field[i][y] == 1:
                break
            for j in range(y, self.n):
                if self.field[i][j] == 1:
                    break
                self.field[i][j] = 1
                self.rest -= 1

    def count(self, x, y):
        res = 0
        for i in range(x, self.n):
            if self.field[i][y] == 1:
                break
            for j in range(y, self.n):
                if self.field[i][j] == 1:
                    break
                res += 1
        return res

    def gms2(self):
        res = []
        for x in reversed(range(self.n)):
            for y in reversed(range(self.n)):
                cr = self.count(x, y)
                if cr > 2:
                    break
                if cr > 0:
                    res.append((x + 1, y + 1))
        return res

    def autowin(self):
        pass


def encrypt(s, n, k, m):
    fm = 1
    loses = 0
    while len(s) > 0:
        gm = game(n)
        mv = fm
        while gm.rest > 0:
            if mv:
                mvs = gm.gms2()
                kr = len(mvs)
                if kr == 1 or len(s) == 0:
                    gm.make_move(*mvs[0])
                    print(*mvs[0])
                elif kr < 4 or len(s) == 1:
                    move = mvs[s[0]]
                    s = s[1:]
                    gm.make_move(*move)
                    print(*move)
                elif kr < 8 or len(s) == 2:
                    move = mvs[s[1] * 2 + s[0]]
                    s = s[2:]
                else:
                    move = mvs[s[2] * 4 + s[1] * 2 + s[0]]
                    s = s[3:]
            else:
                x, y = map(int, input().split())
                gm.make_move(x, y)
            mv = 1 - mv
        if mv == 0:
            loses += 1
        fm = 1 - fm
    print(0)

def decrypt(gn, n, k, m):
    fm = 1
    s = []
    for _ in range(gn):
        gm = game(n)
        mv = fm
        while gm.rest > 0:
            if mv:
                mvs = gm.gms2()
                kr = len(mvs)
                move = tuple(map(int, input().split()))
                gm.make_move(*move)
                ids = mvs.index(move)
                if kr == 1 or len(s) == m:
                    pass
                elif kr < 4 or len(s) == m - 1:
                    s.append(ids)
                elif kr < 8 or len(s) == m - 2:
                    for _ in range(2):
                        s.append(ids % 2)
                        ids //= 2
                else:
                    for _ in range(3):
                        s.append(ids % 2)
                        ids //= 2
            else:
                x, y = map(int, input().split())
                gm.make_move(x, y)
            mv = 1 - mv
        fm = 1 - fm
    print(*s, sep='')

mode = int(input())
n, k, m = map(int, input().split())
if mode == 1:
    s = list(map(int, input()))
    encrypt(s, n, k, m)
else:
    gn = int(input())
    decrypt(gn, n, k, m)
