#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;
using namespace std;

inline void get_answer(vector <vector <pair <int, char>>> &perfs, vector <int> &answer, vector <pair <int, char>> &current, vector <bool> &used, string &s, int n, int m) {
    bool f = true;

    for (auto [perf_id, x]: current) {
        if (x == ' ') {
            f = false;
        }
    }

    if (f) {
        for (int i = 0; i < m; i++) {
            if (current[i].second != s[i]) {
                return;
            }
        }

        for (int x: answer) {
            cout << x + 1 << ' ';
        }

        for (int i = 0; i < n; i++) {
            if (!used[i]) {
                cout << i + 1 << ' ';
            }
        }

        cout << '\n';
        exit(0);
    }

    for (int i = 0; i < n; i++) {
        if (used[i]) continue;

        bool shit_card = false;
        for (auto [pos, c]: perfs[i]) {
            if (current[pos].first == -1 && s[pos] != c) {
                shit_card = true;
                break;
            }
        }

        if (shit_card) continue;

        used[i] = true;

        for (auto [pos, c]: perfs[i]) {
            if (current[pos].first == -1) {
                current[pos] = {i, c};
            }
        }

        answer.push_back(i);

        get_answer(perfs, answer, current, used, s, n, m);

        answer.pop_back();

        used[i] = false;
        for (auto [pos, c]: perfs[i]) {
            if (current[pos].first == i) {
                current[pos] = {-1, ' '};
            }
        }
    }
}


inline void solve() {
    int n, m;
    cin >> n >> m;

    string s;
    cin >> s;

    char c;
    int k, a;
    vector <vector <pair <int, char>>> perfs(n);
    for (int i = 0; i < n; i++) {
        cin >> k;

        for (int j = 0; j < k; j++) {
            cin >> a >> c;
            perfs[i].push_back({a - 1, c});
        }
    }

    vector <int> answer;
    vector <pair <int, char>> current(m, {-1, ' '});
    vector <bool> used(n);

    get_answer(perfs, answer, current, used, s, n, m);

    cout << "-1\n";
}

signed main() {
    #ifdef local
    freopen("input.txt", "r", stdin);
    #endif // local

    cin.tie(NULL);
    ios_base::sync_with_stdio(false);

    solve();
}
