#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;
typedef long double ld;

#define all(x) (x).begin(), (x).end()
#define print(x) {for (auto xxxxx : (x)) cout << xxxxx << ' '; cout << '\n';}

const int maxn = 2000 + 5;

bool dp[maxn][maxn];
int k, n;
vector < vector <bool> > a;
vector <int> s;

void solve1() {
    if (a[0][0] == 1) {
        cout << "a\n";
    } else {
        for (auto x : s) {
            cout << char(x + 'a');
        }
        cout << '\n';
    }
}

void print_ans() {
    while ((int)s.size() >= 2 && a[s[s.size() - 2]][s[s.size() - 1]]) {
        s.pop_back();
    }
    for (auto x : s) {
        cout << char(x + 'a');
    }
    cout << '\n';
}

void solve2() {
    /*
    vector <pii> p;
    for (int i = 0; i < n; i++) {
        if (p.empty() || p.back().first != s[i]) {
            p.emplace_back(s[i], 1);
        } else {
            p.back().second++;
        }
    }
    */
    vector <int> cnt(k, 0);
    for (auto x : s) {
        cnt[x]++;
    }
    if (a[1][1]) {
        vector <int> tmp;
        for (int i = 0; i < n; i++) {
            if (i > 0 && s[i] == 1 && s[i - 1] == 1) {
                continue;
            }
            tmp.push_back(s[i]);
        }
        s = tmp;
        n = s.size();
    }
    if (cnt[0] == 0) {
        print_ans();
        return;
    }
    if (cnt[1] == 0) {
        if (a[0][0]) {
            vector <int> tmp;
            for (int i = 0; i < n; i++) {
                if (i > 0 && s[i] == 0 && s[i - 1] == 0) {
                    continue;
                }
                tmp.push_back(s[i]);
            }
            s = tmp;
            n = s.size();
        }
        print_ans();
        return;
    }
    if (a[0][1] && a[1][0]) {
        vector <int> tmp;
        for (int i = 0; i < n; i++) {
            if (i > 0 && s[i] != s[i - 1])
                break;
            tmp.push_back(s[i]);
        }
        s = tmp;
        n = s.size();
        print_ans();
        return;
    }
    if (a[0][1]) {
        bool was_a = false;
        vector <int> tmp;
        for (int i = 0; i < n; i++) {
            if (s[i] == 1 && was_a)
                continue;
            tmp.push_back(s[i]);
            if (s[i] == 0)
                was_a = true;
        }
        s = tmp;
        n = s.size();
        print_ans();
        return;
    }
    if (a[1][0]) {
        if (a[1][1]) {
            vector <int> tmp;
            bool was_b = false;
            for (int i = 0; i < n; i++) {
                if (was_b && s[i] == 0)
                    continue;
                tmp.push_back(s[i]);
                if (s[i] == 1)
                    was_b = true;
            }
            s = tmp;
            n = s.size();
        }
        while (!s.empty() && s.back() == 0) {
            s.pop_back();
        }
        print_ans();
        return;
    }
    print_ans();
}

void solve() {
    cin >> k >> n;
    a.resize(k, vector <bool> (k));
    for (int i = 0; i < k; i++) {
        for (int j = 0; j < k; j++) {
            char c; cin >> c;
            a[i][j] = (c == '1');
        }
    }
    s.resize(n);
    for (int i = 0; i < n; i++) {
        char c; cin >> c;
        s[i] = c - 'a';
    }

    if (k == 1) {
        solve1();
        return;
    }
    if (k == 2) {
        solve2();
        return;
        //cout << endl;
    }

    for (int j = 0; j < n; j++) {
        for (int k = 0; k < n; k++) {
            dp[j][k] = (j > k);
        }
    }
    for (int len = 1; len <= n; len++) {
        for (int i = 1; i + len <= n; i++) {
            int j = i + len - 1;
            for (int k = i; k <= j; k++) {
                if (a[s[i - 1]][s[k]] && (k - 1 < 0 || dp[i][k - 1]) && (k + 1 >= n || dp[k + 1][j])) {
                    dp[i][j] = true;
                    break;
                }
            }
        }
    }
    vector <string> suff(n);
    for (int i = 0; i < n; i++) {
        suff[i] = "";
        for (int j = i; j < n; j++) {
            suff[i] += (s[j] + 'a');
        }
    }
    for (int i = n - 1; i >= 0; i--) {
        for (int j = i + 1; j < n; j++) {
            if (i + 1 > j - 1 || dp[i + 1][j - 1]) {
                suff[i] = min(suff[i], char(s[i] + 'a') + suff[j]);
            }
        }
        if (dp[i + 1][n - 1]) {
            suff[i] = "";
            suff[i] += (s[i] + 'a');
        }
    }
    cout << suff[0] << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.precision(20);

    int t = 1;
    //cin >> t;
    while (t --> 0) {
        solve();
    }

    return 0;
}