#include <iostream>

#include <queue>
#include <set>

using namespace std;

int n, m;
string s;

bool ret;

vector <int> ans;
int ci;

vector <vector <pair <int, char> > > a;
vector <bool> u;

void dfs(string v, int sz) {
    for (int i = 0; i < n; ++i) {
        if (!u[i]) {
            string nv = v;
            int nsz = sz;

            bool fl = true;

            for (int j = 0; j < a[i].size(); ++j) {
                int pos = a[i][j].first;
                char chr = a[i][j].second;

                if (nv[pos] == '#') {
                    if (s[pos] == chr) {
                        nv[pos] = chr;
                        ++nsz;
                    }
                    else {
                        fl = false;
                        break;
                    }
                }
            }

            if (!fl) {
                continue;
            }

            u[i] = true;

            if (nsz == m) {
                ret = true;
                ans[ci] = i + 1;
                ++ci;
                return;
            }

            dfs(nv, nsz);

            if (ret) {
                ans[ci] = i + 1;
                ++ci;
                return;
            }

            u[i] = false;
        }
    }
}

int main() {
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);

    cin >> n >> m;
    cin >> s;

    string e = "";
    for (int i = 0; i < m; ++i) {
        e += '#';
    }

    a.assign(n, vector <pair <int, char> > (0));
    u.assign(n, false);
    ans.assign(n, 0);

    for (int i = 0; i < n; ++i) {
        int q;
        cin >> q;

        for (int j = 0; j < q; ++j) {
            int x;
            char y;
            cin >> x >> y;

            a[i].push_back(make_pair(x - 1, y));
        }
    }

    dfs(e, 0);

    if (ret) {
        for (int i = 0; i < ci; ++i) {
            cout << ans[ci - i - 1] << ' ';
        }

        for (int i = 0; i < n; ++i) {
            if (!u[i]) {
                cout << i + 1 << ' ';
            }
        }
    }
    else {
        cout << -1;
    }

    return 0;
}