#include <iostream>
#include <map>
#include <set>
#include <string>
#include <algorithm>
#include <vector>

using namespace std;

bool matr[30][30];

string best;

int n,k;
string orig;
vector<int> orig_i;
set<pair<int, string>> used;

void go(int i, string s){
    if(i == s.length()){
        //cout << s << endl;
        if(best.empty() || s < best)
            best = s;
        return;
    }
    if(used.count({i, s}))
        return;

    if(i+1<s.length() && matr[s[i]-'a'][s[i+1]-'a']){
        go(max(0,i-1), s.substr(0, i + 1) + s.substr(i + 2, s.length() - i - 2));
    }
    go(i + 1, s);

    used.insert({i, s});
}

int main() {

    cin >> k >> n;
    for (int i = 0; i < k; ++i) {
        string x;
        cin >> x;
        for (int j = 0; j < k; ++j) {
            matr[i][j] = x[j] == '1';
        }
    }
    cin >> orig;
    orig_i.resize(n);
    for (int i = 0; i < n; ++i) {
        orig_i[i] = orig[i] - 'a';
    }

    go(0, orig);

    cout << best << endl;

    return 0;
}
/*

3 7
010
001
100
abacaba

3 5
010
001
100
bcacb




 */