#include <bits/stdc++.h>

using namespace std;

#define all(a) a.begin(), a.end()
#define nl '\n'
#define elif else if
#define forn(i, n) for (int i = 0; i < n; i++)
#define vi vector<int>
#define maxq(ma, a) ma = max(ma, a)
#define minq(mi, a) mi = min(mi, a)
#define pb push_back
#define sz(a) ((int)a.size())
#define pi pair<int, int>

inline void IO() {
#ifdef Dmitry07
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

const int MAXN = 100;

vi g[MAXN], li[MAXN], ord[MAXN];
pi p[MAXN];
int pr[MAXN], n;

bool dfs(int v) {
    if (g[v].empty()) {
        p[v] = {pr[v], pr[v]};
        return 1;
    }
    vector<pair<pi, int>> vp;
    for (auto to : g[v]) {
        if (!dfs(to)) {
            return 0;
        }
        vp.pb({p[to], to});
    }
    forn (i, sz(g[v])) {
        if (i && vp[i].first.first < vp[i - 1].first.second) {
            return 0;
        }
        ord[v].pb(vp[i].second);
    }
}

void rec(int dep) {
    if (dep == n) {
        if (dfs(0)) {
            cout << "Yes";
            exit(0);
        }
        return;
    }
    if (sz(li[dep]) == 0) {
        rec(dep + 1);
    }
    forn (i, sz(li[dep])) {
        pr[dep] = li[dep][i];
        rec(dep + 1);
    }
}

inline void Solve() {
    cin >> n;
    forn (i, n) {
        int ty, k;
        cin >> ty >> k;
        if (ty == 1) {
            forn (j, k) {
                int to;
                cin >> to;
                to--;
                g[i].pb(to);
            }
        } else {
            li[i].resize(k);
            forn (j, k) {
                cin >> li[i][j];
            }
        }
    }
    rec(0);
    cout << "No";
}

signed main() {
    IO();
    int t = 1;
    while (t--) {
        Solve();
    }
    return 0;
}