#include <algorithm>
#include <iostream>
#include <set>
#include <vector>

using namespace std;

#define ALL(c) c.begin(), c.end()
#define SZ(c) (int)c.size()

const int N = 5e5 + 7;
const int K = 26;

int k, n;
char g[K][K];
int a[N];

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(NULL);
  cout.tie(NULL);
  cin >> k >> n;
  for (int i = 0; i < k; ++i) {
    for (int j = 0; j < k; ++j) {
      cin >> g[i][j];
      g[i][j] -= '0';
    }
  }
  for (int i = 0; i < n; ++i) {
    char c;
    cin >> c;
    a[i] = c - 'a';
  }
  vector<int> cur = {};
  for (int i = 0; i < n; ++i) {
    vector<vector<int>> nxt = {cur};
    while (!cur.empty() && g[a[i]][cur[0]]) {
      cur.erase(cur.begin());
      nxt.push_back(cur);
    }
    sort(ALL(nxt));
    cur = nxt[0];
    cur.insert(cur.begin(), a[i]);
  }
  for (int x : cur) {
    cout << (char)(x + 'a');
  }
  cout << '\n';
  return 0;
}
