//#pragma GCC optimize("Ofast")
//#pragma GCC target("avx2")

#include <bits/stdc++.h>
using namespace std;

#define ioBoost ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr)
#define all(x) begin(x), end(x)
#define rall(x) rbegin(x), rend(x)

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
typedef long long ll;

void solve() {
    int n, m;
    cin >> n >> m;
    string s;
    cin >> s;

    vector<map<int, char>> p(n);

    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;

        for (int j = 0; j < k; ++j) {
            int p1;
            char ch;
            cin >> p1 >> ch;
            --p1;

            p[i][p1] = ch;
        }
    }

    vector<pair<int, int>> nmatch;

    for (int i = 0; i < n; ++i) {
        int cnt = 0;
        for (int j = 0; j < m; ++j) {
            if (p[i].count(j) > 0 && p[i][j] != s[j]) {
                cnt++;
            }
        }
        nmatch.emplace_back(cnt, i);
    }

    sort(all(nmatch));

    vector<bool> done(m);

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (!done[j] && p[nmatch[i].second].count(j) && p[nmatch[i].second][j] != s[j]) {
                cout << "-1\n";
                return;
            } else if (!done[j] && p[nmatch[i].second].count(j) && p[nmatch[i].second][j] == s[j]) {
                done[j] = true;
            }
        }
    }

    for (int i = 0; i < m; ++i) {
        if (!done[i]) {
            cout << "-1\n";
            return;
        }
    }
    for (auto en: nmatch)
        cout << en.second + 1 << ' ';
}

signed main() {
    ioBoost;

    solve();

    return 0;
}