#include<bits/stdc++.h>

#define fi first
#define se second
#define mp make_pair
#define em emplace
#define eb emplace_back
#define pb pop_back
#define sz(v) (int) v.size()
#define all(v) v.begin(), v.end()

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

int randint(int L, int R) {
    return L + rnd() % (R - L + 1);
}

const int N = 35;

bool used[N][N];

int n, k, m;

void do_move(int x, int y) {
    cout << x << " " << y << endl;
    for (int i = x; i <= n; ++i) {
        for (int j = y; j <= n; ++j) {
            used[i][j] = 1;
        }
    }
}

bool do_move_buf() {
    for (int x = 1; x <= n; ++x) {
        for (int y = 1; y <= n; ++y) {
            if (x > 16 || y > 16) if (!used[x][y]) {
                do_move(x, y);
                return 1;
            }
        }
    }
    return 0;
}

bool read_move() {
    int x, y;
    cin >> x >> y;
    for (int i = x; i <= n; ++i) {
        for (int j = y; j <= n; ++j) {
            used[i][j] = 1;
        }
    }
    return x == 1 && y == 1;
}

void clearused() {
    for (int i = 1; i <= n; ++i) {
        for (int j = 1; j<= n; ++j) {
            used[i][j] = 0;
        }
    }
}

void end_game() {
    cout << 0 << endl;
}

int32_t main() {
    int type;
    cin >> type;
    if (type == 1) {
        string s;
        cin >> n >> k >> m >> s;
        int pos = -1, q = 0;
        while (pos < m - 1) {
            clearused();
            if (q == 1) read_move();
            bool startmove = (q == 0);
            while (pos < m - 1) {
                int x = 0, y = 0;
                for (int i = pos + 1; i < min(m, pos + 5); ++i) {
                    if (s[i] == '1') {
                        x += (1 << (i - pos - 1));
                    }
                }
                pos += 4;
                for (int i = pos + 1; i < min(m, pos + 5); ++i) {
                    if (s[i] == '1') {
                        y += (1 << (i - pos - 1));
                    }
                }
                pos += 4;
                if (x == 0 && y == 0) {
                    do_move(1, 1);
                    if (!startmove) pos -= 8;
                    break;
                }
                if (!used[x + 1][y + 1]) {
                    do_move(x + 1, y + 1);
                    if (read_move()) break;
                } else if (!used[y + 1][x + 1]) {
                    if (!do_move_buf()) {
                        do_move(1, 1);
                        pos -= 8;
                        break;
                    }
                    if (read_move()) {
                        pos -= 8;
                        break;
                    }
                    if (!used[y + 1][x + 1]) {
                        do_move(y + 1, x + 1);
                        if (read_move()) break;
                    } else {
                        do_move(1, 1);
                        pos -= 8;
                        break;
                    }
                } else {
                    do_move(1, 1);
                    pos -= 8;
                    break;
                }
                startmove = false;
            }
            if (!used[1][1]) {
                assert(pos >= m - 1);
                do_move(1, 1);
            }
            q ^= 1;
        }
        if (q == 1) read_move();
        end_game();
    } else {
        int n, k, m;
        cin >> n >> k >> m;
        int games;
        cin >> games;
        int q = 0;
        string ans;
        while (games--) {
            int moves = 0, i = q;
            bool flag = false;
            while (true) {
                int x, y;
                cin >> x >> y;
                if (x == 1 && y == 1) {
                    if (!moves) {
                        assert(i == 0);
                        for (int p = 0; p < 8; ++p) ans += '0';
                    }
                    break;
                } else {
                    if (i == 0) {
                        if (x <= 16 && y <= 16) {
                            --x, --y;
                            if (flag) swap(x, y);
                            for (int p = 0; p < 4; ++p) ans += '0' + ((x >> p) & 1);
                            for (int p = 0; p < 4; ++p) ans += '0' + ((y >> p) & 1);
                            flag = 0;
                        } else {
                            flag = 1;
                        }
                    }
                }
                ++moves;
                i ^= 1;
            }
            q ^= 1;
        }
        while (sz(ans) > m) ans.pb();
        cout << ans << endl;
    }
    return 0;
}
