#include <iostream>
#include <vector>
#include <algorithm>
#include <stack>

using namespace  std;

#define int long long
const int INF = 1e9;
string inf;

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int k, n;
    cin >> k >> n;
    vector<vector<bool>> mat(k, vector<bool>(k, false));
    for (int i =0 ; i < n ;i++){
        char xx = 'a' + 28;
        inf += xx;
    }
    for (int i =0; i < k; i++){
        for (int j =0 ; j < k; j++){
            char x;
            cin >> x;
            if (x == '1'){
                mat[i][j] = true;
            }
        }
    }
    string s;
    cin >> s;
    vector<int> pos(n, -1);
    vector<string>dp(n, inf);
    for (int i =0; i < n; i++){
        stack<int> cur;
        cur.push(s[i] - 'a');
        for (int j = i + 1; j < n; j++) {
            while (!cur.empty() && !mat[cur.top()][s[j] - 'a']) {
                cur.pop();
            }
            pos[i] = j;
            if (cur.empty()) {
                break;
            }
            cur.push(s[j] - 'a');
        }
        if (!cur.empty()){
            pos[i] = n;
        }
    }
    dp[n - 1] = "";
    dp[n - 1] += s[n - 1];
    //cout << pos[0] << " ";
    for (int i = n -1; i >= 0; i--){
        //cout << pos[i] << " ";
        for (int j = i + 1; j < n; j++){
            if (pos[i] >= j){
                //cerr << dp[i] << " " << dp[j] << " " << min(dp[i], dp[j]) << '\n';
                dp[i] = min(dp[i], dp[j]);
            }
        }
        dp[i] = s[i] + dp[i];
        if (pos[i] == n){
            dp[i] = s[i];
        }
        //cerr << dp[i] << '\n';
    }
    cout << dp[0];
    return 0;
}
