#include <bits/stdc++.h>
using namespace std;

int main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    int n, m;
    cin >> n >> m;
    string st;
    cin >> st;

    vector<vector<pair<int, int>>> perf(n);
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        while (k-- > 0) {
            int a;
            char b;
            cin >> a >> b;
            perf[i].push_back({a - 1, b});
        }
    }

    vector<bool> closed(m, false);
    vector<bool> used(n, false);
    vector<int> ans(n, -100);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (used[j])
                continue;

            bool is = true;
            for (auto p: perf[j]) {
                if (!(closed[p.first] || p.second == st[p.first])) {
                    is = false;
                    break;
                }
            }

            if (is) {
                ans[i] = j;
                used[j] = true;
                for (auto p: perf[j]) {
                    closed[p.first] = true;
                }
                break;
            }
        }
    }

    bool is = true;
    for (bool i : closed) {
        if (!i) {
            is = false;
            break;
        }
    }

    if (is) {
        for (int a : ans)
            cout << a + 1 << ' ';
    }
    else {
        cout << -1;
    }



    return 0;
}


/*

1 1
a
1 1 a


*/
