#include <bits/stdc++.h>
using namespace std;

vector<vector<bool>> table(32, vector<bool>(32, false));

void clear_table()
{
    for (int i = 0; i < 32; i++) {
        for (int j = 0; j < 32; j++) {
            table[i][j] = false;
        }
    }
}

void draw(int x, int y)
{
    for (int x0 = x; x0 < 32; x0++) {
        for (int y0 = y; y0 < 32; y0++) {
            table[x0][y0] = true;
        }
    }
}

int i_will_draw(int x, int y)
{
    int ans = 0;
    for (int x0 = 0; x0 < 32; x0++) {
        for (int y0 = 0; y0 < 32; y0++) {
            if (x0 >= x && y0 >= y && !table[x0][y0])
                ans++;
        }
    }
    return ans;
}

int main()
{
    //ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    //ifstream cin("\\\\.\\pipe\\game.in");
    //ofstream cout("\\\\.\\pipe\\game.out");
    ofstream out("out.txt");
    int q;
    cin >> q;
    if (q == 1) {
        int n, k, m;
        cin >> n >> k >> m;
        string message;
        cin >> message;
        int game = 0;
        int now = 0;
        while (now < m) {
            if (game % 2 == 1) {
                int x, y;
                cin >> x >> y;
                draw(x - 1, y - 1);
                out << "Cined!!!!!!!! " << x << ' ' << y << endl;
            }
            while (now < m) {
                int x0, y0;
                out << "GGGGGGGGGGGGGGGame!: " << game << endl;
                for (auto m : table) {
                    for (auto a : m) {
                        out << a << ' ';
                    }
                    out << endl;
                }
                out << endl;
                for (x0 = 3; x0 < 32; x0++) {
                    for (y0 = 3; y0 < 32; y0++) {
                        if ((x0 + y0) % 2 == (message[now] - '0')) {
                            if (!table[x0][y0] && i_will_draw(x0, y0) <= 3) {
                                cout << x0 + 1 << ' ' << y0 + 1 << endl;
                                draw(x0, y0);
                                x0 = 50;
                                y0 = 50;
                                now++;
                            }
                        }
                    }
                }
                if (now == m) {
                    cout << "2 1" << endl;
                    int x, y;
                    cin >> x >> y;
                    if (x == 1 && y == 1) {
                        break;
                    }
                    else {
                        cout << "1 2" << endl;
                        cin >> x >> y;
                        break;
                    }
                }

                if (x0 >= 50) {
                    int x, y;
                    cin >> x >> y;
                    draw(x - 1, y - 1);
                    out << "Cined! " << x << ' ' << y << endl;
                }
                else {
                    cout << "2 1" << endl;
                    int x, y;
                    cin >> x >> y;
                    if (x == 1 && y == 1) {
                        out << "Here0" << x << ' ' << y << endl;
                        game++;
                        clear_table();
                        out << "-------------------------" << endl;
                        break;
                    }
                    else {
                        cout << "1 2" << endl;
                        cin >> x >> y;
                        out << "Here1" << endl;
                        if (x != 1 || y != 1)
                            exit(228);
                        game++;
                        clear_table();
                        out << "-------------------------" << endl;
                        break;
                    }
                }
            }
        }
        cout << 0 << endl;
    }
    else {
        int n, k, m;
        cin >> n >> k >> m;
        int games;
        cin >> games;

        string result = "";
        for (int game = 0; game < games; game++) {

            if (game % 2 == 1) {
                int x, y;
                cin >> x >> y;
            }

            while (true) {
                int x, y;
                cin >> x >> y;
                if ((x == 1 && y == 2) || (x == 2 && y == 1)) {}
                else {
                    result += to_string((x + y) % 2);
                }
                cin >> x >> y;
                if (x == 1 && y == 1) break;
            }
        }
        cout << result << endl;
    }



    return 0;
}
