#include <iostream>
#include <algorithm>
#include <vector>
#include <iomanip>
#include <bitset>

using namespace std;

int32_t main()
{
	cin.tie(0);
	cout.tie(0);
	ios_base::sync_with_stdio(0);
	//freopen("\\\\.\\pipe\\game.in", "r", stdin);
	//freopen("\\\\.\\pipe\\game.out", "w", stdout);
	int t;
	cin >> t;
	if (t == 1) {
		int n, k, m;
		cin >> n >> k >> m;
		vector<int> msg;
		for (int i = 0; 5 * i < m; ++i) {
			int tmp = 0;
			for (int j = 0; j < 5; ++j) {
				char c;
				cin >> c;
				c -= '0';
				tmp = tmp * 2 + c;
			}
			msg.push_back(tmp);
		}
		int cur = 0;
		int gn = 0;
		while (cur < msg.size()) {
			vector<bitset<32>> field(n);
			if (gn % 2) {
				int x, y;
				cin >> x >> y;
				--y;
				x = n - x + 1;
				for (int i = n - 1; i >= y; --i) {
					field[i] |= (-1) ^ ((1 << (n - x)) - 1);
				}
			}
			while (!field[0][0]) {
				int row = n - 1;
				while (row >= 0 && (cur >= msg.size() || field[row][n - msg[cur] - 1]))
					--row;
				if (row != 0 && !(row == 1 && msg[cur] == 31)) {
					int x = msg[cur] + 1;
					int y = row;
					cout << n - x + 1<< ' ' << y + 1 << endl;
					cur += 1;
					for (int i = n - 1; i >= y; --i) {
						field[i] |= (-1) ^ ((1 << (n - x)) - 1);
					}
					cin >> x >> y;
					--y;
					x = n - x + 1;
					for (int i = n - 1; i >= y; --i) {
						field[i] |= (-1) ^ ((1 << (n - x)) - 1);
					}
				}
				else if (!field[0][1]) {
					int x = n - 1;
					int y = 0;
					cout << n - x + 1 << ' ' << y + 1 << endl;
					for (int i = n - 1; i >= y; --i) {
						field[i] |= (-1) ^ ((1 << (n - x)) - 1);
					}
					cin >> x >> y;
					--y;
					x = n - x + 1;
					for (int i = n - 1; i >= y; --i) {
						field[i] |= (-1) ^ ((1 << (n - x)) - 1);
					}
				}
				else if (!field[1][0]) {
					int x = n;
					int y = 1;
					cout << n - x + 1 << ' ' << y + 1 << endl;
					for (int i = n - 1; i >= y; --i) {
						field[i] |= (-1) ^ ((1 << (n - x)) - 1);
					}
					cin >> x >> y;
					--y;
					x = n - x + 1;
					for (int i = n - 1; i >= y; --i) {
						field[i] |= (-1) ^ ((1 << (n - x)) - 1);
					}
				}
				else {
					cout << "1 1" << endl;
					field[0][0] = 1;
				}
			}
			++gn;
		}
		cout << 0 << endl;
	}
	else
	{
		int n, k, m;
		cin >> n >> k >> m;
		int t;
		cin >> t;
		vector<int> msg;
		for (int i = 0; i < t; ++i) {
			int x, y;
			cin >> x >> y;
			if (i % 2 && (x != 1 || y != 1))
				cin >> x >> y;
			bool transmit = true;
			for (int j = 0; x != 1 || y != 1; ++j) {
				if (!transmit || j % 2 || msg.size() * 5 >= m) {
					cin >> x >> y;
					continue;
				}
				if (y == 1 || (x == 1 && y == 2)) {
					transmit = false;
					cin >> x >> y;
					continue;
				}
				//msg.push_back(n - y);
				msg.push_back(n - x);
				cin >> x >> y;
			}
		}
		string ans = "";
		for (int x : msg) {
			string tmp = "";
			for (int i = 4; i >= 0; --i) {
				if (x & (1 << i))
					tmp += '1';
				else
					tmp += '0';
			}
			ans += tmp;
		}
		cout << ans << endl;

	}
}