#include <iostream>
#include <vector>
#include <queue>
#include <cstring>

using namespace std;

int main()
{
	int n, m;
	cin >> n >> m;
	string s;
	cin >> s;
	vector<int>* bad = new vector<int>[m];
	vector<pair<int, bool>>* str = new vector<pair<int, bool>>[n];
	int* cnt_bad = new int[n];
	for (int i = 0; i < n; i++)
	{
		cnt_bad[i] = 0;
		int k;
		cin >> k;
		str[i].resize(k);
		char c;
		for (int j = 0; j < k; j++)
		{
			cin >> str[i][j].first >> c;
			str[i][j].first--;
			str[i][j].second = (c != s[str[i][j].first]);
			cnt_bad[i] += str[i][j].second;
			if (str[i][j].second == 1)
				bad[str[i][j].first].push_back(i);
		}
	}
	bool* used = new bool[m];
	memset(used, 0, m * sizeof(bool));
	queue<int> q;
	for (int i = 0; i < n; i++)
	{
		if (cnt_bad[i] == 0)
			q.push(i);
	}
	vector<int> ans;
	while (!q.empty())
	{
		int i = q.front();
		q.pop();
		for (const auto& el : str[i])
		{
			if (el.second == 0 && !used[el.first])
			{
				for (int j : bad[el.first])
				{
					cnt_bad[j]--;
					if (cnt_bad[j] == 0)
						q.push(j);
				}
				used[el.first] = 1;
			}
		}
		ans.push_back(i);
	}
	for (int i = 0; i < m; i++)
	{
		if (!used[i])
		{
			cout << -1 << "\n";
			return 0;
		}
	}
	for (int i = 0; i < n; i++)
	{
		if (cnt_bad[i] > 0)
			ans.push_back(i);
	}
	for (int i : ans)
		cout << i + 1 << " ";
	cout << "\n";
}
