#include <iostream>
#include <cstring>
#include <vector>
#include <string>

using namespace std;

int k, n;
bool** a;

int main()
{
	char c;
	cin >> k >> n;
	a = new bool* [k];
	for (int i = 0; i < k; i++)
	{
		a[i] = new bool[k];
		for (int j = 0; j < k; j++)
		{
			cin >> c;
			a[i][j] = (c == '1');
		}
	}
	int* str = new int[n];
	for (int i = 0; i < n; i++)
	{
		cin >> c;
		str[i] = c - 'a';
	}
	bool** dp = new bool* [n + 1];
	for (int i = 0; i <= n; i++)
	{
		dp[i] = new bool[n + 1];
		memset(dp[i], 0, (n + 1) * sizeof(bool));
		dp[i][i] = 1;
	}
	
	
	/*for (int len = 1; len <= n; len++)
	{
		for (int i = 0, j = len; j <= n; i++, j++)
		{
			if (i == 0)
				continue;
			for (int k = i; k < j && !dp[i][j]; k++)
			{
				if (a[str[i - 1]][str[k]] && dp[i][k] && dp[k + 1][j])
					dp[i][j] = 1;
			}
		}
	}*/

	int* nearest_left = new int[n];
	for (int i = 0; i < n; i++)
	{
		nearest_left[i] = i - 1;
		while (nearest_left[i] >= 0 && !a[str[nearest_left[i]]][str[i]])
			nearest_left[i]--;
	}

	for (int i = n - 1; i > 0; i--)
	{
		int j = i;
		while (j <= n && nearest_left[j] >= i - 1)
			dp[i][++j] = 1;
	}

	/*for (int i = 1; i < n; i++)
	{
		cout << "i = " << i << ": ";
		for (int j = i; j <= n; j++)
		{
			if (dp[i][j])
				cout << j << "; ";
		}
		cout << "\n";
	}*/

	/*vector<int> ans;
	int i = 0;
	ans.push_back(str[i]);
	while (!dp[i + 1][n])
	{
		int best_j = -1;
		for (int j = i + 1; j < n; j++)
		{
			if (dp[i + 1][j] && (best_j == -1 || str[j] < str[best_j]))
				best_j = j;
		}
		ans.push_back(str[best_j]);
		i = best_j;
	}
	for (int el : ans)
		cout << char('a' + el);
	cout << "\n";*/
	string* ans = new string[n];
	for (int i = n - 1; i >= 0; i--)
	{
		ans[i] += char('a' + str[i]);
		if (dp[i + 1][n])
			continue;
		int best_j = -1;
		for (int j = i + 1; j < n; j++)
		{
			if (dp[i + 1][j] && (best_j == -1 || ans[j] < ans[best_j]))
				best_j = j;
		}
		ans[i] += ans[best_j];
	}
	cout << ans[0] << "\n";
}
 