#include <bits/stdc++.h>

using namespace std;

bool check(string a, string b) {
    //cout << "!! " << a << " " << b << endl;
    for (int i = 0; i < min(a.size(), b.size()); i++) {
        if (a[i] != b[i]) {
            return a[i] > b[i];
        }
    }
    return a.size() > b.size();
}

const int MAX_N = 1e5 + 42;
vector < pair < int, char > > gr[MAX_N];

string bfs(int start, int finish) {
    string ans = "";
    vector < int > now;
    vector < int > nxt;
    now.emplace_back(start);
    while (now.size() > 0) {
        char c = 'z' + 1;
        bool f = 0;
        for (auto v : now) {
            if (v == finish) {
                f = 1;
                break;
            }
            for (auto i : gr[v]) {
                c = min(c, i.second);
            }
        }
        if (f) {
            break;
        }
        ans.push_back(c);
        for (auto v : now) {
            for (auto i : gr[v]) {
                int u = i.first;
                if (i.second != c) {
                    continue;
                }
                nxt.emplace_back(u);
                //cout << ans << " " << u << endl;
            }
        }
        sort(nxt.begin(), nxt.end());
        nxt.resize(unique(nxt.begin(), nxt.end()) - nxt.begin());
        swap(now, nxt);
        nxt.clear();
    }
    return ans;
}

int main() {
    //freopen("input.txt", "r", stdin);
    int k, n;
    cin >> k >> n;
    vector < vector < bool > > can(k, vector < bool >(k, 0));
    for (int i = 0; i < k; i++) {
        for (int j = 0; j < k; j++) {
            char x;
            cin >> x;
            can[i][j] = x - '0';
        }
    }
    string s;
    cin >> s;
    vector < vector < bool > > del(n, vector < bool >(n, 0));
    vector < bitset < 2000 > > b1(n);
    vector < bitset < 2000 > > b2(n);
    for (int i = 0; i < n; i++) {
        del[i][i] = 1;
        gr[i].emplace_back(i + 1, s[i]);
        b2[i][i] = 1;
        if (i < n - 1 && can[s[i] - 'a'][s[i + 1] - 'a'] == 1) {
            b1[i][i + 1] = 1;
        }
    }
    vector < bitset < 2000 > > b(n);
    for (int len = 2; len <= n; len++) {
        for (int l = 0; l + len - 1 < n; l++) {
            int r = l + len - 1;
            if ((b1[l] & b2[r]) != 0) {
                del[l][r] = 1;
            }
            if (del[l][r]) {
                gr[l].emplace_back(r + 1, s[l]);
                b2[r][l] = 1;
                if (r < n - 1 && can[s[l] - 'a'][s[r + 1] - 'a'] == 1) {
                    b1[l][r + 1] = 1;
                }
            }
        }
    }
    cout << bfs(0, n);
    return 0;
}
