#include <bits/stdc++.h>

using namespace std;

const int MAX_N = 1e5 + 42;
vector < int > gr[MAX_N];
int cnt[MAX_N];

pair < int, int > dfs(int v) {
    if (gr[v].size() == 0) {
        return {cnt[v], cnt[v]};
    }
    vector < pair < int, int > > p;
    for (auto u : gr[v]) {
        auto tmp = dfs(u);
        if (tmp.first == -1) {
            return {-1, -1};
        }
        p.emplace_back(tmp);
    }
    sort(p.begin(), p.end());
    for (int i = 1; i < p.size(); i++) {
        if (p[i - 1].second >= p[i].first) {
            return {-1, -1};
        }
    }
    return {p[0].first, p.back().second};
}

int main() {
    //freopen("input.txt", "r", stdin);
    int n;
    cin >> n;
    vector < pair < int, int > > p;
    for (int i = 0; i < n; i++) {
        int t;
        cin >> t;
        if (t == 1) {
            int k;
            cin >> k;
            while (k--) {
                int x;
                cin >> x;
                x--;
                gr[i].emplace_back(x);
            }
            continue;
        }
        int k;
        cin >> k;
        while (k--) {
            int x;
            cin >> x;
            p.emplace_back(x, i);
        }
    }
    int m = p.size();
    for (int mask = 0; mask < (1 << m); mask++) {
        fill(cnt, cnt + n, -1);
        bool f = 0;
        for (int i = 0; i < m; i++) {
            if (((mask >> i) & 1) == 0) {
                continue;
            }
            if (cnt[p[i].second] != -1) {
                f = 1;
                break;
            }
            cnt[p[i].second] = p[i].first;
        }
        if (f == 1) {
            continue;
        }
        auto tmp = dfs(0);
        if (tmp.first != -1) {
            cout << "Yes";
            return 0;
        }
    }
    cout << "No";
    return 0;
}
