#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

typedef pair <int, int> pii;

int main() {
  ios::sync_with_stdio(false);
  cin.tie(0);
  int n, m;
  cin >> n >> m;
  vector <int> s;
  {
    string tmp;
    cin >> tmp;
    for (auto &now : tmp) {
      s.push_back(now - 'a');
    }
  }
  vector <vector <pii>> all(n);
  for (int i = 0; i < n; i++) {
    int k;
    cin >> k;
    all[i].resize(k);
    for (int j = 0; j < k; j++) {
      cin >> all[i][j].first;
      all[i][j].first--;
      char c;
      cin >> c;
      all[i][j].second = c - 'a';
    }
  }
  vector <int> p;
  vector <bool> used_string(n), used_pos(m);
  int cnt_all = m;
  for (int it = 0; it < n; it++) {
    vector <pii> can;
    for (int j = 0; j < n; j++) {
      if (used_string[j]) {
        continue;
      }
      bool flag = true;
      int cnt = 0;
      for (auto &now : all[j]) {
        if (used_pos[now.first]) {
          continue;
        }
        cnt++;
        if (now.second != s[now.first]) {
          flag = false;
          break;
        }
      }
      if (flag) {
        can.push_back({cnt, j});
      }
    }
    auto uk = max_element(can.begin(), can.end());
    int id = uk->second;
    cnt_all -= uk->first;
    p.push_back(id + 1);
    for (auto &now : all[id]) {
      used_pos[now.first] = true;
    }
  }
  if (cnt_all) {
    cout << -1;
    return 0;
  }
  for (auto &now : p) {
    cout << now << ' ';
  }
  return 0;
}

/*
1
1
a
1 1 a
 */