#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <queue>

using namespace std;
using ll = long long;

ll n, m, k, q;

vector <string> opa;

pair <ll, ll> move(ll x, ll y) {
	cout << x + 1 << ' ' << y + 1 << endl;
	for (int i = n - 1; i >= x; --i) {
		for (int j = n - 1; j >= y; --j) {
			opa[i][j] = '#';
		}
	}
	ll a, b;
	cin >> a >> b;
	--a; --b;
	for (int i = n - 1; i >= a; --i) {
		for (int j = n - 1; j >= b; --j) {
			opa[i][j] = '#';
		}
	}
	return { a, b };
}

pair <ll, ll> move2(ll x, ll y) {
	cout << x + 1 << ' ' << y + 1 << endl;
	for (int i = n - 1; i >= x; --i) {
		for (int j = n - 1; j >= y; --j) {
			opa[i][j] = '#';
		}
	}
	return { x, y };
}

pair <ll, ll> get() {
	ll a, b;
	cin >> a >> b;
	--a; --b;
	for (int i = n - 1; i >= a; --i) {
		for (int j = n - 1; j >= b; --j) {
			opa[i][j] = '#';
		}
	}
	return { a, b };
}

pair <ll, pair <ll, ll>> gett() {
	ll a, b;
	cin >> a >> b;
	--a; --b;
	ll cnt = 0;
	for (int i = n - 1; i >= a; --i) {
		for (int j = n - 1; j >= b; --j) {
			if (opa[i][j] == ' ') {
				opa[i][j] = '#';
				++cnt;
			}
		}
	}
	return { cnt, { a, b } };
}

ll cnt(ll x, ll y) {
	ll ans = 0;
	for (int i = n - 1; i >= x; --i) {
		for (int j = n - 1; j >= y; --j) {
			if (opa[i][j] == ' ') ++ans;
		}
	}
	return ans;
}

int main() {
	ll t;
	cin >> t;
	cin >> n >> k >> m;
	if (t == 1) {
		string s;
		cin >> s;
		ll games = 1;
		ll ptr = 0;
		pair <ll, ll> last;
		ll cur = 0;
		opa.assign(n, string(n, ' '));
		while (ptr < s.size()) {
			if (games & 1) {
				if (s[ptr] == '0') {
					for (int i = n - 1; i >= 0; --i) {
						for (int j = n - 1; j >= 0; --j) {
							if (cnt(i, j) == 2) {
								last = move(i, j);
							}
						}
					}
				}
				else {
					for (int i = n - 1; i >= 0; --i) {
						for (int j = n - 1; j >= 0; --j) {
							if (cnt(i, j) == 1) {
								last = move(i, j);
							}
						}
					}
				}
			}
			else {
				get();

				if (s[ptr] == '0') {
					for (int i = n - 1; i >= 0; --i) {
						for (int j = n - 1; j >= 0; --j) {
							if (cnt(i, j) == 2) {
								last = move2(i, j);
							}
						}
					}
				}
				else {
					for (int i = n - 1; i >= 0; --i) {
						for (int j = n - 1; j >= 0; --j) {
							if (cnt(i, j) == 1) {
								last = move2(i, j);
							}
						}
					}
				}
			}
			++cur;
			if (cur == 100) {
				if (last == make_pair(0ll, 0ll)) {
					++games;
					cur = 0;
					opa.assign(n, string(n, ' '));
				}
				else {
					if (games & 1) {
						move2(0, 0);
					}
					else {
						get();
						move2(0, 0);
					}
					++games;
					cur = 0;
					opa.assign(n, string(n, ' '));
				}
				if (ptr == s.size() - 1) {
					cout << 0 << endl;
					return 0;
				}
			}
			++ptr;
		}
	}
	else if (t == 2) {
		ll games;
		cin >> games;
		string ans(m, ' ');
		ll ptr = 0;
		for (int i = 0; i < games; ++i) {
			opa.assign(n, string(n, ' '));
			auto it = gett();
			vector <pair <ll, pair <ll, ll>>> opa;
			while (it.second != make_pair(1ll, 1ll)) {
				opa.push_back(it);
			}
			vector <pair <ll, pair <ll, ll>>> act;
			if ((i + 1) & games) {
				for (int j = 0; j < opa.size(); j += 2) {
					act.push_back(opa[j]);
				}
			}
			else {
				for (int j = 1; j < opa.size(); j += 2) {
					act.push_back(opa[j]);
				}
			}
			act.pop_back();
			for (auto& x : act) {
				ans[ptr++] = x.first % 2 + 48;
			}
		}
		cout << ans << '\n';
	}
	return 0;
}
/*
1
32 8 16
1111000011110000
*/