#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>

using namespace std;

using ll = long long;
template <typename T>
using v = vector<T>;
template <typename A, typename B>
using pa = pair<A, B>;

int main() {
	ll k, n;
	cin >> k >> n;
	v<v<bool>> A(k, v<bool>(k));
	for (ll i = 0; i < k; ++i) {
		for (ll j = 0; j < k; ++j) {
			char Aij;
			cin >> Aij;
			A[i][j] = Aij == '1';
		}
	}
	string s;
	cin >> s;
	v<ll> macan(n);
	macan[n - 1] = 0;
	for (ll i = n - 2; i >= 0; --i) {
		ll csize = 0;
		while (i + csize + 1 < n && A[s[i] - 'a'][s[i + csize + 1] - 'a']) {
			csize += macan[i + csize + 1] + 1;
		}
		macan[i] = csize;
	}
	v<string> mi_str(n + 1);
	mi_str[n - 1] = string(1, s[n - 1]);
	for (ll i = n - 2; i >= 0; --i) {
		mi_str[i] = string(1, s[i]) + mi_str[i + 1];
		for (ll j = i + 1; j < n; ++j) {
			if (macan[i] + i + 1 > j) {
				mi_str[i] = min(mi_str[i], string(1, s[i]) + mi_str[j + 1]);
			}
		}
	}
	//for (ll i = 0; i < n; ++i) {
	//	cout << mi_str[i] << '\n';
	//}
	cout << mi_str[0];
}