#include <iostream>
#include <string>
#include <vector>
#include <map>
#include <set>
#include <deque>
#include <algorithm>
#include <cmath>
using namespace std;

string minn(string& a, string b)
{
	for (int i = 0; i < min(a.size(), b.size()); ++i)
	{
		if (a[i] < b[i]) return a;
		if (a[i] > b[i]) return b;
	}

	return (a.size() < b.size() ? a : b);
}

int main()
{
	int k, n; cin >> k >> n;
	vector<vector<char>> A(k, vector<char>(k));
	for (auto& i : A)
		for (auto& j : i)
			cin >> j, j -= '0';

	string s; cin >> s;
	deque<int> tek;
	vector<int> rdel(n);
	for (int i = n - 1; i >= 0; --i)
	{
		while (tek.size() && A[s[i] - 'a'][s[tek[0]] - 'a'])
			tek.pop_front();
		rdel[i] = (tek.size() ? tek[0] : n);
		tek.push_front(i);
	}

	vector<string> res(n + 1); res[n] = "";
	for (int i = n - 1; i >= 0; --i)
	{
		res[i] = s[i] + res[i + 1];
		for (int j = i + 1; j <= rdel[i]; ++j)
			res[i] = minn(res[i], s[i] + res[j]);
	}

	cout << res[0] << '\n';

	return 0;
}