#include <iostream>
#include <string>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <cmath>
#include <numeric>
using namespace std;

int n;
vector<vector<int>> graph, a;
vector<int> alist;

vector<vector<int>> ans;

int mask;

pair<int, int> dfs(int v)
{
	if (graph[v].size() == 0)
	{
		for (auto&i: a[v])
		{
			int x = (lower_bound(alist.begin(), alist.end(), i)) - alist.begin();
			if (((mask >> x) & 1) == 0) continue;
			ans[v] = { i };
			return { i, i };
		}

		return { -1, -1 };
	}

	vector<pair<int, int>> res;
	for (auto&i: graph[v]) {
			pair<int, int> tres = dfs(i);
			if (tres.first == -1)
				return { -1, -1 };
			res.push_back(tres);
		}

	vector<int> ord(res.size());
	iota(ord.begin(), ord.end(), 0);
	sort(ord.begin(), ord.end(), [&](int x, int y) {
		return res[x] < res[y];
	});
	
	for (int i = 0; i + 1 < (int)ord.size(); ++i)
		if (res[ord[i]].second >= res[ord[i + 1]].first)
			return { -1, -1 };

	ans[v] = ord;
	for (auto& i : ans[v]) ++i;

	return { res[ord[0]].first, res[ord[ord.size() - 1]].second };
}

int main()
{
	cin >> n;
	graph.resize(n);
	a.resize(n);

	int acnt = 0;
	for (int i = 0; i < n; ++i)
	{
		int h; cin >> h;
		if (h == 1)
		{
			int k; cin >> k;
			graph[i].resize(k);
			for (auto& j : graph[i])
				cin >> j, --j;
				
		}
		if (h == 2)
		{
			int k; cin >> k; acnt += k;
			a[i].resize(k);
			for (auto& j : a[i])
				cin >> j, alist.push_back(j);
		}
	}
	sort(alist.begin(), alist.end());
	ans.resize(n);

	bool good = false;
	for (mask = 0; mask < (1 << acnt); ++mask)
	{
		good |= (dfs(0).first != -1);
		if (good)
			break;
	}

	cout << (good ? "Yes\n" : "No\n");

	if (good)
	{
		for (auto& i : ans)
		{
			for (auto& j : i)
				cout << j << ' ';
			cout << '\n';
		}
	}

	return 0;
}