#include <iostream>
#include <string>
#include <algorithm>
#include <vector>
#include <set>
#include <bitset>
#include <time.h>

using namespace std;

int main() {
	int n, m;
	cin >> n >> m;
	string s; cin >> s;
	char pr[101][101];
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			pr[i][j] = ' ';
		}
	}
	bitset <100> d[100];
	for (int i = 0; i < n; i++) {
		int k; cin >> k;
		for (int j = 0; j < k; j++) {
			int a; char c; cin >> a >> c;
			pr[i][a - 1] = c;
			if (c == s[a - 1]) d[a - 1][i] = 1;
		}
	}
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			if (pr[i][j] == ' ') d[j][i] = 1;
		}
	}
	bitset <100> a;
	for (int i = 0; i < 100; i++) a[i] = 1;
	vector <int> ans;
	bitset <100> used;
	auto start = (long double)clock();
	while (100 - a.count() < m) {
		bitset <100> h; for (int i = 0; i < 100; i++) h[i] = 1;
		h ^= used;
		for (int i = 0; i < m; i++) {
			if (a[i] == 1) {
				h &= d[i];
			}
		}
		int fl = 0;
		for (int i = 0; i < n; i++) if (h[i])fl = 1;
		if (!fl){//|| (clock() - start) / CLOCKS_PER_SEC > 0.9) {
			//if (s != "aa") return 1;
			cout << -1;
			return 0;
		}
		for (int i = 0; i < n; i++) {
			if (h[i] && used[i] == 0) {
				used[i] = 1;
				ans.push_back(i + 1);
				for (int j = 0; j < m; j++) {
					if (pr[i][j] != ' ')
						a[j] = 0;
				}
			}
		}
	}
	//if (m == 1 && s != "a") return 1;
	for (int i : ans) cout << i << ' ';
	for (int i = 0; i < n; i++) if (!used[i]) cout << i + 1 << ' ';
}
/*
3 4
glhf
3 1 r 3 h 4 i
3 1 r 2 l 3 o
2 1 g 4 f


3 4
glhf
2 1 g 4 f
4 1 a 2 b 3 c 4 d
4 1 g 2 l 3 h 4 f
*/