/*#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,mmx,abm,avx,avx2,popcnt")
*/

#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#include <set>
#include <map>
#include <utility>
#include <functional>
#include <numeric>
#include <chrono>
#include <random>
#include <cassert>


#define fi(a, b) for (int i = a; i < b; ++i)
#define fj(a, b) for (int j = a; j < b; ++j)
#define fk(a, b) for (int k = a; k < b; ++k)
#define fx(x, a) for (auto &x : a)
#define siz(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define pb push_back
#define ppb pop_back()
#define mp make_pair
#define left left1337
#define right right1337
#define lb lower_bound


#ifdef LOCAL 
	#define dbg(x) cout << #x << " : " << x << endl
#else
	#define dbg(x)
#endif

using namespace std;

template<typename T1, typename T2> inline void mine(T1 & x, const T2 &y) {if (y < x) x = y;}
template<typename T1, typename T2> inline void maxe(T1 & x, const T2 &y) {if (x < y) x = y;}


typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef vector<int> vi;
typedef vector<char> vch;
typedef pair<int, int> pii;
typedef vector<pii> vpii;
typedef string str;
typedef vector<str> vs;
typedef vector<vch> vvch;


mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

const int N = 101000;
vi g[N];
vi have[N];
int havem[N];
vi ans;
bool ok;
int n, mask;
int l[N];
int r[N];
int m;
vi nums;

bool ord(int v) {
	assert(g[v].size());
	sort(all(g[v]), [&](int i, int j){
		return l[i] < l[j];
	});
	l[v] = 0;
	r[v] = 0;
	fx(to, g[v]) {
		if (l[to] <= r[v]) return false;
		maxe(r[v], r[to]);
	}
	return true;
}

void dfs(int v) {
	if (!ok) return;
	if (g[v].size() == 0) {
		vi can;
		fi(0, m) {
			if (((mask & havem[v]) >> i) & 1) can.pb(i); 
		}
		if (can.size() != 1) {
			ok = false;
		}
		l[v] = r[v] = nums[can[0]];
		return;
	}
	fx(to, g[v]) {
		dfs(to);
	}
	ord(v);
}

int32_t main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	cin >> n;
	fi(0, n) {
		int type;
		cin >> type;
		int k;
		cin >> k;
		if (type == 1) {
			g[i].resize(k);
		} else {
			fj(0, k) {
				int x;
				cin >> x;
				have[i].pb(x);
				nums.pb(x);
			}
		}
	} 
	sort(all(nums));
	fi(0, n) {
		fx(x, have[i]) {
			x = lb(all(nums), x) - nums.begin();
			havem[i] += 1 << x;
		}
	}
	m = nums.size();
	for (mask = 0; mask < (1 << 20); ++mask) {
		ok = true;
		dfs(0);
		if (ok) {
			cout << "Yes\n";
			fi(0, n) {
				if (g[i].size() == 0) {
					cout << l[i] << '\n';
				} else {
					fx(to, g[i]) cout << to + 1 << ' ';
					cout << '\n';
				}
			}
		}
	}
	cout << "No\n";
}