#include <iostream>
#include <vector>
#include <queue>
#include <cmath>

using namespace std;

typedef long long ll;
typedef long double ld;

#define fastInp cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);

const ll SZ = 5e5 + 100, K = 30;

ll k, n;
bool grid[K][K];
ll lst[SZ];
string dp[SZ];

int main() {
	fastInp;

	cin >> k >> n;

	for (int i = 0; i < k; i++) {
		string s;
		cin >> s;
		for (int j = 0; j < k; j++) {
			grid[i][j] = s[j] - '0';
		}
	}

	string s;
	cin >> s;

	lst[s.size() - 1] = s.size() - 1;
	vector<ll> posses;
	for (int i = s.size() - 2; i >= 0; i--) {
		lst[i] = i;
		ll i1 = s[i] - 'a', i2 = s[i + 1] - 'a';

		if (grid[i1][i2]) {
			lst[i] = lst[i + 1];
		}

		while (lst[i] < s.size() - 1) {
			ll i1 = s[i] - 'a', i2 = s[lst[i] + 1] - 'a';
			if (grid[i1][i2]) {
				lst[i] = lst[lst[i] + 1];
			}
			else {
				break;
			}
		}
	}

	string ans;

	ll i = 0;
	while (i < s.size()) {
		posses.push_back(i);
		i = lst[i] + 1;
	}
	
	string prev;
	for (int i = posses.size() - 1; i >= 0; i--) {
		ll t = posses[i];

		string cur, bst;
		for (int j = t + 1; j <= lst[t]; j++) {
			bst.push_back(s[j]);
			cur.push_back(s[j]);
		}

		cur += prev;
		bst += prev;
		for (int j = t + 1; j <= lst[t]; j++) {
			cur.erase(cur.begin());
			bst = min(bst, cur);
		}

		bst.insert(bst.begin(), s[t]);
		ans = bst;
		prev = ans;
	}

	cout << ans;

	return 0;
}

/*
3 7
010
001
100
abacaba

3 5
010
001
100
bcacb
*/