#include <iostream>
#include <vector>
#include <queue>
#include <cmath>

using namespace std;

typedef long long ll;
typedef long double ld;

#define fastInp cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);

const ll SZ = 5e5 + 100, K = 30;

ll k, n;
bool grid[K][K];
ll lst[SZ];
string dp[SZ];

int main() {
	fastInp;

	cin >> k >> n;

	for (int i = 0; i < k; i++) {
		string s;
		cin >> s;
		for (int j = 0; j < k; j++) {
			grid[i][j] = s[j] - '0';
		}
	}

	string s;
	cin >> s;

	lst[s.size() - 1] = s.size() - 1;
	dp[s.size() - 1] = s.back();

	for (int i = s.size() - 2; i >= 0; i--) {
		dp[i] = dp[i + 1];

		lst[i] = i;
		ll i1 = s[i] - 'a', i2 = s[i + 1] - 'a';

		while (lst[i] < s.size() - 1) {
			ll i1 = s[i] - 'a', i2 = s[lst[i] + 1] - 'a';
			if (grid[i1][i2]) {
				string s2 = dp[lst[i] + 1];
				s2.erase(s2.begin());
				dp[i] = min(dp[i], s2);
				lst[i] = lst[lst[i] + 1];
			}
			else {
				break;
			}
		}

		for (int j = lst[i]; j > i; j--) {
			dp[i] = min(dp[i], dp[j + 1]);
		}
		dp[i].insert(dp[i].begin(), s[i]);
	}

	cout << dp[0];

	return 0;
}

/*
3 7
010
001
100
abacaba

3 5
010
001
100
bcacb
*/