#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <cassert>
#include <algorithm>

using namespace std;

//const int MAX_MEM = 6e8;
//char mem[MAX_MEM];
//int m_pos = 0;
//
//void* operator new(size_t n) {
//    assert((m_pos += n) <= MAX_MEM);
//    return (void*) (mem + m_pos - n);
//}
//
//void operator delete(void*) noexcept {}

#define int long long
const int SZ = 1e5 + 4;

int n;
vector<int> g[SZ];
int x[SZ];
vector<pair<int, int>> ans[SZ];

void read() {
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> x[i];
        if (x[i] == 1) {
            int k;
            cin >> k;
            for (int j = 0; j < k; ++j) {
                int v;
                cin >> v;
                --v;
                g[i].push_back(v);
            }
        } else {
            int k;
            cin >> k;
            for (int j = 0; j < k; ++j) {
                int y;
                cin >> y;
                ans[i].emplace_back(y, y);
            }
        }
    }
}

set<pair<int, int>> p;
void rec(int u, int i) {
    if (i == g[u].size()) {
        ans[u].emplace_back(p.begin()->first, p.rbegin()->second);
        return;
    }

    for (auto z : ans[g[u][i]]) {
        bool zz = true;
        if (!p.empty()) {
            auto it = p.lower_bound(z);
            if (it != p.end()) {
                zz &= it->first > z.second;
            }
            if (it != p.begin()) {
                --it;
                zz &= it->second < z.first;
            }
        }

        if (zz) {
            p.insert(z);
            rec(u, i + 1);
            p.erase(z);
        }
    }
}

void dfs(int u) {
    if (x[u] == 2) return;
    for (int v : g[u]) {
        dfs(v);
    }
    rec(u, 0);
}

void solve() {
    dfs(0);
    if (!ans[0].empty()) {
        cout << "Yes\n";
    } else {
        cout << "No\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    read();
    solve();

    return 0;
}