#include <iostream>
#include <vector>
#include <numeric>
#include <algorithm>
#include <set>
using namespace std;
int a[26][26];
string s;

string t[1000 * 100];

void upd(int p, int l, int r, int ind, string &val) {
    if (r - l == 1) {
        t[p] = val;
        return;
    }
    int m = (l + r) / 2;
    if (ind < m) {
        upd(2 * p + 1, l, m, ind, val);
    }
    else {
        upd(2 * p + 2, m, r, ind, val);
    }
    t[p] = min(t[2 * p + 1], t[2 * p + 2]);
}
string bad = "";

string get(int p, int l, int r, int lq, int rq) {
    if (r <= lq) {
        return bad;
    }
    if (l >= rq) {
        return bad;
    }
    if (l >= lq && r <= rq) {
        return t[p];
    }
    int m = (l + r) / 2;
    return min(get(2 * p + 1, l, m, lq, rq), get(2 * p + 2, m, r, lq, rq));
}

int can_del(int l, int r) {
    if (r < l) {
        return true;
    }
    string s_now;
    for (int i = l - 1; i <= r; i++) {
        s_now.push_back(s[i]);
    }
    while (s_now.size() != 1) {
        bool fl = false;
        for (int i = s_now.size() - 1; i >= 1; i--) {
            if (a[s_now[i - 1] - 'a'][s_now[i] - 'a']) {
                fl = true;
                s_now.erase(s_now.begin() + i);
                i++;
            }
        }
        if (!fl) {
            return false;
        }
    }
    return true;
}

int main() {

    int k, n;
    cin >> k >> n;
    for (int i = 0; i < k; i++) {
        for (int j = 0; j < k; j++) {
            char x;
            cin >> x;
            if (x == '1') {
                a[i][j] = 1;
            }
        }
    }

    cin >> s;
    string ans;
    ans.push_back(s[0]);
    vector<string> minstr(n);
    bad.push_back('a' + 30);
    for (int last_taken = n - 1; last_taken >= 0; last_taken--) {
        if (can_del(last_taken + 1, n - 1)) {
            minstr[last_taken] = "";
            minstr[last_taken].push_back(s[last_taken]);
            upd(0, 0, n, last_taken, minstr[last_taken]);
            continue;
        }
        string minn = "";
        minn.push_back('a' + 30);
        int minn_pos = last_taken + 1;
        int l = last_taken + 1;
        int r = n;
        while (r - l > 1) {
            int m = (l + r) / 2;
            if (can_del(last_taken + 1, m - 1)) {
                l = m;
            }
            else {
                r = m;
            }
        }
        minn = get(0, 0, n, last_taken + 1, r);
        minstr[last_taken] = "";
        minstr[last_taken].push_back(s[last_taken]);
        minstr[last_taken] += minn;
        upd(0, 0, n, last_taken, minstr[last_taken]);
    }
    cout << minstr[0];
}
