#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

int n, m;
string s;

vector < vector < char > > kek;
vector < int > p;

bool check() {
	string res;
	for (int i = 0; i < m; i++) {
		int id = 0;
		while (id < n && kek[p[id]][i] == '#')
			id++;
		if (id == n)
			return false;
		res += kek[p[id]][i];
	}
	if (res == s) return true;
	return false;
}

vector < bool > used;
vector < int > ans15;
void f() {
	if (p.size() == used.size()) {
		if (check() && !ans15.size()) {
			for (auto e : p)
				cout << e + 1 << " ";
			cout << "\n";
			ans15 = p;
		}
		return;
	}

	for (int i = 0; i < used.size(); i++) {
		if (!used[i]) {
			used[i] = true;
			p.push_back(i);
			f();
			p.pop_back();
			used[i] = false;
		}
	}
}

vector < int > solve15() {
	used.assign(n, false);
	ans15.resize(0);
	f();
	if (!ans15.size())
		cout << "-1\n";
	return ans15;
}

void solve50() {
	vector < int > ans;
	vector < bool > taken(m, false);
	vector < bool > usedt(n, false);
	int freepos = m;
	while (freepos > 0) {
		bool take = false;
		for (int i = 0; i < n; i++) {
			if (usedt[i]) continue;
			bool ok = true;
			for (int j = 0; j < m; j++) {
				if (kek[i][j] == '#' || taken[j]) continue;
				if (s[j] != kek[i][j]) ok = false;
			}
			if (!ok) continue;
			take = true;
			usedt[i] = true;
			ans.push_back(i);
			for (int j = 0; j < m; j++) {
				if (kek[i][j] == '#') continue;
				if (!taken[j]) {
					taken[j] = true;
					freepos--;
				}
			}
		}
		if (!take) {
			cout << "-1";
			return;
		}
	}

	for (int i = 0; i < n; i++)
		if (!usedt[i]) ans.push_back(i);

	for (auto e : ans) cout << e + 1 << " ";
	return;
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	cin >> n >> m;
	cin >> s;
	kek.assign(n, vector < char >(m, '#'));

	for (int i = 0; i < n; i++) {
		int k;
		cin >> k;;
		int pos;
		char t;
		for (int j = 0; j < k; j++) {
			cin >> pos >> t;
			pos--;
			kek[i][pos] = t;
		}
	}

	solve50();
}
