#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>

#define pb emplace_back
#define mp make_pair
#define all(x) (x).begin(), (x).end()
#define fi first
#define se second
#define out(x); { for (auto i : x) cout << i << ' '; cout << endl; }


using namespace std;

typedef long long ll;
typedef pair <int, int> pii;
typedef vector <int> vi;

int dp[2001][2001];

vi up[2001];

vi g[2001];
int st[2001];

const int INF = 1000000;

void dfs(int v) {
    if (st[v] == 2) {
        for (int i : up[v])
            dp[v][i] = i;
        for (int i = 1999; i > 0; i--) {
            dp[v][i] = min(dp[v][i], dp[v][i + 1]);
        }
        return;
    }
    if (g[v].size() == 1) {
        dfs(g[v][0]);
        for (int i = 1; i <= 2000; i++)
            dp[v][i] = dp[g[v][0]][i];
        return;
    }
    int l = g[v][0], r = g[v][1];
    dfs(l);
    dfs(r);
    for (int i = 1; i <= 2000; i++) {
        int tr = dp[l][i] + 1;
        //cout << tr << endl;
        if (tr == INF) continue;
        //cout << "h" << endl;
        int tv = dp[r][tr];
        dp[v][i] = min(dp[v][i], tv);
    }
    for (int i = 1; i <= 2000; i++) {
        int tl = dp[r][i] + 1;
        if (tl == INF) continue;
        int tv = dp[l][tl];
        dp[v][i] = min(dp[v][i], tv);
    }
    for (int i = 1999; i > 0; i--) {
        dp[v][i] = min(dp[v][i], dp[v][i + 1]);
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    for (int i = 0; i <= 2000; i++) {
        for (int j = 1; j <= 2000; j++)
            dp[i][j] = INF;
    }

    int n; cin >> n;
    vi uv;
    for (int i = 1; i <= n; i++) {
        cin >> st[i];
        if (st[i] == 1) {
            int k; cin >> k;
            for (int j = 0; j < k; j++) {
                int x; cin >> x;
                g[i].pb(x);
            }
        } else {
            int k; cin >> k;
            for (int j = 0; j < k; j++) {
                int x; cin >> x;
                up[i].pb(x);
                uv.pb(x);
            }
        }
    }

    sort(all(uv));
    for (int i = 1; i <= n; i++) {
        //cout << g[i].size() << endl;
        for (int &j : up[i])
            j = lower_bound(uv.begin(), uv.end(), j) - uv.begin() + 1;
    }

    dfs(1);
    for (int i = 1; i <= uv.size(); i++) {
        if (dp[1][i] != INF) {
            cout << "Yes\n";
            return 0;
        }
    }
    cout << "No\n";
}
