#include <iostream>
#include <vector>
//#include <algorithm>
//#include <random>

using namespace std;

#define FOR(i, a, b) for(__typeof(b) i = (a); i < (b); ++i)
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define sz(x) (int)x.size()

//#define int long long

typedef long long ll;
typedef long double ld;
typedef int32_t i32;
typedef pair<int, int> pii;
typedef vector<int> vi;

//mt19937 rng(104);

void solve(){
    int n, m; cin >> n >> m;
    string s; cin >> s;
    vi remain(n, 0), used(m, 0);
    vector<vi> b(m);
    vector<vector<pii>> p(n);
    vi q;
    FOR(i, 0, n){
        int k; cin >> k;
        FOR(j, 0, k){
            int a; char c; cin >> a >> c;
            a--;
            p[i].emplace_back(a, c);
            if(s[a] != c){
                remain[i]++;
                b[a].push_back(i);
            }
        }
        if(remain[i] == 0){
            q.push_back(i);
        }
    }
    vi ans;
    int cur = 0;
    while(!q.empty()){
        int i = q.back(); q.pop_back();
        for(auto [j, c] : p[i]){
            if(used[j]) continue;
            used[j] = 1;
            cur++;
            for(int k : b[j]){
                remain[k]--;
                if(remain[k] == 0){
                    q.push_back(k);
                }
            }
        }
        ans.push_back(i);
    }
    if(cur != m){
        cout << "-1\n";
    }else{
        for(int i : ans){
            cout << i + 1 << ' ';
        }
        cout << '\n';
    }
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
//    int t; cin >> t; while(t--) solve();
}