#pragma GCC optimze("Ofast")
#include <bits/stdc++.h>

#define sq(x) ((x)*(x))
#define err(x) cerr << "["#x"]  " << (x) << '\n';
#define errv(x) {cerr << "["#x"]  ["; for (const auto& ___ : (x)) cerr << ___ << ", "; cerr << "]\n";}
#define errvn(x, n) {cerr << "["#x"]  ["; for (int ___ = 0; ___ < (n); ++___) cerr << (x)[___] << ", "; cerr << "]\n";}
#define errf() cerr << "\n\n";

using namespace std;

using ll = long long;
using ull = unsigned long long;
using ld = long double;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
inline ll getrnd(ll l, ll r) {
    return uniform_int_distribution<ll>(l, r)(rng);
}

template<typename T1, typename T2>
inline bool relax(T1& a, const T2& b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

template<typename T1, typename T2>
inline bool strain(T1& a, const T2& b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

// ::::::::::::::::::::::::

const int N = 2e5 + 3;

int was[N];
vector<int> graph[N];

void dfs(int v, list<int>& ts) {
    if (was[v]) return;

    was[v] = 1;
    for (int to : graph[v])
        dfs(to, ts);
    ts.emplace_front(v);
}

void solve() {
    int n, m;
    string s;
    cin >> n >> m >> s;

    vector<vector<pair<int, char>>> a(n);
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;

        for (int j = 0; j < k; ++j) {
            int pos;
            char c;
            cin >> pos >> c;
            --pos;

            a[i].emplace_back(pos, c);
            if (s[pos] == c) {
                graph[i].emplace_back(n + pos);
            }
            else {
                graph[n + pos].emplace_back(i);
            }
        }
    }

    list<int> ts;
    for (int i = 0; i < n + m; ++i)
        dfs(i, ts);

    vector<int> has(m), res;
    for (int i : ts) {
        if (i < n) {
            for (auto [pos, c] : a[i]) {
                if (!has[pos]) {
                    if (s[pos] != c) {
                        cout << "-1\n";
                        return;
                    }
                    has[pos] = 1;
                }
            }
            res.emplace_back(i);
        }
    }

    for (int x : res)
        cout << x + 1 << ' ';
    cout << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);

    int t = 1;
//    cin >> t;
    while (t--)
        solve();

    return 0;
}

