#pragma GCC optimze("Ofast")
#include <bits/stdc++.h>

#define sq(x) ((x)*(x))
#define err(x) cerr << "["#x"]  " << (x) << '\n';
#define errv(x) {cerr << "["#x"]  ["; for (const auto& ___ : (x)) cerr << ___ << ", "; cerr << "]\n";}
#define errvn(x, n) {cerr << "["#x"]  ["; for (int ___ = 0; ___ < (n); ++___) cerr << (x)[___] << ", "; cerr << "]\n";}
#define errf() cerr << "\n\n";

using namespace std;

using ll = long long;
using ull = unsigned long long;
using ld = long double;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
inline ll getrnd(ll l, ll r) {
    return uniform_int_distribution<ll>(l, r)(rng);
}

template<typename T1, typename T2>
inline bool relax(T1& a, const T2& b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

template<typename T1, typename T2>
inline bool strain(T1& a, const T2& b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

// ::::::::::::::::::::::::

const int N = 32, B = N / C, C = 1 << LG, LG = 4;

set<pair<int, int>> blcks[N][N];

void solve() {
    int type;
    cin >> type;

    int n, k, m;
    cin >> n >> k >> m;

    if (type == 1) {
        string s;
        cin >> s;

//        err(0);
        int pos = 0;
        while (s.size() % (2 * LG) != 0) {
            s += char(getrnd('0', '1'));
        }
//        err(1);

        for (char& c : s)
            c -= '0';

        auto out = [](int x, int y) {
            cout << x + 1 << ' ' << y + 1 << endl;
        };

        auto reset_blocks = [&]() {
            for (int i = 0; i < n; ++i)
                for (int j = 0; j < n; ++j)
                    blcks[i][j].clear();
            for (int i = 0; i < n; ++i) {
                for (int j = 0; j < n; ++j) {
                    if (i == 0 && j == 0) continue;
                    blcks[i / B][j / B].emplace(i, j);
                }
            }
        };

        auto paint = [&](int x, int y) {
            for (int i = x; i < n; ++i) {
                for (int j = y; j < n; ++j) {
                    blcks[i / B][j / B].erase({i, j});
                }
            }
        };

        reset_blocks();
        int me = 1, st = 1;
        while (pos < s.size()) {
            int bx = 0, by = 0;
            for (int i = pos; i < pos + LG; ++i)
                bx += s[i] << (i - pos);
            for (int i = pos + LG; i < pos + LG * 2; ++i)
                by += s[i] << (i - pos - LG);

//            err(3);
//            err(bx);
//            err(by);
            if (me) {
                if (blcks[bx][by].empty()) {
                    out(0, 0);
                    reset_blocks();
                    st ^= 1;
                    me = st;
                    continue;
                }
                else {
                    auto [x, y] = *blcks[bx][by].rbegin();
                    out(x, y);
                    paint(x, y);
                    me ^= 1;
                }
            }
            else {
                int sx, sy;
                cin >> sx >> sy;
                --sx; --sy;

                if (sx == 1 && sy == 1) {
                    st ^= 1;
                    me = st;
                    reset_blocks();
                    continue;
                }
                paint(sx, sy);
                me ^= 1;
                continue;
            }

            pos += 6;
        }
        if (me) {
            out(0, 0);
        }
        else {
            int sx, sy;
            cin >> sx >> sy;
            --sx; --sy;
            if (sx == 0 && sy == 0) {

            }
            else {
                out(0, 0);
            }
        }
        cout << 0 << endl;
    }
    else {
        int k;
        cin >> k;

        int me = 1, st = 1;
        string res;
        int x, y;
        while (true) {
            cin >> x >> y;

            --x; --y;
            if (x == 0 && y == 0) {
                st ^= 1;
                me = st;
                k--;
                if (k)
                    continue;
                else
                    break;
            }
            if (me) {
                x /= B;
                y /= B;
                for (int j = 0; j < LG; ++j) {
                    res += '0' + char((x >> j) & 1);
                }
                for (int j = 0; j < LG; ++j) {
                    res += '0' + char((y >> j) & 1);
                }
            }
            me ^= 1;
        }
        res.resize(m);

        cout << res << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);

    int t = 1;
//    cin >> t;
    while (t--)
        solve();

    return 0;
}

