#include <iostream>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <string>
#include <queue>
#include <deque>
#include <bitset>
#include <array>

#define ar array
#define int long long

using namespace std;
using ll=long long;
using ld=long double;

int n, m;
string s;
vector<vector<ar<int,2>>> a;
vector<int> sm;
set<ar<int,2>> ssm;
vector<vector<ar<int,2>>> col;

void solve() {
	cin >> n >> m;
	cin >> s;
	a.assign(n,vector<ar<int,2>>(m));
	col.assign(m,vector<ar<int,2>>(0));
	sm.assign(n,0);
	for (int i = 0; i < n; ++i) {
		int k; cin >> k;
		for (int j = 0; j < k; ++j) {
			int x; char y;
			cin >> x >> y; --x;
			if (y==s[x]) {
				a[i][j]={x,1};
				sm[i]++;
			}
			else a[i][j]={x,0};
			col[x].push_back({i,j});
		}
		sm[i]=k-sm[i];
		ssm.insert({sm[i],i});
	}
	vector<bool> used(m,0), tk(n,0);
	vector<int> ans(0);
	while (ssm.size()) {
		ar<int,2> cur=*ssm.begin(); ssm.erase(ssm.begin());
		if (cur[0] > 0) {
			cout << -1;
			return;
		}
		ans.push_back(cur[1]);
		tk[cur[1]]=1;
		for (auto x : a[cur[1]]) {
			if (used[x[0]]) continue;
			used[x[0]]=1;
			for (auto y : col[x[0]]) {
				if (tk[y[0]]) continue;
				ssm.erase(ssm.find({sm[y[0]],y[0]}));
				if (a[y[0]][y[1]][1]==0) --sm[y[0]];
				ssm.insert({sm[y[0]],y[0]});
			}
		}
	}
	for (auto x : used) {
		if (!x) {
			cout << -1;
			return;
		}
	}
	for (auto x : ans) cout << x+1 << " ";
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int test_case=1;
	for (int i = 0; i < test_case; ++i) {
		solve();
		cout << "\n";
	}
}