#include<iostream>
#include<vector>
#include<algorithm>
#include<string>
#include<map>
#include<random>
using namespace std;

mt19937 gen(0);

const int INF = 1e9;



int main() {
	int n, k;
	cin >> k >> n;
	vector<vector<int>> A(k, vector<int>(k));
	for (int i = 0; i < k; ++i) {
		for (int j = 0; j < k; ++j) {
			char c;
			cin >> c;
			A[i][j] = c - '0';
		}
	}
	vector<int> s;
	for (int i = 0; i < n; ++i) {
		char c;
		cin >> c;
		s.push_back(c - 'a');
	}
	vector<int> max_pref(n, 0);
	for (int i = n - 2; i >= 0; --i) {
		int cur_pos = i + 1;
		int cur_val = 0;
		while (cur_pos <= n - 1 && A[s[i]][s[cur_pos]] == 1) {
			cur_val += max_pref[cur_pos] + 1;
			cur_pos += max_pref[cur_pos] + 1;
		}
		max_pref[i] = cur_val;
	}
	int cur_pos = 0;
	string ans = "";
	while (cur_pos <= n - 1) {
		ans += (char)('a' + s[cur_pos]);
		int min_pos = -1;
		int min_char = 27;
		if (cur_pos + max_pref[cur_pos] == n - 1) {
			cur_pos = n;
		}
		else {
			for (int i = 1; i <= max_pref[cur_pos]; ++i) {
				if (min_char > s[i + cur_pos]) {
					min_char = s[i + cur_pos];
					min_pos = i + cur_pos;
				}
			}
			if (min_char > s[cur_pos + max_pref[cur_pos] + 1]) {
				min_pos = max_pref[cur_pos] + cur_pos + 1;
			}
			cur_pos = min_pos;
		}
	}
	cout << ans;
}

//3 7
//010
//001
//100
//abacaba

//3 5
//010
//001
//100
//bcacb