#pragma GCC optimize("Ofast")
#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <set>
#include <map>

using namespace std;

#define rep(i, n) for (int i = 0; i < n; i++) 
#define per(i, n) for (int i = n - 1; i >= 0; i--) 

#define all(x) x.begin(), x.end()
#define sz(x) ((int)x.size())
#define pb push_back
#define ff first
#define ss second

typedef vector< int> vi;
typedef pair<int, int> pii;
typedef vector<pii> vpii;

const int N = 500500;
int up_to[N];

bool can[300][300];


int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int k, n;
	cin >> k >> n;
	rep(i, k) {
		string tmp;
		cin >> tmp;
		rep(j, k) {
			if (tmp[j] == '1') {
				can[i + 'a'][j + 'a'] = true;
			}
		}
	}
	string s;
	cin >> s;
	per(i, n) {
		int ind = i + 1;
		while (ind < n && can[s[i]][s[ind]]) {
			ind = up_to[ind];
		}
		up_to[i] = ind;
	}
	s.pb('$');
	string ans;
	int i = 0;
	while (i < n) {
		ans.pb(s[i]);
		int best = i + 1;
		for (int j = i + 1; j <= up_to[i]; j++) {
			if (s[best] > s[j] || (s[best] == s[j] && up_to[best] < up_to[j])) {
				best = j;
			}
		}
		i = best;
	}
	cout << ans;
	return 0;
}