import java.io.*;
import java.util.*;

public class task4 {
    static ArrayList<Integer>[] lines;
    static int[][] prizes;
    static int[][] used;
    static int[] ans;
    public static void main(String[] args) throws IOException {
        int n = nextInt();
        lines = new ArrayList[n];
        for (int i = 0; i < n; i++) {
            lines[i] = new ArrayList<>();
        }
        prizes = new int[n][n];
        used = new int[n][n];
        int m = nextInt();
        ans = new int[n - 1];
        for (int i = 0; i < n - 1; i++) {
            ans[i] = 1000000007;
        }
        for (int i = 0; i < m; i++) {
            int v = nextInt() - 1;
            int u = nextInt() - 1;
            lines[v].add(u);
            lines[u].add(v);
            prizes[v][u] = nextInt();
            prizes[u][v] = prizes[v][u];
        }
        dfs(0, 1000000007, -1);
        for (int i = 0; i < n - 1; i++) {
            out.println(ans[i]);
        }
        out.close();
    }

    public static void dfs(int v, int min, int max) {
        for (int u : lines[v]) {
            if (used[v][u] == 0) {
                used[v][u] = 1;
                used[u][v] = 1;
                if (u != 0) {
                    ans[u - 1] = Math.min(ans[u - 1], Math.min(min, prizes[v][u]) + Math.max(max, prizes[v][u]));
                }
                dfs(u, Math.min(min, prizes[v][u]), Math.max(max, prizes[v][u]));
                used[v][u] = 0;
                used[u][v] = 0;
            }
        }
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");

    public static String nextToken() throws IOException{
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }
}