#include <bits/stdc++.h>

using namespace std;
#define point() cout << "Have reached" << endl
#define get(x) cout << #x << " : " << x << endl
#define int long long
#define forn(i, n) for (int i = 0; i < (n); ++i)
#define fork(s, i, n) for (int i = (s); i < (n); ++i)
#define printl(x) cout << x << endl
#define printe(x) cout << x << ' '
#define sz(x) (int)x.size()
#define null(x) memset(x, 0, sizeof(x))

void MP() {
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false);
    cin.tie(0);
}
const int inf = (int)1e17 + 9;

int tf['Z' + 1];
void prep() {
    tf['A'] = 1;
    fork ('B', i, 'Z' + 1) {
        if ((i - 'A') % 2 == 0) tf[i] = tf[i - 1] * 2ll;
        else tf[i] = tf[i - 1] * 5ll;
    }
}

void solve() {
    string s;
    cin >> s;
    const int n = sz(s);
    const int m = 'Z' + 1;
    int fen[m];
    null(fen);
    auto update = [&](int i, int inc) {
        for (; i < m; i |= (i + 1)) {
            fen[i] += inc;
        }
    };

    auto get_sum = [&](int i) {
        int ans = 0;
        for (; i >= 0; i = (i & (i + 1)) - 1) {
            ans += fen[i];
        }
        return ans;
    };

    multiset<char> st;
    forn (i, n) {
        if (s[i] != '?') st.insert(s[i]);
    }
    forn (i, n) {
        if (s[i] != '?') {
            auto it = st.lower_bound(s[i]);
            st.erase(it);
            update(s[i], tf[s[i]]);
            continue;
        }
        int ans = -inf;
        char answer;
        fork ('A', c, m) {
            int sum = -get_sum(c - 1);
            if (!st.empty() && *(--st.end()) > c) sum -= tf[c];
            else sum += tf[c];
            if (sum > ans) {
                ans = sum;
                answer = c;
            }
        }
        assert(ans != -inf);
        s[i] = answer;
        update(s[i], tf[s[i]]);
    }
    null(fen);
    st.clear();
    int sum = 0;
    forn (i, n) {
        st.insert(s[i]);
    }
    forn (i, n) {
        auto it = st.lower_bound(s[i]);
        st.erase(it);
        if (!st.empty() && *(--st.end()) > s[i]) sum -= tf[s[i]];
        else sum += tf[s[i]];
    }
    printl(sum);
    printl(s);
}

signed main() {
    MP();
    prep();
    int T;
    for (cin >> T; T--;) {
        solve();
    }
}