#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <string>

using namespace std;
typedef long long ll;

int main() {
	cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);
	vector<ll>zn('z' - 'a' + 1);
	zn[0] = 1;
	for (int i = 1; i < zn.size(); i++)
		if (i % 2 != 0)
			zn[i] = zn[i - 1] * 5;
		else
			zn[i] = zn[i - 1] * 2;
	int t; cin >> t;
	while (t--) {
		string s; cin >> s;
		int n = s.size();
		vector<int>suf(n);
		suf[n - 1] = s[n - 1] - 'A';
		for (int i = n - 2; i >= 0; i--)
			if (s[i] != '?')
				suf[i] = max(suf[i + 1], s[i] - 'A');
			else
				suf[i] = suf[i + 1];
		ll ans = 0;
		vector<int>left(26);
		for (int i = 0; i < n; i++) {
			if (s[i] != '?') {
				if (s[i] - 'A' >= suf[i]) {
					ans += zn[s[i] - 'A'];
					left[s[i] - 'A']++;
				}
				else
					ans -= zn[s[i] - 'A'];
			}
			else {
				ll best_b = -1e18, B = -1;
				ll go_minus = 0;
				for (int b = 0; b < 26; b++) {
					ll score = go_minus + zn[b];
					if (suf[i] > b)
						score -= 2 * zn[b];
					if (best_b < score) {
						best_b = score;
						B = b;
					}
					go_minus -= zn[b] * left[b];
				}
				for (int j = 0; j < B; j++) {
					best_b -= 2 * zn[j] * left[j];
					left[j] = 0;
				}
				if (B >= suf[i])
					ans += zn[B];
				else
					ans -= zn[B];
				s[i] = B + 'A';
				if (B >= suf[i])
					left[B]++;
			}
		}
		cout << ans << '\n' << s << '\n';
	}
	return 0;
}