#include <bits/stdc++.h>

using namespace std;

#define ld long double
#define all(x) x.begin(), x.end()

int n, m;
vector<vector<int>> g;
vector<bool> used;
vector<pair<int, int>> res;
map<pair<int, int>, int> ti1, ti2;

pair<int, int> dfs(int v) {
    used[v] = true;
    vector<int> t1, t2;

    for (auto u : g[v]) {
        if (!used[u]) {
            auto z = dfs(u);
            if (z.first != -1 && ti1.count({v, u})) {
                res.emplace_back(ti1[{v, u}], z.first);
                ti1.erase({v, u});
            }
            else if (z.second != -1 && ti2.count({v, u})) {
                res.emplace_back(z.first, ti2[{v, u}]);
                ti2.erase({v, u});
            }
            if (ti1.count({v, u}))t1.push_back(ti1[{v, u}]);
            if (ti2.count({v, u}))t2.push_back(ti2[{v, u}]);
        }
    }
    while (!t1.empty() && !t2.empty()) {
        int i1 = t1.back();
        int i2 = t2.back();
        res.emplace_back(i2, i1);
        t1.pop_back();
        t2.pop_back();
    }
    pair<int, int> q = {-1, -1};
    if (!t1.empty())q.first = t1.back();
    if (!t2.empty())q.second = t2.back();
    return q;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >> n >> m;
    g.resize(n);
    used.resize(n);
    vector<pair<int, int>> edges(m);
    for (int i = 0; i < m; ++i) {
        int x, y;
        cin >> x >> y;
        --x, --y;
        edges[i] = {x, y};
        g[x].push_back(y);
        g[y].push_back(x);
        ti1[{x, y}] = i;
        ti2[{y, x}] = i;
    }

    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            dfs(i);
        }
    }

    if (res.size() != m / 2) {
        cout << "No\n";
        exit(0);
    }

    cout << "Yes\n";
    for (auto z : res) {
        cout << edges[z.first].first + 1 << " " << edges[z.first].second + 1 << " " << edges[z.second].first + 1 << " "
             << edges[z.second].second + 1 << '\n';
    }
}