#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

#define int ll
#define f first
#define s second
#define pb push_back

const int N = 3e5 + 10;
vector<pair<int, int>> g[N];
int used[N], ans[N], par[N], sz[N];

int get(int v) {
    if (par[v] == v) return v;
    return par[v] = get(par[v]);
}

void update(int a, int b) {
    a = get(a);
    b = get(b);
    if (a == b)
        return;
    if (sz[a] < sz[b])
        swap(a, b);
    sz[a] += sz[b];
    par[b] = a;
}

void dfs(int v, int mn = 1e9, int mx = 0) {
    used[v] = 1;
    ans[v] = mn + mx;
    for (auto u : g[v]) {
        if (!used[u.f]) {
            dfs(u.f, min(mn, u.s), max(mx, u.s));
        }
    }
}

void solve() {
    int n, m, a, b, t;
    cin >> n >> m;
    int mn = 1e9;
    vector<pair<int, pair<int, int>>> ms;
    for (int i = 0; i < m; i++) {
        cin >> a >> b >> t;
        a--;
        b--;
        ms.pb({t, {a, b}});
        mn = min(mn, t);
    }
    for (int i = 1; i < n; i++){
        cout << mn + 1e9 << endl;
    }
    return;
    sort(ms.begin(), ms.end());
    for (int i = 0; i < n; i++) {
        par[i] = i;
        sz[i] = 1;
    }
    for (auto u : ms) {
        if (get(u.s.f) != get(u.s.s)) {
            update(u.s.f, u.s.s);
            g[u.s.f].pb({u.s.s, u.f});
            g[u.s.s].pb({u.s.f, u.f});
        }
    }
    dfs(0);
    for (int i = 1; i < n; i++)
        cout << ans[i] << endl;
}

signed main() {
    solve();
}
