#include <bits/stdc++.h>

using namespace std;

#define int long long
#define all(a) a.begin(), a.end()
#define f first
#define s second
#define pb push_back

const int maxn = 300228, inf = 1e10;

int n, m;

vector<pair<int, int>> g[maxn], g2[maxn];

void solve1() {
    vector<int> mn(n, -1), mx(n, -1);
    queue<int> q;
    q.push(0);
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (auto[u, t]: g[v]) {
            if (v == 0) {
                mn[u] = mx[u] = t;
                q.push(u);
            } else {
                if (mn[u] == -1) {
                    mn[u] = min(mn[v], t);
                    mx[u] = max(mx[v], t);
                    q.push(u);
                }
            }
        }
    }
    for (int i = 1; i < n; ++i) {
        cout << mn[i] + mx[i] << '\n';
    }
}

void solve2() {
    vector<int> mx(n, inf);
    set<pair<int, int>> s;
    mx[0] = 0;
    for (int i = 0; i < n; ++i) {
        s.insert({mx[i], i});
    }
    while (!s.empty()) {
        int v = s.begin()->s;
        s.erase(s.begin());
        for (auto[u, t]: g[v]) {
            if (mx[u] > max(mx[v], t)) {
                s.erase({mx[u], u});
                mx[u] = max(mx[v], t);
                s.insert({mx[u], u});
            }
        }
    }
    for (int i = 1; i < n; ++i) {
        cout << mx[i] << '\n';
    }
}

int t228 = 0;
int tin[maxn], up[maxn], c[maxn];
int mn[maxn], ans[maxn];
bool used[maxn];

void dfs(int v) {
    t228++;
    tin[v] = t228;
    for (auto [u, t]: g[v]) {
        if (tin[u] == 0) {
            dfs(u);
        }
    }
}

void dfs2(int v, int pr) {
    up[v] = tin[v];
    int cnt = 0;
    for (auto [u, t]: g[v]) {
        if (up[u] == 0) {
            dfs2(u, v);
        }
        if (u == pr) {
            cnt++;
        } else if (tin[u] < tin[v]) {
            up[v] = min(up[v], tin[u]);
        } else {
            up[v] = min(up[v], up[u]);
        }
    }
    if (cnt > 1) {
        up[v] = min(up[v], tin[pr]);
    }
}

void col(int v, int c1) {
    c[v] = c1;
    for (auto[u, t1]: g[v]) {
        if (c[u] == 0 && up[u] <= tin[v]) {
            col(u, c1);
        }
    }
}

void get_ans(int v, int pr, int m1) {
    ans[v] = min(m1, mn[v]);
    for (auto [u, t1]: g2[v]) {
        if (u != pr) {
            get_ans(u, v, min(min(m1, mn[v]), t1));
        }
    }
}

void solve3() {
    for (int i = 0; i < n; ++i) {
        tin[i] = used[i] = c[i] = 0;
    }
    t228 = 0;
    dfs(0);
    dfs2(0, 0);
    int c1 = 0;
    for (int i = 0; i < n; ++i) {
        if (c[i] == 0) {
            c1++;
            col(i, c1);
        }
    }
    for (int i = 0; i < n; ++i) {
        mn[c[i]] = inf;
    }
    for (int i = 0; i < n; ++i) {
        for (auto [j, t1]: g[i]) {
            if (c[i] == c[j]) {
                mn[c[i]] = min(mn[c[i]], t1);
            } else {
                g2[c[i]].pb({c[j], t1});
            }
        }
    }
    for (int i = 0; i <= n; ++i) {
        set<int> s;
        for (auto [j, t1]: g2[i]) {
            if (s.count(j)) {
                exit(1);
            }
            s.insert(j);
        }
    }
//    for (int i = 0; i < n; ++i) {
//        cout << tin[i] << ' ' << up[i] << endl;
//    }
    get_ans(c[0], c[0], inf);
    for (int i = 1; i < n; ++i) {
        cout << ans[c[i]] + g[0][0].s << '\n';
    }
}

const int minn = 20;

bool dp[1 << minn][minn];

void solve45() {
    vector<pair<pair<int, int>, int>> edges;
    for (int i = 0; i < n; ++i) {
        for (auto [j, t]: g[i]) {
            if (j > i) {
                edges.pb({{i, j}, t});
            }
        }
    }
    for (int i = 0; i < m; ++i) {
        if (edges[i].f.s == 0) {
            dp[1 << i][edges[i].f.f] = 1;
        }
        if (edges[i].f.f == 0) {
            dp[1 << i][edges[i].f.s] = 1;
        }
    }
    for (int i = 0; i < (1 << m); ++i) {
        for (int j = 0; j < n; ++j) {
            if (dp[i][j]) {
                for (int j2 = 0; j2 < m; ++j2) {
                    if ((i & (1 << j2)) == 0) {
                        if (edges[j2].f.f == j || edges[j2].f.s == j) {
                            dp[i | (1 << j2)][edges[j2].f.f + edges[j2].f.s - j] = 1;
                        }
                    }
                }
            }
        }
    }
    for (int i = 1; i < n; ++i) {
        int ans = inf * 2;
        for (int j = 0; j < (1 << m); ++j) {
            if (dp[j][i]) {
                int mn = inf, mx = 0;
                for (int j2 = 0; j2 < m; ++j2) {
                    if (j & (1 << j2)) {
                        mn = min(mn, edges[j2].s);
                        mx = max(mx, edges[j2].s);
                    }
                }
                ans = min(ans, mn + mx);
            }
        }
        cout << ans << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        int u, v, t;
        cin >> u >> v >> t;
        u--, v--;
        g[u].pb({v, t});
        g[v].pb({u, t});
    }
    if (m == n - 1) {
        solve1();
        return 0;
    }
    bool f = 1;
    for (auto[u, t1]: g[0]) {
        if (t1 != 0) {
            f = 0;
        }
    }
    if (f) {
        solve2();
        return 0;
    }
    if (n <= 20 && m <= 20) {
        solve45();
        return 0;
    }
    f = 1;
    for (auto [u, t1]: g[0]) {
        if (t1 != 1e9) {
            return 1;
        }
    }
    solve3();
    return 0;
}