#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

int main() {
	ios_base::sync_with_stdio(false); cin.tie(0);
	#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	#endif
	int n, m;
	cin >> n >> m;
	set <pair <int, int>> ed;
	vector <set <int>> g(n);
	for (int i = 0; i < m; ++i) {
		int u, v;
		cin >> u >> v;
		--u, --v;
		g[u].insert(v);
		g[v].insert(u);
		ed.insert({u, v});
	}
	vector <array <int, 4>> ans;
	vector <int> used(n);
	function <int(int, int)> dfs = [&] (int u, int p) {
		used[u] = 1;
		vector <int> up, down;
		if (ed.count({u, p})) down.push_back(p);
		if (ed.count({p, u})) up.push_back(p);
		for (auto v : g[u]) {
			if (used[v]) continue;
			int ret = dfs(v, u);
			if (ret & 1) up.push_back(v);
			if (ret & 2) down.push_back(v);
		}
		//cout << u + 1 << endl;
		//for (auto x : )
		vector <int> alive;
		while (!up.empty() && !down.empty()) {
			int a = up.back(), b = down.back();
			up.pop_back();
			down.pop_back();
			ans.push_back(array <int, 4> {a, u, u, b});
		}
		for (auto x : up) {
			if (x != p) {
				cout << "No\n";
				exit(0);
			}
		}
		for (auto x : down) {
			if (x != p) {
				cout << "No\n";
				exit(0);
			}
		}
		int ret = 0;
		if (!down.empty()) ret |= 1;
		if (!up.empty()) ret |= 2;
		return ret;
	};
	for (int i = 0; i < n; ++i) {
		if (!used[i]) {
			dfs(i, -1);
		}
	}
	cout << "Yes\n";
	for (int i = 0; i < (int)ans.size(); ++i) {
		for (int j = 0; j < 4; ++j) {
			cout << ans[i][j] + 1 << ' ';
		}
		cout << '\n';
	}
}