#include <bits/stdc++.h>
 
using namespace std;
 
typedef long long ll;
const int Inf = 1e9 + 7;

int main() {
    ios_base::sync_with_stdio(false); cin.tie(0);
    #ifdef LOCAL
    freopen("input.txt", "r", stdin);
    #endif
    int n, q;
    cin >> n >> q;
    vector <int> x(n), h(n);
    for (int i = 0; i < n; ++i) {
        cin >> x[i] >> h[i];
    }
    x.insert(x.begin(), x[0]);
    h.insert(h.begin(), Inf);
    x.push_back(x.back());
    h.push_back(Inf);
    vector <int> L(q), R(q);
    for (int i = 0; i < q; ++i) {
        cin >> L[i] >> R[i];
    }
    vector <int> kill(n + 2);
    vector <int> stay(n + 2);
    vector <int> min_r(n + 2);
    vector <vector <int>> who(n + 2);

    vector <int> go_r(q);
    vector <int> go_l(q);
    vector <int> ans(q);

    function <void(int, int, vector <int>)> rec = [&] (int l, int r, vector <int> id) {
        if (id.empty()) return;
        //cout << l << ' ' << r << endl;
        int m = (l + r) / 2;
        vector <int> goL, goR;
        vector <int> gs;
        for (int idx : id) {
            if (R[idx] <= m - 1) {
                goL.push_back(idx);
            } else if (L[idx] >= m + 2) {
                goR.push_back(idx);
            } else {
                gs.push_back(idx);
            }
        }
        rec(l, m, goL);
        rec(m + 1, r, goR);

        //cout << m << endl;

        for (int i : gs) {
            who[L[i]].push_back(i);
        }

        vector <int> st;
        for (int i = m + 1; i <= r; ++i) {
            kill[i] = r + 1;
            stay[i] = 0;
        }
        for (int i = m + 1; i <= r; ++i) {
            int lst;
            if (st.empty()) {
                lst = x[m];
            } else {
                lst = x[st.back()];
            }
            int nxt = x[min(n + 1, i + 1)];
            int ok = 0;
            if (x[i] - h[i] >= lst) {
                kill[i] = i + 1;
                ok = 1;
            }
            if (x[i] + h[i] <= nxt) {
                kill[i] = i + 1;
                ok = 1;
            }
            if (ok) {
                stay[i] = 0;
                while (!st.empty() && x[st.back()] + h[st.back()] <= nxt) {
                    kill[st.back()] = i + 1;
                    st.pop_back();
                }
            } else {
                stay[i] = 1;
                st.push_back(i);
            }
        }
        /*vector <int> pl;
        for (int i = m + 1; i <= r; ++i) {
            if (stay[i]) pl.push_back(i);
        }*/
        st.clear();
        for (int i = m; i >= l; --i) {
            int nxt;
            if (st.empty()) {
                nxt = x[min(n + 1, m + 1)];
            } else {
                nxt = x[st.back()];
            }
            int lst = x[max(0, i - 1)];
            int pr = -1;
            if (x[i] + h[i] <= nxt || x[i] - h[i] >= lst) {
                while (!st.empty() && x[st.back()] - h[st.back()] >= lst) st.pop_back();
            }
            if (!st.empty()) pr = st.back();
            if (pr == -1) {
                min_r[i] = m + 1;
            } else {
                int cur = min_r[pr];
                //cout << pr << ' ' << cur << endl;
                while (cur <= r && x[pr] + h[pr] > x[cur]) {
                    if (x[cur] - h[cur] >= x[pr]) cur = cur + 1;
                    else cur = kill[cur];
                }
                min_r[i] = cur;
            }
            for (int t : who[i + 1]) {
                //cout << min_r[1] << endl;
                int cr = R[t];
                int last_l = L[t] - 1;
                if (min_r[last_l] > cr + 1) {
                    assert(!st.empty());
                    for (int i = (int)st.size() - 1; i >= 0; --i) {
                        if (min_r[st[i]] <= cr + 1) {
                            last_l = st[i];
                            ans[t] += (int)st.size() - i;
                            break;
                        }
                    }
                    assert(min_r[last_l] <= cr + 1);
                }
                go_r[t] = min_r[last_l];
                go_l[t] = last_l;
            }
            if (!(x[i] + h[i] <= nxt || x[i] - h[i] >= lst)) {
                st.push_back(i);
            }
        }
        for (int i = l; i <= m; ++i) who[i].clear();
        for (int i : gs) {
            who[R[i]].push_back(i);
        }
        st.clear();
        for (int i = m + 1; i <= r; ++i) {
            int lst;
            if (st.empty()) {
                lst = x[m];
            } else {
                lst = x[st.back()];
            }
            int nxt = x[min(n + 1, i + 1)];
            if (x[i] - h[i] >= lst || x[i] + h[i] <= nxt) {
                while (!st.empty() && x[st.back()] + h[st.back()] <= nxt) {
                    st.pop_back();
                }
            } else {
                st.push_back(i);
            }
            for (int t : who[i]) {
                for (int i = (int)st.size() - 1; i >= 0; --i) {
                    if (st[i] == go_r[t]) {
                        int uk = i;
                        while (uk < (int)st.size() && x[st[uk]] - h[st[uk]] >= x[go_l[t]]) ++uk;
                        ans[t] += st.size() - uk;
                        break;
                    }   
                }
            }
        }
        for (int i = m; i <= r; ++i) who[i].clear();
    };
    vector <int> all(q);
    iota(all.begin(), all.end(), 0);
    rec(0, n + 1, all);
    for (int i = 0; i < q; ++i) {
        cout << R[i] - L[i] + 1 - ans[i] << '\n';
    }
}