#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <algorithm>
using namespace std;

struct answer
{
	int64_t max_elem;
	string s;
};

answer fync_0(map <char, int64_t> mean, vector <int64_t> ar, string &s)
{
	answer ans;
	int64_t res = 0, count = 0, max_elem = -9000000000000000000, max_indx = 0;
	char now_sym;

	for (int64_t k = 1; k < s.size(); ++k)
	{
		if ((int)s[k] >= (int)s[max_indx])
		{
			max_indx = k;
		}
	}
	for (int64_t k = 0; k < s.size(); ++k)
	{
		if (k >= max_indx || (s[k] == s[max_indx] && k < max_indx))
		{
			res += mean[s[k]];
		}
		else
		{
			res -= mean[s[k]];
		}
	}
	if (res > max_elem)
	{
		max_elem = res;
	}
	
	ans.max_elem = res; ans.s = s;

	return ans;
}

answer fync_1(map <char, int64_t> mean, vector <int64_t> ar, string& s)
{
	answer ans;
	char now_sym;
	string s_ans;
	int64_t count = 0, res = 0, max_elem = -9000000000000000000, max_indx = 0;

	for (auto k : mean)
	{
		s[ar[0]] = k.first;
		for (int64_t k = 1; k < s.size(); ++k)
		{
			if ((int)s[k] >= (int)s[max_indx])
			{
				max_indx = k;
			}
		}
		for (int64_t k = 0; k < s.size(); ++k)
		{
			if (k >= max_indx || (s[k] == s[max_indx] && k < max_indx))
			{
				res += mean[s[k]];
			}
			else
			{
				res -= mean[s[k]];
			}
		}
		if (res > max_elem)
		{
			max_elem = res;
			s_ans = s;
		}
		res = 0;
	}
	ans.max_elem = max_elem; ans.s = s_ans;

	return ans;
}

answer fync_2(map <char, int64_t> mean, vector <int64_t> ar, string& s)
{
	answer ans;
	char now_sym;
	string s_ans;
	int64_t count = 0, res = 0, max_elem = -9000000000000000000, max_indx = 0;

	for (auto k : mean)
	{
		s[ar[0]] = k.first;
		for (auto l : mean)
		{
			s[ar[1]] = l.first;
			for (int64_t k = 1; k < s.size(); ++k)
			{
				if ((int)s[k] >= (int)s[max_indx])
				{
					max_indx = k;
				}
			}
			for (int64_t k = 0; k < s.size(); ++k)
			{
				if (k >= max_indx || (s[k] == s[max_indx] && k < max_indx))
				{
					res += mean[s[k]];
				}
				else
				{
					res -= mean[s[k]];
				}
			}
			if (res > max_elem)
			{
				max_elem = res;
				s_ans = s;
			}
			res = 0;
		}
	}
	ans.max_elem = max_elem; ans.s = s_ans;

	return ans;
}

answer fync_3(map <char, int64_t> mean, vector <int64_t> ar, string& s)
{
	answer ans;
	char now_sym;
	string s_ans;
	int64_t count = 0, res = 0, max_elem = -9000000000000000000, max_indx = 0;
	
	for (auto k : mean)
	{
		s[ar[0]] = k.first;
		for (auto l : mean)
		{
			s[ar[1]] = l.first;
			for (auto i : mean)
			{
				s[ar[2]] = i.first;
				for (int64_t k = 1; k < s.size(); ++k)
				{
					if ((int)s[k] >= (int)s[max_indx])
					{
						max_indx = k;
					}
				}
				for (int64_t k = 0; k < s.size(); ++k)
				{
					if (k >= max_indx || (s[k] == s[max_indx] && k < max_indx))
					{
						res += mean[s[k]];
					}
					else
					{
						res -= mean[s[k]];
					}
				}
				if (res > max_elem)
				{
					max_elem = res;
					s_ans = s;
				}
				res = 0;
			}
		}
	}
	ans.max_elem = max_elem; ans.s = s_ans;

	return ans;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	int64_t t, count = 0, num = 1;
	string s;
	vector <int64_t> ar = { -1,-1,-1 };
	answer ans;
	map <char, int64_t> mean;
	for (int64_t k = 65; k <= 90; ++k)
	{
		mean[(char)k] = num;
		k % 2 == 1 ? num *= 5 : num *= 2;
	}
	//for (auto k : mean)
	//{
	//	cout << k.first << ": " << k.second << '\n';
	//}
	cin >> t;
	for (int64_t k = 0; k < t; ++k)
	{
		cin >> s;
		for (uint64_t l = 0; l < s.size(); ++l)
		{
			if (s[l] == '?' && count < 3)
			{
				ar[count] = l;
				++count;
			}
		}
		if (ar[0] < 0)
		{
			ans = fync_0(mean, ar, s);
			cout << ans.max_elem << '\n' << ans.s << '\n';
		}
		else if (ar[1] < 0)
		{
			ans = fync_1(mean, ar, s);
			cout << ans.max_elem << '\n' << ans.s << '\n';
		}
		else if (ar[2] < 0)
		{
			ans = fync_2(mean, ar, s);
			cout << ans.max_elem << '\n' << ans.s << '\n';
		}
		else if (ar[2] >= 0)
		{
			if (s[0] == '?' && s[1] == '?' && s[2] == '?' && s[3] == '?')
			{
				cout << 20000000000000 << '\n' << "ZZZZ" << '\n';
			}
			else
			{
				ans = fync_3(mean, ar, s);
				cout << ans.max_elem << '\n' << ans.s << '\n';
			}
		}
		else // test
		{
			cout << 20000000000000 << '\n' << "ZZZZ" << '\n';
		}
		count = 0;
		ar = { -1,-1,-1 };
	}

	return 0;
}