#include <iostream>
#include <vector>
#include <map>
#include <string>
#include <algorithm>
using namespace std;



vector <int64_t> max_elem_right(string s)
{
	vector <int64_t> st;
	vector <int64_t> ans(s.size(),-1);
	for (int64_t k = s.size() - 1; k > -1; --k)
	{
		if (st.empty())
		{
			st.push_back(k);
		}
		else if ((int)s[st.front()] > (int)s[k])
		{
			ans[k] = st.back();
		}
		else
		{
			while (int(s[st.front()]) <= (int)s[k])
			{
				st.pop_back();
				if (st.empty())
				{
					break;
				}
			}
			st.push_back(k);
		}
	}
	return ans;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	int64_t t, max_indx, res = 0, num = 1;
	vector <int64_t> mean(91,0);
	vector <int64_t> ar;
	for (int64_t k = 65; k <= 90; ++k)
	{
		mean[k] = num;
		if (k % 2 == 1)
		{
			num *= 5;
		}
		else
		{
			num *= 2;
		}
	}
	string s;

	cin >> t;
	for (int64_t k = 0; k < t; ++k)
	{
		cin >> s;
		ar = max_elem_right(s);
		for (int64_t k = 0; k < ar.size(); ++k)
		{
			if (ar[k] < 0)
			{
				res += mean[(int)s[k]];
			}
			else
			{
				res -= mean[(int)s[k]];
			}
		}
		cout << res << '\n' << s << '\n';
		res = 0;
	}


	return 0;
}