#include <bits/stdc++.h>
using namespace std;

const int INF = 1e9 + 100;
vector<vector<pair<int, int>>> g;
vector<int> mn, mx;

void dfs(int u, int p, int _mn, int _mx) {
    mn[u] = _mn;
    mx[u] = _mx;
    for (auto to: g[u]) {
        if (to.first != p)
            dfs(to.first, u, min(_mn, to.second), max(_mx, to.second));
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    g.resize(n);
    mn.resize(n);
    mx.resize(n);
    bool ch = true;
    for (int i = 0; i < m; ++i) {
        int u, v, t;
        cin >> u >> v >> t;
        --u;
        --v;
        g[u].emplace_back(v, t);
        g[v].emplace_back(u, t);
        if (abs(u - v) != 1)
            ch = false;
    }
    if (ch) {
        mn[0] = INF;
        mx[0] = 0;
        for (int i = 0; i < n - 1; ++i) {
            int minim = INF;
            for (auto to: g[i]) {
                if (to.first == i + 1)
                    minim = min(minim, to.second);
            }
            mn[i + 1] = min(mn[i], minim);
            mx[i + 1] = max(mx[i], minim);
        }
        for (int i = 1; i < n; ++i) {
            int ans = INF * 2;
            for (int j = i; j < n; ++j)
                ans = min(ans, mn[j] + mx[j]);
            cout << ans << '\n';
        }
    }
    else if (m == n - 1) {
        dfs(0, -1, 1e9 + 100, -1);
        for (int i = 1; i < n; ++i)
            cout << mn[i] + mx[i] << '\n';
    }
    else {
        vector<int> dist(n, INF);
        dist[0] = 0;
        set<pair<int, int>> s;
        s.emplace(0, 0);
        while (!s.empty()) {
            int u = s.begin()->second;
            s.erase(s.begin());
            for (auto to: g[u]) {
                if (max(dist[u], to.second) < dist[to.first]) {
                    auto it = s.find({dist[to.first], to.first});
                    if (it != s.end())
                        s.erase(it);
                    dist[to.first] = max(dist[u], to.second);
                    s.emplace(dist[to.first], to.first);
                }
            }
        }
        for (int i = 1; i < n; ++i)
            cout << dist[i] << '\n';
    }
}
