#include <bits/stdc++.h> 

#define pb push_back

#define pii pair<int, int>

#define ff first 
#define ss second 

#define int long long

#define all(x) (x).begin(), (x).end()    

using namespace std; 

typedef long long ll; 

const int maxn = 4000 + 7; 
const ll inf = 8e18; 
int n, m; 
vector<int> gr[maxn]; 
int used[maxn]; 
map<pii, int> Edge;
int dp[maxn][3]; 
int dif[maxn][maxn]; 
int PR[maxn][maxn]; 

struct match {
    int u, v; 
    int u1, v1; 
}; 

vector<int> to[maxn]; 

bool get(vector<vector<int> > add, int want) {
    int sumL = 0; 
    int sz = add.size();
    for (int i = 0; i < sz; ++i) {
        sumL += add[i][0]; 
    }    
    if (sumL > want) return false;
    int cntOne = 0; 
    int cntTwo = 0; 
    for (int i = 0; i < sz; ++i) {
        for (int j = 1; j < (int)add[i].size(); ++j) {
            add[i][j] -= add[i][0]; 
        }                    
        if ((int)add[i].size() == 3) {
            cntOne += 2; 
        } else if ((int)add[i].size() == 2) {
            if (add[i][1] == 1) {
                ++cntOne; 
            } else {
                ++cntTwo; 
            }
        }
    }
    if (sumL + cntOne >= want) return true; 
    sumL += cntOne;  
    sumL += cntTwo * 2; 
    if (sumL < want) return false; 
    sumL -= cntTwo * 2;
    if (sumL % 2 != want % 2) {
        --sumL; 
        if (cntOne == 0) return false; 
    }
    int need = (want - sumL) / 2; 
    if (need <= cntTwo) return true; 
    return false; 
}

void dfs(int u, int pr) {
//    cout << u << '\n'; 
    used[u] = 1; 
    int up1 = 0; 
    int down1 = 0; 
    if (Edge.find({u, pr}) != Edge.end()) {
        ++up1; 
    }
    if (Edge.find({pr, u}) != Edge.end()) {
        ++down1; 
    }               
    vector<int> vertex;
    for (auto v : gr[u]) {
        if (!used[v]) {
            to[u].pb(v); 
            vertex.pb(v);
            dfs(v, u); 
        }
    }
    vector<vector<int> > add; 
    for (auto v : vertex) {
        vector<int> pt;
        if (dp[v][2]) {
            pt.pb(-1); 
        } 
        for (int i = 0; i < 2; ++i) {
            if (dp[v][i]) {
                pt.pb(i); 
            } 
        }
        if (pt.empty()) {
            cout << "No\n"; 
            exit(0); 
        }
        add.pb(pt);         
    }
    if (get(add, up1 - down1)) {
        dp[u][0] = 1; 
    }

    if (up1 && get(add, -down1)) {
        dp[u][1] = 1; 
    }

    if (down1 && get(add, up1)) {
        dp[u][2] = 1; 
    } 
}
 
vector<match> res;

vector<int> get(int sz, int shift) {
    vector<int> xx; 
    while (sz) {
        xx.pb(PR[sz][shift]); 
        --sz; 
        if (xx.back() == 1) {
            --shift; 
        }
        if (xx.back() == 2) {
            ++shift; 
        }
    } 
    reverse(all(xx)); 
    return xx; 
}

void calc(int u, int pr, int want) {
//    cout << u << " " << want << endl; 
    used[u] = 1; 
    int up1 = 0; 
    int down1 = 0; 
    if (Edge.find({u, pr}) != Edge.end()) {
        ++up1; 
    }
    if (Edge.find({pr, u}) != Edge.end()) {
        ++down1; 
    }               
    vector<int> vertex = to[u];
    int sz = vertex.size(); 
    int shift = sz + 2; 
    for (int i = 0; i < sz + 1; ++i) {
        for (int j = 0; j < shift * 2; ++j) {
            dif[i][j] = 0; 
        }      
    }

    dif[0][shift] = 1; 
    for (int i = 0; i < sz; ++i) {
        int x = vertex[i]; 
        for (int sum = 0; sum < 2 * shift; ++sum) {
            if (!dif[i][sum]) continue; 
            if (dp[x][0]) {
                dif[i + 1][sum] = 1;            
                PR[i + 1][sum] = 0; 
            } 
            if (dp[x][1] && sum + 1 < 2 * shift) {
                dif[i + 1][sum + 1] = 1;
                PR[i + 1][sum + 1] = 1; 
            } 
            if (dp[x][2] && sum - 1 >= 0) {
                dif[i + 1][sum - 1] = 1;
                PR[i + 1][sum - 1] = 2; 
            }
        }
    }    
    if (want == 0) {
        vector<int> p = get(sz, shift + up1 - down1);
        vector<int> L; 
        vector<int> R; 
        for (int i = 0; i < sz; ++i) {
            if (p[i] == 1) {
                L.pb(vertex[i]); 
            }                
            if (p[i] == 2) {
                R.pb(vertex[i]); 
            }
        }
        if (up1) {
            R.pb(pr);
        }
        if (down1) {
            L.pb(pr); 
        }
        for (int i = 0; i < (int)L.size(); ++i) {
            res.pb({L[i], u, u, R[i]}); 
        }
        /*
        if (u == 1) {
            for (auto v : L) cout << v << " "; 
            cout << '\n'; 
            for (auto v : R) cout << v << " "; 
            cout << '\n'; 
            cout << sz << " "; 
            exit(0); 
        }
        */     
        for (int i = 0; i < sz; ++i) {
            calc(vertex[i], u, p[i]); 
        }
    }        
    if (want == 1) {
//        cout << u << " " << 1 << "\n"; 
        vector<int> p = get(sz, shift - down1); 
        vector<int> L; 
        vector<int> R; 
        for (int i = 0; i < sz; ++i) {
            if (p[i] == 1) {
                L.pb(vertex[i]); 
            }                
            if (p[i] == 2) {
                R.pb(vertex[i]); 
            }
        }
        if (down1) {
            L.pb(pr); 
        }
        for (int i = 0; i < (int)R.size(); ++i) {
            res.pb({L[i], u, u, R[i]}); 
        }
        for (int i = 0; i < sz; ++i) {
            calc(vertex[i], u, p[i]); 
        }
    }
    if (want == 2) {
//        cout << u << " " << 2 << '\n'; 
        vector<int> p = get(sz, shift + up1); 
        vector<int> L; 
        vector<int> R; 
        for (int i = 0; i < sz; ++i) {
            if (p[i] == 1) {
                L.pb(vertex[i]); 
            }                
            if (p[i] == 2) {
                R.pb(vertex[i]); 
            }
        }
        if (up1) {
            R.pb(pr); 
        }
        for (int i = 0; i < (int)R.size(); ++i) {
            res.pb({L[i], u, u, R[i]}); 
        }
        for (int i = 0; i < sz; ++i) {
            calc(vertex[i], u, p[i]); 
        }
    }
}

void solve() {
    cin >> n >> m; 
    vector<pii> e;  
    for (int i = 0; i < m; ++i) {
        int u, v; cin >> u >> v, --u, --v;        
        Edge[{u, v}] = 1; 
        gr[u].pb(v); 
        gr[v].pb(u); 
    }
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            dfs(i, i); 
            if (!dp[i][0]) {
                cout << "No\n"; 
                return; 
            }
        }
    }
    cout << "Yes\n"; 
    for (int i = 0; i < n; ++i) {
        used[i] = 0; 
    }
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            calc(i, i, 0); 
        }        
    }
    for (auto v : res) {
        cout << v.u + 1 << " " << v.v + 1 << " " << v.u1 + 1 << " " << v.v1 + 1 << '\n'; 
    }
    cout << '\n'; 
}                                        

signed main() {
#ifdef LOCAL
  freopen("TASK.in", "r", stdin); 
  freopen("TASK.out", "w", stdout);
#endif

    ios_base::sync_with_stdio(false); 
    cin.tie(0);

    int t = 1; 
    for (int i = 0; i < t; ++i) {
        solve(); 
    }
    return 0; 
}