#include <bits/stdc++.h>

using namespace std;
#define int long long
#define MAXN 300005
#define MAX 1000000000000ll

struct edge {
    int to, t, ind;
    bool br = 0;

    edge(int to, int t, int ind = -1) : to(to), t(t), ind(ind) {}
};

vector<edge> g[MAXN];
int n;
int m;
int ans[MAXN];
bool used[MAXN];
int fup[MAXN];
int d[MAXN];
int c[MAXN];
int counter = 0;

void dfs(int v, int p, int dep) {
    used[v] = 1;
    fup[v] = d[v] = dep;
    for (auto &u:g[v]) {
        if (p == u.ind) {
            continue;
        }
        if (used[u.to]) {
            fup[v] = min(fup[v], d[u.to]);
        } else {
            dfs(u.to, u.ind, dep + 1);
            if (fup[u.to] == d[u.to]) {
                u.br = 1;
            }
            fup[v] = min(fup[v], fup[u.to]);
        }
    }
}

void dfs2(int v, int p, int col) {
    c[v] = col;
    for (auto u:g[v]) {
        if (u.ind == p || c[u.to] != -1) {
            continue;
        }
        if (u.br) {
            dfs2(u.to, u.ind, ++counter);
        } else {
            dfs2(u.to, u.ind, col);
        }
    }
}

int val[MAXN];
vector<edge> gc[MAXN];

void dfs3(int v, int mn) {
    val[v] = mn = min(mn, val[v]);
    used[v] = 1;
    for (auto e:gc[v]) {
        if (!used[e.to]) {
            dfs3(e.to, min(mn, e.t));
        }
    }
}

void run(int fix) {

    memset(used, 0, sizeof(used));
    dfs(0, -1, 0);
    memset(c, 255, sizeof(c));
    counter = 0;
    dfs2(0, -1, 0);
    counter++;
    for (int i = 0; i < counter; ++i) {
        val[i] = MAX;
    }
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            continue;
        }
        for (auto e:g[i]) {
            if (c[i] != c[e.to]) {
                gc[c[i]].push_back({c[e.to], e.t});
                gc[c[e.to]].push_back({c[i], e.t});
            } else {
                val[c[i]] = min(val[c[i]], e.t);
            }
        }
    }
    memset(used, 0, sizeof(used));
    dfs3(0, MAX);
    for (int i = 0; i < n; ++i) {
        ans[i] = val[c[i]] + fix;
    }
}

void solve() {
    run(1e9);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        int u, v, t;
        cin >> u >> v >> t;
        u--;
        v--;
        g[u].emplace_back(v, t, i);
        g[v].emplace_back(u, t, i);
    }
    solve();
    for (int i = 1; i < n; ++i) {
        cout << ans[i] << "\n";
    }
}//
// Created by roi on 09.04.2021.
//

