#include <iostream>
#include <vector>
#include <tuple>
#include <unordered_set>

using namespace std;

#pragma GCC optimize("Ofast")

int main() {
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int n, m;
    cin >> n >> m;
    vector<unordered_set<int>> graph(n);
    vector<unordered_set<int>> tgraph(n);
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        u--; v--;
        graph[u].insert(v);
        tgraph[v].insert(u);
    }
    vector<pair<pair<int, int>, pair<int, int>>> ans;

    while (ans.size() != m / 2) {
        bool good = false;
        for (int u = 0; u < n; u++) {
            if (tgraph[u].empty() && graph[u].size() == 1) {
                int v = *(graph[u].begin());
                if (graph[v].size() == 1) {
                    int w = *(graph[v].begin());
                    ans.push_back({{u, v}, {v, w}});
                    graph[u].erase(v);
                    graph[v].erase(w);
                    tgraph[v].erase(u);
                    tgraph[w].erase(v);
                    good = true;
                    break;
                }
            }
        }
        if (!good) {
            for (int w = 0; w < n; w++) {
                if (graph[w].empty() && tgraph[w].size() == 1) {
                    int v = *(tgraph[w].begin());
                    if (tgraph[v].size() == 1) {
                        int u = *(tgraph[v].begin());
                        ans.push_back({{u, v}, {v, w}});
                        graph[u].erase(v);
                        graph[v].erase(w);
                        tgraph[v].erase(u);
                        tgraph[w].erase(v);
                        good = true;
                        break;
                    }
                }
            }
            if (!good) {
                for (int u = 0; u < n; u++) {
                    if (graph[u].size() == 1) {
                        int v = *(graph[u].begin());
                        if (tgraph[v].size() == 1 && graph[v].count(u)) {
                            int w = u;
                            ans.push_back({{u, v}, {v, w}});
                            graph[u].erase(v);
                            graph[v].erase(w);
                            tgraph[v].erase(u);
                            tgraph[w].erase(v);
                            good = true;
                            break;
                        }
                    }
                }

                if (!good) {
                    for (int u = 0; u < n; u++) {
                        if (!graph[u].empty()) {
                            for (auto& v0 : graph[u]) {
                                int v = v0;
                                if (!graph[v].empty()) {
                                    int w = *(graph[v].begin());
                                    ans.push_back({{u, v}, {v, w}});
                                    graph[u].erase(v);
                                    graph[v].erase(w);
                                    tgraph[v].erase(u);
                                    tgraph[w].erase(v);
                                    good = true;
                                    break;
                                }
                            }
                            if (good) {
                                break;
                            }
                        }

                    }
                    if (!good) {
                        cout << "No";
                        return 0;
                    }
                }
            }
        }
    }
    cout << "Yes\n";
    for (auto& i : ans) {
        cout << i.first.first+1 << " " << i.first.second+1 << " " << i.second.first+1 << " " << i.second.second+1 << "\n";
    }
/*
5 6
1 2
2 1
1 5
2 3
2 4
4 2
*/
    return 0;
}

