#include <iostream>
#include <vector>
#include <set>
#include <tuple>

using namespace std;

#pragma GCC optimize("Ofast")
//#pragma GCC target("avx,avx2,sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,mmx,abm")

int main() {
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int n, q;
    cin >> n >> q;
    pair<int, int> a[n];
    for (auto& i : a) {
        cin >> i.first >> i.second;
    }
    while (q--) {
        int l, r;
        cin >> l >> r;
        l--; r--;
        int ll = a[0].first;
        if (l) {
            ll = a[l - 1].first;
        }
        int rr = a[n - 1].first;
        if (r + 1 < n) {
            rr = a[r + 1].first;
        }
        if (l == r) {
            if (a[l].first + a[l].second <= rr || a[l].first - a[l].second >= ll) {
                cout << "1\n";
            }
            else {
                cout << "0\n";
            }
            continue;
        }

        set<pair<int, int>> can;
        for (int i = l; i <= r; i++) {
            can.insert({a[i].first, i});
        }

        pair<int, int> dist[r - l + 1];
        set<pair<int, int>> s;
        dist[0] = {a[l].first - ll, a[l + 1].first - a[l].first};
        dist[r - l] = {a[r].first - a[r - 1].first, rr - a[r].first};
        s.insert({a[l].second - max(dist[0].first, dist[0].second), l});
        s.insert({a[r].second - max(dist[r - l].first, dist[r - l].second), r});
        for (int i = l + 1; i <= r - 1; i++) {
            dist[i - l] = {a[i].first - a[i - 1].first, a[i + 1].first - a[i].first};
            s.insert({a[i].second - max(dist[i - l].first, dist[i - l].second), i});
        }
        while (!s.empty()) {
            int d, i;
            tie(d, i) = *s.begin();
            if (d > 0) {
                break;
            }
            s.erase(s.begin());
            auto it = can.find({a[i].first, i});

            int i_l, x_l, h_l, i_r, x_r, h_r;
            i_l = x_l = h_l = i_r = x_r = h_r = -1;

            auto it_r = it;
            it_r++;
            if (it_r != can.end()) {
                tie(x_r, i_r) = *it_r;
                h_r = a[i_r].second;
            }
            auto it_l = it;
            if (it != can.begin()) {
                it_l--;
                tie(x_l, i_l) = *it_l;
                h_l = a[i_l].second;
            }

            if (i_l != -1) {
                s.erase({h_l - max(dist[i_l - l].first, dist[i_l - l].second), i_l});
                dist[i_l - l].second = rr - x_l;
                if (i_r != -1) {
                    dist[i_l - l].second = x_r - x_l;
                }
                s.insert({h_l - max(dist[i_l - l].first, dist[i_l - l].second), i_l});
            }
            if (i_r != -1) {
                s.erase({h_r - max(dist[i_r - l].first, dist[i_r - l].second), i_r});
                dist[i_r - l].first = x_r - ll;
                if (i_l != -1) {
                    dist[i_r - l].first = x_r - x_l;
                }
                s.insert({h_r - max(dist[i_r - l].first, dist[i_r - l].second), i_r});
            }
            can.erase(it);
        }
        cout << r - l + 1 - s.size() << '\n';
    }
/*
3 3
1 3
3 1
4 2
1 1
2 3
1 3
*/
    return 0;
}
