#include <bits/stdc++.h>
 
using namespace std;
 
#define all(a) a.begin(), a.end()
#define int long long
#define size(a) (int) a.size()
#define fi first
#define se second
#define pii pair<int, int>
#define mp make_pair
#define chkmin(a, b) a = min(a, b)
const int inf = 2e9 + 8;
const int max_n = 5e5 + 3;
int n, m;

vector<pii> gr[max_n];
map<int, int> dp[max_n];

void solve() {
	cin >> n >> m;
	for(int i = 0;i < m;i++) {
		int v1, v2, c;
		cin >> v1 >> v2 >> c;
		gr[--v1].emplace_back(--v2, c);
		gr[v2].emplace_back(v1, c);
	}

	auto comp = [&](pii v1, pii v2) {
		int t1 = dp[v1.fi][v1.se], t2 = dp[v2.fi][v2.se];
		if (t1 != t2) return t1 < t2;
		return v1 < v2;
	};
	set<pii, decltype(comp)> so(comp);
	dp[0][inf] = 0;
	so.emplace(mp(0, inf));

	while(size(so)) {
		pii v = *so.begin();
		so.erase(so.begin());

		for(pii to : gr[v.fi]) {
			int nwv = max(dp[v.fi][v.se], to.se);
			int nw = min(v.se, to.se);
			if (to.fi == 6) cout << nw << " " << nwv << endl;
			if (!dp[to.fi].count(nw) || dp[to.fi][nw] > nwv) {
				so.erase(mp(to.fi, nw));
				dp[to.fi][nw] = nwv;
				so.emplace(mp(to.fi, nw));
			}
		}
	}
	cout << dp[0][2] << endl;
	
	for(int i = 1;i < n;i++) {
		int res = inf;
		for(auto j : dp[i]) {
			chkmin(res, j.fi + j.se);
		}
		cout << res << endl;
	}
}


signed main() {
    cin.tie(0), cout.tie(0), ios_base::sync_with_stdio(0);
 
    #ifdef local
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    #endif
 
    solve();
}