#include <bits/stdc++.h>

#define int long long
#define pb push_back
#define ld long double

using namespace std;

const int N = 2e5 + 10;
vector<int> g[N];
map<pair<int, int>, int> mp;
vector<bool> used(N);
vector<pair<pair<int, int>, pair<int,int>>> ans;

bool solve(int n, int m, vector<pair<int,int>> v){
    for (int i = 0; i < (1 << m); i++){
        vector<set<pair<int,int>>> in(n + 1), out(n + 1);
        for (int j = 0; j < m; j++){
            if (i & (1 << j)){
                in[v[j].second].insert({v[j].first, v[j].second});
            }
            else{
                out[v[j].first].insert({v[j].first, v[j].second});
            }
        }
        bool x = 0;
        for (int j = 1; j <= n; j++){
            if (in[j].size() != out[j].size()){
                x = 1;
                break;
            }
        }
        if (!x){
            return 1;
        }
    }
    return 0;
}

void dfs(int v, int p){
    used[v] = 1;
    set<pair<int,int>> out, in;
    for (auto to : g[v]){
        if (!used[to]){
            dfs(to, v);
            if (mp[{v, to}]){
                out.insert({v, to});
            }
            if (mp[{to, v}]){
                in.insert({to, v});
            }
        }
    }
    while(in.size() > 0 && out.size() > 0){
        pair<int,int> p = *in.begin(), pp = *out.begin();
        ans.pb({p, pp});
        in.erase(p);
        out.erase(pp);
    }
    if (in.size() > 1 || out.size() > 1){
        return;
    }
    if (in.size() > 0 || out.size() > 0){
        if (p == -1){
            return;
        }
        if (in.size() > 0){
            if (mp[{v, p}]){
                mp[{v, p}] = 0;
                ans.pb({*in.begin(), {v, p}});
            }
        }
        if (out.size() > 0){
            if (mp[{p, v}]){
                mp[{p, v}] = 0;
                ans.pb({{p, v}, *out.begin()});
            }
        }
    }
}

int32_t main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    vector<pair<int,int>> v(m);
    for (int i = 0; i < m; i++){
        cin >> v[i].first >> v[i].second;
        mp[{v[i].first, v[i].second}] = 1;
        g[v[i].first].pb(v[i].second);
        g[v[i].second].pb(v[i].first);
    }
    for (int i = 1; i <= n; i++){
        if (!used[i]){
            dfs(i, -1);
        }
    }
    if (ans.size() != m / 2){
        cout << "No\n";
    }
    else{
        cout << "Yes\n";
        for (auto to : ans){
            cout << to.first.first << ' ' << to.first.second << ' ' << to.second.first << ' ' << to.second.second << "\n";
        }
    }
    return 0;
}
