#include <bits/stdc++.h>

#define pb push_back
#define ld long double

using namespace std;

const int K = 320;
const int N = 5e5 + 10;
int x[N], h[N], n, L, R;

set<int> st, del;

bool cmp(const pair<int, pair<int,int>> &a, const pair<int, pair<int,int>> &b){
    if (a.second.first / K != b.second.first / K){
        return (a.second.first / K) < (b.second.first / K);
    }
    else{
        if ((a.second.first / K) & 1){
            return a.second.second < b.second.second;
        }
        else{
            return b.second.second < a.second.second;
        }
    }
}

bool func(int v){
    bool f = 0;
     if (st.upper_bound(v) != st.end()){
        int ii = v, j = *st.upper_bound(v);
        if (!(x[j] - h[j] < x[ii] && x[ii] < x[j])){
            del.insert(j);
        }
        if (!(x[ii] < x[j] && x[j] < x[ii] + h[ii])){
            del.insert(ii);
            f = 1;
        }
    }
    if (v != *st.begin()){
        auto it = st.lower_bound(v);
        it--;
        int ii = *it, j = v;
        if (!(x[j] - h[j] < x[ii] && x[ii] < x[j])){
            del.insert(j);
            f = 1;
        }
        if (!(x[ii] < x[j] && x[j] < x[ii] + h[ii])){
            del.insert(ii);
        }
    }
    return f;
}

void clean(int mn, int mx){
    vector<int> a;
    for (auto to : st){
        a.pb(to);
    }
    for (auto to : a){
        if (!func(to)){
            del.erase(to);
        }
    }
    int ii = *st.begin();
    if (!(x[ii] - h[ii] < mn && mn < x[ii]) && ii != 0){
        del.insert(ii);
    }
    ii = *st.rbegin();
    if (!(x[ii] < mx && mx < x[ii] + h[ii]) && ii != n - 1){
        del.insert(ii);
    }
    while(del.size() > 0){
        auto v = *del.begin();
        del.erase(v);
        st.erase(v);
        if (st.size() == 0) break;
        int ii = *st.begin();
        if (!(x[ii] - h[ii] < mn && mn < x[ii]) && ii != 0){
            del.insert(ii);
        }
        ii = *st.rbegin();
        if (!(x[ii] < mx && mx < x[ii] + h[ii]) && ii != n - 1){
            del.insert(ii);
        }
        auto it = st.lower_bound(v);
        if (st.lower_bound(v) != st.end() && it != st.begin()){
            it--;
            int ii = *it, j = *st.lower_bound(v);
            if (!(x[j] - h[j] < x[ii] && x[ii] < x[j])){
                del.insert(j);
            }
            if (!(x[ii] < x[j] && x[j] < x[ii] + h[ii])){
                del.insert(ii);
            }
        }
    }
}

void movee(int l, int r){
    while(l < L){
        L--;
        st.insert(L);
        del.erase(L);
        if (st.upper_bound(L) != st.end()){
            del.erase(*st.upper_bound(L));
            func(*st.upper_bound(L));
        }
        auto it = st.lower_bound(L);
        if (it != st.begin()){
            it--;
            del.erase(*it);
            func(*it);
        }

        func(L);
    }
    while(L < l){
        st.erase(L);
        del.erase(L);
        if (st.upper_bound(L) != st.end()){
            del.erase(*st.upper_bound(L));
            func(*st.upper_bound(L));
        }
        auto it = st.lower_bound(L);
        if (it != st.begin()){
            it--;
            del.erase(*it);
            func(*it);
        }
        L++;
    }
    while(R < r){
        R++;
        st.insert(R);
        del.erase(R);
        if (st.upper_bound(R) != st.end()){
            del.erase(*st.upper_bound(R));
            func(*st.upper_bound(R));
        }
        auto it = st.lower_bound(R);
        if (it != st.begin()){
            it--;
            del.erase(*it);
            func(*it);
        }
        func(R);
    }
    while(r < R){
        st.erase(R);
        del.erase(R);
        if (st.upper_bound(R) != st.end()){
            del.erase(*st.upper_bound(R));
            func(*st.upper_bound(R));
        }
        auto it = st.lower_bound(R);
        if (it != st.begin()){
            it--;
            del.erase(*it);
            func(*it);
        }
        R--;
    }
}

int32_t main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int q;
    cin >> n >> q;
    vector<pair<int, pair<int,int>>> u(q);
    vector<int> ans(q);
    for (int i = 0; i < n; i++){
        cin >> x[i] >> h[i];
    }
    for (int i = 0; i < q; i++){
        cin >> u[i].second.first >> u[i].second.second;
        u[i].first = i;
    }
    sort(u.begin(), u.end(), cmp);
    L = u[0].second.first, R = u[0].second.second;
    L--, R--;
    for (int j = L; j <= R; j++){
        st.insert(j);
        func(j);
    }
    int mn = x[0], mx = x[n - 1];
    if (L > 0) mn = x[L - 1];
    if (R + 1 < n) mx = x[R + 1];
    clean(mn, mx);
    ans[u[0].first] = (R - L + 1) - st.size();
    for (int i = 1; i < q; i++){
        int l = u[i].second.first, r = u[i].second.second;
        int sum = (r - l + 1);
        l--, r--;
        for (int j = l; j <= r && j <= l + 200; j++){
            st.insert(j);
            func(j);
        }
        for (int j = r; j >= l && j >= r - 200; j--){
            st.insert(j);
            func(j);
        }
        movee(l, r);
        int mn = x[0], mx = x[n - 1];
        if (l > 0){
            mn = x[l - 1];
        }
        if (r + 1 < n){
            mx = x[r + 1];
        }
        if (st.size() == 0){
            ans[u[i].first] = (R - L + 1);
            continue;
        }
        clean(mn, mx);
        ans[u[i].first] = (R - L + 1) - st.size();
    }
    for (auto to : ans){
        cout << to << "\n";
    }
    return 0;
}
