#include <bits/stdc++.h>

#define pb push_back
#define ld long double

using namespace std;

const int K = 320;

bool cmp(const pair<int, pair<int,int>> &a, const pair<int, pair<int,int>> &b){
    if (a.second.first / K != b.second.first / K){
        return (a.second.first / K) < (b.second.first / K);
    }
    else{
        if ((a.second.first / K) & 1){
            return a.second.second < b.second.second;
        }
        else{
            return b.second.second < a.second.second;
        }
    }
}

int32_t main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, q;
    cin >> n >> q;
    vector<int> x(n), h(n);
    vector<pair<int, pair<int,int>>> u(q);
    for (int i = 0; i < n; i++){
        cin >> x[i] >> h[i];
    }
    for (int i = 0; i < q; i++){
        cin >> u[i].second.first >> u[i].second.second;
        u[i].first = i;
    }
    sort(u.begin(), u.end(), cmp);
    vector<int> ans(q);
    for (int i = 0; i < q; i++){
        int l = u[i].second.first, r = u[i].second.second;
        int sum = (r - l + 1);
        l--, r--;
        int mn = x[0], mx = x[n - 1];
        if (l > 0){
            mn = x[l - 1];
        }
        if (r + 1 < n){
            mx = x[r + 1];
        }
        set<int> st, del;
        for (int j = l; j <= r; j++){
            st.insert(j);
            if (j + 1 <= r){
                if (!(x[j] < x[j + 1] && x[j + 1] < x[j] + h[j])){
                    del.insert(j);
                }
            }
            if (j - 1 >= l){
                if (!(x[j] - h[j] < x[j - 1] && x[j - 1] < x[j])){
                    del.insert(j);
                }
            }
        }
        if (st.size() == 0){
            ans[u[i].first] = sum;
        }
        else{
            int ii = *st.begin();
            if (!(x[ii] - h[ii] < mn && mn < x[ii]) && ii != 0){
                del.insert(ii);
            }
            ii = *st.rbegin();
            if (!(x[ii] < mx && mx < x[ii] + h[ii]) && ii != n - 1){
                del.insert(ii);
            }
            while(del.size() > 0){
                auto v = *del.begin();
                del.erase(v);
                st.erase(v);
                if (st.size() == 0) break;
                int ii = *st.begin();
                if (!(x[ii] - h[ii] < mn && mn < x[ii]) && ii != 0){
                    del.insert(ii);
                }
                ii = *st.rbegin();
                if (!(x[ii] < mx && mx < x[ii] + h[ii]) && ii != n - 1){
                    del.insert(ii);
                }
                auto it = st.lower_bound(v);
                if (st.lower_bound(v) != st.end() && it != st.begin()){
                    it--;
                    int ii = *it, j = *st.lower_bound(v);
                    if (!(x[j] - h[j] < x[ii] && x[ii] < x[j])){
                        del.insert(j);
                    }
                    if (!(x[ii] < x[j] && x[j] < x[ii] + h[ii])){
                        del.insert(ii);
                    }
                }
            }
            ans[u[i].first] = sum - st.size();
        }
    }
    for (auto to : ans){
        cout << to << "\n";
    }
    return 0;
}
