#include <bits/stdc++.h>

#define pb push_back
#define ld long double
#define int long long

using namespace std;

const int N = 3e5 + 10;
vector<pair<int,int>> g[N], gr[N];
vector<int> u;
vector<int> ans(N);

void dfs(int v, int mn, int mx, int p){
    ans[v] = mn + mx;
    for (auto to : g[v]){
        if (to .first!= p){
            dfs(to.first, min(mn, to.second), max(mx, to.second), v);
        }
    }
}

int32_t main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; i++){
        int a, b, c;
        cin >> a >> b >> c;
        g[a].pb({b, c});
        g[b].pb({a, c});
    }
    dfs(1, 1e18, -1e18, -1);
    for (int i = 2; i <= n; i++){
        cout << ans[i] << endl;
    }
    return 0;
}
