#include <bits/stdc++.h>

using namespace std;

void solve();

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
#endif
    solve();
    return 0;
}

#define int long long

const int N = 3e5 + 100, K = 26, INF = 2e18;

int n, m, ans[N], d[N];
vector<pair<int, int>> a[N];
bool used[N];

void dfs(int v, int mn, int mx) {
    ans[v] = min(ans[v], mn + mx);
    used[v] = true;
    for (auto to : a[v]) {
        if (used[to.first]) continue;
        dfs(to.first, min(mn, to.second), max(mx, to.second));
    }
}

void solve() {
    cin >> n >> m;
    for (int i = 0; i < m; i++) {
        int f, s, c;
        cin >> f >> s >> c;
        f--, s--;
        a[f].push_back({s, c});
        a[s].push_back({f, c});
    }
    fill(d, d + n, INF);
    set<pair<int, int>> se;
    se.insert({0, 0});
    d[0] = 0;
    while (!se.empty()) {
        int v = se.begin()->second;
        se.erase(se.begin());
        for (auto to : a[v]) {
            if (max(d[v], to.second) < d[to.first]) {
                se.erase({d[to.first], to.first});
                d[to.first] = max(d[v], to.second);
                se.insert({d[to.first], to.first});
            }
        }
    }
    for (int i = 1; i < n; i++) {
        cout << d[i] << '\n';
    }
}
