#include <bits/stdc++.h>
typedef int ll;
using namespace std;
bool used[300005];
vector<vector<pair<ll,ll> > > g(300005);
map<ll,ll> edges;
ll k;
ll n,m;
ll ans=1e18;
void dfs(ll v,ll mn=1e18,ll mx=-1e18)
{
    if(mx>=ans)
        return;
    if(v==k)
    {
        //cout<<mn<<' '<<mx<<'\n';
        ans=min(ans,mn+mx);
    }
    for(auto to:g[v])
    {
        if(!used[to.first])
        {
            used[to.first]=1;
            dfs(to.second,min(mn,edges[to.first]),max(mx,edges[to.first]));
            if(mx>=ans)
                return;
            used[to.first]=0;
        }
    }
    return;
}
bool rl_used[3000005];
void rl_dfs(ll v,ll mn=1e18,ll mx=-1e18)
{
    rl_used[v]=1;
    if(v==k)
    {
        //cout<<mn<<' '<<mx<<'\n';
        ans=mn+mx;
        return;
    }
    for(auto x:g[v])
    {
        if(!rl_used[x.second])
        {
            rl_dfs(x.second,min(mn,edges[x.first]),max(mx,edges[x.first]));
        }
    }
    return;
}
bool cmp(pair<ll,ll> a,pair<ll,ll> b)
{
    return edges[a.first]<edges[b.first];
}
int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cin>>n>>m;
    for(int i=0;i<m;i++)
    {
        ll a,b,c;
        cin>>a>>b>>c;
        g[a].push_back({i,b});
        g[b].push_back({i,a});
        edges[i]=c;
    }
    for(int i=1;i<=n;i++)
    {
        sort(g[i].begin(),g[i].end(),cmp);
    }
    for(k=2;k<=n;k++)
    {
        fill(rl_used,rl_used+n+1,0);
        ans=1e18;
        rl_dfs(1);
        if(n>20)
        cout<<ans<<'\n';
        else
        {
            dfs(1);
            cout<<ans<<'\n';
        }
    }
    return 0;
}
