#include <bits/stdc++.h>

#define int long long

using namespace std;

void fastpow(int a, int n) {
    if (n == 0) return 1;
    if (n % 2 == 0) {
        int x = fastpow(a, n / 2);
        return x * x;
    } else {
        return fastpow(a, n - 1) * a;
    }
}

void solve() {
    string s;
    cin >> s;
    int n = s.size();
    int maxnum = 1e9;
    int ans = 0;
    for (int i = n - 1; i >= 0; --i) {
        int num = s[i] - 'A';
        if (num % 2 == 0) {
            if (num >= maxnum) {
                ans += fastpow(10, i / 2);
            } else {
                ans -= fastpow(10, i / 2);
            }
        } else {
            if (num >= maxnum) {
                ans += 5 * fastpow(10, i / 2);
            } else {
                ans -= 5 * fastpow(10, i / 2);
            }
        }
    }
    cout << s << '\n';
    cout << ans << '\n';
}

signed main() {
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}