#define _CRT_SECURE_NO_WARNINGS
#include<iostream>
#include<string>
#include<vector>
#include<cmath>
#include <algorithm>
using namespace std;
//#define int long long
vector<vector<int>> g;
vector<int> covered, used, match, cl;
bool trykuhn(int v) {
	used[v] = true;
	for (auto& x : g[v]) {
		if (match[x] == -1 || (!used[match[x]] && trykuhn(match[x]))) {
			match[x] = v;
			return true;
		}
	}
	return false;
}
void dfscl(int v) {
	for (auto& x : g[v]) {
		if (cl[x] != 0) continue;
		cl[x] = 3 - cl[v];
		dfscl(x);
	}
}
signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#endif
	int n, m;
	cin >> n >> m;
	vector<vector<int>> in(n), out(n);
	vector<pair<int, int>> edges;
	g.resize(m);
	for (int i = 0; i < m; ++i) {
		int q, w;
		cin >> q >> w;
		--q, --w;
		edges.push_back({ q ,w });
		in[w].push_back(i);
		out[q].push_back(i);
	}
	for (int i = 0; i < n; ++i) {
		for (auto& x : in[i]) {
			for (auto& y : out[i]) {
				g[x].push_back(y);
			}
		}
	}
	bool f = true;
	covered.assign(m, 0);
	match.assign(m, -1);
	cl.assign(m, 0);
	for (int i = 0; i < m; ++i) {
		if (cl[i] == 0) {
			cl[i] = 1;
			dfscl(i);
		}
	}
	vector<int> frst;
	for (int i = 0; i < m; ++i) if (cl[i] == 1) frst.push_back(i);
	while (f) {
		f = false;
		used.assign(m, false);
		vector<int> newf;
		for (auto& i : frst) {
			if (!covered[i] && trykuhn(i)) {
				covered[i] = true;
				f = true;
			}
			else newf.push_back(i);
		}
		frst = newf;
	}
	for (int i = 0; i < m; ++i) {
		if (!covered[i] && match[i] == -1) {
			cout << "No\n";
			return 0;
		}
	}
	cout << "Yes\n";
	for (int i = 0; i < m; ++i) {
		if (match[i] == -1) continue;
		cout << edges[i].first + 1 << ' ' << edges[i].second + 1 << ' ' << edges[match[i]].first + 1 << ' ' << edges[match[i]].second + 1 << '\n';
	}
	return 0;
}