#define _CRT_SECURE_NO_WARNINGS
#include<iostream>
#include<string>
#include<vector>
#include<cmath>
#include<queue>
#include<cassert>
#include <algorithm>
using namespace std;
//#define int long long
signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#endif
	int n, q;
	cin >> n >> q;
	vector<int> x(n + 1), h(n + 2);
	for (int i = 1; i <= n; ++i) {
		cin >> x[i] >> h[i];
	}
	x[0] = x[1];
	x.push_back(x[n]);
	for (int T = 0; T < q; ++T) {
		int l, r;
		cin >> l >> r;
		vector<int> next(n + 2, -1), prev(n + 2, -1), used(n + 2, 0);
		queue<int> q;
		for (int i = 1; i <= n; ++i) {
			prev[i] = i - 1;
			next[i] = i + 1;
		}
		prev[0] = -1;
		next[n + 1] = -1;
		for (int i = l; i <= r; ++i) {
			q.push(i);
		}
		int ans = 0;
		while (!q.empty()) {
			int v = q.front();
			q.pop();
			if (used[v]) continue;
			if (prev[v] != -1 && x[v] - h[v] >= x[prev[v]]) {
				next[prev[v]] = next[v];
				used[v] = true;
				if (next[v] != -1) prev[next[v]] = prev[v];
				if (prev[v] >= l && prev[v] <= r) q.push(prev[v]);
				if (next[v] >= l && next[v] <= r) q.push(next[v]);
				ans++;
			}
			else if (next[v] != -1 && x[v] + h[v] <= x[next[v]]) {
				next[prev[v]] = next[v];
				used[v] = true;
				if (next[v] != -1) prev[next[v]] = prev[v];
				if (prev[v] >= l && prev[v] <= r) q.push(prev[v]);
				if (next[v] >= l && next[v] <= r) q.push(next[v]);
				ans++;
			}
		}
		cout << ans << '\n';
	}
}