#include <bits/stdc++.h>

using namespace std;

void IO() {
#ifdef DIVAN
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
}

#define all(x) x.begin(), x.end()
#define sz(x) ((int)x.size())
#define forn(i, n) for (int i = 0; i < (n); ++i)
#define eb emplace_back
#define vi vector<int>
#define pi pair<int,int>
#define vpi vector<pi>

typedef long long ll;


const int INF = 2139062143;
const int nINF = -2139062144;
const ll INFL = 9187201950435737471;
const ll nINFL = -9187201950435737472;

const int MAXN = 3e5 + 15;

int ans[MAXN];
vpi adj[MAXN];
int cost[MAXN];
bool used[MAXN];
int tin[MAXN], fup[MAXN], timer;
bool isBridge[MAXN];

void DFS(int v, int p = -1) {
    tin[v] = fup[v] = timer++;
    used[v] = 1;
    for (auto [to, num] : adj[v]) {
        if (num == p) {continue;}
        if (used[to]) {
            fup[v] = min(fup[v], tin[to]);
        } else {
            DFS(to, num);
            fup[v] = min(fup[v], fup[to]);
            if (fup[to] > tin[v]) {
                isBridge[num] = 1;
            }
        }
    }
}

void Solve() {
    int n, m;
    cin >> n >> m;
    forn(i, m) {
        int a, b, c;
        cin >> a >> b >> c;
        adj[a].eb(b, i);
        adj[b].eb(a, i);
        all.eb(c, i);
    }
    DFS(1);
    for (int i = 2; i <= n; ++i) {
        cout << ans[i] + (int)1e9 << '\n';
    }
}

signed main() {
    IO();
    int t = 1;
//    cin >> t;
    while(t--) {
        Solve();
    }
    return 0;
}