#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <set>
using namespace std;
typedef long long ll;


ll n, m;
vector<vector<pair<ll, ll>>> g;
vector<bool> used;
vector<ll> ans1, ans2;
void dfs(ll u, ll p) {
	for (auto c : g[u]) {
		if (c.first == p) continue;
		ans1[c.first] = c.second;
		ans2[c.first] = c.second;
		if (p != -1) {
			ans1[c.first] = min(ans1[c.first], ans1[u]);
			ans2[c.first] = max(ans2[c.first], ans2[u]);
		}
		dfs(c.first, u);
	}
}
int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	cin >> n >> m;
	g.resize(n);
	ans1.resize(n, 1e18);
	ans2.resize(n, 0);


	for (int i = 0; i < m; i++) {
		ll a, b, t;
		cin >> a >> b >> t;
		a--;
		b--;
		g[a].push_back({ b,t });
		g[b].push_back({ a,t });
	}
	set<pair<ll,ll>> s;
	vector<ll> d(n, 1e18);
	s.insert({ 0,0 });
	d[0] = 0;
	used.resize(n, false);
	while (!s.empty()) {
		ll u = s.begin()->first;
		s.erase(s.begin());
		if (used[u]) continue;
		used[u] = true;
		for (auto c : g[u]) {
			if (!used[c.first]) {
				d[c.first] = min(d[c.first], max(c.second, d[u]));
				s.insert(make_pair(c.first, d[c.first]));
			}
		}
	}

	for (int i = 1; i < n; i++) {
		cout << d[i] << "\n";
	}

}