#include <bits/stdc++.h>
using namespace std;

#define int long long
#define s second
#define f first

vector <vector <int> > g;
vector <int> p;
int n;
vector <int> used;

int dfs(int v)
{
    used[v]=1;
    for (int u:g[v]){
        if (used[u]==1){
            continue;
        }
        if (p[u]==-1){
            p[u]=v;
            p[v]=u;
            return 1;
        }
        used[u]=1;
        if (dfs(p[u])==1){
            p[u]=v;
            p[v]=u;
            return 1;
        }
        used[u]=0;
    }
    return 0;
}

signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int m;
    cin >> n >> m;
    vector <vector <int> > gg(n);
    vector <pair <int,int> > rlist(m);
    for (int i=0; i<m; i++){
        int v,u;
        cin >> v >> u;
        v--;
        u--;
        rlist[i]={v,u};
        gg[v].push_back(i);
    }
    g.resize(m);

    for (int i=0; i<m; i++){
        int v=rlist[i].f;
        int u=rlist[i].s;
        for (int j:gg[u]){
            int w=rlist[j].s;
            g[i].push_back(j);
            g[j].push_back(i);
        }
    }

    n=m;
    p.resize(n,-1);
    int cnt=0;
    for (int i=0; i<n; i++){
        if (p[i]!=-1)continue;
        for (int j:g[i]){
            if (p[j]!=-1)continue;
            p[i]=j;
            p[j]=i;
            cnt+=2;
            break;
        }
    }
    for (int i=0; i<n; i++){
        if (p[i]!=-1)continue;
        used.assign(n,0);
        cnt+=2*dfs(i);
    }
    if (cnt!=n){
        cout << "No" << '\n';
        return 0;
    }
    cout << "Yes" << '\n';
    used.assign(n,0);
    for (int i=0; i<n; i++){
        if (used[i])continue;
        cout << rlist[i].f+1 << " " << rlist[i].s+1 << " " << rlist[p[i]].f+1 << " " << rlist[p[i]].s+1 << '\n';
        used[i]=1;
        used[p[i]]=1;
    }
}
/**
5 6
1 2
2 1
1 5
2 3
2 4
4 2
*/

