#include <algorithm>
#include <iostream>
#include <cstring>
#include <string>
#include <vector>
#include <set>
#include <map>
using namespace std;

typedef long long ll;
#define fastio ios::sync_with_stdio(false), cin.tie(0)
#define forn(i, n) for (int i = 0; i < (n); i++)
#define rforn(i, n) for (int i = (n) - 1; i >= 0; i--)
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

const int N = 10010;
int x[N], h[N];

int solve(int l, int r, int xl, int xr) {
	vector<pair<int, int>> v(r - l + 1);
	forn(i, r - l + 1) {
		v[i] = make_pair(x[l + i], h[l + i]);
	}
	v.push_back(make_pair(xr, 1e9));

	int ans = 0;
	vector<pair<int, int>> st;
	st.push_back(make_pair(xl, 1e9));
	forn(i, v.size()) {
		while (st.back().first + st.back().second <= v[i].first) {
			st.pop_back();
			ans++;
		}
		if (st.back().first <= v[i].first - v[i].second) {
			ans++;
		}
		else {
			st.push_back(v[i]);
		}
	}
	return ans;
}

int main() {
	fastio;
	int n, q;
	cin >> n >> q;
	forn(i, n) {
		cin >> x[i] >> h[i];
	}

	while (q--) {
		int l, r;
		cin >> l >> r;
		l--, r--;
		cout << solve(l, r, x[max(0, l - 1)], x[min(n - 1, r + 1)]) << '\n';
	}
	return 0;
}