#include <algorithm>
#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <map>
using namespace std;

typedef long long ll;
#define fastio ios::sync_with_stdio(false), cin.tie(0)
#define forn(i, n) for (int i = 0; i < (n); i++)
#define rforn(i, n) for (int i = (n) - 1; i >= 0; i--)
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

const int N1 = 300100;
vector<pair<int, int>> g[N1];

int d0[N1];
void dfs0(int v, int p = -1, int mn = 1e9, int mx = 0) {
	d0[v] = mn + mx;
	for (auto u : g[v]) {
		if (u.first == p) continue;
		dfs0(u.first, v, min(mn, u.second), max(mx, u.second));
	}
}

int d1[N1];

const int N2 = 20;
int dp[N2][1 << N2];

const int N3 = 2010;
int a[N3];
int b[N3];

int main() {
	fastio;
	int n, m;
	cin >> n >> m;
	map<pair<pair<int, int>, int>, int> id;
	vector<pair<pair<int, int>, int>> e;
	forn(i, m) {
		int a, b, t;
		cin >> a >> b >> t;
		a--, b--;
		g[a].push_back(make_pair(b, t));
		g[b].push_back(make_pair(a, t));
		id[make_pair(make_pair(a, b), t)] = i;
		id[make_pair(make_pair(b, a), t)] = i;
		e.push_back(make_pair(make_pair(a, b), t));
	}

	bool flag3 = true;
	for (auto i : e) {
		if (abs(i.first.first - i.first.second) != 1) {
			flag3 = false;
			break;
		}
	}

	if (flag3) {
		for (auto& i : a) i = 1e9 + 1;
		for (auto& i : b) i = 1e9 + 1;
		forn(i, n - 1) {
			for (auto j : g[i]) {
				if (j.first < i) continue;
				if (a[j.first] > j.second) {
					b[j.first] = a[j.first];
					a[j.first] = j.second;
				}
				else if (b[j.first] > j.second) {
					b[j.first] = j.second;
				}
			}
		}

		vector<int> ans(n, 2e9 + 2);

		int mn1 = 1e9, mx1 = 0;
		for (int i = 1; i < n; i++) {
			mn1 = min(mn1, a[i]);
			mx1 = max(mx1, a[i]);

			int mn2 = 1e9, mx2 = 0;
			for (int j = i; j >= 1; j--) {
				ans[j] = min(ans[j], (i == j ? mn1 + mx1 : min(mn1, mn2) + max(mx1, mx2)));
				if (b[j] > 1e9) break;
				mn2 = min(mn2, b[j]);
				mx2 = max(mx2, b[j]);
			}
		}
		for (int i = 1; i < n; i++) {
			cout << ans[i] << '\n';
		}
		return 0;
	}

	if (m == n - 1) {
		dfs0(0);
		for (int i = 1; i < n; i++) {
			cout << d0[i] << '\n';
		}
		return 0;
	}

	bool flag1 = true, flag2 = true;
	for (auto i : g[0]) {
		if (i.second != 0) flag1 = false;
		if (i.second != 1e9) flag2 = false;
	}

	if (flag1) {
		set<pair<int, int>> q;
		q.insert(make_pair(0, 0));
		forn(i, n) d1[i] = 1e9 + 1;
		d1[0] = 0;

		while (q.size()) {
			int v = q.begin()->second;
			q.erase(q.begin());
			for (auto u : g[v]) {
				if (d1[u.first] > max(d1[v], u.second)) {
					q.erase(make_pair(d1[u.first], u.first));
					d1[u.first] = max(d1[v], u.second);
					q.insert(make_pair(d1[u.first], u.first));
				}
			}
		}
		for (int i = 1; i < n; i++) {
			cout << d1[i] << '\n';
		}
		return 0;
	}

	if (n <= 20 && m <= 20) {
		for (auto& i : dp) {
			for (auto& j : i) {
				j = 2e9 + 1;
			}
		}
		set<pair<int, pair<int, int>>> q;
		q.insert(make_pair(0, make_pair(0, 0)));
		dp[0][0] = 0;
		while (q.size()) {
			auto v = q.begin()->second;
			q.erase(q.begin());
			int mn = 1e9, mx = 0;
			forn(i, m) {
				if (v.second >> i & 1) {
					mn = min(mn, e[i].second);
					mx = max(mx, e[i].second);
				}
			}
			for (auto u : g[v.first]) {
				int k = id[make_pair(make_pair(v.first, u.first), u.second)];
				if (v.second >> k & 1) continue;
				int curmn = min(mn, u.second);
				int curmx = max(mx, u.second);
				int s = (v.second ^ (1 << k));
				if (dp[u.first][s] > curmn + curmx) {
					q.erase(make_pair(dp[u.first][s], make_pair(u.first, s)));
					dp[u.first][s] = curmn + curmx;
					q.insert(make_pair(dp[u.first][s], make_pair(u.first, s)));
				}
			}
		}
		for (int i = 1; i < n; i++) {
			int ans = 2e9 + 1;
			forn(j, (1 << m)) {
				ans = min(ans, dp[i][j]);
			}
			cout << ans << '\n';
		}
		return 0;
	}
	return 0;
}