#include <bits/stdc++.h>

#define int long long
#define ll long long
#define all(v) v.begin(),  v.end()


using namespace std;

const int maxn = 3e5 + 10;


const int inf = 5 * 1e12 * maxn;

int dp[maxn][26];
int from[maxn][26];
char sym[maxn][26];


int vals[]{1, 5, 10, 50, 100, 500, 1000, 5000, 10000, 50000, 100000, 500000, 1000000, 5000000, 10000000, 50000000,
           100000000, 500000000, 1000000000, 5000000000, 10000000000, 50000000000, 100000000000, 500000000000,
           1000000000000, 5000000000000};


signed main() {
    cin.tie(0);
    ios::sync_with_stdio(false);
    int t;
    cin >> t;
    while (t-- > 0) {
        string s;
        cin >> s;
        int n = s.size();
        for (int i = 0; i <= n; ++i) {
            for (int k = 0; k < 26; ++k) {
                dp[i][k] = -inf;
            }
        }
        dp[n][0] = 0;
        for (int i = n - 1; i >= 0; --i) {
            if (s[i] != '?') {
                for (int prev_mx = 0; prev_mx < 26; ++prev_mx) {
                    int new_mx = max(prev_mx, (int) s[i] - 'A');
                    int val = new_mx == s[i] - 'A' ? vals[s[i] - 'A'] : -vals[s[i] - 'A'];
                    if (dp[i][new_mx] < dp[i + 1][prev_mx] + val) {
                        dp[i][new_mx] = dp[i + 1][prev_mx] + val;
                        from[i][new_mx] = prev_mx;
                        sym[i][new_mx] = s[i];
                    }
                }
            } else {
                for (int it = 0; it < 26; ++it) {
                    for (int prev_mx = 0; prev_mx < 26; ++prev_mx) {
                        int new_mx = max(prev_mx, it);
                        int val = new_mx == it ? vals[it] : -vals[it];
                        if (dp[i][new_mx] < dp[i + 1][prev_mx] + val) {
                            dp[i][new_mx] = dp[i + 1][prev_mx] + val;
                            from[i][new_mx] = prev_mx;
                            sym[i][new_mx] = it + 'A';
                        }
                    }
                }
            }
        }
        int ans = -inf;
        int last = -1;
        for (int i = 0; i < 26; ++i) {
            if (dp[0][i] > ans) {
                ans = dp[0][i];
                last = i;
            }
        }
        string res;
        for (int i = 0; i < n; ++i) {
            res += sym[i][last];
            last = from[i][last];
        }
        cout << ans << "\n" << res << "\n";
    }
    return 0;
}
