#include <bits/stdc++.h>

#define int long long
#define ll long long
#define all(v) v.begin(),  v.end()


using namespace std;

const int maxn = 15e4 + 10;


vector<pair<int, int>> full_graph[maxn];

set<pair<int, int>> edges;


int mt[maxn * 2 + 1];
vector<int> up[maxn];
vector<int> down[maxn];
map<pair<int, int>, int> ind;
bool was[maxn];


int cnt(int u, int v) {
    if (edges.count({u, v}) && edges.count({v, u})) return 2;
    else if (edges.count({u, v})) return 1;
    else return 0;
}


void dfs(int v, int p) {
    was[v] = true;
    for (auto[u, u_ind]: full_graph[v]) {
        if (u == p) continue;
        dfs(u, v);
        int g = 0, h = 0;
        if (cnt(v, u) == 2) g++, h++;
        else if (cnt(v, u) == 1) g++;
        else h++;
        if (down[u].size() == 1 && g == 1) {
            int pr = down[u].back();
            mt[pr] = u_ind;
            mt[u_ind] = pr;
            down[u].pop_back();
            g--;
        }
        if (up[u].size() == 1 && h == 1) {
            int pr = up[u].back();
            mt[pr] = ind[{u, v}];
            mt[ind[{u, v}]] = pr;
            up[u].pop_back();
            h--;
        }
        if (g == 1 && h == 1) {
            mt[u_ind] = ind[{u, v}];
            mt[ind[{u, v}]] = u_ind;
            --g, --h;
        }
        if (g != 0) {
            down[v].push_back(u_ind);
        }
        if (h != 0) {
            up[v].push_back(ind[{u, v}]);
        }
    }
    for (int i = 0; i < min(up[v].size(), down[v].size()); ++i) {
        int ui = up[v].size() - i - 1;
        int di = down[v].size() - i - 1;
        mt[down[v][di]] = up[v][ui];
        mt[up[v][ui]] = down[v][di];
    }
    int solved = min(up[v].size(), down[v].size());
    up[v].resize(up[v].size() - solved);
    down[v].resize(down[v].size() - solved);
//    if (down[v].size() > 1 || up[v].size() > 1) {
//        cout << "No\n";
//        exit(0);
//    }
}


signed main() {
    cin.tie(0);
    ios::sync_with_stdio(false);
    int n, m;
    cin >> n >> m;
    vector<pair<int, int>> e;
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        e.emplace_back(u, v);
        --u, --v;
        if (!edges.count({v, u})) {
            full_graph[u].emplace_back(v, i);
            full_graph[v].emplace_back(u, i);
        }
        ind[{u, v}] = i;
        edges.insert({u, v});
    }
    vector<int> order(m);
    iota(all(order), 0);
    do {
        vector<bool> used(m, false);
        int cnt = 0;
        for (int i = 0; i < m; ++i) {
            if (used[i] || used[order[i]]) continue;
            if (e[i].second == e[order[i]].first) {
                used[i] = true;
                used[order[i]] = true;
                ++cnt;
            }
        }
        if (cnt == m / 2) {
            cout << "Yes\n";
            fill(all(used), false);
            for (int i = 0; i < m; ++i) {
                if (used[i]) continue;
                if (e[i].second == e[order[i]].first) {
                    used[i] = true;
                    used[order[i]] = true;
                    cout << e[i].first << " " << e[i].second << " " << e[order[i]].first << " " << e[order[i]].second
                         << "\n";
                }
            }
            exit(0);
        }
    } while (next_permutation(all(order)));
    cout << "No\n";
    return 0;
}
