#include <bits/stdc++.h>

#define int long long
#define ll long long
#define all(v) v.begin(),  v.end()


using namespace std;

const int inf = 1e10;

const int maxn = 300000;


vector<int> graph[maxn];

int a[maxn];
int b[maxn];
int c[maxn];

int res[maxn];
bool was[maxn];

void dfs(int v, int mn, int mx) {
    res[v] = min(res[v], mn + mx);
    for (int ind: graph[v]) {
        was[ind] = true;
        dfs(a[ind] + b[ind] - v, min(c[ind], mn), max(c[ind], mx));
        was[ind] = false;
    }
}


signed main() {
    cin.tie(0);
    ios::sync_with_stdio(false);
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        cin >> a[i] >> b[i] >> c[i];
        --a[i], --b[i];
        graph[a[i]].emplace_back(i);
        graph[b[i]].emplace_back(i);
    }
    dfs(0, inf, -1);
    for (int i = 1; i < n; ++i) {
        cout << res[i] << "\n";
    }
    return 0;
}
