#include <bits/stdc++.h>

using namespace std;
template<class T1, class T2> inline bool chkmin(T1 &x, const T2 &y) {
	if (x > y) {
		x = y;
		return true;
	}
	return false;
}
template<class T1, class T2> inline bool chkmax(T1 &x, const T2 &y) {
	if (x < y) {
		x = y;
		return true;
	}
	return false;
}
#define all(c) (c).begin(), (c).end()
#define rall(c) (c).rbegin(), (c).rend()
#define sz(c) (int)(c).size()
#define pb push_back
#define mp make_pair
using ll = long long;
using ld = long double;
const int MAXN = 300228;


int n, m;
vector<int> g[MAXN];
map<int, int> alive[MAXN];
bool used[MAXN];
vector<pair<pair<int, int>, pair<int, int> > > ans;


void dfs(int u, int pr = -1) {
	used[u] = true;
	vector<pair<int, int> > st, st1;
	for (auto h: g[u]) {
		if (h == pr) continue;
		if (used[h]) continue;
		dfs(h, u);
		if (alive[u][h]) {
			st1.pb(mp(u, h));
		}
		if (alive[h][u]) {
			st.pb(mp(h, u));
		}
	}	
	while (!st.empty() && !st1.empty()) {
		auto f = st.back();
		st.pop_back();
		auto f1 = st1.back();
		st1.pop_back();
		alive[f.first][f.second] = false;
		alive[f1.first][f1.second] = false;
		ans.pb(mp(f, f1));
	}
	if (!st.empty()) {
		if (sz(st) >= 2 || pr == -1) {
			cout << "No\n";
			exit(0);
		}
		if (!alive[u][pr]) {
			cout << "No\n";
			exit(0);
		}
		auto f = st.back();
		alive[f.first][f.second] = false;
		alive[u][pr] = false;
		ans.pb(mp(f, mp(u, pr)));
	} 
	if (!st1.empty()) {
		if (sz(st1) >= 2 || pr == -1) {
			cout << "No\n";
			exit(0);
		}
		if (!alive[pr][u]) {
			cout << "No\n";
			exit(0);
		}
		auto f = st1.back();
		alive[f.first][f.second] = false;
		alive[pr][u] = false;
		ans.pb(mp(mp(pr, u), f));
	}
}


int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	cin >> n >> m;
	for (int i = 0; i < m; i++) {
		int a, b;
		cin >> a >> b;
		g[a].pb(b);
		g[b].pb(a);
		alive[a][b] = true;
	}
	for (int i = 1; i <= n; i++) {
		if (!used[i]) {
			dfs(i);
		}
	}
	cout << "Yes\n";
	for (auto x: ans) {
		cout << x.first.first << ' ' << x.first.second << ' ' << x.second.first << ' ' << x.second.second << '\n';
	}
	return 0;
}