from itertools import product
from bisect import bisect_left


def chet(chislo):
    last = ''
    res = 0
    data = {"A": 1, "B": 5, "C": 10, "D": 50, "E": 100, "F": 500, "G": 1000,
            "H": 5000, "I": 10000, "J": 50000, "K": 100000, "L": 500000,
            "M": 1000000, "N": 5000000, "O": 10000000, "P": 50000000,
            "Q": 100000000, "R": 500000000, "S": 1000000000, "T": 5000000000,
            "U": 10000000000, "V": 50000000000, "W": 100000000000,
            "X": 500000000000, "Y": 1000000000000, "Z": 5000000000000}
    dataes = ["A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L",
              "M", "N", "O", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z"]
    for i in chislo[::-1]:
        nomen = bisect_left(dataes, i)
        if nomen % 2 == 0:
            nomen = 10 ** (nomen // 2)
        else:
            nomen = 5 * (10 ** (nomen // 2))
        if last == '' or i >= last:
            last = i
            res += nomen
        else:
            res -= nomen
    return res


opred = lambda string: [c for c in range(len(string)) if string[c] == '?']

for _ in range(int(input())):
    stroke = input()
    new_stroke = ''
    lens = len(stroke)
    res = opred(stroke)
    if len(res) == 0:
        print(chet(stroke))
        print(stroke)
    else:
        data = []
        last = ''
        maximum = ''
        minimum = ''
        mb = []
        maxs = 0
        for c, i in enumerate(stroke):
            if i != '?':
                if i != last:
                    mb.append(i)
                last = i
                continue
            k = ['Z']
            k.extend(mb)
            data.append(list(set(k)))
        for x in product(*data):
            rr = list(stroke)
            for pozition, i in zip(res, x):
                rr[pozition] = i
            rr = ''.join(rr)
            ll = chet(rr)
            if ll >= maxs:
                maxs = ll
                new_stroke = rr
        print(maxs)
        print(new_stroke)