#include <iostream>
#include <vector>

#define int long long

using namespace std;

struct wood{
    int x, h;
};

int MAXN = 10003;
vector <bool> visited(MAXN);
vector <wood> trees;
int n, q;

bool check(int id) {
    int x = trees[id].x, h = trees[id].h;
    bool ch_l = true, ch_r = true;
    for (int i = 0; i < n + 2; ++i) {
        if (visited[i])
            continue;
        ch_l = ch_l && !(x - h < trees[i].x && trees[i].x < x);
        ch_r = ch_r && !(x < trees[i].x && trees[i].x < x + h);
    }
    return ch_l || ch_r;
}

signed main() {
    cin >> n >> q;
    for (int i = 0; i < n; ++i) {
        int x, y;
        cin >> x >> y;
        if (i == 0)
            trees.push_back({2 * x - 1, 2 * y});
        trees.push_back({2 * x, 2 * y});
    }
    trees.push_back(trees.back());
    trees.back().x += 1;
    for (int i = 0; i < q; ++i) {
        int x, y;
        cin >> x >> y;
        int ans = 0;
        while (true){
            bool ch = true;
            for (int j = x; j <= y; ++j) {
                if (visited[j])
                    continue;
                if (check(j)){
                    visited[j] = true;
                    ans++;
                    ch = false;
                }
            }
            if (ch)
                break;
        }
        for (int j = x; j <= y; ++j) {
            visited[j] = false;
        }
        cout << ans << endl;
    }
}
