#include <bits/stdc++.h>

using namespace std;
#define int long long
#define fastio ios_base::sync_with_stdio(0);

vector<int> mn;
vector<int> mx;
vector<bool> used;
vector<vector<pair<int, int>>> g;

void dfs(int v) {
    used[v] = true;
    for (auto p : g[v]) {
        int u = p.first;
        if (used[u]) continue;
        int w = p.second;
        mn[u] = min(mn[v], w);
        mx[u] = max(mx[v], w);
        dfs(u);
    }
}

signed main() {
    int n, m;
    cin >> n >> m;
    vector<pair<pair<int, int>, int>> a (m);
    g.resize(n);
    for (int i = 0; i < m; ++i) {
        cin >> a[i].first.first >> a[i].first.second >> a[i].second;
        --a[i].first.first;
        --a[i].first.second;
        g[a[i].first.first].push_back({a[i].first.second, a[i].second});
        g[a[i].first.second].push_back({a[i].first.first, a[i].second});
    }
    if (m == n - 1) {
        used.resize(n, false);
        mn.resize(n, 0);
        mx.resize(n, 0);
        mn[0] = 1000000000;
        mx[0] = 0;
        dfs(0);
        for (int i = 1; i < n; ++i) {
            cout << mn[i] + mx[i] << '\n';
        }
        return 0;
    }
}