#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
#define pii pair<int,int>
#define pll pair<ll,ll>
#define pb push_back
#define all(x) (x).begin(),(x).end()
#define vi vector <int>
#define vll vector <ll>
#define vvi vector <vi>
#define vvll vector <vll>
#define vpii vector <pii>
#define vvpii vector <vpii>
#define vb vector <bool>
#define vvb vector <vb>
#define fi first
#define se second

const int INF = 1e9;
const ll INFLL = 1e18;
const int mod1 = 1e9 + 7;
const int mod2 = 1e9 + 9;
const int MAXN = 1e5 + 100;

void solve() {
    int n, q;
    cin >> n >> q;
    vector<pii > x(n);
    for (auto &to:x)
        cin >> to.fi >> to.se;
    while (q--) {
        int lll, rrr;
        cin >> lll >> rrr;
        lll--, rrr--;
        int mx_left = (lll == 0 ? x[0].fi : x[lll - 1].fi);
        int mx_right = (rrr == n - 1 ? x[n - 1].fi : x[rrr + 1].fi);
        int ans = 0;
        set<pair<int, pii>> s;
        int cur = 1;
        s.insert({0, {mx_left, 0}});
        for (int i = lll; i <= rrr; i++)
            s.insert({cur, {x[i]}}), cur++;
        s.insert({cur, {mx_right, 0}});
        unordered_set<int> can;
        vector<pair<int, pii>> a(s.begin(), s.end());
        for (int i = 1; i + 1 < a.size(); i++) {
            int mx = max(a[i].se.fi - a[i - 1].se.fi, a[i + 1].se.fi - a[i].se.fi);
            if (mx >= a[i].se.se)
                can.insert(i);
        }
        while (!can.empty()) {
            ans++;
            auto tooo = can.begin();
            int now = *tooo;
            can.erase(tooo);
            auto my_pos = s.lower_bound({now, {a[now].se}});
            auto lef = prev(my_pos);
            auto rig = next(my_pos);
            auto l = *lef;
            auto r = *rig;
            int val = r.se.fi - l.se.fi;
            assert(val >= 0);
            if (l.fi != 0) {
                if (val>=a[l.fi].se.se)
                    can.insert(l.fi);
            }
            if (r.fi != cur) {
                if (val>=a[r.fi].se.se)
                    can.insert(r.fi);
            }
            s.erase(my_pos);
        }
        cout << ans << '\n';
    }
}

int main() {
#ifdef Mip182
    freopen("a.in", "r", stdin);
#else
    ios_base::sync_with_stdio(0);cin.tie(0);
#endif
    int _t = 1;
    while (_t--)
        solve();
}