#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <numeric>
#include <cassert>
#include <cstring>
#include <string>

using namespace std;

#define range(i, n) for (int i = 0; i < (n); ++i)
#define prange(i, n) for (int i = 1; i <= (n); ++i)
#define rrange(i, n) for (int i = (n) - 1; i >= 0; --i)

typedef long long ll;
typedef pair<int, int> pii;
#define fi first
#define se second
#define pb push_back
#define all(a) (a).begin(), (a).end()

void setup() {
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#endif
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
}

void solve();

int main() {
    setup();
    int t = 1;
    cin >> t;
    range(i, t) {
        solve();
    }
}
ll zn[26];

void fZn() {
    ll ten = 1;
    range(i, 13) {
        zn[2*i] = ten;
        zn[2*i + 1] = ten * 5;
        ten *= 10;
    }
}

const ll minf = -1e18;

const int MAXN = 3e5 + 10;
ll dp[MAXN][26];
int pred[MAXN][26];

void solve() {
    fZn();
    string s; cin >> s;
    int n = s.size();
    range(j, 26) {
        dp[n][j] = 0;
    }
    rrange(i, n) {
        if (s[i] == '?') {
            range(j, 26) {
                ll bZn = minf;
                ll bCh = 0;
                range(c, j + 1) {
                    if (dp[i + 1][c] == minf) continue;
                    ll temp = dp[i + 1][c] + zn[j];
                    if (temp > bZn) {
                        bZn = temp;
                        bCh = c;
                    }
                }
                for (int c = j + 1; c < 26; ++c) {
                    if (dp[i + 1][c] == minf) continue;
                    ll temp = dp[i + 1][c] - zn[j];
                    if (temp > bZn) {
                        bZn = temp;
                        bCh = c;
                    }
                }
                dp[i][j] = bZn;
                pred[i][j] = bCh;
            }
        } else {
            range(j, s[i] - 'A') {
                dp[i][j] = minf;
            }
            {
                int j = s[i] - 'A';
                ll bZn = minf;
                ll bCh = 0;
                range(c, j + 1) {
                    if (dp[i + 1][c] == minf) continue;
                    ll temp = dp[i + 1][c] + zn[j];
                    if (temp > bZn) {
                        bZn = temp;
                        bCh = c;
                    }
                }
                dp[i][j] = bZn;
                pred[i][j] = bCh;
            }
            for (int j = s[i] - 'A' + 1; j < 26; ++j) {
                if (dp[i + 1][j] == minf) {
                    dp[i][j] = minf;
                } else {
                    dp[i][j] = dp[i + 1][j] - zn[s[i] - 'A'];
                    pred[i][j] = j;
                }
            }
        }
    }
    ll bans = minf;
    ll c = 0;
    range(j, 26) {
        if (bans < dp[0][j]) {
            bans = dp[0][j];
            c = j;
        }
    }
    cout << bans << '\n';
    range(i, n) {
        if (s[i] == '?') {
            cout << (char) (c + 'A');
        } else {
            cout << s[i];
        }
        c = pred[i][c];
    }
    cout << '\n';
}



