#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
const ll INF = 1e10;

int n, q;
vector<ll> x;
vector<ll> h;

vector<ll> sub;
vector<ll> subh;
vector<ll> kek;

void solve(int l, int r) {
	int sz = r - l + 1;
	sub = {};
	subh = {};
	for ( int i = l; i <= r; ++i ) sub.push_back(x[i]);
	for ( int i = l; i <= r; ++i ) subh.push_back(h[i]);

	int res = 0;
	int ans = 0;
	int leng = sub.size();

	for ( res = 0; res <= leng; ++res ) {
		int pos = -1;
		for ( int i = 0; i < sub.size(); ++i ) {
			bool flag = false;
			//left
			if ( i == 0 ) {
				if ( sub[i] - subh[i] >= x[l - 1] ) {
					flag = true;
				}
			} else if ( sub[i] - subh[i] >= sub[i - 1] ) {
				flag = true;
			}

			//right
			if ( i == sub.size() - 1 ) {
				if ( sub[i] + subh[i] <= x[r + 1] ) {
					flag = true;
				}
			} else if ( sub[i] + subh[i] <= sub[i + 1] ) {
				flag = true;
			}

			if ( flag ) { pos = i; break; }
		}

		if ( pos == -1 ) {
			ans = res;
			break;
		}

		kek = {};

		for ( int i = 0; i < sub.size(); ++i ) {
			if ( i == pos ) continue;
			kek.push_back(sub[i]);
		}
		sub.swap(kek);

		kek = {};

		for ( int i = 0; i < subh.size(); ++i ) {
			if ( i == pos ) continue;
			kek.push_back(subh[i]);
		}
		subh.swap(kek);
	}

	cout << ans << "\n";
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	cin >> n >> q;
	x = vector<ll>(n + 2);
	h = vector<ll>(n + 2);

	for ( int i = 0; i < n; ++i ) {
		cin >> x[i + 1] >> h[i + 1];
	}

	x[0] = x[1];
	x[n + 1] = x[n];

	h[0] = INF;
	h[n + 1] = INF;

	int l, r;
	for ( int i = 0; i < q; ++i ) {
		cin >> l >> r;

		solve(l, r);
	}
	return 0;
}