#include <iostream>

#include <algorithm>

#include <vector>

using namespace std;

typedef long long ll;

int main() {
	ios_base::sync_with_stdio(false), cin.tie(NULL), cout.tie(NULL);

	int n, q; cin >> n >> q;
	vector<pair<int, int>> a(n);
	for (auto& c : a) {
		cin >> c.first >> c.second;
	}

	while (q--) {
		int l, r; cin >> l >> r;
		l--; r--;
		vector<bool> used(n, true);
		int ans = 0;
		while (true) {
			bool flag = false;
			for (int i = l; i <= r; i++) {
				if (!used[i]) continue;

				bool flag_l = true;
				for (int j = 0; j < i; j++) {
					if (a[i].first - a[i].second < a[j].first && used[j]) {
						flag_l = false;
						break;
					}
				}

				if (flag_l && a[i].first - a[i].second >= a[0].first) {
					flag = true;
					used[i] = false;
					break;
				}

				bool flag_r = true;
				for (int j = i + 1; j < n; j++) {
					if (a[i].first + a[i].second > a[j].first && used[j]) {
						flag_r = false;
						break;
					}
				}

				if (flag_r && a[i].first + a[i].second <= a.back().first) {
					flag = true;
					used[i] = false;
					break;
				}
			}

			ans += flag;
			if (!flag)
				break;
		}

		cout << ans << '\n';
	}

	return 0;
}