#include <iostream>

#include <algorithm>

#include <string>

using namespace std;

typedef long long ll;

ll val[26];

ll get(string s, int l, int r) {
	char max_c = s[r];
	ll res = 0;
	for (int i = r; i >= l; i--) {
		if (s[i] == '?')
			break;

		if (s[i] >= max_c) {
			res += val[s[i] - 'A'];
		}
		else {
			res -= val[s[i] - 'A'];
		}

		max_c = max(max_c, s[i]);
	}

	return res;
}

int main() {
	ios_base::sync_with_stdio(false), cin.tie(NULL), cout.tie(NULL);

	ll cur = 1;
	for (int i = 0; i < 26; i++) {
		val[i] = cur;
		if (i % 2 == 0)
			cur *= 5l;
		else
			cur *= 2l;
	}

	int t; cin >> t;
	while (t--) {
		string s; cin >> s;
		int n = s.size();
		char last = 'A';
		for (int i = n - 1; i >= 0; i--) {
			if (s[i] == '?') {
				char best_c = last;
				ll best_sum = -2e18;
				for (char c = last; c <= 'Z'; c++) {
					s[i] = c;
					if (get(s, 0, n - 1) > best_sum) {
						best_sum = get(s, 0, n - 1);
						best_c = c;
					}
				}

				s[i] = best_c;
			}
		}

		cout << get(s, 0, n -1) << '\n' << s << '\n';
	}

	return 0;
}