#include <iostream>

#include <algorithm>

#include <string>
#include <vector>

using namespace std;

typedef long long ll;

ll val[26];

const ll inf = 2e18;

int main() {
	ios_base::sync_with_stdio(false), cin.tie(NULL), cout.tie(NULL);

	ll cur = 1;
	for (int i = 0; i < 26; i++) {
		val[i] = cur;
		if (i % 2 == 0)
			cur *= 5l;
		else
			cur *= 2l;
	}

	int t; cin >> t;
	while (t--) {
		string s; cin >> s;
		int n = s.size();

		vector<vector<ll>> dp(n, vector<ll>(26, -inf));
		vector<vector<char>> best_c(n, vector<char>(26));

		if (s[0] != '?') {
			for (char m = 'A'; m <= 'Z'; m++) {
				best_c[0][m-'A'] = s[0];
				if (s[0] >= m)
					dp[0][m - 'A'] = val[s[0] - 'A'];
				else
					dp[0][m - 'A'] = -val[s[0] - 'A'];
			}
		}
		else {
			for (char m = 'A'; m <= 'Z'; m++) {
				best_c[0][m-'A'] = 'Z';
				dp[0][m - 'A'] = val['Z' - 'A'];
			}
		}

		for (int i = 1; i < n; i++) {
			for (char m = 'A'; m <= 'Z'; m++) {
				if (s[i] != '?') {
					best_c[i][m-'A'] = s[i];
					if (s[i] >= m)
						dp[i][m - 'A'] = dp[i - 1][max(s[i], m) - 'A'] + val[s[i] - 'A'];
					else
						dp[i][m - 'A'] = dp[i - 1][max(s[i], m) - 'A'] - val[s[i] - 'A'];
				}
				else {
					for (char x = 'A'; x <= 'Z'; x++) {
						if (x >= m) {
							if (dp[i][m - 'A'] <= dp[i - 1][max(x, m) - 'A'] + val[x - 'A']) {
								dp[i][m - 'A'] = dp[i - 1][max(x, m) - 'A'] + val[x - 'A'];
								best_c[i][m - 'A'] = x;
							}
						}
						else {
							if (dp[i][m - 'A'] <= dp[i - 1][max(x, m) - 'A'] - val[x - 'A']) {
								dp[i][m - 'A'] =  dp[i - 1][max(x, m) - 'A'] - val[x - 'A'];
								best_c[i][m - 'A'] = x;
							}
						}
					}
				}
			}
		}

		string ans = "";
		int cur = 0;
		for (int i = n - 1; i >= 0; i--) {
			ans += best_c[i][cur];
			cur = max(cur, best_c[i][cur] -'A');
		}

		reverse(ans.begin(), ans.end());

		cout << dp.back()[0] << '\n' << ans << '\n';
	}

	return 0;
}