#include <iostream>

#include <algorithm>

#include <vector>
#include <set>

using namespace std;

typedef long long ll;

int main() {
	ios_base::sync_with_stdio(false), cin.tie(NULL), cout.tie(NULL);

	int n, q; cin >> n >> q;
	vector<pair<int, int>> a(n);
	for (auto& c : a) {
		cin >> c.first >> c.second;
	}

	while (q--) {
		int l, r; cin >> l >> r;
		l--; r--;
		vector<bool> used(n, true);
		int ans = 0;
		set<int> x, ix;
		for (auto c : a) {
			x.insert(c.first);
			ix.insert(-c.first);
		}

		while (true) {
			bool flag = false;
			for (int i = l; i <= r; i++) {
				if (!used[i]) continue;

				bool flag_l = true;

				auto it = x.upper_bound(a[i].first - a[i].second);
				if (it != x.end() && *it < a[i].first)
					flag_l = false;

				if (flag_l && a[i].first - a[i].second >= a[0].first) {
					flag = true;
					used[i] = false;
					x.erase(a[i].first);
					ix.erase(-a[i].first);
					break;
				}

				bool flag_r = true;
				//for (int j = i + 1; j < n; j++) {
				//	if (a[i].first + a[i].second > a[j].first && used[j]) {
				//		flag_r = false;
				//		break;
				//	}
				//}
				 it = ix.upper_bound(-(a[i].first + a[i].second));
				if (it != ix.end() && -*it > a[i].first)
					flag_r = false;
				

				if (flag_r && a[i].first + a[i].second <= a.back().first) {
					flag = true;
					used[i] = false;
					x.erase(a[i].first);
					ix.erase(-a[i].first);
					break;
				}
			}

			ans += flag;
			if (!flag)
				break;
		}

		cout << ans << '\n';
	}

	return 0;
}