#include <bits/stdc++.h>
using namespace std;

using ll = long long;

vector<ll> lazy_calc(30, -1);
ll calc(int pos) {
    if (lazy_calc[pos] == -1) {
        lazy_calc[pos] = pos == 0 ? 1 : calc(pos - 1);
        if (pos % 2 == 1) {
            lazy_calc[pos] *= 5;
        } else if (pos != 0) {
            lazy_calc[pos] *= 2;
        }
    }

    return lazy_calc[pos];
}

ll count(const string& s) {
    int n = s.size();

    ll ans = calc(s[n - 1] - 'A');
    int mx_pos = n - 1;
    for (int i = n - 2; i >= 0; i--) {
        if (s[mx_pos] <= s[i]) {
            mx_pos = i;
            ans += calc(s[i] - 'A');
        } else {
            ans -= calc(s[i] - 'A');
        }
    }

    return ans;
}

ll ans = LLONG_MIN;
string ans_str;
void rec(string s, const vector<int>& positions, int ind) {
    if (ind == positions.size()) {
        ll cur_ans = count(s);
        if (cur_ans > ans) {
            ans = cur_ans;
            ans_str = s;
        }

        return;
    }

    int pos = positions[ind];
    string before, after;
    for (int i = 0; i < pos; i++) {
        before += s[i];
    }

    for (int i = pos + 1; i < s.size(); i++) {
        after += s[i];
    }

    for (int i = 0; i < 26; i++) {
        string cur = before;
        cur += ('A' + i);
        cur += after;

        rec(cur, positions, ind + 1);
    }
}

void ok_solve(string s) {
    int n = s.size();

    vector<vector<ll>> dp(n, vector<ll>(26, 0));
    for (int i = 0; i < n; i++) {
        if (s[i] != '?') {
            ans_str += s[i];
            for (int j = 0; j < 26; j++) {
                dp[i][j] = i != 0 ? dp[i - 1][j] : 0;
                if (s[i] - 'A' < j) {
                    dp[i][j] -= calc(s[i] - 'A');
                } else {
                    dp[i][j] += calc(s[i] - 'A');
                }
            }
        } else {
            int mx_pos = 0;
            for (int j = 0; j < 26; j++) {
                dp[i][j] = (i != 0 ? dp[i - 1][j] : 0) + calc(j);
                if (dp[i][mx_pos] < dp[i][j]) {
                    mx_pos = j;
                }
            }

            ans_str += 'A' + mx_pos;
        }
    }

    ans = count(ans_str);
}

void solve() {
    ans = LLONG_MIN;

    string s;
    cin >> s;
    /*
    vector<int> positions;
    for (int i = 0; i < s.size(); i++) {
        if (s[i] == '?') {
            positions.push_back(i);
        }
    }

    rec(s, positions, 0);
    cout << ans << "\n" << ans_str << "\n";
    */
    ans = LLONG_MIN;
    ans_str = "";
    ok_solve(s);
    cout << ans << "\n" << ans_str << "\n";
}

int main() {
    int t;
    cin >> t;

    while (t--) {
        solve();
    }

    return 0;
}
