#include <bits/stdc++.h>
using namespace std;

using ll = long long;

vector<ll> lazy_calc(30, -1);
ll calc(int pos) {
    if (lazy_calc[pos] == -1) {
        lazy_calc[pos] = pos == 0 ? 1 : calc(pos - 1);
        if (pos % 2 == 1) {
            lazy_calc[pos] *= 5;
        } else if (pos != 0) {
            lazy_calc[pos] *= 2;
        }
    }

    return lazy_calc[pos];
}

ll count(const string& s) {
    int n = s.size();

    ll ans = calc(s[n - 1] - 'A');
    int mx_pos = n - 1;
    for (int i = n - 2; i >= 0; i--) {
        if (s[mx_pos] <= s[i]) {
            mx_pos = i;
            ans += calc(s[i] - 'A');
        } else {
            ans -= calc(s[i] - 'A');
        }
    }

    return ans;
}

ll ans = LLONG_MIN;
string ans_str;
void rec(string s, const vector<int>& positions, int ind) {
    if (ind == positions.size()) {
        ll cur_ans = count(s);
        if (cur_ans > ans) {
            ans = cur_ans;
            ans_str = s;
        }

        return;
    }

    int pos = positions[ind];
    string before, after;
    for (int i = 0; i < pos; i++) {
        before += s[i];
    }

    for (int i = pos + 1; i < s.size(); i++) {
        after += s[i];
    }

    for (int i = 0; i < 26; i++) {
        string cur = before;
        cur += ('A' + i);
        cur += after;

        rec(cur, positions, ind + 1);
    }
}

void ok_solve(string s) {
    int n = s.size();

    vector<vector<ll>> dp(n, vector<ll>(26, -1e18));
    vector<vector<ll>> bt(n, vector<ll>(26, -1));
    for (int i = 0; i < n; i++) {
        if (s[i] != '?') {
            for (int j = 0; j < 26; j++) {
                if (i != 0) {
                    dp[i][j] = LLONG_MIN;
                    for (int k = max(s[i] - 'A', j); k < 26; k++) {
                        /*if (s[i] - 'A' < j) {
                            dp[i][j] -= calc(s[i] - 'A');
                        } else {
                            dp[i][j] += calc(s[i] - 'A');
                        }*/

                        if (dp[i][j] < dp[i - 1][k] + calc(s[i] - 'A') * (s[i] - 'A' < j ? -1 : 1)) {
                            dp[i][j] = dp[i - 1][k] + calc(s[i] - 'A') * (s[i] - 'A' < j ? -1 : 1);
                            bt[i][j] = k;
                        }
                    }
                } else {
                    dp[i][j] = calc(s[i] - 'A') * (s[i] - 'A' < j ? -1 : 1);
                }
                //dp[i][j] = i != 0 ? dp[i - 1][max(s[i] - 'A', j)] : 0;
            }
        } else {
            for (int j = 0; j < 26; j++) {
                if (i != 0) {
                    dp[i][j] = LLONG_MIN;
                    for (int k = j; k < 26; k++) {
                       if (dp[i][j] < dp[i - 1][k] + calc(j)) {
                           dp[i][j] = dp[i - 1][k] + calc(j);
                           bt[i][j] = k;
                       }
                    }
                } else {
                    dp[i][j] = calc(j);
                }
            }
        }
    }

    int mx_pos = 0;
    for (int i = 0; i < 26; i++) {
        if (dp[n - 1][mx_pos] < dp[n - 1][i]) {
            mx_pos = i;
        }
    }

    for (int i = n - 1; i >= 0; i--) {
        if (s[i] == '?') {
            ans_str += 'A' + mx_pos;
        } else {
            ans_str += s[i];
        }

        mx_pos = bt[i][mx_pos];
    }

    reverse(ans_str.begin(), ans_str.end());

    ans = count(ans_str);
}

void solve() {
    ans = LLONG_MIN;

    string s;
    cin >> s;

    /*
    int n = rand() % 5 + 1;
    for (int i = 0; i < n; i++) {
        if (rand() % 6 == 1) {
            s += "?";
        } else {
            s += 'A' + rand() % 26;
        }
    }
    /**/
    /*
    vector<int> positions;
    for (int i = 0; i < s.size(); i++) {
        if (s[i] == '?') {
            positions.push_back(i);
        }
    }

    //cerr << s << "\n";

    rec(s, positions, 0);
    cout << ans << "\n" << ans_str << "\n";

    string rec_ans = ans_str;
    /* */
    ans = LLONG_MIN;
    ans_str = "";
    ok_solve(s);
    cout << ans << "\n" << ans_str << "\n";
    /*
    if (count(ans_str) != count(rec_ans)) {
        cout << s << "\n\n" << rec_ans << "\n\n" << ans_str;
        exit(0);
    }
    /**/
}

int main() {
    int t;
    cin >> t;

    while (t--) {
        solve();
    }

    return 0;
}
