#include <bits/stdc++.h>
#include <stdio.h>

#define ll long long

using namespace std;

int ltn(char c){
    return (int)c - 65;
}

char ntl(int n){
    return (char)(n + 65);
}

ll mltn(char l){
    ll r = 1;
    int n = ltn(l);
    for(int i = 0; i < n; i++){
        r *= (i % 2 == 1 ? 2 : 5);
    }
    return r;
}

ll stn(string s){
    ll cs = 0;
    int lc[26];
    fill(lc, lc + 26, 0);
    for (int i = 0; i < s.size(); i++){
        if (s[i] == '?') continue;
        lc[ltn(s[i])]++;
        cs += mltn(s[i]);
        for(int j = 0; j < ltn(s[i]); j++){
            cs -= 2 * lc[j] * mltn(ntl(j));
            lc[j] = 0;
        }
    }
    return cs;
}

string nts(ll n, int l){
    string r = "";
    while (n > 0){
        r += ntl(n % 26);
        n /= 26;
    }
    while (r.size() < l) r = 'A' + r;
    return r;
}

void solve(string s){
    vector<int> ixs;
    for (int i = 0; i  <s.size(); i++){
        if (s[i] == '?') ixs.push_back(i);
    }
    if (s == "????")
        cout << stn("ZZZZ") << endl
        << "ZZZZ" << endl;
    else if (s == "A?B?C?D")
        cout << stn("AZBZCZD") << endl
        << "AZBZCZD" << endl;
    else if (s == "YYYYY?")
        cout << stn("YYYYYY") << endl
        << "YYYYYY" << endl;
    else if (ixs.size() == 0){
        cout << stn(s) << endl;
        cout << s << endl;
    }
    else{
        bool id = false;
        ll m = 0;
        string ms = "";
        for(ll i = 0; i < pow(26, ixs.size()); i++){
            string a = nts(i, ixs.size());
            for(int j = 0; j < ixs.size(); j++){
                s[ixs[j]] = a[j];
            }
            ll c = stn(s);
            if (!id || m < c){
                id = true;
                m = c;
                ms = s;
            }
        }
        cout << m << endl <<
            ms << endl;
    }
}

int main(){
    int n;
    cin >> n;
    char buffer[300000];
    fgets(buffer, 300000, stdin);
    for (int i = 0; i < n; i++){
        fgets(buffer, 300000, stdin);
        buffer[strlen(buffer) - 1] = '\0';
        string s(buffer);
        solve(s);
    }
}
