#include<bits/stdc++.h>
using namespace std;

typedef long long ll;
#define rep(i, a, b) for(int i = a; i < b; i++)

vector<vector<pair<int, int> > > g;
vector<int> d;
vector<int> used;

void dfs(int v, int MIN, int MAX)
{
    used[v] = 1;

    d[v] = MIN + MAX;

    for(auto x : g[v]) if(!used[x.first])
    {
        dfs(x.first, min(MIN, x.second), max(MAX, x.second));
    }
}

int main()
{
    int n, m;
    cin >> n >> m;

    g.resize(n);
    d.resize(n);
    used.resize(n, 0);
    int MAX = -1;

    rep(i, 0, m)
    {
        int u, v, t;
        cin >> u >> v >> t;
        u--; v--;
        g[u].push_back({v, t});
        g[v].push_back({u, t});
        MAX = max(MAX, t);
    }

    if(m == n - 1)
    {
        dfs(0, 1e9, -1e9);

        rep(i, 1, n) cout << d[i] << endl;
        return 0;
    }
    else
    {
        d[0] = 0;
        rep(i, 1, n) d[i] = 1e9 + 7;

        set<pair<int, int> > q;
        q.insert({0, 0});

        rep(i, 0, n)
        {
            //cout << q.size() << endl;
            //for(auto x : q) cout << x.first << " " << x.second << endl;
            int v = (*q.begin()).second;
            //cout << v << endl;

            q.erase({d[v], v});

            for(pair<int, int> x : g[v])
            {
                int to = x.first, cost = x.second;
                if(max(d[v], cost) < d[to]) {q.erase({d[to], to});
                d[to] = min(d[to], max(d[v], cost));
                q.insert({d[to], to});}
            }
        }

        rep(i, 1, n) cout << d[i] << endl;
        return 0;

    }






    return 0;

}
