#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
using namespace std;
void initial()
{
#ifdef PC
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}
#define all(x) (x).begin(), (x).end()
#define sz(x) ((long long)(x).size())
#define pb push_back
typedef long long ll;
vector <ll> x;
vector <ll> h;
const ll maxn = 1e5;
ll lf[maxn];
ll rt[maxn];
bool used[maxn];
deque <ll> q;
ll l, r;
void upd(ll i)
{
    if (i < l || i > r || used[i]) return;
    if (max(x[i] - x[lf[i]], x[rt[i]] - x[i]) >= h[i])
    {
        q.push_back(i);
        used[i] = true;
    }
}
void solve()
{
    cin >> l >> r;
    q.clear();
    for (int i = l; i <= r; i++)
    {
        lf[i] = i - 1;
        rt[i] = i + 1;
        used[i] = false;
        upd(i);
    }
    ll cnt = 0;
    while (!q.empty())
    {
        int v = q.front();
        q.pop_front();
        cnt++;
        lf[rt[v]] = lf[v];
        rt[lf[v]] = rt[v];
        upd(lf[v]);
        upd(rt[v]);
    }
    cout << cnt << endl;
}
int main() {
    initial();
    ll n, q;
    cin >> n >> q;
    x.resize(n + 2);
    h.resize(n + 2);
    for (int i = 1; i <= n; i++)
    {
        cin >> x[i] >> h[i];
    }
    x[0] = x[1];
    x[n + 1] = x[n];
    while (q--)
        solve();
    return 0;
}
