#include <bits/stdc++.h>

typedef long long ll;

using namespace std;

#define pll pair<ll, ll>
#define ff first
#define ss second

ll n, m;

const ll MAXN = 1.5e5 + 10;

vector<pll > og[MAXN];
vector<ll> g[MAXN];
vector<ll> gr[MAXN];

//vector<ll> gnx[MAXN];
//vector<ll> grnx[MAXN];

ll gsz[MAXN];
ll grsz[MAXN];

//ll gst[MAXN];
//ll grst[MAXN];

pll edges[MAXN];
bool used[MAXN];

void solve() {
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        ll u, v;
        cin >> u >> v;
        edges[i] = {u, v};
        og[u].emplace_back(v, i);
    }

    set<pll> usedes;
    for (int i = 0; i < m; ++i) {
        for (auto e: og[edges[i].ss]) {
            if(usedes.count({i, e.ss})) continue;
            g[i].push_back(e.ss);
            g[e.ss].push_back(i);

            usedes.insert({i, e.ss});
            usedes.insert({e.ss, i});
        }
    }

    //set<pll > into, out;

    for (int i = 0; i < m; ++i) {
        gsz[i] = g[i].size();
        //grsz[i] = gr[i].size();

        //for(int j = 0; j < g[i].size(); ++j) gnx[i][j] = j + 1;
        //for(int j = 0; j < gr[i].size(); ++j) grnx[i][j] = j + 1;

        //out.insert({g[i].size(), i});
        ///into.insert({gr[i].size(), i});
    }
    vector<pll> ans;

    set<pll> que;
    for(int i = 0; i < m; ++i) que.insert({gsz[i], i});
    while (!que.empty()) {
        ll v = que.begin()->ss;
        que.erase(*que.begin());

        ll to = -1;
        for(ll e: g[v]){
            if(!used[e] && (to == -1 || gsz[to] > gsz[e])){
                to = e;
                break;
            }
        }
        if(to == -1){
            cout << "No\n";
            return;
        }

        que.erase({gsz[to], to});
        used[v] = used[to] = true;

        ans.emplace_back(v, to);
        for(ll e: g[v]){
            if(used[e]) continue;
            que.erase({gsz[e], e});
            que.insert({--gsz[e], e});
        }
        for(ll e: g[to]){
            if(used[e]) continue;
            que.erase({gsz[e], e});
            que.insert({--gsz[e], e});
        }
    }

    cout << "Yes\n";
    for(pll p: ans){
        cout << edges[p.ff].ff << " " << edges[p.ff].ss << " ";
        cout << edges[p.ss].ff << " " << edges[p.ss].ss << "\n";
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    solve();
}