#include <iostream>
#include <vector>
#include <cmath>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>

#define sqr(x) ((x) * (x))
#define mp make_pair
#define pb push_back
#define endl '\n'
//#define int ll

#pragma warning (disable : 4996)

using namespace std;

typedef long double ld;
typedef long long ll;
typedef pair<int, int> pii;
typedef vector<pii> vii;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<char> vc;

const ld EPS = 1e-8;
const int N = (int)1e5 + 10;
const int INF = (int)2e18 + 10;
const int MOD = (int)1e9 + 7;

bool check(vi& a, int x, int h, vc& c) {
	bool f1 = x - h >= a[0], f2 = x + h <= a.back();
	for (int i = 0; i < a.size(); ++i) {
		if (x - h < a[i] && a[i] < x && !c[i])
			f1 = 0;
		if (x < a[i] && a[i] < x + h && !c[i])
			f2 = 0;
	}
	return f1 || f2;
}

void solve() {
	
	int n, q;
	cin >> n >> q;
	vi x(n), h(n);
	for (int i = 0; i < n; ++i)
		cin >> x[i] >> h[i];
	for (int t = 0; t < q; ++t) {
		int l, r;
		cin >> l >> r;
		--l;
		vc c(n);
		for (int it = 0; it <= n; ++it) {
			bool flag = 1;
			for (int i = l; i < r; ++i) {
				if (!c[i] && check(x, x[i], h[i], c)) {
					c[i] = 1;
					flag = 0;
					break;
				}
			}
			if (flag) {
				cout << it << endl;
				break;
			}
		}
	}
	
	return;
}

signed main() {
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	solve();

	return 0;
}