#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <set>
#include <map>
#include <deque>
#include <tuple>

using namespace std;

typedef long long ll;

#define int ll
#define loop(i, n) for (int i = 0; i < n; ++i)
#define loop1(i, n) for (int i = 1; i <= n; ++i)
#define all(x) begin(x), end(x)
#define pi pair <int, int>
#define ti tuple <int, int, int>
#define F first
#define S second

const int N = 3e5 + 7, K = 26, INF = 8e18;

int dp[K][N], p[K][N];
int val[K] = { 1 };

void solve() {
	string s; cin >> s;
	int n = s.size();
	loop1(i, n)
		loop(j, K)
			dp[j][i] = p[j][i] = 0;
	vector <bool> mns(n);
	int ans = 0, cmx = 1;
	for (int i = n - 1; i >= 0; --i) {
		if (s[i] != '?') {
			cmx = max(cmx, val[s[i] - 'A']);
			if (val[s[i] - 'A'] < cmx) {
				ans -= val[s[i] - 'A'];
				mns[i] = 1;
			}
			else
				ans += val[s[i] - 'A'];
		}
	}
	int cnt = 1;
	int cur[K] = { 0 };
	loop(i, n) {
		if (s[i] == '?') {
			int qcnt = 0;
			while (i < n && s[i] == '?') {
				++i; ++qcnt;
			}
			--i;
			int sum = 0;
			loop(j, K) {
				dp[j][cnt] = sum + qcnt * val[j];
				sum -= val[j] * cur[j];
				cur[j] = 0;
			}
			++cnt;
		}
		else if (!mns[i])
			++cur[s[i] - 'A'];
	}
	--cnt;
	loop1(i, cnt) {
		pi cmx = { -INF, -1 };
		for (int j = K - 1; j >= 0; --j) {
			if (dp[j][i - 1] > cmx.F)
				cmx = { dp[j][i - 1], j };
			dp[j][i] += cmx.F;
			p[j][i] = cmx.S;
		}
	}
	int pos = 0;
	loop(i, K)
		if (dp[pos][cnt] < dp[i][cnt])
			pos = i;
	vector <char> ansv;
	cout << ans + dp[pos][cnt] << "\n";
	for (int i = cnt; i > 0; --i) {
		ansv.push_back(pos + 'A');
		pos = p[pos][i];
	}
	reverse(all(ansv));
	cnt = 0;
	loop(i, n) {
		if (s[i] != '?')
			cout << s[i];
		else {
			for (; i < n && s[i] == '?'; ++i)
				cout << ansv[cnt];
			--i, ++cnt;
		}
	}
	cout << "\n";
}

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	loop1(i, K - 1)
		val[i] = (i & 1 ? val[i - 1] * 5 : val[i - 2] * 10);
	int t; cin >> t; loop(i, t)
		solve();
	return 0;
}