#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <set>
#include <map>
#include <deque>
#include <tuple>

using namespace std;

typedef long long ll;

//#define int ll
#define loop(i, n) for (int i = 0; i < n; ++i)
#define loop1(i, n) for (int i = 1; i <= n; ++i)
#define all(x) begin(x), end(x)
#define pi pair <int, int>
#define ti tuple <int, int, int>
#define F first
#define S second

const int N = 6007;

vector <pi> g[N], ag[N];
vector <int> ng[N];
int col[N], mt[N], kun_col[N];
pi ed[N];

void dfs(int v, bool c) {
	col[v] = (int)c + 1;
	for (int u : ng[v])
		if (!col[u])
			dfs(u, !c);

}

bool kun(int v, int c) {
	kun_col[v] = c;
	for (int u : ng[v])
		if (!mt[u] || col[mt[u]] != c && kun(mt[u], c)) {
			mt[u] = v;
			return true;
		}
	return false;
}

void solve() {
	int n, m;
	loop1(i, m) {
		int u, v;
		cin >> u >> v;
		g[u].push_back({ v, i });
		ag[v].push_back({ u, i });
		ed[i] = { u, v };
	}
	loop1(i, n) {
		for (pi v : g[i]) {
			for (pi u : ag[i]) {
				ng[v.S].push_back(u.S);
				ng[u.S].push_back(v.S);
			}
		}
	}
	loop1(i, m)
		if (!col[i])
			dfs(i, 0);
	int cnt = 0;
	loop1(i, m)
		if (col[i] == 1)
			if (!kun(i, ++cnt)) {
				cout << "No"; return;
			}
	cout << "Yes\n";
	loop1(i, m)
		if (col[i] == 2)
			cout << ed[i].F << " " << ed[i].S << " " << ed[mt[i]].F << " " << ed[mt[i]].S << "\n";
}

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	solve();
	return 0;
}