#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <set>
#include <map>
#include <deque>
#include <tuple>

using namespace std;

typedef long long ll;

//#define int ll
#define loop(i, n) for (int i = 0; i < n; ++i)
#define loop1(i, n) for (int i = 1; i <= n; ++i)
#define all(x) begin(x), end(x)
#define pi pair <int, int>
#define ti tuple <int, int, int>
#define F first
#define S second

const int N = 20, INF = 1e9 + 7;

vector <pi> g[N];
pi dist[N], dp[1 << N][N];

void calc_dp(int n) {
	loop(i, n)
		dist[i] = { INF, INF };
	dp[1][0] = { INF, 0 };
	for (int mask = 2; mask < (1 << n); ++mask) {
		loop(v, n) {
			if (!(mask & (1 << v)))
				continue;
			dp[mask][v] = { INF, INF };
			for (pi u : g[v])
				if (mask & (1 << u.F)) {
					pi cdist = { min(dp[mask ^ (1 << v)][u.F].F, u.S), max(dp[mask ^ (1 << v)][u.F].S, u.S) };
					if (cdist.F + cdist.S < dp[mask][v].F + dp[mask][v].S)
						dp[mask][v] = cdist;
				}
			if (dist[v].F + dist[v].S > dp[mask][v].F + dp[mask][v].S)
				dist[v] = dp[mask][v];
		}
	}
}

void solve() {
	int n, m;
	cin >> n >> m;
	loop(i, m) {
		int u, v, c;
		cin >> u >> v >> c;
		--u, --v;
		g[u].push_back({ v, c });
		g[v].push_back({ u, c });
	}
	calc_dp(n);
	loop1(i, n - 1)
		cout << dist[i].F + dist[i].S << "\n";
}

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	solve();
	return 0;
}