#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <string>
#include <stdio.h>
#include <algorithm>
#include <math.h>


using namespace std;

#define ll long long
#define FOR(i, Left, Right) for(ll  i = (Left); i <= (Right); ++i)
#define FOR_DOWN(i, Right, Left) for(ll  i = (Right); i >= (Left); --i)
#define pii pair <ll , ll > 



const ll  cnt = 312345, inf = 812345678;
ll  n, m;
vector <ll > g[cnt];
vector <ll > de_g[cnt];
vector <pii> ans;
vector <ll > r_g[cnt];



ll  p[cnt], h[cnt];

int typ_p[cnt];

void dfs_create(ll  v)
{
	for (ll u : g[v])
	{
		if (p[u] == 0)
		{
			h[u] = h[v] + 1;
			r_g[v].push_back(u);
			p[u] = v;
			typ_p[u] = 1;
			dfs_create(u);
		}
	}
	for (ll u : de_g[v])
	{
		if (p[u] == 0)
		{
			r_g[v].push_back(u);
			h[u] = h[v] + 1;
			p[u] = v;
			dfs_create(u);
		}
		if (p[u] == v)
		{
			typ_p[u] += 2;
		}
	}
}

ll  dfs(ll  v)
{
	vector <ll > to;
	vector <ll > from;
	if (r_g[v].size() == 0)
	{
		if (g[v].size() == 1)
		{
			if (de_g[v].size() == 1)
			{
				ans.push_back({ v, p[v] });
				ans.push_back({ p[v], v });
				return 0;
			}
			return v;
		}
		if (de_g[v].size() == 1)
		{
			return -v;
		}
	}
	for (ll  u : r_g[v])
	{
		ll  t = dfs(u);
		if (t > 0)
			to.push_back(t);
		if (t < 0)
			from.push_back(t);
	}
	while (to.size() > 0 && from.size() > 0)
	{
		ll  x1 = *to.rbegin();
		ll  x2 = *from.rbegin();
		to.pop_back();
		from.pop_back();
		if (x1 == inf || x2 == inf)
			return inf;
		ans.push_back({  x1, v });
		ans.push_back({ v, -x2 });
	}
	if (to.size() == 1) {
		if (typ_p[v] >= 2)
		{
			ans.push_back({ to[0], v });
			ans.push_back({ v, p[v] });
		}
		else
			return inf;
		if (typ_p[v] % 2 == 1)
			return v;
		else
			return 0;

	}
	if (from.size() == 1) {
		if (typ_p[v] % 2 == 1)
		{
			ans.push_back({ p[v], v });
			ans.push_back({ v, -from[0] });
		}
		else
			return inf;
		if (typ_p[v] >= 2)
			return v;
		else
			return 0;
	}
}

int main()
{

#ifdef _DEBUG
	freopen("Text.txt", "r", stdin);
#endif // _DEBUG

	ios_base::sync_with_stdio();
	cin.tie(0);
	cout.tie(0);

	cin >> n >> m;
	ll  u, v;
	FOR(i, 1, m)
	{
		cin >> u >> v;
		g[u].push_back(v);
		de_g[v].push_back(u);
	}

	FOR(i, 1, n)
	{
		if (p[i] == 0) {
			p[i] = i;
			h[i] = 1;
			dfs_create(i);

			if (dfs(i) == inf)
			{
				cout << "No";
				return 0;
			}
		}
	}
	int jj = 0;
	cout << "Yes\n";
	for (auto u : ans)
	{
		jj++;
		cout << u.first << " " << u.second << " ";
		if (jj % 2 == 0)
			cout << '\n';
	}

}
