#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#define int long long
using namespace std;

const int INF = 1e18;

int n, m;
vector <vector <pair <int, int>>> g;
bool ok = true;

vector <pair <pair <int, int>, pair <int, int>>> ans;

pair <int, pair <int, int>> dfs(int u, int p = -1) { // -1 - down, 0 - zero, 1 - up
	pair <int, int> srem;
	pair <int, int> down, up;
	for (auto pp : g[u]) {
		int v = pp.first;
		int type = pp.second; // 1: u->v    0: v->u
		auto rem = dfs(v, u);

		if (rem.first == -1) {
			if (type == 1)
				ans.push_back({ {u, v}, rem.second });
			else
				ok = false;
		}
		else if (rem.first == 1) {
			if (type == 0)
				ans.push_back({ rem.second, { v, u } });
			else
				ok = false;
		}			
		else {
			if (type) {
				srem.first++;
				down = { u, v };
			}
			else {
				srem.second++;
				up = { u, v };
			}
		}
	}
	int k = min(srem.first, srem.second);
	srem.first -= k;
	srem.second -= k;
	if (srem.first == 1 && srem.second == 0)
		return { -1, down };
	if (srem.first == 0 && srem.second == 1)
		return { 1, up };
	if (srem.first == 0 && srem.second == 0)
		return { 0, down };
	ok = false;
	return { 0, down };
}

signed main() {
	//ios::sync_with_stdio(0);
	//cin.tie(0);
	//cout.tie(0);

	cin >> n >> m;
	g.resize(n);
	for (int i = 0; i < m; i++) {
		int u, v; cin >> u >> v; u--, v--;
		g[u].push_back({ v, 1 });
		g[v].push_back({ u, 0 });
	}
	
	auto rem = dfs(0);
	if (ok && rem.first == 0) {
		cout << "Yes" << endl;
		for (auto p : ans) {
			cout << p.first.first + 1 << ' ' << p.first.second + 1 << ' ' << p.second.first + 1 << ' ' << p.second.second + 1 << endl;
		}
	}
	cout << "No";

	return 0;
}

/*
4 4
1 2 1000000000
2 3 1
2 4 1
1 4 1000000000
*/