#ifdef DEBUG
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>

using namespace std;
using ll = long long;

#ifndef DEBUG
#define endl '\n'
#endif

void solve();

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
//    ll t;
//    cin >> t;
//    while (t--)
    solve();
}


vector<bool> used;

struct edge {
    ll u, v, t;
};

// map<u, edge_id>
vector<map<ll, vector<ll>>> gr;
vector<map<ll, ll>> mxe, mne;
vector<edge> edges;

vector<ll> ans;

ll test_group = 1;

void dfs(ll v, ll mn = 1e18, ll mx = 0) {
    if (v != 0) {
        ans[v] = min(ans[v], mn + mx);
    }
    for (auto[u, eids]: gr[v]) {
        for (auto eid: eids) {
            if (!used[eid]) {
                used[eid] = true;
                dfs(u, min(mn, edges[eid].t), max(mx, edges[eid].t));
                used[eid] = false;
            }
        }
    }
}

void solve() {
    ll n, m;
    cin >> n >> m;
    used.resize(m);
    ans.resize(n, 1e18);
    gr.resize(n);
    bool tst2 = true, tst3 = true;
    for (int i = 0; i < m; ++i) {
        ll u, v, t;
        cin >> u >> v >> t;
        --u, --v;
        if ((u == 1 or v == 1) and t != 0) tst2 = false;
        if ((u == 1 or v == 1) and t != 1e9) tst3 = false;
        gr[u][v].push_back(i);
        gr[v][u].push_back(i);
        edges.push_back({u, v, t});
    }
    if (tst2) test_group = 2;
    if (tst3) test_group = 3;
    dfs(0);
    for (int i = 1; i < n; ++i) {
        cout << ans[i] << endl;
    }
}

//3 3
//1 2 2
//1 3 1
//2 3 1
