#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <string>
#include <algorithm>
#include <map>
#include <vector>

using namespace std;

#define endl '\n'

const int Base = 3e5 + 10;
const long long inf = 1e18;

struct Gadged
{
	int x1, y1;
	int x2, y2;
};

map<pair<int, int>, int> wasE;
int n, m;
vector<pair<int, int>> e[Base];
bool dp[Base][5];
int rec[Base][5];
bool used[Base];
vector<Gadged> ans;

void upd(int id, int x, int y)
{
	int d = 0;
	if (x == y)
	{
		d = 0;
	}
	else if (x + 1 == y)
	{
		d = 2;
	}
	else if (x == y + 1)
	{
		d = 1;
	}
	else
	{
		return;
	}
	dp[id][d] = true;
	if (x == y && x > 0)
	{
		d = 3;
	}
	dp[id][d] = true;
}

void cntDp(int x, int p)
{
	used[x] = true;

	if (e[x].size() == 1 && p != 0)
	{
		dp[x][0] = true;
		return;
	}

	for (auto v : e[x])
	{
		if (v.first != p)
		{
			cntDp(v.first, x);
		}
	}

	int cnt1 = 0, cnt2 = 0;
	int float10 = 0;
	int float01 = 0;
	bool float11 = false;
	for (auto v : e[x])
	{
		if (v.first != p)
		{
			bool can11 = false;
			bool can01 = false;
			bool can10 = false;
			bool can00 = false;
			if (v.second == 3 && dp[v.first][0])
			{
				can11 = true;
			}
			if (dp[v.first][v.second])
			{
				can00 = true;
			}
			if ((v.second == 1 && dp[v.first][0]) || (v.second == 3 && dp[v.first][2]))
			{
				can10 = true;
			}
			if ((v.second == 2 && dp[v.first][0]) || (v.second == 3 && dp[v.first][1]))
			{
				can01 = true;
			}

			if (!can11 && !can01 && !can10 && !can00)
			{
				return;
			}
			else if (can11 && !can01 && !can10 && !can00)
			{
				cnt1++;
				cnt2++;
			}
			else if (!can11 && can01 && !can10 && !can00)
			{
				cnt2++;
			}
			else if (!can11 && !can01 && can10 && !can00)
			{
				cnt1++;
			}
			else if (!can11 && !can01 && !can10 && can00)
			{
				//
			}
			else if (can11 && can01 && !can10 && !can00)
			{
				cnt2++;
				float10++;
			}
			else if (can11 && !can01 && can10 && !can00)
			{
				cnt1++;
				float01++;
			}
			else if (can11 && !can01 && !can10 && can00)
			{
				float11 = true;
			}
			else if (!can11 && can01 && can10 && !can00)
			{
				float11 = true;
			}
			else if (!can11 && can01 && !can10 && can00)
			{
				float01++;
			}
			else if (!can11 && !can01 && can10 && can00)
			{
				float10++;
			}
		}
	}

	if (float01 && float10)
	{
		float11 = true;
	}

	if (float11)
	{
		cnt1++;
		cnt2++;
	}

	if (cnt1 < cnt2)
	{
		if (float10 >= cnt2 - 1 - cnt1)
		{
			float10 -= cnt2 - 1 - cnt1;
			cnt1 = cnt2 - 1;
		}
		else
		{
			return;
		}
		upd(x, cnt1, cnt2);
		if (float10 >= 1)
		{
			float10 -= 1;
			cnt1 = cnt2;
		}
		else
		{
			return;
		}
		upd(x, cnt1, cnt2);
		if (float10 >= 1)
		{
			float10 -= 1;
			cnt1 = cnt2 + 1;
		}
		else
		{
			return;
		}
		upd(x, cnt1, cnt2);
	}
	else if (cnt2 < cnt1)
	{
		if (float01 >= cnt1 - 1 - cnt2)
		{
			float01 -= (cnt1 - 1 - cnt2);
			cnt2 = cnt1 - 1;
		}
		else
		{
			return;
		}
		upd(x, cnt1, cnt2);
		if (float01 >= 1)
		{
			float01 -= 1;
			cnt2 = cnt1;
		}
		else
		{
			return;
		}
		upd(x, cnt1, cnt2);
		if (float01 >= 1)
		{
			float01 -= 1;
			cnt2 = cnt1 + 1;
		}
		else
		{
			return;
		}
		upd(x, cnt1, cnt2);
	}
	else
	{
		if (float01 > 0)
		{
			cnt2++;
			upd(x, cnt1, cnt2);
			cnt2--;
		}
		if (float10 > 0)
		{
			cnt1++;
			upd(x, cnt1, cnt2);
			cnt1--;
		}
		upd(x, cnt1, cnt2);
	}
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif // _DEBUG

	ios_base::sync_with_stdio(0);
	cin.tie(0);

	cin >> n >> m;

	for (int i = 0; i < m; i++)
	{
		int a, b;
		cin >> a >> b;
		int d = 1;
		if (a > b)
		{
			d = 10;
			swap(a, b);
		}
		wasE[make_pair(a, b)] += d;
	}

	int cl = 0;
	pair<int, int> del[4];

	for (auto k : wasE)
	{
		if (k.second == 1)
		{
			del[cl++] = (k.first);
		}
		if (k.second == 10)
		{
			del[cl++] = (make_pair(k.first.second, k.first.first));
		}
	}

	if (cl == 0)
	{
		cout << "Yes" << endl;
		for (auto k : wasE)
		{
			cout << k.first.first << ' ' << k.first.second << ' ' << k.first.second << ' ' << k.first.first << endl;
		}
		return 0;
	}

	while (next_permutation(del, del + 4))
	{
		if (del[0].second == del[1].first && del[2].second == del[3].first)
		{
			cout << del[1].second << ' ' << del[1].first << ' ' << del[0].second << ' ' << del[0].first << endl;
			cout << del[3].second << ' ' << del[3].first << ' ' << del[2].second << ' ' << del[2].first << endl;
			for (auto k : wasE)
			{
				if (k.second == 11)
				{
					cout << k.first.first << ' ' << k.first.second << ' ' << k.first.second << ' ' << k.first.first << endl;
				}
			}
			return 0;
		}
	}

	cout << "No" << endl;
}