#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
#define pb push_back
#define pll pair<ll, ll>

const ll inf = ll(4e18) + 123;
const ll maxn = ll(3e5) + 5;

ll n, m;
vector<pll> gr[maxn];

vector<ll> ans(maxn, 0);

void dfs_on_tree(ll v, ll par, ll mn, ll mx) {
    ans[v] = mn + mx;
    for(auto el : gr[v]) {
        if(el.first == par) continue;

        ll nw_mn = min(mn, el.second);
        ll nw_mx = max(mx, el.second);

        dfs_on_tree(el.first, v, nw_mn, nw_mx);
    }
}

void solve() {
    cin >> n >> m;
    for(ll i = 0; i < m; i++) {
        ll v, u, t;
        cin >> v >> u >> t;
        v--;
        u--;
        gr[v].pb({u, t});
        gr[u].pb({v, t});
    }

    if(m == n - 1) {
        dfs_on_tree(0, -1, inf, -inf);
        for(ll i = 1; i < n; i++) {
            cout << ans[i] << "\n";
        }
        return;
    }
}

int main()
{
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    solve();

    return 0;
}
