#define _CRT_SECURE_NO_WARNINGS

#pragma GCC optimize("Ofast")

#include <iostream>
#include <algorithm>
#include <fstream>
#include <cmath>
#include <math.h>
#include <fstream>
#include <set>
#include <vector>
#include <queue>
#include <iomanip>
#include <string>

using namespace std;

#define ll long long
#define BE(x) x.begin(), x.end()
#define endl '\n'

const int N = 5e5;
const int bes = 1e9;

struct E
{
	int from, to, t;
};

vector<E> e[N];
int ans[N];
bool used[N];

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < m; i++)
	{
		int a, b, t;
		cin >> a >> b >> t;
		a--;
		b--;
		e[a].push_back({ a,b,t });
		e[b].push_back({ b,a,t });
	}
	set<pair<int, int>> s;
	s.insert({ bes + 1,0 });
	while (!s.empty())
	{
		auto [now, i] = *s.begin();
		s.erase(s.begin());
		if (!used[i])
		{
			used[i] = true;
			ans[i] = now;
			for (E j : e[i])
			{
				if (!used[j.to])
				{
					s.insert({ min(now,j.t),j.to });
				}
			}
		}
	}
	for (int i = 1; i < n; i++)
	{
		cout << ans[i] + bes << endl;
	}
}