#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

const int N = 3e5 + 7;
const int T = 1e9;

int n, m;
struct Edge {
    int u, v, t;
} e[N];
vector<pair<int, int>> g[N];
int d[N];

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        cin >> e[i].u >> e[i].v >> e[i].t;
        --e[i].u, --e[i].v;
        g[e[i].u].push_back({e[i].v, e[i].t});
        g[e[i].v].push_back({e[i].u, e[i].t});
    }
    for (int i = 1; i < n; ++i) d[i] = T;
    d[0] = 0;
    priority_queue<pair<int, int>, vector<pair<int, int>>, greater<pair<int, int>>> q;
    q.push({0, 0});
    while (!q.empty()) {
        auto pp = q.top();
        q.pop();
        int v = pp.second;
        if (d[v] != pp.first) continue;
        for (auto x : g[v]) {
            int u = x.first, t = x.second;
            if (max(d[v], t) < d[u]) {
                d[u] = max(d[v], t);
                q.push({d[u], u});
            }
        }
    }
    for (int i = 1; i < n; ++i) cout << d[i] << " ";
    cout << endl;
    return 0;
}
