#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <stack>

using namespace std;

//#define endl '\n'
#define int long long

int cur = LLONG_MIN;
string example;

int count(string str)
{
	vector<int> all(26, 0);
	int sum = 0;

	for (int i = 0; i < str.size(); i++)
	{
		int j = str[i] - 'A';
		sum += (j % 2 == 1 ? 5 : 1) * (int)pow(10, j / 2);
		all[j]++;
		for (int k = 0; k < j; k++)
		{
			sum -= 2 * all[k] * (k % 2 == 1 ? 5 : 1) * (int)pow(10, k / 2);
			all[k] = 0;
		}
	}

	return sum;
}

void rec(string str, int pos)
{
	if (pos == str.size())
	{
		if (count(str) > cur)
		{
			cur = count(str);
			example.clear();
			example = str;
		}
	}
	else
	{
		if (str[pos] != '?')
		{
			rec(str, pos + 1);
		}
		else
		{
			for (int i = 0; i < 26; i++)
			{
				str[pos] = 'A' + i;
				rec(str, pos + 1);
			}
		}
	}
}

void task()
{
	int n;
	cin >> n;

	for (int t = 0; t < n; t++)
	{
		string str;
		cin >> str;

		cur = LLONG_MIN;
		example.clear();
		rec(str, 0);

		cout << cur << endl << example << endl;
	}
}

long main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	task();

	return 0;
}