#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ft first
#define sd second
#define pb push_back
#define eb emplace_back
#define all(x) (x).begin(), (x).end()

const int INF = 1e9 + 1;

void dfs1(int i, int par, vector<int> &mn, vector<int> &mx, vector<vector<pair<int, int>>> &graph){
    for (auto edge : graph[i]){
        if (edge.ft == par)
            continue;
        mn[edge.ft] = min(mn[i], edge.sd);
        mx[edge.ft] = max(mx[i], edge.sd);
        dfs1(edge.ft, i, mn, mx, graph);
    }
}

signed main(){
    cin.tie(0);
    ios_base::sync_with_stdio(false);
    int n, m;
    cin >> n >> m;
    vector<vector<pair<int, int>>> graph(n);
    int a, b, w;
    for (int i = 0; i < m; i++){
        cin >> a >> b >> w;
        a--; b--;
        graph[a].eb(b, w);
        graph[b].eb(a, w);
    }
    if (m == n - 1){
        vector<int> mn(n, INF);
        vector<int> mx(n, -INF);
        dfs1(0, 0, mn, mx, graph);
        for (int i = 1; i < n; i++)
            cout << mn[i] + mx[i] << "\n";
    }
    return 0;
}