#include <bits/stdc++.h>

using namespace std;

vector<pair<int, int>> g[300000];
vector<int> ans(300000);

void dfs(int v, int now_min = -1, int now_max = -1, int p = -1) {
	ans[v] = now_min + now_max;
	for (auto u: g[v]) {
		if (p == -1) {
			dfs(u.first, u.second, u.second, v);
			continue;
		}
		if (u.first != p) {
			dfs(u.first, min(now_min, u.second), max(now_max, u.second), v);
		}
	}
}
signed main() {
	ios_base::sync_with_stdio(NULL);
	cin.tie(NULL);
	cout.tie(NULL);
	int n, m;
	cin >> n >> m;
	vector<pair<int, pair<int, int>>> edges;
	for (int i = 0; i < m; i++) {
		int a, b, c;
		cin >> a >> b >> c;
		a--;
		b--;
		edges.push_back(make_pair(c, make_pair(a, b)));
		g[a].push_back(make_pair(b, c));
		g[b].push_back(make_pair(a, c));
	}

	if (n == m + 1) {
		dfs(0);
		for (int i = 1; i < n; i++) {
			cout << ans[i] << " ";
		}
		return 0;
	}

	if (g[0][0].second == 0) {
		vector<int> d(n, 2000000000);
		d[0] = 0;
		set<pair<int, int>> s;
		s.insert(make_pair(0, d[0]));
		while (s.size() != 0) {
			int v = (*s.begin()).second;
			s.erase(s.begin());
			for (auto u: g[v]) {
				if (d[u.first] > max(u.second, d[v])) {
					if (d[u.first] != 2000000000) {
						s.erase(make_pair(d[u.first], u.first));
					}
					d[u.first] = max(u.second, d[v]);
					s.insert(make_pair(d[u.first], u.first));
				}
			}
		}
		for (int i = 1; i < n; i++) {
			cout << d[i] << " ";
		}
		return 0;
	}
	if (g[0][0].second == 1000000000) {
		return 0;
	}
	if (n <= 10 && m <= 10) {
		vector<int> ans(10, 10000000);
		vector<int> inds(m);
		for (int i = 0; i < m; i++) {
			inds[i] = i;
		}
		do {
			int now = 0;
			int now_min = -1;
			int now_max = -1;

			for (int i = 0; i < inds.size(); i++) {
				int a = edges[inds[i]].second.first;
				int b = edges[inds[i]].second.second;
				int c = edges[inds[i]].first;
				if (a != now) {
					swap(a, b);
					if (a != now) {
						break;
					}
				}
				if (now_min == -1) {
					now_max = c;
					now_min = c;
				} else {
					now_max = max(now_max, c);
					now_min = min(now_min, c);
				}
				now = b;
				ans[b] = min(ans[b], now_min + now_max);
			}
		} while (next_permutation(inds.begin(), inds.end()));
		for (int i = 1; i < n; i++) {
			cout << ans[i] << endl;
		}
	}
}