#pragma GCC optimize("O3")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("unroll-loops")
//#pragma GCC target("avx2")

#define ll long long
#define u unsigned
#define frr(x,y) for(int y=0;y<int(x);y++)
#define fr(x) frr(x,i)
#define frin fr(n)

#include <iostream>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <queue>
#include <vector>
#include <cassert>
#include <string>
#include <bitset>

using namespace std;

struct egg {
	int v, f, r;
	bool frt;
	egg(int a = 0, int b = 0, int c = 0, bool d=0)
	{
		v = a, f = b, r = c,frt=d;
	}
};

ll n, m, k, t, x, y, z, a, b, c, d, l, r;
vector<int>f, p, dp;

vector<pair<int, int>>edge;
vector<vector<int>>g;
vector<vector<egg>>dg;
vector<vector<int>>to;

vector<int>used;

inline void mrb(int fr, int to)
{
	dg[fr].push_back(egg(to, 1, dg[to].size(),1));
	dg[to].push_back(egg(fr, 0, dg[fr].size() - 1,0));
}


inline void dfs(int v, bool d = 0)
{
	if (!d)
	{
		mrb(0, v + 1);
	}
	else
	{
		mrb(v + 1, m + 1);
	}
	used[v] = 1;
	for (auto& x : g[edge[v].second])
	{
		if(!d)
				mrb(v + 1, x + 1);
		if (!used[x])
		{
			
			dfs(x,!d);
		}
	}
	for (auto& x : to[edge[v].first])
	{
		if(!d)
				mrb(v + 1, x + 1);
		if (!used[x])
		{
			
			dfs(x,!d);
		}
	}
}

inline bool bfs()
{
	dp.assign(m + 2, 0);
	queue<int>q;
	q.push(0);
	while (!q.empty())
	{
		int v = q.front();
		q.pop();
		for (auto& x : dg[v])
		{
			if (x.v && !dp[x.v] && x.f)
			{
				dp[x.v] = dp[v] + 1;
				if (x.v == m + 1)
					return 1;
				q.push(x.v);
			}
		}
	}
	return 0;
}

inline bool dinitz(int v)
{
	if (v == m + 1)
		return 1;
	for(auto& x:dg[v])
	{
		if (used[x.v]!=t+1&&x.f && dp[v] + 1 == dp[x.v])
		{
			if (dinitz(x.v))
			{
				x.f = 0;
				dg[x.v][x.r].f = 1;
				return 1;
			}
		}
 	}
	used[v] = t+1;
	return 0;
}

int main()
{
	ios::sync_with_stdio(0);
	cin.tie();
	cout.tie();
	cin >> n >> m;
	g.resize(n);
	to.resize(n);
	p.resize(m);
	used.resize(m + 2);
	fr(m)
	{
		cin >> a >> b;
		a--, b--;
		edge.push_back({ a,b });
		g[a].push_back(i);
		to[b].push_back(i);
	}
	dg.resize(m + 2);
	fr(m)
		if(!used[i])
			dfs(i);
	p.assign(m, -1);
	c = 0;
	used.assign(m + 2, 0);
	t = 0;
	while (bfs())
	{
		while(dinitz(0))
		c++;
		t++;
	}
	if (c != m / 2)
	{
		cout << "No";
		return 0;
	}
	fr(m + 1)
	{
		if(i)
			for (auto& x : dg[i])
			{
				if (x.frt && !x.f&&x.v<=m)
				{
					p[x.v-1] = i-1;
				}
			}
	}
	cout << "Yes\n";
	fr(m)
	{
		if (p[i]!=-1)
		{
			if (edge[p[i]].second == edge[i].first)
				cout << edge[p[i]].first + 1 << " " << edge[p[i]].second + 1 << " " << edge[i].first + 1 << " " << edge[i].second + 1 << "\n";
			else if (edge[i].second == edge[p[i]].first)
				cout << edge[i].first + 1 << " " << edge[i].second + 1 << " " << edge[p[i]].first + 1 << " " << edge[p[i]].second + 1 << "\n";
			else
				assert(false);
		}
	}

}
