#include <bits/stdc++.h>
#pragma optimaze("Ofast")
using namespace std;

typedef long long ll;


#define mmp make_pair


map<pair<int, int>, int> mp;



const int maxn = 150000;
char dp[maxn][3];
vector<vector<int>> g(maxn);
vector<char> used(maxn), usd(maxn);

/*void dfs(int v) {
    used[v] = true;
    int cntup = 0, cntdwn = 0;
    bool dead = false;
    dp[v][0] = false;
    dp[v][1] = false;
    dp[v][2] = false;
    for (auto to : g[v]) {
        if (used[to]) continue;
        dfs(to);
        int t1 = mp[{v, to}], t2 = mp[{to, v}];
        if (t1 && t2) {
            if (dp[to][0]) {
                continue;
            }
            if (dp[to][1]) {
                cntup++;
                continue;
            }
            if (dp[to][2]) {
                cntdwn++;
                continue;
            }
            dead = true;
            continue;
        }
        if (t1) {
            if (dp[to][0]) {
                cntdwn++;
                continue;
            }
            if (dp[to][1]) {
                continue;
            }
            dead = true;
            continue;
        }
        if (t2) {
            if (dp[to][0]) {
                cntup++;
                continue;
            }
            if (dp[to][2]) {
                continue;
            }
            dead = true;
            continue;
        }
    }

    // cout << v << " " << cntup << " " << cntdwn << endl;
    // cout << dead << endl;
    if (dead) {
        return;
    }
    if (cntup == cntdwn) {
        dp[v][0] = true;
        return;
    }
    if (cntup == cntdwn + 1) {
        dp[v][2] = true;
        return;
    }
    if (cntdwn == cntup + 1) {
        dp[v][1] = true;
        return;
    }
    return;
}*/


pair<int, int> walk(int v, vector<pair<pair<int, int>, pair<int, int>>> & ans) {
    vector<int> cntup, cntdwn;
    usd[v] = true;
    dp[v][0] = false;
    dp[v][1] = false;
    dp[v][2] = false;
    bool dead = false;
    for (auto to : g[v]) {
        if (usd[to]) continue;
        pair<int, int> tt = walk(to, ans);
        int t1 = mp[{v, to}], t2 = mp[{to, v}];
        if (t1 && t2) {
            if (dp[to][0]) {
                ans.emplace_back(mmp(to, v), mmp(v, to));
                continue;
            }
            if (dp[to][1]) {
                ans.emplace_back(mmp(v, to), tt);
                cntup.push_back(to);
                continue;
            }
            if (dp[to][2]) {
                ans.emplace_back(tt, mmp(to, v));
                cntdwn.push_back(to);
                continue;
            }
            dead = true;
            continue;
        }
        if (t1) {
            if (dp[to][0]) {
                cntdwn.push_back(to);
                continue;
            }
            if (dp[to][1]) {
                ans.emplace_back(mmp(v, to), tt);
                continue;
            }
            dead = true;
            continue;
        }
        if (t2) {
            if (dp[to][0]) {
                cntup.push_back(to);
                continue;
            }
            if (dp[to][2]) {
                ans.emplace_back(tt, mmp(to, v));
                continue;
            }
            dead = true;
            continue;
        }
    }
    if (dead) return {-1, -1};
    if (cntup.size() == cntdwn.size()) {
        int nn = cntup.size();
        for (int i = 0; i < nn; i++) {
            ans.emplace_back(mmp(cntup[i], v), mmp(v, cntdwn[i]));
        }
        dp[v][0] = true;
        return {-1, -1};
    }
    if (cntup.size() + 1 == cntdwn.size()) {
        int nn = cntup.size();
        for (int i = 0; i < nn; i++) {
            ans.emplace_back(mmp(cntup[i], v), mmp(v, cntdwn[i]));
        }
        dp[v][1] = true;
        return {v, cntdwn.back()};
    }

    if (cntup.size() == cntdwn.size() + 1) {
        int nn = cntdwn.size();
        assert(cntup.size() == nn + 1);
        for (int i = 0; i < nn; i++) {
            ans.emplace_back(mmp(cntup[i], v), mmp(v, cntdwn[i]));
        }
        dp[v][2] = true;
        return {cntup.back(), v};
    }
    return {-1, -1};
}






int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    int n, m; cin >> n >> m;
    for (int i = 0; i < m; i++) {
        int a, b; cin >> a >> b;
        a--; b--;
        if (!mp[make_pair(b, a)]) {
            g[a].push_back(b);
            g[b].push_back(a);
        }
        mp[make_pair(a, b)] = i + 1;
    }
    vector<pair<pair<int, int>, pair<int, int>>> ans;
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            walk(i, ans);
            if (!dp[i][0]) {
                cout << "No" << endl;
                return 0;
            }
        }
    }
    cout << "Yes" << endl;

    for (auto el : ans) {
        pair<int, int> i1 = el.first, i2 = el.second;
        cout << i1.first + 1 << " " << i1.second + 1 << " ";
        cout << i2.first + 1 << " " << i2.second + 1 << endl;
    }




    return 0;
}
