#include <bits/stdc++.h>
// #pragma optimaze("Ofast")
using namespace std;

typedef long long ll;


int maxn = 3e5;
vector<vector<int>> gg(maxn);
vector<bool> b(maxn);
vector<int> fup(maxn), h(maxn), pr(maxn);
vector<bool> used(maxn);


void dfs(int v, int p, int depth) {
    h[v] = depth;
    fup[v] = depth;
    used[v] = true;
    pr[v] = p;
    int cnt = 0;
    for (auto to : gg[v]) {
        if (to == p && !cnt) {cnt++; continue;}
        if (!used[to]) {
            dfs(to, v, depth + 1);
            if (fup[to] == depth + 1) {
                b[to] = true;
            }
            if (fup[to] < fup[v]) {
                fup[v] = fup[to];
            }
        } else {
            if (h[to] < fup[v]) {
                fup[v] = h[to];
            }
        }
    }
    return;
}

vector<vector<pair<int, int>>> ng(maxn);
vector<bool> usd(maxn);
vector<int> col(maxn, -1);
vector<pair<int, int>> my;


pair<int, int> walk(int v, int c) {
    col[v] = c;
    pair<int, int> ans = {1e9, 0};
    for (auto eg : ng[v]) {
        int to = eg.first, t = eg.second;
        if (col[to] == -1) {
            pair<int, int> nans = walk(to, c);
            ans.first = min(ans.first, nans.first);
            ans.second = max(ans.second, nans.second);
        }
        ans.first = min(ans.first, t);
        ans.second = max(ans.second, t);
    }
    return ans;
}

vector<vector<pair<int, int>>> tg(maxn);
vector<int> mn(maxn, 1e9), mx(maxn);

void dfss(int v, int p) {
    mn[v] = min(mn[v], my[v].first);
    mx[v] = max(mx[v], my[v].second);
    for (auto to : tg[v]) {
        if (to.first != p) {
            mn[to.first] = min(mn[v], to.second);
            mx[to.first] = max(mx[v], to.second);
            dfss(to.first, v);
        }
    }
    return;
}


int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    int n, m; cin >> n >> m;
    vector<vector<pair<int, int>>> g(n);
    for (int i = 0; i < m; i++) {
        int a, b, c; cin >> a >> b >> c;
        a--; b--;
        g[a].emplace_back(b, c);
        g[b].emplace_back(a, c);
        gg[a].push_back(b);
        gg[b].push_back(a);
    }
    int inf = 1e9;
    dfs(0, -1, 0);
    for (int i = 0; i < n; i++) {
        for (auto to : g[i]) {
            int j = to.first;
            if ((pr[i] == j && b[i]) || (pr[j] == i && b[j])) continue;
            ng[i].push_back(to);
        }
    }
    int cnt = 0;
    for (int i = 0; i < n; i++) {
        if (col[i] == -1) {
            my.push_back(walk(i, cnt)); cnt++;
        }
    }
    for (int i = 0; i < n; i++) {
        for (auto to : g[i]) {
            int j = to.first;
            if (col[i] != col[j]) {
                tg[col[i]].emplace_back(col[j], to.second);
            }
        }
    }
    dfss(0, -1);
    for (int i = 1; i < n; i++) cout << mn[col[i]] + mx[col[i]] << endl;
    return 0;
}
