#include <bits/stdc++.h>
#define all(x) (x).begin(), (x).end()

using namespace std;

const int N = 510;
bool dp[N][N];


signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, q;
    cin >> n >> q;

    vector <int> h(n), x(n);

    for (int i = 0; i < n; i++) {
        int a, b;
        cin >> a >> b;
        x[i] = a, h[i] = b;
    }

    for (int ln = 0; ln < n; ln++) {
        for (int st = 0; st + ln < n; st++) {
            int last = st + ln;

            int left = (st == 0 ? x[st] : x[st - 1]);
            int right = (last == n - 1 ? x[last] : x[last + 1]);

            for (int i = st; i <= last; i++) {
                bool leftok = (i == st || dp[st][i - 1]);
                bool rightok = (i == last || dp[i + 1][last]);
                if (leftok && rightok && (x[i] - left >= h[i] || right - x[i] >= h[i])) {
                    dp[st][last] = true;
                    break;
                }
            }
        }
    }

    while (q--) {
        int a, b;
        cin >> a >> b;
        a--, b--;

        int ans = 0;
        for (int i = a; i <= b; i++) {
            bool ok = false;

            if (dp[a][i])
                ok = true;
            if (dp[i][b])
                ok = true;

            if (ok)
                ans++;
        }
        cout << ans << endl;
    }
    return 0;
}
