#include <bits/stdc++.h>
#define all(x) (x).begin(), (x).end()

using namespace std;


signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m;
    cin >> n >> m;

    vector <array <int, 3>> edges;
    for (int i = 0; i < m; i++) {
        int a, b, t;
        cin >> a >> b >> t;
        a--, b--;
        edges.push_back({a, b, t});
    }

    vector <int> ans(n, INT_MAX);

    for (int mask = 0; mask < (1 << m); mask++) {
        vector <pair <int, int>> g[n];
        for (int i = 0; i < m; i++) {
            if ((mask >> i) & 1) {
                g[edges[i][0]].emplace_back(edges[i][1], edges[i][2]);
                g[edges[i][1]].emplace_back(edges[i][0], edges[i][2]);
            }
        }

        int mn = INT_MAX, mx = INT_MIN;

        int now = 0;
        while (!g[now].empty()) {
            mn = min(mn, g[now].back().second);
            mx = max(mx, g[now].back().second);
            int v = g[now].back().first;
            g[v].erase(find(all(g[v]), make_pair(now, g[now].back().second)));
            g[now].pop_back();
            now = v;
        }

        ans[now] = min(ans[now], mn + mx);
    }

    for (int i = 1; i < n; i++) {
        cout << ans[i] << "\n";
    }
    return 0;
}
