#include <bits/stdc++.h>
#define all(x) (x).begin(), (x).end()

using namespace std;


signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m;
    cin >> n >> m;

    vector <array <int, 3>> edges;
    for (int i = 0; i < m; i++) {
        int a, b, t;
        cin >> a >> b >> t;
        a--, b--;
        edges.push_back({a, b, t});
    }

    vector <int> ans(n, INT_MAX);

    for (int mask = 0; mask < (1 << m); mask++) {
        vector <vector <int>> g(n);

        int mn = INT_MAX, mx = INT_MIN;

        for (int i = 0; i < m; i++) {
            if ((mask >> i) & 1) {
                mn = min(mn, edges[i][2]);
                mx = max(mx, edges[i][2]);
                g[edges[i][0]].push_back(edges[i][1]);
                g[edges[i][1]].push_back(edges[i][0]);
            }
        }

        vector <int> odd;
        for (int i = 0; i < n; i++) {
            if (g[i].size() % 2 == 1) {
                odd.push_back(i);
            }
        }

        if (odd.size() == 2 && odd[0] == 0) {
            int nw = odd[1];
            vector <int> used(n, 0);
            used[0] = 1;
            vector <int> x = {0};
            while (!x.empty()) {
                int v = x.back();
                x.pop_back();

                for (int i : g[v]) {
                    if (!used[i]) {
                        used[i] = true;
                        x.push_back(i);
                    }
                }
            }

            bool ok = true;
            for (int i = 0; i < n; i++) {
                if (!g[i].empty() && !used[i]) {
                    ok = false;
                }
            }
            if (ok)
                ans[nw] = min(ans[nw], mn + mx);
        }
    }

    for (int i = 1; i < n; i++) {
        cout << ans[i] << "\n";
    }
    return 0;
}
