#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <numeric>
#include <cmath>
#include <set>
#include <map>

using namespace std;

const int INF = 2e9;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, q;
    cin >> n >> q;
    vector<int> x(n), h(n);
    for (int i = 0; i < n; ++i) {
        cin >> x[i] >> h[i];
    }
    while (q--) {
        int l, r;
        cin >> l >> r;
        --l;
        --r;
        int ans = 0;
        vector<pair<int, int>> stack;
        stack.emplace_back((l == 0 ? x[0] : x[l - 1]), INF);
        for (int i = l; i <= r; ++i) {
            while (stack.back().second <= x[i]) {
                ++ans;
                stack.pop_back();
            }
            if (x[i] - h[i] >= stack.back().first) {
                ++ans;
            }
            else {
                stack.emplace_back(x[i], x[i] + h[i]);
            }
        }
        int end = (r == n - 1 ? x[n - 1] : x[r + 1]);
        while (stack.back().second <= end) {
            ++ans;
            stack.pop_back();
        }
        cout << ans << "\n";
    }

    return 0;
}
