#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <cassert>
#include <cmath>
#include <cstring>

using namespace std;

#define int long long
#define fi first
#define se second
#define all(x) x.begin(),x.end()


int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, q;
    cin >> n >> q;
    vector<int> x(n), h(n), nx(n, -1), ls(n, n);
    for (int i = 0; i < n; ++i) {
        cin >> x[i] >> h[i];
    }

    for (int i = 0; i < n; ++i) {
        for (int j = i+1; j < n; ++j) {
            if (x[j] - x[i] < h[i]) {
                nx[i] = j;
            } else break;
        }

        for (int j = i-1; j >= 0; --j) {
            if (x[i] - x[j] < h[i]) {
                ls[i] = j;
            } else break;
        }
    }

    vector<char> used(n, 1);
    while (q-->0) {
        int l, r;
        cin >> l >> r;
        l--; r--;

        int cnt = 0;
        bool ok = 1;
        while (ok) {
            ok = 0;
            for (int i = l; i <= r; ++i) {
                if (used[i] == 0 || x[n-1]-x[i] < h[i]) continue;
                int g = 0;
                for (int j = i+1; j <= nx[i]; ++j) {
                    g += used[j];
                    if (g > 0) break;
                }
                if (g == 0) {
                    used[i] = 0;
                    cnt++;
                    ok = 1;
                }
            }
            for (int i = l; i <= r; ++i) {
                if (used[i] == 0 || x[i]-x[0] < h[i]) continue;
                int g = 0;
                for (int j = i-1; j >= ls[i]; --j) {
                    g += used[j];
                    if (g > 0) break;
                }
                if (g == 0) {
                    used[i] = 0;
                    cnt++;
                    ok = 1;
                }
            }
        }
        for (int i = l; i <= r; ++i) used[i] = 1;
        cout << cnt << "\n";
    }


}