#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <cassert>
#include <cmath>
#include <cstring>

using namespace std;

#define int long long
#define fi first
#define se second
#define all(x) x.begin(),x.end()

vector<vector<pair<int,int>>> gr;
vector<int> ans;

void dfs(int v, int mn = 1e9, int mx = -1e9, int p=-1) {
    ans[v] = mn + mx;
    for (auto [i, c] : gr[v]) {
        if (i != p) {
            dfs(i, min(mn, c), max(mx, c), v);
        }
    }
}

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    gr.resize(n);
    ans.resize(n);
    for (int i = 0; i < m; ++i) {
        int u, v, c;
        cin >> u >> v >> c;
        u--; v--;
        gr[u].push_back({v, c});
        gr[v].push_back({u, c});
    }
    dfs(0);
    for (int i = 1; i < n; ++i) cout << ans[i] << "\n";
}
