#include <bits/stdc++.h>

#define int long long

using namespace std;

vector<vector<int>> gr;
vector<vector<int>> rg;
vector<vector<int>> tree;
vector<int> used;
vector<pair<pair<int, int>, pair<int, int>>> ans;

bool flag;

pair<set<int>, set<int>> dfs(int v, int par) {
    used[v] = 1;
    pair<set<int>, set<int>> in_out;
    for (auto u : tree[v]) {
        if (!used[u]) {
            auto [in, out] = dfs(u, v);
            for (auto k : in) {
                in_out.second.insert(k);
            }
            for (auto k : out) {
                in_out.first.insert(k);
            }
        }
    }
    for (int i = 0; i < min(in_out.first.size(), in_out.second.size()); ++i) {
        ans.emplace_back(make_pair(*in_out.first.begin(), v), make_pair(v, *in_out.second.begin()));
        in_out.first.erase(in_out.first.begin());
        in_out.second.erase(in_out.second.begin());
    }
    if (in_out.first.empty() && in_out.second.empty()) {
        if (par != -1) {
            if (find(gr[v].begin(), gr[v].end(), par) != gr[v].end()) {
                in_out.second.insert(par);
            }
            if (find(gr[par].begin(), gr[par].end(), v) != gr[par].end()) {
                in_out.first.insert(par);
            }
        }
        for (int i = 0; i < min(in_out.first.size(), in_out.second.size()); ++i) {
            ans.emplace_back(make_pair(*in_out.first.begin(), v), make_pair(v, *in_out.second.begin()));
            in_out.first.erase(in_out.first.begin());
            in_out.second.erase(in_out.second.begin());
        }
    } else if (!in_out.first.empty()) {
        if (par != -1) {
            if (find(gr[v].begin(), gr[v].end(), par) != gr[v].end()) {
                in_out.second.insert(par);
            }
        }
        for (int i = 0; i < min(in_out.first.size(), in_out.second.size()); ++i) {
            ans.emplace_back(make_pair(*in_out.first.begin(), v), make_pair(v, *in_out.second.begin()));
            in_out.first.erase(in_out.first.begin());
            in_out.second.erase(in_out.second.begin());
        }
        if (par != -1) {
            if (find(gr[par].begin(), gr[par].end(), v) != gr[par].end()) {
                in_out.first.insert(par);
            }
        }
    } else if (!in_out.second.empty()) {
        if (par != -1) {
            if (find(gr[par].begin(), gr[par].end(), v) != gr[par].end()) {
                in_out.first.insert(par);
            }
        }
        for (int i = 0; i < min(in_out.first.size(), in_out.second.size()); ++i) {
            ans.emplace_back(make_pair(*in_out.first.begin(), v), make_pair(v, *in_out.second.begin()));
            in_out.first.erase(in_out.first.begin());
            in_out.second.erase(in_out.second.begin());
        }
        if (par != -1) {
            if (find(gr[v].begin(), gr[v].end(), par) != gr[v].end()) {
                in_out.second.insert(par);
            }
        }
    }

    if (in_out.first.size() + in_out.second.size() > 1) {
        flag = false;
        return {{}, {}};
    } else {
        if (!in_out.first.empty()) {
            return {{v}, {}};
        } else if (!in_out.second.empty()) {
            return {{}, {v}};
        } else {
            return {{}, {}};
        }
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    gr.resize(n);
    rg.resize(n);
    tree.resize(n);
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        --u; --v;
        gr[u].push_back(v);
        rg[v].push_back(u);
        tree[u].push_back(v);
        tree[v].push_back(u);
    }
    used.resize(n);
    flag = true;
    auto [in, out] = dfs(0, -1);
    if (in.size() + out.size() >= 1) {
        flag = false;
    }
    if (!flag) {
        cout << "No" << '\n';
    } else {
        for (auto [p1, p2] : ans) {
            cout << p1.first + 1 << ' ' << p1.second + 1 << ' ' << p2.first + 1 << ' ' << p2.second + 1 << '\n';
        }
    }
}

int32_t main() {

    solve();

    return 0;
}
