#include <bits/stdc++.h>

using namespace std;

#define int long long

const long long inf = 2e18 + 1329;

signed main() {
    vector<long long> val (26);
    val[0] = 1;
    for (int i = 1; i < 26; ++i) {
        if (i % 2 == 1) {
            val[i] = val[i - 1] * 5;
        } else {
            val[i] = val[i - 1] * 2;
        }
    }

    int t; cin >> t;
    while (t--) {
        string s; cin >> s;
        int n = (int) s.size();
        vector<vector<long long>> dp (n + 1, vector<long long> (26, 0));
        for (int i = 0; i < n; ++i) {
            for (int c = 0; c < 26; ++c) {
                dp[i][c] = -inf;
            }
        }
        vector<vector<int>> lastl (n + 1, vector<int> (26, 0));
        vector<vector<int>> ancaps (n + 1, vector<int> (26, 0));
        for (int i = n - 1; i >= 0; --i) {
            if (s[i] == '?') {
                for (int c = 0; c < 26; ++c) {
                    // all letters in suffix arent bigger than f
                    if (dp[i][c] < dp[i + 1][c] + val[c]) {
                        dp[i][c] = dp[i + 1][c] + val[c];
                        lastl[i][c] = c;
                        ancaps[i][c] = c;
                    }
                    // there are letters in suffix bigger than f
                    for (int caps = c + 1; caps < 26; ++caps) {
                        if (dp[i][c] < dp[i + 1][caps] - val[c]) {
                            dp[i][c] = dp[i + 1][caps] - val[c];
                            lastl[i][c] = c;
                            ancaps[i][c] = caps;
                        }
                    }
                }
            } else {
                int c = s[i] - 'A';
                // all letters in suffix arent bigger than f
                if (dp[i][c] < dp[i + 1][c] + val[c]) {
                    dp[i][c] = dp[i + 1][c] + val[c];
                    lastl[i][c] = c;
                    ancaps[i][c] = c;
                }
                // there are letters in suffix bigger than f
                for (int caps = c + 1; caps < 26; ++caps) {
                    if (dp[i][caps] < dp[i + 1][caps] - val[c]) {
                        dp[i][caps] = dp[i + 1][caps] - val[c];
                        lastl[i][caps] = c;
                        ancaps[i][caps] = caps;
                    }
                }
            }
            for (int c = 1; c < 26; ++c) {
                if (dp[i][c - 1] > dp[i][c]) {
                    dp[i][c] = dp[i][c - 1];
                    lastl[i][c] = lastl[i][c - 1];
                    ancaps[i][c] = ancaps[i][c - 1];
                }
            }
        }
        int ansc = 0;
        for (int c = 0; c < 26; ++c) {
            if (dp[0][c] > dp[0][ansc]) {
                ansc = c;
            }
        }
        cout << dp[0][ansc] << '\n';
        for (int i = 0; i < n; ++i) {
            cout << (char) (lastl[i][ansc] + 'A');
            ansc = ancaps[i][ansc];
        } cout << '\n';
    }
}