#include <bits/stdc++.h>

using namespace std;
#define int long long
const int MAXN = 3e5;
vector<int> et;
vector<vector<int> > gd;

void dfs(int v, int p){
    et.push_back(v);
    for(auto to: gd[v]){
        if(to == p) continue;
        dfs(to, v);
        et.push_back(v);
    }
}

vector<int> pr;

int get(int v){
    if(pr[v] == v) return v;
    else return pr[v] = get(pr[v]);
}

void merge(int u, int v){
    u = get(u);
    v = get(v);
    if(rand() % 2) pr[u] = v;
    else pr[v] = u;
}

signed main() {
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    set<pair<int, int> > edges;
    gd.resize(n);
    pr.resize(n);
    iota(pr.begin(), pr.end(), 0);
    for(int i = 0; i < m; i++){
        int u, v;
        cin >> u >> v;
        u--, v--;
        if(get(u) != get(v)){
            gd[u].push_back(v);
            gd[v].push_back(u);
            merge(u, v);
        }
        edges.insert({u, v});
    }
    for(int i = 1; i < n; i++){
        if(get(i) != get(i - 1)){
            gd[i].push_back(i - 1);
            gd[i - 1].push_back(i);
            merge(i, i - 1);
        }
    }
    dfs(0, -1);
    //euler tour
    int cnt = 0;
    vector<int> kek;
    for(int i = 1; i < et.size(); i++){
        //u -> v
        //if not => reverse v, u
        int u = et[i - 1], v = et[i];
        if(edges.find({u, v}) == edges.end()){
            kek.push_back(cnt);
            cnt = 0;
        } else cnt++;
    }
    kek.push_back(cnt);
    et.pop_back();
    if((kek[0] + kek[2]) % 2 == 0 && kek[1] % 2 == 0){
        cout << "Yes\n";
        int lol = 0;
        for(int i = kek[0] + 1; lol < kek[1]; lol += 2, i += 2){
            cout << et[i] + 1 << ' ' << et[i + 1] + 1 << ' ' << et[i + 1] + 1 << ' ' << et[i + 2] + 1 << endl;
        }
        for(int i = (kek[1] + kek[0] + 2) % et.size(); i != kek[0]; i = (i + 2) % et.size()){
            cout << et[i] + 1 << ' ' << et[(i + 1) % et.size()] + 1 << ' ' << et[(i + 1) % et.size()] + 1 << ' ' << et[(i + 2) % et.size()] + 1 << endl;
        }
    } else cout << "No\n";
}