#pragma GCC optimize("O3")

#include <iostream>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <queue>
#include <stack>
#include <unordered_set>

using namespace std;

#define ll int
#define S second
#define F first
#define all(x) x.begin(), x.end()

ll a, b, c, d, e;
vector <ll> ar;
vector <vector <pair <ll, ll> > > arr;
vector <ll> vis;
vector <pair <ll, ll> > edges;
unordered_set <pair <ll, ll> > set1, set2;
vector <ll> cnt;
vector <unordered_set <ll> > pp, pp1;

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> a >> b;
    edges.resize(b);
    cnt.resize(a);
    pp.resize(a);
    pp1.resize(a);
    for (ll i = 0; i < b; ++i)
    {
        cin >> edges[i].F >> edges[i].S;
        --edges[i].F, --edges[i].S;
        set1.insert({min(edges[i].F, edges[i].S), max(edges[i].F, edges[i].S)});
        set2.insert({edges[i].F, edges[i].S});
        pp[edges[i].F].insert(edges[i].S);
        pp1[edges[i].S].insert(edges[i].F);
    }
    for (auto v : set1)
        cnt[v.F]++, cnt[v.S]++;
    vector <pair <pair <ll, ll>, pair <ll, ll> > > ans;
    queue <ll> q;
    for (ll i = 0; i < a; ++i)
    {
        if (cnt[i] == 1)
            q.push(i);
    }
    vector <ll> vis(a, 0);
    while(!q.empty())
    {
        ll x = q.front();
        q.pop();
        if (cnt[x] != 1 || vis[x])
            continue;
        vis[x] = 1;
        //cout << x << endl;
        ll x1;
        if (pp[x].size() != 0)
        {
            x1 = *pp[x].begin();
            if (pp[x1].find(x) != pp[x1].end())
            {
                ans.push_back({{x, x1}, {x1, x}});
                pp[x1].erase(x);
                pp[x].erase(x1);
                pp1[x1].erase(x);
                pp1[x].erase(x1);
                set2.erase({x, x1});
                set2.erase({x1, x});
                --cnt[x1];
                if (cnt[x1] == 1)
                    q.push(x1);
            }
            else
            {
                if (pp[x1].size() == 0)
                    break;
                ll x2 = *pp[x1].begin();
                ans.push_back({{x, x1}, {x1, x2}});
                pp[x1].erase(x2);
                pp[x].erase(x1);
                pp1[x1].erase(x);
                pp1[x2].erase(x1);
                set2.erase({x, x1});
                set2.erase({x1, x2});
                --cnt[x1];
                if (cnt[x1] == 1)
                    q.push(x1);
                if (set2.find({x2, x1}) == set2.end())
                {
                    --cnt[x2];
                    if (cnt[x2] == 1)
                        q.push(x2);
                    --cnt[x1];
                    if (cnt[x1] == 1)
                        q.push(x1);
                }
            }
        }
        else
        {
            if (pp1[x].size() == 0)
                break;
            ll x1 = *pp1[x].begin();
            if (pp1[x1].size() == 0)
                break;
            ll x2 = *pp1[x1].begin();
            ans.push_back({{x2, x1}, {x1, x}});
            pp[x2].erase(x1);
            pp[x1].erase(x);
            pp1[x1].erase(x2);
            pp1[x].erase(x1);
            set2.erase({x2, x1});
            set2.erase({x1, x});
            --cnt[x1];
            if (cnt[x1] == 1)
                q.push(x1);
            if (set2.find({x1, x2}) == set2.end())
            {
                --cnt[x2];
                if (cnt[x2] == 1)
                    q.push(x2);
                --cnt[x1];
                if (cnt[x1] == 1)
                    q.push(x1);
            }
        }
    }
    if (ans.size() != b / 2)
    {
        cout << "No";
        return 0;
    }
    cout << "Yes\n";
    for (auto v : ans)
        cout << v.F.F + 1 << " " << v.F.S + 1 << " " << v.S.F + 1 << " " << v.S.S + 1 << '\n';
}
