//#pragma GCC optimize("O3")

#include <iostream>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <queue>
#include <stack>
#include <unordered_set>

using namespace std;

#define ll int
#define S second
#define F first
#define all(x) x.begin(), x.end()

ll a, b, c, d, e;
vector <ll> ar;
vector <vector <ll> > arr, arr1;
vector <ll> vis;
vector <pair <ll, ll> > edges;
vector <ll> match, pp;
bool fl = true;

void dfs(ll v, ll col)
{
    vis[v] = col;
    for (auto v1 : arr[v])
        if (!vis[v1])
            dfs(v1, 3 - col);
        else
            if (vis[v1] == vis[v])
                fl = false;
    return;
}

bool dfss(ll v)
{
    vis[v] = 1;
    pp.push_back(v);
    for (auto v1 : arr1[v])
    {
        if (match[v1] == -1 || !vis[match[v1]] && dfss(match[v1]))
        {
            match[v1] = v;
            return true;
        }
    }
    return false;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> a >> b;
    match.resize(b, -1);
    edges.resize(b);
    for (ll i = 0; i < b; ++i)
    {
        cin >> edges[i].F >> edges[i].S;
        --edges[i].F, --edges[i].S;
    }
    arr.resize(b);
    vis.resize(b);
    for (ll i = 0; i < b; ++i)
    {
        for (ll j = 0; j < b; ++j)
            if (edges[i].S == edges[j].F)
            {
                arr[i].push_back(j);
                arr[j].push_back(i);
            }
    }
    for (ll i = 0; i < b; ++i)
        if (!vis[i])
            dfs(i, 1);
    arr1.resize(b);
    for (ll i = 0; i < b; ++i)
    {
        if (vis[i] == 1)
        for (ll j = 0; j < arr[i].size(); ++j)
        {
            if (vis[arr[i][j]] == 2)
            {
                //cout << i << " " << arr[i][j] << " qq" << endl;
                arr1[i].push_back(arr[i][j]);
            }

        }
    }
    //return 0;
    vector <ll> color = vis;
    vis.assign(b, 0);
    for (ll i = 0; i < b; ++i)
    {
        if (color[i] != 1)
            continue;
        for (ll j = 0; j < pp.size(); ++j)
            vis[pp[j]] = 0;
        pp.clear();
        dfss(i);
    }
    //for (ll i = 0; i < b; ++i)
    //    cout << color[i] << " " << match[i] << endl;
    ll cnt = 0;
    for (ll i = 0; i < b; ++i)
        if (color[i] == 1)
            ++cnt;
        else
            --cnt;
    for (ll i = 0; i < b; ++i)
        if (color[i] == 2 && match[i] == -1)
            fl = false;
    if (!fl || cnt != 0)
    {
        cout << "No";
        return 0;
    }
    cout << "Yes\n";
    for (ll i = 0; i < a; ++i)
        if (color[i] == 2)
        {
            if (edges[i].S == edges[match[i]].F)
                cout << edges[i].F + 1 << " " << edges[i].S + 1 << " " << edges[match[i]].F + 1 << " " << edges[match[i]].S + 1 << '\n';
            else
                cout << edges[match[i]].F + 1 << " " << edges[match[i]].S + 1 << " " << edges[i].F + 1 << " " << edges[i].S + 1 << '\n';
        }
    //for (auto v : ans)
    //    cout << v.F.F + 1 << " " << v.F.S + 1 << " " << v.S.F + 1 << " " << v.S.S + 1 << '\n';
}
