#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <cstdio>
#include <algorithm>

using namespace std;

const long long INFL = 1000000000000000009ll;
const long long Num[26] = {
	1,
	5,
	10,
	50,
	100,
	500,
	1000,
	5000,
	10000,
	50000,
	100000,
	500000,
	1000000,
	5000000,
	10000000,
	50000000,
	100000000,
	500000000,
	1000000000,
	5000000000,
	10000000000,
	50000000000,
	100000000000,
	500000000000,
	1000000000000,
	5000000000000
};

long long GetNum(int num)
{
	return Num[num];
}

signed main()
{
	ios::sync_with_stdio(0);
	cin.tie();
	cout.tie();
	//freopen("input.txt", "r", stdin);

	int t;
	cin >> t;
	while (t--)
	{
		string s;
		cin >> s;

		vector <vector <long long> > dp(s.size() + 1, vector<long long>(26, -INFL));
		vector <vector <int> > ans(s.size() + 1, vector <int>(26));
		for (int i = 0; i < 26; ++i)
		{
			dp[0][i] = 0;
		}
		for (int i = 0; i < s.size(); ++i)
		{
			for (int j = 26 - 1; j >= 0; --j)
			{
				if (s[i] == '?')
				{
					if (dp[i + 1][j] < dp[i][j] + GetNum(j))
					{
						dp[i + 1][j] = dp[i][j] + GetNum(j);
						ans[i + 1][j] = j;
					}
				}
				else
				{
					if (s[i] - 'A' >= j)
					{
						if (dp[i + 1][j] < dp[i][s[i] - 'A'] + GetNum(s[i] - 'A'))
						{
							dp[i + 1][j] = dp[i][s[i] - 'A'] + GetNum(s[i] - 'A');
							ans[i + 1][j] = s[i] - 'A';
						}
					}
					else
					{
						if (dp[i + 1][j] < dp[i][j] - GetNum(s[i] - 'A'))
						{
							dp[i + 1][j] = dp[i][j] - GetNum(s[i] - 'A');
							ans[i + 1][j] = j;
						}
					}
				}
				if (j < 26 - 1)
				{
					if (dp[i + 1][j] < dp[i + 1][j + 1])
					{
						dp[i + 1][j] = dp[i + 1][j + 1];
						ans[i + 1][j] = ans[i + 1][j + 1];
					}
				}
			}
		}
		cout << dp[s.size()][0] << '\n';
		string anss;
		int ind = 0;
		for (int i = s.size(); i > 0; --i)
		{
			if (s[i - 1] == '?')
			{
				anss += (char)('A' + ans[i][ind]);
			}
			else
			{
				anss += s[i - 1];
			}
			ind = ans[i][ind];
		}
		reverse(anss.begin(), anss.end());
		cout << anss << '\n';
	}

	return 0;
}