#define _CRT_SECURE_NO_WARNINGS
//#pragma comment(linker, "/stack:2000000000")
#include <iostream>
#include <vector>
#include <cstdio>
#include <algorithm>
#include <set>
#include <numeric>

using namespace std;

const int INF = 1000000009;
const long long INFL = 1000000000000000009ll;
const int SIZE = 30;

vector <int> g[SIZE];
vector <pair <pair <int, int>, int> > edges;
int ans[SIZE];
set <pair <int, int> > mem;

void Go(int v, int mask, int ma, int mi)
{
	if (mem.count({ v, mask }))
	{
		return;
	}
	mem.insert({ v, mask });
	ans[v] = min(ans[v], ma + mi);
	for (int to : g[v])
	{
		if (!((1 << to) & mask))
		{
			if (edges[to].first.first == v)
			{
				Go(edges[to].first.second, mask | (1 << to), max(ma, edges[to].second), min(mi, edges[to].second));
			}
			else
			{
				Go(edges[to].first.first, mask | (1 << to), max(ma, edges[to].second), min(mi, edges[to].second));
			}
		}
	}
}

signed main()
{
	for (int i = 0; i < SIZE; ++i)
	{
		ans[i] = INF;
	}

	ios::sync_with_stdio(0);
	cin.tie();
	cout.tie();
	//freopen("input.txt", "r", stdin);

	int n, m;
	cin >> n >> m;
	edges.resize(m);
	for (int i = 0; i < m; ++i)
	{
		int u, v, t;
		cin >> u >> v >> t;
		u--; v--;
		edges[i] = { { u, v }, t };
		g[u].push_back(i);
		g[v].push_back(i);
	}
	
	Go(0, 0, -INF, INF);

	for (int i = 1; i < n; ++i)
	{
		cout << ans[i] << '\n';
	}

	return 0;
}