#pragma GCC optimize("O3")
#include <iostream>
constexpr size_t MEM = 10e8;
char _data[MEM + int(1e7)];
size_t _ptr = 0;
void *operator new (size_t sz) {	
	if (_ptr > MEM) {
		_ptr -= MEM / 2;
		//exit(234);
	}
	void *res = _data + _ptr;
	_ptr += sz;

	return res;
}
void operator delete(void *) {
	;
}

#include <vector>
#include <numeric>
#include <functional>
#include <algorithm>

#include <immintrin.h>
#include <list>
#include <random>
#include <ctime>
#include <chrono>

//#define lg(val) (31 -_lzcnt_u32(val))
//struct ST {
//private:
//	std::vector<std::vector<std::pair<int, int>>> data;
//
//public:
//	ST() {
//		;
//	}
//
//	ST(std::vector<int> vec) {
//		data.resize(lg(vec.size()) + 1);
//		data[0].resize(vec.size());
//		for (int i = 0; i < vec.size(); i++) {
//			data[0][i] = { vec[i], i };
//		}
//		for (int k = 1; k < data.size(); k++) {
//			data[k].resize(vec.size() - (1 << k) + 1);
//			for (int i = 0; i < vec.size() - (1 << k) + 1; i++) {
//				data[k][i] = std::min(data[k - 1][i], data[k - 1][i + (1 << k - 1)]);
//			}
//		}
//	}
//
//	//[l, r)
//	int get(int l, int r) {
//		int k = lg(r - l);
//		return std::min(data[k][l], data[k][r - (1 << k)]).second;
//	}
//};


std::mt19937 rnd(24);
constexpr int MAXN = 1e4 + 5;

struct Tree {
	int x, h;

	Tree() : x(0), h(0) {
		;
	}

	Tree(int x, int h) : x(x), h(h) {
		;
	}
};

int n, q;
Tree input[MAXN];

std::pair<int, std::list<Tree>::iterator> fuck(std::list<Tree> &list, std::list<Tree>::iterator it) {
	if (it == list.begin() || it == list.end() || std::next(it) == list.end()) {
		return { 0, it };
	}
	int res = 0;
	if (it->x + it->h <= std::next(it)->x) {
		res++;
	} else if (std::prev(it)->x + it->h <= it->x) {
		res++;
	}
	if (res > 0) {
		auto pr = std::prev(it);
		auto nx = std::next(it);
		list.erase(it);
		if (pr != list.begin()) {
			auto p = fuck(list, pr);
			res += p.first;
			return { res, p.second };
		} else {
			auto p = fuck(list, nx);
			res += p.first;
			return { res, p.second };
		}
	} else {
		return { 0, it };
	}
}

int cum(std::list<Tree> list) {
	int res = 0;
	for (auto it = list.begin(); it != list.end(); it++) {
		auto p = fuck(list, it);
		res += p.first;
		it = p.second;
	}
	return res;
}


int32_t main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr);

	n = q = 10000;
	std::cin >> n >> q;
	for (int i = 1; i <= n; i++) {
		input[i].x = rnd() % (int(1e8) + 1);
		input[i].h = rnd() % (int(1e6) + 1) + 1;
		std::cin >> input[i].x >> input[i].h;
	}
	std::sort(input + 1, input + n + 1, [](Tree a, Tree b) {return a.x < b.x; });
	input[0] = input[1];
	input[n + 1] = input[n];
	input[0].h = input[n + 1].h = 1.1e9;

	while (q--) {
		int l, r;
		l = rnd() % n;
		r = rnd() % n;
		if (l > r) {
			std::swap(l, r);
		}
		l++; r++;
		std::cin >> l >> r;
		r++;
		std::list<Tree> list(input + l, input + r);
		list.push_front(input[l - 1]);
		list.push_back(input[r]);
		//std::cerr << "res: ";
		int res = cum(list);
		std::cout << res << "\n";
	}

	std::cerr << clock() * 1.0 / CLOCKS_PER_SEC << std::endl;

	return 0;
}
/*
3 3
1 3
3 1
4 2

1 1
2 3
1 3

*/