#include <bits/stdc++.h>

using namespace std;

const int MAXN = 21;
vector<pair<int, int>> graph[MAXN];
int ans[MAXN];

void solve(int v, int p, int mx, int mn) {
  ans[v] = min(ans[v], mx + mn);
  for (auto[u, w] : graph[v]) {
    if (u == p)
      continue;
    int nmx = max(mx, w);
    int nmn = min(mn, w);
    if (ans[u] > nmx + nmn) {
      ans[u] = nmx + nmn;
      solve(u, v, nmx, nmn);
    }
  }
}

signed main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  int n, m;
  cin >> n >> m;
  for (int i = 0; i < m; i++) {
    int v, u, t;
    cin >> v >> u >> t;
    v--;
    u--;
    graph[v].emplace_back(u, t);
    graph[u].emplace_back(v, t);
  }
  for (int i = 0; i < n; i++) {
    ans[i] = INT_MAX;
  }
  for (auto [u, w] : graph[0]) {
    solve(u, 0, w, w);
  }
  for (int i = 1; i < n; i++)
    cout << ans[i] << '\n';
  return 0;
}