#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int N = 3e5 + 10, INF = 1e9+10;
const ll LINF = 1e18 + 10;

vector<pair<int,int>> g[N];

int ans[N];

void dfs(int v, int from, int mx, int mn) {
    ans[v] = mx+mn;
    for (auto e : g[v]) {
        int to = e.first;
        int w = e.second;
        if (to == from) continue;
        dfs(to, v, max(mx, w), min(mn, w));
    }
}


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, m;
    cin >> n >> m;

    for (int i = 0; i < m; i++) {
        int a, b, w;
        cin >> a >> b >> w;

        g[a].push_back({b,w});
        g[b].push_back({a,w});
    }

    dfs(1, 0, 0, INF);

    for (int i = 2; i <= n; i++) {
        cout << ans[i] << "\n";
    }

    return 0;
}
