#include <bits/stdc++.h>

using namespace std;

//#define  int long long
#define  x first
#define  y second

const int MAXN = 300000;
const int INF = 1e9 + 7;

pair<pair<int, int>, int> rebs[MAXN];

vector<int> g[MAXN];

vector<pair<int, int>> ng[MAXN];

map<pair<int, int>, int> mm, is_most;

int tin[MAXN], fup[MAXN], used[MAXN], timer = 0, comp[MAXN], the_best[MAXN];

void dfs(int v = 0, int p = -1) {
    tin[v] = fup[v] = timer++;
    used[v] = 1;
    for (auto x : g[v])
        if (x == p) {
            continue;
        } else if (used[x]) {
            fup[v] = min(fup[v], tin[x]);
        } else {
            dfs(x, v);
            fup[v] = min(fup[v], fup[x]);
            if (fup[x] > tin[v]) {
               if (mm[{min(x, v), max(x, v)}] == 1)
                    is_most[{min(x, v), max(x, v)}] = 1;
            }
        }
}

void dfs1(int v, int compa) {
    comp[v] = compa;
    used[v] = 1;
    for (auto x : g[v]) {
        if (!used[x]) {
            if (is_most.find({min(x, v), max(x, v)}) != is_most.end())
                dfs1(x, ++timer);
            else
                dfs1(x, compa);
        }
    }
}

void dfs2(int v, int p = -1, int ans = 1e9) {
    the_best[v] = min(the_best[v], ans);
    ans = the_best[v];
    for (auto x : ng[v])
        if (x.x != p)
            dfs2(x.x, v, min(ans, x.y));
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> dist(n, INF);
    dist[0] = 0;
    for (int i = 0; i < m; ++i) {
        int a, b, c;
        cin >> a >> b >> c;
        --a;
        --b;
        if (a > b)
            swap(a, b);
        if (mm[{a, b}] == 0) {
            g[a].push_back(b);
            g[b].push_back(a);
        }
        ++mm[{a, b}];
        rebs[i] = make_pair(make_pair(a, b), c);
    }
    dfs(0);
    for (int i = 0; i < n; ++i)
        used[i] = 0;
    timer = 0;
    dfs1(0, 0);
    for (int i = 0; i < n; ++i)
        the_best[i] = 1e9;
    map<pair<int, int>, int> the_best_reb;
    for (int i = 0; i < m; ++i) {
        if (comp[rebs[i].x.x] == comp[rebs[i].x.y]) {
            the_best[comp[rebs[i].x.x]] = min(the_best[comp[rebs[i].x.x]], rebs[i].y);
        } else {
            if (the_best_reb.find(rebs[i].x) == the_best_reb.end())
                the_best_reb[rebs[i].x] = rebs[i].y;
            else
                the_best_reb[rebs[i].x] = min(the_best_reb[rebs[i].x], rebs[i].y);
        }
    }
    for (auto x : the_best_reb) {
        int A = comp[x.x.x], B = comp[x.x.y], W = x.y;
        ng[A].push_back({B, W});
        ng[B].push_back({A, W});
    }
    dfs2(0);
    for (int i = 1; i < n; ++i)
        cout << the_best[comp[i]] + 1000000000 << '\n';
}

signed main() {
#ifdef  LOCAL
    freopen("input.txt", "r", stdin);
#else
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
#endif
    int t = 1; // cin >> t;
    while (t--)
        solve();
    return 0;
}