#include <bits/stdc++.h>

using namespace std;

//#define  int long long
#define  x first
#define  y second

const int INF = 2e9 + 7;

const int MAXN = 300000;

vector<pair<int, int>> g[MAXN];

void solve() {
    int n, m;
    cin >> n >> m;
    vector<pair<int, pair<int, int>>> rebs(m);
    for (int i = 0; i < m; ++i) {
        int a, b, c;
        cin >> a >> b >> c;
        --a;
        --b;
        rebs[i] = {c, {a, b}};
    }
    sort(rebs.rbegin(), rebs.rend());
    vector<int> ans(n, INF);
    while (rebs.size()) {
        for (int i = 0; i < n; ++i)
            g[i].clear();
        for (auto x : rebs) {
            int A = x.y.x;
            int B = x.y.y;
            g[A].push_back({B, x.x});
            g[B].push_back({A, x.x});
        }
        set<pair<int, int>> s;
        s.insert({INF, 0});
        vector<int> dist(n, INF);
        while (s.size()) {
            pair<int, int> p = *s.begin();
            s.erase(p);
            int v = p.y;
            int cost = p.x;
            for (auto x : g[v])
                if (dist[x.x] > min(cost, x.y)) {
                    s.erase({dist[x.x], x.x});
                    dist[x.x] = min(cost, x.y);
                    s.insert({dist[x.x], x.x});
                }
        }
        for (int i = 0; i < n; ++i)
            ans[i] = min(ans[i], rebs.back().x + dist[i]);
        rebs.pop_back();
    }
    for (int i = 1; i < n; ++i)
        cout << ans[i] << '\n';
}

signed main() {
#ifdef  LOCAL
    freopen("input.txt", "r", stdin);
#else
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
#endif
    int t = 1; // cin >> t;
    while (t--)
        solve();
    return 0;
}