#include <bits/stdc++.h>

#define f first
#define s second

using namespace std;
using li = long long;
using pii = pair<int, int>;

const int INF = 2e9 + 13;
const int N = 3e5 + 13;


vector<int> g[N];
pair<pii, int> e[N];
int ans[N];
int n, m;

void dfs1(int v, int par, int mn, int mx) {
    ans[v] = mn + mx;
    for(auto i : g[v]) {
        int u = e[i].f.f ^ e[i].f.s ^ v;
        int w = e[i].s;
        if(u != par)
            dfs1(u, v, min(mn, w), max(mx, w));
    }
}



int getmn(int mask) {
    int res = INF;
    for(int i = 0; i < m; i++)
        if((1 << i) & mask)
            res = min(res, e[i].s);
    return res;
}

int getmx(int mask) {
    int res = 0;
    for(int i = 0; i < m; i++)
        if((1 << i) & mask) {
//            cout << i << ' ' << e[i].s << endl;
            res = max(res, e[i].s);
        }

    return res;
}

int mask_mn[1 << 21], mask_mx[1 << 21];
bool dp[1 << 21][21];

/*
group 0
3 3
1 2 2
1 3 1
2 3 1

4 4
1 2 2
3 2 0
2 4 3
4 3 1

group 1
5 4
1 2 1
1 3 4
2 4 2
2 5 3

group 2

*/

int main() {
//    ios::sync_with_stdio(0);
//    cin.tie(0);


    cin >> n >> m;

    for(int i = 0; i < m; i++) {
        int v, u, w;
        cin >> v >> u >> w;

        v--;
        u--;

        e[i] = {{v, u}, w};

        g[v].push_back(i);
        g[u].push_back(i);
    }

    if(m <= 20) {
        for(int i = 0; i < n; i++)
            ans[i] = INF;
//        cout << getmx(2) << endl;
//        return 0;
        for(int mask = 0; mask < (1 << m); mask++) {
            mask_mn[mask] = getmn(mask);
            mask_mx[mask] = getmx(mask);
//            cout << mask << ' ' << mask_mn[mask] << ' ' << mask_mx[mask] << endl;
        }

        dp[0][0] = true;
        for(int mask = 0; mask < (1 << m); mask++) {
            for(int v = 0; v < n; v++) if(dp[mask][v]) {
//                cout << mask << ' ' << v << endl;
                for(auto i : g[v]) if((mask & (1 << i)) == 0) {
                    int u = e[i].f.f ^ e[i].f.s ^ v;
                    int nmask = mask | (1 << i);
                    dp[nmask][u] = true;
//                    cout << ans[u] << ' ' << nmask << ' ' << mask_mn[nmask] + mask_mx[nmask] << endl;
                    ans[u] = min(ans[u], mask_mn[nmask] + mask_mx[nmask]);

                }
            }
        }
    } else if(n - 1 == m) {
        dfs1(0, 0, INF, 0);
    } else {
        for(int i = 0; i < n; i++)
            ans[i] = INF;
        ans[0] = 0;
        set<pii> st;
        st.insert({ans[0], 0});

        while(!st.empty()) {
            int v = st.begin()->s;
            st.erase(st.begin());

            for(auto i : g[v]) {
                int u = e[i].f.f ^ e[i].f.s ^ v;
                int w = max(ans[v], e[i].s);
                if(ans[u] > w) {
                    st.erase({ans[u], u});
                    ans[u] = w;
                    st.insert({ans[u], u});
                }
            }
        }
    }

    for(int i = 1; i < n; i++)
        cout << ans[i] << '\n';
}
