#define ll long long

#include<iostream>
#include<vector>
#include<string>
#include<algorithm>
#include<cmath>

using namespace std;

ll num(char c) {
	return (ll)(c - 'A');
}

ll cost(ll x) {
	ll ans = pow(10, x / 2);
	if (x % 2 != 0) {
		ans *= 5;
	}
	return ans;
}

void true_main() {
	string s;
	cin >> s;
	ll n = s.size();

	vector<ll> a(26, 0);
	ll last = 26;

	for (int i = 0; i < n; i++) {
		if (s[i] == '?') {
			ll mx = -1e18;
			ll pos = -1;
			for (int j = 0; j < last; j++) {
				if (cost(j) - a[j] > mx) {
					mx = cost(j) - a[j];
					pos = j;
				}
			}
			s[i] = char('A' + pos);
			for (int j = 0; j < pos; j++) {
				a[pos] = 0;
			}
		}
		else {
			ll now = num(s[i]);
			ll now_cost = cost(now);
			for (int j = now + 1; j < 26; j++) {
				a[j] += now_cost;
			}
		}
	}
	ll ans = 0;
	ll max_now = 0;
	for (int i = n - 1; i > -1; i--) {
		ll now = num(s[i]);
		ll cost_now = cost(now);
		if (max_now <= now) {
			ans += cost_now;
			max_now = now;
		}
		else {
			ans -= cost_now;
		}
	}
	cout << ans << "\n";
	cout << s;
}

signed main() {
	ll t;
	cin >> t;
	
	while (t--) {
		true_main();
		cout << "\n";
	}
}
