#define ll long long

#include<iostream>
#include<vector>
#include<string>
#include<algorithm>
#include<cmath>

using namespace std;

void rec(vector<vector<ll>> &gr, ll v, ll &balance, ll pred) {
	for (int i = 0; i < gr[v].size(); i++) {
		if (gr[v][i] == pred) {
			balance++;
		}
		else {
			balance--;
			rec(gr, gr[v][i], balance, v);
		}
	}
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	ll n, m;
	cin >> n >> m;
	vector<ll> in(n, 0);
	vector<ll> out(n, 0);
	vector<vector<ll>> gr(n);

	for (int i = 0; i < m; i++) {
		ll l, r;
		cin >> l >> r;
		in[--r]++;
		out[--l]++;
		gr[l].push_back(r);
	}
	ll balance = 0;
	rec(gr, 0, balance, -1);
	if (balance) {
		cout << "No";
	}
	else {
		cout << "Yes";
	}
}