#define ll long long

#include<iostream>
#include<vector>
#include<string>
#include<algorithm>
#include<cmath>
#include<map>

using namespace std;

struct tree {
	ll x = 0, h = 0;
};

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	ll n, q;
	cin >> n >> q;

	vector<tree> a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i].x >> a[i].h;
	}

	for(int i = 0; i < q; i++){
		ll l, r;
		cin >> l >> r;
		l--; r--;
		
		bool is = 1;
		vector<ll> nextl(n);
		vector<ll> nextr(n);
		for (int i = 0; i < n; i++) {
			nextl[i] = i - 1;
			nextr[i] = i + 1;
		}
		vector<bool> cuted(n, 0);
		ll ans = 0;
		while (is) {
			is = 0;
			for (int i = l; i <= r; i++) {
				if (cuted[i]) {
					continue;
				}
				while (nextl[i] != -1 && cuted[nextl[i]]) {
					nextl[i]--;
				}
				while (nextr[i] != n && cuted[nextr[i]]) {
					nextr[i]++;
				}
				ll distl = 0, distr = 0;
				distl = a[i].x - (nextl[i] == -1 ? a[0].x : a[nextl[i]].x);
				distr = (nextr[i] == n ? a[n - 1].x : a[nextr[i]].x) - a[i].x;
				if (max(distl, distr) >= a[i].h) {
					cuted[i] = 1;
					is = 1;
					ans++;
				}
			}
		}
		cout << ans << "\n";
	}
}

/*
8 10
1 2
2 3
3 4
4 3
5 2
5 6
6 5
1 7
7 1
7 8
*/