#include <iostream>
#include<vector>
#include<algorithm>;
#define fori(n) for(int i=0;i<n;i++)
#define forj(n) for(int j=0;j<n;j++)
#define INF 2000000000
using namespace std;


struct road {
	int to, id, time;
	road(int to_, int id_, int time_) {
		to = to_; id = id_; time = time_;
	};
};




vector<int>ans;
vector<bool>used;
vector<vector<road*>>d;
vector<int>cnt;



int go(int u, int min_, int max_) {
	if (cnt[u] >= 2)return 0;
	cnt[u]++;
	ans[u] = min(ans[u], min_ + max_);
	for (auto i : d[u]) {
		if (used[i->id])continue;
		used[i->id] = 1;
		go(i->to, min(min_, i->time), max(max_, i->time));
		used[i->id] = 0;
	}
	cnt[u]--;
	return 0;
}



int main() {

	int n, m, u, v, time;
	road* r;
	cin >> n >> m;
	d.resize(n);
	cnt.resize(n, 0);
	used.resize(m);
	ans.resize(n, INF);
	fori(m) {
		cin >> u >> v >> time;
		d[u - 1].push_back(new road(v - 1, i, time));
		d[v - 1].push_back(new road(u - 1, i, time));
	}
	go(0, INF, 0);
	for (int i = 1; i < n;i++) {
		cout << ans[i]<<'\n';
	}
}