#include <bits/stdc++.h>

using namespace std;

#define FAST ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define all(x) (x).begin(), (x).end()
#define allr(x) (x).rbegin(), (x).rend()
#define gsize(x) (int)((x).size())


typedef long long ll;
typedef long double ld;

const ll inf = 1e9;
const ll inf2 = 1e18;
const ll mod = 1e9 + 7;
const ld eps = 1e-9;
const char nl = '\n';

const int maxn = 1e6, maxm = 1e6;

ll mp[26];

void solve() {
	string s;
	cin >> s;
	int n = gsize(s);
	vector<int> a(n);
	for (int i = 0; i < n; i++) {
		if (s[i] == '?') a[i] = -1;
		else a[i] = s[i] - 'A';
	}
	vector<vector<ll>> dp(n + 1, vector<ll> (26, -inf2));
	vector<vector<pair<int, int>>> p(n + 1, vector<pair<int, int>> (26, {-1, -1}));
	for (int j = 0; j < 26; j++) {
		dp[n][j] = 0;
	}
	
	
	for (int i = n - 1; i >= 0; i--) {
		int l = 0, r = 26;
		if (a[i] >= 0) {
			l = a[i]; r = a[i] + 1;
		}
		for (int j = l; j < r; j++) {
			for (int k = 0; k < 26; k++) {
				if (j >= k) {
					if (dp[i + 1][k] + mp[j] > dp[i][j]) {
						p[i][j] = {j, k};
					}
					dp[i][j] = max(dp[i][j], dp[i + 1][k] + mp[j]);
				} else {
					if (dp[i + 1][k] - mp[j] > dp[i][k]) {
						p[i][k] = {j, k};
					}
					dp[i][k] = max(dp[i][k], dp[i + 1][k] - mp[j]);
				}
			}
		}
	}
	
	ll mx = *max_element(all(dp[0]));
	string ans;
	int j = 0;
	while (dp[0][j] != mx) j++;
	cout << mx << nl;
	for (int i = 0; i < n; i++) {
		ans += (char)(p[i][j].first + 'A');
		j = p[i][j].second;
	}
	cout << ans << nl;
	
}

int main() {
	FAST;
	ll cv = 1;
	for (int i = 0; i < 26; i++) {
		mp[i] = cv;
		if (i & 1) cv *= 2LL;
		else cv *= 5LL;
	}
	int t;
	cin >> t;
	while (t--) solve();
}
