#include <bits/stdc++.h>

using namespace std;

#define FAST ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define all(x) (x).begin(), (x).end()
#define allr(x) (x).rbegin(), (x).rend()
#define gsize(x) (int)((x).size())


typedef long long ll;
typedef long double ld;

const ll inf = 1e9;
const ll inf2 = 1e18;
const ll mod = 1e9 + 7;
const ld eps = 1e-9;
const char nl = '\n';

const int maxn = 3e5, maxm = 2e6;

vector<array<int, 3>> g[maxn];


int ans[maxn], cmask = 0;
bool usd[20][maxm];

inline bool used(int i) {
	return (cmask >> i) & 1;
}

void dfs(int v, int ma=0, int mi=inf) {
	if (usd[v][cmask]) return;
	ans[v] = min(ans[v], ma + mi);
	for (auto u: g[v]) {
		if (used(u[2])) continue;
		cmask += (1 << u[2]);
		dfs(u[0], max(ma, u[1]), min(mi, u[1]));
		cmask -= (1 << u[2]);
	}
	usd[v][cmask] = true;
}

int main() {
	FAST;
	
	int n, m;
	cin >> n >> m;
	while (m--) {
		int u, v, t;
		cin >> u >> v >> t;
		u--; v--;
		g[u].push_back({v, t, m});
		g[v].push_back({u, t, m});
	}
	for (int i = 0; i < n; i++) ans[i] = 2*inf;
	
	dfs(0);
	for (int i = 1; i < n; i++) cout << ans[i] << nl;
}
