#include <bits/stdc++.h>

using namespace std;

#define FAST ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define all(x) (x).begin(), (x).end()
#define allr(x) (x).rbegin(), (x).rend()
#define gsize(x) (int)((x).size())


typedef long long ll;
typedef long double ld;

const ll inf = 1e9;
const ll inf2 = 1e18;
const ll mod = 1e9 + 7;
const ld eps = 1e-9;
const char nl = '\n';

const int maxn = 3e5, maxm = 2e6;

int ans[maxn];
bool used[maxn];
int tv = 0;
vector<int> g[maxn];

void dfs(int v) {
	ans[v] = min(ans[v], tv);
	if (used[v]) return;
	used[v] = true;
	for (int u: g[v]) dfs(u);
}

int main() {
	FAST;
	
	int n, m;
	cin >> n >> m;
	vector<array<int, 3>> a(m);
	for (int i = 0; i < m; i++) {
		cin >> a[i][1] >> a[i][2] >> a[i][0];
		a[i][2]--; a[i][1]--;
	}
	for (int i = 0; i < n; i++) ans[i] = inf;
	
	sort(all(a));
	dfs(0);
	used[0] = true;
	for (auto p: a) {
		tv = p[0];
		int u = p[1], v = p[2];
		if (used[v]) {
			swap(u, v);
		}
		g[u].push_back(v);
		g[v].push_back(u);
		if (used[u] && !used[v]) {
			dfs(v);
		}
	}
	
	for (int i = 1; i < n; i++) cout << ans[i] << nl;
}
