#include <bits/stdc++.h>

using namespace std;

// #define int long long
#define all(x) (x).begin(), (x).end()
#define fr(i, a, b) for(int i = a; i < b; i++)
#define sz(x) (int)(x).size()

const int N = 1.5 * 1e5;
unordered_set<int> gr[N];
vector<int> in[N], out[N];
int lst[N];


struct gadget{
	int a, b, c, d;
};


void solve(){
	int n, m;
	cin >> n >> m;
	vector<pair<int, int>> ed(m);
	set<pair<int, int>> stogr, edgs;
	vector<gadget> res;
	fr(i, 0, m){
		int u, v; cin >> u >> v;
		u--, v--;
		ed[i] = {u, v};
		stogr.insert({u, v});
		stogr.insert({v, u});
		edgs.insert(ed[i]);
	}
	for(auto [v, u] : stogr){
		gr[u].insert(v);
		gr[v].insert(u);
	}
	vector<int> list;  // tree`s list
	fr(i, 0, n){
		if(sz(gr[i]) == 1){
			list.push_back(i);
		}
	}
	vector<int> vislist(n, 0);
	for(int tt = 0; tt < sz(list); tt++){
		int u = list[tt];
		if(vislist[u]) continue;
		vislist[u] = 1;
		if(sz(gr[u]) != 1) continue;
		int v = *gr[u].begin();
		if(edgs.count({u, v}) && edgs.count({v, u})){
			res.push_back({u, v, v, u});
			gr[v].erase(u);
			gr[u].erase(v);
			if(sz(gr[v]) == 1) list.push_back(v);
			continue;
		} 
		if(edgs.count({u, v})) in[v].push_back(u);
		if(edgs.count({v, u})) out[v].push_back(u);
		lst[v]++;
	}
	vector<int> parlist;
	fr(i, 0, n) if(lst[i] > 0 && lst[i] >= sz(gr[i]) - 1) parlist.push_back(i);
	vector<int> visited(n, 0);
	for(int tt = 0; tt < sz(parlist); tt++){
		int i = parlist[tt];
		if(visited[i] || sz(gr[i]) == 0) continue;
		visited[i] = 1;
		if(lst[i] == sz(gr[i])){
			if(sz(in[i]) == sz(out[i])){
				// cout << i << endl;
				fr(j, 0, sz(in[i])){
					res.push_back({in[i][j], i, i, out[i][j]});
				}
				continue;
			} else {
				cout << "No";
				return;
			}
		} else {
			int ty = -1;
			int dv = -1;
			for(int j : gr[i]){
				if(sz(gr[j]) > 1){
					dv = j;
					if(edgs.count({j, i})) ty = 0;
					if(edgs.count({i, j})) ty = 1;
					if(edgs.count({i, j}) && edgs.count({j, i})) ty = 2;
				}
			}
			if(ty == -1){
				cout << "No\n";
				return;
			}
			bool flag = false;
			if(sz(in[i]) == sz(out[i])){
				// cout << 2;
				// cout << i << endl;
				fr(j, 0, sz(in[i])){
					res.push_back({in[i][j], i, i, out[i][j]});
				}
				flag = true;
				if(ty == 0){
					lst[dv]++;
					out[dv].push_back(i);
					if(lst[dv] > 0 && lst[dv] >= sz(gr[dv]) - 1) parlist.push_back(dv);
				}
				if(ty == 1){
					lst[dv]++;
					in[dv].push_back(i);
					if(lst[dv] > 0 && lst[dv] >= sz(gr[dv]) - 1) parlist.push_back(dv);
				}
				if(ty == 2){
					gr[dv].erase(i);
					res.push_back({i, dv, dv, i});
					while(sz(gr[dv]) == 1){
						i = dv;
						dv = *gr[i].begin();

						if(edgs.count({dv, i})) out[dv].push_back(i), lst[dv]++;
						if(edgs.count({i, dv})) in[dv].push_back(i), lst[dv]++;
						if(edgs.count({i, dv}) && edgs.count({dv, i})) {
							gr[dv].erase(i);
							res.push_back({i, dv, dv, i});
						}
					}
					if(lst[dv] > 0 && lst[dv] >= sz(gr[dv]) - 1) parlist.push_back(dv);

				}
				continue;
			}
			if(!flag && (ty == 0 || ty == 2) && sz(in[i]) + 1 == sz(out[i])){
				fr(j, 0, sz(in[i])){
					res.push_back({in[i][j], i, i, out[i][j]});
				}
				res.push_back({dv, i, i, out[i].back()});

				flag = true;
				if(ty == 0){
					gr[dv].erase(i);
					while(sz(gr[dv]) == 1){
						i = dv;
						dv = *gr[i].begin();

						if(edgs.count({dv, i})) out[dv].push_back(i), lst[dv]++;
						if(edgs.count({i, dv})) in[dv].push_back(i), lst[dv]++;
						if(edgs.count({i, dv}) && edgs.count({dv, i})) {
							gr[dv].erase(i);
							res.push_back({i, dv, dv, i});
						}
					}
					if(lst[dv] > 0 && lst[dv] >= sz(gr[dv]) - 1) parlist.push_back(dv);
				} else {
					lst[dv]++;
					gr[i].clear();
					gr[i].insert(dv);
					in[dv].push_back(i);
					if(lst[dv] > 0 && lst[dv] >= sz(gr[dv]) - 1) parlist.push_back(dv);
					
				}
				continue;
			}
			
			if(!flag && (ty == 1 || ty == 2) && sz(in[i]) == sz(out[i]) + 1){
				fr(j, 0, sz(out[i])){
					res.push_back({in[i][j], i, i, out[i][j]});
				}
				res.push_back({in[i].back(), i, i, dv});
				if(ty == 1){
					gr[dv].erase(i);
					while(sz(gr[dv]) == 1){
						i = dv;
						dv = *gr[i].begin();

						if(edgs.count({dv, i})) out[dv].push_back(i), lst[dv]++;
						if(edgs.count({i, dv})) in[dv].push_back(i), lst[dv]++;
						if(edgs.count({i, dv}) && edgs.count({dv, i})) {
							gr[dv].erase(i);
							res.push_back({i, dv, dv, i});
						}
					}
					if(lst[dv] > 0 && lst[dv] >= sz(gr[dv]) - 1) parlist.push_back(dv);
				} else {
					lst[dv]++;
					gr[i].clear();
					gr[i].insert(dv);
					out[dv].push_back(i);
					if(lst[dv] > 0 && lst[dv] >= sz(gr[dv]) - 1) parlist.push_back(dv);
				}
				flag = true;
				continue;
			}

			if(!flag){
				cout << "No";
				return;
			}
		}	
	}
	if(sz(res) == m / 2){
		cout << "Yes\n";
		for(auto i : res) cout << i.a+1 << ' ' << i.b+ 1 << ' ' << i.c + 1 << ' ' << i.d + 1 << endl;
	} else {
		cout << "No\n";
	}

}

signed main(){
	// freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
	int t = 1;
	// cin >> t;
	while(t--) solve();
}