#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

vector<int> a;

void dfs(int v, vector<vector<vector<int>>> &gr, int mn, int mx, vector<int> now) {
    if (a[v] < mn + mx){
        return;
    }
    a[v] = min(mn + mx, a[v]);
    for (auto u : gr[v]) {
        if (count(now.begin(), now.end(), u[2]) == 0) {
            now.push_back(u[2]);
            dfs(u[0], gr, min(mn, u[1]), max(mx, u[1]), now);
            now.pop_back();
        }
    }
}

signed main() {
    int n, m;
    cin >> n >> m;
    vector<vector<vector<int>>> gr(n);
    for (int i = 0; i < m; ++i) {
        int v, u, t;
        cin >> v >> u >> t;
        --v;
        --u;
        gr[v].push_back({u, t, i});
        gr[u].push_back({v, t, i});
    }
    a.resize(n, 2000000000);
    dfs(0, gr, 1000000000, 0, {});
    for (int i = 1; i < n; ++i) {
        cout << a[i] << "\n";
    }
}