from sys import stdin, stdout, exit
from copy import deepcopy, copy

input=stdin.readline

n, m = map(int, input().split())
G = [[] for _ in range(n)]
ordering = set()
for _ in range(m):
    u, v = map(int, input().split())
    u, v = u - 1, v - 1
    if u not in G[v]:
        G[v].append(u)
        G[u].append(v)
    ordering.add((u, v))

def order(x, y):
    if (x, y) in ordering and (y, x) in ordering:
        return 0
    elif (x, y) in ordering:
        return 1
    return -1

ts = []
parents = []
used = [0] * n
j = 0
i = 0
for i in range(n):
    if len(ts) <= i:
        while used[j]:
            j += 1
        ts.append(j)
        used[j] = 1
        parents.append(None)
    kids = copy(G[ts[i]])
    if parents[i] is not None:
        kids.remove(ts[parents[i]])
    ts.extend(kids)
    parents.extend([i] * len(kids))
    for el in kids:
        used[el] = 1

fin = [[] for _ in range(n)]
fout = [[] for _ in range(n)]
res = []
for i in reversed(range(n)):
    kin, kout = fin[i], fout[i]
    if abs(len(kin) - len(kout)) > 1:
        stdout.write('No\n')
        exit()
    for a, b in zip(kin, kout):
        res.append([a + 1, ts[i] + 1, ts[i] + 1, b + 1])
    if len(kin) == len(kout):
        if parents[i] is not None:
            a = order(ts[i], ts[parents[i]])
            if a == 0:
                res.append([ts[i] + 1, ts[parents[i]] + 1,
                    ts[parents[i]] + 1, ts[i] + 1])
            elif a == 1:
                fin[parents[i]].append(ts[i])
            else:
                fout[parents[i]].append(ts[i])
    elif len(kin) > len(kout):
        if parents[i] is None:
            stdout.write('No\n')
            exit()
        a = order(ts[i], ts[parents[i]])
        if a == 0:
            res.append([kin[-1] + 1, ts[i] + 1,
                ts[i] + 1, ts[parents[i]] + 1])
            fout[parents[i]].append(ts[i])
        elif a == 1:
            res.append([kin[-1] + 1, ts[i] + 1,
                ts[i] + 1, ts[parents[i]] + 1])
        else:
            stdout.write('No\n')
            exit()
    else:
        if parents[i] is None:
            stdout.write('No\n')
            exit()
        a = order(ts[i], ts[parents[i]])
        if a == 0:
            res.append([ts[parents[i]] + 1, ts[i] + 1,
                ts[i] + 1, kout[-1] + 1])
            fin[parents[i]].append(ts[i])
        elif a == -1:
            res.append([ts[parents[i]] + 1, ts[i] + 1,
                ts[i] + 1, kout[-1] + 1])
        else:
            stdout.write('No\n')
            exit()
stdout.write('Yes\n')
stdout.write('\n'.join(map(lambda x: ' '.join(map(str, x)), res)))
stdout.write('\n')
