#include <bits/stdc++.h>
 
using namespace std;
 
typedef long long ll;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;
 
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define print(x) {for (auto xxxxx : (x)) cout << xxxxx << ' '; cout << '\n';}
 
const ll inf = 2e18;
 
int n, q;
vector < vector <int> > g[2], rg[2];
vector <int> x, h, ed[2];
vector <bool> can[2];
vector <int> CNT[2];
 
void solve() {
    cin >> n >> q;
    x.resize(n);
    h.resize(n);
    ed[0].resize(n);
    ed[1].resize(n);
    g[0].resize(n);
    g[1].resize(n);
    rg[0].resize(n);
    rg[1].resize(n);
    can[0].resize(n, true);
    can[1].resize(n, true);
    CNT[0].resize(n, 0);
    CNT[1].resize(n, 0);
    for (int i = 0; i < n; i++) {
        cin >> x[i] >> h[i];
        ed[0][i] = x[i] - h[i];
        ed[1][i] = x[i] + h[i];
    }
    for (int i = 0; i < n; i++) {
        if (ed[0][i] < x[0])
            can[0][i] = false;
        if (ed[1][i] > x[n - 1])
            can[1][i] = false;
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (i == j)
                continue;
 
            if (x[i] - h[i] < x[j] && x[j] < x[i]) {
                g[0][i].push_back(j);
                rg[0][j].push_back(i);
                CNT[0][i]++;
            }
            if (x[i] < x[j] && x[j] < x[i] + h[i]) {
                CNT[1][i]++;
                g[1][i].push_back(j);
                rg[1][j].push_back(i);
            }
        }
    }
    
    while (q --> 0) {
        vector <int> cnt[2];
        cnt[0] = CNT[0];
        cnt[1] = CNT[1];
        int l, r; cin >> l >> r; l--, r--;
        vector <int> lst;
        vector <bool> was(n, false);
        for (int i = l; i <= r; i++) {
            if ((g[0][i].empty() && can[0][i]) || (g[1][i].empty() && can[1][i])) {
                lst.push_back(i);
                was[i] = true;
            }
        }
        int ans = 0;
        while (!lst.empty()) {
            ans++;
            int v = lst.back();
            lst.pop_back();
            for (int t = 0; t < 2; t++) {
                for (auto to : rg[t][v]) {
                    if (to < l || to > r)
                        continue;

                    cnt[t][to]--;
                    if (was[to])
                        continue;
                    if (cnt[t][to] == 0 && can[t][to]) {
                        was[to] = true;
                        lst.push_back(to);
                    }
                }
            }
        }

        cout << ans << '\n';
    }
}
 
signed main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.precision(20);
 
    int t = 1;
    //cin >> t;
    while (t --> 0) {
        solve();
    }
 
    return 0;
}