#include <bits/stdc++.h>
 
using namespace std;
 
typedef long long ll;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;
 
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define print(x) {for (auto xxxxx : (x)) cout << xxxxx << ' '; cout << '\n';}
 
const ll inf = 2e18;
 
int n, q;
vector < vector <int> > g[2], rg[2];
vector <int> x, h, ed[2];
vector <bool> can[2];
vector <int> CNT[2];

void solve() {
    cin >> n >> q;
    x.resize(n);
    h.resize(n);
    ed[0].resize(n);
    ed[1].resize(n);
    g[0].resize(n);
    g[1].resize(n);
    rg[0].resize(n);
    rg[1].resize(n);
    can[0].resize(n, true);
    can[1].resize(n, true);
    CNT[0].resize(n, 0);
    CNT[1].resize(n, 0);
    for (int i = 0; i < n; i++) {
        cin >> x[i] >> h[i];
        ed[0][i] = x[i] - h[i];
        ed[1][i] = x[i] + h[i];
    }
    for (int i = 0; i < n; i++) {
        if (ed[0][i] < x[0])
            can[0][i] = false;
        if (ed[1][i] > x[n - 1])
            can[1][i] = false;
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (i == j)
                continue;
 
            if (x[i] - h[i] < x[j] && x[j] < x[i]) {
                g[0][i].push_back(j);
                rg[0][j].push_back(i);
                CNT[0][i]++;
            }
            if (x[i] < x[j] && x[j] < x[i] + h[i]) {
                CNT[1][i]++;
                g[1][i].push_back(j);
                rg[1][j].push_back(i);
            }
        }
    }

    while (q --> 0) {
        int l, r; cin >> l >> r; l--, r--;
        set <int> lst;
        for (int i = l; i <= r; i++) {
            lst.insert(x[i]);
        }
        int ans = 0;
        vector <int> st;
        for (int i = l; i <= r; i++) {
            st.push_back(i);
            while (!st.empty()) {
                int id = st.back();
                bool ok = false;
                if (can[1][id] && (i + 1 >= n || x[i + 1] >= ed[1][id])) {
                    ok = true;
                }
                if (can[0][id] && (st.size() == 1 || x[st[st.size() - 2]] <= ed[0][id]) && (l == 0 || ed[0][id] >= x[l - 1])) {
                    ok = true;
                }
                if (ok) {
                    st.pop_back();
                    ans++;
                } else {
                    break;
                }
            }
        }

        cout << ans << '\n';
    }
}
 
signed main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.precision(20);
 
    int t = 1;
    //cin >> t;
    while (t --> 0) {
        solve();
    }
 
    return 0;
}