#include <bits/stdc++.h>
using namespace std;
using ll = long long;
#define all(x) x.begin(), x.end()
#define mp make_pair
#define mt make_tuple
#define x first
#define y second
#define int ll

const int N 	= 3e5 + 10;
const int K 	= 26;
const int INF 	= 2e18;

string s;
int n;
int dp[N][K];
int pr[N][K];
int val[K];

void go(int i, int j, int jj, int de) {
	if (dp[i][j] < dp[i - 1][jj] + de) {
		dp[i][j] = dp[i - 1][jj] + de;
		pr[i][j] = jj;
	}
}

void solve() {
	cin >> s;
	n = (int)s.size();
	fill_n(dp[0], (n + 1) * K, -INF);
	fill_n(pr[0], (n + 1) * K, -1);
	dp[0][0] = 0;
	for (int i = 0; i < n; ++i) {
		if (s[n - 1 - i] == '?') {
			for (int j = 0; j < K; ++j) {
				for (int d = j; d < K; ++d) {
					go(i + 1, d, j, +val[d]);
				}
			}
		} else {
			int d = s[n - 1 - i] - 'A';
			for (int j = 0; j <= d; ++j) {
				go(i + 1, d, j, +val[d]);
			}
			for (int j = d + 1; j < K; ++j) {
				go(i + 1, j, j, -val[d]);
			}
		}
	}
	int i = n, j = 0;
	for (int jj = 0; jj < K; ++jj) {
		if (dp[i][j] < dp[i][jj]) {
			j = jj;
		}
	}
	cout << dp[i][j] << "\n";
	string answer;
	while (i > 0) {
		int jj = pr[i][j];
		if (s[n - i] != '?') {
			answer += s[n - i];
		} else {
			answer += (char)('A' + j);
		}
		--i;
		j = jj;
	}
	cout << answer << "\n";
}

signed main() {
#ifdef LC
	assert(freopen("input.txt", "r", stdin));
#endif
	ios::sync_with_stdio(0); cin.tie(0);
	val[0] = 1, val[1] = 5;
	for (int i = 2; i < K; ++i) {
		val[i] = val[i - 2] * 10;
	}

	int tn;
	cin >> tn;
	while (tn--) {
		solve();
	}
	return 0;
}