#include <bits/stdc++.h>
using namespace std;
using ll = long long;
#define all(x) x.begin(), x.end()
#define mp make_pair
#define mt make_tuple
#define x first
#define y second

const int N = 3e5 + 10;

int n, m;
set<int> t[N], g[N];
vector<tuple<int, int, int>> answer;
bool used[N];

void no() {
	cout << "No\n";
	exit(0);
}

bool f(int v, int u) {
	return g[v].count(u);
}

void add(int a, int b, int c) {
	answer.emplace_back(a, b, c);
	g[a].erase(b);
	g[b].erase(c);
}

void dfs(int v, int p) {
	used[v] = true;
	vector<int> up, down;
	for (int u : t[v]) {
		t[u].erase(v);
		dfs(u, v);
		if (f(v, u) && f(u, v)) {
			add(v, u, v);
		} else if (f(v, u)) {
			down.push_back(u);
		} else if (f(u, v)) {
			up.push_back(u);
		}
	}
	while (up.size() && down.size()) {
		answer.emplace_back(up.back(), v, down.back());
		up.pop_back();
		down.pop_back();
	}
	if (up.size() == 1) {
		if (p != -1 && f(v, p)) {
			add(up.back(), v, p);
		} else {
			no();
		}
	} else if (down.size() == 1) {
		if (p != -1 && f(p, v)) {
			add(p, v, down.back());
		} else {
			no();
		}
	} else if (up.size() || down.size()) {
		no();
	}
}

void edge(int v, int u) {
	t[v].insert(u);
	t[u].insert(v);
	g[v].insert(u);
}

signed main() {
#ifdef LC
	assert(freopen("input.txt", "r", stdin));
#endif
	ios::sync_with_stdio(0); cin.tie(0);
	cin >> n >> m;
	for (int v, u, i = 0; i < m; ++i) {
		cin >> v >> u;
		--v, --u;
		edge(v, u);
	}
	for (int i = 0; i < n; ++i) {
		if (used[i]) {
			continue;
		}
		dfs(i, -1);
	}
	cout << "Yes\n";
	for (auto e : answer) {
		int a, b, c;
		tie(a, b, c) = e;
		cout << a + 1 << " " << b + 1 << " " << b + 1 << " " << c + 1 << "\n";
	}
	return 0;
}