#include <bits/stdc++.h>
#define vec vector
#define ll long long
#define all(x) x.begin(), x.end()
#define fi first
#define se second
//#define int long long
//#define endl "\n"

using namespace std;

struct SNM{
    vec<vec<int>> v;
    vec<int> col;
    SNM(){};
    SNM(int n) {
        v.resize(n);
        col.resize(n);
        for (int i = 0; i < n; ++i) {
            v[i].push_back(i);
            col[i] = i;
        }
    }

    vec<int> merg(int x, int y) {
        /*cout << "MERG " << endl;
        for (int i = 0; i < v.size(); ++i) {
            cout << i + 1 << " : ";
            for (auto it: v[i]) cout << it << ' ';
            cout << endl;
        }*/
        x = col[x];
        y = col[y];
        if (x == y) return {};
        if (v[x].size() < v[y].size()) {
            swap(x, y);
        }
        vec<int> ans;
        if (col[0] == x && col[0] != y) {
            ans = v[y];
        } else if (col[0] != x && col[0] == y) {
            ans = v[x];
        }
        for (int i = 0; i < v[y].size(); ++i) {
            col[v[y][i]] = x;
            v[x].push_back(v[y][i]);
        }
        v[y].clear();
        return ans;
    }
};

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, m; cin >> n >> m;
    vec<int> ans(n);
    vec<vec<int>> al;
    for (int i = 0; i < m; ++i) {
        int a, b, c; cin >> a >> b >> c;
        a--; b--;
        al.push_back({c, a, b});
    }
    sort(all(al));
    SNM snm(n);
    for (int i = 0; i < m; ++i) {
        int a = al[i][1], b = al[i][2], c = al[i][0];
        if ((a == 0 || b == 0) && c != 0) return -1;
        vec<int> v = snm.merg(a, b);
        for (auto it: v) ans[it] = c;
        /*cout << "NOW " << i + 1 << endl;
        cout << a + 1 << ' ' << b + 1 << ' ' << c << endl;
        for (auto it: v) cout << it + 1 << ' ';
        cout << endl;*/
    }
    for (int i = 1; i < n; ++i) {
        cout << ans[i] << ' ';
    }
}
/*
4 3
1 2 2
2 3 3
2 4 1
*/
/*
5 6
1 2 0
1 3 0
2 3 2
2 4 5
3 5 3
4 5 6
*/
/*
8 10
1 2 0
1 3 0
2 4 3
4 8 3
8 6 0
4 6 4
4 7 7
4 5 5
5 7 2
6 7 4
*/


