//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("avx,avx2")

#include <bits/extc++.h>

using namespace std;

#define vc vector
typedef long long ll;
typedef vc<ll> vll;

vc<pair<ll, ll>> g[300005];

ll d[300005];

bool used[300005];

void dfs(ll v, ll mn) {
    used[v] = true;
    d[v] = min(d[v], mn);
    for (auto &to : g[v]) {
        if (!used[to.first]) {
            dfs(to.first, min(mn, to.second));
        }
    }
    used[v] = false;
}

bool cmp(pair<ll, ll> a, pair<ll, ll> b) {
    return a.second < b.second;
}

int main() {
    ll n, m;
    cin >> n >> m;
    for (ll v = 1; v <= n; ++v) {
        d[v] = INT_MAX;
    }
    while (m--) {
        ll v, to, w;
        cin >> v >> to >> w;
        g[v].emplace_back(to, w);
        g[to].emplace_back(v, w);
    }
    for (auto &v : g) {
        sort(v.begin(), v.end(), cmp);
    }
    dfs(1, LLONG_MAX);
    for (ll to = 2; to <= n; ++to) {
        cout << d[to] + 1000000000 << ' ';
    }
}