#include <bits/stdc++.h>

///#define int ll

using namespace std;

#define ff first
#define ss second
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define _ << " " <<

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

const int MXN = 150111;

map<pii, int> edg_mp;
pii edg[2*MXN];

int tt = 1;
int used[2*MXN];
int mt[2*MXN];
bool gr_usd[2*MXN];

int color[2*MXN];

vector<int> v_beg[MXN];
vector<int> v_end[MXN];

int n, m;

bool try_khun(int i) {
    if (used[i] == tt) return false;
    used[i] = tt;
    for (auto to: v_end[edg[i].ff]) {
        if (mt[to] == -1 || try_khun(mt[to])) {
            mt[to] = i;
            return true;
        }
    }
    for (auto to: v_beg[edg[i].ss]) {
        if (mt[to] == -1 || try_khun(mt[to])) {
            mt[to] = i;
            return true;
        }
    }
    return false;
}

void dfs_color(int i, int clr) {
    if (color[i] != 0) return;
    color[i] = clr;
    for (auto to: v_end[edg[i].ff]) {
        if (clr == 1) dfs_color(to, 2);
        else dfs_color(to, 1);
    }
    for (auto to: v_beg[edg[i].ss]) {
        if (clr == 1) dfs_color(to, 2);
        else dfs_color(to, 1);
    }
}

void solve() {
    cin >> n >> m;
    int x, y;
    for (int i = 0; i < m; ++i) {
        cin >> x >> y; --x; --y;
        edg[i] = {x, y};
        edg_mp[make_pair(x, y)] = i;
        v_beg[x].push_back(i);
        v_end[y].push_back(i);
    }
    for (int i = 0; i < m; ++i) {
        if (color[i] == 0) dfs_color(i, 1);
    }
    fill_n(mt, 2*MXN, -1);
    for (int i = 0; i < m; ++i) {
        if (color[i] != 1) continue;
        if (edg_mp.count({edg[i].ss, edg[i].ff})) continue;
        for (auto to: v_end[edg[i].ff]) {
            if (gr_usd[i]) break;
            if(mt[to] == -1) {
                mt[to] = i;
                gr_usd[i] = 1;
            }
        }
        if (gr_usd[i]) continue;
        for (auto to: v_beg[edg[i].ss]) {
            if (gr_usd[i]) break;
            if(mt[to] == -1) {
                mt[to] = i;
                gr_usd[i] = 1;
            }
        }
        if (gr_usd[i]) continue;
    }
    for (int i = 0; i < m; ++i) {
        if (color[i] != 1) continue;
        //if (edg_mp.count({edg[i].ss, edg[i].ff})) continue;
        for (auto to: v_end[edg[i].ff]) {
            if (gr_usd[i]) break;
            if(mt[to] == -1) {
                mt[to] = i;
                gr_usd[i] = 1;
            }
        }
        if (gr_usd[i]) continue;
        for (auto to: v_beg[edg[i].ss]) {
            if (gr_usd[i]) break;
            if(mt[to] == -1) {
                mt[to] = i;
                gr_usd[i] = 1;
            }
        }
        if (gr_usd[i]) continue;
    }
    for (int i = 0; i < m; ++i) {
        if (gr_usd[i]) continue;
        if (color[i] == 1) {
            ++tt;
            try_khun(i);
        }
    }
    vector<pii> ans;
    for (int i = 0; i < m; ++i) {
        if (mt[i] != -1) {
            ans.push_back({i, mt[i]});
        }
    }
    if (ans.size() < (m/2)) {
        cout << "No\n";
    } else {
        cout << "Yes\n";
        for (auto to: ans) {
            cout << edg[to.ff].ff+1 _ edg[to.ff].ss+1 << " ";
            cout << edg[to.ss].ff+1 _ edg[to.ss].ss+1 << "\n";
        }
    }
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    int tests = 1;
    //cin >> tests;
    while (tests--) {
        solve();
    }
}

