#include<bits\stdc++.h>

using namespace std;

const int MAXN = 3e5  +1;
bool used[26];
long long info[26];
long long dp[MAXN][26];

long long get(string& tmp) {
    for (int i = 0; i < 26; ++i) used[i] = false;
    long long res = 0;
    for (int i = (int)tmp.size() - 1; i >= 0; --i) {
        used[tmp[i] - 'A'] = true;
        bool ok = false;
        for (int j = tmp[i] + 1; j <= 'Z'; ++j) {
            ok |= used[j - 'A'];
        }
        if (ok) res -= info[tmp[i] - 'A'];
        else res += info[tmp[i] - 'A'];
    }
    return res;
}

void solve() {
    info[0] = 1;
    info[1] = 5;
    for (int i = 2; i < 26; ++i) {
        info[i] = info[i - 2] * 10;
    }
    string s;
    cin >> s;
    vector<int> pos;
    for (int i = 0; i < s.size(); ++i) {
        if (s[i] == '?') {
            pos.push_back(i);
        }
    }
    if (pos.size() == 0) {
        cout << get(s) << "\n" << s << "\n";
        return;
    }
    if (pos.size() == 1) {
        pair<long long, string> best = {0, ""};
        for (int x = 'A'; x <= 'Z'; ++x) {
            s[pos[0]] = x;
            long long t = get(s);
            if (best.first < t) {
                best = {t, s};
            }
        }
        cout << best.first << "\n" << best.second << "\n";
    }
    if (pos.size() == 2) {
        pair<long long, string> best = {0, ""};
        for (int x = 'A'; x <= 'Z'; ++x) {
            for (int y = 'A'; y <= 'Z'; ++y) {
                s[pos[0]] = x;
                s[pos[1]] = y;
                long long t = get(s);
                if (best.first < t) {
                    best = {t, s};
                }
            }
        }
        cout << best.first << "\n" << best.second << "\n";
    }
    if (pos.size() == 3) {
        pair<long long, string> best = {0, ""};
        for (int x = 'A'; x <= 'Z'; ++x) {
            for (int y = 'A'; y <= 'Z'; ++y) {
                for (int z = 'A'; z <= 'Z'; ++z) {
                    s[pos[0]] = x;
                    s[pos[1]] = y;
                    s[pos[2]] = z;
                    long long t = get(s);
                    if (best.first < t) {
                        best = {t, s};
                    }
                }
            }
        }
        cout << best.first << "\n" << best.second << "\n";
    }
}

/*
4
BBBC
????
A?B?C?D
YYYYY?
*/

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}
