#include <bits/stdc++.h>

using ll = long long;
using namespace std;
#define SZ(x) (int)((x).size())
#define ALL(x) (x).begin(), (x).end()

const ll INF = 1e18;

ll get_value(char x) {
    int power = (x - 'A') / 2;
    ll ans = 1;
    for (int i = 0; i < power; i++)
        ans *= 10;
    if ((x - 'A') % 2)
        ans *= 5;
    return ans;
}


int main() {
    ios::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    int t;
    cin >> t;
    for (int ttt = 0; ttt < t; ttt++) {
        string s;
        cin >> s;
        int n = SZ(s);
        reverse(ALL(s));
        vector<vector<ll>> dp(n + 1, vector<ll>(26, -INF));
        vector<vector<pair<int, char>>> p(n + 1, vector<pair<int, char>>(26, make_pair(-1, 'A')));
        for (int i = 0; i < 26; i++)
            dp[0][i] = 0;
        for (int i = 0; i < n; i++) {
            if (s[i] != '?') {
                int j = s[i] - 'A';
                ll val = get_value(s[i]);
                for (int k = 0; k <= j; k++) {
                    if (dp[i + 1][j] < dp[i][k] + val) {
                        dp[i + 1][j] = dp[i][k] + val;
                        p[i + 1][j] = make_pair(k, s[i]);
                    }
                }
                for (int k = j + 1; k < 26; k++) {
                    dp[i + 1][k] = dp[i][k] - val;
                    p[i + 1][k] = make_pair(k, s[i]);
                }
            } else {
                for (int now = 0; now < 26; now++) {
                    ll val = get_value('A' + now);
                    for (int prv = 0; prv <= now; prv++) {
                        if (dp[i + 1][now] < dp[i][prv] + val) {
                            dp[i + 1][now] = dp[i][prv] + val;
                            p[i + 1][now] = make_pair(prv, now + 'A');
                        }
                    }
                    for (int k = now + 1; k < 26; k++) {
                        if (dp[i + 1][k] < dp[i][k] - val) {
                            dp[i + 1][k] = dp[i][k] - val;
                            p[i + 1][k] = make_pair(k, now + 'A');
                        }
                    }
                }
            }
        }
        ll mx = dp[n][0];
        ll where = 0;
        for (int i = 0; i < 26; i++)
            if (dp[n][i] > mx) {
                mx = max(mx, dp[n][i]);
                where = i;
            }
        int pos = n;
        string ans;
        while (pos > 0) {
            ans += p[pos][where].second;
            where = p[pos--][where].first;
        }
        cout << mx << '\n';
//        reverse(ALL(ans));
        cout << ans << '\n';
    }
    return 0;
}
