#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

inline void input() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
#ifdef _DEBUG
    freopen("../src/input.txt", "r", stdin);
    freopen("../src/output.txt", "w", stdout);
#endif
}

ll d[15];

ll num(int i) {
    ll ans = d[i / 2];
    if (i & 1)
        ans *= 5;
    return ans;
}

const ll INFL = 2e18;

int main() {
    input();
    d[0] = 1;
    for (int i = 1; i < 15; i++)
        d[i] = d[i - 1] * 10;
    int t;
    cin >> t;
    while (t--) {
        string s;
        cin >> s;
        int n = s.size();
        vector<vector<ll>> pref(n + 1, vector<ll>(26));
        for (int i = 1; i <= n; i++) {
            for (int j = 0; j < 26; j++)
                pref[i][j] += pref[i - 1][j];
            if (s[i - 1] != '?')
                ++pref[i][s[i - 1] - 'A'];
        }
        ll ans = 0;
        vector<char> temp(n);
        int mx = 0;
        for (int i = n - 1; i >= 0; i--) {
            if (s[i] == '?') {
                ll sum = 0;
                ll mxsum = -INFL;
                int mxind = -1;
                for (int j = mx; j < 26; j++) {
                    if (sum + num(j) > mxsum) {
                        mxsum = sum + num(j);
                        mxind = j;
                    }
                    sum -= num(j) * pref[i][j];
                }
                ans += mxsum;
                temp[i] = char('A' + mxind);
                mx = max(mx, mxind);
            } else {
                temp[i] = s[i];
                int s1 = s[i] - 'A';
                if (s1 >= mx){
                    ans += num(s1);
                    for (; mx < s1; mx++)
                        ans -= num(mx) * pref[i][mx];
                }
            }
        }
        cout << ans << "\n";
        for (auto & i : temp)
            cout << i;
        cout << "\n";
    }
    return 0;
}