#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <ios>
#include <cassert>
#include <queue>
#include <cassert>
using namespace std;

const int INF = 1e9;

vector<vector<pair<int, int>>> g;

int main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int n, m;
	cin >> n >> m;
	g.resize(n);

	vector<int> min_edge_to(n, INF);

	for (int i = 0; i < m; i++) {
		int a, b, c;
		cin >> a >> b >> c;
		a--; b--;
		if (a > b)
			swap(a, b);

		if (b != a + 1) {
			exit(3);
		}

		min_edge_to[b] = min(min_edge_to[b], c);
	}

	int cur_min = INF, cur_max = 0;
	for (int i = 1; i < n; i++) {
		cur_min = min(cur_min, min_edge_to[i]);
		cur_max = max(cur_max, min_edge_to[i]);
		cout << cur_min + cur_max << "\n";
	}
}