#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

//#pragma GCC target("avx2");
//#pragma GCC optimize("Ofast");
//#pragma GCC optimize("unrol-loops");

typedef long long ll;
typedef long double ld;
/*
typedef tree <
int,
null_type,
less<int>,
rb_tree_tag,
tree_order_statistics_node_update>
oredered_set;
*/

#define _ << " " <<
#define ff first
#define ss second
#define pb push_back

#ifdef LOCAL
    #define err cerr
#else
    #define err if (0) cerr
#endif // LOCAL

vector<pair<int, int> > edg;

int n, m;

vector<int> st;
vector<int> used(30);

void get_ans() {
    for (int i = 0; i < edg.size(); i += 2) {
        if (edg[st[i]].ff != edg[st[i + 1]].ss && edg[st[i]].ss != edg[st[i + 1]].ff) return;
    }
    cout << "Yes" << "\n";
    for (int i = 0; i < edg.size(); i += 2) {
        cout << edg[st[i]].ff _ edg[st[i]].ss _ edg[st[i + 1]].ff _ edg[st[i + 1]].ss << "\n";
    }
    exit(0);
}

void backtracking() {
    if (st.size() == edg.size()) {/*
        for (auto to : st) {
            err << to << " ";
        }
        err << endl;*/

        get_ans();
        return;
    }

    for (int i = 0; i < m; ++i) {
        if (used[i] == 0 && (st.size() % 2 == 0 || (edg[i].ff == edg[st.back()].ss || edg[i].ss == edg[st.back()].ff))) {
            st.pb(i);
            used[i] = 1;
            backtracking();
            st.pop_back();
            used[i] = 0;
        }
    }
}

void solve() {
    cin >> n >> m;

    if (m % 2 == 1) {
        cout << "No";
        return;
    }

    int u, v;
    for (int i = 0; i < m; ++i) {
        cin >> u >> v;
        edg.pb({u, v});
    }

    backtracking();
    cout << "No" << endl;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL

    int tests = 1;
    //cin >> tests;
    while (tests--) {
        solve();
    }
}
