#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

//#pragma GCC target("avx2");
//#pragma GCC optimize("Ofast");
//#pragma GCC optimize("unrol-loops");

typedef long long ll;
typedef long double ld;
/*
typedef tree <
int,
null_type,
less<int>,
rb_tree_tag,
tree_order_statistics_node_update>
oredered_set;
*/

#define _ << " " <<
#define ff first
#define ss second
#define pb push_back

#ifdef LOCAL
    #define err cerr
#else
    #define err if (0) cerr
#endif // LOCAL

const int N = 3e5 + 10;

vector<pair<int, ll> > g[N];

vector<ll> mn(N, 1e10), mx(N);

void dfs(int v, int prv) {
    for (auto e : g[v]) {
        ll w = e.ss;
        int to = e.ff;

        if (to == prv) continue;

        mn[to] = min(mn[v], w);
        mx[to] = max(mx[v], w);

        dfs(to, v);
    }
}

void solve() {
    int n, m;
    cin >> n >> m;

    int u, v;
    ll t;
    for (int i = 0; i < m; ++i) {
        cin >> u >> v >> t;
        g[u].pb({v, t});
        g[v].pb({u, t});
    }

    dfs(1, -1);

    for (int i = 2; i <= n; ++i) {
        cout << mn[i] + mx[i] << "\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL

    int tests = 1;
    //cin >> tests;
    while (tests--) {
        solve();
    }
}

