#include <bits/stdc++.h>

using namespace std;
#define x first
#define y second

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

mt19937 rand1(chrono::high_resolution_clock::now().time_since_epoch().count());
int randlr(int l, int r) {
    return rand1() % (r - l + 1) + l;
}

vector<pii> g[300009];
int dist[300009];
int answ[300009];

const int inf = 1e9 + 7;
void dfs(int v, int p, int mx, int mn) {
    answ[v] = mx + mn;
    for (auto u : g[v]) {
        if (u.x == p) continue;
        dfs(u.x, v, max(mx, u.y), min(mn, u.y));
    }
}

signed main() {
    ios :: sync_with_stdio(0);
    cin.tie(0);

    #ifdef localfile
        freopen("input.txt", "r", stdin);
    #endif // localfile

    int n, m;
    cin >> n >> m;

    for (int i = 0; i < m; i++) {
        int a, b, c;
        cin >> a >> b >> c;

        g[a].push_back({b, c});
        g[b].push_back({a, c});
    }

    dfs(1, -1, 0, 1000000000);

    for (int i = 2; i <= n; i++) {
        cout << answ[i] << "\n";
    }

    return 0;
}



