#include <bits/stdc++.h>

using namespace std;
#define x first
#define y second

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

mt19937 rand1(chrono::high_resolution_clock::now().time_since_epoch().count());
int randlr(int l, int r) {
    return rand1() % (r - l + 1) + l;
}

vector<pii> g[300009];
int dist[300009];
int answ[300009];
int cost[300009];

const int inf = 1e9 + 7;
pii dp[(1 << 20) + 1][21];

signed main() {
    ios :: sync_with_stdio(0);
    cin.tie(0);

    #ifdef localfile
        freopen("input.txt", "r", stdin);
    #endif // localfile

    int n, m;
    cin >> n >> m;

    for (int i = 0; i < m; i++) {
        int a, b, c;
        cin >> a >> b >> c;

        g[a].push_back({b, i});
        g[b].push_back({a, i});
        cost[i] = c;
    }


    for (int i = 0; i < (1 << m); i++) {
        for (int j = 1; j <= n; j++) dp[i][j] = {-1, -1};
    }

    dp[0][1] = {1000000000, 0};

    for (int mask = 0; mask < (1 << m); mask++) {
        for (int fin = 1; fin <= n; fin++) {
            if (dp[mask][fin].x != -1) {
                for (auto u : g[fin]) {
                    int e = u.y;
                    if ((mask >> e) & 1) continue;

                    dp[mask ^ (1 << e)][u.x].x = min(dp[mask][fin].x, cost[e]);
                    dp[mask ^ (1 << e)][u.x].y = max(dp[mask][fin].y, cost[e]);
                }
            }
        }
    }

    for (int v = 2; v <= n; v++) {
        answ[v] = inf + inf;
        for (int mask = 0; mask < (1 << m); mask++) {
            if (dp[mask][v].x != -1)
            answ[v] = min(answ[v], dp[mask][v].x + dp[mask][v].y);
        }

        cout << answ[v] << "\n";
    }

    return 0;
}



