#include <bits/stdc++.h>
#define int long long
#define u_map unordered_map

using namespace std;

const int inf = 1000000000000000000;
vector <int> d;
vector <char> b;

ostream& operator<<(ostream& os, vector <int> a)
{
    for (auto x : a)
    {
        os << x << " ";
    }
    return os;
}

ostream& operator<<(ostream& os, pair <int, int> a)
{
    os << a.first << " " << a.second;
    return os;
}

void solve()
{
    string s;
    cin >> s;
    int n = s.size();

    vector <int> temp(27, -inf);
    vector <vector <int> > dp(n + 1, temp);
    dp[n][0] = 0;
    for (int i = n - 1; i >= 0; i--)
    {
        if (s[i] != '?')
        {
            int mx = -inf;
            for (int j = 0; j <= b[s[i]]; j++)
            {
                mx = max(mx, dp[i + 1][j]);
            }
            dp[i][b[s[i]]] = mx + d[b[s[i]]];
            for (int j = b[s[i]] + 1; j <= 26; j++)
            {
                dp[i][j] = dp[i + 1][j] - d[b[s[i]]];
            }
        }
    }
    int ans = dp[0][1];
    for (int i = 1; i <= 26; i++)
    {
        ans = max(ans, dp[0][i]);
    }
    cout << ans << endl << s << endl;
}

void dict_create()
{
    d.push_back(0);
    d.push_back(1);
    d.push_back(5);
    for (int i = 3; i <= 26; i++)
    {
        d.push_back(d[i - 2] * 10);
    }
    for (int i = 0; i <= 90; i++)
    {
        b.push_back((int) i - 'A' + 1);
    }
}

int32_t main()
{
    int t;
    cin >> t;
    dict_create();
    for (int i = 0; i < t; i++)
    {
        solve();
    }
    return 0;
}
/*
8
BBBC
BBA
ABC
BAC
ACA
ZZZZ
AZBZCZD
YYYYYY
*/
