#include <bits/stdc++.h>
#define int long long
#define u_map unordered_map

using namespace std;

const int inf = 1000000000000000000;
vector <int> d;
vector <int> b;

int mypow(int x, int y)
{
    int c = 1;
    for (int i = 0; i < y; i++)
    {
        c *= x;
    }
    return c;
}

ostream& operator<<(ostream& os, vector <int> a)
{
    for (auto x : a)
    {
        os << x << " ";
    }
    return os;
}

ostream& operator<<(ostream& os, pair <int, int> a)
{
    os << a.first << " " << a.second;
    return os;
}

int count(string s)
{
    int n = s.size();
    int v = 0, mx = 0;
    for (int i = n - 1; i >= 0; i--)
    {
        int c = d[b[s[i]]];
        if (c >= mx)
        {
            v += c;
            mx = c;
        }
        else
        {
            v -= c;
        }
    }
    return v;
}

void solve()
{
    string s;
    cin >> s;
    int n = s.size();
    vector <string> parts;
    string part = "";
    for (int i = 0; i < n; i++)
    {
        if (s[i] == '?')
        {
            parts.push_back(part);
            part = "";
        }
        else
        {
            part += s[i];
        }
    }
    parts.push_back(part);
    if (parts.size() == 1)
    {
        cout << count(s) << endl << s << endl;
        return;
    }
    int mx = -inf;
    string best;
    for (int k = 0; k < mypow(26, parts.size() - 1); k++)
    {
        string temp = parts[0];
        int k1 = k;
        for (int i = 0; i < parts.size() - 1; i++)
        {
            temp += (char) (k1 % 26) + 'A';
            k1 /= 26;
            temp += parts[i + 1];
        }
        int ans = count(temp);
        if (ans > mx)
        {
            mx = ans;
            best = temp;
        }
    }
    cout << mx << endl << best << endl;
}

void dict_create()
{
    d.push_back(0);
    d.push_back(1);
    d.push_back(5);
    for (int i = 3; i <= 26; i++)
    {
        d.push_back(d[i - 2] * 10);
    }
    for (int i = 0; i <= 90; i++)
    {
        b.push_back((int) i - 'A' + 1);
    }
}

int32_t main()
{
    int t;
    cin >> t;
    dict_create();
    for (int i = 0; i < t; i++)
    {
        solve();
    }
    return 0;
}
/*
4
BBBC
????
A?B?C?D
YYYYYY?
*/
