#include <bits/stdc++.h>
using namespace std;


#define ll long long
#define pb push_back
#define all(x) x.begin(), x.end()


struct edge {
    int u, w;
    int index;
};


void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> fwd(n);
    for (int i = 0; i < m; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        u--;
        v--;
        if (v > u) {
            swap(v, u);
        }
        fwd[v].pb(w);
    }
    for (int i = 0; i < n; i++) {
        sort(all(fwd[i]));
    }
    int mn = fwd[0][0], mx = fwd[0][0];
    for (int v = 1; v < n; v++) {
        int curMin = mn, curMax = mx;
        int answer = curMax + curMin;
        for (int j = v + 1; j < n; j++) {
            if (fwd[j - 1].size() == 1) {
                break;
            }
            curMin = min(curMin, fwd[j - 1][0]);
            curMax = max(curMax, fwd[j - 1][1]);
            answer = min(answer, curMax + curMin);
        }
        cout << answer << "\n";
        if (v + 1 < n) {
            mn = min(mn, fwd[v][0]);
            mx = max(mx, fwd[v][0]);
        }
    }
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    solve();
    return 0;
}
