#include <iostream>
#include <vector>
#include <algorithm>
#define int long long

using namespace std;

int32_t main()
{
	cin.tie(0);
	cout.tie(0);
	ios_base::sync_with_stdio(0);
	int n, q;
	cin >> n >> q;
	vector<int> x(n);
	vector<int> h(n);
	for (int i = 0; i < n; ++i)
		cin >> x[i] >> h[i];
	vector<int> l(n, -1);
	vector<int> r(n, -1);
	for (int i = 0; i < n; ++i) {
		if (x[i] - h[i] >= x[0]) {
			l[i] = (upper_bound(x.begin(), x.end(), x[i] - h[i])) - x.begin();
		}
		if (x[i] + h[i] <= x[n - 1]) {
			r[i] = (--lower_bound(x.begin(), x.end(), x[i] + h[i])) - x.begin();
		}
	}
	for (int i = n - 2; i >= 0; --i) {
		int j = i + 1;
		while (j <= r[i]) {
			if (l[j] > i)
				++j;
			else if (r[j] != -1) {
				j = r[j] + 1;
			}
			else {
				break;
			}
		}
		if (j <= r[i])
			r[i] = -1;
		else
			r[i] = j - 1;
	}
	for (int i = 1; i < n; ++i) {
		int j = i - 1;
		while (j >= l[i]) {
			if (r[j] < i)
				--j;
			else if (l[j] != -1) {
				j = l[j] - 1;
			}
			else {
				break;
			}
		}
		if (j >= l[i])
			l[i] = -1;
		else
			l[i] = j + 1;
	}
	for (int t = 0; t < q; ++t) {
		int x, y;
		cin >> x >> y;
		--x, --y;
		int ans = 0;
		for (int i = x; i <= y; ++i)
			if ((r[i] != -1 && r[i] <= y) || l[i] >= x)
				++ans;
		cout << ans << '\n';
	}
}
