#include <bits/stdc++.h>
using namespace std;
const int maxn = 150001;
vector <int> g1[maxn];
vector <pair<int, int> > g[maxn];
vector <pair<int, int> > gr[maxn];


// bool cmp(pair<int, int> &p1, pair<int, int> &p2) {
// 	if (p1.first != p2.first) return p1.first
// }


int pr[maxn];
bool used[maxn];

queue <int> q;


void dfs(int u, int par) {
	used[u] = 1;
	pr[u] = par;

	// int nd = 0;
	for (pair<int, int> p : g[u]) {
		int v = p.first;
		if (used[v]) continue;
		dfs(v, u);
		// nd++;
	}
	for (pair<int, int> p : gr[u]) {
		int v = p.first;
		if (used[v]) continue;
		dfs(v, u);
		// nd++;
	}

	q.push(u);
	return;
}

vector <pair<pair<int, int>, pair<int, int> > > gadget;

vector <int> want_out[maxn];
vector <int> want_in[maxn];

int main() {
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < m; i++) {
		int ui, vi;
		cin >> ui >> vi;
		ui--; vi--;
		g1[ui].push_back(vi);
	}
	for (int i = 0; i < n; i++) {
		sort(g1[i].begin(), g1[i].end());
	}

	for (int u = 0; u < n; u++) {
		for (int v : g1[u]) {
			auto t = (lower_bound(g1[v].begin(), g1[v].end(), u));
			if (t != g1[v].end() && *t == u) {
				g[u].push_back({v, 1});
				gr[v].push_back({u, 1});
			}
			else {
				g[u].push_back({v, 0});
				gr[v].push_back({u, 0});
			}
		}
	}

	for (int i = 0; i < n; i++) {
		sort(g[i].begin(), g[i].end());
		sort(gr[i].begin(), gr[i].end());
	}

	for (int i = 0; i < n; i++) {
		if (!used[i])
			dfs(i, -1);
	}

	while(!q.empty()) {
		int u = q.front();
		q.pop();
		int pt1 = 0, pt2 = 0;
		while(pt1 < want_in[u].size() && pt2 < want_out[u].size()) {
			gadget.push_back({{u, want_in[u][pt1]}, {want_out[u][pt2], u}});
			pt1++; pt2++;
		}

		int v = pr[u];

		if (v == -1) { //when we are dealing with a root!!
			// cerr << "ROTZ";
			if (pt1 != want_in[u].size() || pt2 != want_out[u].size()) {
				cout << "No";
				return 0;
			}
			continue;
		}

		int num_out = 0, num_in = 0;
		if (pt1 == want_in[u].size()) {
			int num_left = want_out[u].size() - pt2;
			if (num_left >= 2) {
				cout << "No\n";
				return 0;
			}

			auto tm = lower_bound(g[u].begin(), g[u].end(), make_pair(v, -1));
			if (tm != g[u].end() && (*tm).first == v) {
				int t = (*tm).second;
				if (t == 0) {
					if (num_left == 1) {
						gadget.push_back({{want_out[u][pt2], u}, {u, v}});
						num_out = 0;
					}
					else {
						num_out = 1;
					}
				}
				else {
					if (num_left == 1) {
						gadget.push_back({{want_out[u][pt2], u}, {u, v}});
						num_in = 1;
					}
					else {
						gadget.push_back({{u, v}, {v, u}});
					}
				}
			}
			else {
				// auto tm1 = lower_bound(gr[u].begin(), gr[u].end(), make_pair(v, -1));
				if (num_left != 0) {
					cout << "No";
					return 0;
				}
				num_in = 1;
			}
		}
		else {
			int num_left = want_in[u].size() - pt1;
			if (num_left >= 2) {
				cout << "No\n";
				return 0;
			}

			auto tm = lower_bound(g[u].begin(), g[u].end(), make_pair(v, -1));
			if (tm != g[u].end() && (*tm).first == v) {
				int t = (*tm).second;
				if (t == 0) {
					if (num_left != 0) {
						cout << "No\n";
						return 0;
					}
					num_out = 1;
				}
				else {
					if (num_left != 0) {
						gadget.push_back({{v, u}, {u, want_in[u][pt1]}});
						num_out = 1;
					}
					else {
						gadget.push_back({{u, v}, {v, u}});
					}
				}
			}
			else {
				// auto tm1 = lower_bound(gr[u].begin(), gr[u].end(), make_pair(v, -1));
				if (num_left == 0) {
					num_in = 1;
				}
				else {
					gadget.push_back({{v, u}, {u, want_in[u][pt1]}});
				}
			}
		}

		if (num_in == 1) {
			want_in[v].push_back(u);
		}
		if (num_out == 1) {
			want_out[v].push_back(u);
		}
	}

	cout << "Yes\n";
	for (int i = 0; i < gadget.size(); i++) {
		cout << gadget[i].first.first + 1 << " " << gadget[i].first.second + 1 << " " << gadget[i].second.first + 1 << " " << gadget[i].second.second + 1 << "\n";
	}
}