#include <bits/stdc++.h>
using namespace std;
using ll = long long;
#define all(o) o.begin(), o.end()


vector<vector<pair<int, int>>> graph;


vector<int> mins, maxs;
vector<bool> visited;


void dfs(int v = 0, int mn = INT32_MAX, int mx = 0) {
    visited[v] = true;
    mins[v] = mn;
    maxs[v] = mx;
    for (auto &edge : graph[v]) {
        if (!visited[edge.first]) {
            dfs(edge.first, min(mn, edge.second), max(mx, edge.second));
        }
    }
}


void solve() {
    int n, m; cin >> n >> m;

    graph.assign(n, vector<pair<int, int>>());
    visited.assign(n, false);
    mins.assign(n, 0);
    maxs.assign(n, 0);
    int maxw = -1;

    for (int i = 0; i < m; ++i) {
        int v, u, w; cin >> v >> u >> w;
        v--; u--;
        graph[v].push_back({u, w});
        graph[u].push_back({v, w});
        maxw = max(maxw, w);
    }

    if (m == n - 1) {
        dfs(0);
        for (int i = 1; i < n; ++i) {
            cout << mins[i] + maxs[i] << "\n";
        }
    } else {
        for (int i = 1; i < n; ++i) {
            cout << maxw << "\n";
        }
    }
}


int main() {
#if ELT
    freopen("../D.txt", "r", stdin);
    int q; cin >> q;
    while(q--) {
        cout << " -- TEST --\n";
        solve();
    }
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
#endif
    return 0;
}
