#include "bits/stdc++.h"

using namespace std;

typedef long long ll;

vector<ll> vals = {1, 5, 10, 50, 100, 500, 1000, 5000, 10000, 50000, (ll)1e5, (ll)5e5, (ll)1e6, (ll)5e6, (ll)1e7,
                   (ll)5e7, (ll)1e8, (ll)5e8, (ll)1e9, (ll)5e9, (ll)1e10, (ll)5e10, (ll) 1e11,
                   (ll)5e11, (ll)1e12, (ll) 5e12};

int k = vals.size();

ll inf = 1e18;

int main() {
    int t;
    cin >> t;
    for (int q = 0; q < t; ++q) {
        string s;
        cin >> s;
        int n = s.length();
        vector<vector<ll>> dp(n, vector<ll>(k, 0));
        vector<vector<char>> p(n, vector<char>(k, 0));
        for (int i = 0; i < k; ++i) {
            if (s[n - 1] == '?') {
                dp[n - 1][i] = vals[i];
                p[n - 1][i] = i;
            } else if (s[n - 1] - 'A' <= i) {
                dp[n - 1][i] = vals[s[n - 1] - 'A'];
                p[n - 1][i] = s[n - 1] - 'A';
            } else {
                dp[n - 1][i] = -inf;
            }
        }

        for (int i = n - 2; i >= 0; --i) {
            for (int j = 0; j < k; ++j) {
                if (dp[i + 1][j] == -inf) {
                    dp[i][j] = -inf;
                    continue;
                }
                if (s[i] == '?') {
                    dp[i][j] = -inf;
                    for (int cur = 0; cur <= j; ++cur) {
                        if (dp[i][j] < vals[cur] + dp[i + 1][j]) {
                            dp[i][j] = vals[j] + dp[i + 1][j];
                            p[i][j] = j;
                        }
                    }
                } else {
                    if (s[i] - 'A' > j) {
                        dp[i][j] = -inf;
                    } else if (s[i] - 'A' == j) {
                        dp[i][j] = vals[s[i] - 'A'] + dp[i + 1][j];
                        p[i][j] = j;
                    } else {
                        dp[i][j] = dp[i + 1][j] - vals[s[i] - 'A'];
                        p[i][j] = s[i] - 'A';
                    }
                }
                for (int j1 = 0; j1 < j; ++j1) dp[i][j] = max(dp[i][j], dp[i][j1]);
            }
        }
        ll ans = -inf;

        for (int i = 0; i < k; ++i) {
            if (ans < dp[0][i]) {
                ans = dp[0][i];
            }
        }
        cout << ans << '\n';
        string ans1;
        for (int pos = 0; pos < n; ++pos) {
            //cout << "ans " << ans << '\n';
            for (int i = 0; i < k; ++i) {
                if (dp[pos][i] == ans) {
                    //cout << (int)p[pos][i] << '\n';
                    ans1.push_back(p[pos][i] + 'A');
                    if (s[pos] == '?') ans -= vals[i];
                    else if (s[pos] - 'A' >= i) {
                        //cout << pos << "cool " << '\n';
                        ans -= vals[s[pos] - 'A'];
                    } else {
                        //cout << pos << "heh " << '\n';
                        ans += vals[s[pos] - 'A'];
                    }
                    break;
                }
            }
        }

        cout << ans1 << '\n';
    }

    return 0;
}