#include <iostream>
#include <vector>

using namespace std;

string s;
int n;

long long v[26] = {
    1, 5, 10, 50, 100, 500, 1000, 5000, 10000, 50000, 100000, 500000, 1000000, 5000000, 10000000, 50000000, 100000000,
    500000000, 1000000000, 5000000000, 10000000000, 50000000000, 100000000000, 500000000000, 1000000000000, 5000000000000
};

long long calc(int a) {
    long long r = 0;
    int mx = 0;
    for (int i = a; i >= 0; --i) {
        if (s[i] - 'A' >= mx) {
            mx = s[i] - 'A';
            r += v[mx];
        } else {
            r -= v[s[i] - 'A'];
        }
    }
    return r;
}

void solve() {
    cin >> s;
    n = s.size();
    for (int i = 0; i < n; ++i) {
        if (s[i] == '?') {
            int mx = 0;
            for (int j = 1; j < 26; ++j) {
                s[i] = 'A' + j;
                long long t = calc(i);
                s[i] = 'A' + mx;
                if (t > calc(i)) {
                    mx = j;
                }
            }
            s[i] = 'A' + mx;
        }
    }
    cout << calc(n - 1) << endl << s << endl;
}


int main() {
    int t;
    cin >> t;
    while (t--)
        solve();
    return 0;
}
