#include <iostream>
#include <vector>
#include <map>

using namespace std;

typedef vector <int> vi;
typedef vector <vi> vvi;
typedef pair <int, int> pii;
typedef vector <pii> vpii;
typedef vector <vpii> vvpii;

vvpii g;
vi mi, ma;

void dfs(int v, int p = -1) {
  for (auto [u, w] : g[v]) {
    if (u == p) {
      continue;
    }
    if (p == -1) {
      mi[u] = ma[u] = w;
    } else {
      mi[u] = min(mi[v], w);
      ma[u] = max(ma[v], w);
    }
    dfs(u, v);
  }
}

int main() {
  int n, m;
  cin >> n >> m;
  g.resize(n);
  map <pii, int> all;
  for (int i = 0; i < m; i++) {
    int u, v, w;
    cin >> u >> v >> w;
    u--, v--;
    if (all.find({u, v}) == all.end()) {
      all[{u, v}] = all[{v, u}] = w;
    } else {
      all[{u, v}] = all[{v, u}] = min(all[{u, v}], w);
    }
  }
  for (auto &now : all) {
    int u = now.first.first, v = now.first.second, w = now.second;
    g[u].push_back({v, w});
  }
  mi.resize(n), ma.resize(n);
  dfs(0);
  for (int v = 1; v < n; v++) {
    cout << mi[v] + ma[v] << '\n';
  }
  return 0;
}