#include <iostream>
#include <string>
#include <vector>
#include <algorithm>

using namespace std;

using ll = long long;
template <typename T>
using v = vector<T>;

ll tpow[15];

void precalc_tpow() {
	tpow[0] = 1;
	for (ll i = 1; i < 15; ++i) {
		tpow[i] = 10 * tpow[i - 1];
	}
}

ll get_digit_contrib(ll d) {
	ll pot = d >> 1;
	if (d & 1) {
		return tpow[pot] * 5;
	}
	else {
		return tpow[pot];
	}
}

int main() {
	ll t;
	cin >> t;
	precalc_tpow();
	for (ll req = 0; req < t; ++req) {
		string s;
		cin >> s;
		v<v<ll>> dpv(26, v<ll>(s.size()));
		v<v<ll>> ans(26, v<ll>(s.size()));
		for (ll i = 0; i < s.size(); ++i) {
			for (ll d = 0; d < 26; ++d) {
				if (i == 0) {
					if (s[i] == '?') {
						ll res = -1e18;
						ll maans = 0;
						for (ll cd = d; cd < 26; ++cd) {
							ll cres = get_digit_contrib(cd);
							if (cres > res) {
								res = cres;
								maans = cd;
							}
						}
						dpv[d][i] = res;
						ans[d][i] = maans;
					}
					else if (s[i] - 'A' < d) {
						dpv[d][i] = -get_digit_contrib(s[i] - 'A');
						ans[d][i] = s[i] - 'A';
					}
					else {
						dpv[d][i] = get_digit_contrib(s[i] - 'A');
						ans[d][i] = s[i] - 'A';
					}
				}
				else {
					if (s[i] == '?') {
						ll res = -1e18;
						ll maans = 0;
						for (ll cd = d; cd < 26; ++cd) {
							ll cres = dpv[cd][i - 1] + get_digit_contrib(cd);
							if (cres > res) {
								res = cres;
								maans = cd;
							}
						}
						dpv[d][i] = res;
						ans[d][i] = maans;
					}
					else if (s[i] - 'A' < d) {
						dpv[d][i] = dpv[d][i - 1] - get_digit_contrib(s[i] - 'A');
						ans[d][i] = s[i] - 'A';
					}
					else {
						dpv[d][i] = dpv[s[i] - 'A'][i - 1] + get_digit_contrib(s[i] - 'A');
						ans[d][i] = s[i] - 'A';
					}
				}
			}
		}
		/*for (ll d = 0; d < 26; ++d) {
			cout << ('A' + d) << ": ";
			for (ll i = 0; i < s.size(); ++i) {
				cout << dpv[d][i] << ' ';
			}
			cout << '\n';
		}*/
		cout << dpv[0][s.size() - 1] << '\n';
		string sans(s.size(), ' ');
		ll cmad = 0;
		for (ll i = s.size() - 1; i >= 0; --i) {
			ll cans = ans[cmad][i];
			sans[i] = 'A' + cans;
			cmad = max(cmad, cans);
		}
		cout << sans << '\n';
	}
}