#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <cmath>
#include <numeric>
using namespace std;

long long n, m;
vector<vector<pair<long long, long long>>> graph;

int main()
{
	cin >> n >> m;
	graph.resize(n);
	
	vector<long long> T;
	for (long long i = 0; i < m; ++i)
	{
		long long a, b, t; cin >> a >> b >> t; --a; --b;
		graph[a].emplace_back(b, t);
		graph[b].emplace_back(a, t);
	}

	vector<long long> mn(n), mx(n);
	mn[0] = 1e9 + 1; mx[0] = -1;


	for (long long i = 1; i < n; ++i)
	{
		long long b = 1e9 + 1;

		for (auto& j : graph[i])
			if (j.first == i - 1)
				b = min(b, j.second);

		if (n == 1e9 + 1) return 1;

		mn[i] = min(mn[i - 1], b);
		mx[i] = max(mx[i - 1], b);
	}


	for (long long i = 1; i < n; ++i)
		cout << mn[i] + mx[i] << '\n';

	return 0;
}