#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>

#define err(x) cerr << "["#x"]  " << (x) << '\n';
#define errv(x) {cerr << "["#x"]  ["; for (const auto& ___ : (x)) cerr << ___ << ", "; cerr << "]\n";}
#define errvn(x, n) {cerr << "["#x"]  ["; for (int ___ = 0; ___ < (n); ++___) cerr << (x)[___] << ", "; cerr << "]\n";}
#define errf() cerr << "\n\n";

using namespace std;

using ll = long long;
using ull = unsigned long long;
using ld = long double;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
ll getrnd(ll l, ll r) {
    return uniform_int_distribution<ll>(l, r)(rng);
}

template<typename T1, typename T2>
inline bool relax(T1& a, const T2& b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

template<typename T1, typename T2>
inline bool strain(T1& a, const T2& b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

// ::::::::::::::::::::::::::

const int N = 3e5 + 3;

int who[N], ex[N], ey[N], din[N], dout[N], d[N];
vector<pair<int, int>> graph[N], ginv[N], gr[N];

vector<int> euler;
void dfs(int v) {
    while (!graph[v].empty()) {
        auto [to, ind] = graph[v].back();
        graph[v].pop_back();

        dfs(to);
    }
    euler.push_back(v);
}

void solve() {
    int n, m;
    cin >> n >> m;

    for (int i = 0; i < m; ++i) {
        int x, y;
        cin >> x >> y;
        --x; --y;

        ex[i] = x;
        ey[i] = y;
        ++dout[x];
        ++din[y];
        graph[x].emplace_back(y, i);
        ginv[y].emplace_back(x, i);
    }

//    for (int i = 0; i < m; ++i)
//        who[i] = -1;
//    for (int i = 0; i < m; ++i) {
//        if (din[ex[i]] == 0 && dout[ey[i]] == 0) {
//            cout << "No\n";
//            return;
//        }
//        int ind = -1;
//        if (din[ex[i]] == 1 && dout[ey[i]] == 0) {
//            ind = ginv[ex[i]][0].second;
//        }
//        if (din[ex[i]] == 0 && dout[ey[i]] == 1) {
//            ind = graph[ey[i]][0].second;
//        }
//
//        if (ind != -1) {
//            if (who[ind] != -1) {
//                cout << "No\n";
//                return;
//            }
//            who[ind] = i;
//            who[i] = ind;
//        }
//    }

//    for (int i = 0; i < m; ++i) {
//        if (who[i] == -1) {
//            ++d[ex[i]];
//            --d[ey[i]];
//            gr[ex[i]].emplace_back(ey[i], i);
//        }
//    }

    int st = -1, c = 0;
    for (int i = 0; i < n; ++i) {
        if (dout[i] - din[i] == 1) {
            if (st != -1) {
                cout << "No\n";
                return;
            }
            st = i;
        }
        if (dout[i] - din[i] == -1) {
            if (c != 0) {
                cout << "No\n";
                return;
            }
            c = 1;
        }
        if (abs(dout[i] - din[i]) > 1) {
            cout << "No\n";
            return;
        }
    }
    if (st == -1) st = 0;

    dfs(st);
    for (int i = 0; i < n; ++i) {
        if (!graph[i].empty())
            dfs(i);
    }
    reverse(euler.begin(), euler.end());
    errv(euler);
    err(euler.size());
//    if (euler.size() != m + 2) {
//        cout << "No\n";
//    }
    cout << "Yes\n";
    for (int i = 0; i + 2 < euler.size(); i += 3) {
        cout << euler[i] + 1 << ' ' << euler[i + 1] + 1 << ' ' << euler[i + 1] + 1 << ' ' << euler[i + 2] + 1 << '\n';
    }
}

/*
5 6
1 2
2 1
1 5
2 3
2 4
4 2

4 4
2 1
2 3
2 4
4 2

4 4
1 2
2 1
3 4
4 3


*/

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr); cout.tie(nullptr);

    int t = 1;
//    cin >> t;
    while (t--)
        solve();
}


