#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>

#define err(x) cerr << "["#x"]  " << (x) << '\n';
#define errv(x) {cerr << "["#x"]  ["; for (const auto& ___ : (x)) cerr << ___ << ", "; cerr << "]\n";}
#define errvn(x, n) {cerr << "["#x"]  ["; for (int ___ = 0; ___ < (n); ++___) cerr << (x)[___] << ", "; cerr << "]\n";}
#define errf() cerr << "\n\n";

using namespace std;

using ll = long long;
using ull = unsigned long long;
using ld = long double;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
ll getrnd(ll l, ll r) {
    return uniform_int_distribution<ll>(l, r)(rng);
}

template<typename T1, typename T2>
inline bool relax(T1& a, const T2& b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

template<typename T1, typename T2>
inline bool strain(T1& a, const T2& b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

// ::::::::::::::::::::::::::

void solve() {
    int n, q;
    cin >> n >> q;

    vector<int> x(n), h(n);
    for (int i = 0; i < n; ++i)
        cin >> x[i] >> h[i];

    for (int rep = 0; rep < q; ++rep) {
        int l, r;
        cin >> l >> r;

        --l; --r;
        int res = 0;
        vector<int> st;
        for (int i = l; i <= r; ++i) {
            while (!st.empty()) {
                if (x[st.back()] + h[st.back()] > x[i])
                    break;
                ++res;
                st.pop_back();
            }

            bool canl = x[i] - h[i] >= x[0];
            bool canr = x[i] + h[i] <= x[n - 1];

            if (!st.empty() && x[i] - h[i] < x[st.back()])
                canl = 0;
            if (i + 1 < n && x[i] + h[i] > x[i + 1])
                canr = 0;

            if (!canl && !canr)
                st.push_back(i);
            else {
                ++res;
            }
        }
        while (!st.empty()) {
            if (x[st.back()] + h[st.back()] > x[min(r + 1, n - 1)])
                break;
            ++res;
            st.pop_back();
        }
//        errv(st);
        cout << res << '\n';
    }
}

/*
3 3
1 3
3 1
4 2
1 1
2 3
1 3

5 3
1 5
3 1
4 2
5 3
6 1
1 5
5 5
1 1

1 1
100 100
1 1
*/

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr); cout.tie(nullptr);

    int t = 1;
//    cin >> t;
    while (t--)
        solve();
}

