#include <bits/stdc++.h>
#define debug(x) std::cout << #x << ": " << x << '\n';
#define pb push_back
#define FOR(i, n) for (int i = 0; i < (int)(n); ++i)
#define mp std::make_pair
typedef long long ll;
const int N = 3e5 + 10, K = 26, INF = 1e9;
struct edge
{
	ll a, b;
	ll cost;
};
struct dsu
{
	int p[N];
	std::vector<int> v[N];

	dsu(int n) {
		FOR(i, n) {
			v[i].pb(i);
			p[i] = i;
		}
	}

	int find(int x) {
		return p[x] == x ? x : p[x] = find(p[x]);
	}

	void unite(int a, int b) {
		a = find(a);
		b = find(b);

		if (v[a].size() < v[b].size()) std::swap(a, b);

		p[b] = a;
		while (!v[b].empty()) {
			v[a].pb(v[b].back());
			v[b].pop_back();
		}
	}
};
ll answ[N];
int main() {
	std::ios::sync_with_stdio(false);
	std::cin.tie(0);
	int n, m;
	std::cin >> n >> m;
	std::vector<edge> v;
	FOR(i, m) {
		int a, b, c;
		std::cin >> a >> b >> c;
		--a; --b;
		v.pb({a, b, c});
	}
	ll max = 1e9;
	std::sort(v.begin(), v.end(), [](auto a, auto b) {
		return a.cost > b.cost;
	});
	dsu check(n);
	FOR(i, m) {
		int p1 = check.find(v[i].a);
		int p2 = check.find(v[i].b);
		if (p1 != p2) {
			if (check.find(0) == p1) {
				for (auto e : check.v[p2]) {
					answ[e] = max + v[i].cost;
				}
			}
			if (check.find(0) == p2) {
				for (auto e : check.v[p1]) {
					answ[e] = max + v[i].cost;
				}
			}
			check.unite(p1, p2);
		}
	}
	for (int i = 1; i < n; ++i) {
		std::cout << answ[i] << '\n';
	}
}