#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <algorithm>
#include <iomanip>

#pragma warning(disable : 4996)

using itn = int;

using namespace std;

const long long INF = 1e18;

vector <long long> val(26);

string s;

int maxim = 0;

vector <vector <long long>> dp;
vector <vector <char>> dp2;
vector <vector <int>> pred;

void solve() {
	cin >> s;
	reverse(s.begin(), s.end());
	dp.assign(s.size(), vector <long long>(26, -INF));
	dp2.assign(s.size(), vector <char>(26, '*'));
	pred.assign(s.size(), vector <int>(26, 0));
	for (int i = 0; i < s.size(); ++i) {
		if (s[i] == '?') {
			for (int j = 0; j < 26; ++j) {
				if (i == 0) {
					dp[i][j] = val[j];
					dp2[i][j] = 'A' + j;
				}
				else {
					int best1 = -1, best2 = -1;
					for (int k = 0; k <= j; ++k) {
						long long this_ = dp[i - 1][k] + val[j];
						if (this_ > dp[i][j]) {
							dp[i][j] = this_;
							best1 = k;
						}
					}
					for (int k = 0; k < j; ++k) {
						long long this_ = dp[i - 1][j] + val[k];
						if (this_ > dp[i][j]) {
							dp[i][j] = this_;
							best2 = k;
						}
					}
					if (best2 != -1) {
						pred[i][j] = j;
						dp2[i][j] = 'A' + best2;
					}
					else {
						pred[i][j] = best1;
						dp2[i][j] = 'A' + j;
					}
				}
			}
		}
		else {
			int vv = s[i] - 'A';
			if (i == 0) {
				dp[0][vv] = val[vv];
				dp2[0][vv] = s[i];
				pred[0][vv] = -1;
			}
			else {
				for (int j = 0; j <= vv; ++j) {
					long long this_ = dp[i - 1][j];
					this_ += val[vv];
					if (this_ > dp[i][vv]) {
						dp[i][vv] = this_;
						dp2[i][vv] = s[i];
						pred[i][vv] = j;
					}
				}
				for (int j = vv + 1; j < 26; ++j) {
					long long this_ = dp[i - 1][j];
					this_ -= val[vv];
					if (this_ > dp[i][j]) {
						dp[i][j] = this_;
						dp2[i][j] = s[i];
						pred[i][j] = j;
					}
				}
			}
		}
	}
	int ind = 0;
	for (int i = 0; i < 26; ++i) {
		if (dp[s.size() - 1][i] > dp[s.size() - 1][ind])
			ind = i;
	}
	cout << dp[s.size() - 1][ind] << "\n";
	string answer = "";
	for (int i = s.size() - 1; i >= 0; --i) {
		answer += dp2[i][ind];
		ind = pred[i][ind];
	}
	cout << answer << "\n";
}

int main() {
	val[0] = 1;
	for (int i = 1; i < 26; ++i) {
		if (i % 2 == 1)
			val[i] = val[i - 1] * 5;
		else
			val[i] = val[i - 1] * 2;
	}
	int t;
	cin >> t;
	for (int i = 0; i < t; ++i)
		solve();
}