#include <bits/stdc++.h>
using namespace std;

#define fastream ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
typedef long long ll;
typedef pair<int, int> pii;

ll bin_pow(ll x, ll p) {
    if (p == 0) {
        return 1;
    }
    if (p & 1) {
        return bin_pow(x, p - 1) * x;
    } else {
        return bin_pow(x * x, p >> 1);
    }
}

ll dp[300000][26];
vector<ll> vals;
pii p[300000][26];

signed main() {
    fastream;
    for (int i = 0; i < 26; i++) {
        ll x = bin_pow(10, i / 2);
        if (i % 2) {
            x *= 5;
        }
        vals.push_back(x);
    }
    int t;
    cin >> t;
    while (t--) {
        string s;
        cin >> s;
        int n = s.size();
        for (int i = 0; i <= n; i++) {
            fill(dp[i], dp[i] + 26, -1e18);
        }
        dp[n][0] = 0;
        for (int i = n; i > 0; i--) {
            for (int j = 0; j < 26; j++) {
                if (dp[i][j] == -1e18) {
                    continue;
                }
                if (s[i - 1] == '?') {
                    for (int k = 0; k < 26; k++) {
                        if (k < j) {
                            if (dp[i][j] - vals[k] > dp[i - 1][j]) {
                                dp[i - 1][j] = dp[i][j] - vals[k];
                                p[i - 1][j] = {k, j};
                            }
                        } else {
                            if (dp[i][j] + vals[k] > dp[i - 1][k]) {
                                dp[i - 1][k] = dp[i][j] + vals[k];
                                p[i - 1][k] = {k, j};
                            }
                        }
                    }
                } else {
                    if (s[i - 1] - 'A' < j) {
                        if (dp[i][j] - vals[s[i - 1] - 'A'] > dp[i - 1][j]) {
                            dp[i - 1][j] = dp[i][j] - vals[s[i - 1] - 'A'];
                            p[i - 1][j] = {s[i - 1] - 'A', j};
                        }
                    } else {
                        if (dp[i][j] + vals[s[i - 1] - 'A'] > dp[i - 1][s[i - 1] - 'A']) {
                            dp[i - 1][s[i - 1] - 'A'] = dp[i][j] + vals[s[i - 1] - 'A'];
                            p[i - 1][s[i - 1] - 'A'] = {s[i - 1] - 'A', j};
                        }
                    }
                }
            }
        }
        int k = max_element(dp[0], dp[0] + 26) - dp[0];
        cout << dp[0][k] << endl;
        string res;
        for (int i = 0; i < n; i++) {
            res += 'A' + p[i][k].first;
            k = p[i][k].second;
        }
        cout << res << endl;
    }
}