from sys import setrecursionlimit

setrecursionlimit(3000000)

def letter_to_num(l):
    return ord(l)-ord('A')


def calculate(word, maximum, pos):
    if pos == -1:
        return 0

    if word[pos].isalpha():
        letter = letter_to_num(word[pos])
        if letter >= maximum:
            return calculate(word, letter, pos-1) + numbers[letter]
        else:
            return calculate(word, maximum, pos-1) - numbers[letter]


numbers = [1, 5, 10, 50, 100, 500, 1000, 5000, 10000, 50000, 100000, 500000, 1000000, 5000000, 10000000, 50000000,
           100000000, 500000000, 1000000000, 5000000000, 10000000000, 50000000000, 100000000000, 500000000000,
           1000000000000, 5000000000000]

t = int(input())
for _ in range(t):
    word = input()
    m = word[-1]
    s = 0
    for i in word[::-1]:
        if i < m:
            s -= numbers[letter_to_num(i)]
        else:
            m = i
            s += numbers[letter_to_num(i)]
    #print(calculate(word, -1, len(word)-1))
    print(s)
    print(word)

