#include <bits/stdc++.h>

#define endl "\n"
using namespace std;

#define double long double
#define int long long

#ifdef LOCAL
ifstream fin; // NOLINT(cert-err58-cpp)
#define cin fin
#endif

void solve() {
    int cnt_pos[28];
    int cnt_neg[28];
    memset(cnt_pos, 0, sizeof(cnt_pos));
    memset(cnt_neg, 0, sizeof(cnt_neg));

    string s;
    cin >> s;
    int n = s.length();

    for (int i = 0; i < n; i++) {
        int v = s[i] - 'A';
        for (int j = 0; j < v; j++) {
            cnt_neg[j] += cnt_pos[j];
            cnt_pos[j] = 0;
        }
        cnt_pos[v]++;
    }

    int res = 0;
    int v = 1;
    for (int i = 0; i < 28; i++) {
        res += (cnt_pos[i] - cnt_neg[i]) * v;
        if (i & 1) {
            v *= 2;
        } else {
            v *= 5;
        }
    }
    cout << res << endl;
}

#define MULTITEST

int32_t main() {
#ifdef LOCAL
    fin.open("in.txt");
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef MULTITEST
    int32_t _t;
    cin >> _t;
    while (_t--)
#endif
        solve();
    return 0;
}
