#include <bits/stdc++.h>

#define endl "\n"
using namespace std;

#define double long double
#define int long long

#ifdef int
#define IMIN INT64_MIN
#define IMAX INT64_MAX
#endif

#ifdef LOCAL
ifstream fin; // NOLINT(cert-err58-cpp)
#define cin fin
#endif

struct dp_t {
    int cnt, l, r;
};

void solve() {
    int n, q;
    cin >> n >> q;
    pair<int, int> t[n];
    for (int i = 0; i < n; i++) {
        cin >> t[i].first >> t[i].second;
    }

    dp_t dp[n + 1][n];
    for (int len = 1; len <= n; len++) {
        for (int i = 0; i + len <= n; i++) {
            dp[len][i].cnt = IMIN;
            for (int j = i; j < i + len; j++) {
                auto l = (j - i != 0 ? dp[j - i][i] : dp_t{.cnt = 0, .l = t[max(i - 1, (int) 0)].first, .r = IMAX});
                auto r = (i + len - j - 1 != 0 ? dp[i + len - j - 1][j + 1] : dp_t{.cnt = 0, .l = IMIN, .r = t[min(i + len,
                                                                                                           n -
                                                                                                           1)].first});

                int cres = l.cnt + r.cnt;

                bool can = t[j].first + t[j].second <= r.r ||
                           t[j].first - t[j].second >= l.l;

                if (can) {
                    cres++;
                }

                if (cres > dp[len][i].cnt) {
                    dp[len][i].cnt = cres;
                    dp[len][i].l = max(r.l, max(can ? IMIN : t[j].first, l.l != t[j].first ? l.r : IMIN));
                    dp[len][i].r = min(l.r, min(can ? IMAX : t[j].first, r.r != t[j].first ? r.r : IMAX));
                }
            }
        }
    }

    for (int asd = 0; asd < q; asd++) {
        int l, r;
        cin >> l >> r;
        l--;
        cout << dp[r - l][l].cnt << endl;
    }
}

//#define MULTITEST

int32_t main() {
#ifdef LOCAL
    fin.open("in.txt");
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef MULTITEST
    int32_t _t;
    cin >> _t;
    while (_t--)
#endif
    solve();
    return 0;
}
