#include <bits/stdc++.h>

using namespace std;

string s;
int n;

int bit(int x, int i) {
    return (x >> i) & 1;
}

void encode() {
    cout << s;
    for (int i = 0; i < 17; i++) {
        int x = 0;
        for (int j = 0; j < n; j++) {
            if (bit(j, i)) {
                x ^= int(s[j] - '0');
            }
        }
        cout << x;
    }
}

void decode() {
    n -= 17;
    vector<int> xors(17, 0);
     for (int i = 0; i < 17; i++) {
        for (int j = 0; j < n; j++) {
            if (bit(j, i)) {
                xors[i] ^= int(s[j] - '0');
            }
        }
    }
    for (int i = 0; i < n; i++) {
        bool good = true;
        for (int j = 0; j < 17; j++) {
            if (bit(i, j)) {
                if (xors[j] ^ 1 != int(s[n + j] - '0')) {
                    good = false;
                    break;
                }
            }
            else {
                if (xors[j] != int(s[n + j] - '0')) {
                    good = false;
                    break;
                }
            }
        }
        if (good) {
            s[i] = '0' + '1' - s[i];
            break;
        }
    }
    for (int i = 0; i < n; i++) {
        cout << s[i];
    }
}

int main() {
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int x;
    cin >> x >> s;
    n = s.size();
    if (x == 1) {
        encode();
    }
    else {
        decode();
    }
}
