from math import floor
from math import ceil

def encode(x):
    n=len(x)
    y=x
    p=0
    while 2**p<=n:
        
        i=0
        step=2**p
        data=0
        while i<n:
            if i%step<step/2:
                #print(i)
                if x[i]=="1":
                    data=1-data
            i+=1
        y+=str(data)
        p+=1
    y+=y[n]
    return y

def decode(z):
    n1=len(z)-1
    p=0
    while True:
        n=n1-p
        if n<=2**p:
            break
        p+=1
    
    s=""
    p1=0
    while 2**p1<=n:
        
        i=0
        step=2**p1
        data=0
        while i<n:
            if i%step<step/2:
                #print(i)
                if z[i]=="1":
                    data=1-data
            i+=1
        s+=str(data)
        p1+=1
    
    err=""
    for i in range(p):
        if s[i]!=z[n+i]:
            err+="1"
        else:
            err+="0"
    
    #print(err)
    
    if err[0]=="1":
        #has error in string or s0
        if z[-1]!=z[n]:
            #have's error in s0
            z=z[:n]+str(1-int(z[n]))+z[n+1:]
            return z,n
        #has error in string
        imax=n-1
        imin=0
        for i in range(1,p):
            #print(imin, imax)
            imid=(imax+imin)/2
            step=2**p
            #i%step<step/2
            if err[p-i]=="0":
                imin=ceil(imid)
                
            else:
                imax=floor(imid)
        imid=(imax+imin)//2
        #has error in imid
        z=z[:imid]+str(1-int(z[imid]))+z[imid+1:]      
        return z,n
        
                
    else:
        #no error in string and s0
        for i in range(1,p):
            if err[i]=="1":
                #error in si
                z=z[:n+i]+str(1-int(z[n+i]))+z[n+i+1:]
                return z,n
        #no error
        return z,n
    
test=int(input())

if test==1:
    print(encode(input()))
else:
    r,n=decode(input())
    print(r[:n])