#include <iostream>
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;
using namespace std;
using ll = long long;
using ordered_set = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;
ll mod = 1e9 + 7;

ll bin_pow(int a, int n){
    if (n == 0){
        return 1;
    }
    if (n & 1){
        return bin_pow(a, n - 1) * a % mod;
    }else {
        ll rez = bin_pow(a, n / 2);
        return rez * rez % mod;
    }
}

ll inv(ll n){
    return bin_pow(n, mod - 2);
}
void print(string str){
    for (int i = 0; i < str.length() - 17; i++){
        cout << str[i];
    }
    cout << endl;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int type;
    cin >> type;
    if (type == 1){
        string str;
        cin >> str;
        int n = str.size();
        ll cur_ans = 0;
        ll cur_mod = 1;
        for (int i = 0; i < n; i++){
            cout << str[i];
            if (str[i] - '0'){
                cur_ans += cur_mod;
                cur_ans %= mod;
            }
            cur_mod *= 3;
            cur_mod %= mod;
        }
//        cout << endl;
//        cout << cur_ans % bin_pow(2, 18) << endl;
        for (int i = 0; i < 17; i++){
            if (cur_ans % 2 == 0){
                cout << 0;
            }else{
                cout << 1;
            }
            cur_ans /= 2;
        }
    }else{
        //////////////////////////////////
        string s;
        cin >> s;
        int n = s.length();
        //////////////////////////////////////////////
        ll cur_ans = 0;
        for (int i = n - 17, pow = 1; i < n; i++, pow *= 2) {
            if (s[i] - '0') {
                cur_ans += pow;
            }
        }
        //////////////////////////////////////////////////////
        ll stup_ans = 0;
        ll pow = 1;
        for (int i = 0; i < n - 17; i++){
            if (s[i] - '0'){
                stup_ans += pow;
                stup_ans %= mod;
            }
            pow *= 3;
            pow %= mod;
        }
//        cout << stup_ans % bin_pow(2, 18) << endl;
        if (stup_ans % bin_pow(2, 18) == cur_ans){
            print(s);
            return 0;
        }
        ////////////////////////////////////////////////////////
        vector<ll> suf_ans(n);
        pow = 1;
        ll c_a = 0;
        for (int i = 0; i < n - 17; i++){
            if (s[i] - '0'){
                c_a += pow;
                c_a %= mod;
            }
            pow *= 3;
            pow %= mod;
            suf_ans[i] = ((stup_ans - c_a) % mod + mod) % mod;
        }
        ll ans = 0;
        pow = 1;
        for (int i = 0; i < n - 17; i++){
            if (s[i] - '0'){
//                cout << (ans + suf_ans[i]) % mod % bin_pow(2, 18) << endl;
                if ((ans + suf_ans[i]) % mod % bin_pow(2, 18) == cur_ans){
//                    cout << i << endl;
                    s[i] = '0';
                    print(s);
                    return 0;
                }
                ans += pow;
                ans %= mod;
            }else{
//                cout << (ans + pow + suf_ans[i] ) % mod % bin_pow(2, 18) << endl;
                if ((ans + pow + suf_ans[i]) % mod % bin_pow(2, 18) == cur_ans){
//                    cout << i << endl;
                    s[i] = '1';
                    print(s);
                    return 0;
                }
            }
            pow *= 3;
            pow %= mod;

        }
        print(s);
    }
    return 0;
}




