#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>
#include <string>

using namespace std;

#define endl '\n'

#define range(i, n) for (int i = 0; i < (n); ++i)
#define rrange(i, n) for (int i = (n) - 1; i >= 0; --i)

#define all(a) a.begin(), a.end()

typedef int64_t ll;
typedef uint64_t ull;
//typedef __int128_t lll;
//typedef __uint128_t ulll;

void setup() {
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
}
void solve();
signed main() {
    setup();
    int t = 1;
//    cin >> t;
    range(i, t) {
        solve();
    }
}


string sum(string a, string b) {
    int d = 0;
    string ans;
    range(i, a.size()) {
        int t = a[i] - '0' + b[i] -'0' + d;
        ans.push_back(t % 10 + '0');
        d = t / 10;
    }
    if (d) ans.push_back(d + '0');
    while(ans.back() == '0') ans.pop_back();
    return ans;
}

string raz(string a, string b) {
    int d = 0;
    string ans;
    range(i, a.size()) {
        int t = (a[i] - '0') - d - (b[i] - '0') ;
        if (t < 0) {t += 10; d = 1;}
        else {d = 0;}
        ans.push_back(t + '0');
    }
    while(ans.back() == '0') ans.pop_back();
    return ans;
}

bool cmp(string a, string b) {
    rrange(i, a.size()) {
        if (a[i] > b[i]) return false;
        if (a[i] < b[i]) return true;
    }
    return false;
}



void solve() {
    string a;
    string b;
    cin >> a >> b;
    reverse(all(a));
    reverse(all(b));
    bool za = 0, zb = 0;
    if (a.back() == '-') {za = 1; a.pop_back();}
    if (b.back() == '-') {zb = 1; b.pop_back();}
    range(i, max(a.size(), b.size())) {
        if (a.size() <= i) a.push_back('0');
        if (b.size() <= i) b.push_back('0');
    }
    string ans;
    if (za && zb) {
        ans = sum(a, b);
        ans.push_back('-');
    } else if (za) {
        if (cmp(a, b)) {
            ans = raz(b, a);
        } else {
            ans = raz(a, b);
            ans.push_back('-');
        }
    } else if (zb) {
        if (cmp(b, a)) {
            ans = raz(a, b);
        } else {
            ans = raz(b, a);
            ans.push_back('-');
        }
    } else {
        ans = sum(a, b);
    }

    while(ans.back() == '0') ans.pop_back();
    reverse(all(ans));
    cout << ans;
}
