#include <bits/stdc++.h>


using namespace std;

#define int long long
#define pb push_back
typedef long double ld;
#define endl '\n'

const int maxn = 1000000;
int t[maxn * 4];

void build (vector<int> &A, int l, int r, int i) {
    if (l + 1 == r) {
        if (l < A.size()) t[i] = A[l];
        return;
    }
    int m = (l + r) / 2;
    build (A, l, m, i * 2 + 1);
    build (A, m, r, i * 2 + 2);
    t[i] = max(t[i * 2 + 1], t[i * 2 + 2]);
}

void upd (int x, int pos, int l, int r, int i) {
    if (l + 1 == r) {
        t[i] = x;
        return;
    }
    int m = (l + r) / 2;
    if (m > pos) {
        upd (x, pos, l, m, i * 2 + 1);
    } else {
        upd (x, pos, m, r, i * 2 + 2);
    }
    t[i] = max(t[i * 2 + 1], t[i * 2 + 2]);
}

int query (int l, int r, int ql, int qr, int i) {
    if (l >= ql && r <= qr) {
        return t[i];
    }
    if (l >= qr || r <= ql) {
        return 0;
    }
    int m = (l + r) / 2;
    return max(query (l, m, ql, qr, i * 2 + 1), query (m, r, ql, qr, i * 2 + 2));
}

signed main() {
//    ios::sync_with_stdio(false);
//    cin.tie(nullptr);
//    cout.tie(nullptr);
    int n;
    cin >> n;
    if (n == 1) {
        string s;
        cin >> s;
        for (int i = 0; i < 3; i++) {
            for (int j = 0; j < s.size(); j++) {
                cout << s[j];
            }
        }
        cout << endl;
    } else {
        string s;
        cin >> s;
        int m = s.size() / 3;
        vector<int> lol(m);
        for (int i = 0; i < 3; i++) {
            for (int j = i * m; j < (i + 1) * m; j++) {
                if (s[j] == 1) lol[j % m]++;
            }
        }
        for (int i = 0; i < m; i++) {
            if (lol[i] >= 2) {
                cout << 1;
            } else {
                cout << 0;
            }
        }
        cout << endl;
    }
    return 0;
}
