#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define range(i, n) for(int i = 0; i < (n); ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define ar array

typedef long long ll;
using namespace std;
using namespace __gnu_pbds;

using ordered_set = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

void solve1() {
    auto ask = [&] (int x) {
        cout << x << '\n';
        int res; cin >> res;
        if (res == 0) exit(0);
        return res == 1;
    };
    int l = 0;
    int r; cin >> r;
    r++;
    while(r - l > 1) {
        int mid = (r + l) / 2;
        if (ask(mid)) {
            l = mid;
        } else {
            r = mid;
        }
    }
}

void solve2() {
    int n; cin >> n;
    int q; cin >> q;
    auto ask = [&] (int x) {
        int res; cin >> res;
        if (res == 0) {
            cout << x << '\n';
            exit(0);
        }
        return res == 1;
    };
    int l = 0;
    int r = n + 1;
    while(r - l > 1) {
        int mid = (r + l) / 2;
        if (ask(mid)) {
            l = mid;
        } else {
            r = mid;
        }
    }
}

void solve() {
    int x; cin >> x;
    if (x == 1) solve1();
    else solve2();
}

int main() {
    ios_base::sync_with_stdio(false);
    //cin.tie(0);
    int tests = 1;
    range(_, tests) {
        solve();
    }
    return 0;
}