#include <bits/stdc++.h>

#define int long long
#define double long double
#define all(x) x.begin(), x.end()

using namespace std;

const int mod = (int) 1e7 + 7;
const int MAXN = 777;

double dist[MAXN][MAXN];

int my_rand() {
    return 179179179179179LL;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    for (int i = 0; i < MAXN; i++) {
        for (int j = 0; j < MAXN; j++) {
            dist[i][j] = my_rand() / (double) 1000000;
        }
        dist[i][i] = 0.0;
    }
    for (int i = 0; i < MAXN; i++) {
        for (int j = 0; j < MAXN; j++) {
            dist[i][j] = dist[j][i];
        }
    }
    for (int k = 0; k < MAXN; k++) {
        for (int i = 0; i < MAXN; i++) {
            for (int j = 0; j < MAXN; j++) {
                dist[i][j] = min(dist[i][j], dist[i][k] + dist[j][k]);
            }
        }
    }
    double mx = 0.0;
    for (int i = 0; i < MAXN; i++) {
        for (int j = 0; j < MAXN; j++) {
            mx = max(mx, dist[i][j]);
        }
    }
    cout << fixed << setprecision(20) << mx << '\n';
}
