#include <bits/stdc++.h>

using namespace std;

bool operator >(string a, string b){
    if(a.size() > b.size())
        return 1;
    if(b.size() > a.size())
        return 0;
    for(int i = 0; i < a.size(); ++i){
        if(a[i] > b[i])
            return 1;
        if(a[i] < b[i])
            return 0;
    }
    return 0;
}

bool operator <(string a, string b){
    if(a.size() > b.size())
        return 0;
    if(b.size() > a.size())
        return 1;
    for(int i = 0; i < a.size(); ++i){
        if(a[i] > b[i])
            return 0;
        if(a[i] < b[i])
            return 1;
    }
    return 0;
}

string operator +(string a, string b){
    if(a.size() < b.size())
        swap(a, b);
    reverse(a.begin(), a.end());
    reverse(b.begin(), b.end());
    int r = 0;
    for(int i = 0; i < b.size(); ++i){
        a[i] -= '0', a[i] += b[i] - '0' + r;
        r = a[i] / 10, a[i] %= 10;
        a[i] += '0';
    }
    for(int i = b.size(); i < a.size(); ++i){
        a[i] -= '0', a[i] += r;
        r = a[i] / 10, a[i] %= 10;
        a[i] += '0';
    }
    if(r != 0)
        a.push_back(r + '0'), r = 0;
    reverse(a.begin(), a.end());
    return a;
}

string operator -(string a, string b){
    bool f = 0;
    if(a < b)
        swap(a, b), f = 1;
    reverse(a.begin(), a.end());
    reverse(b.begin(), b.end());
    int r = 0;
    for(int i = 0; i < b.size(); ++i){
        a[i] -= '0';
        a[i] -= (b[i] - '0') - r;
        if(a[i] < 0)
            r = 1, a[i] += 10;
        else
            r = 0;
        a[i] += '0';
    }
    for(int i = b.size(); i < a.size(); ++i){
        a[i] -= '0';
        a[i] -= r;
        if(a[i] < 0)
            r = 1, a[i] += 10;
        else
            r = 0;
        a[i] += '0';
    }
    while(a.back() == '0'&& a.size() > 2)
        a.pop_back();
    if(f && a != "0")
        a.push_back('-');
    reverse(a.begin(), a.end());
    return a;
}

int main()
{
    string a, b; cin >> a >> b;
    if(a[0] == '-' && b[0] == '-'){
        a.erase(a.begin()), b.erase(b.begin());
        string c = a + b;
        if(c != "0")
            c.insert(c.begin(), '-');
        cout << c << '\n';
        return 0;
    }
    if(a[0] == '-'){
        a.erase(a.begin());
        cout << b - a;
        return 0;
    }
    if(b[0] == '-'){
        b.erase(b.begin());
        cout << a - b;
        return 0;
    }
    cout << a + b;
    return 0;
}
