#include <bits/stdc++.h>

using namespace std;

template<typename T>
istream &operator>>(istream &is, vector<T> &v) {
    for (auto &i : v) {
        is >> i;
    }
    return is;
}

template<typename T>
istream &operator>>(istream &is, pair<T, T> &p) {
    is >> p.first >> p.second;
    return is;
}

template<typename T>
ostream &operator<<(ostream &os, vector<T> &v) {
    for (auto &i : v) {
        os << i << ' ';
    }
    return os;
}

template<typename T>
ostream &operator<<(ostream &os, pair<T, T> &p) {
    os << p.first << ' ' << p.second;
    return os;
}

#define all(a) a.begin(), a.end()
#define nl '\n'
#define elif else if
#define forn(i, n) for (int i = 0; i < n; i++)
#define pb push_back
#define vi vector<int>
#define pi pair<int, int>
#define vpi vector<pair<int, int>>
#define maxq(ma, a) ma = max(ma, a)
#define minq(mi, a) mi = min(mi, a)

typedef long long ll;

auto seed = chrono::high_resolution_clock::now().time_since_epoch().count();
mt19937 rnd(seed);

inline void IO() {
#ifdef Dmitry07
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

// #define int ll

const int MAXN = 1e3 + 10;

int d[MAXN][MAXN];

void Solve() {
    int n = 1012;
    forn (i, n) {
        forn (j, n) {
            d[i][j] = rnd() % 1000;
        }
    }
    forn (p, n) {
        forn (i, n) {
            forn (j, n) {
                minq(d[i][j], d[i][p] + d[p][j]);
            }
        }
    }
    ll a, b;
    cin >> a >> b;
    cout << a + b;
}

signed main() {
    IO();
    int t = 1;
//    cin >> t;
    for (int ii = 0; ii < t; ii++) {
        Solve();
    }
    return 0;
}