#include <iostream>
#include <vector>
#include <set>
#include <string>
#include <cassert>


using namespace std;


#pragma warning(disable:4996)
#define int long long


const int mod = 1e9 + 9;
const int x = 129;
const int maxn = 1e5 + 10;
int pw[maxn];


signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
#ifdef _DEBUG
	assert(freopen("input.txt", "r", stdin));
#endif
	pw[0] = 1;
	for (int i = 1; i < maxn; i++)
		pw[i] = pw[i - 1] * x % mod;
	int t;
	cin >> t;
	if (t == 1) {
		string s;
		cin >> s;
		int x = 0;
		int n = s.size();
		for (int i = 0; i < n; i++) {
			if (s[i] == '1') {
				x += pw[i + 1];
				x %= mod;
			}
		}
		cout << s;
		for (int i = 0; i < 30; i++) {
			if ((x >> i) & 1)
				cout << '1';
			else
				cout << '0';
		}
		for (int i = 0; i < 30; i++) {
			if ((x >> i) & 1)
				cout << '1';
			else
				cout << '0';
		}
		for (int i = 0; i < 30; i++) {
			if ((x >> i) & 1)
				cout << '1';
			else
				cout << '0';
		}
		cout << endl;
		//cout << endl;
		//cout << x << endl;
	}
	if (t == 2) {
		string s;
		cin >> s;
		int t = s.size() - 90;
		int y = 0, x = 0;
		for (int i = 0; i < 30; i++) {
			int f0 = 0;
			int f1 = 0;
			f0 += (s[t + i] == '0');
			f0 += (s[t + i + 30] == '0');
			f0 += (s[t + i + 60] == '0');
			f1 += (s[t + i] == '1');
			f1 += (s[t + i + 30] == '1');
			f1 += (s[t + i + 60] == '1');
			if (f0 < f1) {
				x += (1LL << i);
				x %= mod;
			}
		}
		for (int i = 0; i < t; i++)
			if (s[i] == '1') {
				y += pw[i + 1];
				y %= mod;
			}
		if (x == y) {
			cout << s.substr(0, t) << endl;
			return 0;
		}
		for (int i = 0; i < t; i++) {
			if (s[i] == '0') {
				s[i] = '1';
				y += pw[i + 1];
				y %= mod;
				if (y == x) {
					cout << s.substr(0, t) << endl;
					return 0;
				}
				y -= pw[i + 1] - mod;
				y %= mod;
				s[i] = '0';
			}
			else {
				s[i] = '0';
				y -= pw[i + 1] - mod;
				y %= mod;
				if (y == x) {
					cout << s.substr(0, t) << endl;
					return 0;
				}
				y += pw[i + 1];
				y %= mod;
				s[i] = '1';
			}
		}
		assert(0);
	}
	return 0;
}