#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>

using namespace std;

#define fastInp cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);

typedef long long ll;
typedef long double ld;

const ll SZ = 2e5 + 100;

int qs(ll vl) {
	cout << vl << endl;
	ll a;
	cin >> a;
	if (a == 0) exit(0);
	return a;
}

void sol1() {
	ll n;
	cin >> n;

	ll l = 1, r = n + 1;

	while (r - l > 1) {
		ll mid = (l + r) / 2;
		ll qr = qs(mid);

		if (qr == 1) {
			l = mid;
		}
		else {
			r = mid;
		}
	}

	cout << l << endl;
}

ll i = 0;

int qs2(ll vl, vector<ll>& vec) {
	ll a = vec[i];
	i++;
	if (a == 0) {
		cout << vl;
		exit(0);
	}
	return a;
}

void sol2() {
	ll n;
	cin >> n;

	ll sz;
	cin >> sz;
	vector<ll> vec(sz);
	for (auto& c : vec) cin >> c;


	ll l = 1, r = n + 1;

	while (r - l > 1) {
		ll mid = (l + r) / 2;
		ll qr = qs2(mid, vec);

		if (qr == 1) {
			l = mid;
		}
		else {
			r = mid;
		}
	}

	cout << l << endl;
}

int main() {
	//fastInp;

	ll t;
	cin >> t;

	if (t == 1) {
		sol1();
	}
	else {
		sol2();
	}
	

	return 0;
}