#include <map>
#include <cstdio>
#include <vector>
#include <iomanip>
#include <iostream>
#include <algorithm>

using namespace std;

const int K = 17;

int main() {
#ifdef DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#else
  ios::sync_with_stdio(false);
  cin.tie(0);
  cout.tie(0);
#endif

  int type;
  cin >> type;
  vector<int> numbers;
  for (int i = 0; i < (1 << K); ++i) {
    if (__builtin_popcount(i) >= 2)
      numbers.emplace_back(i);
  }
  string s;
  cin >> s;
  int n = s.size();
  if (type == 1) {
    cout << s;
    vector<int> kek(K);
    for (int i = 0; i < n; ++i) {
      for (int j = 0; j < K; ++j) {
        if (numbers[i] & (1 << j))
          kek[j] ^= (s[i] - '0');
      }
    }
    for (int j = 0; j < K; ++j)
      cout << kek[j];
    return 0;
  }
  n -= K;
  vector<int> kek1(K);
  for (int i = 0; i < n; ++i) {
    for (int j = 0; j < K; ++j) {
      if (numbers[i] & (1 << j))
        kek1[j] ^= (s[i] - '0');
    }
  }
  vector<int> bad;
  for (int j = 0; j < K; ++j) {
    if (kek1[j] != (s[n + j] - '0'))
      bad.emplace_back(j);
  }
  if (bad.size() < 2) {
    for (int i = 0; i < n; ++i)
      cout << s[i];
    return 0;
  }
  int num = 0;
  for (int j : bad)
    num ^= (1 << j);
  int id = 0;
  for (int i = 0; i < numbers.size(); ++i) {
    if (numbers[i] == num) {
      id = i;
      break;
    }
  }
  for (int i = 0; i < n; ++i) {
    if (i == id) {
      cout << 1 + '0' - s[i];
    } else {
      cout << s[i];
    }
  }
  cout << '\n';
  return 0;
}
