#include <iostream>
#include <vector>
#include <iomanip>
#include <map>
#include <set>
using namespace std;

int query(int x) {
	cout << x << "\n";
	cout.flush();
	int ans;
	cin >> ans;
	if (ans == 0) {
		exit(0);
	}
	return ans;
}

void solve() {
	int subway;
	cin >> subway;
	int n;
	cin >> n;
	if (subway == 1) {
		int l = 0, r = n + 1;
		while (l + 1 < r) {
			int x = (l + r) / 2;
			if (query(x) == 1) {
				l = x;
			}
			else {
				r = x;
			}
		}
		//cout << r << "\n";
	}
	else {
		int q;
		cin >> q;
		int l = 0, r = n + 1;
		while (l + 1 < r) {
			int x = (l + r) / 2;
			int ans;
			cin >> ans;
			if (ans == 0) {
				cout << x << "\n";
				return;
			}
			if (ans == 1) {
				l = x;
			}
			else {
				r = x;
			}
		}
		cout << r << "\n";
	}
}

int main() {
	ios_base::sync_with_stdio(0); cin.tie(false); cout.tie(false);
	solve();
}