#include <bits/stdc++.h>

using namespace std;
#define get(x) cout << #x << " : " << (x) << endl
#define forn(i, n) for (int i = 0; i < (n); ++i)
#define fork(s, i, n) for (int i = (s); i < (n); ++i)
#define printl(x) cout << x << '\n'
#define printe(x) cout << x << ' '
#define null(x) memset(x, 0, sizeof(x))
#define sz(x) (int)x.size()
#define nLine() cout << '\n'
#define pii pair<int, int>
#define fi first
#define se second
#define vpii vector<pii>
#define vi vector<int>

void MP() {
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false);
    cin.tie(0);
}

const int MAX = 105;
int a[MAX][MAX];

void solve() {
    int n, m;
    cin >> n >> m;
    string s;
    cin >> s;
    vector<pair<int, char>> a[n];

    forn (i, n) {
        int k;
        cin >> k;
        a[i].resize(k);
        forn (j, k) {
            int x;
            char c;
            cin >> x >> c;
            --x;
            //a[i][x] = s[x] == c;
            a[i][j] = {x, c};
        }
    }

    vi ans;
    bool change = true;
    bool muted[n];
    null(muted);
    while (change) {
        change = false;
        forn (i, n) {
            if (muted[i]) continue;
            bool ok = true;
            for (pii x : a[i]) {
                if (s[x.fi] == '*') continue;
                if (s[x.fi] != x.se) {
                    ok = false;
                    break;
                }
            }
            if (ok) {
                muted[i] = true;
                ans.push_back(i);
                for (pii x : a[i]) {
                    s[x.fi] = '*';
                }
                change = true;
            }
        }
    }
    forn (i, m) {
        if (s[i] != '*') {
            printl(-1);
            return;
        }
    }
    if (sz(ans) != n) {
        printl(-1);
        return;
    }
    for (int i : ans) printe(i + 1);
}

signed main() {
    MP();
    solve();
}