#include <bits/stdc++.h>

using namespace std;
#define get(x) cout << #x << " : " << (x) << endl
#define forn(i, n) for (int i = 0; i < (n); ++i)
#define fork(s, i, n) for (int i = (s); i < (n); ++i)
#define printl(x) cout << x << '\n'
#define printe(x) cout << x << ' '
#define null(x) memset(x, 0, sizeof(x))
#define sz(x) (int)x.size()
#define nLine() cout << '\n'
#define pii pair<int, int>
#define fi first
#define se second
#define vpii vector<pii>
#define vi vector<int>

void MP() {
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false);
    cin.tie(0);
}

void solve() {
    int n, m;
    cin >> n >> m;
    string s;
    cin >> s;
    vector<pair<int, char>> a[n];
    forn (i, n) {
        int k;
        cin >> k;
        a[i].resize(k);
        forn (j, k) {
            int x;
            char c;
            cin >> x >> c;
            --x;
            a[i][j] = {x, c};
        }
    }
    int p[n];
    iota(p, p + n, 0);
    sort(p, p + n, [&](int l1, int r1) {
        vector<pair<int, char>> l = a[l1];
        vector<pair<int, char>> r = a[r1];
        int id1 = 0, id2 = 0;
        while (true) {
            if (id1 == sz(l)) return true;
            if (id2 == sz(r)) return false;
            if (l[id1].fi == r[id2].fi) {
                if (l[id1].se == s[l[id1].fi] && r[id2].se != s[l[id1].fi]) return true;
                if (l[id1].se != s[l[id1].fi] && r[id2].se == s[l[id1].fi]) return false;
            }
            if (l[id1].fi < r[id2].fi) ++id1;
            else ++id2;
        }
    });

    for (int i : p) {
        for (pair<int, char> x : a[i]) {
            if (s[x.fi] == '*') continue;
            if (s[x.fi] != x.se) {
                printl(-1);
                return;
            }
            s[x.fi] = '*';
        }
    }
    forn (i, m) {
        if (s[i] != '*') {
            printl(-1);
            return;
        }
    }
    for (int i : p) printe(i + 1);
}

signed main() {
    MP();
    solve();
}