#include <bits/stdc++.h>
 
using namespace std;
 
typedef long long ll;

struct num {
    static const int MA = 1e9 + 7, MB = 1e9 + 9;
    int a, b;
    num(int a, int b) : a(a), b(b) {}
    num() : a(0), b(0) {}
    num(int a) : a(a), b(a) {}
    num operator +(const num &other) const {
        return num((a + other.a) % MA, (b + other.b) % MB);
    }
    num operator -(const num &other) const {
        return num((a - other.a + MA) % MA, (b - other.b + MB) % MB);
    }
    num operator *(const num &other) const {
        return num((ll)a * other.a % MA, (ll)b * other.b % MB);
    }
    bool operator ==(const num &other) const {
        return a == other.a && b == other.b;
    }
};

const num P = 237;
 
int main() {
    ios_base::sync_with_stdio(false); cin.tie(0);
    #ifdef LOCAL
    freopen("input.txt", "r", stdin);
    #endif
    int k, n;
    cin >> k >> n;
    vector <vector <int>> a(k, vector <int> (k));
    for (int i = 0; i < k; ++i) {
        for (int j = 0; j < k; ++j) {
            char c;
            cin >> c;
            a[i][j] = c - '0';
        }
    }
    auto rev = [&] (string a) {
        reverse(a.begin(), a.end());
        return a;
    };
    string s;
    cin >> s;
    for (auto &c : s) c -= 'a';
    string st;
    set <int> who;
    vector <num> h;
    h.push_back(0);
    vector <num> deg(n + 1);
    deg[0] = 1;
    for (int i = 1; i <= n; ++i) deg[i] = deg[i - 1] * P;
    auto get_h = [&] (int j, int len) {
        return h[j + 1] - h[j - len] * deg[len];
    };
    for (int i = n - 1; i >= 0; --i) {
        while (!who.empty()) {
            int j = *who.rbegin();
            if (a[s[i]][st[j]]) {
                who.erase(--who.end());
                int l = 0, r = j + 1;
                while (r - l > 1) {
                    int m = (l + r) >> 1;
                    if (get_h(j - 1, m) == get_h((int)st.size() - 1, m)) l = m;
                    else r = m;
                }
                int ok = 0;
                if (l == j) {
                    ok = 1;
                } else if (st[j - 1 - l] < st[(int)st.size() - 1 - l]) {
                    ok = 1;
                }
                if (ok) {
                    while ((int)st.size() > j) {
                        st.pop_back();
                        h.pop_back();
                    }
                }
            } else {
                break;
            }
        }
        st += s[i];
        h.push_back(h.back() * P + s[i] + 1);
        who.insert((int)st.size() - 1);
    }
    reverse(st.begin(), st.end());
    for (auto &c : st) c += 'a';
    cout << st << '\n';
}