#include <iostream>
#include <string>
#include <algorithm>
#include <vector>
#include <set>
#include <cassert>
using namespace std;
#define pb push_back
#define cap(x) (int)x.size()
string dp[2020];
int f[1 << 21];
int A[100][100];
bool ls(string s, string t) {
	for (int i = 0; i < min(cap(s), cap(t)); i++) {
		if (s[i] < t[i])
			return true;
		else if (s[i] > t[i])
			return false;
	}
	return cap(s) < cap(t);
}
void cmn(string& s, string t) {
	if (ls(t, s)) s = t;
}
bool can_er(string s) {
	assert(cap(s));
	int n = cap(s);
	vector<int> used(n);
	int cnt = 0;
	while (true) {
		bool ok = false;
		for (int i = n - 1; i >= 1; i--) if (!used[i]) {
			int x;
			for (int j = i - 1; j >= 0; j--) if (!used[j]) {
				x = s[j] - 'a';
				break;
			}
			int y = s[i] - 'a';
			if (A[x][y]) {
				used[i] = 1;
				ok = true;
				break;
			}
		}
		if (!ok) break;
		cnt++;
	}
	return cnt == n - 1;
}
int main() {
	ios::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);
	int k, n;
	string s;
	cin >> k >> n;
	for (int i = 0; i < k; i++)
		for (int j = 0; j < k; j++) {
			char c;
			cin >> c;
			A[i][j] = c - '0';
		}
	cin >> s;
	dp[0] = s[0];
	for (int msk = 1; msk < (1 << n); msk++) {
		int cnt = 0;
		for (int j = 0; j < n; j++) if (msk & (1 << j)) {
			cnt++;
		}
		if (cnt == 1) {
			f[msk] = 1;
			continue;
		}
		for (int j = 0; j < n; j++) if (msk & (1 << j)) {
			int prev = -1;
			for (int i = j - 1; i >= 0; i--) if (msk & (1 << i)) {
				prev = i;
				break;
			}
			if (prev == -1) continue;
			int x = s[prev] - 'a';
			int y = s[j] - 'a';
			if (A[x][y]) {
				f[msk] |= f[msk ^ (1 << j)];
			}
		}
	}
	f[0] = 1;
	string ans = s;
	for (int msk = 1; msk < (1 << n); msk++) {
		if (msk & 1 ^ 1) continue;
		int cur = 0;
		int ok = 1;
		for (int j = 0; j < n; j++) {
			if (msk & (1 << j)) {
				ok &= f[cur];
				cur = 0;
			}
			cur |= (1 << j);
		}
		ok &= f[cur];
		if (ok) {
			string p;
			for (int i = 0; i < n; i++) if (msk & (1 << i))
				p.pb(s[i]);
			cmn(ans, p);
		}
	}
	cout << ans;
	return 0;
}
/*
3 7
010
001
100
abacaba
*/