#include <iostream>
#include <string>
#include <algorithm>
#include <vector>
#include <set>
#include <cassert>
#include <chrono>
#include <ctime>
#include <random>
using namespace std;
#define pb push_back
#define cap(x) (int)x.size()
const int N = 2020;
string dp[N];
int A[100][100];
int f[N];
mt19937 rnd(time(0));
bool ls(string s, string t) {
	for (int i = 0; i < min(cap(s), cap(t)); i++) {
		if (s[i] < t[i])
			return true;
		else if (s[i] > t[i])
			return false;
	}
	return cap(s) < cap(t);
}
void cmn(string& s, string t) {
	if (s.empty() || ls(t, s)) s = t;
}
bool can_er(string s) {
	assert(cap(s));
	int n = cap(s);
	vector<int> used(n);
	int cnt = 0;
	while (true) {
		bool ok = false;
		for (int i = n - 1; i >= 1; i--) if (!used[i]) {
			int x;
			for (int j = i - 1; j >= 0; j--) if (!used[j]) {
				x = s[j] - 'a';
				break;
			}
			int y = s[i] - 'a';
			if (A[x][y]) {
				used[i] = 1;
				ok = true;
				break;
			}
		}
		if (!ok) break;
		cnt++;
	}
	return cnt == n - 1;
}
int k, n;
string s;
string solve1() {
	for (int i = n - 1; i >= 0; i--) {
		cmn(dp[i], s[i] + dp[i + 1]);
		int j = f[i];
		while (j != -1) {
			cmn(dp[j], s[j] + dp[i + 1]);
			j = f[j];
		}
	}
	return dp[0];
}
int main() {
	ios::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);
	cin >> k >> n;
	for (int i = 0; i < k; i++)
		for (int j = 0; j < k; j++) {
			char c;
			cin >> c;
			A[i][j] = c - '0';
		}
	cin >> s;
	memset(f, -1, sizeof f);
	for (int i = 1; i < n; i++) {
		int j = i - 1;
		int y = s[i] - 'a';
		while (j != -1) {
			int x = s[j] - 'a';
			if (A[x][y]) {
				f[i] = j;	
				break;
			}
			j = f[j];
		}
	}
	cout << solve1();
	return 0;
}
/*
3 7
010
001
100
abacaba
*/