#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <queue>

using namespace std;

int main() {
    int n, m; cin >> n >> m;
    string s; cin >> s;
    vector<map<int, char>> p(n);
    vector<int> er(n), ans;
    vector<vector<int>> g(m);
    queue<int> q;

    for (int i = 0; i < n; ++i) {
        int k; cin >> k;
        while (k--) {
            int a; char ch; cin >> a >> ch; --a;
            if (ch != s[a]) ++er[i];
            g[a].push_back(i);
            p[i][a] = ch;
        }
        if (!er[i]) q.push(i);
    }

    while (!q.empty()) {
        int i = q.front(); q.pop();
        ans.push_back(i);
        for (auto [j, c] : p[i]) {
            for (int t : g[j]) {
                if (t == i) continue;
                if (p[t][j] != c) {
                    --er[t];
                    if (!er[t]) q.push(t);
                } 
                p[t].erase(j);
            }
        }
    }

    if (ans.size() < n) {
        cout << -1 << endl;
    } else {
        for (int i : ans) cout << i+1 << ' ';
        cout << endl;
    }
}