#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#define all(a) (a).begin(), (a).end()
#define int long long
typedef long long ll;
using namespace std;

const int INF = 1e18;

int n;
map<int, vector<int>> timing;
vector<int> leaf;
vector<vector<int>> v;
vector<vector<int>> up;

vector<int> st;

bool check_solve(int u) {
    if (v[u].empty()) {
        return 1;
    }
    up[u].clear();
    vector<vector<int>> tmp;
    for (int i : v[u]) {
        if (check_solve(i) == 0) {
            return 0;
        }
        tmp.emplace_back(up[i]);
    }
    sort(all(tmp), [] (vector<int> &a, vector<int> &b) {
         return a[0] < b[0];
    });
    for (int i = 1; i < tmp.size(); ++i) {
        for (int j : tmp[i - 1]) {
            for (int k : tmp[i]) {
                if (j > k) {
                    return 0;
                }
            }
        }
    }
    for (auto i : tmp) {
        for (int j : i) {
            up[u].emplace_back(j);
        }
    }
    return 1;
}

void brut(int x) {
    if (x == leaf.size()) {
        for (int i = 0; i < st.size(); ++i) {
            up[leaf[i]] = {st[i]};
            //cout << st[i] << ' ';
        }
        //cout << endl;
        if (check_solve(0)) {
            cout << "Yes";
            exit(0);
        }
        return;
    }
    for (int i : timing[leaf[x]]) {
        st.emplace_back(i);
        brut(x + 1);
        st.pop_back();
    }
}

signed main() {
#ifdef LOCAL
    freopen("input", "r", stdin);
    freopen("output", "w", stdout);
#else
    ios_base::sync_with_stdio(0);cin.tie(0);
#endif


    cin >> n;
    v.resize(n);
    up.resize(n);
    for (int i = 0; i < n; ++i) {
        int t;
        cin >> t;
        int cnt;
        cin >> cnt;
        if (t == 1) {
            for (int j = 0; j < cnt; ++j) {
                int fr = i, to;
                cin >> to;
                to--;
                v[fr].emplace_back(to);
            }
        } else {
            leaf.emplace_back(i);
            for (int j = 0; j < cnt; ++j) {
                int tmp;
                cin >> tmp;
                timing[i].emplace_back(tmp);
            }
        }
    }

    brut(0);
    cout << "No\n";
    return 0;
}
