#include <iostream>
#include <vector>
#include <set>
#include <tuple>
#include <utility>
#include <algorithm>

using namespace std;

//#pragma GCC optimize("Ofast")
//#pragma GCC target("avx,avx2,sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,mmx,abm")

int main() {
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int k, n;
    cin >> k >> n;
    vector<vector<bool>> can(k, vector<bool>(k));
    for (int i = 0; i < k; i++) {
        string s;
        cin >> s;
        for (int j = 0; j < k; j++) {
            can[j][i] = (s[j] == '1');
        }
    }
    string s;
    cin >> s;
    vector<vector<bool>> canDelete(n, vector<bool>(n, false));
    for (int i = 1; i < n; i++) {
        canDelete[i][i] = can[s[i] - 'a'][s[i - 1] - 'a'];
    }
    for (int len = 2; len < n; len++) {
        for (int l = 1; l + len <= n; l++) {
            int r = l + len - 1;
            for (int j = r - 1; j >= l - 1; j--) {
                if (can[s[r] - 'a'][s[j] - 'a'] && (j == r - 1 || canDelete[j + 1][r - 1]) && (j == l - 1 || canDelete[l][j])) {
                    canDelete[l][r] = true;
                    break;
                }
            }
        }
    }
    vector<string> dp(n, "{");
    vector<int> pr(n, -1);
    dp[0] = s[0];
    string ans = "{";
    for (int i = 1; i < n; i++) {
        for (int j = i - 1; j >= 0; j--) {
            if (j == i - 1 || canDelete[j + 1][i - 1]) {
                if (s[i] <= s[j] && dp[i] > dp[j] + s[i]) {
                    dp[i] = dp[j] + s[i];
                    pr[i] = j;
                }
                else {
                    int l = pr[j];
                    int num = 0;
                    int last = j - 1;
                    for (int h = j - 1; h > pr[j]; h--) {
                        if (s[h] == s[j] && (h == last || canDelete[h + 1][last])) {
                            num++;
                            last = h - 1;
                        }
                    }
                    string new_s = dp[j];
                    for (int h = 0; h < num; h++) {
                        new_s += s[j];
                    }
                    new_s += s[i];
                    if (dp[i] > new_s) {
                        dp[i] = new_s;
                        pr[i] = j;
                    }
                }
            }
        }
        if (i == n - 1 || canDelete[i + 1][n - 1]) {
            ans = min(ans, dp[i]);
        }
    }
    cout << ans;
    for (int i = 0; i < n; i++) {
     //   cout << "\ni == " << i << "\n";
    //    cout << dp[i] << "   " << pr[i];
    }
/*
3 7
010
001
100
abacaba

3 5
010
001
100
bcacb

3 10
010
000
000
aabbbbcccc
*/
    return 0;
}
