#include <bits/stdc++.h>

int main() {
    int n, m;
    std::cin >> n >> m;
    std::string s;
    std::cin >> s;
    bool have[m];
    memset(have, 0, sizeof have);

    std::vector<std::vector<std::pair<int, char>>> cards(n);
    for(auto &i : cards) {
        int sz;
        std::cin >> sz;
        i.resize(sz);
        for(auto &j : i) std::cin >> j.first >> j.second, --j.first;
    }

    std::vector<int> order;
    for(int i = 0; i < n; i++) {

        std::pair<int, std::vector<int>> best;
        for(int pos = 0; pos <= order.size(); pos++) {
            std::vector<int> order1 = order;
            order1.insert(order1.begin() + pos, i);
            char have1[m];
            memset(have1, 0, sizeof have1);
            for(auto &j : order1) {
                for(auto &[p, e] : cards[j]) {
                    if(have1[p] == 0) have1[p] = e;
                }
            }

            bool have2[m];
            for(int j = 0; j < m; j++) have2[j] = (have1[j] == s[j]);

            int cntNew = 0;
            bool good = true;
            for(int j = 0; j < m; j++) {
                good &= !(have[j] && !have2[j]);
                cntNew += have2[j] && !have[j];
            }
            if(!good) continue;

            if(cntNew >= best.first) {
                memcpy(have, have2, sizeof have);
                best = std::make_pair(cntNew, order1);
            }
        }
        order = best.second;
        if(order.size() != i + 1) {
            std::cout << -1 << '\n';
            return 0;
        }
    }

    if(*std::min_element(have, have + m) != 1) {
        std::cout << -1 << '\n';
        return 0;
    }

    for(auto &i : order) {
        std::cout << i + 1 << ' ';
    }
    std::cout << '\n';
}
