/*
//#pragma GCC optimize("unroll-loops,avx,avx2,no-stack-protector,Ofast")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4.1,sse4.2")

#include <bits/stdc++.h>

int n;
const int MAXN = 10;
std::vector<int> g[MAXN];

std::vector<std::vector<int>> possible;

bool used[MAXN];
std::vector<int> now;

bool isGood(std::vector<int> &a) {
    for(int i = 1; i < a.size(); i++) if(a[i] > a[i - 1]) return false;
    return true;
}

void makeAll(std::vector<std::vector<int>> &toChoice) {
    if(*std::min_element(used, used + n) == 1) {
        possible.push_back(now);
        return;
    }
    for(int i = 0; i < n; i++) {
        if(used[i]) continue;
        used[i] = true;
        for(auto &j : toChoice[i]) now.push_back(j);
        if(isGood(now)) makeAll(toChoice);
        for(auto &j : toChoice[i]) now.pop_back();
        used[i] = false;
    }
}

std::vector<std::vector<int>> variants[MAXN];

void dfs(int v) {
    if(g[v].size() == 0) return;
    std::vector<std::vector<int>> nowV;
    for(auto &i : g[v]) {
        dfs(i);
//        nowV.push_back(variants[i]);
        for(auto &j : variants[i]) nowV.push_back(j);
    }
    possible.clear();
    makeAll(nowV);
    variants[v] = possible;
}

int main() {
    std::cin >> n;
    for(int i = 0; i < n; i++) {
        int type;
        std::cin >> type;
        int c;
        std::cin >> c;
        if(type == 2) {
            for(int j = 0; j < c; j++) {
                int t;
                std::cin >> t;
                variants[c].push_back({ t });
            }
        }
        else {
            for(int j = 0; j < c; j++) {
                int t;
                std::cin >> t;
                t--;
                g[i].push_back(t);
            }
        }
    }

    dfs(0);
}
*/


#include <bits/stdc++.h>

const int MAXK = 26;
char a[MAXK][MAXK];

std::map<std::string, std::string> mem;
std::string calc(std::string s) {
    std::string ans = s;
    if(mem.count(s)) return mem[s];
    for(int i = 1; i < s.size(); i++) {
        if(a[s[i - 1] - 'a'][s[i] - 'a'] == '1') {
            std::string s1 = s;
            s1.erase(s1.begin() + i);
            ans = std::min(ans, calc(s1));
        }
    }
    return mem[s] = ans;
}

int main() {
    int k, n;
    std::cin >> k >> n;
    for(int i = 0; i < k; i++) for(int j = 0; j < k; j++) std::cin >> a[i][j];

    std::string s;
    std::cin >> s;
    std::cout << calc(s);
}
