#include <bits/stdc++.h>

using namespace std;

vector<vector<bool> > used;

int n, k, m;

void step(int x, int y, bool my = false)
{
    if (my) cout << x + 1 << " " << y + 1 << endl;
    for (int i = x; i < n; ++i)
    for (int j = y; j < n; ++j)
        {
            used[i][j] = true;
        }
}

vector<vector<int> > num;

void calc()
{
    int tmp = 0;
    for (int i = n - 1; i > -1; --i)
    for (int j = n - 1; j > -1; --j)
    {
        num[i][j] = 0;
        if (used[i][j])
        {
            num[i][j] = -1;
            continue;
        }
        num[i][j] = 1;
        if (i < n - 1) num[i][j] += num[i + 1][j];
        if (j < n - 1) num[i][j] += num[i][j + 1];
        if (i < n - 1 && j < n - 1) num[i][j] -= num[i + 1][j + 1];
    }
    vector<pair<int, pair<int, int> > > all;
    for (int i = 0; i < n; ++i)
    for (int j = 0; j < n; ++j)
        all.push_back({num[i][j], make_pair(i, j)});
    sort(all.begin(), all.end());
    for (int i = 0; i < all.size(); ++i)
        num[all[i].second.first][all[i].second.second] = i;
}

pair<int, int> find(int nm)
{
    if (nm == -1) return {-1, -1};
    for (int i = n - 1; i > -1; --i)
    for (int j = n - 1; j > -1; --j)
        if (num[i][j] == nm)
            return {i, j};
}

string s;

int to(int cnt)
{
    if (s.size() < cnt)
    {
        return -1;
    }
    int res = 0;
    for (int i = 0; i < cnt; ++i)
    {
        res = res * 2 + s.back() - '0';
        s.pop_back();
    }
    return res;
}

string bck(int res, int cnt)
{
    string ans = "";
    for (int i = 0; i < cnt; ++i)
    {
        ans += (char)('0' + res % 2);
        res /= 2;
    }
    reverse(ans.begin(), ans.end());
    return ans;
}

int WOW = 5;

int main()
{
    //freopen("\\\\.\\pipe\\game.in", "r", stdin);
    //freopen("\\\\.\\pipe\\game.out", "w", stdout);
    int t;
    cin >> t;
    cin >> n >> k >> m;
    if (t == 1)
    {
        cin >> s;
        bool myturn = true;
        int played = 0;
        used.assign(n, vector<bool> (n, false));
        num.resize(n, vector<int> (n));
        while (true)
        {
            if (myturn)
            {
                calc();
                if (s.size() == 0)
                {
                    cout << "1 1" << endl;
                    cout << 0 << endl;
                    return 0;
                }
                if (num[0][0] < (1 << WOW))
                {
                    step(0, 0, true);
                    used.assign(n, vector<bool> (n, false));
                    ++played;
                    if (played % 2 == 1) myturn = false;
                    else myturn = true;
                    continue;
                }
                int qq = to(WOW);
                pair<int, int> wow = find(qq);
                if (wow.first == -1)
                {
                    step(0, 0, true);
                    return 0;
                }
                step(wow.first, wow.second, true);
                myturn = false;
            }
            else
            {
                int x, y;
                cin >> x >> y;
                --x;
                --y;
                step(x, y);
                if (x == 0 && y == 0)
                {
                    used.assign(n, vector<bool> (n, false));
                    ++played;
                    if (played % 2 == 1) myturn = false;
                    else myturn = true;
                    continue;
                }
                myturn = true;
            }
        }
    }
    else
    {
        int cnt;
        cin >> cnt;
        used.assign(n, vector<bool> (n, false));
        num.resize(n, vector<int> (n));
        bool myturn = true;
        int played = 0;
        string m;
        while (played < cnt)
        {
            int x, y;
            cin >> x >> y;
            --x;
            --y;
            if (x == 0 && y == 0)
            {
                used.assign(n, vector<bool> (n, false));
                ++played;
                if (played % 2 == 1) myturn = false;
                else myturn = true;
                continue;
            }
            if (myturn)
            {
                calc();
                int tmp = num[x][y];
                m += bck(tmp, WOW);
                myturn = false;
            }
            else myturn = true;
            step(x, y);
        }
        reverse(m.begin(), m.end());
        cout << m << endl;
    }
}
