#include <iostream>
#include <string>
#include <vector>
#include <set>

using namespace std;

#define x first
#define y second
#define int long long
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.end()

int32_t main() {
	cin.tie(NULL);
	cout.tie(NULL);
	ios::sync_with_stdio(false);

	int n, m;
	cin >> n >> m;
	vector<vector<int>> good(n);
	vector<int> bad(n);
	vector<vector<pair<char, int>>> a(m);

	string s;
	cin >> s;

	for (int i{}; i < n; ++i) {
		int k;
		cin >> k;
		for (int j{}; j < k; ++j) {
			int ind;
			char c;
			cin >> ind >> c;
			ind--;
			a[ind].push_back({ c, i });
			if (s[ind] != c) {
				bad[i]++;
			}
			else {
				good[i].push_back(ind);
			}
		}
	}

	vector<int> ans;

	set<pair<int, int>> st;
	for (int i{}; i < n; ++i) {
		st.insert({ bad[i], i });
	}

	vector<char> used(n, false);

	while (!st.empty()) {
		auto x = *st.begin();
		if (x.x != 0) {
			cout << -1;
			return 0;
		}
		st.erase(st.begin());
		ans.push_back(x.y);
		used[x.y] = true;
		for (auto i : good[x.y]) {
			for (auto j : a[i]) {
				if (used[j.y]) continue;
				if (j.x != s[i]) {
					st.erase({ bad[j.y], j.y });
					bad[j.y]--;
					st.insert({ bad[j.y], j.y });
				}
			}
			a[i].clear();
		}
	}


	for (auto i : ans) {
		cout << i + 1 << " ";
	}


	return 0;
}


//3 4
//glhf
//3 1 r 3 h 4 i
//3 1 r 2 l 3 o
//2 1 g 4 f