#include <bits/extc++.h>

using namespace std;

typedef long long ll;
typedef double dl;

#define nl '\n'
#define all(a) (a).begin(), (a).end()
#define minq(a, b) (a) = min(a, b)
#define maxq(a, b) (a) = max(a, b)
#define sz(a) (int((a).size()))
#define forn(i, n) for (int i = 0; i < (n); i++)

void IO() {
#ifdef SEVA
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#else
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
#endif
}

const int N = (int) 1e5 + 10;

bool used[N];
bool need[N];

void Solve() {
    int n, m;
    cin >> n >> m;
    string s;
    cin >> s;
    vector<map<int, char>> cards(n);
    for (auto &mp : cards) {
        int k;
        cin >> k;
        forn(i, k) {
            int a;
            char c;
            cin >> a >> c;
            a--;
            mp[a] = c;
        }
    }
    fill(need, need + m, true);
    vector<int> ans;
    while (true) {
        bool action = false;
        forn(i, n) {
            if (used[i])
                continue;
            bool ok = true;
            for (auto&[pos, val] : cards[i]) {
                ok &= !need[pos] || s[pos] == val;
            }
            if (!ok)
                continue;
            action = true;
            ans.emplace_back(i);
            used[i] = true;
            for (auto& [pos, val] : cards[i]) {
                need[pos] = false;
            }
        }
        if (!action)
            break;
    }
    if (sz(ans) != n || count(need, need + n, true)) {
        cout << -1 << nl;
    }
    else {
        for (auto& i : ans) {
            cout << i + 1 << ' ';
        }
    }
}

signed main() {
    IO();
    Solve();
    return 0;
}