#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;

#define int ll
#define f first
#define s second
#define vi vector<int>
#define pii pair<int, int>
#define pb push_back
using namespace std;

const int maxn = 2e5 + 50;
vi r[maxn];
vi top;
int used[maxn];
void dfs(int v) {
    used[v] = 1;
    for (auto &u : r[v]) {
        if (!used[u]) {
            dfs(u);
        }
    }
    top.pb(v);

}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<pair<int, char>> a[n];
    string s;
    cin >> s;
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        for (int j = 0; j < k; ++j) {
            int p;
            char c;
            cin >> p >> c;
            p--;
            a[i].pb({p, c});
        }
    }
    for (int i = 0; i < n; ++i) {
        for (auto &[p, c] : a[i]) {
            if (s[p] == c) {
                r[i].pb(n + p);
            } else {
                r[n + p].pb(i);
            }
        }
    }
    for (int i = 0; i < n + m; ++i) {
        if (!used[i]) {
            dfs(i);
        }
    }
    reverse(top.begin(), top.end());
    set<int> st;
    for (int i = 0; i < m; ++i)
        st.insert(i);
    for (int i = 0; i < n + m; ++i) {
        if (top[i] >= n)
            continue;
        for (auto &[p, c] : a[top[i]]) {
            if (st.count(p)) {
                if (c == s[p]) {
                    st.erase(p);
                } else {
                    cout << -1 << '\n';
                    exit(0);
                }
            }
        }
    }
    if (st.size()) {
        cout << -1 << '\n';
        exit(0);
    }
    for (auto &i : top) {
        if (i < n)
            cout << i + 1 << ' ';
    }
    cout << '\n';
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    while (t--)
        solve();
    return 0;
}
