#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second
#define mp make_pair
#define pb push_back
#define all(a) (a).begin(), (a).end()
using ll = long long;
using ull = unsigned long long;
using pii = pair<int, int>;
using pil = pair<int, ll>;
using pli = pair<ll, int>;
using pll = pair<ll, ll>;
using ld = long double;
template<typename T1, typename T2> bool chkmin(T1 &x, T2 y)
{
    return y < x ? (x = y, true) : false;
}
template<typename T1, typename T2> bool chkmax(T1 &x, T2 y)
{
    return y > x ? (x = y, true) : false;
}
void debug_out()
{
    cerr << endl;
}
template<typename T1, typename... T2> void debug_out(T1 A, T2... B)
{
    cerr << ' ' << A;
    debug_out(B...);
}
template<typename T> void mdebug_out(T* a, int n)
{
    for (int i = 0; i < n; ++i)
        cerr << a[i] << ' ';
    cerr << endl;
}
#ifdef DEBUG
    #define debug(...) cerr << "[" << #__VA_ARGS__ << "]:", debug_out(__VA_ARGS__)
    #define mdebug(a, n) cerr << #a << ": ", mdebug_out(a, n)
#else
    #define debug(...) 1337
    #define mdebug(a, n) 1337
#endif
template<typename T> ostream& operator << (ostream& stream, const vector<T> &a)
{
    for (auto& x : a)
        stream << x << ' ';
    return stream;
}
template<typename T1, typename T2> ostream& operator << (ostream& stream, const pair<T1, T2>& p)
{
    return stream << p.first << ' ' << p.second;
}

mt19937 rng(228);
int n, k, m;
int a[32][32];

void initGrid()
{
    memset(a, 0, sizeof a);
}

vector<int> getMsg()
{
    #ifdef DEBUG
        vector<int> a(m);
        for (auto& x : a)
            x = rng() % 2;
        return a;
    #else
        string s;
        cin >> s;
        vector<int> a(m);
        for (int i = 0; i < m; ++i)
            a[i] = s[i] - '0';
        return a;
    #endif
}

struct pt
{
    int x, y;
    pt(int _x = 0, int _y = 0): x(_x), y(_y) {}

    bool operator == (const pt& oth) const { return x == oth.x && y == oth.y; }
    bool operator != (const pt& oth) const { return x != oth.x || y != oth.y; }
};
vector<pt> moves;

void paint(int xx, int yy)
{
    return;
    for (int x = xx; x < n; ++x)
        for (int y = yy; y < n; ++y)
            a[x][y] = 1;
}
int wouldPaint(int xx, int yy)
{
    int cnt = 0;
    for (int x = xx; x < n; ++x)
        for (int y = yy; y < n; ++y)
            if (!a[x][y])
                ++cnt;
    return cnt;
}

pt getBot()
{
    #ifdef DEBUG
        vector<pt> cand;
        for (int x = 0; x < n; ++x)
            for (int y = 0; y < n; ++y)
                if (!a[x][y])
                {
                    int d = wouldPaint(x, y);
                    if (1 <= d && d <= k)
                    {
                        cand.push_back(pt(x, y));
                    }
                }
        int i = rng() % cand.size();
        pt A = cand[i];
        paint(A.x, A.y);
        moves.push_back(A);//cout << A.x + 1 << ' ' << A.y + 1 << endl;
        return A;
    #else
        pt A;
        cin >> A.x >> A.y;
        --A.x;
        --A.y;
        paint(A.x, A.y);
        return A;
    #endif
}

void makeMove(int x, int y)
{
//    assert(a[x][y] == 0);
    paint(x, y);
    #ifdef DEBUG
        moves.push_back(pt(x, y));
    #else
        cout << x + 1 << ' ' << y + 1 << endl;
    #endif
}
void makeMove(pt A)
{
    makeMove(A.x, A.y);
}

pt findOne()
{
    for (int x = 0; x < n; ++x)
        for (int y = 0; y < n; ++y)
            if (!a[x][y] && wouldPaint(x, y) == 1)
                return pt(x, y);
    assert(false);
}

pt readPoint()
{
    pt A;
    cin >> A.x >> A.y;
    --A.x;
    --A.y;
    return A;
}

pair<int, vector<pt>> task1()
{
    #ifdef DEBUG
        freopen("out", "w", stdout);
    #endif
    auto s = getMsg();
    int fst = 0;

    int games = 0;
    moves.clear();
    for (int i = 0; i < m; ++i)
    {
        //initGrid();
        if (fst == 1)
            getBot();
        if (s[i] == 0)
        {
            makeMove(0, 0);
        }
        else
        {
//                pt A = findOne();
            pt A = pt(1, 1);
            makeMove(A);
            getBot();
            makeMove(0, 0);
        }
        fst ^= 1;
        ++games;
    }
    #ifdef DEBUG
        return mp(games, vector<pt>(all(moves)));
    #else
        cout << "0" << endl;
        exit(0);
    #endif
}

signed main()
{
    int task;
    cin >> task;
    #ifdef DEBUG
        n = 32;
        k = 8;
        m = 100000;
    #else
        cin >> n >> k >> m;
    #endif
    if (task == 1)
    {
        task1();
    }
    else
    {
        #ifdef DEBUG
            freopen("in", "r", stdin);
        #endif
        int games;
        cin >> games;
        int fst = 0;
        string ans = "";
        for (int i = 0; i < games; ++i)
        {
            if (fst)
            {
                readPoint();
            }
            pt A = readPoint();
            int c = 0;
            while (A != pt(0, 0))
            {
                A = readPoint();
                A = readPoint();
                ++c;
            }
            ans += (char)('0' + c);

            fst ^= 1;
        }
        cout << ans << endl;
    }
    
    return 0;
}