#include <bits/stdc++.h>

using namespace std;
template<class T1, class T2> inline bool chkmin(T1& x, const T2& y) {
	if (x > y) {
		x = y;
		return true;
	}
	return false;
}
template<class T1, class T2> inline bool chkmax(T1& x, const T2& y) {
	if (x < y) {
		x = y;
		return true;
	}
	return false;
}
#define rall(c) (c).rbegin(), (c).rend()
#define all(c) (c).begin(), (c).end()
#define sz(c) (int)(c).size()
#define mp make_pair
#define pb push_back
using ll = long long;
using ld = long double;


int n, k, m;
int g[33][33];
int score[40][40];

const int BLOCK = 60;


int getScore(int x, int y) {
	return g[x][y];
}

void init() {
	for (int i = 1; i <= 32; i++) {
		for (int j = 1; j<= 32; j++) {
			g[i][j] = (i - 1) * 32 + (j - 1);
		}
	}
} 


namespace encode {
	string s;	
	int uk = 0;
	bool f[33][33];
	int lyambda[33][33];

	int sum[33][33];

	map<vector<pair<int, int> >, bool> kek;
	map<vector<pair<int, int> >, pair<int, int> > moved;

	bool win(vector<pair<int, int> > a) {
		if (sz(a) <= 1) {
			return false;
		}
		if (kek.find(a) != kek.end()) {
			return kek[a];
		}
		kek[a] = false;
		for (int i = 0; i < sz(a); i++) {
			if (a[i].first == 1 && a[i].second == 1) {
				continue;
			}
			vector<pair<int, int> > na;
			for (int j = 0; j < sz(a); j++) {
				if (a[j].first >= a[i].first && a[j].second >= a[i].second) {
					continue;
				}
				na.pb(a[j]);
			}
			if (!win(na)) {
				kek[a]= true;
				moved[a] = a[i];
				return true;
			}
		}
		return false;
	}

	bool solve() {
		vector<pair<int, int> > gt;
		for (int i = 1; i <= n; i++) {
			for (int j = 1; j <= n; j++) {
				if (!f[i][j]) {
					gt.pb(mp(i, j));
				}
			}
		}
		if (win(gt)) {
			auto ff = moved[gt];
			cout << ff.first << ' ' << ff.second << endl;
			{
				for (int i = ff.first; i <= n; i++) {
					for (int j = ff.second; j <= n; j++) {
						f[i][j] = true;
					}
				}
			}
			int mi, mj;
			cin >> mi >> mj;
			for (int i = mi; i <= n; i++) {
				for (int j = mj; j <= n; j++) {
					f[i][j] = true;
				}
			}
			if (mi == 1 && mj == 1) {
				return true;
			}
			assert(solve());
			return true;
		}
		return false;
	}

	void play(int start, bool win) {
		if (start) {
			int mi, mj;
			cin >> mi >> mj;
			for (int i = mi; i <= n; i++) {
				for (int j = mj; j <= n; j++) {
					f[i][j] = 1;
				}
			}
		}
		if (!win) {
			cout << 0 << endl;
			return;
		}
		int opt = 1e9;
		int pi = 1;
		int pj = 1;
		int cnt = 0;
		bool was = false;
		while (true) {
			int cnte = 0;
			int cnte1 = 0;
			for (int i = n; i >= 1; i--) {
				if (!f[i][1]) {
					cnte++;
				}
				if (!f[1][i]) {
					cnte1++;
				}
			}
			if (max(cnte, cnte1) < 9) {
				if (cnte > cnte1) {
					cout << 1 << ' ' << 2 << endl;
					int mi, mj;
					cin >> mi >> mj;
					cout << 2 << ' ' << 1 << endl;
					cin >> mi >> mj;
					assert(mi == 1 && mj == 1);
				} else {
					cout << 2 << ' ' << 1 << endl;
					int mi, mj;
					cin >> mi >> mj;
					cout << 1 << ' ' << 2 << endl;
					cin >> mi >> mj;
					assert(mi == 1 && mj == 1);
				}
				return;			
			}
			int val = (uk < m ? s[uk] - '0': 0) + 2 * (uk + 1 < m ? s[uk + 1] - '0': 0) + 4 * (uk + 2 < m ? s[uk + 2] - '0': 0) + 8 * (uk + 3 < m ? s[uk + 3] - '0': 0);
			int rem = val % 16;
			opt = 1e9;
			pi = 1;
			pj = 1;
			for (int i = n; i >= 1; i--) {
				for (int j = n; j >= 1; j--) {
					if (!f[i][j]) {
						sum[i][j] = 1;
					} else {
						sum[i][j] = 0;
					}
					sum[i][j] += sum[i + 1][j] + sum[i][j + 1] - sum[i + 1][j + 1];
					if (!f[i][j] && getScore(i, j) % 16 == rem) {
						if (min(i, j) == 1 && max(i, j) <= 15) {
							continue;
						}
						if (opt > sum[i][j]) {
							opt =  sum[i][j];
							pi = i;
							pj = j;
						}
					}
				}
			}

			if (pi == 1 && pj == 1) {
				if (cnte > cnte1) {
					cout << 1 << ' ' << 2 << endl;
					int mi, mj;
					cin >> mi >> mj;
					cout << 2 << ' ' << 1 << endl;
					cin >> mi >> mj;
					assert(mi == 1 && mj == 1);
				} else {
					cout << 2 << ' ' << 1 << endl;
					int mi, mj;
					cin >> mi >> mj;
					cout << 1 << ' ' << 2 << endl;
					cin >> mi >> mj;
					assert(mi == 1 && mj == 1);
				}
				return;
			}
			cout << pi << ' ' << pj << endl;
			cnt += 4;
			uk += 4;
			{
				for (int i = pi; i <= n; i++) {
					for (int j = pj; j <= n; j++) {
						f[i][j] = 1;
					}
				}
			}
			{
				int mi, mj;
				cin >> mi >> mj;
				{
					for (int i = mi; i <= n; i++) {
						for (int j = mj; j <= n; j++) {
							f[i][j] = 1;
						}
					}
				}
				if (mi == 1 && mj == 1) {
					return;
				}
			}
		}
	}

	void encoder() {
		cin >> n >> k >> m;
		cin >> s;
		int d = 0;
		uk = 0;
		for (int i =1; i <= n; i++) {
			for (int j = 1; j <= n; j++) {
				lyambda[i][j] = (n - i) * (n - j) * max(n - i, n - j);
			}
		}
		while (uk < m) {
			memset(f, 0, sizeof(f));
			play(d & 1, true);
			d++;
		}
		memset(f, 0, sizeof(f));
		play(d & 1, false);
	}

};


namespace decode {

void decoder() {
	cin >> n >> k >> m;
	int cnt;
	cin >> cnt;
	vector<vector<pair<int, int> > > moves;
	for (int it = 0; it < cnt; it++) {
		vector<pair<int, int> > cur;
		int a, b;
		int id = it & 1;
		bool fek[200][200];
		memset(fek, 0, sizeof(fek));
		while (cin >> a >> b) {
			
			if (a == 1 && b == 1) {
				break;
			}
			if (id == 0) {
				if (min(a, b) >= 2 || max(a, b) > 2) {
					cur.pb(mp(a, b));
				}
			}
			for (int i = a; i <= n; i++) {
				for (int j = b; j <= n; j++) {
					fek[i][j] = true;
				}
			}
			id ^= 1;
			
		}
		moves.pb(cur);
	}
	string ans;
	for (auto x: moves) {

		for (int f = 0; f < sz(x); f++) {
			int k1 = getScore(x[f].first, x[f].second);
			int t =	k1 % 16;
			ans += char('0' + (t & 1));
			ans += char('0' + ((t >> 1) & 1));
			ans += char('0' + ((t >> 2) & 1));
			ans += char('0' + ((t >> 3) & 1));
		}
	}
	ans.resize(m);
	cout << ans << endl;
}

};

int main() {
	ios_base::sync_with_stdio(false);
//	freopen("/tmp/game.in", "r", stdin); 
	//freopen("/tmp/game.out", "w", stdout);
	//freopen("input.in", "r", stdin);
	init();
	int t;
	cin >> t;
	if (t == 1) {
		encode::encoder();
	} else {
		decode::decoder();
	}
	return 0;
}
