#include <bits/stdc++.h>

using namespace std;
#define int long long
#define fastio ios_base::sync_with_stdio(0); cin.tie(0);

bool cmp(string l, string r) {
    for (int i = 0; i < min(l.size(), r.size()); ++i) {
        if (l[l.size() - 1 - i] != r[r.size() - 1 - i]) {
            return l[l.size() - 1 - i] < r[r.size() - 1 - i];
        }
    }
    return l.size() < r.size();
}

signed main() {
    fastio
    int k, n;
    cin >> k >> n;
    vector<string> a(k);
    for (int i = 0; i < k; ++i) {
        cin >> a[i];
    }
    string s;
    cin >> s;
    vector<vector<bool>> can1(n, vector<bool>(n, false));
    for (int i = 0; i < n; ++i) {
        can1[i][i] = true;
    }
    for (int l = 0; l < n; ++l) {
        stack<int> b;
        b.push(l);
        for (int r = l + 1; r < n; ++r) {
            while (b.size() >= 1 && a[s[b.top()] - 'a'][s[r] - 'a'] == '0') {
                b.pop();
            }
            if (b.empty()) {
                break;
            }
            can1[l][r] = true;
            b.push(r);
        }
    }
    vector<string> dp(n + 1);
    dp[n] = "";
    for (int i = n - 1; i >= 0; --i) {
        dp[i] = dp[i + 1];
        for (int j = i + 1; j < n; ++j) {
            if (can1[i][j]) {
                if (cmp(dp[j + 1], dp[i])) {
                    dp[i] = dp[j + 1];
                }
            } else break;
        }
        dp[i] += s[i];
    }
    cout << dp[0];
}