#include <bits/stdc++.h>

using namespace std;

#define int long long

const int MAXN = 1e5 + 10;

int32_t main() {
    int n, m;
    cin >> n >> m;

    string s;
    cin >> s;

    vector<int> ans, wr_ind;
    bitset<MAXN> used;
    vector<bitset<MAXN>> wrong, setting;
    vector<bool> used_s(n);
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;

        bitset<MAXN> wr, set;

        bool ok = true;
        for (int j = 0; j < k; j++) {
            int pos;
            char c;
            cin >> pos >> c;

            pos--;

            if (s[pos] != c && !used[pos]) {
                ok = false;
                wr.set(pos);
            }

            set.set(pos);
        }

        if (ok) {
            ans.push_back(i);
            used_s[i] = true;
            used |= set;
        } else {
            wr_ind.push_back(i);
            wrong.push_back(wr);
            setting.push_back(set);
        }
    }


    for (int t = 0; t < n; t++) {
        int sel = -1;
        for (int i = 0; i < wrong.size(); i++) {
            if (used_s[wr_ind[i]] || ((wrong[i] ^ used) & wrong[i]).count()) {
                continue;
            }

            sel = i;
            break;
        }

        if (sel == -1) {
            break;
        }

        ans.push_back(sel);
        used_s[wr_ind[sel]] = true;
        used |= setting[sel];
    }

    if (used.count() != m) {
        cout << -1;
        exit(0);
    }

    for (int i : ans) {
        cout << (i + 1) << " ";
    }

    return 0;
}