#include <bits/stdc++.h>
using namespace std;

#define fi first
#define se second
#define all(x) x.begin(), x.end()
#define int long long

vector<vector<int> > g;
vector<int> leaf;
vector<vector<int> > add;
vector<pair<int, int> > nw;

vector<vector<int> > ans;

pair<int, int> dfs(int v) {
    if (g[v].size() == 0) {
        ans[v].resize(1);
        ans[v][0] = nw[v].fi - 1;
        return nw[v];
    }
    vector<pair<pair<int, int>, int> > cur;
    for (auto to : g[v]) {
        cur.push_back({dfs(to), to});
        if (cur.back().fi.fi == -1 && cur.back().fi.se == -1)
            return {-1, -1};
    }
    sort(all(cur));
    bool ok = true;
    for (int i = 1; i < cur.size(); i++) {
        if (cur[i].fi.fi < cur[i - 1].fi.se) {
            ok = false;
            break;
        }
    }
    ans[v].resize(cur.size());
    for (int i = 0; i < cur.size(); i++) {
        ans[v][i] = cur[i].se;
    }
    if (ok)
        return {cur[0].fi.fi, cur.back().fi.se};
    else
        return {-1, -1};
}

void rec(int id) {
    if (id == leaf.size()) {
        pair<int, int> t = dfs(0);
        if (t.fi == -1 && t.se == -1)
            return;
        cout << "Yes\n";
        for (int i = 0; i < ans.size(); i++) {
            for (int j = 0; j < ans[i].size(); j++) {
                cout << ans[i][j] + 1 << " ";
            }
            cout << '\n';
        }
        exit(0);
    }
    for (int i = 0; i < add[id].size(); i++) {
        nw[leaf[id]] = {add[id][i], add[id][i]};
        rec(id + 1);
    }
}

signed main() {
//    ios_base::sync_with_stdio(0);
//    cin.tie(0);
//    cout.tie(0);
//    freopen("\\\\.\\pipe\\game.in", "r", stdin);
//    freopen("\\\\.\\pipe\\game.out", "w", stdout);

    int n;
    cin >> n;
    g.resize(n);
    nw.resize(n);
    ans.resize(n);
    for (int i = 0; i < n; i++) {
        int t;
        cin >> t;
        if (t == 1) {
            int k;
            cin >> k;
            g[i].resize(k);
            for (int j = 0; j < k; j++) {
                cin >> g[i][j];
                g[i][j]--;
            }
        } else {
            leaf.push_back(i);
            int k;
            cin >> k;
            vector<int> e(k);
            for (int j = 0; j < k; j++) {
                cin >> e[j];
            }
            add.push_back(e);
        }
    }

    rec(0);
    cout << "No\n";

    return 0;
}
/*
6
1 3 5 4 6
2 3 10 61 60
2 2 80 20
2 2 40 70
1 2 3 2
2 4 30 90 91 92
 */