#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <algorithm>
#include <iomanip>
#include <set>
#include <map>

#define sqr(x) ((x) * (x))
#define mp make_pair
#define pb push_back
#define endl '\n'
//#define int ll

#pragma warning (disable : 4996)

using namespace std;

typedef long double ld;
typedef long long ll;
typedef pair<int, int> pii;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<pii> vii;
typedef vector<char> vc;

const ld EPS = 1e-8;
const int N = (int)1e5 + 10;
const int INF = (int)1e9 + 10;
const int MOD = (int)1e9 + 7;

signed main() {
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	int n, m;
	cin >> n >> m;
	string s;
	cin >> s;
	vector<vii> a(m);
	vvi b(n);
	set<pii> q;
	vi p;
	vi cnt(n);
	for (int i = 0; i < n; ++i) {
		int k;
		cin >> k;
		cnt[i] = m;
		for (int j = 0; j < k; ++j) {
			int x;
			char c;
			cin >> x >> c;
			--x;
			int y = 0;
			if (c == s[x])
				y = 1;
			else {
				y = -1;
				--cnt[i];
			}
			a[x].pb({ i, y });
			b[i].pb(x);
		}
		q.insert({ -cnt[i], i });
	}
	vc used(n);
	vc ok(m);
	while (!q.empty()) {
		auto x = *q.begin();
		if (x.first != -m) {
			cout << -1;
			return 0;
		}
		q.erase(q.begin());
		int i = x.second;
		used[i] = 0;
		p.pb(i);
		for (auto t : b[i]) {
			if (!ok[t]) {
				ok[t] = 1;
				for (auto z : a[t]) {
					if (z.second == -1 && !used[z.first]) {
						q.erase({ -cnt[z.first], z.first });
						++cnt[z.first];
						q.insert({ -cnt[z.first], z.first });
					}
				}
			}
		}
	}
	for (int i = 0; i < m; ++i) {
		if (!ok[i]) {
			cout << -1;
			return 0;
		}
	}
	for (int i = 0; i < n; ++i)
		cout << p[i] + 1 << ' ';

	return 0;
}