#include <bits/stdc++.h>

using namespace std;

//#pragma GCC optimize("O3,no-stack-protector,delete-null-pointer-checks")
//#pragma GCC target("avx,sse,sse4.1,sse4.2,mmx,abm,popcnt")

string s;
vector<string> perfs;
vector<int> indices;

bool check() {
	string mask = s;
	for (int i : indices) {
		for (int k = 0; k < (int)perfs[i].size(); ++k) {
			if (perfs[i][k] != '$' && mask[k] != '$') {
				if (perfs[i][k] == mask[k]) {
					mask[k] = '$';
				} else {
					return false;
				}
			}	
		}
	}
	return count(mask.begin(), mask.end(), '$') == mask.size();
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	int n, m;
	cin >> n >> m;
	cin >> s;
	perfs.resize(n);
	for (int i = 0; i < n; ++i) {
		int k;
		cin >> k;
		int pos = 0;
		while (k--) {
			int np;
			cin >> np;
			--np;
			char c;
			cin >> c;
			while (pos < np) {
				perfs[i].push_back('$');
				++pos;
			}
			perfs[i].push_back(c);
			++pos;
		}
		while (pos < m) {
			perfs[i].push_back('$');
			++pos;
		}
		//cout << perfs[i] << '\n';
	}
	indices.resize(n);
	iota(indices.begin(), indices.end(), 0);
	vector<int> first_idxs = indices;
	do {
		if (check()) {
			for (int x : indices) {
				cout << x + 1 << ' ';
			}
			cout << '\n';
			return 0;
		}
		next_permutation(indices.begin(), indices.end());
	} while (indices != first_idxs);
	cout << -1 << '\n';
}
