#include <bits/stdc++.h>

using namespace std;

bool a[26][26];

string lexmin(string a, string b) {
	return min(a, b);
}

signed main() {
	int k, n;
	cin >> k >> n;

	for(int i = 0; i < k; i++) {
		string s;
		cin >> s;
		for(int j = 0; j < k; j++) {
			a[i][j] = s[j] - '0';
		}
	}

	string s;
	cin >> s;

	vector< vector<bool> > dp_can_delete(n, vector<bool>(n));
	for(int i = 0; i < n; i++) {
		dp_can_delete[i][i] = true;
	}
	for(int l = n - 1; l >= 0; l--) {
		string stack;
		stack.push_back(s[l]);
		for(int r = l + 1; r < n; r++) {
			while(stack.size() > 0 && !a[stack.back() - 'a'][s[r] - 'a']) {
				stack.pop_back();
			}
			if(stack.size() == 0) {
				break;
			}
			stack.push_back(s[r]);
			dp_can_delete[l][r] = true;
		}
	}

	vector<string> dp_lexmin(n);
	for(int l = n - 2; l >= 0; l--) {
		dp_lexmin[l] = string(1, s[l + 1]) + dp_lexmin[l + 1];
		for(int m = l + 1; m < n; m++) {
			if(a[s[l] - 'a'][s[m] - 'a'] && dp_can_delete[l][m - 1]) {
				dp_lexmin[l] = lexmin(dp_lexmin[l], dp_lexmin[m]);
			}
		}
	}

	cout << s[0] << dp_lexmin[0] << endl;

	return 0;
}