#ifdef DEBUG
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>

#ifndef DEBUG
#define endl '\n'
#endif

using namespace std;

using ll = long long;

void solve();

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
}

ll n, m;
string s;
vector<vector<char>> p;
vector<bool> used;
vector<vector<ll>> badd, good;

vector<ll> get(set<ll> &pos) {
    if (pos.empty()) {
        return {};
    }
    for (int i = 0; i < n; ++i) {
        if (used[i]) continue;
        bool bad = false;
        for (auto j: badd[i]) {
            if (pos.count(j)) {
                bad = true;
                break;
            }
        }
        if (bad) continue;
        vector<ll> erased;
        for (auto j: good[i]) {
            if (pos.count(j)) {
                pos.erase(j);
                erased.push_back(j);
            }
        }
        used[i] = true;

        auto ans = get(pos);
        for (auto j: erased) {
            pos.insert(j);
        }
        if (!ans.empty() and ans.front() == -1) {
            return {-1};
        }
        ans.push_back(i);
        used[i] = false;

        return ans;
    }
    return {-1};
}

void solve() {
    cin >> n >> m;
    cin >> s;
    p.resize(n);
    used.resize(n, false);
    badd.resize(n);
    good.resize(n);
    for (int i = 0; i < n; ++i) {
        ll k;
        cin >> k;
        p[i].resize(m);
        for (int j = 0; j < k; ++j) {
            ll a;
            char c;
            cin >> a >> c;
            p[i][a - 1] = c;
            if (p[i][a - 1] == s[a - 1]) {
                good[i].push_back(a - 1);
            } else {
                badd[i].push_back(a - 1);
            }
        }
    }
    set<ll> pos;
    for (int i = 0; i < m; ++i) {
        pos.insert(i);
    }
//    auto ans = get(pos);
    vector<ll> ans;
    vector<vector<ll>> erased;
    while (!pos.empty()) {
        for (int i = 0; i <= n; ++i) {
            if (i == n) {
                for (auto j: erased.back()) {
                    pos.insert(j);
                }
                erased.pop_back();
                assert(used[ans.back()]);
                used[ans.back()] = false;
                ans.pop_back();
            }
            if (used[i]) continue;
            bool bad = false;
            for (auto j: badd[i]) {
                if (pos.count(j)) {
                    bad = true;
                    break;
                }
            }
            if (bad) continue;
            erased.emplace_back();
            for (auto j: good[i]) {
                if (pos.count(j)) {
                    pos.erase(j);
                    erased.back().push_back(j);
                }
            }
            used[i] = true;

            ans.push_back(i);
            break;
//            auto ans = get(pos);
//            for (auto j: erased) {
//                pos.insert(j);
//            }
//            if (!ans.empty() and ans.front() == -1) {
//                return {-1};
//            }
//            ans.push_back(i);
//            used[i] = false;
        }
    }

    if (!ans.empty()) {
        set<ll> have(ans.begin(), ans.end());
        for (int i = 0; i < n; ++i) {
            if (!have.count(i)) {
                ans.push_back(i);
                have.insert(i);
            }
        }
        for (auto e: ans) {
            cout << e + 1 << ' ';
        }
        cout << endl;
        return;
    }
    cout << -1 << endl;
}

//1 1
//a
//1 1 a

//3 4
//glhf
//3 1 r 3 h 4 i
//3 1 r 2 l 3 o
//2 1 g 4 f

//2 2
//aa
//2 1 a 2 b
//2 1 b 2 a

// ----

//3 4
//aaaa
//0
//1 2 a
//4 1 a 2 b 4 a 3 a
