#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <stack>
#define int long long

using namespace std;


bool mn(string a, string b)
{
    for (int i(0); i < min((int) b.size(), (int) a.size()); ++i)
    {
        if (a[i] < b[i]) return true;
        if (b[i] < a[i]) return false;
    }
    if (a.size() < b.size()) return true;
    return false;
}


bool mnt(string a, string b)
{
    for (int i(0); i < min((int) b.size(), (int) a.size()); ++i)
    {
        if (a[i] < b[i]) return true;
        if (b[i] < a[i]) return false;
    }
    if (a.size() > b.size()) return true;
    return false;
}


int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int k, n;
    cin >> k >> n;
    vector<vector<bool>> g(k, vector<bool> (k));
    for (int i(0); i < k; ++i)
    {
        string now;
        cin >> now;
        for (int j(0); j < k; ++j)
        {
            if (now[j] == '1') g[i][j] = true;
        }
    }
    string as;
    cin >> as;
    vector<int> a(n);
    for (int i(0); i < n; ++i) a[i] = as[i] - 'a';
    vector<vector<bool>> can(n, vector<bool> (n));
    for (int i(1); i < n; ++i)
    {
        stack<int> st;
        for (int j(i); j > 0; --j)
        {
            st.push(j);
            while (!st.empty() && g[a[j - 1]][a[st.top()]]) st.pop();
            if (st.empty()) can[j][i] = true;
        }
    }
    string strinf = "{";
    vector<vector<string>> dp(n, vector<string> (n, strinf));
    for (int R(0); R < n; ++R)
    {
        for (int L(R); L > -1; --L)
        {
            if (L == R)
            {
                dp[L][R] = as[L];
                continue;
            }
            for (int M(L); M < R; ++M)
            {
                if (can[L][M])
                {
                    if (mn(dp[M + 1][R], dp[L][R])) dp[L][R] = dp[M + 1][R];
                }
            }
            for (int M(L + 1); M < R + 1; ++M)
            {
                if (can[M][R])
                {
                    if (mn(dp[L][M - 1], dp[L][R])) dp[L][R] = dp[L][M - 1];
                }
            }
            for (int M(L); M < R; ++M)
            {
                if (mn(dp[L][M] + dp[M + 1][R], dp[L][R])) dp[L][R] = dp[L][M] + dp[M + 1][R];
            }
        }
    }
    cout << dp[0][n - 1] << endl;
    return 0;
}
