import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.*;

public class A {
    public static void main(String[] args) throws IOException {
        BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
        PrintWriter writer = new PrintWriter(System.out);
        StringTokenizer st = new StringTokenizer(reader.readLine());
        int k = Integer.parseInt(st.nextToken());
        int n = Integer.parseInt(st.nextToken());
        TreeSet<Integer>[] kill = new TreeSet[k];
        for(int i = 0; i < k; ++i){
            kill[i] = new TreeSet<>();
        }
        for(int i = 0; i < k; ++i){
            char[] c = reader.readLine().toCharArray();
            for (int j = 0; j < k; ++j) {
                if (c[j] == '1') {
                    kill[j].add(i);
                }
            }
        }
        char[] s = reader.readLine().toCharArray();
        ArrayList<Integer> now = new ArrayList<>();
        for(int i = 0; i < n; ++i){
            now.add(s[i] - 'a');
        }
        StringBuilder ans = new StringBuilder();
        ans.append(s[0]);
        int last = 0;
        TreeSet<Integer>[] bef = new TreeSet[k];
        for(int i = 0; i < k; ++i){
            bef[i] = new TreeSet<>();
        }
        bef[now.get(0)].add(0);
        while(true){
            int min = 10000;
            int last_ind = 0;
            int ind = last + 1;
            while(ind < n){
                if(min > now.get(ind)){
                    min = now.get(ind);
                    last_ind = ind;
                }
                int max = -1;
                for(Integer killer : kill[now.get(ind)]){
                    if(bef[killer].size() != 0){
                        max = Math.max(max, bef[killer].last());
                    }
                }
                if(max == -1){
                    break;
                }
                else{
                    for(int i = max + 1; i < ind; ++i){
                        bef[now.get(i)].remove(i);
                    }
                }
                bef[now.get(ind)].add(ind);
                ++ind;
            }
            if(ind == n){
                System.out.println(ans);
                return;
            }
            ans.append((char)(min + 'a'));
            for(int i = 0; i < k; ++i){
                bef[i].clear();
            }
            last = last_ind;
            bef[now.get(last)].add(last);
        }
    }
}
