#include <bits/stdc++.h>

#define range(i, n) for(int i = 0; i < (n); ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define ar array


typedef long long ll;
using namespace std;

const int maxN = 33;
bool used[maxN][maxN];
int has[maxN * 5];
int cnt[maxN][maxN];
int us = 0;
int n;

void Do(int x, int y) {
    if (x > n || y > n || used[x][y]) return;
    used[x][y] = true;
    for(int x1 = 1; x1 <= x; ++x1) {
        for(int y1 = 1; y1 <= y; ++y1) {
            cnt[x1][y1]--;
        }
    }
    us++;
    Do(x + 1, y);
    Do(x, y + 1);
}

void solve1() {
    int k, m;
    cin >> n >> k >> m;
    string s;
    cin >> s;
    int j = 0;
    int ch = 0;
    while (j < m) {
        for(int x = 1; x <= n; ++x) for(int y = 1; y <= n; ++y) {
                used[x][y] = false;
                cnt[x][y] = (n - x + 1) * (n - y + 1);
            }
        int e = 2 * n;
        int cur = ch;
        ch ^= 1;
        bool ended = false;
        while (!ended) {
            int x = -1, y = -1;
            if (cur == 1) {
                cin >> x >> y;
            } else {
                if (e == 2 || j == m) {
                    x = 1, y = 1;
                } else {
                    int need = 0;
                    if (s[j] == '1') need |= 1;
                    if (j + 1 < m && s[j + 1] == '1') need |= 2;
                    need++;
                    for(int xx = 1; xx <= n; ++xx) {
                        for(int yy = 1; yy <= n; ++yy) {
                            if (used[xx][yy]) continue;
                            if (x == 1 && y == 1) continue;
                            if (cnt[xx][yy] != need) continue;
                            x = xx, y = yy;
                            break;
                        }
                        if (x != -1) break;
                    }
                }
                if (x == -1) x = 1, y = 1;
                cout << x << ' ' << y << endl;
            }
            if (x == 1 && y == 1) ended = true;
            Do(x, y);
            cur ^= 1;
        }
    }
    if (ch == 1) {
        cin >> ch >> ch;
    }
    cout << "0" << endl;
}

void solve2() {
    int k, m;
    cin >> n >> k >> m;
    int gms;
    cin >> gms;
    vector<int> result(m + 5, 0);
    int j = 0;
    int ch = 0;
    range(_, gms) {
        int cur = ch;
        ch ^= 1;
        bool ended = false;
        while (!ended) {
            int x, y;
            cin >> x >> y;
            us = 0;
            Do(x, y);
            if (x == 1 && y == 1) ended = true;
            else if (cur == 0) {
                us--;
                result[j++] = us & 1;
                result[j++] = us & 2;
            }
            cur ^= 1;
        }
    }
    range(i, m) cout << result[i];
    cout << endl;
}

void solve() {
    //freopen("\\\\.\\pipe\\game.in", "r", stdin);
    //freopen("\\\\.\\pipe\\game.out", "w", stdout);
    int t;
    cin >> t;
    if (t == 1) solve1();
    else solve2();
}

int main() {
    //ios_base::sync_with_stdio(false);
    //cin.tie(0);
    int tests = 1;
    range(_, tests) {
        solve();
    }
    return 0;
}