#include <bits/stdc++.h>

// #pragma GCC optimize("Ofast")

using namespace std;

typedef long long ll;
typedef long double ld;
#define pb push_back
#define pll pair<ll, ll>

const ll maxn = ll(1e3) + 2;

ll n;
set<ll> vals[maxn];
vector<ll> gr[maxn];

vector<ll> tmp;

map<ll, ll> dif;

ll dp[maxn][maxn]; /// last element if all elements > j in vertex i
ll perm[maxn][maxn]; /// permutation

ll fact[10];

void dfs(ll v) {
    for(auto i : gr[v]) {
        dfs(i);
    }

    if(gr[v].size() == 0) {
        for(ll i = 0; i < maxn; i++) {
            if(vals[v].upper_bound(i) == vals[v].end()) {
                dp[v][i] = -1;
            } else {
                dp[v][i] = *vals[v].upper_bound(i);
            }
        }
    } else {
        for(ll f = 0; f < maxn; f++) {
            for(ll tt = 0; tt < fact[gr[v].size()]; tt++) {
                ll lst = f;
                for(auto i : gr[v]) {
                    if(dp[i][lst] == -1) {
                        lst = -1;
                        break;
                    }
                    lst = dp[i][lst];
                }

                if(lst == -1) {
                    /// nothing
                } else {
                    if(dp[v][f] == -1 || dp[v][f] > lst) {
                        dp[v][f] = lst;
                    }
                }

                next_permutation(gr[v].begin(), gr[v].end());
            }
        }
    }
}

void solve() {
    cin >> n;

    for(ll i = 0; i < n; i++) {
        for(ll j = 0; j < maxn; j++) {
            dp[i][j] = -1;
        }
    }

    for(ll i = 0; i < n; i++) {
        ll tp;
        cin >> tp;
        ll cnt;
        cin >> cnt;
        if(tp == 1) {
            for(ll j = 0; j < cnt; j++) {
                ll u;
                cin >> u;
                u--;
                gr[i].pb(u);
            }
            sort(gr[i].begin(), gr[i].end());
        } else {
            for(ll j = 0; j < cnt; j++) {
                ll cur;
                cin >> cur;
                vals[i].insert(cur);
                tmp.pb(cur);
            }
        }
    }

    sort(tmp.begin(), tmp.end());
    for(ll i = 0; i < tmp.size(); i++) {
        dif[tmp[i]] = i + 1;
    }

    for(ll i = 0; i < n; i++) {
        set<ll> old = vals[i];
        vals[i].clear();

        for(auto el : old) {
            vals[i].insert(dif[el]);
        }
    }

    dfs(0);

    if(dp[0][0] != -1) {
        cout << "Yes\n";
    } else {
        cout << "No\n";
    }
}

int main()
{
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    fact[0] = 1;
    for(ll i = 1; i < 10; i++) {
        fact[i] = fact[i - 1] * i;
    }

    solve();

    return 0;
}
