#include <iostream>
#include <vector>

using namespace std;

const int MAXN = 1e5 + 228;

vector<pair<int, char> > b[MAXN];
string s;
bool used[MAXN];
bool used2[MAXN];

bool check(int pos) {
	for (int i = 0; i < b[pos].size(); ++i) {
		if (!used[b[pos][i].first] && s[b[pos][i].first] != b[pos][i].second) return false;
	}
	return true;
}

int cnt = 0;
vector<int> ans;

void add(int pos) {
	used2[pos] = true;
	ans.push_back(pos);
	for (int i = 0; i < b[pos].size(); ++i) {
		if (!used[b[pos][i].first]) {
			++cnt;
			used[b[pos][i].first] = true;
		}
	}
}

int main() {
	int n, m;
	cin >> n >> m;
	cin >> s;
	for (int i = 0; i < n; ++i) {
		int k;
		cin >> k;
		for (int j = 0; j < k; ++j) {
			int a;
			char c;
			cin >> a >> c;
			--a;
			b[i].push_back(make_pair(a, c));
		}
	}
	bool flag;
	while (cnt < m) {
		flag = false;
		for (int i = 0; i < n; ++i) {
			if (used2[i]) continue;
			if (check(i)) {
				flag = true;
				add(i);
				break;
			}
		}
		if (!flag) {
			cout << -1;
			return 0;
		}
	}
	for (int i = 0; i < ans.size(); ++i) {
		cout << ans[i] + 1 << " ";
	}
	for (int i = 0; i < n; ++i) {
		if (!used2[i]) {
			cout << i + 1 << " ";
		}
	}
}