#include <bits/stdc++.h>
using namespace std;

const int N = 2005;
const int INF = 1e9 + 10;

int n;
vector<int> g[N];
int k[N], m[N], type[N];
vector<int> a[N];
vector<int> A;
int p[N];
vector<int> w[N];
vector<int> dp[N];

void dfs(int v) {
    if (type[v] == 2) {
        for (int i = 0; i < m[v]; ++i) {
            dp[v][i] = i;
        }
    } else {
        for (int u : g[v]) {
            dfs(u);
        }
        auto ch = g[v];
        do {
            for (int st = 0; st < w[ch[0]].size(); ++st) {
                if (dp[ch[0]][st] < INF) {
                    int cur = w[ch[0]][dp[ch[0]][st]];
                    for (int i = 1; i < ch.size(); ++i) {
                        int pos = upper_bound(w[ch[i]].begin(), w[ch[i]].end(), cur) - w[ch[i]].begin();
                        if (pos == w[ch[i]].size() || dp[ch[i]][pos] == INF) {
                            cur = INF;
                            break;
                        }
                        cur = w[ch[i]][dp[ch[i]][pos]];
                    }
                    dp[v][st] = min(dp[v][st], cur);
                }
            }
        } while (next_permutation(ch.begin(), ch.end()));
        for (int i = (int)w[v].size() - 1; i > 0; --i) dp[v][i - 1] = min(dp[v][i - 1], dp[v][i]);
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cin >> n;
    p[0] = -1;
    for (int i = 0; i < n; ++i) {
        cin >> type[i];
        if (type[i] == 1) {
            cin >> k[i];
            g[i].resize(k[i]);
            for (int &v : g[i]) {
                cin >> v;
                --v;
                p[v] = i;
            }
            sort(g[i].begin(), g[i].end());
        } else {
            cin >> m[i];
            a[i].resize(m[i]);
            for (int &x : a[i]) {
                cin >> x;
                A.push_back(x);
            }
        }
    }
    sort(A.begin(), A.end());
    for (int i = 0; i < n; ++i) {
        if (type[i] == 2) {
            for (int &x : a[i]) x = lower_bound(A.begin(), A.end(), x) - A.begin();
            sort(a[i].begin(), a[i].end());
        }
    }
    for (int i = 0; i < n; ++i) {
        if (type[i] == 2) {
            for (int j = i; j != -1; j = p[j]) {
                for (int x : a[i]) w[j].push_back(x);
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        sort(w[i].begin(), w[i].end());
        dp[i].resize(w[i].size());
        for (int &x : dp[i]) x = INF;
    }
    dfs(0);
    for (int i = 0; i < w[0].size(); ++i) {
        if (dp[0][i] < INF) {
            cout << "Yes" << endl;
            return 0;
        }
    }
    cout << "No" << endl;
    return 0;
}
