#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <fstream>
#include <algorithm>
#include <vector>
#include <string>
#include <queue>
#include <stack>
#include <bitset>
#include <cassert>

using namespace std;

typedef long long ll;

#ifndef _DEBUG
const int N = 100010;
#else
const int N = 100;
#endif
const int LOGN = 20;
const int ALP = 28;

bool del[500][500];

int pos[N];

string s;

stack < int > st;

pair < string, int > dp[N];

pair < pair < string, int >, int > sp[LOGN][N];

int lg2[N];

int n;

void add(int i) {
	sp[0][i] = { dp[i], i };
	for (int j = 1; j < LOGN; ++j) {
		if (i + (1 << j) - 1 >= n)
			continue;
		sp[j][i] = min(sp[j - 1][i], sp[j - 1][i + (1 << (j - 1))]);
	}
}

int get_min(int l, int r) {
	int j = lg2[r - l + 1];
	return min(sp[j][l], sp[j][r - (1 << j) + 1]).second;
}

int pr[N];

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
#ifdef _DEBUG
	freopen("Test.txt", "r", stdin);
#endif

	for (int i = 2; i < N; ++i) {
		lg2[i] = lg2[i / 2] + 1;
	}

	int k;

	cin >> k >> n;

	for (int i = 1; i <= k; ++i) {
		string s;
		cin >> s;
		s = '0' + s;
		for (int j = 1; j < s.size(); ++j) {
			if (s[j] == '0')
				del[i + 'a' - 1][j + 'a' - 1] = 0;
			else
				del[i + 'a' - 1][j + 'a' - 1] = 1;
		}
	}

	cin >> s;

	while (!st.empty())
		st.pop();

	for (int i = n - 1; i >= 0; --i) {
		while (!st.empty() && del[s[i]][s[st.top()]])
			st.pop();
		pos[i] = n;
		if (!st.empty()) {
			pos[i] = st.top();
		}
		st.push(i);
	}


	dp[n - 1].first += s[n - 1];

	add(n - 1);

	pr[n - 1] = n;

	for (int i = n - 2; i >= 0; --i) {
		dp[i].first += char('z' + 1);
		if (pos[i] == n) {
			dp[i].first = s[i];
			pr[i] = n;
			add(i);
			continue;
		}
		auto t = get_min(i + 1, pos[i]);
		pr[i] = t;
		dp[i].first = s[i] + dp[t].first;
		dp[i].second = dp[t].second;
		if (dp[i].first.size() >= 250) {
			vector < pair < pair < string, int >, int > > c;
			for (int j = i; j < n; ++j) {
				c.push_back({ dp[j], j });
			}
			sort(c.begin(), c.end());
			for (int i = 0; i < c.size(); ++i) {
				dp[c[i].second] = { "", i + 1 };
			}
			for (int j = n - 1; j >= i; --j) {
				add(j);
			}
		}
		add(i);
	}

	int v = 0;
	while (v != n) {
		cout << s[v];
		v = pr[v];
	}

}