#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <algorithm>
#include <cmath>
#include <stdio.h>
#include <stack>

using namespace std;

vector<vector<long long>> v;
long long k = 0;
long long n = 0;
string str = "";
vector<vector<bool>> segdes;
string ans = "";

bool cmp(string str1, string str2)
{
	long long pos = 0;
	while (pos < str1.size() && pos < str2.size() && str1[pos] == str2[pos])
	{
		pos++;
	}

	if (str1.size() == pos)
	{
		return true;
	}
	else if (str2.size() == pos)
	{
		return false;
	}
	else
	{
		if (str1[pos] < str2[pos])
		{
			return true;
		}
		else
		{
			return false;
		}
	}
}

bool candestroy(long long l, long long r)
{
	stack<char> st;

	for (long long i = r; i >= l; i--)
	{
		while (!st.empty() && v[str[i] - 'a'][st.top() - 'a'] == 1)
		{
			st.pop();
		}
		st.push(str[i]);
	}

	if (st.size() == 1)
	{
		return true;
	}
	else
	{
		return false;
	}
}

void rec(long long pos, string cur)
{
	cur.push_back(str[pos]);

	if (pos == n)
	{
		if (cmp(cur, ans))
		{
			ans.clear();
			ans = cur;
		}
	}
	else
	{
		for (long long i = pos; i < n; i++)
		{
			if (segdes[pos][i])
			{
				rec(i + 1, cur);
			}
		}
	}
}

void task()
{
	cin >> k >> n;

	v.resize(k, vector<long long>(k, 0));

	for (long long i = 0; i < k; i++)
	{
		for (long long j = 0; j < k; j++)
		{
			char x;
			cin >> x;

			v[i][j] = x - '0';
		}
	}

	cin >> str;

	segdes.resize(n, vector<bool>(n, false));

	for (long long i = 0; i < n; i++)
	{
		for (long long j = i; j < n; j++)
		{
			segdes[i][j] = candestroy(i, j);
		}
	}

	ans = str;

	rec(0, "");

	for (long long i = 0; i < ans.size(); i++)
	{
		cout << ans[i];
	}
	cout << endl;
}

int main()
{
	task();

	return 0;
}