#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ft first
#define sd second
#define pb push_back
#define eb emplace_back
#define all(x) (x).begin(), (x).end()

bool check(int mask, string &s, vector<string> &matrix){
    int n = s.size();
    vector<int> next(n, -1);
    vector<int> deleted(n);
    for (int i = 0; i < n - 1; i++)
        next[i] = i + 1;
    for (int i = n - 1; i >= 0; i--){
        while (next[i] != -1 && !(mask & (1 << next[i])) && matrix[s[i] - 'a'][s[next[i]] - 'a'] == '1'){
            deleted[next[i]] = 1;
            next[i] = next[next[i]];
        }
    }
    for (int i = 0; i < n; i++)
        if (!(mask & (1 << i)) && !deleted[i])
            return false;
    return true;
}

string get(int mask, string &s){
    string ans;
    int n = s.size();
    for (int i = 0; i < n; i++)
        if (mask & (1 << i))
            ans += s[i];
    return ans;
}

signed main(){
    cin.tie(0);
    ios_base::sync_with_stdio(false);
    int k, n;
    cin >> k >> n;
    vector<string> matrix(k);
    for (int i = 0; i < k; i++)
        cin >> matrix[i];
    string s;
    cin >> s;

    int mx_mask = (1 << n);
    string best = s;
    for (int mask = 0; mask < mx_mask; mask++){
        if (check(mask, s, matrix)){
            string curr = get(mask, s);
            //cout << curr << endl;
            if (best > curr)
                best = curr;
        }
    }
    cout << best;
    return 0;
}