#pragma GCC optimize ("O3")

#include <iostream>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <vector>
#include <random>
#include <deque>

using namespace std;

const int N = 2e6;

typedef long long ll;

mt19937 rnd(228);

struct all
{
	int sz;
	vector<pair<int, char>> pos;
	int real;
};

bool comp(all a, all b)
{
	return a.sz < b.sz;
}

all a[N];
bool used[N];
vector < pair<char, int>> pos[N];
int need[N];
bool us[N];

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int n, m;
	cin >> n >> m;
	string s;
	cin >> s;
	int x;
	char c;
	for (int w = 0; w < n; w++)
	{
		a[w].real = w;
		cin >> a[w].sz;
		for (int q = 0; q < a[w].sz; q++)
		{
			cin >> x; x--;
			cin >> c;
			pos[x].push_back({ c,w });
			a[w].pos.push_back({ x,c });
			if (s[x] != c)
			{
				need[w]++;
			}
		}
	}
	vector <int> ans;
	deque<int> canuse;
	for (int q = 0; q < n; q++)
	{
		if (need[q] == 0)
		{
			canuse.push_back(q);
		}
	}
	while (canuse.size() != 0)
	{
		auto x = canuse.front();
		ans.push_back(x);
		canuse.pop_front();
		used[x] = true;
		for (int q = 0; q < a[x].pos.size(); q++)
		{
			if (!us[a[x].pos[q].first])
			{
				int t = a[x].pos[q].first;
				us[t] = true;
 				for (int qq = 0; qq < pos[t].size(); qq++)
				{
					if (pos[t][qq].first != s[t])
					{
						need[pos[t][qq].second]--;
						if (need[pos[t][qq].second] == 0)
						{
							canuse.push_back(pos[t][qq].second);
						}
					}
				}
			}
		}
	}
	for (int q = 0; q < n; q++)
	{
		if (used[q] == false)
		{
			cout << -1;
			return 0;
		}
	}
	for (auto x : ans)
	{
		cout << x + 1 << " ";
	}
}