#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
#define sz(x) int(x.size())

const int N = 1e5 + 10;

int n, m;
string s;

vector <int> a[N];
set <int> b[N], t[N];
char used[N], g[N];

signed main() {
#ifdef CHOPPAWONTMISS
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    cin >> n >> m >> s;
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;

        while (k--) {
            int pos;
            char c;

            cin >> pos >> c;
            pos--;

            if (s[pos] == c) {
                a[i].push_back(pos);
            } else {
                b[i].insert(pos);
                t[pos].insert(i);
            }
        }
    }

    vector <int> ans;
    queue <int> q;

    for (int i = 0; i < n; i++) {
        if (b[i].empty()) {
            q.push(i);
            used[i] = 1;
        }
    }

    while (!q.empty()) {
        int i = q.front();
        q.pop();

        ans.push_back(i);

        for (int x : a[i]) {
            g[x] = 1;
            for (int j : t[x]) {
                b[j].erase(x);
                if (b[j].empty() && !used[j]) {
                    used[j] = 1;
                    q.push(j);
                }
            }
            t[x].clear();
        }
    }

    int cnt = 0;
    for (int i = 0; i < m; i++) {
        cnt += g[i];
    }

    if (sz(ans) < n || cnt < m) {
        cout << "-1\n";
    } else {
        for (int x : ans) {
            cout << x + 1 << " ";
        }
    }
    cout << endl;

    return 0;
}
