#include <algorithm>
#include <iostream>
#include <vector>
#include <bitset>
#include <math.h>
#include <queue>
#include <set>
#include <map>

using namespace std;

#define ll long long
#define int ll

#define vi vector<int>
#define pii pair<int, int>

const int N = 1e5 + 5;
const ll INF = 1e18 + 5;

vi ma(N, INF), mi(N, -INF);
vi a[N];

void dfs(int v) {
	if (!a[v].size()) return;
	if (a[v].size() == 1) {
		mi[v] = mi[a[v][0]];
		ma[v] = ma[a[v][0]];
	}
	if (a[v].size() == 2) {
		int i = a[v][0], j = a[v][1];
		dfs(i); dfs(j);

		bool can = 0;
		
		if (ma[i] <= mi[j]) {
			can = 1;
			ma[v] = min(ma[v], ma[j]);
			mi[v] = max(mi[v], mi[i]);
		}
		if (ma[j] <= mi[i]) {
			can = 1;
			ma[v] = min(ma[v], ma[i]);
			mi[v] = max(mi[v], mi[j]);
		}
		if (!can) {
			cout << "No\n";
			exit(0);
		}

	}
}

signed main() {

	ios::sync_with_stdio(false);
	cin.tie(nullptr); cout.tie(nullptr);
	
	int n; cin >> n;
	for (int i = 0; i < n; ++i) {
		int x; cin >> x;
		if (x == 1) {
			int k; cin >> k;
			for (int j = 0; j < k; ++j) {
				int f; cin >> f;
				--f;
				a[i].push_back(f);
			}
		}
		else {
			int k; cin >> k;
			vi res;
			for (int i = 0; i < k; ++i) {
				int v; cin >> v;
				res.push_back(v);
			}
			sort(res.begin(), res.end());
			ma[i] = res[0];
			mi[i] = res.back();
		}
	}
	dfs(0);
	cout << "Yes\n";
}

/*

3 7
010
001
100
abacaba

3 5
010
001
100
bcacb

*/