#include <iostream>
#include <vector>
#include <array>

using namespace std;

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

int can[26][26];
vector<int> a;

bool can_del(int l, int r) {
	vector<int> now;
	for (int i = r; i >= l; --i) {
		while (now.size()) {
			if (can[a[i]][now.back()])
				now.pop_back();
			else
				break;
		}
		if (i != l)
			now.push_back(a[i]);
	}
	return now.size() == 0;
}

string char_to(int a) {
	string res;
	res += (a + 'a');
	return res;
}

string _min(string a, string b) {
	a += 'z' + 1, b += 'z' + 1;
	auto res = min(a, b);
	res.pop_back();
	return res;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int k, n;
	cin >> k >> n;
	for (int i = 0; i < k; ++i) {
		string s;
		cin >> s;
		for (int j = 0; j < k; ++j) {
			can[i][j] = (s[j] - '0');
		}
	}
	a.resize(n);
	for (int i = 0; i < n; ++i) {
		char c;
		cin >> c;
		a[i] = (c - 'a');
	}
	string bad;
	bad += 'a' + k + 1;

	if (n > 300) {
		string res = char_to(a[0]);
		for (int i = 1; i < n; ++i) {
			if (res.back() == 'a' && a[i] == 1) {
				if (!can[0][1])
					res += char_to(a[i]);
			}
			if (a[i] == 0)
				res += char_to(a[i]);
		}
		if (can[0][0]) {
			while (res.size() > 1 && res[res.size() - 1] == 'a' && res[res.size() - 2] == 'a')
				res.pop_back();
		}
		for (auto i : res)
			cout << i;
		return 0;
	}

	vector<vector<int>> del(n, vector<int> (n));
	for (int i = 0; i < n; ++i) {
		for (int j = i; j < n; ++j) {
			del[i][j] = can_del(i, j);
		}
	}
	vector<vector<string>> dp(n, vector<string> (n + 1, bad));
	dp[0][1] = char_to(a[0]);
	for (int i = 1; i < n; ++i) {
		for (int j = 0; j < i; ++j) {
			if (del[j][i]) {
				for (int k = 1; k <= i; ++k) {
					dp[i][k] = min(dp[i][k], dp[j][k]);
				}
			}
			for (int k = 1; k <= i; ++k) {
				dp[i][k + 1] = min(dp[i][k + 1], dp[i - 1][k] + char_to(a[i]));
			}
		}
	}
	string ans = bad;
	for (string i : dp.back())
		ans = min(ans, i);
	cout << ans << '\n';
}