#include <bits/stdc++.h>

using namespace std;

#define int long long
#define pii pair<int, int>
#define fi first
#define se second
#define sz(a) (int) (a).size()
#define pb push_back
#define all(a) (a).begin(), (a).end()

void print(vector<char> a) {
    for (auto x : a) cout << x << " ";
    cout << endl;
}

const int N = 100000;
int type[N], n;
vector<vector<int>> g, dp, tmp;

void dfs(int v) {
    if (sz(tmp)) return;
    vector<vector<int>> d;
    for (auto x : g[v]) {
        dfs(x);
        d.pb(tmp[x]);
    }
    sort(all(d));
    for (auto x : d) {
        for (auto y : x) {
            tmp[v].pb(y);
        }
    }
}

void gen(int x) {
    if (x == n) {
        for (int i = 0; i < n; i++) if (type[i] == 1) tmp[i].clear();
        dfs(0);
        if (is_sorted(all(tmp[0]))) {
            cout << "Yes\n";
            for (int i = 0; i < n; i++) {
                if (type[i] == 2) {
                    for (int j = 0; ; j++) {
                        if (dp[i][j] == tmp[i][0]) {
                            cout << j + 1 << '\n';
                            break;
                        }
                    }
                }
                else {
                    vector<pii> d;
                    for (auto x : g[i]) {
                        d.pb({tmp[x][0], x});
                    }
                    sort(all(d));
                    for (auto x : d) {
                        cout << x.se + 1 << " ";
                    } cout << '\n';
                }
            }
            exit(0);
        }
    }
    for (auto y : dp[x]) {
        tmp[x].pb(y);
        gen(x + 1);
        tmp[x].pop_back();
    }
    if (sz(dp[x]) == 0) gen(x + 1);
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    g.resize(n);
    dp.resize(n);
    tmp.resize(n);
    for (int i = 0; i < n; i++) {
        int t;
        cin >> t;
        type[i] = t;
        if (t == 1) {
            int k;
            cin >> k;
            while (k--) {
                int x; cin >> x; x--;
                g[i].pb(x);
            }
        }
        else {
            int k;
            cin >> k;
            while (k--) {
                int x; cin >> x;
                dp[i].pb(x);
            }
        }
    }
    gen(0);
    cout << "No";
}
