#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <queue>

using namespace std;

#define int long long
#define fi first
#define se second
#define all(x) x.begin(), x.end()

int32_t main() {
    //ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
    int n, k;
    cin >> k >> n;
    vector<vector<int>> ok(k, vector<int>(k));
    for (int i = 0; i < k; ++i) {
        string s;
        cin >> s;
        for (int j = 0; j < k; ++j) {
            ok[i][j] = s[j] == '1';
        }
    }


    string s;
    cin >> s;

    vector<vector<int>> del(n+1, vector<int>(n+1, 0));
    for (int l = 1; l < n; ++l) {
        for (int r = l; r < n; ++r) {
            string g = s.substr(l-1, r-l+2);
           // cout << l << ' ' << r << ' ' << g << endl;
            int x = 1;
            while (x) {
                x = 0;
                for (int i = (int)g.size()-1; i >= 1; --i) {
                    if (ok[ g[i-1]-'a' ][ g[i]-'a' ]) {
                        g.erase(g.begin() + i);
                        x = 1;
                        //if (l == 1 && r == 4) cout << g << endl;
                    }
                }
            }
            if (g.size() == 1) {
                del[l][r] = 1;
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
         //   cout << del[i][j] << ' ';
        }
      //  cout << endl;
    }
    s += char('a' + k);
    n++;
    vector<string> dp(n);
    dp[0] = s[0];
    for (int i = 1; i < n; ++i) {
        dp[i] = string(1, char('z' + 1));
        for (int j = 0; j < i; ++j) {
            if (i != j+1 && !del[j+1][i]) {
                continue;
            }
            string x = dp[j];
            dp[i] = min(dp[i], x + s[i]);
            while (x.size() >= 1 && ok[x.back() - 'a'][s[i] - 'a']) {
                x.pop_back();
                dp[i] = min(dp[i], x + s[i]);
            }
        }

    }
    string ans = dp[n-1].substr(0, dp[n-1].size()-1);
    cout << ans;
}

/*
 * 3 5
010
001
100
bcacb
 */