#include <bits/stdc++.h>
 
using namespace std;
 
#define pii pair <int, int>
#define pb push_back
#define mp make_pair
#define all(a) (a).begin(), (a).end()
#define sz(a) (int)(a).size()
#define ss second
#define ff first
 
typedef long long ll;
typedef long double ld;
#define int ll
 
const int inf = 1e9 + 100;
const ll inf64 = 1ll * inf * inf;
 
int n, k, m;
 
const int STEP = 4;
 
int to_int(string bin){
    int ans = 0;
    int ti = 0;
    for(int i = sz(bin) - 1; i >= 0; --i){
        ans += (bin[i] == '1') * (1ll << ti);
        ti++;
    }
    return ans;
}
string to_bin(int x){
    string ans;
    while(x){
        ans.pb((x % 2) + '0');
        x /= 2;
    }
    while(sz(ans) < STEP)
        ans.pb('0');
    reverse(all(ans));
    return ans;
}
 
 
pii find(vector <vector <int>> &a, int tmod){
    int clear_cnt = 0;
    for(int i = n - 1; i >= 0; --i){
        for(int j = n - 1; j >= 0; --j){
            if((i ^ j) % (1ll << STEP) == tmod && a[i][j] == 0){
                return mp(i, j);
            }
        }
    }
    return mp(0, 0);
}
 
void color(vector <vector <int>> &a, int ti, int tj){
    for(int i = n - 1; i >= ti; --i){
        for(int j = n - 1; j >= tj; --j){
            a[i][j] = 1;
        }
    }
}
 
 
void play(){
    cin >> n >> k >> m;
    string s;
    cin >> s;
    int t = 0;
    vector <vector <int>> a(n, vector <int>(n));
    bool move = 0;
    bool first_move = 1;
    while(t < sz(s)){
        move = !move;
        if(move){
            string ts;
            for(int ti = t; ti < t + STEP; ++ti){
                ts.pb(s[ti]);
            }
            pii tp = find(a, to_int(ts));
            if(tp == mp(0ll, 0ll)){
                cout << 1 << ' ' << 1 << endl;
                first_move = !first_move;
                if(first_move)
                    move = 0;
                else
                    move = 1;
                a.assign(n, vector <int>(n, 0));
                continue;
            }
            else{
                cout << tp.ff + 1 << ' ' << tp.ss + 1 << endl;
            }
            color(a, tp.ff, tp.ss);
            t += STEP;
        }
        else{
            int ti, tj;
            cin >> ti >> tj;
            --ti;
            --tj;
            if(mp(ti, tj) == mp(0ll, 0ll)){
                first_move = !first_move;
                if(first_move)
                    move = 0;
                else
                    move = 1;
                a.assign(n, vector <int>(n, 0));
            }
            color(a, ti, tj);
        }
    }
    cout << 1 << ' ' << 1 << endl;
    int ti, tj;
    cin >> ti >> tj;
    cout << 0 << endl;
}
 
void gans(){
    vector <pii> moves;
    cin >> n >> k >> m;
    int cg;
    cin >> cg;
    bool move = 0;
    bool first_move = 1;
    for(int i = 0; i < cg;){
        move = !move;
        int ti, tj;
        cin >> ti >> tj;
        --ti;
        --tj;
        if(mp(ti, tj) == mp(0ll, 0ll)){
            first_move = !first_move;
            if(first_move)
                move = 0;
            else
                move = 1;
            ++i;
            continue;
        }
        if(move){
            moves.pb(mp(ti, tj));
        }
    }
    string ans;
    for(auto i : moves){
        ans += to_bin((i.ff ^ i.ss) % (1ll << STEP));
    }
    cout << ans << endl;
}
 
void run(){
    int game;
    cin >> game;
    if(game == 1){
        play();
    }
    else{
        gans();
    }
}
 
signed main(){
//    freopen("/tmp/game.in", "r", stdin);
//    freopen("/tmp/game.out", "w", stdout);
    cin.tie(0);
    cout.tie(0);
    iostream::sync_with_stdio(0);
    run();
}