#define ll long long

#include <iostream>
#include <string>
#include <algorithm>
#include <vector>
#include <set>
#include <map>

using namespace std;

ll num(char c) {
	return (c - 'a');
}

signed main() {
	ll n, k;
	cin >> k >> n;
	vector<vector<ll>> del(k, vector<ll>(k));
	for (int i = 0; i < k; i++) {
		string hj;
		cin >> hj;
		for (int j = 0; j < k; j++) {
			del[i][j] = (hj[j] == '1');
		}
	}
	string s;
	cin >> s;
	vector<vector<string>> dp(n, vector<string>(k, "}"));
	dp[0][num(s[0])] = s[0];
	for (int i = 1; i < n; i++) {
		ll op = num(s[i]);
		if (del[num(s[i - 1])][op]) {
			for (int j = 0; j < k; j++) {
				dp[i][j] = dp[i - 1][j];
			}
		}
		else {
			for (int j = 0; j < k; j++) {
				if (del[j][op] && dp[i - 1][j] != "}") {
					dp[i][j] = dp[i - 1][j];
				}
			}
		}
		for (int j = 0; j < k; j++) {
			if (dp[i - 1][j] != "}") {
				if (dp[i][op] == "}") {
					dp[i][op] = dp[i - 1][j] + s[i];
				}
				else {
					dp[i][op] = min(dp[i - 1][j] + s[i], dp[i][op]);
				}
			}
		}
		if (dp[i - 1][op] != "}" && del[op][op]) {
			dp[i][op] = min(dp[i - 1][op], dp[i][op]);
		}
	}
	string ans = "";
	ans += char('z' + 1);
	for (int i = 0; i < k; i++) {
		ans = min(dp.back()[i], ans);
	}
	cout << ans;
}


/*
3 7
0 1 0
0 0 1
1 0 0
abacaba
*/