#include <bits/stdc++.h>

#define FAST ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define all(x) (x).begin(), (x).end()
#define allr(x) (x).rbegin(), (x).rend()
#define gsize(x) (int)((x).size())

typedef long long ll;
typedef long double ld;

const char nl = '\n';

const ll inf = 1e9;
const ll inf2 = 1e18;
const ld eps = 1e-9;
const ll mod = 1e9+7;

const ll maxn = 10000, maxm = 1e6;

using namespace std;

vector<int> g[maxn];
vector<vector<int>> good[maxn];
vector<int> tgood[maxn];

bool ha = true;

bool f(vector<int> tv) {
		int cv = 0;
		for (int i: tv) {
			int v2 = -1;
			for (int x: tgood[i]) {
				if (x > cv) {
					v2 = x;
					cv = v2;
					break;
				}
			}
			if (v2 < 0) {
				return false;
			}
		}
		
		return true;
}

vector<int> cres;
void gen(int v, vector<int> &p, int i) {
	if (i == gsize(p) && f(cres)) {
		good[v].push_back(cres);
		return;
	} else if (i == gsize(p)) return;
	
	for (int j = 0; j < gsize(good[p[i]]); j++) {
		int tn = gsize(good[p[i]][j]);	
		for (int k = 0; k < tn; k++) {
			cres.push_back(good[p[i]][j][k]);
		}
		gen(v, p, i + 1);
		while(tn--) cres.pop_back();
	}
	
}

void dfs(int v) {
	
	if (gsize(g[v]) == 0) return;
	int tn = gsize(g[v]);
	for (int u: g[v]) {
		dfs(u);	
		if (!ha) return;
	}
	vector<int> p(tn);
	for (int i = 0; i < tn; i++) p[i] = g[v][i];
	sort(all(p));
	//for (int x: p) cout << x << ' ';
//	cout << endl;
	
	int ct = 0;
	do {
		ct++;
		gen(v, p, 0);
	} while (next_permutation(all(p)));
	if (gsize(good[v]) == 0) {
		ha = false;
		return;
	}
	//cout << ct << ' ' << v << ' ' << "HI" << endl;
}

int main() {
	FAST;
	
	int n;
	cin >> n;
	for (int i = 0; i < n; i++) {
		int ct;
		cin >> ct;
		if (ct == 1) {
			good[i] = {};
			int m;
			cin >> m;
			while (m--) {
				int v;
				cin >> v;
				v--;
				g[i].push_back(v);
			}
		} else {
			int m;
			cin >> m;
			good[i] = {{i}};
			while (m--) {
				int x;
				cin >> x;
				tgood[i].push_back(x);
			}
			sort(all(tgood[i]));
		}
	}
	
	dfs(0);
	
	if (!ha) {
		cout << "No" << nl;
		return 0;
	}
	
	for (auto tv: good[0]) {
		cout << "Yes" << nl;
		return 0;
	}
	cout << "No" << nl;
}
