#include <bits/stdc++.h>
using namespace std;

#pragma GCC optimize("O3")

const int K = 27, N = 5e5 + 5;

int k, n;

vector<int> a, lft;


bool can[K][K];

string dp[N];

struct dsu {
  int size;
  vector<int> par;
  dsu(int sz) : size(sz) {
    par.resize(size);
    iota(par.begin(), par.end(), 0);
  }
  int gpar(int x) {
    if (par[x] == x) return x;
    return par[x] = gpar(par[x]);
  }
  void merge(int x, int y) {
    x = gpar(x), y = gpar(y);
    if (x == y) return;
//    if (v[x].size() > v[y].size())
//      swap(x, y);
    if (dp[x] < dp[y]) {
      par[y] = x;
      dp[y].clear();
    } else {
      par[x] = y;
      dp[x].clear();
    }
  }
  void add(int x, char ch) {
    x = gpar(x);
    string nn = ch + dp[x];
    dp[x] = min(dp[x], nn);
  }
};

int nxt[N];

int get_nxt(int x) {
  if (nxt[x] == x)
    return x;
  return nxt[x] = get_nxt(nxt[x]);
}


int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);


  cin >> k >> n;

  iota(nxt, nxt + n + 1, 0);

  for (int i = 0; i < k; ++i) {
    string ss;
    cin >> ss;
    for (int j = 0; j < k; ++j) {
      if (ss[j] == '1')
        can[i][j] = true;
    }
  }
  string ss;
  cin >> ss;
  a.resize(n);
  lft.resize(n);
  for (int i = 0; i < n; ++i) {
    a[i] = ss[i] - 'a';
  }

  for (int i = 0; i < n; ++i) {
    int l = i - 1;
    while (l != -1 && !can[a[l]][a[i]])
      l = lft[l];
    lft[i] = l;
  }

  dsu D(n + 1);

  for (int i = n - 1; i >= 0; --i) {
    if (lft[i + 1] != i) {
      dp[i] = char('a' + a[i]) + dp[i + 1];
    } else {
      int j = get_nxt(i + 1), jj = j;
      while (j < n && lft[j] >= i) {
        D.merge(jj, j);
        nxt[j] = j + 1;
        j = get_nxt(j);
      }
      D.merge(jj, j);
//      nxt[j] = j + 1;
      dp[D.gpar(i)] = char('a' + a[i]) + dp[D.gpar(j)];
    }
  }

  cout << dp[D.gpar(0)];

}