from functools import lru_cache


@lru_cache(maxsize=None)
def ith(n):
    return 1 << (n - 1)


def read_perf(s):
    perf = [0, 0, 0]
    inp = input().split()
    k = int(inp[0])
    for i in range(k):
        n, ch = inp[i * 2 + 1:i * 2 + 3]
        n = int(n)
        if ch == s[n - 1]:
            perf[0] += ith(n)
        else:
            perf[1] += ith(n)
            perf[2] += 1
    return perf


n, m = map(int, input().split())
s = input()
perfs = sorted([[i, read_perf(s)] for i in range(n)],
        key=lambda x: x[1][2])
covered = 0
prev = -1
res = []
while len(perfs) != 0 and covered != prev:
    prev = covered
    nperfs = []
    for i, perf in perfs:
        if perf[1] == perf[1] & covered:
            covered = covered | perf[0]
            res.append(i + 1)
        else:
            nperfs.append(perf)
    perfs = nperfs
if covered != (1 << m) - 1:
    print(-1)
else:
    print(*res)

