#include <iostream>
#include <string>
#include <vector>
using namespace std;
int main() {
    int n, m;
    cin >> n >> m;
    string s;
    cin >> s;
    vector <vector <char>> a(n, vector <char> (m, ' '));
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        for (int j = 0; j < k; j++) {
            int pos;
            char val;
            cin >> pos >> val;
            a[i][pos-1] = val;
        }
    }
    vector <bool> filled(m, false);
    vector <bool> used(n, false);
    vector <int> res;
    for (int i = 0; i < n; i++) {
        int best_cnt = 0;
        int best = -1;
        for (int j = 0; j < n; j++) {
            if (!used[j]) {
                int cnt;
                for (int k = 0; k < m; k++) {
                    if (!filled[k]) {
                        cnt = 0;
                        if (a[j][k] == s[k]) {
                            cnt++;
                        } else if (a[j][k] != ' ') {
                            cnt = -1;
                            break;
                        }
                    }
                }
                if (cnt > best_cnt) {
                    best_cnt = cnt;
                    best = j;
                }
            }
        }
        if (best != -1) {
            used[best] = true;
            for (int j = 0; j < m; j++) {
                if (a[best][j] == s[j]) {
                    filled[j] = true;
                }
            }
            res.push_back(best+1);
        } else {
            res = {-1};
            break;
        }
    }
    for (int i = 0; i < res.size(); i++) {
        cout << res[i] << ' ';
    }
    return 0;
}
