#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;
typedef long double ld;

#define all(x) (x).begin(), (x).end()
#define print(x) {for (auto xxxxx : (x)) cout << xxxxx << ' '; cout << '\n';}


void solve() {
    int n, m;
    cin >> n >> m;
    string s; cin >> s;
    vector <set <pii> > a(n), b(m);
    vector <int> z(n, 0);
    set <int> zer;
    for (int i = 0; i < n; i++) {
        int k; cin >> k;
        while (k --> 0) {
            int x; char c; cin >> x >> c; x--;
            if (!(c == s[x]))
                z[i]++;
            a[i].insert({x, (c == s[x])});
            b[x].insert({i, (c == s[x])});
        }
        if (z[i] == 0)
            zer.insert(i);
    }
    vector <int> ans;
    vector <bool> ok(m, false);
    while (!zer.empty()) {
        int id = *(zer.begin());
        ans.push_back(id + 1);
        zer.erase(zer.begin());
        for (auto x : a[id]) {
            ok[x.first] = true;
            for (auto y : b[x.first]) {
                if (y.first == id)
                    continue;
                a[y.first].erase({x.first, y.second});
                if (y.second == 0) {
                    z[y.first]--;
                    if (z[y.first] == 0) {
                        zer.insert(y.first);
                    }
                }
            }
        }
    }
    if (int(ans.size()) != n) {
        cout << "-1\n";
        return;
    }
    for (auto x : ok) {
        if (!x) {
            cout << "-1\n";
            return;
        }
    }
    print(ans);
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.precision(20);

    int t = 1;
    //cin >> t;
    while (t --> 0) {
        solve();
    }

    return 0;
}