#include <cassert>
#include <iostream>
#include <vector>
#include <string>
#include <map>
using namespace std;


vector < int > ch(int n, int m, string s, vector < vector < char > > p) {
	vector < int > ord;
	int cnt = 0, cnt_l = 0;
	vector < bool > used(m, false);
	vector < bool > usedl(n, false);
	for (; cnt < m;) {
		vector < int > no;
		for (int i = 0; i < n; i++) {
			if (usedl[i])
				continue;
			bool g = true;
			for (int j = 0; j < m; j++) {
				if (!used[j]) {
					g = g && (p[i][j] == '?' || p[i][j] == s[j]);
				}
			}
			if (g)
				no.push_back(i);
		}
		for (int i = 0; i < no.size(); i++) {
			ord.push_back(no[i]);
			usedl[no[i]] = true;
			for (int j = 0; j < m; j++) {
				if (p[no[i]][j] == s[j] && !used[j]) {
					used[j] = true;
					cnt++;
				}
			}
		}
		if (cnt == cnt_l && cnt < m) {
			return {};
		}
		cnt_l = cnt;
	}

	return ord;
}


int main() {
	iostream::sync_with_stdio(0); cin.tie(0); cout.tie(0);

	int n, m;
	string s;
	cin >> n >> m >> s;

	vector < vector < char > > p(n, vector < char >(m, '?'));
	for (int i = 0; i < n; i++) {
		int k;
		cin >> k;
		for (int j = 0;j < k; j++) {
			int a;
			char c;
			cin >> a >> c;
			p[i][a - 1] = c;
		}
	}

	vector < int > res = ch(n, m, s, p);

	if (res.size()) {
		for (int el : res)
			cout << el + 1 << " ";
		cout << "\n";
	}
	else
		cout << "-1\n";

	/*for (int sd = 2; sd <= 100; sd++) {
		srand(sd);
		cout << sd << endl;

		int n = 5, m = 5;
		vector < vector < char > > p(n, vector < char >(m, '?'));
		string s;
		for (int i = 0; i < m; i++)
			s += rand() % 2 + 'a';
		cout << s << "\n";
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < m; j++) {
				if (rand() % 3 == 0)
					p[i][j] = rand() % 2 + 'a';
				cout << p[i][j] << " ";
			}
			cout << "\n";
		}

		vector < int > res = ch(n, m, s, p);

		for (int el : res)
			cout << el + 1 << " ";
		cout << "\n";
		if (res.size())
			for (int j = 0; j < m; j++) {
				int i = 0;
				while (p[res[i]][j] == '?')
					i++;
				assert(p[res[i]][j] == s[j]);
			}
	}*/

	return 0;
}
/*
3 4
glhf
3 1 r 3 h 4 i
3 1 r 2 l 3 o
2 1 g 4 f
*/