#include <algorithm>
#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
using namespace std;


vector < vector < int > > d;


void get_ord(int v, int p, vector < vector < int > >& g, vector < vector < int > >& res, vector < vector < int > >& ord) {
	if (!g[v].size()) {
		ord.push_back(d[v]);
		return;
	}
	for (int el : res[v])
		if (g[v][el] != p)
			get_ord(g[v][el], v, g, res, ord);
}


void per(int v, vector < vector < int > >& g, vector < vector < int > >& res) {
	if (v == g.size()) {
		vector < vector < int > > ord;
		get_ord(0, 0, g, res, ord);
		vector < int > res(1, 0);
		for (int i = 0; i < ord.size(); i++) {
			int j = 0;
			while (j < ord[i].size() && ord[i][j] < res.back())
				j++;
			if (j == ord[i].size())
				return;
			res.push_back(ord[i][j]);
		}
		cout << "Yes\n";
		/*for (int i = 1; i < res.size(); i++)
			cout << res[i] << "/n";
		cout << "\n";*/
		exit(0);
	}
	
	vector < int > p(g[v].size());
	for (int i = 0; i < g[v].size(); i++)
		p[i] = i;
	bool f = true;
	while (f) {
		res[v] = p;
		per(v + 1, g, res);
		f = next_permutation(p.begin(), p.end());
	}
}


int main() {
	iostream::sync_with_stdio(0); cin.tie(0); cout.tie(0);

	int n;
	cin >> n;

	d.resize(n);
	vector < vector < int > > g(n);
	for (int i = 0; i < n; i++) {
		int t;
		cin >> t;
		if (t == 1) {
			int k;
			cin >> k;
			for (int j = 0; j < k; j++) {
				int b;
				cin >> b;
				g[i].push_back(b - 1);
			}
		}
		else {
			int m;
			cin >> m;
			for (int j = 0; j < m; j++) {
				int u;
				cin >> u;
				d[i].push_back(u);
			}
		}
		sort(d[i].begin(), d[i].end());
	}

	vector < vector < int > > res(n);
	per(0, g, res);

	cout << "No\n";

	return 0;
}
/*
6
1 3 5 4 6
2 3 10 61 60
2 2 80 20
2 2 40 70
1 2 3 2
2 4 30 90 91 92

3
1 2 2 3
2 1 1
2 1 2
*/