#include <bits/stdc++.h>
using namespace std;

#define x first
#define y second
#define all(x) begin(x), end(x)
#define sz(x) ((int) (x).size())
typedef long long ll;
typedef long double ld;

const int N = 2e3 + 10, K = 8, MASK = 1 << K;

int n, m;
int wback[N];
map<int, int> widx;
int t[N], k[N];
vector<int> g[N];
int dp[N][N], pr[N][N];
vector<int> ans[N];
int dpc[MASK][N];

void dfs(int u) {
	if (t[u] == 2) {
		for (int v : g[u])
			for (int j = 0; j <= v; ++j)
				dp[u][j] = min(dp[u][j], v + 1);
		return;
	}
	for (int v : g[u])
		dfs(v);
	
	int z = sz(g[u]);
	int max_mask = 1 << z;
	for (int i = 0; i < max_mask; ++i)
		fill(dpc[i], dpc[i] + m, N);
	iota(dpc[0], dpc[0] + m, 0);

	for (int mask = 1; mask < max_mask; ++mask)
		for (int j = 0; j < z; ++j)
			if (mask >> j & 1)
				for (int h = 0; h < m; ++h)
					dpc[mask][h] = min(dpc[mask][h],
						dp[g[u][j]][dpc[mask ^ (1 << j)][h]]);
	copy_n(dpc[max_mask - 1], m, dp[u]);
}


// void dfs_back(int u, int i) {
// 	if (t[u] == 2) {
// 		ans[u].push_back(wback[*lower_bound(all(g[u]), i)]);
// 		return;
// 	}
// 	for (int iter = 0; iter < pr[u][i]; ++iter)
// 		next_permutation(all(g[u]));
// 	ans[u] = g[u];
// 	for (int &e : ans[u])
// 		++e;
// 	for (int v : g[u]) {
// 		dfs_back(v, i);
// 		i = dp[v][i];
// 	}
// }

signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cin >> n;
	for (int i = 0; i < n; ++i) {
		cin >> t[i] >> k[i];
		g[i].resize(k[i]);
		for (int j = 0; j < k[i]; ++j) {
			cin >> g[i][j];
			if (t[i] == 1)
				--g[i][j];
			else
				widx[g[i][j]] = 0;
		}
		sort(all(g[i]));
	}
	for (auto &e : widx) {
		wback[m] = e.x;
		e.y = m++;
	}
	m += 10;
	for (int i = 0; i < n; ++i) {
		if (t[i] == 1)
			continue;
		for (auto &u : g[i])
			u = widx[u];
	}
	fill(dp[0], dp[N], N);
	dfs(0);
	if (dp[0][0] == N) {
		cout << "No";
	} else {
		cout << "Yes\n";
		// dfs_back(0, 0);
		// for (int i = 0; i < n; ++i) {
		// 	for (int v : ans[i])
		// 		cout << v << " ";
		// 	cout << "\n";
		// }
	}
	// cout << (dp[0][0] == N ? "No" : "Yes");
	return 0;
}