#include <bits/stdc++.h>

using namespace std;

#define all(a) a.begin(), a.end()
#define nl '\n'
#define elif else if
#define forn(i, n) for (int i = 0; i < n; i++)
#define vi vector<int>
#define maxq(ma, a) ma = max(ma, a)
#define minq(mi, a) mi = min(mi, a)
#define pb push_back
#define sz(a) ((int)a.size())
#define pi pair<int, int>
#define vpi vector<pair<int, int>>

inline void IO() {
#ifdef Dmitry07
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

const int MAXN = 100;

int F(string s) {
    int ans = 0;
    forn (i, 5) {
        if (s[i] == '1') {
            ans += 1 << i;
        }
    }
    return ans;
}

string F1(int a) {
    string ans;
    forn (i, 5) {
        if (a & (1 << i)) {
            ans += '1';
        } else {
            ans += '0';
        }
    }
    return ans;
}

char fi[40][40];

void Fill() {
    forn (i, 32) {
        fill(fi[i], fi[i] + 32, 0);
    }
}

void Paint(int x, int y) {
    for (int i = x; i < 32; i++) {
        fill(fi[i] + y, fi[i] + 32, 1);
    }
}

bool Play(int &ind, int &game, vi &a) {
    if (!game) {
        int x = a[ind], y = -1;
        for (int i = 31; i >= 0; i--) {
            if (fi[x][i] == 0) {
                y = i;
                break;
            }
        }
        if (y == -1 || x == 0 && y == 0) {
            cout << "1 1" << endl;
            game ^= 1;
            return 0;
        }
        cout << x + 1 << ' ' << y + 1 << endl;
        Paint(x, y);
        ind++;
        int x1, y1;
        cin >> x1 >> y1;
        x1--;
        y1--;
        Paint(x1, y1);
        if (x1 == 0 && y1 == 0) {
            game ^= 1;
        }
    } else {
        int x1, y1;
        cin >> x1 >> y1;
        x1--;
        y1--;
        Paint(x1, y1);
        if (x1 == 0 && y1 == 0) {
            game ^= 1;
            return 0;
        }
        int x = a[ind], y = -1;
        for (int i = 31; i >= 0; i--) {
            if (fi[x][i] == 0) {
                y = i;
                break;
            }
        }
        if (y == -1 || x == 0 && y == 0) {
            cout << "1 1" << endl;
            game ^= 1;
            return 0;
        }
        cout << x + 1 << ' ' << y + 1 << endl;
        Paint(x, y);
        ind++;
    }
    return 1;
}

inline void Solve() {
    int typ;
    cin >> typ;
    if (typ == 1) {
        int n, k, m;
        cin >> n >> k >> m;
        string s;
        cin >> s;
        vi a(sz(s) / 5);
        for (int i = 0; i < sz(s); i += 5) {
            a[i / 5] = F(s.substr(i, 5));
        }
        int game = 0, ind = 0;
        while (ind < sz(a)) {
            if (!Play(ind, game, a)) {
                Fill();
            }
        }
        ind = 0;
        while (Play(ind, game, a)) {
            int qq = 1;
        }
        cout << 0 << endl;
        return;
    }
    int n, k, m;
    cin >> n >> k >> m;
    int cc;
    cin >> cc;
    forn (i, cc) {
        vpi aa;
        int x, y;
        cin >> x >> y;
        aa.pb({x - 1, y - 1});
        while (x != 1 || y != 1) {
            cin >> x >> y;
            aa.pb({x - 1, y - 1});
        }
        aa.pop_back();
        string ans;
        for (int j = i % 2; j < sz(aa); j += 2) {
            auto[x, y] = aa[j];
            if (sz(ans) < m) {
                ans += F1(x);
            }
        }
        cout << ans;
    }
}

signed main() {
//    IO();
    int t = 1;
    while (t--) {
        Solve();
    }
    return 0;
}