#include <bits/stdc++.h>
#define X first
#define Y second
#define pb push_back
#define sz(a) (int)a.size()

using namespace std;

void solve1(), solve2();

signed main() {
    //freopen("\\\\.\\pipe\\game.in", "r", stdin);
    //freopen("\\\\.\\pipe\\game.out", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int type;
    cin >> type;
    if (type == 1)
        solve1();
    else
        solve2();
    return 0;
}

bitset <33> used[33];

bool check(int x, int y) {
    if (x <= 32 && y <= 32)
        return true;
    return false;
}

int dx[2] = {0, 1};
int dy[2] = {1, 0};

void dfs(int x, int y) {
    used[x][y] = 1;
    for (int i = 0; i < 2; ++i) {
        int xx = x + dx[i], yy = y + dy[i];
        if (check(xx, yy) && !used[xx][yy])
            dfs(xx, yy);
    }
}

int cnt = 0;

void kfs(int x, int y) {
    //used[x][y] = 1;
    cnt++;
    for (int i = 0; i < 1; ++i) {
        int xx = x + dx[i], yy = y + dy[i];
        if (check(xx, yy) && !used[xx][yy])
            kfs(xx, yy);
    }
}

string s;

void solve1() {
    int n, k, m;
    cin >> n >> k >> m;
    cin >> s;
    bool f;
    int x, y;
    bool p = true;
    int z = 0;
    while (z < sz(s)) {
        f = false;
        int ansx, ansy, pp = 10000;
        for (int i = 32; i >= 1; --i) {
            cnt = 0;
            for (int j = 32; j >= 1; --j) {
                kfs(i, j);
                if (!used[i][j] && (i != 1 || j != 1) && (i % 2 == s[z] - '0') && ((i / 2) % 2 == s[z + 1] - '0') && (j % 2 == s[z + 2] - '0') && ((j / 2) % 2 == s[z + 3] - '0') && ((j / 4) % 2 == s[z + 4] - '0')) {
                    if (!f || pp > cnt) {
                        pp = cnt;
                        f = true;
                        ansx = i, ansy = j;
                    }
                }
            }
        }
        if (!f) {
            cout << "1 1" << endl;
            for (int i = 1; i <= 32; ++i)
                used[i] = 0;
            if (p) {
                cin >> x >> y;
                dfs(x, y);
            }
            p ^= 1;
        } else {
            cout << ansx << " " << ansy << endl;
            dfs(ansx, ansy);
            z+=5;
            cin >> x >> y;
            if (x == 1 && y == 1) {
                for (int i = 1; i <= 32; ++i)
                    used[i] = 0;
                if (p) {
                    cin >> x >> y;
                    dfs(x, y);
                    p ^= 1;
                } else {
                    p ^= 1;
                    continue;
                }
            } else {
                dfs(x, y);
            }
        }
    }
    cout << 1 << " " << 1 << endl;
    if (p) {
        cin >> x >> y;
        cout << 0 << endl;
    } else {
        cout << 0 << endl;
    }
}

void solve2() {
    int n, k, m, t, x, y;
    cin >> n >> k >> m;
    cin >> t;
    bool p = true, f = true;
    while (cin >> x >> y) {
        if (f) {
            if (x != 1 || y != 1) {
                s.pb((char)('0' + (x % 2)));
                s.pb((char)('0' + (x / 2 % 2)));
                s.pb((char)('0' + (y % 2)));
                s.pb((char)('0' + (y / 2 % 2)));
                s.pb((char)('0' + (y / 4 % 2)));
            }
        }
        if (x == 1 && y == 1) {
            if (p)
                f = true;
            else
                f = false;
            p ^= 1;
            t--;
        }
        f ^= 1;
        if (sz(s) == m)
            break;
    }
    cout << s << endl;
}
