#include <bits/stdc++.h>

using namespace std;
using ll = long long;
#define SZ(x) (int)((x).size())
#define ALL(x) (x).begin(), (x).end()
const int MAXN = 32;
int n, k, m;
string message;
int arr[MAXN][MAXN];
int cnt[MAXN][MAXN];

vector<pair<pair<int, int>, int>> get_moves() {
    vector<pair<pair<int, int>, int>> ret;
    for (int i = n - 1; i >= 0; i--)
        for (int j = n - 1; j >= 0; j--) {
            cnt[i][j] = (!arr[i][j]);
            if (i + 1 < n)
                cnt[i][j] += cnt[i + 1][j];
            if (j + 1 < n)
                cnt[i][j] += cnt[i][j + 1];
            if (i + 1 < n && j + 1 < n)
                cnt[i][j] -= cnt[i + 1][j + 1];
            if (!arr[i][j])
                ret.emplace_back(make_pair(i, j), cnt[i][j]);
        }
    sort(ALL(ret), [&](pair<pair<int, int>, int> a, pair<pair<int, int>, int> b){
        return a.second < b.second;
    });
    return ret;
}

void paint(int x, int y){
    for (int i = x; i < n; i++)
        for (int j = y; j < n; j++)
            arr[i][j] = 1;
//    cerr << "!!!!" << x << ' ' << y << '\n';
}

void clear(){
    for (int i = 0; i < n; i++)
        for (int j = 0; j < n; j++)
            arr[i][j] = 0;
}

void get_move(int x, int y){
    cout << x + 1 << ' ' << y + 1 << endl;
    paint(x, y);
}
int turn = 0;
int start_turn = 0;
int pnt = 0;

bool new_game(int pr = 1){
    turn = (start_turn ^= 1);
    if (pnt == m && pr){
        cout << "0" << endl;
        return true;
    }
    clear();
    return false;
}

void solve1(){
    cin >> message;

    while (true){
        if (turn == 0){
            auto x = get_moves();
            if (SZ(x) == 1){
                get_move(0, 0);
                if (new_game())
                    break;
                continue;
            }
            for (auto [a, b] : x){
                cerr << a.first << ' ' << a.second << '\n';
            }
            cerr << '\n';
            for (int i = 0; i < n; i++)
                for (int j = 0; j < n; j++)
                    cerr << arr[i][j] << " \n"[j + 1 == n];

            pair<int, int> move;
            if (pnt == m || message[pnt++] == '0')
                move = x[0].first;
            else
                move = x[1].first;
            auto [xx, yy] = move;
            get_move(xx, yy);
            if (xx == 0 && yy == 0){
                if (new_game())
                    break;
                continue;
            }
        }
        else {
            int x, y;
            cin >> x >> y;
            paint(x - 1, y - 1);
            if (x == 1 && y == 1)
                new_game();
        }
        turn ^= 1;
    }
}

void solve2(){
    int games;
    cin >> games;
    string ans;
    while (games){
        int x, y;
        cin >> x >> y;
        --x, --y;
        if (turn == 1){
            paint(x, y);
            if (x == 0 && y == 0) {
                new_game(0);
                games--;
            }
            turn ^= 1;
            continue;
        }
        auto moves = get_moves();
        if (SZ(moves) == 1){
            new_game(0);
            games--;
            continue;
        }
        auto move = make_pair(x, y);
        paint(x, y);
        turn ^= 1;
        if (SZ(ans) == m)
            continue;
        if (move == moves[0].first)
            ans += '0';
        else
            ans += '1';
    }
    cout << ans << endl;
}

int main() {
    int t;
    cin >> t >> n >> k >> m;
    if (t == 1)
        solve1();
    else
        solve2();
    return 0;
}
