#include <bits/stdc++.h>

#define X first
#define Y second
#define endl '\n'
#define int long long

const int INF = 1e9;

using namespace std;


void solve(){
    int n, m;
    cin >> n >> m;
    string s;
    cin >> s;

    vector<vector<pair<int, int>>> arr(n);

    for (int i = 0; i < n; ++i){
        int k;
        cin >> k;
        arr[i].resize(k);
        for (int j = 0; j < k; ++j){
            int a;
            char c;
            cin >> a >> c;
            arr[i][j] = {a - 1, c};
        }
    }

    vector<int> bads(n), ans;
    vector<vector<int>> indexes(m);

    vector<bool> mask(m), used(n);

    for (int i = 0; i < n; ++i){
        for (auto e : arr[i]){
            if (s[e.X] != e.Y) {
                ++bads[i];
                indexes[e.X].push_back(i);
            }
        }
    }


    vector<int> goods;
    for (int i = 0; i < n; ++i){
        if (bads[i] == 0)
            goods.push_back(i);
    }


    int good_cnt = 0;
    int iter = 0;

    while (good_cnt < m || iter != n){
        int j = -1;

        if (!goods.empty()){
            j = goods.back();
            goods.pop_back();
        }

        if (j == -1){
            cout << -1;
            return;
        }

        ans.push_back(j + 1);

        used[j] = true;
        for (auto e : arr[j]) {
            if (!mask[e.X]){
                mask[e.X] = true;
                for (int i : indexes[e.X]){
                    --bads[i];
                    if (bads[i] == 0)
                        goods.push_back(i);

                }
                ++good_cnt;
            }
        }
        ++iter;
    }



    for (int i : ans)
        cout << i << " ";
}

signed main() {
    solve();
    return 0;
}
