#include <bits/stdc++.h>

using namespace std;

inline void input() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
#ifdef _DEBUG
    freopen("../src/input.txt", "r", stdin);
    freopen("../src/output.txt", "w", stdout);
#endif
}

int main() {
    input();
    int k, n;
    cin >> k >> n;
    vector<vector<int>> arr(k, vector<int>(k));
    for (int i = 0; i < k; i++) {
        string line;
        cin >> line;
        for (int j = 0; j < k; j++)
            arr[i][j] = line[j] == '1';
    }
    string s;
    cin >> s;
    // 0 -- not take, 1 -- take;
    string inf;
    for (int i = 0; i < n; i++)
        inf += 'z';
    vector<vector<vector<string>>> dp(n + 1, vector<vector<string>>(2, vector<string>(n + 1, inf)));
    vector<vector<int>> moves(n + 1);
    stack<int> st;
    st.push(n - 1);
    for (int i = n; i > 0; i--)
        moves[i].push_back(i - 1);
    for (int i = n - 2; i >= 0; i--){
        while (!st.empty() && arr[s[i] - 'a'][s[st.top()] - 'a']) {
            moves[st.top() + 1].push_back(i);
            st.pop();
        }
        st.push(i);
    }
    dp[0][1][1] = s[0];
    for (int i = 0; i < n; i++) {
        for (auto &j : moves[i]) {
            for (int len = 1; len <= n; len++){
                string temp = min(dp[j][0][len - 1] + s[i], dp[j][1][len - 1] + s[i]);
                dp[i][1][len] = min(dp[i][1][len], temp);
            }
        }
        for (auto &j : moves[i + 1]) {
            for (int len = 0; len <= n; len++){
                string temp = min(dp[j][0][len], dp[j][1][len]);
                dp[i][0][len] = min(dp[i][0][len], temp);
            }
        }
    }
    string ans = inf;
    for (int i = 0; i <= n; i++){
        ans = min(ans, dp[n - 1][0][i]);
        ans = min(ans, dp[n - 1][1][i]);
    }
    cout << ans;
    return 0;
}
