#include <bits/stdc++.h>

using namespace std;

inline void input() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
#ifdef _DEBUG
    freopen("../src/input.txt", "r", stdin);
    freopen("../src/output.txt", "w", stdout);
#endif
}

struct vertex {
    int l, r, i;

    bool operator<(const vertex &a) const {
        return l < a.l;
    }
};

bool ok;
vector<vector<int>> ans;

vertex dfs(vector<vector<int>> &g, vector<int> &val, int v) {
    vector<vertex> vs;
    for (auto &i : g[v])
        vs.push_back(dfs(g, val, i));
    sort(vs.begin(), vs.end());
    if (g[v].size() == 0) {
        vs = {{val[v], val[v], v}};
        ans[v] = {val[v]};
    } else {
        for (auto &i : vs)
            ans[v].push_back(i.i + 1);
    }
    for (int i = 1; i < vs.size(); i++)
        ok &= vs[i].l > vs[i - 1].r;
    return {vs.front().l, vs.back().r, v};
}

int main() {
    input();
    int n;
    cin >> n;
    int m = 0;
    vector<vector<int>> g(n);
    vector<pair<int, int>> up;
    for (int i = 0; i < n; i++) {
        int t, k;
        cin >> t >> k;
        if (t == 1) {
            g[i].resize(k);
            for (int j = 0; j < k; j++)
                cin >> g[i][j], --g[i][j];
        } else {
            m += k;
            for (int j = 0; j < k; j++) {
                int x;
                cin >> x;
                up.push_back({i, x});
            }
        }
    }
    for (int mask = 0; mask < (1 << m); mask++) {
        vector<int> val(n);
        bool flag = true;
        for (int j = 0; j < m; j++) {
            if (mask & (1 << j) && val[up[j].first] != 0)
                flag = false;
            else if (mask & (1 << j) && val[up[j].first] == 0) {
                val[up[j].first] = up[j].second;
            }
        }
        for (int i = 0; i < n; i++)
            if (g[i].size() == 0 && val[i] == 0)
                flag = false;
        if (flag) {
            ok = true;
            ans.clear();
            ans.resize(n);
            dfs(g, val, 0);
            if (ok) {
                cout << "Yes\n";
                for (auto &i : ans) {
                    for (auto &j : i)
                        cout << j << " ";
                    cout << "\n";
                }
                return 0;
            }
        }
    }
    cout << "No";
    return 0;
}
