#include <iostream>
#include <vector>
#include <set>
#include <cassert>
#include <string>
#include <algorithm>


using namespace std;


#pragma warning(disable:4996)
#define x first
#define y second

const int maxn = 1e5;


bool used[maxn];
bool oth[maxn];
vector<int> v[maxn];
int dist[maxn];


bool cmp(vector<pair<int, char>> &a, vector<pair<int, char>>& b) {
	return a.size() < b.size();
}


signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
#ifdef _DEBUG
	assert(freopen("input.txt", "r", stdin));
#endif
	int n, m;
	cin >> n >> m;
	string s;
	cin >> s;
	//cout << n << ' ' << m << endl;
	vector<vector<pair<int, char>>> t(n);
	vector<int> ans;
	set<pair<int, int>> th;
	for (int i = 0 ; i < n; i++) {
		int x;
		cin >> x;
		t[i].resize(x);
		for (int j = 0; j < x; j++) {
			int y;
			char x;
			cin >> y >> x;
			y--;
			t[i][j] = { y, x };
			if (s[y] != x) {
				dist[i]++;
				v[y].push_back(i);
			}
		}
		th.insert({dist[i], i});
	}
	bool f = 1;
	while (th.size()) {
		auto u = *th.begin();
		th.erase(th.begin());
		if (u.x != 0) {
			cout << -1;
			return 0;
		}
		ans.push_back(u.y);
		for (auto el : t[u.y]) {
			if (!used[el.x]) {
				used[el.x] = 1;
				for (int el2 : v[el.x]) {
					th.erase({dist[el2], el2});
					dist[el2]--;
					th.insert({dist[el2], el2});
				}
			}
		}
	}
	for (int i = 0; i < m; i++)
		if (!used[i]) {
			cout << -1;
			return 0;
		}
	for (int el : ans)
		cout << el + 1 << ' ';
	return 0;
}