#include <iostream>
#include <algorithm>
#include <math.h>
#include <vector>
#include <deque>
#include <string>
#include <set>

using namespace std;
using ll = long long;

#define ve vector
#define vll ve <ll>
#define look1(n) cerr << (#n) << ":" << n << "\n";
#define pb push_back
#define ft first
#define sd second


int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	ll n, m;
	cin >> n >> m;
	string s;
	cin >> s;
	ve <set <pair <ll, char> > > g(m);
	ve <ve <pair <ll, char>> > h(n);
	vll cnt(n);
	for (int i = 0; i < n; ++i) {
		ll k;
		cin >> k;
		while (k--) {
			ll ind;
			char c;
			cin >> ind >> c;
			h[i].push_back({ ind - 1, c });
			if (s[ind - 1] != c) {
				++cnt[i];
				g[ind - 1].insert({ i, c });
			}
		}
	}
	deque <ll> w;
	ve <bool> used(m);
	for (int i = 0; i < n; ++i) {
		if (!cnt[i]) {
			w.push_back(i);
		}
	}
	vll ans;
	while (!w.empty()) {
		ll v = w.front();
		ans.pb(v + 1);
		w.pop_front();
		for (auto it : h[v]) {
			if (!used[it.ft]) {
				used[it.ft] = 1;
				for (auto el : g[it.ft]) {
					--cnt[el.ft];
					if (cnt[el.ft] == 0) {
						w.pb(el.ft);
					}
				}
			}
		}
	}
	for (int i = 0; i < m; ++i) {
		if (!used[i]) {
			cout << -1;
			return 0;
		}
	}
	for (int i = 0; i < n; ++i) {
		cout << ans[i] << " ";
	}
	return 0;
}
