#include <bits/stdc++.h>
#define f first
#define s second
#define _ << ' ' <<
#define all(x) x.begin(), x.end()
#define time() clock() / CLOCKS_PER_SEC
#define mp make_pair

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

const int MAXN = 2e3 + 10, MAXK = 2e3 + 10;

vector<int> g[MAXN];
vector<int> upd[MAXN];
int dp1[MAXN][MAXK], dp2[MAXN][MAXK];

int n;

void dfs(int v) {
    fill(dp1[v], dp1[v] + MAXK, MAXK);
    fill(dp2[v], dp2[v] + MAXK, -1);
    if (g[v].size() == 0) {
        for (auto el : upd[v]) {
            dp1[v][el] = el;
            dp2[v][el] = el;
        }
    } else {
        int u1, u2;
        if (g[v].size() == 1) {
            u1 = g[v][0];
            for (int i = 0; i < MAXK; i++) {
                dp1[v][i] = dp1[u1][i];
                dp2[v][i] = dp2[u1][i];
            }
        } else {
            u1 = g[v][0];
            u2 = g[v][1];
            for (int i = 0; i < MAXK; i++) {
                int l1 = dp2[u1][i], r1 = dp1[u1][i];
                int l2 = dp2[u2][i], r2 = dp1[u2][i];
                dp1[v][l1] = min(dp1[v][l1], r2);
                dp1[v][l2] = min(dp1[v][l2], r1);
                dp2[v][r1] = max(dp2[v][r1], l2);
                dp2[v][r2] = max(dp2[v][r2], l1);
            }
        }
    }
    for (int i = MAXK - 2; i >= 0; i--) {
        dp1[v][i] = min(dp1[v][i + 1], dp1[v][i]);
    }
    for (int i = 1; i < MAXK; i++) {
        dp2[v][i] = max(dp2[v][i], dp2[v][i - 1]);
    }
}

void compress() {
    vector<int> b;
    for (int i = 0; i < n; i++){
        for (auto el : upd[i]) b.push_back(el);
    }
    sort(all(b));
    b.resize(unique(all(b)) - b.begin());
    for (int i = 0; i < n; i++) {
        for (auto &el : upd[i]) {
            el = lower_bound(all(b), el) - b.begin();
        }
    }
}

void solve() {
    cin >> n;
    int type, k;
    for (int i = 0; i < n; i++) {
        cin >> type >> k;
        if (type == 1) {
            g[i].resize(k);
            for (int j = 0; j < k; j++) {
                cin >> g[i][j];
                g[i][j]--;
            }
        } else {
            upd[i].resize(k);
            for (int j = 0; j < k; j++) cin >> upd[i][j];
        }
    }
    compress();
    dfs(0);
    if (dp1[0][0] != MAXK) {
        cout << "Yes";
    } else {
        cout << "No";
    }
}

signed main() {
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
    #endif // LOCAL

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int tests = 1;
    //cin >> tests;
    while (tests--) {
        solve();
    }
}

