#include <bits/stdc++.h>
#define f first
#define s second
#define _ << ' ' <<
#define all(x) x.begin(), x.end()
#define time() clock() / CLOCKS_PER_SEC
#define mp make_pair

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

const int MAXN = 2e3 + 10, MAXK = 2e3 + 10;

vector<int> g[MAXN];
vector<int> upd[MAXN];
int lef[MAXN], rig[MAXN];
vector<int> order[MAXN];

int n;

bool dfs(int v) {
    if (g[v].size() == 0) return 1;
    vector<pair<pii, int> > seg;
    for (auto to : g[v]) {
        if (!dfs(to)) return 0;
        seg.push_back(mp(mp(lef[to], rig[to]), to));
    }
    sort(all(seg));
    for (int i = 0; i < seg.size(); i++) order[v][i] = seg[i].s;
    for (int i = 1; i < seg.size(); i++) {
        if (seg[i].f.f < seg[i - 1].f.s) return 0;
    }
    lef[v] = seg[0].f.f;
    rig[v] = seg.back().f.s;
    return 1;
}

bool rec(int i) {
    if (i == n) {
        if (dfs(0)) {
            return 1;
        }
        return 0;
    }
    if (g[i].size() > 0) return rec(i + 1);
    for (int j = 0; j < upd[i].size(); j++) {
        order[i] = {j};
        lef[i] = upd[i][j];
        rig[i] = upd[i][j];
        if (rec(i + 1)) return 1;
    }
    return 0;
}

void compress() {
    vector<int> b;
    for (int i = 0; i < n; i++){
        for (auto el : upd[i]) b.push_back(el);
    }
    sort(all(b));
    b.resize(unique(all(b)) - b.begin());
    for (int i = 0; i < n; i++) {
        for (auto &el : upd[i]) {
            el = lower_bound(all(b), el) - b.begin();
        }
    }
}

void solve() {
    cin >> n;
    int type, k;
    for (int i = 0; i < n; i++) {
        cin >> type >> k;
        if (type == 1) {
            g[i].resize(k);
            for (int j = 0; j < k; j++) {
                cin >> g[i][j];
                g[i][j]--;
            }
        } else {
            upd[i].resize(k);
            for (int j = 0; j < k; j++) cin >> upd[i][j];
        }
        order[i].resize(k);
    }
    compress();
    if (!rec(0)) {
        cout << "No";
        return;
    }
    cout << "Yes\n";
    for (int i = 0; i < n; i++) {
        for (auto el : order[i]) cout << el + 1 << ' ';
        cout << '\n';
    }
}

signed main() {
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
    #endif // LOCAL

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int tests = 1;
    //cin >> tests;
    while (tests--) {
        solve();
    }
}

