#include <bits/stdc++.h>
using namespace std;

int main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    int n, m;
    cin >> n >> m;
    string st;
    cin >> st;

    vector<vector<pair<int, int>>> perf(n);
    vector<vector<int>> good(n);
    vector<vector<int>> bad(n);
    vector<vector<int>> have_bad(m);
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        while (k-- > 0) {
            int a;
            char b;
            cin >> a >> b;
            perf[i].push_back({a - 1, b});
            if (b == st[a - 1])
                good[i].push_back(a - 1);
            else {
                bad[i].push_back(a - 1);
                have_bad[a - 1].push_back(i);
            }
        }
    }

    vector<int> counter(n);
    map<int, set<int>> res;
    for (int i = 0; i < n; i++) {
        counter[i] = bad[i].size();
        res[counter[i]].insert(i);
    }

    vector<bool> closed(m, false);
    vector<bool> used(n, false);
    vector<int> ans(n, -100);
    for (int i = 0; i < n; i++) {
        if (!res[0].empty()) {
            int it = *res[0].begin();
            res[0].erase(it);
            ans[i] = it;
            used[it] = true;
            for (int g : good[it]) {
                if (!closed[g]) {
                    closed[g] = true;
                    for (int el : have_bad[g]) {
                        counter[el]--;
                        res[counter[el] + 1].erase(el);
                        res[counter[el]].insert(el);
                    }
                }
            }
        }
    }

    bool is = true;
    for (bool i : closed) {
        if (!i) {
            is = false;
            break;
        }
    }

    if (is) {
        for (int a : ans)
            cout << a + 1 << ' ';
    }
    else {
        cout << -1;
    }



    return 0;
}
