#include <bits/stdc++.h>
#include <random>
#include <ctime>

using namespace std;

typedef long long ll;
typedef long double ld;
#define mp make_pair
#define pb push_back
#define all(x) x.begin(), x.end()

inline void SOLVE() {
    int n, m;
    cin >> n >> m;
    vector<bool> used(m);
    vector<vector<int>> ban(m); // сли не текущей позиции стоит не нужная буква - такаие индексы храним
    vector<int> cnt(n); // сколько нехороших символов у текущей карты
    string s;
    cin >> s;
    vector<vector<int>> op(n);
    queue<int> q; // очередь хороших элементов
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        for (int j = 0; j < k; ++j) {
            int id;
            char c;
            cin >> id >> c;
            id--;
            op[i].pb(id);
            if (s[id] != c) {
                cnt[i]++;
                ban[id].pb(i);
            }
        }
    }
    // used - проверяем, что iый символ корректный
    for (int i = 0; i < n; ++i) {
        if (!cnt[i])
            q.push(i);
    }
    vector<int> ans;
    while (!q.empty()) {
        int v = q.front();
        ans.pb(v);
        q.pop();
        for (int u : op[v]) {
            if (!used[u]) {
                used[u] = true;
                while (!ban[u].empty()) {
                    int w = ban[u].back();
                    ban[u].pop_back();
                    cnt[w]--;
                    if (cnt[w] == 0)
                        q.push(w);
                }
            }
        }
    }
    bool f = true;
    for (int i = 0; i < m; ++i) {
        if (!used[i]) {
            f = false;
            break;
        }
    }
    if (!f) {
        cout << -1;
        return;
    }
    for (int e : ans) {
        cout << e + 1 << ' ';
    }
}

inline void FASTIO() {
    cin.tie(NULL);
    ios::sync_with_stdio(false);
}

int main() {
#ifdef GOSHA
    freopen("../IO/input.txt", "r", stdin);
    freopen("../IO/output.txt", "w", stdout);
#endif
    FASTIO();
    SOLVE();
}