#include <algorithm>
#include <iostream>
#include <string>
#include <vector>
#include <bitset>
#include <set>

#define all(x) (x).begin(), (x).end()

using namespace std;

typedef long long ll;

const ll cst = 5e5 + 5;
const ll inf = (ll)1e18 + 228;

ll n, k;

string s;

bool er[30][30];

vector<ll> p[26];
ll sm[26][cst];

ll cl[cst];

ll st[4 * cst];

ll pos = 0;

void upd(ll v, ll tl, ll tr, ll p, ll x) {
	if (tl == tr - 1) {
		st[v] = x;
		return;
	}
	ll tm((tl + tr) >> 1);
	if (p < tm) upd(2 * v, tl, tm, p, x);
	else upd(2 * v + 1, tm, tr, p, x);
	st[v] = max(st[2 * v], st[2 * v + 1]);
}

ll get(ll v, ll tl, ll tr, ll l, ll r) {
	if (l >= r) return 0;
	if (l == tl && r == tr) return st[v];
	ll tm((tl + tr) >> 1);
	ll g1 = get(2 * v, tl, tm, l, min(r, tm));
	ll g2 = get(2 * v + 1, tm, tr, max(l, tm), r);
	return max(g1, g2);
}

bool cc(ll j) {
	return pos + cl[pos] >= j;
}

ll gt(ll l, ll r, ll x) {
	if (l != 0) return sm[x][r] - sm[x][l - 1];
	else return sm[x][r];
}


int main() {
	cin.tie(0)->sync_with_stdio(0);
	cin >> k >> n;
	for (ll i = 0; i < k; i++) {
		for (ll j = 0; j < k; j++) {
			char c;
			cin >> c;
			er[i][j] = c - '0'; 
		}
	}
	cin >> s;
	for (ll i = 0; i < n; i++) {
		p[s[i] - 'a'].push_back(i);
		if (i != 0) {
			for (ll l = 0; l < k; l++) sm[l][i] = sm[l][i - 1];
		}
		sm[s[i] - 'a'][i]++;
	}
	upd(1, 0, n, n - 1, n - 1);
	for (ll i = n - 2; i >= 0; i--) {
		ll l = i, r = n;
		while (r - l > 1) {
			ll m((l + r) >> 1);
			bool ok = 1;
			for (ll lt = 0; lt < k; lt++) {
				ll kek = gt(i + 1, m, lt);
				if (!kek) continue;
				if (!er[s[i] - 'a'][lt]) {
					ok = 0;
					break;
				}
			}
			if (ok) l = m;
			else r = m;
		}
		cl[i] = max(0ll, get(1, 0, n, i, l + 1) - i);
		upd(1, 0, n, i, cl[i] + i);
	}
	string answ = "";
	answ.push_back(s[0]);
	for (ll i = 0; i < k; i++) reverse(all(p[i]));
	while (1) {
		if (cc(n - 1)) break;
		ll ps = -1;
		for (ll l = 0; l < k; l++) {
			while (p[l].size() && p[l].back() <= pos) p[l].pop_back();
			if (p[l].empty()) continue;
			if (cc(p[l].back() - 1)) {
				ps = p[l].back();
				break;
			}
		}
		answ.push_back(s[ps]);
		pos = ps;
	}
	cout << answ;
	return 0;
}





/*

3 7
010
001
100
abacabs

*/






