#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

#define all(a) a.begin(), a.end()

#define ll long long

#define pii pair<int, int>
#define ft first
#define sd second
#define mp make_pair

const int MAX_K = 26;

bool can[MAX_K][MAX_K];

struct my_string {
	string * s;
	my_string():
		s(nullptr)
	{};
	my_string(char c) {
		s = new string();
		s->push_back(c);
	}
	my_string(my_string old, char append) :
		s(old.s)
	{
		s->push_back(append);
	}

};

void solve() {
	int k, n;
	cin >> k >> n;
	for (int i = 0; i < k; i++) {
		string s;
		cin >> s;
		for (int j = 0; j < k; j++)
			can[i][j] = (s[j] == '1');
	}
	vector<int> vals;
	vals.reserve(n);
	for (int i = 0; i < n; i++) {
		char c;
		cin >> c;
		vals.push_back(c - 'a');
	}
	vector<vector<bool>> can_be_deleted(n + 1, vector<bool>(n + 1, false));
	for (int i = 0; i <= n; i++)
		can_be_deleted[i][i] = true;
	for (int i = 1; i < n; i++)
		if (can[vals[i - 1]][vals[i]])
			can_be_deleted[i][i + 1] = true;
	for (int len = 2; len < n; len++)
		for (int l = 1; l <= n - len; l++) {
			int r = l + len;
			for (int m = l; m < r; m++)
				if (can_be_deleted[l][m] && can_be_deleted[m + 1][r])
					if (can[vals[l - 1]][vals[m]]) {
						can_be_deleted[l][r] = true;
						break;
					}
		}
	vector<vector<int>> min_string(n);
	vector<vector<int>> ans_strings;
	min_string[0] = vector<int>(1, vals[0]);
	for (int i = 1; i < n; i++) {
		vector<vector<int>> strings;
		for (int j = 0; j < i; j++)
			if (can_be_deleted[j + 1][i]) {
				strings.push_back(vector<int>());
				for (int val : min_string[j])
					strings.back().push_back(val);
				strings.back().push_back(vals[i]);
			}
		sort(all(strings));
		min_string[i] = strings[0];
		if (can_be_deleted[i + 1][n])
			ans_strings.push_back(min_string[i]);
	}
	sort(all(ans_strings));
	for (int val : ans_strings[0])
		cout << (char)(val + 'a');
	
	/*
	vector<vector<int>> strings;
	char c;
	cin >> c;
	strings.push_back(vector<int>());
	strings[0].push_back(c - 'a');
	for (int i = 1; i < n; i++) {
		char c;
		cin >> c;
		c -= 'a';
		vector<vector<int>> newstrings;
		for (int j = 0; j < strings.size(); j++) {
			newstrings.push_back(vector<int>());
			for (int val : strings[j])
				newstrings.back().push_back(val);
			newstrings.back().push_back(c);
			while (newstrings.back().size() > 1 &&
				can[(*----newstrings.back().end())][(*--newstrings.back().end())]) {
				newstrings.push_back(vector<int>());
				for (int val : (*----newstrings.end()))
					newstrings.back().push_back(val);
				newstrings.back().pop_back();
			}
		}
		sort(all(newstrings));
		strings.clear();
		vector<bool> used(k);
		for (int i = 0; i < newstrings.size(); i++)
			if (!used[newstrings[i].back()]) {
				used[newstrings[i].back()] = true;
				strings.push_back(newstrings[i]);
			}
		newstrings.clear();
	}
	for (int val : strings[0])
		cout << (char)(val + 'a');*/
}

int32_t main()
{
	cin.tie(0);
	cout.tie(0);
	ios_base::sync_with_stdio(0);
	int t = 1;
	// cin >> t;
	while (t--)
		solve();
}
/*
3 7
010
001
100
abacaba
*/

/*
3 5
010
001
100
bcacb
*/