#include <iostream>
#include <iomanip>
#include <istream>
#include <ostream>
#include <vector>
#include <string>
#include <stack>
#include <queue>
#include <deque>
#include <bitset>
#include <array>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <algorithm>
#include <functional>
#include <random>
#include <chrono>
#include <time.h>
#include <limits>
#include <cmath>
#include <cassert>

using namespace std;

template<typename T1, typename T2> bool chkmin(T1& a, const T2& b) {if (b < a) {a = b; return 1;} return 0;}
template<typename T1, typename T2> bool chkmax(T1& a, const T2& b) {if (a < b) {a = b; return 1;} return 0;}

template<typename T1, typename T2> ostream& operator<< (ostream& out, const pair<T1, T2>& a) {
	out << "{" << a.first << ", " << a.second << "}";
	return out;
}

template<typename T> ostream& operator<< (ostream& out, const vector<T>& a) {
	for (auto k : a) {
		out << k << " ";
	}
	return out;
}

#define int long long 
#define pii pair<int, int>
#define pb push_back
#define ppb pop_back
#define all(a) a.begin(), a.end()

#ifdef LOCAL
	#define dbg(x) cout << #x << " : " << x << endl;
#else 
	#define dbg(x)
#endif

mt19937 gen(chrono::high_resolution_clock::now().time_since_epoch().count());

const int N = 1e5 + 10;

int n, m; 
string s;
vector<pair<int, char>> a[N];
vector<int> bad[N];
int badcnt[N];

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cin >> n >> m;
	cin >> s;
	queue<int> q;
	for (int i = 0; i < n; i++) {
		int sz;
		cin >> sz;
		a[i].resize(sz);
		for (int j = 0; j < sz; j++) {
			cin >> a[i][j].first >> a[i][j].second;
			a[i][j].first--;
			if (a[i][j].second != s[a[i][j].first]) {
				bad[a[i][j].first].pb(i);
				badcnt[i]++;
			}
		}
		if (badcnt[i] == 0) q.push(i);
	}
	vector<int> order;
	string have(m, '!');
	while (!q.empty()) {
		int ind = q.front();
		q.pop();
		order.pb(ind + 1);
		for (auto[pos, ch] : a[ind]) {
			if (have[pos] == '!') {
				have[pos] = ch;
				for (auto ind1 : bad[pos]) {
					badcnt[ind1]--;
					if (badcnt[ind1] == 0) {
						q.push(ind1);
					}
				}
			}
		}
	}
	if (have != s) cout << "-1\n";
	else cout << order << "\n";
}
/*
1 1
a
1 1 a

3 4
glhf
3 1 r 3 h 4 i
3 1 r 2 l 3 0 
2 1 g 4 f

2 2
aa
2 1 a 2 b 
2 1 b 2 a
*/