#include <iostream>
#include <string>
#include <vector>
#include <set>
using namespace std;

const int MAXN = 5e5 + 123;
const int MAXK = 27;
int k;
short f[MAXK][MAXK];

int get_rt(vector<int>& rt, int i){
	if(i < 0 || i >= rt.size() || rt[i] == i)
		return i;
	return rt[i] = get_rt(rt, rt[i]);
}

vector<int> find_lmn_(vector<int>& a){
	vector<int> ans;
	int n = a.size();
	for(int i = 0; i < n; ++i){
		while(ans.size() > 1 && ans.back() > a[i]){
			ans.pop_back();
		}
		ans.push_back(a[i]);
	}
	while(ans.size() >= 3 && ans.back() == ans[ans.size() - 2])
		ans.pop_back();
	return ans;
}

vector<int> find_lexmin(vector<int>& a){
	int n = a.size();
	if(n == 1)
		return a;
	vector<int> pv(n);
	vector<int> nt(n);
	for(int i = 0; i < n; ++i)
		pv[i] = nt[i] = i;
	set<int> st;
	for(int i = 1; i < n; ++i){
		if(f[a[i - 1]][a[i]])
			st.insert(i);
	}
	if(st.empty())
		return a;
	while(st.size()){
		int i = *st.rbegin();
		st.erase(prev(st.end()));
		nt[i] = i + 1;
		pv[i] = i - 1;
		int pvi = get_rt(pv, i);
		int nti = get_rt(nt, i);
		if(pvi != -1 && nti != n){
			if(f[a[pvi]][a[nti]])
				st.insert(nti);
		}
	}
	vector<int> ps;
	int i = 0;
	while(i < n){
		ps.push_back(i);
		i = get_rt(nt, i + 1);
	}
	vector<int> ans = {a[0]};
	for(int i = 0; i + 1 < ps.size(); ++i){
		vector<int> a_;
		for(int j = ps[i]; j <= ps[i + 1]; ++j){
			a_.push_back(a[j]);
		}
		vector<int> ans_ = find_lmn_(a_);
//		for(auto x : a_)
//			cout << char(x + 'a');
//		cout << endl;
//		for(auto x : ans_)
//			cout << char(x + 'a');
//		cout << " --- "<< endl;
		for(int j = 1; j < ans_.size(); ++j)
			ans.push_back(ans_[j]);
	}
	return ans;
}

signed main(){
	int n;
	cin >> k >> n;
	for(int i = 0; i < k; ++i){
		for(int j = 0; j < k; ++j){
			char c;
			cin >> c;
			if(c == '1')
				f[i][j] = 1;
		}
	}
	vector<int> a(n);
	for(int i = 0; i < n; ++i){
		char c;
		cin >> c;
		a[i] = (c - 'a');
	}
	vector<int> ans = find_lexmin(a);
	for(auto x : ans)
		cout << char('a' + x);
}
