#include <iostream>
using namespace std;

const int MAXN = 32;
const int MAXM = 2e5;
int n, k, m;
int f[MAXN][MAXN];
int w[MAXM];


void clr(int i, int j){
	for(int i_ = i; i_ < n; ++i_){
		for(int j_ = j; j_ < n; ++j_){
			f[i_][j_] = 1;
		}
	}
}

void turn_rbt(){
	int i, j;
	cin >> i >> j;
	--i, --j;
	clr(i, j);
}

signed main(){
	int l;
	cin >> l;
	cin >> n >> k >> m;
	for(int i = 0; i < m; ++i){
		char c;
		cin >> c;
		w[i] = (c == '1');
	}
	if(l == 1){
		int cps = 0;
		int ff = 0;
		while(true){
			if(cps == m){
				cout << 0 << endl;
				return 0;
			} 
			for(int i = 0; i < n; ++i)
				for(int j = 0; j < n; ++j)
					f[i][j] = 0;
			if(ff % 2){
				turn_rbt();
			}
			++ff;
			while(f[0][0] == 0){
				if(cps == m){
					cout << "1 1" << endl;
					clr(0, 0);
					break;
				}
				int sleft = 0;
				for(int i = 0; i < n; ++i){
					for(int j = 0; j < n; ++j){
						sleft += 1 - f[i][j];
					}
				}	
				if(sleft >= 4){
					for(int i = n - 1; i >= 0; --i){
						for(int j = n - 1; j >= 0; --j){
							if(f[i][j] == 0 && ((i + j) % 2) == w[cps]){
								cout << i + 1 << ' ' << j + 1 << endl;
								clr(i, j);
								break;
							}
						}
					}
					turn_rbt();
				} else {
					cout << "1 1" << endl;
					clr(0, 0);
					break;
				}
			}
		}
	} else {
		int p;
		cin >> p;
		int cps = 0;
		int ff = 0;
		while(cps < m && p){
			int i, j;
			cin >> i >> j;
			if(!ff && (i != 1 || j != 1)){
				w[cps] = (i + j) % 2;
				cps++;
			}
			++ff;
		}
		for(int i = 0; i < m; ++i){
			cout << w[i];
		}
	}
}
