#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
using ll =long long;

void play(ll nu, string &s, ll& t, ll n)
{
	vector<vector<ll>> a(n, vector<ll>(n, 0));
	if (nu == 2)
	{
		ll x, y; cin >> x >> y; --x, --y;
		for (int i = x; i < n; ++i)
			for (int j = y; j < n; ++j)
				a[i][j] = 1;
		if (a[0][0] == 1)
			return;
	}
	while (true)
	{
		if (t == s.size())
		{
			cout << 1 << ' ' << 1 << endl;
			return;
		}
		bool have = false;
		for (int x = n - 1; x >= 0; --x)
			for (int y = n - 1; y >= 0; --y)
				if ((x + y) % 2 == s[t] - '0' && (x+y!=0) && a[x][y] != 1)
				{
					cout << x + 1 << ' ' << y + 1 << endl;
					for (int i = x; i < n; ++i)
						for (int j = y; j < n; ++j)
							a[i][j] = 1;
					++t;
					have = true;
					x = -1;
					y = -1;
				}
		if (!have)
		{
			cout << 1 << ' ' << 1 << endl;
			return;
		}
		else
		{
			ll x, y; cin >> x >> y; --x, --y;
			for (int i = x; i < n; ++i)
				for (int j = y; j < n; ++j)
					a[i][j] = 1;
			if (a[0][0] == 1)
				return;
		}
	}
}

signed main()
{
	ll num; cin >> num;
	if (num == 1)
	{
		ll n, k, m; cin >> n >> k >> m;
		string s; cin >> s;
		ll t = 0;

		ll nu = 1;
		while (t < s.size())
		{
			play(nu, s, t, n);
			nu = (nu) % 2 + 1;
		}
		cout << 0 << endl;
	}
	else
	{
		ll n, k, m; cin >> n >> k >> m;
		string s;
		ll cnt; cin >> cnt;
		for (int i = 0; i < cnt; ++i)
		{
			ll x = n, y = n;
			ll nu = 0;
			while (x + y != 0)
			{
				cin >> x >> y; --x, --y;
				if (nu % 2 == i % 2)
				{
					if (x + y != 0)
						s.push_back((x + y) % 2 + '0');
				}
				nu++;
			}
		}
		cout << s.substr(0, m) << endl;
	}



	return 0;
}