#include <bits/stdc++.h>

using namespace std;

#define all(x) (x).begin(), (x).end()
#define ll long long
#define size(x) (int)(x).size()

int n, m;
string s;

const int maxn = 400000;
vector<int> adj[maxn];
vector<pair<int, char>> tt[maxn];

vector<int> deg;

signed main() {
#ifdef _LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin >> n >> m;
    cin >> s;
    deg.resize(n);
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        for (int j = 0; j < k; ++j) {
            int p;
            char c;
            cin >> p >> c;
            p--;
            tt[i].push_back({p, c});
            if (s[p] != c) {
                deg[i]++;
                adj[p].push_back(m + i);
            } else {
                adj[m + i].push_back(p);
            }
        }
    }

    queue<int> q;
    for (int i = 0; i < n; ++i) {
        if (deg[i] == 0) q.push(i);
    }
    vector<char> ss(m, '!');
    vector<int> ans;

    while (!q.empty()) {
        int v = q.front();
        q.pop();
        ans.push_back(v + 1);
        for (auto to : tt[v]) {
            if (ss[to.first] == '!') {
                ss[to.first] = to.second;
                for (auto it : adj[to.first]) {
                    int nxt = it - m;
                    deg[nxt]--;
                    if (deg[nxt] == 0) q.push(nxt);
                }
            }
        }
    }


    for (int i = 0; i < m; ++i) {
        if (ss[i] != s[i]) {
            cout << "-1\n";
            exit(0);
        }
    }
    for (int i = 0; i < size(ans); ++i) {
        cout << ans[i] << " ";
    }
    cout << "\n";
}
