//#pragma GCC optimize("O3", "Ofast", "unroll-loops", "unswitch-loops", "fast-math", "no-stack-protector")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,abm,mmx,avx,avx2,popcnt,tune=native")

#include <bits/stdc++.h>

using namespace std;

#define all(x) (x).begin(), (x).end()
#define ll long long
#define size(x) (int)(x).size()

int n, k, m;
string s;

pair<int, int> read() {
    int a, b;
    cin >> a >> b;
    return {a - 1, b - 1};
}

void out(pair<int, int> tk) {
    cout << tk.first + 1 << " " << tk.second + 1 << "\n";
    cout.flush();
}

void game(int &uk, int f) {
    vector<vector<int> > a(n, vector<int>(n, 0));
    while (a[0][0] == 0) {
        pair<int, int> tk;
        if (f == 1) {
            tk = read();
        } else {
            tk = {0, 0};
            if (uk == size(s)) {
                out(tk);
                return;
            }
            int mx = 0;
            for (int i = 0; i < n; ++i) {
                for (int j = 0; j < n; ++j) {
                    if ((i + j) % 2 == (s[uk] - '0') && i + j > mx && a[i][j] == 0) {
                        mx = i + j;
                        tk = {i, j};
                    }
                }
            }
            if (tk.first != 0 || tk.second != 0) uk++;
            out(tk);
        }
        for (int i = tk.first; i < n; ++i) {
            for (int j = tk.second; j < n; ++j) {
                a[i][j] = 1;
            }
        }
        f = (f + 1) % 2;
    }
}

signed main() {

    freopen("\\\\.\\pipe\\game.in", "r", stdin);
    freopen("\\\\.\\pipe\\game.out", "w", stdout);

    int t;
    cin >> t >> n >> k >> m;
    if (t == 1) {
        cin >> s;
        int uk = 0;
        int f = 0;
        while (uk < size(s)) {
            game(uk, f);
            f = (f + 1) % 2;
        }
        cout << "0\n";
        cout.flush();
    } else {
        string ans;
        int cnt;
        cin >> cnt;
        int f = 0;
        while (cnt != 0) {
            int a, b;
            cin >> a >> b;
            a--, b--;
            if (a == 0 && b == 0) cnt--;
            else {
                if (f == 0) {
                    ans.push_back((a + b) % 2 + '0');
                }
            }
            f = (f + 1) % 2;
        }
        cout << ans << "\n";
    }
}
