#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

vector < vector < char > > kek;

vector < int > p;
vector < bool > used;

int n, m;
string s;

bool check() {
	string res;
	for (int i = 0; i < m; i++) {
		int id = 0;
		while (id < n && kek[p[id]][i] == '#')
			id++;
		if (id == n)
			return false;
		res += kek[p[id]][i];
	}
	if (res == s) return true;
	return false;
}

void f() {
	if (p.size() == used.size()) {
		if (check()) {
			for (auto e : p)
				cout << e + 1 << " ";
			exit(0);
		}
		return;
	}

	for (int i = 0; i < used.size(); i++) {
		if (!used[i]) {
			used[i] = true;
			p.push_back(i);
			f();
			p.pop_back();
			used[i] = false;
		}
	}
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	cin >> n >> m;
	cin >> s;

	kek.assign(n, vector < char >(m, '#'));

	for (int i = 0; i < n; i++) {
		int k;
		cin >> k;
		int pos;
		char t;
		for (int j = 0; j < k; j++) {
			cin >> pos >> t;
			pos--;
			kek[i][pos] = t;
		}
	}
	used.assign(n, false);
	f();
	cout << -1;
}