#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int k, n;
	cin >> k >> n;
	vector < vector < char > > a(k, vector < char >(k, 0));
	for (int i = 0; i < k; i++)
		for (int j = 0; j < k; j++) cin >> a[i][j];

	string s;
	cin >> s;
	s += "#";

	vector < vector < int > > nearestpos(n, vector < int >(k, -1));
	vector < int > todel(n, -1);
	for (int i = 1; i < n; i++) {
		nearestpos[i] = nearestpos[i - 1];
		if (a[s[i - 1] - 'a'][s[i] - 'a'] == '1')
			nearestpos[i][s[i - 1] - 'a'] = i - 1;
		for (int j = 0; j < k; j++) {
			if (nearestpos[i][j] == -1) continue;
			if (a[j][s[i] - 'a'] == '1') todel[i] = max(todel[i], nearestpos[i][j]);
		}
	}

	int start = 0;
	int id = 0;
	string ans;
	while (id < n) {
		if (todel[id] == -1) {
			ans.push_back(s[id]);
			start = id;
			id++;
			continue;
		}

		int takepos = id;
		while (id < n && todel[id] >= start) {
			id++;
			if (s[id] < s[takepos]) takepos = id;
		}
		ans.push_back(s[takepos]);
		start = takepos;
		id = takepos + 1;
	}
	if (ans.back() == '#') ans.pop_back();
	cout << ans;
}