#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>

#define pb emplace_back
#define mp make_pair
#define fi first
#define se second
#define all(x) (x).begin(), (x).end()
#define out(x); { for (auto i : x) cout << i << ' '; cout << endl; }

using namespace std;

typedef long long ll;
typedef pair <int, int> pii;
typedef vector <int> vi;

const int N = 6e5;

int lg[N];
int f[33][33];
string s;
int it;
int n, m, k;

int get(int len) {
    //cout << "len " << len << endl;
    int x = 0;
    for (int i = it; i < s.size() && i < it + len; i++) {
        if (s[i] == '1')
            x += (1 << (i - it));
    }
    it += len;
    return x;
}

bool turn() {
    vi fd;
    unordered_map <int, pii> sq;
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= n; j++) {
            if (f[i][j] == 0) {
                fd.pb(i - j);
                sq[i - j] = mp(i, j);
            }
        }
    }
    sort(all(fd));
    fd.resize(unique(all(fd)) - fd.begin());
    //cout << "here" << endl;
    //cout << fd.size() << endl;
    //out(fd);

    int x = fd[get(lg[fd.size()])];
    //cout << x << endl;

    cout << sq[x].fi << " " << sq[x].se << endl;

    for (int i3 = sq[x].fi; i3 <= n; i3++) {
        for (int j3 = sq[x].se; j3 <= n; j3++)
            f[i3][j3] = 1;
    }

    return (sq[x].fi != 1 || sq[x].se != 1);
}

bool upd() {
    int i, j; cin >> i >> j;
    if (i == 1 && j == 1)
        return false;
    for (int i2 = i; i2 <= n; i2++) {
        for (int j2 = j; j2 <= n; j2++)
            f[i2][j2] = 1;
    }
    /*for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= n; j++)
            cerr << f[i][j] << " ";
        cerr << endl;
    }
    cerr << endl;*/
    return true;
}

void solve1() {
    for (int i = 2; i < N; i++)
        lg[i] = lg[i / 2] + 1;
    cin >> n >> k >> m;
    cin >> s;

    int gn = 0;
    while (it < s.size()) {
        for (int i = 1; i <= n; i++) {
            for (int j = 1; j <= n; j++)
                f[i][j] = 0;
        }
        if (gn % 2 == 0) {
            while (true) {
                if (!turn())
                    break;
                if (!upd())
                    break;
            }
        } else {
            while (true) {
                if (!upd())
                    break;
                if (!turn())
                    break;
            }
        }
        gn++;
        //cout << "new game" << endl;
        //cout << it << endl;
    }
    cout << 0 << endl;
}

void add(int x, int len) {
    //cout << "add " << x << " " << len << endl;
    for (int i = 0; i < len; i++) {
        if (x & (1 << i))
            s += "1";
        else
            s += "0";
    }
}

bool tspy() {
    //cout << "tspy" << endl;
    vi fd;
    unordered_map <int, pii> sq;
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= n; j++) {
            if (f[i][j] == 0) {
                fd.pb(i - j);
                sq[i - j] = mp(i, j);
            }
        }
    }
    sort(all(fd));
    fd.resize(unique(all(fd)) - fd.begin());

    int ti, tj; cin >> ti >> tj;

    for (int i3 = ti; i3 <= n; i3++) {
        for (int j3 = tj; j3 <= n; j3++)
            f[i3][j3] = 1;
    }

    //cout << "num " << num << endl;
    //out(fd);
    for (int i = 0; i < fd.size(); i++) {
        if (fd[i] == ti - tj)
            add(i, lg[fd.size()]);
    }
    return (ti != 1 || tj != 1);
}

void solve2() {
    for (int i = 2; i < N; i++)
        lg[i] = lg[i / 2] + 1;
    cin >> n >> k >> m;
    int g; cin >> g;

    for (int i = 0; i < g; i++) {
        for (int i = 1; i <= n; i++) {
            for (int j = 1; j <= n; j++)
                f[i][j] = 0;
        }
        if (i % 2 == 0) {
            while (true) {
                if (!tspy())
                    break;
                if (!upd())
                    break;
            }
        } else {
            while (true) {
                if (!upd())
                    break;
                if (!tspy())
                    break;
            }
        }
    }

    s.resize(m);
    cout << s << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    //freopen("\\\\.\\pipe\\game.in", "r", stdin);
    //freopen("\\\\.\\pipe\\game.out", "w", stdout);

    int t; cin >> t;
    if (t == 1) {
        solve1();
    } else {
        solve2();
    }
}
