#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <iomanip>
#include <algorithm>
#include <utility>
#include <deque>
#include <cassert>
using namespace std;
//#define int long long

void makeTurn(int x, int y, vector <vector <int>>& a) {
	for (int i = x; i < a.size(); ++i) {
		for (int j = y; j < a.size(); ++j) {
			a[i][j] = 1;
		}
	}
}

void goBot(vector <vector <int>>& a, bool& Ifirst) {
	int n = a.size();
	int x, y;
	cin >> x >> y;
	--x, --y;
	makeTurn(x, y, a);
	if (x == 0 && y == 0) {
		a.assign(n, vector <int>(n, 0));
		if (Ifirst == false) {
			Ifirst = true;
			goBot(a, Ifirst);
		}
		else {
			Ifirst = false;
		}
	}
}

void solve() {
	int subway;
	cin >> subway;
	if (subway == 1) {
		int n, k, m;
		cin >> n >> k >> m;
		string s;
		cin >> s;
		int ptr = 0;
		vector <vector <int>> a(n, vector <int>(n));
		bool Ifirst = false;
		while (ptr < s.size()) {
			int left = 0;
			for (int i = 0; i < n; ++i) {
				for (int j = 0; j < n; ++j) {
					if (a[i][j] == 0) {
						++left;
					}
				}
			}
			bool maxim = (left > 8 && left <= 16);
			int minf = 1e8, xf = 0, yf = 0;
			int it = 0;
			while (it++ <= 100) {
				int x = rand() % n, y = rand() % n;
				if ((x == 0 && y == 0) || a[x][y] == 1) continue;
				int f = 0;
				for (int i = x; i < n; ++i) {
					for (int j = y; j < n; ++j) {
						if (a[i][j] == 0) {
							++f;
						}
					}
				}
				if (f % 2 == (s[ptr] - '0') % 2) {
					if (f < minf && !maxim) {
						minf = f;
						xf = x;
						yf = y;
					}
					if (f > minf && maxim) {
						minf = f;
						xf = x;
						yf = y;
					}
				}
			}
			if (minf == 1e8) {
				cout << "1 1\n";
				cout.flush();
				a.assign(n, vector <int>(n, 0));
				if (Ifirst == false) {
					goBot(a, Ifirst);
				}
				Ifirst = !Ifirst;
			}
			else {
				cout << xf + 1 << " " << yf + 1 << "\n";
				++ptr;
				makeTurn(xf, yf, a);
				cout.flush();
				goBot(a, Ifirst);
			}
		}
		cout << "1 1\n";
		cout << "0\n";
		cout.flush();
	}
	else {
		//assert(false);
		int n, m, k, games;
		cin >> n >> m >> k >> games;
		int played = 0;
		vector <vector <int>> a(n, vector <int>(n));
		bool Ifirst = false;
		bool nowI = true;
		int x, y;
		string ans;
		while (true) {
			cin >> x >> y;
			--x, --y;
			if (x == 0 && y == 0) {
				nowI = Ifirst;
				a.assign(n, vector <int>(n));
				Ifirst = !Ifirst;
				++played;
				if (played == games) {
					break;
				}
			}
			else {
				if (nowI) {
					int f = 0;
					for (int i = x; i < n; ++i) {
						for (int j = y; j < n; ++j) {
							if (a[i][j] == 0) {
								++f;
							}
						}
					}

					ans += ('0' + f % 2);
					makeTurn(x, y, a);
				}
				else {
					makeTurn(x, y, a);
				}
				nowI = !nowI;
			}
		}
		//ans.pop_back();
		cout << ans << "\n";
	}
}

int32_t main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#ifdef _LOCAL
	//freopen("input.txt", "r", stdin);


#endif
	//freopen("\\\\.\\pipe\\game.in", "r", stdin);
	//freopen("\\\\.\\pipe\\game.out", "w", stdout);
	int test = 1;
	while (test--) {
		solve();
	}
}