#pragma GCC optimze("Ofast")
#include <bits/stdc++.h>

#define sq(x) ((x)*(x))
#define err(x) cerr << "["#x"]  " << (x) << '\n';
#define errv(x) {cerr << "["#x"]  ["; for (const auto& ___ : (x)) cerr << ___ << ", "; cerr << "]\n";}
#define errvn(x, n) {cerr << "["#x"]  ["; for (int ___ = 0; ___ < (n); ++___) cerr << (x)[___] << ", "; cerr << "]\n";}
#define errf() cerr << "\n\n";

using namespace std;

using ll = long long;
using ull = unsigned long long;
using ld = long double;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
inline ll getrnd(ll l, ll r) {
    return uniform_int_distribution<ll>(l, r)(rng);
}

template<typename T1, typename T2>
inline bool relax(T1& a, const T2& b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

template<typename T1, typename T2>
inline bool strain(T1& a, const T2& b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

// ::::::::::::::::::::::::

void solve() {
    int n, m;
    string s;
    cin >> n >> m >> s;

    vector<int> bad(n), wasind(m);
    vector<vector<int>> miss(m);
    vector<vector<pair<int, char>>> a(n);
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;

        for (int j = 0; j < k; ++j) {
            int pos;
            char c;
            cin >> pos >> c;
            --pos;

            wasind[pos] = 1;
            a[i].emplace_back(pos, c);
            if (s[pos] != c) {
                ++bad[i];
                miss[pos].emplace_back(i);
            }
        }
    }

    if (count(wasind.begin(), wasind.end(), 0) > 0) {
        cout << "-1\n";
        return;
    }

    vector<int> was(n);
    queue<int> scope;
    for (int i = 0; i < n; ++i)
        if (bad[i] == 0)
            scope.emplace(i), was[i] = 1;

    vector<int> ans;
    while (!scope.empty()) {
        int i = scope.front();
        scope.pop();
        ans.emplace_back(i);

        for (auto [pos, c] : a[i]) {
            for (int j : miss[pos]) {
                --bad[j];
                if (bad[j] == 0 && !was[j]) {
                    was[j] = 1;
                    scope.emplace(j);
                }
            }
            miss[pos].clear();
        }
    }

    if (ans.size() != n)
        cout << "-1\n";
    else {
        for (int x : ans)
            cout << x + 1 << ' ';
        cout << '\n';
    }
}

/*
3 4
glhf
3 1 r 3 h 4 i
3 1 r 2 l 3 o
2 1 g 4 f
*/

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);

    int t = 1;
//    cin >> t;
    while (t--)
        solve();

    return 0;
}

