#include <iostream>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <string>
#include <queue>
#include <deque>
#include <bitset>
#include <array>

#define ar array

using namespace std;
using ll=long long;
using ld=long double;

int k, n;
vector<vector<bool>> a;
vector<int> b;
string s;
vector<ar<ar<int,3>,26>> dp;

ar<int, 3> comp(ar<int, 3> x, ar<int, 3> y) {
	if (x[0]==0) return x;
	if (y[0]==0) return y;
	if (b[x[1]]<b[y[1]]) return x;
	if (b[x[1]]>b[y[1]]) return y;
	return comp(dp[x[2]][b[x[1]]],dp[y[2]][b[y[1]]]);
}

void solve() {
	cin >> k >> n;
	a.assign(k,vector<bool>(k));
	for (int i = 0; i < k; ++i) {
		for (int j = 0; j < k; ++j) {
			char c; cin >> c;
			a[i][j]=(c=='1'?1:0);
		}
	}
	b.resize(n+1); b[n]=0;
	cin >> s;
	for (int i=0; i<n; ++i) b[i]=s[i]-'a';
	dp.resize(n+1);
	for (int i=0; i<k; ++i) dp[n][i]={0,n,n};
	for (int i = n - 1; i > 0; --i) {
		for (int pr = 0; pr < k; ++pr) {
			// dp[i][pr]
			dp[i][pr]={dp[i+1][b[i]][0]+1,i,dp[i+1][b[i]][1]};
			ar<int,3> ans=dp[dp[i+1][b[i]][1]][b[i-1]];
			dp[i][pr]=comp(dp[i][pr],ans);
		}
	}
	vector<int> ans(0);
	ans.push_back(0);
	int prev=0, cur=dp[1][b[0]][1];
	while (cur<n) {
		ans.push_back(cur);
		int cur0=cur;
		cur=dp[cur][b[prev]][2];
		prev=cur0;
	}
	for (auto x : ans) cout << char(b[x]+static_cast<int>('a'));
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int test_case=1;
	for (int i = 0; i < test_case; ++i) {
		solve();
		cout << "\n";
	}
}