#include <iostream>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <string>
#include <queue>
#include <deque>
#include <bitset>
#include <array>

#define ar array

using namespace std;
using ll=long long;
using ld=long double;

int k, n;
vector<vector<bool>> a;
vector<int> b;

void solve() {
	cin >> k >> n;
	a.assign(k,vector<bool>(k));
	for (int i = 0; i < k; ++i) {
		for (int j = 0; j < k; ++j) {
			char c; cin >> c;
			a[i][j]=(c=='1'?1:0);
		}
	}
	string s; cin >> s;
	vector<string> dp(n+1); dp[n]="";
	for (int i = n - 1; i >= 0; --i) {
		vector<int> last={s[i]-'a'};
		dp[i]=dp[i+1];
		for (int j = i + 1; j < n; ++j) {
			bool ok=0;
			for (int t = last.size() - 1; t >= 0; --t) {
				if (a[last[t]][s[j] - 'a']) {
					ok=1;
					while(last.size()-1>t) last.pop_back();
					break;
				}
			}
			if (ok) {
				last.push_back(s[j]-'a');
				dp[i]=min(dp[i],dp[j+1]);
			}
			else break;
		}
		dp[i]=s[i]+dp[i];
	}
	cout << dp[0];
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int test_case=1;
	for (int i = 0; i < test_case; ++i) {
		solve();
		cout << "\n";
	}
}