#pragma comment(linker, "/STACK:10000000000")
#pragma GCC oprimize("O3")
#pragma GCC oprimize("Ofast")
#pragma GCC target("avx,avx2,fma")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;
using namespace std;

//const int MAX_MEM = 1e8;
//int mpos = 0;
//char mem[MAX_MEM];
//inline void * operator new (size_t n) {
//    assert((mpos += n) <= MAX_MEM);
//    return (void *) (mem + mpos - n);
//}
//inline void operator delete(void *) noexcept {}

#define int long long
#define sz(a) (int) (a).size()
#define all(a) (a).begin(), (a).end()
#define x first
#define y second
#define debug(x) cout << #x << ": " << x << '\n';
#define sqr(a) (a) * (a)

template<class t, class u> bool amax(t &a, u b) {if (a < b) {a = b; return true;} return false;}
template<class t, class u> bool amin(t &a, u b) {if (a > b) {a = b; return true;} return false;}
template<class t> using vc = vector<t>;
template<class t> using vvc = vector<vector<t>>;

using pi = pair<int, int>;
using vi = vc<int>;
using vpi = vc<pi>;

//mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
mt19937 rnd(6734043);

const int maxn = 100;

int n = 32, k, m;
int a[maxn][maxn];

void paint(int x, int y) {
    for (int i = x; i <= n; i++) {
        for (int j = y; j <= n; j++) {
            a[i][j] = 1;
        }
    }
}

int get_cnt() {
    int cnt = 0;
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= n; j++) {
            cnt += a[i][j] == 0;
        }
    }
    return cnt;
}

pi find_point(int num) {
    int cnt = 0;
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= n; j++) {
            cnt += a[i][j] == 0;
            if (cnt - 1 == num) return {i, j};
        }
    }
    return {-1, -1};
}

void ask(int x, int y = -1) {
    if (y == -1) cout << x << endl;
    else {
        cout << x << ' ' << y << endl;
        paint(x, y);
    }
}

pi read() {
    int x, y;
    cin >> x >> y;
    paint(x, y);
    return {x, y};
}

void solve1() {
    string s;
    cin >> s;
    int chet = 0;
    for (int i = 0; i < m; i++) {
        int bt = s[i] - '0';
        if (chet == 0) {
            if (bt == 0) {
                ask(1, 2);
                read();
                ask(2, 1);
                read();
            } else {
                ask(2, 1);
                read();
                ask(1, 2);
                read();
            }
        } else {
            if (bt == 0) {
                read();
                ask(1, 2);
                read();
                ask(2, 1);
                read();
            } else {
                read();
                ask(2, 1);
                read();
                ask(1, 2);
                read();
            }
        }
        chet ^= 1;
    }
    ask(0);
}

void solve2() {
    int chet = 0;
    int cnt_games;
    cin >> cnt_games;
    string ans;
    for (int i = 0; i < cnt_games; i++) {
        if (chet == 0) {
            pi res = read();
            read();
            read();
            read();
            if (res == pi{1, 2}) ans += '0';
            else ans += '1';
        } else {
            read();
            pi res = read();
            read();
            read();
            read();
            if (res == pi{1, 2}) ans += '0';
            else ans += '1';
        }
        chet ^= 1;
    }
    cout << ans << endl;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
//    freopen("\\\\.\\pipe\\game.in", "r", stdin);
//    freopen("\\\\.\\pipe\\game.out", "w", stdout);
    int game;
    cin >> game;
    cin >> n >> k >> m;
    if (game == 1) solve1();
    else solve2();

    return 0;
}