//#pragma GCC target ("avx2")
//#pragma GCC optimization ("O3")
//#pragma GCC optimization ("unroll-loops")

#include <iostream>
#include<vector>
#include<algorithm>
#include<string>

using namespace std;

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	int n, m;
	string s;
	cin >> n >> m >> s;
	vector<vector<int>> a(n);
	vector<vector<int>> symb(m);
	vector<int> left(n);
	vector<int> q;
	q.reserve(n);
	for (int i = 0; i < n; ++i) {
		int k;
		cin >> k;
		a[i].resize(k);
		for (int j = 0; j < k; ++j) {
			int temp1;
			char temp2;
			cin >> temp1 >> temp2;
			--temp1;
			a[i][j] = temp1;
			if (s[temp1] != temp2) {
				left[i]++;
				symb[temp1].push_back(i);
			}
		}
		if (left[i] == 0)
			q.push_back(i);
	}
	vector<int> ok(m);
	vector<int> res;
	res.reserve(n);
	while (!q.empty()) {
		int now = q.back();
		q.pop_back();
		for (int v : a[now]) {
			for (int t : symb[v]) {
				--left[t];
				if (left[t] == 0)
					q.push_back(t);
			}
			symb[v].clear();
			ok[v] = 1;
		}
		res.push_back(now);
	}
	bool ans = true;
	for (int i : ok)
		ans &= i;
	if (ans)
		for (int i : res)
			cout << i + 1 << ' ';
	else
		cout << -1;
}