#include <bits/stdc++.h>

using namespace std;

#define int long long
#define ft first
#define sd second
#define rs resize
#define all(a) a.begin(), a.end()

typedef long long ll;
typedef long double ld;

const int MN = 3e5 + 5, MC = 26;
ll n, dp[MN][MC], pref[MN][MC], p[MN][MC], sdp[MC];
vector<ll> val;

void clear(int n)
{
    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < MC; j++)
        {
            dp[i][j] = 0;
            p[i][j] = 0;
            pref[i][j] = 0;
        }
    }
}

ll get_val(string s)
{
    ll res = 0;
    char mx = 'A';
    for (int i = (int)(s.size()) - 1; i >= 0; i--)
    {
        if (s[i] < mx)
        {
            res -= val[s[i] - 'A'];
        }
        else
        {
            res += val[s[i] - 'A'];
        }
        mx = max(mx, s[i]);
    }
    return res;
}

ll get_lost(int l, int r, int c)
{
    if (l < 0 || r < l)
    {
        return 0;
    }
    if (l == 0)
    {
        return pref[r][c];
    }
    return pref[r][c] - pref[l - 1][c];
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ll temp = 1;
    for (int i = 0; i < 13; i++)
    {
        val.push_back(temp);
        val.push_back(temp * 5);
        temp *= 10;
    }
    int t;
    cin >> t;
    while (t--)
    {
        string s;
        cin >> s;
        n = s.size();
        vector<int> arr;
        for (int i = 0; i < n; i++)
        {
            for (int j = 0; j < MC; j++)
            {
                if (i == 0)
                {
                    pref[i][j] = 0;
                }
                else
                {
                    pref[i][j] = pref[i - 1][j];
                }
            }
            if (s[i] != '?')
            {
                for (int j = s[i] - 'A' + 1; j < MC; j++)
                {
                    pref[i][j] += val[s[i] - 'A'];
                }
            }
            else
            {
                arr.push_back(i);
            }
        }
        if (arr.size() == 0)
        {
            cout << get_val(s) << "\n" << s << "\n";
            // clear(s.size());
            continue;
        }
        int mx = 0;
        for (int i = s.size() - 1; i > arr.back(); i--)
        {
            mx = max(mx, (ll)(s[i] - 'A'));
        }
        for (int j = mx; j < MC; j++)
        {
            dp[0][j] = val[j] - get_lost(0, arr[0] - 1, j);
            p[0][j] = -1;
        }
        sdp[MC - 1] = MC - 1;
        for (int j = MC - 2; j >= mx; j--)
        {
            sdp[j] = sdp[j + 1];
            if (dp[0][j] > dp[0][sdp[j]])
            {
                sdp[j] = j;
            }
        }
        for (int i = 1; i < arr.size(); i++)
        {
            for (int j = mx; j < MC; j++)
            {
                p[i][j] = sdp[j];
                dp[i][j] = dp[i - 1][sdp[j]] + val[j] - get_lost(arr[i - 1] + 1, arr[i] - 1, j);
            }
            sdp[MC - 1] = MC - 1;
            for (int j = MC - 2; j >= mx; j--)
            {
                sdp[j] = sdp[j + 1];
                if (dp[i][j] > dp[i][sdp[j]])
                {
                    sdp[j] = j;
                }
            }
        }
        int i = arr.size() - 1, x = sdp[0];
        while (x != -1)
        {
            s[arr[i]] = 'A' + x;
            x = p[i][x];
            i--;
        }
        cout << get_val(s) << "\n" << s << "\n";
        // clear(s.size());
    }
    return 0;
}

