#include <bits/stdc++.h>

using namespace std;

//#define int long long
#define ft first
#define sd second
#define rs resize
#define all(a) a.begin(), a.end()

typedef long long ll;
typedef long double ld;

const int MN = 1e5 + 5;
int n, q, x[MN], h[MN];

int get_ans(int l, int r)
{
    int ans = 0;
    stack<pair<int, int>> st; // {x, h}
    for (int i = l; i <= r; i++)
    {
        int left = x[max(0, l - 1)], right = x[min(n - 1, r + 1)];
        if (st.size() > 0)
        {
            left = st.top().ft;
        }
        if (i < r)
        {
            right = x[i + 1];
        }
        if (h[i] <= max(x[i] - left, right - x[i]))
        {
            ans++;
            while (!st.empty() && right - st.top().ft >= st.top().sd)
            {
                ans++;
                st.pop();
            }
        }
        else
        {
            st.push({x[i], h[i]});
        }
    }
    return ans;
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> q;
    for (int i = 0; i < n; i++)
    {
        cin >> x[i] >> h[i];
    }
    while (q--)
    {
        int l, r;
        cin >> l >> r;
        l--; r--;
        cout << get_ans(l, r) << "\n";
    }
    return 0;
}
