#include <bits/stdc++.h>
#define int long long

using namespace std;
const int maxn = 3e5;
const int inf = 1e9+7;
vector <pair <int,int> > gr[maxn];
vector <int> mi(maxn, 1e9+1);
vector <int> ma(maxn, -1);
vector <int> used(maxn,0);
vector <int> dist(maxn, inf);
set <pair <int, int > > st;

void relax(int u, int v, int c){
    if (min(dist[u],c) < dist[v]){
        st.erase(make_pair(dist[v],v));
        dist[v] = min(dist[u],c);
        st.insert(make_pair(dist[v],v));
    }
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n,m;
    cin >> n >> m;
    for (int i = 0; i < m;++i){
        int u,v,c;
        cin >> u >> v >> c;
        gr[u-1].push_back(make_pair(v-1,c));
        gr[v-1].push_back(make_pair(u-1,c));
    }
    for (int i = 1; i < n;++i){
        st.insert(make_pair(inf, i));
    }
    used[0] = 1;
    for (auto v : gr[0]){
        relax(0,v.first,v.second);
    }
    while ((int) st.size() > 0){
        set <pair <int, int> >::iterator it = st.begin();
        auto t = *it;
        st.erase(t);
        for (auto v : gr[t.second]){
            relax(t.second, v.first, v.second);
        }
    }
    for (int i = 1; i < n;++i){
        cout << inf-7+dist[i] << endl;
    }
    return 0;
}
