#include<bits/stdc++.h>
using namespace std;
#define ll long long
#define ld long double
#define pii pair<int, int>
#define all(a) (a).begin(), (a).end()

const int N = 3e5 + 10;
struct edge {
	int u, v, t;

	int most;

	edge() {}
	edge(int u_, int v_, int t_) {
		u = u_, v = v_, t = t_;
		most = 0;
	}
	void input() {
		cin >> u >> v >> t;
		u--, v--;
		most = 0;
	}
	int get(int from) {
		if (u == from) return v;
		return u;
	}
};
bool operator<(edge a, edge b) {
	return a.t < b.t;
}

edge e[N];
int n, m;
vector<int> g[N];



int ans[N];
void go(int u, int p, int mn, int mx) {
	ans[u] = mn + mx;

	for (auto i : g[u]) {
		int to = e[i].get(u);
		if (to == p) continue;
		go(to, u, min(mn, e[i].t), max(mx, e[i].t));
	}
}
void solve_tree() {
	go(0, 0, 1e9, 0);
	for (int i = 1; i < n; i++) {
		cout << ans[i] << '\n';
	}
	cout << '\n';	
}

void solve_0() {
	vector<int> dmax(n, 1e9);
	// dmax[0] = 1e9;

	set<pii> djk;
	djk.insert({0, 0});
	while (!djk.empty()) {
		pii p = *djk.begin();
		djk.erase(djk.begin());
		if (dmax[p.second] <= p.first) continue;
		dmax[p.second] = p.first;
		for (auto i : g[p.second]) {
			djk.insert({max(p.first, e[i].t), e[i].get(p.second)});
		}	
	}

	for (int i = 1; i < n; i++) {
		cout << dmax[i] << '\n';
	}
}




int used[N];
int tin[N];
int tup[N];
int tmr;

void dfs(int u, int p) {
	used[u] = 1;
	tin[u] = tmr++;
	tup[u] = tin[u];
	for (auto i : g[u]) {
		int to = e[i].get(u);
		if (to == p) continue;

		if (used[to]) {
			if (tin[to] < tin[u]) {
				tup[u] = min(tup[u], tup[to]);
			} else {

			}
		} else {
			dfs(to, u);
			tup[u] = min(tup[u], tup[to]);
			if (tup[to] > tin[u]) {
				e[i].most = 1;
			}
		}
	}
}

int clr[N];
void color(int u, int cl) {
	if (clr[u] != 0) return;
	clr[u] = cl;
	for (auto i : g[u]) {
		if (e[i].most == 1) continue;

		color(e[i].get(u), cl);
	}
}

int mreb[N];

int anss[N];

vector<pii> gg[N];

void ansver(int u, int p, int mn) {
	mn = min(mn, mreb[u]);
	anss[u] = mn;

	for (auto i : gg[u]) {
		if (i.first == p) continue;
		ansver(i.first, u, min(mn, i.second));
	}
}

void solve_1e9() {
	// assert(0);
	dfs(0, 0);

	for (int i = 0; i < n; i++) {
		if (clr[i] == 0) {
			color(i, i + 1);
		}
	}


	for (int i = 0; i < N; i++) {
		mreb[i] = 1e9;
	}
	for (int i = 0; i < m; i++) {
		if (e[i].most == 0) {
			mreb[clr[e[i].u]] = min(mreb[clr[e[i].u]], e[i].t);
		} else {
			gg[clr[e[i].u]].push_back({clr[e[i].v], e[i].t});
			gg[clr[e[i].v]].push_back({clr[e[i].u], e[i].t});
		}
	}

	// for (int i = 0; i <= n; i++) {
	// 	cout << mreb[i] << '\n';
	// }

	ansver(clr[0], clr[0], 1e9);

	// assert(0);

	cout << fixed << setprecision(0);

	for (int i = 1; i < n; i++) {
		cout << anss[clr[i]] + 1e9 << '\n';
	}

	// for (int i = 0; i < m; i++) {
	// 	cout << e[i].u + 1 << ' ' << e[i].v + 1 << ' ' << e[i].most << '\n';
	// }
	// cout << '\n';
}


signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);

	cin >> n >> m;
	for (int i = 0; i < m; i++) {
		e[i].input();
		g[e[i].u].push_back(i);
		g[e[i].v].push_back(i);
	}

	// solve_1e9();
	// return 0;

	if (n == m + 1) {
		solve_tree();
		return 0;
	}

	bool f1 = 1, f2 = 1;
	for (auto i : g[0]) {
		if (e[i].t != 0) f1 = 0;
		if (e[i].t != 1e9) f2 = 0;
	}

	if (f1) {
		solve_0();
		return 0;
	}
	if (f2) {
		solve_1e9();
		return 0;
	}


	return 0;
}
