#include <bits/stdc++.h>

using namespace std;

#define ld long double
#define all(x) x.begin(), x.end()
#define int long long

int n, q;
vector<int> x, h, rz1, rz2;
const int inf = 1e18;


void erase(int id) {
    rz1[id] = -inf;
    rz2[id] = -inf;
    int left_close = -1;
    int right_close = -1;

    for (int i = id; i < n; ++i) {
        if (rz1[i] != -inf) {
            right_close = i;
            break;
        }
    }
    for(int i = 0; i < id; ++i){
        if(rz1[i] != -inf){
            left_close = i;
            break;
        }
    }
    if(left_close == -1 && right_close == -1)return;
    if(left_close == -1){
        rz2[right_close] = x[right_close] - x[0] - h[right_close];
    }else if(right_close == -1){
        rz1[left_close] = x[n - 1] - x[left_close] - h[left_close];
    }else{
        rz2[right_close] = x[right_close] - x[left_close] - h[right_close];
        rz1[left_close] = x[right_close] - x[left_close] - h[left_close];
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >> n >> q;
    x.resize(n);
    h.resize(n);
    rz1.resize(n, -inf);
    rz2.resize(n, -inf);
    for (int i = 0; i < n; ++i) cin >> x[i] >> h[i];
    while (q--) {
        int l, r;
        cin >> l >> r;
        --l, --r;
        for (int i = 0; i < n - 1; ++i) {
            rz1[i] = x[i + 1] - x[i] - h[i];
        }
        for (int i = 1; i < n; ++i) {
            rz2[i] = x[i] - h[i] - x[i - 1];
        }
        rz1[n - 1] = -h[n - 1];
        rz2[0] = -h[0];

        bool can_erase = true;
        int er = 0;
        while (can_erase) {
            can_erase = false;
            ++er;
            for (int i = l; i <= r; ++i) {
                if (rz1[i] >= 0) {
                    erase(i);
                    can_erase = true;
                    break;
                }
            }
            if (!can_erase) {
                for (int i = l; i <= r; ++i) {
                    if (rz2[i] >= 0) {
                        erase(i);
                        can_erase = true;
                        break;
                    }
                }
            }
        }
        cout << er - 1 << '\n';
    }
}