#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <assert.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
const ll INF = (ll)1e18;
const double PI = acos(-1.0);

const int MAX_N = 300005;
int n, m;
pair<pair<int, int>, int> ed[MAX_N];
int dpmax[MAX_N], dpmin[MAX_N];

int main()
{
	//freopen(".in", "r", stdin);
	//freopen(".out", "w", stdout);
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	cin >> n >> m;
	for (int i = 0; i < m; i++)
	{
		cin >> ed[i].first.first >> ed[i].first.second >> ed[i].second;
	}

	for (int i = 1; i <= n; i++)
	{
		dpmax[i] = dpmin[i] = -1;
	}
	dpmin[1] = (int)2e9;
	dpmax[1] = -2;
	bool flag = 1;
	int a, b, t;
	int nwmin, nwmax;
	while (flag)
	{
		flag = 0;
		for (int i = 0; i < m; i++)
		{
			a = ed[i].first.first;
			b = ed[i].first.second;
			t = ed[i].second;

			if (dpmin[b] == -1 && dpmin[a] != -1)
			{
				nwmin = min(dpmin[a], t);
				nwmax = max(dpmax[a], t);
				dpmin[b] = nwmin;
				dpmax[b] = nwmax;
				flag = 1;
			}
			else if (dpmin[b] != -1 && dpmin[a] == -1)
			{
				nwmin = min(dpmin[b], t);
				nwmax = max(dpmax[b], t);
				dpmin[a] = nwmin;
				dpmax[a] = nwmax;
				flag = 1;
			}
			else if (dpmin[b] != -1 && dpmin[a] != -1)
			{
				nwmin = min(dpmin[a], t);
				nwmax = max(dpmax[a], t);
				if (dpmax[b] + dpmin[b] > nwmin + nwmax)
				{
					dpmin[b] = nwmin;
					dpmax[b] = nwmax;
					flag = 1;
				}
				nwmin = min(dpmin[b], t);
				nwmax = max(dpmax[b], t);
				if (dpmax[a] + dpmin[a] > nwmin + nwmax)
				{
					dpmin[a] = nwmin;
					dpmax[a] = nwmax;
					flag = 1;
				}
			}
		}
	}

	for (int i = 2; i <= n; i++)
	{
		cout << dpmin[i] + dpmax[i] << endl;
	}

	return 0;
}