#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <assert.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
const ll INF = (ll)1e18;
const double PI = acos(-1.0);

const int MAX_N = 300005;
int n, m;
pair<int, pair<int, int>> ed[MAX_N];
int dpmin[MAX_N];

int main()
{
	//freopen(".in", "r", stdin);
	//freopen(".out", "w", stdout);
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	cin >> n >> m;
	for (int i = 0; i < m; i++)
	{
		cin >> ed[i].second.first >> ed[i].second.second >> ed[i].first;
	}
	sort(ed, ed + m);
	reverse(ed, ed + m);

	for (int i = 1; i <= n; i++)
	{
		dpmin[i] = 1e9;
	}
	int a, b, t;
	int nwmin;
	for (int i = 0; i < m; i++)
	{
		a = ed[i].second.first;
		b = ed[i].second.second;
		t = ed[i].first;

		nwmin = min(dpmin[a], t);
		if (dpmin[b] > nwmin)
		{
			dpmin[b] = nwmin;
		}
		nwmin = min(dpmin[b], t);
		if (dpmin[a] > nwmin)
		{
			dpmin[a] = nwmin;
		}
	}

	for (int i = 2; i <= n; i++)
	{
		cout << dpmin[i] + (int)1e9 << endl;
	}

	return 0;
}