#ifdef _MSC_VER
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <iomanip>
#include <cassert>
#include <ctime>
#include <random>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <deque>
#else
#include <bits/stdc++.h>
#include <bits/extc++.h>
#endif

#define all(q) q.begin(), q.end()

using namespace std;
using ll = long long;
constexpr int MAXN = 20;
constexpr int INF = (int)2e9 + 57;
bool dp[1 << MAXN][MAXN];
int cost[1 << MAXN];
int et[MAXN];
vector<pair<int, int>> g[MAXN];

int main(int argc, char *argv[]) {
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	int n, m;
	cin >> n >> m;
	for (int i = 0; i < m; ++i) {
		int u, v, t;
		cin >> u >> v >> t;
		--u, --v;
		g[u].emplace_back(v, i);
		g[v].emplace_back(u, i);
		et[i] = t;
	}

	dp[0][0] = true;
	for (int mask = 0; mask < (1 << m); ++mask)
		for (int v = 0; v < n; ++v)
			for (const auto &[u, e] : g[v])
				if (mask & (1 << e))
					dp[mask][v] |= dp[mask ^ (1 << e)][u];

	for (int mask = 0; mask < (1 << m); ++mask) {
		int mint = INF;
		int maxt = 0;
		for (int e = 0; e < m; ++e) {
			if (mask & (1 << e)) {
				mint = min(mint, et[e]);
				maxt = max(maxt, et[e]);
			}
		}
		cost[mask] = mint + maxt;
	}

	for (int v = 1; v < n; ++v) {
		int dist = INF;
		for (int mask = 0; mask < (1 << m); ++mask)
			if (dp[mask][v])
				dist = min(dist, cost[mask]);
		cout << dist << '\n';
	}

	return 0;
}