#include <bits/stdc++.h>

using namespace std;
//#define int long long
#define pb push_back
#define f first
#define s second
#define pii pair<int,int>
const int MAX_N = 1e5 + 7;
int par1[MAX_N], par2[MAX_N];

int n, q;

int get1(int v) {
    if (v == -1 || v == n || v == par1[v])return v;
    return par1[v] = get1(par1[v]);
}

int get2(int v) {
    if (v == -1 || v == n || v == par2[v])return v;
    return par2[v] = get2(par2[v]);
}

int a[MAX_N], h[MAX_N];
bool banned[MAX_N];
int cnt = 0;

void solve(int l, int r, int lef, int rig, int pos) {
    if (pos < l || pos > r)return;
    if (lef == -1) {
        if (rig == n)return;
        if (a[rig] - a[pos] >= h[pos]) {
            cnt++;
            banned[pos] = true;
            par1[pos] = lef, par2[pos] = rig;
            par1[rig] = lef;
            solve(l, r, lef, get2(rig + 1), rig);
        }
    } else if (rig == n) {
        if (a[pos] - a[lef] >= h[pos]) {
            cnt++;
            banned[pos] = true;
            par1[pos] = lef, par2[pos] = rig;
            par2[lef] = rig;
            solve(l, r, get1(lef - 1), rig, lef);
        }
    } else {
        if (a[rig] - a[pos] >= h[pos]) {
            cnt++;
            banned[pos] = true;
            par1[pos] = lef, par2[pos] = rig;
            par1[rig] = lef,par2[lef] = rig;
            solve(l, r, lef, get2(rig + 1), rig);
            solve(l, r, get1(lef - 1), rig, lef);
        } else if (a[pos] - a[lef] >= h[pos]) {
            cnt++;
            banned[pos] = true;
            par1[pos] = lef, par2[pos] = rig;
            par1[rig] = lef,par2[lef] = rig;
            solve(l, r, lef, get2(rig + 1), rig);
            solve(l, r, get1(lef - 1), rig, lef);
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie();
    cin >> n >> q;
    for (int i = 0; i < n; ++i) {
        cin >> a[i] >> h[i];
    }
    while (q--) {
        int l, r;
        cin >> l >> r;
        l--, r--;
        for (int i = 0; i < n; ++i) {
            par1[i] = par2[i] = i;
        }
        cnt = 0;
        fill(banned, banned + n, false);
        for (int i = l; i <= r; ++i) {
            if (banned[i])continue;
            solve(l, r, get1(i - 1), get2(i + 1), i);
        }
        cout << cnt << endl;
    }
    /*3 3
    1 3
    3 1
    4 2
    1 1
    2 3
    1 3*/
}
