#include <bits/stdc++.h> 

#define pb push_back

#define pii pair<int, int>

#define ff first 
#define ss second 

//#define int long long

#define all(x) (x).begin(), (x).end()    

using namespace std; 

typedef long long ll; 

const int maxn = 3e5 + 7; 
const ll inf = 2e9; 
int n, m; 
vector<pii> gr[maxn]; 
 
struct edge {
    int u, v, w; 
}; 

int res[maxn]; 

void solve() {
    cin >> n >> m; 
    for (int i = 0; i < n; ++i) {
        res[i] = inf; 
    }
    vector<edge> e; 
    for (int i = 0; i < m; ++i) {
        int u, v, t; cin >> u >> v >> t, --u, --v;
        e.pb({u, v, t}); 
    }
    vector<int> perm;
    for (int i = 0; i < m; ++i) {
        perm.pb(i); 
    }        
    while (true) {
        int last = 0; 
        int mn = inf; 
        int mx = -inf; 
        for (int i = 0; i < m; ++i) {
            edge tet = e[perm[i]];
            if (tet.u != last) swap(tet.u, tet.v); 
            if (tet.u != last) break;  
            mn = min(mn, tet.w); 
            mx = max(mx, tet.w); 
            last = tet.v; 
            res[last] = min(res[last], mn + mx); 
        }
        bool ok = next_permutation(all(perm)); 
        if (!ok) break; 
    }                 
    for (int i = 1; i < n; ++i) {
        cout << res[i] << '\n'; 
    }
}                                        

signed main() {
#ifdef LOCAL
  freopen("TASK.in", "r", stdin); 
  freopen("TASK.out", "w", stdout);
#endif

    ios_base::sync_with_stdio(false); 
    cin.tie(0);

    int t = 1; 
    for (int i = 0; i < t; ++i) {
        solve(); 
    }
    return 0; 
}