#include <bits/stdc++.h> 

#define pb push_back

#define pii pair<int, int>

#define ff first 
#define ss second 

//#define int long long

#define all(x) (x).begin(), (x).end()    

using namespace std; 

typedef long long ll; 

const int maxn = 3e5 + 7; 
const ll inf = 2e9; 
int n, m; 
vector<pii> gr[maxn]; 
 
struct edge {
    int v, w, id; 
}; 

int res[maxn]; 
const int L = 20; 
int dp[1 << L][L];  

vector<edge> to[maxn]; 

void solve() {
    cin >> n >> m; 
    for (int i = 0; i < n; ++i) {
        res[i] = inf; 
    }
    vector<int> e; 
    for (int i = 0; i < m; ++i) {
        int u, v, t; cin >> u >> v >> t, --u, --v;
        e.pb(t); 
        to[u].pb({v, t, i}); 
        to[v].pb({u, t, i}); 
    }
    for (int i = 0; i < (1 << m); ++i) {
        for (int j = 0; j  < n; ++j) {
            dp[i][j] = inf; 
        }
    }
    dp[0][0] = 0; 
    for (int mask = 0; mask < (1 << m); ++mask) {
        int mn = inf; 
        int mx = -inf; 
        for (int i = 0; i < m; ++i) {
            if ((mask >> i) & 1) {
                mn = min(mn, e[i]); 
                mx = max(mx, e[i]); 
            }                            
        }
        for (int last = 0; last < n; ++last) {
            if (dp[mask][last] == inf) continue; 
            for (auto v : to[last]) {
                int id = v.id; 
                if ((mask >> id) & 1) continue; 
                dp[mask ^ (1 << id)][v.v] = min(dp[mask ^ (1 << id)][v.v], min(mn, v.w) + max(mx, v.w));  
            }       
        }
    }
    for (int i = 1; i < n; ++i) {
        for (int mask = 0; mask < (1 << m); ++mask) {
            res[i] = min(res[i], dp[mask][i]); 
        }
    }
    for (int i = 1; i < n; ++i) {
        cout << res[i] << '\n'; 
    }
}                                        

signed main() {
#ifdef LOCAL
  freopen("TASK.in", "r", stdin); 
  freopen("TASK.out", "w", stdout);
#endif

    ios_base::sync_with_stdio(false); 
    cin.tie(0);

    int t = 1; 
    for (int i = 0; i < t; ++i) {
        solve(); 
    }
    return 0; 
}