#include <bits/stdc++.h>

using namespace std;
#define MAXN 5005
int x[MAXN];
int h[MAXN];
vector<int> need_l[MAXN];
vector<int> need_r[MAXN];
int n;
void pre() {
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            if (x[j] < x[i] + h[i]) {
                need_r[i].push_back(j);
            } else {
                break;
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = i - 1; j >= 0; --j) {
            if (x[i] + h[i] < x[j]) {
                need_l[i].push_back(j);
            } else {
                break;
            }
        }
    }
}

int solve(int from, int to) {
    set<int> done;
    while (true) {
        int pos = -1;
        for (int i = from; i < to; ++i) {
            if (done.count(i)) {
                continue;
            }
            bool f = true;
            for (auto e:need_l[i]) {
                if (!done.count(e)) {
                    f = false;
                    break;
                }
            }
            if (f && x[i] - h[i] >= x[0]) {
                pos = i;
                break;
            }
            f = true;
            for (auto e:need_r[i]) {
                if (!done.count(e)) {
                    f = false;
                    break;
                }
            }
            if (f &&  x[i] + h[i] <= x[n-1]) {
                pos = i;
                break;
            }
        }
        if (pos == -1) {
            break;
        } else {
            done.insert(pos);
        }
    }
    return done.size();
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int  q;
    cin >> n >> q;
    for (int i = 0; i < n; ++i) {
        cin >> x[i] >> h[i];
    }
    pre();
    for (int i = 0; i < q; ++i) {
        int _l, _r;
        cin >> _l >> _r;
        _l--;
        cout << solve(_l, _r) << "\n";
    }
    return 0;
}
