#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif // LOCAL

#include <bits/stdc++.h>
#define int long long
#define all(a) (a).begin(), (a).end()
typedef long long ll;
using namespace std;

const int INF = 1e18;

int f(int x) {
    vector<int> a(24);
    a[0] = 1;
    for (int i = 1; i < a.size(); ++i) {
        a[i] = a[i - 1] * 10;
    }
    if (x % 2 == 1) {
        return 5 * a[x / 2];
    } else {
        return a[x / 2];
    }
}

int str_to_int(string s) {
    int res = 0;
    char Max = '$';
    int n = s.size();
    for (int i = n - 1; i >= 0; --i) {
        Max = max(Max, s[i]);
        if (s[i] == Max) {
            res += f(s[i] - 'A');
        } else {
            res -= f(s[i] - 'A');
        }
    }
    //cout << s << ' ' << res << endl;
    return res;
}

signed main() {
#ifdef LOCAL
    freopen("input", "r", stdin);
    freopen("output", "w", stdout);
#else
    ios_base::sync_with_stdio(0);cin.tie(0);
#endif // LOCAL

    int q;
    cin >> q;
    while (q--) {
        string s;
        cin >> s;
        int n = s.size();
        //cout << str_to_int(s) << '\n' << s << '\n';
        int maxn = 26;
        vector<string> seg;
        string tmp = "";
        vector<int> pos;
        for (int i = 0; i < n; ++i) {
            if (s[i] == '?') {
                seg.emplace_back(tmp);
                pos.emplace_back(i);
                tmp.clear();
            } else {
                tmp += s[i];
            }
        }
        seg.emplace_back(tmp);
        //pos.emplace_back(n);
        int k = seg.size();
        vector<vector<int>> dp(k + 1, vector<int> (maxn, -INF));
        vector<vector<int>> pr(k + 1, vector<int> (maxn, -INF));
        dp[0][maxn - 1] = 0;
        for (int i = 1; i < k; ++i) {
            for (int j = 0; j < maxn; ++j) {
                for (int x = j; x < maxn; ++x) {
                    string t_str = seg[i - 1] + char(j + 'A');
                    //cout << t_str << endl;
                    int tmp = dp[i - 1][x] + str_to_int(t_str);
                    if (dp[i][j] < tmp) {
                        dp[i][j] = tmp;
                        pr[i][j] = x;
                    }
                }
                //cout << dp[i][j] << ' ';
            }
            //cout << endl;
        }
        int cur = -1, res = -INF;
        for (int i = 0; i < maxn; ++i) {
            if (dp[k - 1][i] > res) {
                res = dp[k - 1][i];
                cur = i;
            }
        }
        res += str_to_int(seg.back());
        for (int i = k - 1; i > 0; --i) {
            //cout << cur << ' ' << pos[i - 1] << endl;
            s[pos[i - 1]] = char('A' + cur);
            cur = pr[i][cur];
        }
        cout << res << '\n';
        cout << s << '\n';
    }
    return 0;
}
