#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

#define int ll
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define fs first
#define sc second
#define MP make_pair
#define pb push_back
#define sz(x) (int)x.size()

#ifdef FlameDragon
    mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
#else
    mt19937 rng(5235);
#endif

const int N = 2e5 + 10;
vector<pair<int, int>> g[N];

struct Ans {
    int a, b, c, d;
};
int n, m;
vector<Ans> ans;
int used[N];
vector<int> in[N], out[N];

void gg() {
    cout << "No\n";
    exit(0);
}

void dfs(int v, int p) {
    used[v] = true;
    for (auto &[u, c] : g[v]) {
        if (u == p) continue;
        if (c == 1) {
            out[v].push_back(u);
        } else {
            in[v].push_back(u);
        }
        if (!used[u]) {
            dfs(u, v);
        }
        if (sz(in[u]) && c == 0){
            ans.push_back({in[u].back(), u, u, v});
            in[v].pop_back();
            in[u].pop_back();
        }
        if (sz(out[u]) && c == 1) {
            ans.push_back({v, u, u, out[u].back()});
            out[v].pop_back();
            out[u].pop_back();
        }
    }
    while (sz(in[v]) && sz(out[v])) {
        ans.push_back({in[v].back(), v, v, out[v].back()});
        in[v].pop_back();
        out[v].pop_back();
    }
}

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
#ifdef FlameDragon
    freopen("in.txt", "r", stdin);
#endif
    cin >> n >> m;
    for (int i = 0; i < m; i++) {
        int v, u;
        cin >> v >> u;
        v--; u--;
        g[v].push_back(make_pair(u, 1));
        g[u].push_back(make_pair(v, 0));
    }
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            dfs(i, -1);
        }
    }
    if (sz(ans) != m / 2) {
        gg();
    }
    cout << "Yes\n";
    for (auto e : ans) {
        cout << e.a + 1 << ' ' << e.b + 1 << ' ' << e.c + 1 << ' ' << e.d + 1 << '\n';
    }
}
