#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_map>
#include <string>

using namespace std;
//#define int long long
#pragma GCC optimize("Ofast")
#define forn(i, n) for(int i = 0; i < (int)n; i++)
#define firn(i, n) for(int i = 1; i < (int)n; i++)
const int maxn = 3e5;
vector<pair<int, int>> g1[maxn], g2[maxn];
vector<int>g[maxn];
int used[maxn], dist[maxn], used2[maxn];
int cnt = 0;
vector<pair<pair<int, int>, pair<int, int>>>ans;
vector<int>used3;
void dfs(int v) {
	used[v] = 1;
	for (auto u : g[v]) {
		if (!used[u]) {
			dist[u] = dist[v] + 1;
			dfs(u);
		}
	}
}
void dfs2(int v) {
	used2[v] = 1;
	for (auto u : g[v]) {
		if (!used2[u]) {	
			dfs2(u);
		}
	}
	
	int l = 0;
	int r = 0;
	while (l < (int)g1[v].size()) {
		if (dist[v] > dist[g1[v][l].first] || used3[g1[v][l].second] == 0) {
			l++;
			if (l == (int)g1[v].size()) {
				break;
			}
			continue;
		}
		while (r < (int)g2[v].size()) {
			if (dist[v] > dist[g2[v][r].first] || used3[g2[v][r].second] == 0) {
				r++;
			}
			else {
				break;
			}
		}
		if (r < (int)g2[v].size()) {
			pair<int, int>ed1, ed2;
			ed1.first = v;
			ed1.second = g1[v][l].first;
			ed2.second = v;
			ed2.first = g2[v][r].first;
			used3[g1[v][l].second] = 0;
			used3[g2[v][r].second] = 0;
			ans.push_back({ ed1, ed2 });
			l++;
			r++;
		}
		else {
			break;
		}

	}
	int ind1 = -1;
	forn(i, g1[v].size()){
		if (dist[v] < dist[g1[v][i].first] && used3[g1[v][i].second] == 1) {
			ind1 = i;
		}
	}
	if (ind1 != -1) {
		forn(i, g2[v].size()) {
			if (used3[g2[v][i].second] == 1) {
				pair<int, int>ed1, ed2;
				ed1.first = v;
				ed1.second = g1[v][ind1].first;
				ed2.second = v;
				ed2.first = g2[v][i].first;
				used3[g1[v][ind1].second] = 0;
				used3[g2[v][i].second] == 1;
				ans.push_back({ ed1, ed2 });
			}
		}
	}
	else {
		int ind2 = -1;
		forn(i, g2[v].size()) {
			if (dist[v] < dist[g2[v][i].first] && used3[g2[v][i].second] == 1) {
				ind2 = i;
				break;
			}
		}
		if (ind2 != -1) {
			forn(i, g1[v].size()) {
				if (used3[g1[v][i].second] == 1) {

					pair<int, int>ed1, ed2;
					ed1.first = v;
					ed1.second = g1[v][i].first;
					ed2.second = v;
					ed2.first = g2[v][ind2].first;
					used3[g1[v][i].second] = 0;
					used3[g2[v][ind2].second] = 0;
					ans.push_back({ ed1, ed2 });
				}
			}
		}
	}
}
signed main() {
	cin.tie(NULL);
	ios_base::sync_with_stdio(false);
	cout.tie(NULL);
	int n, m;
	map<pair<int, int>, int> mp2;
	
	cin >> n >> m;
	int t = 0;
	forn(i, m) {
		int u, v;
		cin >> u >> v;
		u--;
		v--;
		g1[u].push_back({ v, t });
		g2[v].push_back({ u, t });
		used3[t] = 1;
		t++;
		if (mp2[{u, v}] == 0) {
			mp2[{u, v }] = 1;
			
			mp2[{v, u }] = 1;
			
			g[u].push_back(v);
			g[v].push_back(u);
		}
	}
	
	forn(i, n) {
		if (!used[i]) {
			dfs(i);
			dfs2(i);
		}
	}
	
	if (ans.size() != m / 2) {
		cout << "No";
		return 0;
	}
	cout << "Yes" << '\n';
	forn(i, m / 2) {
		cout << ans[i].first.first + 1 << " " << ans[i].first.second + 1 << " " << ans[i].second.first + 1 << " " << ans[i].second.second + 1 << '\n';
	}
	
	return 0;
}