#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <string>

using namespace std;
#define int long long
#define forn(i, n) for(int i = 0; i < (int)n; i++)
#define firn(i, n) for(int i = 1; i < (int)n; i++)
vector<vector<pair<int, int>>>g;
vector<int>ma, mi, used;
void dfs(int v) {
	used[v] = 1;
	for (auto u : g[v]) {
		if (!used[u.first]) {
			ma[u.first] = max(ma[v], u.second);
			mi[u.first] = min(mi[v], u.second);
			dfs(u.first);
		}
	}
}
signed main() {
	int n, m;
	cin >> n >> m;
	g.resize(n);
	mi.resize(n,1e9);
	ma.resize(n,-1e9);
	used.resize(n);
	forn(i, m) {
		int u, v, t;
		cin >> u >> v >> t;
		u--;
		v--;
		g[v].push_back({ u, t });
		g[u].push_back({ v, t });

	}
	//dfs(0);
	vector<int>dist(n, 1e9);
	dist[0] = 0;
	set<pair<int, int>>s;
	s.insert({ 0, 0 });
	while (!s.empty()) {
		auto x = *s.begin();
		int v = x.second;
		s.erase(x);
		used[v] = 1;
		for (auto u : g[v]) {
			if (dist[u.first] > u.second && dist[u.first] > dist[v]) {
				s.erase({ dist[u.first], u.first });
				dist[u.first] = max(u.second, dist[v]);
				s.insert({ dist[u.first], u.first });
			}
		}
	}
	firn(i, n) {
		cout << dist[i] << '\n';
	}
	return 0;
}