#include <bits/stdc++.h>
  
using namespace std;
  
#define all(a) a.begin(), a.end()
#define int long long
#define size(a) (int) a.size()
#define fi first
#define se second
#define pii pair<int, int>
#define mp make_pair
#define chkmin(a, b) a = min(a, b)
const int inf = 2e9 + 8;
const int max_n = 5e5 + 3;
int n, m;
 
vector<pii> gr[max_n];
int dp[max_n];
 
void solve() {
    cin >> n >> m;
    for(int i = 0;i < m;i++) {
        int v1, v2, c;
        cin >> v1 >> v2 >> c;
        gr[--v1].emplace_back(--v2, c);
        gr[v2].emplace_back(v1, c);
    }
 
    auto comp = [&](int v1, int v2) {
        return mp(dp[v1], v1) < mp(dp[v2], v2);
    };
 
    set<int, decltype(comp)> so(comp);
    for(int i = 0;i < n;i++)
        dp[i] = inf;
 
    so.emplace(0);
 
    while(size(so)) {
        int v = *so.begin();
        so.erase(so.begin());
 
        for(pii to : gr[v]) {
            if (dp[to.fi] > min(dp[v], to.se)) {
                so.erase(to.fi);
                dp[to.fi] = min(dp[v], to.se);
                so.emplace(to.fi);
            }
        }
    }
 
    for(int i = 1; i < n;i++)
        cout << dp[i] + 1e9 << endl;
}   
 
 
signed main() {
    cin.tie(0), cout.tie(0), ios_base::sync_with_stdio(0);
  
    #ifdef local
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    #endif
  
    solve();
}