#include <bits/stdc++.h>

using namespace std;

void solve();

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
#endif
    solve();
    return 0;
}

#define int long long

const int N = 5e5 + 100, K = 26, INF = 2e18;

int n, q;
vector<pair<int, int>> a;
bool used[N];

void solve() {
    cin >> n >> q;
    a.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i].first >> a[i].second;
    }
    set<pair<int, int>> se;
    for (int i = 0; i < n; i++) {
        se.insert({a[i].first, i});
    }
    int l, r, ans, ds;
    while (q--) {
        cin >> l >> r;
        l--, r--;
        ans = 0;
        for (int i = 0; i < n; i++) {
            se.insert({a[i].first, i});
        }
        set<int> ss;
        for (int i = l; i <= r; i++) {
            ds = 0;
            if (i > 0) ds = max(ds, a[i].first - a[i - 1].first);
            if (i + 1 < n) ds = max(ds, a[i + 1].first - a[i].first);
            if (ds >= a[i].second) {
                ss.insert(i);
            }
        }
        while (!ss.empty()) {
            int cur = *ss.begin();
            ss.erase(ss.begin());
            auto it = se.upper_bound({a[cur].first, INF});
            int pos1 = -1, pos2 = -1;
            ds = 0;
            if (it != se.end()) {
                if (it->first - a[cur].first >= a[it->second].second) {
                    pos2 = it->second;
                }
                ds = max(ds, it->first - a[cur].first);
            } else {
                ds = max(ds, a[n - 1].first - a[cur].first);
            }
            it--;
            if (it != se.begin()) {
                it--;
                if (a[cur].first - it->first >= a[it->second].second) {
                    pos1 = it->second;
                }
                ds = max(ds, a[cur].first - it->first);
            } else {
                ds = max(ds, a[cur].first - a[0].first);
            }
            if (ds >= a[cur].second) {
                se.erase({a[cur].first, cur});
                ans++;
                if (pos1 != -1 && pos1 >= l) {
                    ss.insert(pos1);
                }
                if (pos2 != -1 && pos2 <= r) {
                    ss.insert(pos2);
                }
            }
        }
        cout << ans << '\n';
    }
}