#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <cstdlib>
#include <string>
#include <ctime>
#include <stack>
#include <set>


using namespace std;


#define int long long
#define ll long long
#define all(a) a.begin(), a.end()


int n, m;
vector<vector<int>> g;
vector<vector<int>> t;
vector<vector<int>> nmb;
vector<int> res;
vector<int> ts;
vector<vector<int>> nxt;




void get_res() {
	for (int i = 0; i < n; ++i) {
		sort(all(nxt[i]));
	}
	int _mn = 1e9;
	int _mx = 0;
	for (int i = 0; i < n; ++i) {
		res[i] = 2e9;
		int mn = _mn;
		int mx = _mx;
		for (int j = i; j < n; ++j) {
			res[i] = min(res[i], mn + mx);
			if (nxt[j].size() <= 1 || j == n - 1) {
				break;
			}
			mn = min(mn, nxt[j][0]);
			mx = max(mx, nxt[j][1]);
		}
		if (i < n - 1) {
			_mn = min(_mn, nxt[i][0]);
			_mx = max(_mx, nxt[i][0]);
		}
	}
}



int32_t main() {
	cin >> n >> m;
	g.resize(n);
	t.resize(n);
	res.resize(n);
	ts.resize(m);
	nmb.resize(n);
	for (int i = 0; i < m; ++i) {
		int u, v, tm;
		cin >> u >> v >> tm;
		ts[i] = tm;
		--u;
		--v;
		if (u > v) {
			swap(u, v);
		}
		g[u].push_back(v);
		t[u].push_back(tm);
		g[v].push_back(u);
		t[v].push_back(tm);
		nmb[v].push_back(i);
		nmb[u].push_back(i);
		nxt[u].push_back(tm);
	}
	get_res();
	for (int i = 1; i < n; ++i) {
		cout << res[i] << "\n";
	}
}

/*
3 3
1 2 2
1 3 1
2 3 1
*/