#include <bits/stdc++.h>

#define int long long
#define pb push_back
#define pii pair<int, int>

using namespace std;

const int inf = 1e9 + 10;

int n, m;
vector<vector<pii>> g;
vector<int> d, used;

void solve() {
	cin >> n >> m;
	g.resize(n);
	for (int i = 0; i < m; i++) {
		int a, b, x;
		cin >> a >> b >> x;
		a--; b--;
		g[a].pb({b, x});
		g[b].pb({a, x});
	}
	used.assign(n, 0);
	d.assign(n, inf);
	d[0] = 0;
	set<pii> q;
	for (int i = 0; i < n; i++) {
		q.insert({d[i], i});
	}
	while (!q.empty()) {
		pii t = *q.begin();
		q.erase(q.begin());

		// cout << t.second << " : " << t.first << endl;

		used[t.second] = 1;
		for (auto e : g[t.second]) {
			if (!used[e.first]) {
				int nd = min(e.second, d[t.second]);
				if (nd < d[e.first]) {
					q.erase({d[e.first], e.first});
					d[e.first] = nd;
					q.insert({d[e.first], e.first});
				}
			}
		}
	}
	for (int i = 1; i < n; i++) {
		cout << d[i] + (int) (1e9)<< "\n";
	}
}

signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	solve();

	return 0;
}
