#include <bits/stdc++.h>

#define int long long
#define pb push_back
#define pii pair<int, int>

using namespace std;

struct reb {
	int to, w, i;
	reb() {}
	reb(int to_, int w_, int u_) {
		to = to_;
		w = w_;
		i = u_;
	}
};

int n, m;
vector<vector<reb>> g;
vector<int> ans;
vector<int> u;
multiset<int> q;

void dfs(int v) {
	if (q.size() > 0) {
		auto it = q.end();
		it--;
		ans[v] = min(ans[v], (*(q.begin()) + *(it)));
	}
	for (auto e : g[v]) {
		if (!u[e.i]) {
			u[e.i] = 1;
			q.insert(e.w);
			dfs(e.to);
			q.erase(q.find(e.w));
			u[e.i] = 0;
		}
	}
}

void solve() {
	cin >> n >> m;
	g.resize(n);
	for (int i = 0; i < m; i++) {
		int a, b, x;
		cin >> a >> b >> x;
		a--; b--;
		g[a].pb(reb(b, x, i));
		g[b].pb(reb(a, x, i));
	}
	u.assign(m, 0);
	ans.assign(n, 3 * 1e9);

	dfs(0);

	for (int i = 1; i < n; i++) {
		cout << ans[i] << "\n";
	}
}

signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	solve();

	return 0;
}
