#include <bits/stdc++.h>
 
#define int long long
 
using namespace std;
 
const int MAXN = 1 << 5; 

array<int, MAXN * 2> sect;
array<int, MAXN * 2> mem;

void push(int i) {
    if (mem[i] == -1) return;
    sect[i] = mem[i];
    if (i >= MAXN) {
        return;
    }
    mem[i * 2] = mem[i];
    mem[i * 2 + 1] = mem[i];
    mem[i] = -1;
}

void upd(int i, int l, int r, int lq, int rq, int d) {
    push(i);
    if(lq <= l && r <= rq) {
        mem[i] = d;
        push(i);
        return;
    }
    if(rq <= l || r <= lq) {
        return;
    }
    int m = (r + l) / 2;
    upd(i * 2, l, m, lq, rq, d);
    upd(i * 2 + 1, m, r, lq, rq, d);
    sect[i] = sect[i * 2] + sect[i * 2 + 1];
}

int get(int i, int l, int r, int lq, int rq) {
    push(i);
    if (lq <= l && r <= rq) {
        return sect[i];
    }
    if (r <= lq || rq <= l) {
        return 0;
    }
    int m = (r + l) / 2;
    return get(i * 2, l, m, lq, rq) + get(i * 2 + 1, m, r, lq, rq);
}

const int INF = 1e18 + 10;

int fastpow(int a, int n) {
    if (n == 0) return 1;
    if (n % 2 == 0) {
        int x = fastpow(a, n / 2);
        return x * x;
    } else {
        return fastpow(a, n - 1) * a;
    }
}

int getval(int num) {
    if (num % 2 == 0) {
        return fastpow(10, num / 2);
    } else {
        return 5 * fastpow(10, num / 2);
    }
}

void solve() {
    string s;
    cin >> s;
    int n = s.size();
    int sumplus = 0;
    int summinus = 0;
    for (int i = 0; i < n; ++i) {
        int num = s[i] - 'A';
        sumplus -= get(1, 0, MAXN, 0, num);
        summinus += get(1, 0, MAXN, 0, num);
        upd(1, 0, MAXN, 0, num, 0);
        upd(1, 0, MAXN, num, num + 1, get(1, 0, MAXN, num, num + 1) + getval(num));
        sumplus += getval(num);
        cout << sumplus << ' ' << summinus << ' ' << i << endl;
    }
    // for (int i = 0; i < 64; ++i) {
    //     cout << sect[i] << ' ' << mem[i] << i << endl;
    // }
    upd(1, 0, MAXN, 0, 26, 0);
    cout << sumplus - summinus << '\n';
    cout << s << '\n';
}
 
signed main() {
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}