#include <bits/stdc++.h>

using namespace std;

const int MAXN = 3e5 + 10;

array<vector<pair<int, int>>, MAXN> graph;
array<int, MAXN> ans;
array<int, MAXN> used;

void dfs(int vertex, int mn, int mx) {
    used[vertex] = 1;
    ans[vertex] = mn + mx;
    for (auto [elem, w] : graph[vertex]) {
        if (!used[elem]) {
            dfs(elem, min(mn, w), max(mx, w));
        }
    }
}

signed main() {
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        int u, v, t;
        cin >> u >> v >> t;
        u--;v--;
        graph[u].push_back({v, t});
        graph[v].push_back({u, t});
    }
    dfs(0, 1e9 + 10, -1e9);
    for (int i = 1; i< n; ++i) {
        cout << ans[i] << endl;
    }
    return 0;
}