#include <bits/stdc++.h>

using namespace std;

void IO() {
#ifdef DIVAN
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
}

#define all(x) x.begin(), x.end()
#define sz(x) ((int)x.size())
#define forn(i, n) for (int i = 0; i < (n); ++i)
#define eb emplace_back
#define vi vector<int>
#define pi pair<int,int>
#define vpi vector<pi>

typedef long long ll;


const int INF = 2139062143;
const int nINF = -2139062144;
const ll INFL = 9187201950435737471;
const ll nINFL = -9187201950435737472;

const int MAXN = 3e5 + 15;

int ans[MAXN];
vi comp[MAXN];
int par[MAXN];
int now, one;

int GetPar(int v) {
    if (par[v] == -1) {
        return v;
    }
    return par[v] = GetPar(par[v]);
}

void Merge(int a, int b) {
    a = GetPar(a);
    b = GetPar(b);
    if (a == b) {return;}
    if (a == one) {
        for (auto u : comp[b]) {
            ans[u] = now;
        }
    }
    if (b == one) {
        for (auto u : comp[a]) {
            ans[u] = now;
        }
    }
    if (sz(comp[a]) > sz(comp[b])) {
        swap(a, b);
    }
    for (auto u : comp[a]) {
        comp[b].eb(u);
    }
    comp[a].clear();
    par[a] = b;
}

void Solve() {
    int n, m;
    cin >> n >> m;
    for (int i = 1; i <= n; ++i) {
        comp[i] = {i};
        par[i] = -1;
    }
    map <int, vpi> edges;
    forn(i, m) {
        int a, b, c;
        cin >> a >> b >> c;
        if (a == 1 || b == 1) {
            c = 0;
        }
        edges[c].eb(a, b);
    }
    for (auto &[x, y] : edges) {
        now = x;
        for (auto [a, b] : y) {
            one = GetPar(1);
            Merge(a, b);
        }
    }
    for (int i = 2; i <= n; ++i) {
        cout << ans[i] + (int)1e9 << '\n';
    }
}

signed main() {
    IO();
    int t = 1;
//    cin >> t;
    while(t--) {
        Solve();
    }
    return 0;
}

