#include <bits/stdc++.h>

using namespace std;

void IO() {
#ifdef DIVAN
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
}

#define all(x) x.begin(), x.end()
#define sz(x) ((int)x.size())
#define forn(i, n) for (int i = 0; i < (n); ++i)
#define eb emplace_back
#define vi vector<int>
#define pi pair<int,int>
#define vpi vector<pi>
#define ti tuple<int,int,int>

typedef long long ll;


const int INF = 2139062143;
const int nINF = -2139062144;
const ll INFL = 9187201950435737471;
const ll nINFL = -9187201950435737472;

const int MAXN = 25;

bool dp[MAXN][MAXN][MAXN];
vi all;
vpi adj[MAXN];

void Solve() {
    int n, m;
    cin >> n >> m;
    all.eb(0);
    vector <ti> edges;
    forn(i, m) {
        int a, b, c;
        cin >> a >> b >> c;
        edges.eb(a, b, c);
        all.eb(c);
    }
    sort(all(all));
    all.resize(unique(all(all)) - all.begin());
    for (auto [a, b, c] : edges) {
        c = lower_bound(all(all), c) - all.begin();
        adj[a].eb(b, c);
        adj[b].eb(a, c);
    }
    dp[1][0][0] = 1;
    queue <ti> q;
    q.push({1, 0, 0});
    while(!q.empty()) {
        auto[v, a, b] = q.front();
        q.pop();
        for (auto [to, c] : adj[v]) {
            int na = min(a, c), nb = max(c, b);
            if (v == 1) {
                na = c;
                nb = c;
            }
            if (!dp[to][na][nb]) {
                dp[to][na][nb] = 1;
                q.push({to, na, nb});
            }
        }
    }
    for (int i = 2; i <= n; ++i) {
        int now = INF;
        forn(x, MAXN) {
            forn(y, MAXN) {
                if (dp[i][x][y]) {
                    now = min(now, all[x] + all[y]);
                }
            }
        }
        cout << now << '\n';
    }
}

signed main() {
    IO();
    int t = 1;
//    cin >> t;
    while(t--) {
        Solve();
    }
    return 0;
}

