#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;

#define x first
#define y second
#define int long long
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()

const int inf = 1e9;

int n;
vector<vector<pair<int, int>>> a;


int32_t main() {
	cin.tie(NULL);
	cout.tie(NULL);
	ios::sync_with_stdio(false);

	int m;
	cin >> n >> m;
	a.resize(n);
	int x, y, w;
	vector < pair<int, pair<int, int>>> e;
	for (int i{}; i < m; ++i) {
		cin >> x >> y >> w;
		x--;
		y--;
		e.push_back({ w, {x, y} });
	}

	sort(all(e));

	vector<int> dp(n, inf);
	vector<int> ans(n, inf + inf + 1);
	set<pair<int, int>> st;
	dp[0] = 0;

	for (auto ii : e) {
		int mn = ii.x;
		a[ii.y.x].push_back({ ii.y.y, ii.x });
		a[ii.y.y].push_back({ ii.y.x, ii.x });
		st.insert({ dp[ii.y.x], ii.y.x });
		st.insert({ dp[ii.y.y], ii.y.y });
		while (!st.empty()) {
			auto v = st.begin()->y;
			st.erase(st.begin());
			for (auto i : a[v]) {
				int t = dp[v];
				if (i.y > t) t = i.y;
				if (t < dp[i.x]) {
					st.erase({ dp[i.x], i.x });
					dp[i.x] = t;
					st.insert({ dp[i.x], i.x });
				}
			}
		}

		for (int j{ 1 }; j < n; ++j) {
			if (dp[j] + mn < ans[j]) {
				ans[j] = dp[j] + mn;
			}
		}

	}

	for (int i{ 1 }; i < n; ++i) {
		cout << ans[i] << '\n';
	}
	return 0;
}

/*
3 3
1 2 2
1 3 1
2 3 1
*/