#include <bits/stdc++.h>
using namespace std;

//#define int long long
#define FF first
#define SS second
#define ALL(a) a.begin(), a.end()
#define RALL(a) ar.begin(), a.rend()
#define mp make_pair
#define pb push_back
#define pf push_front

using ll = long long;
using ld = long double;

const int INFI = 1e9 + 228;
const ll INFL = 1e18 + 228;
const ld INFLD = 1e18 + 228;
const ld PI = acos(-1);
const int MAXN = 6e5 + 228;
vector<int> in[MAXN];
vector<int> out[MAXN];
vector<pair<pair<int, int>, pair<int, int> > > ans;
bool used[MAXN];
vector<int> g[MAXN];
int kolin[MAXN];
int kolout[MAXN];
struct Edge {
    int a, b;
    Edge(int a, int b): a(a), b(b) {};
};
vector<Edge> edges;
bool usedE[MAXN];
void add(int a, int b) {
    in[b].pb(edges.size());
    kolin[b]++;
    out[a].pb(edges.size());
    kolout[a]++;
    edges.pb(Edge(a, b));
}
void dfs(int v, int p) {
    used[v] = true;
    for (auto u : g[v]) {
        if (used[u]) continue;
        dfs(u, v);
    }
    if (abs(kolin[v] - kolout[v]) >= 2) {
        cout << "No" << endl;
        exit(0);
    }
    //cout << "#" << ' ' << v << ' ' << kolin[v] << ' ' << kolout[v] << endl;
    if (kolin[v] == kolout[v]) {
        int uk = 0;
        for (auto u : in[v]) {
            if (usedE[u]) continue;
            int w = edges[u].a;
            while (usedE[out[v][uk]]) ++uk;
            ans.pb({{w, v}, {v, edges[out[v][uk]].b}});
            usedE[u] = true;
            kolin[v]--;
            kolout[v]--;
            kolin[edges[out[v][uk]].b]--;
            kolout[w]--;
            //cout << w << ' ' << edges[out[v][uk]].b << endl;
            usedE[out[v][uk]] = true;
            ++uk;
        }
        return;
    }
    if (kolin[v] > kolout[v]) {
        bool was = false;
        for (auto u : in[v]) {
            if (usedE[u]) continue;
            if (edges[u].a == p) was = true;
        }
        if (!was) {
            cout << "No" << endl;
            exit(0);
        }
        int uk = 0;
        for (auto u : in[v]) {
            if (usedE[u]) continue;
            int w = edges[u].a;
            if (w == p) continue;
            while (usedE[out[v][uk]]) ++uk;
            ans.pb({{w, v}, {v, edges[out[v][uk]].b}});
            usedE[u] = true;
            kolin[v]--;
            kolout[v]--;
            kolin[edges[out[v][uk]].b]--;
            kolout[w]--;
            //cout << w << ' ' << edges[out[v][uk]].b << endl;
            usedE[out[v][uk]] = true;
            ++uk;
        }
    }
    if (kolin[v] < kolout[v]) {
        bool was = false;
        for (auto u : out[v]) {
            if (usedE[u]) continue;
            if (edges[u].b == p) was = true;
        }
        if (!was) {
            cout << "No" << endl;
            exit(0);
        }
        int uk = 0;
        for (auto u : out[v]) {
            if (usedE[u]) continue;
            int w = edges[u].b;
            if (w == p) continue;
            while (usedE[in[v][uk]]) ++uk;
            ans.pb({{edges[in[v][uk]].a, v}, {v, w}});
            usedE[u] = true;
            kolout[v]--;
            kolin[v]--;
            kolout[edges[in[v][uk]].a]--;
            kolin[w]--;
            //cout << w << ' ' << edges[in[v][uk]].a << endl;
            usedE[in[v][uk]] = true;
            ++uk;
        }
        return;
    }
}
void run() {
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        int v, u;
        cin >> v >> u;
        --v;
        --u;
        g[u].pb(v);
        g[v].pb(u);
        add(v, u);
    }
    for (int i = 0; i < n; ++i) {
        if (used[i]) continue;
        dfs(i, i);
    }
    cout << "Yes" << endl;
    for (auto u : ans) {
        cout << u.FF.FF + 1 << ' ' << u.FF.SS + 1 << ' ' << u.SS.FF + 1 << ' ' << u.SS.SS + 1 << endl;
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    //cin >> t;
    t = 1;
    while (t--) run();
    return 0;
}
