#include <algorithm>
#include <iostream>
#include <string>
#include <vector>
#include <set>
using namespace std;

typedef long long ll;
#define fastio ios::sync_with_stdio(false), cin.tie(0)
#define forn(i, n) for (int i = 0; i < (n); i++)
#define rforn(i, n) for (int i = (n) - 1; i >= 0; i--)
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

const int N = 300100;
vector<pair<int, int>> g[N];

int d0[N];
void dfs0(int v, int p = -1, int mn = 1e9, int mx = 0) {
	d0[v] = mn + mx;
	for (auto u : g[v]) {
		if (u.first == p) continue;
		dfs0(u.first, v, min(mn, u.second), max(mx, u.second));
	}
}

int d1[N];

int main() {
	fastio;
	int n, m;
	cin >> n >> m;
	forn(i, m) {
		int a, b, t;
		cin >> a >> b >> t;
		a--, b--;
		g[a].push_back(make_pair(b, t));
		g[b].push_back(make_pair(a, t));
	}

	if (m == n - 1) {
		dfs0(0);
		for (int i = 1; i < n; i++) {
			cout << d0[i] << '\n';
		}
		return 0;
	}

	bool flag1 = true, flag2 = true;
	for (auto i : g[0]) {
		if (i.second != 0) flag1 = false;
		if (i.second != 1e9) flag2 = false;
	}

	if (flag1) {
		set<pair<int, int>> q;
		q.insert(make_pair(0, 0));
		forn(i, n) d1[i] = 1e9 + 1;

		while (q.size()) {
			int v = q.begin()->second;
			q.erase(q.begin());
			for (auto u : g[v]) {
				if (d1[u.first] > max(d1[v], u.second)) {
					q.erase(make_pair(d1[u.first], u.first));
					d1[u.first] = max(d1[v], u.second);
					q.insert(make_pair(d1[u.first], u.first));
				}
			}
		}
		for (int i = 1; i < n; i++) {
			cout << d1[i] << '\n';
		}
		return 0;
	}
	return 0;
}