#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using vii = vector<int>;

int n, m;
void optimize() {
    ios::sync_with_stdio(false);
    cin.tie(0);
}
const int N = 3e5 + 5;

vector<pll> g[N];
ll d[N];
bool used[N];

int main() {
    optimize();
    cin >> n >> m;
    bool f = 1;
    for (int i = 0; i < m; ++i) {
        ll u, v, w; cin >> u >> v >> w; --u; --v;
        if ((u == 0 || v == 0) && w != 0)
            f = 0;
        g[u].emplace_back(v, w);
        g[v].emplace_back(u, w);
    }
    if (!f) exit(-1);
    fill(d, d + n, 1e18);
    d[0] = 0; set<pll> q; q.insert({0, 0});
    while (!q.empty()) {
        auto p = *q.begin(); q.erase(q.begin());
        int num = p.second;
        if (used[num]) continue;
        used[num] = 1;
        for (auto v : g[num]) {
            if (used[v.first]) continue;
            if (d[v.first] > max(d[num], v.second)) {
                d[v.first] = max(d[num], v.second);
                q.insert({d[v.first], v.first});
            }
        }
    }
    for (int i = 1; i < n; ++i) {
        cout << d[i] << '\n';
    }

    return 0;
}
