#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

#pragma optimize("0fast");

using namespace std;

#define int long long

map<char, int> value;

struct biba
{
	int Sum;
	string S;
	vector<pair<int, int>> v;

	void Init()
	{
		v.resize(26);
		for (int i = 0; i < 26; i++)
			v[i] = { 0, 0 };
		Sum = 0;
		S = "";
	}
	
	int neg(int x)
	{
		if (x > 0) return -x;
		else return x;
	}

	void Add(char c)
	{
		Sum = 0;
		S += c;
		v[c - 'A'].first++;
		for (char x = 'A'; x <= 'Z'; x++)
		{
			if (x < c)
			{
				v[x - 'A'].second += v[x - 'A'].first;
				v[x - 'A'].first = 0;
			}
			Sum += value[x] * (v[x - 'A'].first - v[x - 'A'].second);
		}
	}

	void Copy(biba& a)
	{
		Sum = a.Sum;
		S = a.S;
		for (int i = 0; i < 26; i++)
			v[i] = a.v[i];
	}
};

int32_t main()
{
	ios::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);

	int k = 1;
	for (char c = 'A'; c <= 'Z'; c += 2)
	{
		value[c] = k;
		value[c + 1] = k * 5;
		k *= 10;
	}

	int q;
	cin >> q;
	while (q--)
	{
		string s, ans = "";
		cin >> s;
		int n = s.length();

		int sum = 0;
		char mx = 'A';

		for (int i = n - 1; i >= 0; i--)
		{
			if (s[i] != '?')
			{
				if (s[i] < mx)
					sum -= value[s[i]];
				else sum += value[s[i]];
				ans += s[i];
				mx = max(mx, s[i]);
				continue;
			}

			char mn = 'Z';
			for (int j = i - 1; j >= 0; j--)
			{
				if (s[j] != '?')
				{
					mn = s[j];
					break;
				}
			}

			if (mn >= mx)
			{
				ans += mn;
				sum += value[mn];
			}
			else
			{
				ans += 'Z';
				sum += value['Z'];
			}
		}
		
		reverse(ans.begin(), ans.end());
		cout << sum << endl << ans << endl;
	}
	

}