#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

#pragma optimize("0fast");

using namespace std;

#define int long long

vector<int> from[150000];
bool banned[1000][1000];
vector<int> to[150000];
vector<pair<int, int>> ans_beb, ans;
vector<pair<int, int>> path;
vector<bool> visited;

void dfs(int u)
{
	visited[u] = 1;
	for (int i = 0; i < from[u].size(); i++)
	{
		if (banned[u][from[u][i]]) continue;
		//cout << u << " " << i << " not banned (" << u + 1 << " -> " << from[u][i] + 1 << ")" << endl;
		banned[u][from[u][i]] = 1;
		path.push_back({u, from[u][i]});
		dfs(from[u][i]);
		path.pop_back();
	}

	if (path.size() > ans_beb.size())
	{
		ans_beb.resize(path.size());
		for (int i = 0; i < path.size(); i++)
			ans_beb[i] = path[i];
	}
}

int32_t main()
{
	ios::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);

	int n, m;
	cin >> n >> m;

	for (int i = 0; i < m; i++)
	{
		int u, v;
		cin >> u >> v;
		from[u - 1].push_back(v - 1);
		to[v - 1].push_back(u - 1);
	}
	
	visited.resize(n);
	for (int i = 0; i < n; i++)
		visited[i] = 0;

	vector<pair<int, int>> bad;
		
	bool f = true;
	while (f)
	{
		f = false;

		for (int x = 0; x < n; x++)
		{
			if (from[x].size() == 1 && to[x].size() == 0)
			{
				for (int i = 0; i < from[from[x][0]].size(); i++)
				{
					//cout << "bind " << x + 1 << " -> " << from[x][0] + 1 << " -> " << from[from[x][0]][i] + 1 << endl;
						
					bad.push_back({ x, from[x][0] });
					bad.push_back({ from[from[x][0]][i], from[x][0]});

					for (int g = 0; g < to[from[x][0]].size(); g++)
					{
						for (int w = 0; w < to[from[from[x][0]][i]].size(); w++)
						{
							to[from[from[x][0]][i]].erase(to[from[from[x][0]][i]].begin() + w);
							to[from[x][0]].erase(to[from[x][0]].begin() + g);
							goto _opa;
						}
					}

					_opa:

					from[from[x][0]].erase(from[from[x][0]].begin() + i);
					from[x].erase(from[x].begin());
					//cout << "end bind" << endl;
					break;
				}
			}
		}

		for (int x = 0; x < n; x++)
		{
			if (to[x].size() != 1) continue;
			for (int i = 0; i < to[x].size(); i++)
			{
				if (f) break;
				for (int j = 0; j < to[to[x][i]].size(); j++)
				{
					if (f) break;
					for (int a = 0; a < from[to[to[x][i]][j]].size(); a++)
					{
						if (f) break;
						for (int b = 0; b < from[to[x][i]].size(); b++)
						{
							if (from[to[x][i]][b] == x && from[to[to[x][i]][j]][a] == to[x][i])
							{
								//cout << "bind " << x + 1 << " <- " << to[x][i] + 1 << " <- " << to[to[x][i]][j] + 1 << endl;
								bad.push_back({ to[x][i], x });
								bad.push_back({ to[to[x][i]][j], to[x][i] });
								from[to[x][i]].erase(from[to[x][i]].begin() + b);
								from[to[to[x][i]][j]].erase(from[to[to[x][i]][j]].begin() + a);
								to[to[x][i]].erase(to[to[x][i]].begin() + j);
								to[x].erase(to[x].begin() + i);
								f = true;
								//cout << "end bind" << endl;
								goto _end;
							}
						}
					}
				}
			}
		_end:;
		}
	}

	if ((int)(ans.size()) + (int)(bad.size()) != m)
		cout << "No";
	else
	{
		cout << "Yes\n";

		for (int i = 0; i + 1 < bad.size(); i += 2)
		{
			cout << bad[i].first + 1 << " " << bad[i].second + 1 << " ";
			cout << bad[i + 1].first + 1 << " " << bad[i + 1].second + 1 << endl;
		}
		//cout << "those were bad" << endl;
		for (int i = 0; i + 1 < ans.size(); i += 2)
		{
			cout << ans[i].first + 1 << " " << ans[i].second + 1 << " ";
			cout << ans[i + 1].first + 1 << " " << ans[i + 1].second + 1 << endl;
		}
	}
}