#include <bits/stdc++.h>

#define int long long
#define ll long long
#define all(v) v.begin(),  v.end()


using namespace std;

const int inf = 1e10;

const int maxn = 300000;


vector<pair<int, int>> graph[maxn];


int res[maxn];

bool was[maxn];

void dfs(int v, int mn, int mx) {
    was[v] = true;
    res[v] = mx + mn;
    for (auto[u, c]: graph[v]) {
        if (!was[u]) {
            dfs(u, min(c, mn), max(c, mx));
        }
    }
}


signed main() {
    cin.tie(0);
    ios::sync_with_stdio(false);
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        int u, v, c;
        cin >> u >> v >> c;
        --u, --v;
        graph[u].emplace_back(v, c);
        graph[v].emplace_back(u, c);
    }
    dfs(0, inf, -1);
    for (int i = 0; i < n; ++i) {
        cout << res[i] << "\n";
    }
    return 0;
}
