#include <bits/stdc++.h>

#define int long long
#define ll long long
#define all(v) v.begin(),  v.end()


using namespace std;

const int inf = 1e10;

const int maxn = 300000;


vector<pair<int, int>> graph[maxn];


int res[maxn];


signed main() {
    cin.tie(0);
    ios::sync_with_stdio(false);
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        int u, v, c;
        cin >> u >> v >> c;
        --u, --v;
        graph[u].emplace_back(v, c);
        graph[v].emplace_back(u, c);
    }
    auto comp = [&](int l, int r) -> bool {
        return tie(res[l], l) < tie(res[r], r);
    };
    set<int, decltype(comp)> x(comp);
    fill(res, res + n, inf);
    res[0] = 0;
    while (!x.empty()) {
        int v = *x.begin();
        x.erase(v);
        for (auto[u, c]: graph[v]) {
            if (c < res[u]) {
                x.erase(u);
                res[u] = c;
                x.insert(u);
            }
        }
    }
    for (int i = 1; i < n; ++i) {
        cout << res[i] + 1000ll * 1000ll * 1000ll << "\n";
    }
    return 0;
}
