#include <iostream>
#include <vector>
#include <queue>

using namespace std;

struct edge{
    int u, t;
};

const int MAXN = 300004, INF = 1e16;
vector <edge> g[MAXN];
vector <int> ans(MAXN, INF);

signed main() {
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        int x, y, z;
        cin >> x >> y >> z;
        x--;
        y--;
        g[x].push_back({y, z});
        g[y].push_back({x, z});
    }
    ans[0] = 0;
    priority_queue <pair <int, int>> a;
    a.push({0, 0});
    int k = 0;

    while (a.size() > 0){
        k++;
        if (k > 1e6)
            break;
        auto p = a.top();
        a.pop();
        int val = p.first, v = p.second;
        if (ans[v] < val)
            continue;
        for (auto e : g[v]) {
            if (ans[e.u] > max(val, e.t)) {
                ans[e.u] = max(val, e.t);
                a.push({ans[e.u], e.u});
            }
        }
    }

    for (int i = 1; i < n; ++i) {
        cout << ans[i] << "\n";
    }
}
