#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
#define pii pair<int,int>
#define pll pair<ll,ll>
#define pb push_back
#define all(x) (x).begin(),(x).end()
#define vi vector <int>
#define vll vector <ll>
#define vvi vector <vi>
#define vvll vector <vll>
#define vpii vector <pii>
#define vvpii vector <vpii>
#define vb vector <bool>
#define vvb vector <vb>
#define fi first
#define se second

const int INF = 1e9;
const ll INFLL = 1e18;
const int mod1 = 1e9 + 7;
const int mod2 = 1e9 + 9;
const int MAXN = 3e5 + 100;
int del[MAXN];
vector<int> path;
int ans[MAXN];
bool used[MAXN];
int par[MAXN];
int val[MAXN];
int ranks[MAXN];

void make_set(int s) {
    par[s] = s;
    ranks[s] = 0;
    val[s] = INF + 100;
}

int find_set(int s) {
    if (par[s] == s)
        return s;
    return par[s] = find_set(par[s]);
}

void union_sets(int u, int v) {
    u = find_set(u);
    v = find_set(v);
    if (u != v) {
        if (ranks[u] < ranks[v])
            swap(u, v);
        par[v] = u;
        val[u] = min(val[v], val[u]);
        if (ranks[u] == ranks[v])
            ranks[u]++;
    }
}

vvpii g;
vi cost;

void dfs(int s) {
    path.pb(s);
    used[s] = true;
    for (auto to:g[s]) {
        if (used[to.fi])
            continue;
        if (s < to.fi)
            del[to.se] = 1;
        else
            del[to.se] = 2;
        dfs(to.fi);
    }
}

int type[MAXN];

void dffs(int s, int cur) {
    type[s] = cur;
    for (auto to:g[s]) {
        if (type[to.fi] != 0)
            continue;
        if ((del[to.se] == 1 && s < to.fi) || (del[to.se] == 2 && s > to.fi))
            continue;
        dffs(to.fi, cur);
    }
}

vvpii gg;

void dfss(int s, int p, int mx) {
    mx = min(mx, val[s]);
    val[s] = mx;
    for (auto to:gg[s]) {
        if (to.fi == s)
            continue;
        dfss(to.fi, s, min(mx, to.se));
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    cost = vi(m);
    g=vvpii(n);
    vpii ed(m);
    for (int i = 0; i < m; i++) {
        int u, v, c;
        cin >> u >> v >> c;
        u--, v--;
        cost[i] = c;
        g[u].pb({v, i});
        g[v].pb({u, i});
        ed[i] = {u, v};
    }
//    cout<<"ahah\n";
    for (int i = 0; i < n; i++) {
        if (used[i])
            continue;
        dfs(i);
    }
//    cout<<"ahha\n";
    assert(path.size() == n);
    int cur = 1;
    for (auto to:path) {
        if (type[to]!=0)
            continue;
        dffs(to, cur++);
    }
    int sz = cur - 1;
//    cout<<sz<<'\n';
    gg = vvpii(sz);
    for (int i = 0; i < sz; i++)
        make_set(i);
    unordered_map<int, int> mm;
    int now = -1;
    for (auto to:ed) {
        now++;
        if (type[to.fi] != type[to.se]) {
            gg[type[to.fi] - 1].pb({type[to.se] - 1, cost[now]});
            gg[type[to.se] - 1].pb({type[to.fi] - 1, cost[now]});
            continue;
        }
        val[type[to.fi] - 1] = min(val[type[to.fi] - 1], cost[now]);
    }
    int what = type[0] - 1;
    dfss(what, what, INF + 100);
    for (int i = 1; i < n; i++)
        cout << INF + val[type[i] - 1] << '\n';
}

int main() {
#ifdef Mip182
    freopen("a.in", "r", stdin);
#else
    ios_base::sync_with_stdio(0);cin.tie(0);
#endif
    int _t = 1;
    while (_t--)
        solve();
}