#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <numeric>
#include <cassert>
#include <cstring>
#include <string>
#include <list>

using namespace std;

#define range(i, n) for (int i = 0; i < (n); ++i)
#define prange(i, n) for (int i = 1; i <= (n); ++i)
#define rrange(i, n) for (int i = (n) - 1; i >= 0; --i)

typedef long long ll;
typedef pair<int, int> pii;
#define fi first
#define se second
#define pb push_back
#define all(a) (a).begin(), (a).end()

void setup() {
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#endif
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
}

void solve();

int main() {
    setup();
    int t = 1;
//    cin >> t;
    range(i, t) {
        solve();
    }
}

const int MAXN = 5e5 + 10;
int xs[MAXN];
int hs[MAXN];
int n;

int l, r;
int cnt;
int ls[MAXN];
int rs[MAXN];
void process(int i) {
    if (i == l - 1) {process(rs[i]); return;}
    if (i == r + 1) return;
    int lx = xs[ls[i]];
    int rx = xs[rs[i]];
    int x = xs[i];
    if (rx - x >= hs[i] ||  x - lx >= hs[i]) {
        rs[ls[i]] = rs[i];
        ls[rs[i]] = ls[i];
        ++cnt;
        process(ls[i]);
    } else {
        process(rs[i]);
    }
}

void solve() {
    int q;
    cin >> n >> q;
    prange(i, n) {
        cin >> xs[i] >> hs[i];
    }
    n += 2;
    xs[0] = xs[1];
    xs[n - 1] = xs[n - 2];
    hs[0] = hs[n - 1] = INT32_MAX;
    range(_, q) {
        cin >> l >> r;
        cnt = 0;
        rs[l - 1] = l;
        for (int i = l; i <= r; ++i) {
            ls[i] = i - 1;
            rs[i] = i + 1;
        }
        ls[r + 1] = r;
        process(l);
        cout << cnt << '\n';
    }
}



