#include <bits/stdc++.h>

using namespace std;

const int N = 15e4;

struct pair_edge {
    int v1, v2;
    int u1, u2;
};

vector < vector <int> > g(N, vector <int> ());
vector < vector <int> > h(N, vector <int> ());
/*vector <bool> used(N, 0), t(N, 0);
vector <int> dp(N, 0), bad(N, 0);
vector <pair_edge> an;
int ls = 0;

bool dfs(int v, int p) {
    used[v] = 1;
    int fr = 0, to = 0;
    vector <int> e_to, e_fr;
    for (auto u : g[v]) {
        if (u != p) {
            if (!used[u] && !dfs(u, v)) {
                return 0;
            }
            to++;
            e_to.push_back(u);
            if (dp[u] == 1) {
                to--;
                e_to.pop_back();
                an.push_back({v, u, u, bad[u]});
                t[u] = 1;
            } else if (dp[u] == -1) {
                t[u] = 1;
                ls++;
            }
        }
    }
    for (auto u : h[v]) {
        if (u != p) {
            if (!used[u] && !dfs(u, v)) {
                return 0;
            }
            fr++;
            e_fr.push_back(u);
            if (dp[u] == 1 && t[u] == 0) {
                return 0;
            } else if (dp[u] == -1) {
                fr--;
                e_fr.pop_back();
                an.push_back({bad[u], u, u, v});
                if (t[u]) {
                    ls--;
                    t[u] = 0;
                }
            }
        }
    }
    for (auto u : g[v]) {
        t[u] = 0;
    }
    for (auto u : h[v]) {
        t[u] = 0;
    }
    if (ls > 0) {
        return 0;
    }
    if (abs(to - fr) >= 2) {
        return 0;
    }
    dp[v] = to - fr;
    for (int i = 0; i < min(to, fr); ++i) {
        an.push_back({e_fr[i], v, v, e_to[i]});
    }
    if (to > fr) {
        bad[v] = e_to.back();
    } else if (to < fr) {
        bad[v] = e_fr.back();
    }
    return 1;
}*/

int u1 = -1, u2, v1, v2;
vector <int> an;

bool fun(int v, int p) {
    if (v == v1 || v == v2) {
        an.push_back(v);
        return 1;
    }
    for (auto u : g[v]) {
        if (u != p) {
            if (fun(u, v)) {
                an.push_back(v);
                return 1;
            }
        }
    }
    return 0;
}

signed main() {
    int n, m; cin >> n >> m;
    map < pair <int, int>, bool> e;
    int pp = 0;
    for (int i = 0; i < m; ++i) {
        int u, v; cin >> u >> v;
        u--; v--;
        g[u].push_back(v);
        h[v].push_back(u);
        e[{u, v}] = 1;
        if (e[{v, u}]) {
            pp--;
        } else {
            pp++;
        }
    }
    if (pp == 0) {
        cout << "Yes\n";
        for (int i = 0; i < n; ++i) {
            for (auto u : g[i]) {
                if (u > i) {
                    cout << i + 1 << ' ' << u + 1 << ' ' << u + 1 << ' ' << i + 1 << "\n";
                }
            }
        }
        return 0;
    }
    for (int i = 0; i < n; ++i) {
        for (auto u : g[i]) {
            if (!e[{u, i}]) {
                if (u1 == -1) {
                    u1 = i, u2 = u;
                } else {
                    v1 = i, v2 = u;
                }
            }
        }
    }
    if (u1 == v1 || u2 == v2) {
        cout << "No\n";
        return 0;
    }
    if (u1 == v2 || u2 == v1) {
        cout << "Yes\n";
        cout << u1 + 1 << ' ' << u2 + 1 << ' ' << v1 + 1 << ' ' << v2 + 1 << "\n";
        for (int i = 0; i < n; ++i) {
            for (auto u : g[i]) {
                if (u > i) {
                    cout << u + 1 << ' ' << i + 1 << ' ' << i + 1 << ' ' << u + 1 << "\n";
                }
            }
        }
        return 0;
    }
    if (!fun(u2, -1)) {
        fun(u1, -1);
        int len = an.size();
        if (an[0] == v2 && !(len & 1)) {
            cout << "No\n";
            return 0;
        }
        if (an[0] == v1 && len & 1) {
            cout << "No\n";
            return 0;
        }
        cout << "Yes\n";
        vector <int> t(n, 0);
        for (int i = 0; i < len; ++i) {
            t[an[i]] = 1;
        }
        t[v1 + v2 - an[0]] = 1;
        t[u2] = 1;
        for (int i = 0; i < n; ++i) {
            for (auto u : g[i]) {
                if (u > i && (!t[u] || !t[i])) {
                    cout << u + 1 << ' ' << i + 1 << ' ' << i + 1 << ' ' << u + 1 << "\n";
                }
            }
        }
        reverse(an.begin(), an.end());
        an.push_back(v2 + v1 - an.back());
        for (int i = 0; i < len; ++i) {
            if (i == 0) {
                cout << u1 + 1 << ' ' << u2 + 1 << ' ' << an[i + 1] + 1 << ' ' << u1 + 1 << "\n";
            } else if (i & 1) {
                cout << an[i] + 1 << ' ' << an[i + 1] + 1 << ' ' << an[i - 1] + 1 << ' ' << an[i] + 1 << "\n";
            } else {
                cout << an[i] + 1 << ' ' << an[i - 1] + 1 << ' ' << an[i + 1] + 1 << ' ' << an[i] + 1 << "\n";
            }
        }
    } else {
        int len = an.size();
        if (an[0] == v1 && !(len & 1)) {
            cout << "No\n";
            return 0;
        }
        if (an[0] == v2 && len & 1) {
            cout << "No\n";
            return 0;
        }
        cout << "Yes\n";
        vector <int> t(n, 0);
        for (int i = 0; i < len; ++i) {
            t[an[i]] = 1;
        }
        t[v1 + v2 - an[0]] = 1;
        t[u1] = 1;
        for (int i = 0; i < n; ++i) {
            for (auto u : g[i]) {
                if (u > i && (!t[u] || !t[i])) {
                    cout << u + 1 << ' ' << i + 1 << ' ' << i + 1 << ' ' << u + 1 << "\n";
                }
            }
        }
        reverse(an.begin(), an.end());
        an.push_back(v2 + v1 - an.back());
        for (int i = 0; i < len; ++i) {
            if (i == 0) {
                cout << u1 + 1 << ' ' << u2 + 1 << ' ' << u2 + 1 << ' ' << an[i + 1] + 1 << "\n";
            } else if (i & 1) {
                cout << an[i] + 1 << ' ' << an[i - 1] + 1 << ' ' << an[i + 1] + 1 << ' ' << an[i] + 1 << "\n";
            } else {
                cout << an[i] + 1 << ' ' << an[i + 1] + 1 << ' ' << an[i - 1] + 1 << ' ' << an[i] + 1 << "\n";
            }
        }
    }
    /*for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            if (!dfs(i, -1) || dp[i] != 0) {
                cout << "No\n";
                return 0;
            }
        }
    }
    cout << "Yes\n";
    for (auto p : an) {
        cout << p.v1 + 1 << ' ' << p.v2 + 1 << ' ' << p.u1 + 1 << ' ' << p.u2 + 1 << "\n";
    }*/
}
/*
5 6
1 2
2 1
1 5
2 3
2 4
4 2

4 4
2 1
2 3
2 4
4 2

4 4
1 2
2 1
3 4
4 3
*/
