#include <bits/stdc++.h>
using namespace std;
#define pii pair<int, int>
#define x first
#define y second
using ll = long long;
const int maxn = 3e5;
vector<pair<pii, pii>> ans;

struct Edge {
    int u, v, t, ind;
    bool used;
    Edge(){};
    Edge(int uu, int vv, int tt, int indd) {
        u = uu;
        v = vv;
        t = tt;
        ind = indd;
        used = false;
    }
};


vector<Edge> adj[maxn];
bool been[maxn];

void dfs(int u, int p=-1) {
    been[u] = true;
    vector<int> inn, outt;
    int upi = -1;
    for (int i = 0; i < (int)adj[u].size(); ++i) {
        if (adj[u][i].v == p) {
            upi = i;
            continue;
        }
        int v = adj[u][i].v;
        dfs(v, u);
    }
    for (int i = 0; i < (int)adj[u].size(); ++i) {
        if (adj[u][i].v == p) {
            upi = i;
            continue;
        }
        if (adj[u][i].t == 3) {
            inn.push_back(adj[u][i].v);
            outt.push_back(adj[u][i].v);
        }
        else if (adj[u][i].t == 2) {
            inn.push_back(adj[u][i].v);
        }
        else if (adj[u][i].t == 1) {
            outt.push_back(adj[u][i].v);
        }
    }
    if (inn.size() == outt.size()) {
        for (int i = 0; i < (int)inn.size(); ++i) {
            ans.emplace_back(make_pair(inn[i], u), make_pair(u, outt[i]));
        }
        return;
    }
    if (p == -1) {
        cout << "No\n";
        exit(0);
    }
    if ((int)inn.size() == (int)outt.size() + 1) {
        if (adj[u][upi].t == 3) {
            adj[u][upi].t = 2;
            adj[p][adj[u][upi].ind].t = 1;
            outt.push_back(p);
        }
        else if (adj[u][upi].t == 1) {
            adj[u][upi].t = 0;
            adj[p][adj[u][upi].ind].t = 0;
            outt.push_back(p);
        }
        else {
            cout << "No\n";
            exit(0);
        }
        for (int i = 0; i < (int)inn.size(); ++i) {
            ans.emplace_back(make_pair(inn[i], u), make_pair(u, outt[i]));
        }
        return;
    }
    if ((int)inn.size() + 1 == (int)outt.size()) {
        if (adj[u][upi].t == 3) {
            adj[u][upi].t = 1;
            adj[p][adj[u][upi].ind].t = 2;
            inn.push_back(p);
        }
        else if (adj[u][upi].t == 2) {
            adj[u][upi].t = 0;
            adj[p][adj[u][upi].ind].t = 0;
            inn.push_back(p);
        }
        else {
            cout << "No\n";
            exit(0);
        }
        for (int i = 0; i < (int)inn.size(); ++i) {
            ans.emplace_back(make_pair(inn[i], u), make_pair(u, outt[i]));
        }
        return;
    }
    cout << "No\n";
    exit(0);
}

signed main() {
    ios::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
    int n, m;
    cin >> n >> m;
    map<pii, int> c;
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        --u; --v;
        auto it = c.find({v, u});
        if (it == c.end()) {
            adj[u].emplace_back(u, v, 1, (int)adj[v].size());
            adj[v].emplace_back(v, u, 2, (int)adj[u].size() - 1);
            c[{u, v}] = (int)adj[u].size() - 1;
        }
        else {
            adj[v][(*it).y].t = 3;
            adj[u][adj[v][(*it).y].ind].t = 3;
        }
    }
    for (int i = 0; i < n; ++i) {
        if (!been[i]) {
            dfs(i);
        }
    }
    cout << "Yes\n";
    for (auto elem : ans) {
        cout << elem.x.x + 1 << " " << elem.x.y + 1 << " " << elem.y.x + 1 << " " << elem.y.y + 1 << "\n";
    }
}
/*
5 6
1 2
2 1
1 5
2 3
2 4
4 2

4 4
2 1
2 3
2 4
4 2

4 4
1 2
2 1
3 4
4 3
 */