#include <bits/stdc++.h>

typedef long long ll;

using namespace std;

#define pll pair<ll, ll>
#define ff first
#define ss second

ll n, m;

const ll MAXN = 3e5 + 10;

vector<pll> og[MAXN];
vector<ll> g[MAXN];
ll mt[MAXN];
bool used[MAXN];

pll edges[MAXN];

bool kuhn(ll v){
    if(used[v]) return false;
    used[v] = true;
    for(ll to: g[v]){
        if(mt[to] == -1 || kuhn(mt[to])){
            mt[to] = v;
            return true;
        }
    }
    return false;
}

void solve(){
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        ll u, v;
        cin >> u >> v;
        edges[i] = {u, v};
        og[u].emplace_back(v, i);
    }
    for(ll i = 0; i < m; ++i){
        for(auto e: og[edges[i].ss]){
            if(e.ss > i)
                g[i].push_back(e.ss);
        }
    }
    for(int i = 0; i < m; ++i) mt[i] = -1;
    ll cnt = 0;
    for(int i = 0; i < m; ++i){
        for(int j = 0; j < m; ++j) used[j] = false;
        cnt += kuhn(i);
        //if(cnt == m / 2) break;
    }
    if(cnt == m / 2){
        cout << "Yes\n";
        for(int i = 0; i < m; ++i){
            if(mt[i] != -1){
                cout << edges[mt[i]].ff << " " << edges[mt[i]].ss << " ";
                cout << edges[i].ff << " " << edges[i].ss << "\n";
            }
        }
    }else{
        cout << "No\n";
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    solve();
}
