#include <bits/stdc++.h>
using namespace std;
//#define int long long
typedef vector<int> vi;
typedef vector<vi> v2i;
typedef pair<int, int> pii;
typedef vector<pii> vp;
typedef vector<vp> v2p;
const int inf = 1e9;

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m;
    cin >> n >> m;
    v2p g(n);
    for (int i = 0; i < m; ++i) {
        int v, u, t;
        cin >> v >> u >> t;
        --v, --u;
        g[v].emplace_back(u, t);
        g[u].emplace_back(v, t);
    }
    set<pair<int, int>> q;
    vi dist(n, 2 * inf);
    dist[0] = inf;
    q.insert({dist[0], 0});
    while (!q.empty()) {
        int v = q.begin()->second;
        q.erase(q.begin());
        for (auto[to, t] : g[v])
            if (dist[to] > min(dist[v], t)) {
                q.erase({dist[to], to});
                dist[to] = min(dist[v], t);
                q.insert({dist[to], to});
            }
    }
    for (int i = 1; i < n; ++i)
        cout << dist[i] + inf << '\n';
}
