#include <iostream>
#include <vector>
#include <cmath>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>

#define sqr(x) ((x) * (x))
#define mp make_pair
#define pb push_back
#define endl '\n'
//#define int ll

#pragma warning (disable : 4996)

using namespace std;

typedef long double ld;
typedef long long ll;
typedef pair<int, int> pii;
typedef vector<pii> vii;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<char> vc;

const ld EPS = 1e-8;
const int N = (int)1e5 + 10;
const int INF = (int)2e18 + 10;
const int MOD = (int)1e9 + 7;

int L, R;

bool check(set<int>& a, int x, int h) {
	auto it = a.upper_bound(x);
	if (x + h <= R && (it == a.end() || *it >= x + h))
		return 1;
	if (x - h < L)
		return 0;
	it = a.lower_bound(x);
	if (it == a.begin())
		return 1;
	--it;
	return *it <= x - h;
}

void solve() {
	
	int n, q;
	cin >> n >> q;
	vi x(n), h(n);
	for (int i = 0; i < n; ++i)
		cin >> x[i] >> h[i];
	L = x[0]; R = x.back();
	for (int t = 0; t < q; ++t) {
		int l, r;
		cin >> l >> r;
		--l;
		set<int> s;
		for (int i = 0; i < n; ++i)
			s.insert(x[i]);
		for (int it = 0; it <= n; ++it) {
			bool flag = 1;
			for (int i = l; i < r; ++i) {
				if (s.find(x[i]) != s.end() && check(s, x[i], h[i])) {
					s.erase(x[i]);
					flag = 0;
					break;
				}
			}
			if (flag) {
				cout << it << endl;
				break;
			}
		}
	}
	
	return;
}

signed main() {
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	solve();

	return 0;
}