﻿#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const int INF = 1e9;

void dfsg1(int v, vector<int>& used, vector<pair<int, int>>& dp, vector<vector<pair<int, int>>>& g) {
	used[v] = 1;
	for (auto i : g[v]) {
		if (!used[i.first]) {
			dp[i.first].first = min(dp[v].first, i.second);
			dp[i.first].second = max(dp[v].second, i.second);
			dfsg1(i.first, used, dp, g);
		}
	}
}

void solg1(int n, int m) {
	int u, v, t;
	vector<vector<pair<int, int>>> g(n);
	vector<int> used(n, 0);
	vector<pair<int, int>> dp(n);
	dp[0] = make_pair(INF, 0);
	for (int i = 0; i < m; ++i) {
		cin >> u >> v >> t;
		--u;
		--v;
		g[u].emplace_back(v, t);
		g[v].emplace_back(u, t);
	}
	dfsg1(0, used, dp, g);
	for (int i = 1; i < n; ++i) {
		cout << dp[i].first + dp[i].second << '\n';
	}
}

int main() {
	int n, m;
	cin >> n >> m;
	if (m == n - 1) {
		solg1(n, m);
	}
	return 0;
}
