#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

#define all(x) (x).begin(), (x).end()
#define size(x) (ll)x.size()

const int N = 3e5 + 15;
vector<pair<int, int>> g[N];
int pt[N];
int f[N];
int INF = 2e9;
int ans[N];

void dfs(int v, int p) {
    for(auto e : g[v]) {
        int to = e.first;
        int c = e.second;
        if (to == p) continue;
        f[to] = max(f[v], c);
        dfs(to, v);
    }
}


int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    int n, m;
    cin >> n >> m;
    for(int i = 0; i < m; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        --a; --b;
        g[a].emplace_back(b, c);
        g[b].emplace_back(a, c);
    }
    mt19937 gen;
    for(int i = 0; i < n; i++) {
        shuffle(all(g[i]), gen);
    }
    fill(ans, ans + n, 0);
    fill(f, f + n, -INF);
    dfs(0, -1);
    for(int i = 1; i < n; i++) {
        ans[i] += f[i];
    }
    for(int i = 0; i < n; i++) {
        for(auto &e : g[i]) {
            e.second = -e.second;
        }
    }
    fill(f, f + n, -INF);
    dfs(0, -1);
    for(int i = 1; i < n; i++) {
        ans[i] -= f[i];
    }
    for(int i = 1; i < n; i++) {
        cout << ans[i] << ' ';
    }
}