#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <set>
#include <map>
#include <deque>
#include <tuple>

using namespace std;

typedef long long ll;

#define int ll
#define loop(i, n) for (int i = 0; i < n; ++i)
#define loop1(i, n) for (int i = 1; i <= n; ++i)
#define all(x) begin(x), end(x)
#define pi pair <int, int>
#define ti tuple <int, int, int>
#define F first
#define S second

const int N = 3e5 + 7, K = 26;

int add[K][N];
int val[K] = { 1 };

void solve() {
	string s; cin >> s;
	int n = s.size();
	vector <int> prs;
	vector <bool> mns(n);
	int ans = 0, cmx = 1;
	for (int i = n - 1; i >= 0; --i) {
		if (s[i] != '?') {
			cmx = max(cmx, val[s[i] - 'a']);
			if (val[s[i] - 'a'] < cmx) {
				ans -= val[s[i] - 'a'];
				mns[i] = 1;
			}
			else
				ans += val[s[i] - 'a'];
		}
	}
	cout << ans << "\n" << s << "\n";
}

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	loop1(i, K)
		val[i] = (i & 1 ? val[i - 1] * 5 : val[i - 2] * 10);
	int t; cin >> t; loop(i, t)
	solve();
	return 0;
}
