#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <set>
#include <map>
#include <deque>
#include <tuple>

using namespace std;

typedef long long ll;

//#define int ll
#define loop(i, n) for (int i = 0; i < n; ++i)
#define loop1(i, n) for (int i = 1; i <= n; ++i)
#define all(x) begin(x), end(x)
#define pi pair <int, int>
#define ti tuple <int, int, int>
#define F first
#define S second

const int N = 5e5 + 7;

int nxt[N], prv[N];
pi cut[N];

void solve() {
	int n, q;
	cin >> n >> q;
	loop1(i, n)
		cin >> cut[i].F >> cut[i].S;
	cut[0] = cut[1];
	cut[n + 1] = cut[n];
	loop(c, q) {
		int l, r;
		cin >> l >> r;
		set <pi> cur;
		for (int i = l; i <= r; ++i) {
			prv[i] = i - 1, nxt[i] = i + 1;
			cur.insert({ cut[i].S - max(cut[i].F - cut[prv[i]].F, cut[nxt[i]].F - cut[i].F), i });
		}
		while (!cur.empty() && cur.begin()->F <= 0) {
			int pos = cur.begin()->S;
			cur.erase(cur.begin());
			int L = prv[pos], R = nxt[pos];
			if (L >= l) {
				cur.erase({ cut[L].S - max(cut[L].F - cut[prv[L]].F, cut[nxt[L]].F - cut[L].F), L });
				nxt[L] = R;
				cur.insert({ cut[L].S - max(cut[L].F - cut[prv[L]].F, cut[nxt[L]].F - cut[L].F), L });
			}
			if (R <= r) {
				cur.erase({ cut[R].S - max(cut[R].F - cut[prv[R]].F, cut[nxt[R]].F - cut[R].F), R });
				prv[R] = L;
				cur.insert({ cut[R].S - max(cut[R].F - cut[prv[R]].F, cut[nxt[R]].F - cut[R].F), R });
			}
		}
		cout << r - l + 1 - cur.size() << "\n";
	}
}

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	solve();
	return 0;
}