#include <bits/stdc++.h>

using namespace std;

const int INF = 1000000001;

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int n, m;
	cin >> n >> m;

	vector< vector< pair<int, int> > > adj(n);
	for(int i = 0; i < m; i++) {
		int u, v, t;
		cin >> u >> v >> t;
		u--; v--;
		adj[u].emplace_back(v, t);
		adj[v].emplace_back(u, t);
	}

	for(auto [v, t]: adj[0]) {
		if(t != 0) {
			return 1;
		}
	}

	exit(1);

	queue<int> q;
	vector<bool> inqueue(n);
	vector<int> dist(n, INF);
	dist[0] = 0;
	q.push(0);
	inqueue[0] = true;
	while(q.size() > 0) {
		int u = q.front();
		q.pop();
		inqueue[u] = false;
		for(auto [v, t]: adj[u]) {
			if(max(dist[u], t) < dist[v]) {
				dist[v] = max(dist[u], t);
				if(!inqueue[v]) {
					inqueue[v] = true;
					q.push(v);
				}
			}
		}
	}

	for(int i = 1; i < n; i++) {
		cout << dist[i] << " ";
	}
	cout << endl;

	return 0;
}