#ifdef DEBUG
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>

using namespace std;
using ll = long long;

#ifndef DEBUG
#define endl '\n'
#endif

void solve();

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    ll t;
    cin >> t;
    while (t--)
        solve();
}

unordered_map<char, ll> dict{
        {'A', 1e0},
        {'B', 5e0},
        {'C', 1e1},
        {'D', 5e1},
        {'E', 1e2},
        {'F', 5e2},
        {'G', 1e3},
        {'H', 5e3},
        {'I', 1e4},
        {'J', 5e4},
        {'K', 1e5},
        {'L', 5e5},
        {'M', 1e6},
        {'N', 5e6},
        {'O', 1e7},
        {'P', 5e7},
        {'Q', 1e8},
        {'R', 5e8},
        {'S', 1e9},
        {'T', 5e9},
        {'U', 1e10},
        {'V', 5e10},
        {'W', 1e11},
        {'X', 5e11},
        {'Y', 1e12},
        {'Z', 5e12},
};

char xch = 0;
ll xps = 0;

template<class Iterator>
ll calc(Iterator rbegin, Iterator rend) {
//    cerr << "calc(" << rend - rbegin << ")" << endl;
    ll ret = 0;
    char mx = 0;
    for (auto e = rbegin; e != rend; ++e) {
        ll q = 0;
        if (*e == '?') {
            if (rend - e - 1 < xps) continue;
            q = dict[xch];
        }
        assert(dict.count((q ? xch : *e)));
        mx = max(mx, (q ? xch : *e));
        if (mx > (q ? xch : *e)) {
            if (q) ret -= q;
            else ret -= dict[*e];
        } else {
            if (q) ret += q;
            else ret += dict[*e];
        }
    }
    return ret;
}


void solve() {
    string s;
    cin >> s;
    string sss = s;
    ll n = s.size();
    vector<ll> pos;
    for (ll i = 0; i < s.size(); ++i) {
        if (s[i] == '?') {
            pos.push_back(i);
        }
    }

    for (int i = 0; i < n; ++i) {
        ll mx = -9e18;
        xps = i;
        char mc = 0;
        if (s[i] == '?') {
            for (char c = 'A'; c <= 'Z'; ++c) {
                xch = c;
                ll v = calc(s.rbegin(), s.rend());
                if (v >= mx) {
                    mx = v;
                    mc = c;
                }
            }
            s[i] = mc;
        }
    }

    ll clc = calc(s.rbegin(), s.rend());
    cout << clc << endl;
    cout << s << endl;
    string ss = s;
    s = sss;
#ifdef DEBUG
    {
        ll mx = -1e18;
        string s2 = s;
        auto check = [&mx, &s, &s2]() -> void {
            ll v = calc(s.rbegin(), s.rend());
            if (v > mx) {
                mx = v;
                s2 = s;
            }
        };

        for (char i = 'A'; i <= 'Z'; ++i) {
            if (pos.size() < 1) break;
            s[pos[0]] = i;
            for (char j = 'A'; j <= 'Z'; ++j) {
                if (pos.size() < 2) break;
                s[pos[1]] = j;
                for (char k = 'A'; k <= 'Z'; ++k) {
                    if (pos.size() < 3) break;
                    s[pos[2]] = k;
                    check();
                }
                check();
            }
            check();
        }
        check();
        cout << s2 << endl;
        cout << calc(s2.rbegin(), s2.rend()) << endl;
        assert(clc == calc(s2.rbegin(), s2.rend()));
    }
#endif
}
