d = {
    'A': int(1e0),
    'B': int(5e0),
    'C': int(1e1),
    'D': int(5e1),
    'E': int(1e2),
    'F': int(5e2),
    'G': int(1e3),
    'H': int(5e3),
    'I': int(1e4),
    'J': int(5e4),
    'K': int(1e5),
    'L': int(5e5),
    'M': int(1e6),
    'N': int(5e6),
    'O': int(1e7),
    'P': int(5e7),
    'Q': int(1e8),
    'R': int(5e8),
    'S': int(1e9),
    'T': int(5e9),
    'U': int(1e10),
    'V': int(5e10),
    'W': int(1e11),
    'X': int(5e11),
    'Y': int(1e12),
    'Z': int(5e12),
}


def calc(s) -> int:
    ret = 0
    mx = '\0'
    for e in s[::-1]:
        assert e in d
        mx = max(mx, e)
        if mx > e:
            ret -= d[e]
        else:
            ret += d[e]
    return ret


def main():
    s = list(input())
    for i in range(len(s)):
        if s[i] == '?':
            mxc = '\0'
            mxv = 0
            for c in d.keys():
                s[i] = c
                v = calc(s[:i + 1])
                if v > mxv:
                    mxc = c
                    mxv = v
            s[i] = mxc
    print(calc(s))
    print(*s, sep='')


if __name__ == '__main__':
    for _ in range(int(input())):
        main()
