#ifdef DEBUG
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>

using namespace std;
using ll = long long;

#ifndef DEBUG
#define endl '\n'
#endif

void solve();

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
//    ll t;
//    cin >> t;
//    while (t--)
    solve();
}

struct tree {
    ll x, h;
};

void solve() {
    ll n, q;
    cin >> n >> q;
    vector<tree> t(n);
    for (int i = 0; i < n; ++i) {
        cin >> t[i].x >> t[i].h;
    }

    for (int qq = 0; qq < q; ++qq) {
        ll l, r;
        cin >> l >> r;
        --l, --r;
        auto vt = t;
        ll cnt = 0;
        for (bool run = true; run;) {
            run = false;
            for (int i = l; i <= r; ++i) {
                if (vt[i].h == 0) continue;
                bool srub = false;
                // <---
                ll j = i - 1;
                while (j >= 0 and vt[j].h == 0) --j;
                srub = (i > 0 and (j < 0 or vt[j].x <= vt[i].x - vt[i].h));
                if (not srub) {
                    // --->
                    j = i + 1;
                    while (j < n and vt[j].h == 0) ++j;
                    srub = (i < n - 1 and (j >= n or vt[j].x >= vt[i].x + vt[i].h));
                }
                if (srub) {
                    run = true;
                    ++cnt;
                    vt[i].h = 0;
                    break;
                }
            }
        }
        cout << cnt << endl;
    }
}

//3 3
//1 3
//3 1
//4 2
//1 1
//2 3
//1 3
