#ifdef DEBUG
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>

using namespace std;
using ll = long long;

#ifndef DEBUG
#define endl '\n'
#endif

void solve();

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
//    ll t;
//    cin >> t;
//    while (t--)
    solve();
}

struct tree {
    ll x, h;
};


void solve() {
    ll n, q;
    cin >> n >> q;
    vector<tree> t(n);
    for (int i = 0; i < n; ++i) {
        cin >> t[i].x >> t[i].h;
    }
    ll L = t.front().x;
    ll R = t.back().x;

    vector<ll> lbad(n);
    for (int i = 0; i < n; ++i) {
        if (t[i].x - t[i].h < L) lbad[i] = -1;
        else if (t[i].x - t[i].h >= t[i - 1].x) lbad[i] = i;
        else {
            lbad[i] = upper_bound(t.begin(), t.end(), tree{t[i].x - t[i].h, 0}, [](
                    tree a, tree b) -> bool {
                return a.x < b.x;
            }) - t.begin();
            assert(lbad[i] < i);
        }
    }
    vector<ll> rbad(n);
    for (int i = 0; i < n; ++i) {
        if (t[i].x + t[i].h > R) rbad[i] = n;
        else if (t[i].x + t[i].h <= t[i + 1].x) rbad[i] = i;
        else {
            auto it = lower_bound(t.begin(), t.end(), tree{t[i].x + t[i].h, 0}, [](
                    tree a, tree b) -> bool {
                return a.x < b.x;
            });
            --it;
            rbad[i] = it - t.begin();
            assert(rbad[i] > i);
        }
    }
    for (int i = 1; i < n; ++i) {
        for (int j = lbad[i]; j < i; ++j) {
            if (lbad[i] == -1) break;
            if (rbad[j] != j) {
                lbad[i] = min(lbad[i], lbad[j]);
            }
        }
    }
    for (ll i = n - 1; i > 0; --i) {
        for (int j = rbad[i]; j > i; --j) {
            if (rbad[i] == n) break;
            if (lbad[j] != j) {
                rbad[i] = max(rbad[i], rbad[j]);
            }
        }
    }

    for (int qq = 0; qq < q; ++qq) {
        ll l, r;
        cin >> l >> r;
        --l, --r;
        ll cnt = 0;
        for (int i = l; i <= r; ++i) {
            if (lbad[i] >= l or rbad[i] <= r) {
                ++cnt;
            }
        }
        cout << cnt << endl;
    }
}

//3 3
//1 3
//3 1
//4 2
//1 1
//2 3
//1 3

//5 0
//1 5
//2 3
//3 1
//7 10
//8 1
