#include "bits/stdc++.h"
using ll = long long;
#define int ll
#define F first
#define S second
#define mp make_pair
#define pb push_back
#define pob pop_back
using namespace std;
using pii=pair<int, int>;
using vint=vector<int>;
using vpii=vector<pii>;

#define all(v) (v).begin(), (v).end()
#define range(i, n) for (int i = 0; i < n; ++i)
#define sz(s) int(s.size())

const int inf = 2e18+5;
const int N = 3e5+5;

vpii g[N];
int n, m;
int ans[N];
bool used[N];
vint e;

void dfs(int v, int mn = inf, int mx = -inf) {
	// cerr << v << ' ' << mn << ' ' << mx << '\n';
	ans[v] = min(ans[v], mx + mn);
	for (pii toe: g[v]) {
		int to = toe.F;
		if (used[toe.S])
			continue;
		used[toe.S] = 1;
		int w = e[toe.S];
		dfs(to, min(mn, w), max(mx, w));
		used[toe.S] = 0;
	}
}

void solve() {
	cin >> n >> m;
	range(i, n)
		ans[i] = inf;
	range(i, m) {
		int x, y, t;
		cin >> x >> y >> t;
		--x; --y;
		g[x].pb({y, i});
		g[y].pb({x, i});
		e.pb(t);
	}
	dfs(0);
	for (int i = 1; i < n; ++i) {
		cout << ans[i] << '\n';
	}
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(NULL);
	solve();
}