#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
#define pb push_back
#define pll pair<ll, ll>

const ll inf = ll(4e18) + 123;

vector<ll> vals(26, 0);

void solve() {
    string s;
    cin >> s;
    ll n = s.size();

    vector<ll> suf_mx(n + 1, 0);

    for(ll i = n - 1; i >= 0; i--) {
        ll cur = 0;
        if(s[i] != '?') cur = s[i] - 'A';

        suf_mx[i] = max(cur, suf_mx[i + 1]);
    }

    ll dp[n + 1][26];
    ll par[n + 1][26];
    char let[n + 1][26];
    for(ll i = 0; i < n + 1; i++) {
        for(ll j = 0; j < 26; j++) {
            dp[i][j] = -inf;
            par[i][j] = -1;
            let[i][j] = ' ';
        }
    }
    for(ll i = 0; i < 26; i++) {
        dp[0][i] = 0;
    }

    for(ll i = 0; i < n; i++) {
        for(ll j = 25; j >= 0; j--) {
            if(s[i] != '?') {
                if(j > s[i] - 'A' || suf_mx[i] > s[i] - 'A') {
                    ll nw = dp[i][j] - vals[s[i] - 'A'];
                    if(nw > dp[i + 1][j]) {
                        dp[i + 1][j] = nw;
                        par[i + 1][j] = j;
                        let[i + 1][j] = s[i];
                    }
                } else {
                    ll nw = dp[i][j] + vals[s[i] - 'A'];
                    if(nw > dp[i + 1][j]) {
                        dp[i + 1][j] = nw;
                        par[i + 1][j] = j;
                        let[i + 1][j] = s[i];
                    }
                }
            } else {
                /// it is last
                if(j > 0) {
                    if(suf_mx[i] > j) {
                        ll nw = dp[i][j] - vals[j];
                        if(nw > dp[i + 1][j - 1]) {
                            dp[i + 1][j - 1] = nw;
                            par[i + 1][j - 1] = j;
                            let[i + 1][j - 1] = char('A' + j);
                        }
                    } else {
                        ll nw = dp[i][j] + vals[j];
                        if(nw > dp[i + 1][j - 1]) {
                            dp[i + 1][j - 1] = nw;
                            par[i + 1][j - 1] = j;
                            let[i + 1][j - 1] = char('A' + j);
                        }
                    }
                }

                /// not last
                if(suf_mx[i] > j) {
                    ll nw = dp[i][j] - vals[j];
                    if(nw > dp[i + 1][j]) {
                        dp[i + 1][j] = nw;
                        par[i + 1][j] = j;
                        let[i + 1][j] = char('A' + j);
                    }
                } else {
                    ll nw = dp[i][j] + vals[j];
                    if(nw > dp[i + 1][j]) {
                        dp[i + 1][j] = nw;
                        par[i + 1][j] = j;
                        let[i + 1][j] = char('A' + j);
                    }
                }
            }
        }
    }

    ll mx = -inf;
    ll mx_pos = -1;
    for(ll i = 0; i < 26; i++) {
        if(dp[n][i] > mx) {
            mx = dp[n][i];
            mx_pos = i;
        }
    }

    string ans = "";
    for(ll i = n; i > 0; i--) {
        ans += let[i][mx_pos];
        mx_pos = par[i][mx_pos];
    }
    reverse(ans.begin(), ans.end());

    cout << mx << "\n";
    cout << ans << "\n";
}

int main()
{
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    vals[0] = 1;
    vals[1] = 5;
    for(ll i = 2; i < 26; i++) {
        vals[i] = vals[i - 2] * 10;
    }

    ll q;
    cin >> q;
    for(ll i = 0; i < q; i++)
    solve();

    return 0;
}
