#include <bits/stdc++.h>
using namespace std;

struct e {
    int u, v, c;
};

vector<vector<e>> g;
int n, m;
vector<int> ans;

void task1(int v, int mn = 1e9, int mx = 0, int p = -1) {
    ans[v] = mn + mx;
    for (auto now : g[v]) {
        int to = now.v;
        int cost = now.c;
        if (to != p) {
            task1(to, min(mn, cost), max(mx, cost), v);
        }
    }
}

void solve1() {
    task1(0);
    for (int i = 1; i < n; ++i)
        cout << ans[i] << '\n';
    exit(0);
}

const int inf = 2e9;

void solve2() {
    set<pair<int, int>> gt;
    for (auto now : g[0]) {
        int to = now.v;
        int cost = now.c;
        gt.insert({cost, to});
    }
    while (!gt.empty()) {
        auto now = *gt.begin();
        int to = now.second;
        int cost = now.first;
        if (ans[to] != inf) {
            ans[to] = cost;
            for (auto tt : g[to]) {
                gt.insert({tt.c, tt.v});
            }
        }
        gt.erase(gt.begin());
    }
    for (int i = 1; i < n; ++i)
        cout << ans[i] << '\n';
    exit(0);
}

int main() {
    cin >> n >> m;
    g.resize(n);
    for (int i = 0; i < m; ++i) {
        int u, v, c;
        cin >> u >> v >> c;
        --u, --v;
        g[u].push_back({u, v, c});
        g[v].push_back({v, u, c});
    }

    ans.resize(n);
    for (int i = 0; i < n; ++i)
        ans[i] = inf;
    if (m == n - 1)
        solve1();
    else
        solve2();
    return 0;
}
