#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <math.h>
#include <vector>
#include <string>
#include <map>

using namespace std;

typedef long long ll;

const ll N = 3e5 + 10;
const ll inf = 1e18;

vector <pair <ll, ll>> e[N];
ll ans[N];

void dfs(ll x, ll p, ll mi, ll ma){
	ans[x] = mi + ma;
	for (ll i = 0; i < e[x].size(); i++) {
		if (p == e[x][i].first){
			continue;
		}
		dfs(e[x][i].first, x, min(mi, e[x][i].second), max(ma, e[x][i].second));
	}
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	ll n, m;
	cin >> n >> m;
	for (ll i = 0; i < n; i++) {
		ll a, b, c; cin >> a >> b >> c;
		a--; b--;
		e[a].push_back(make_pair(b, c));
		e[b].push_back(make_pair(a, c));
	}
	dfs(0);
	for (ll i = 1; i < n; i++) {
		cout << ans[i] << '\n';
	}
}