#include <bits/stdc++.h>
using namespace std;

#define ios ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
using ll = long long;
using ld = long double;
using ull = unsigned long long;

#define all(v) v.begin(), v.end()

inline int h(char c)
{
    return c - 'A';
}

vector<ll> val(26, 1);

ll get(int x)
{
    if(x < 0)
        return 0;
    return val[x];
}

signed main()
{
    ios;
    int t;
    cin >> t;
    for(int i = 1; i < 26; ++i)
    {
        if(i % 2 == 1)
        {
            val[i] = 5 * val[i - 1];
        }
        else
        {
            val[i] = 2 * val[i - 1];
        }
    }
    while(t--)
    {
        string s;
        cin >> s;
        int n = s.size();
        vector<vector<ll> > pref(n, vector<ll>(26, 0));
        vector<int> suf(n, 0);
        if(s[0] != '?')
            pref[0][h(s[0])] = 1;
        if(s[n - 1] != '?')
            suf[n - 1] = h(s[n - 1]);
        else
            suf[n - 1] = 0;
        for(int i = n - 2; i >= 0; --i)
        {
            suf[i] = suf[i + 1];
            if(s[i] != '?')
                suf[i] = max(suf[i], h(s[i]));
        }
        for(int i = 1; i < n; ++i)
        {
            pref[i] = pref[i - 1];
            if(s[i] != '?')
                ++pref[i][h(s[i])];
        }
        int last = 25;
        ll cur = 0;
        for(int i = 0; i < n; ++i)
        {
            if(s[i] != '?')
            {
                if(h(s[i]) >= suf[i])
                    cur += val[h(s[i])];
                else
                    cur -= val[h(s[i])];
            }
            else
            {
                ll delta = 0;
                pair<ll, int> best = {-1, -1};
                for(int j = suf[i]; j <= last; ++j)
                {
                    delta += val[j];
                    ll d = 0;
                    for(int k = suf[i]; k < j; ++k)
                        delta -= 2 * val[k] * pref[i][k];
                    best = max(best, make_pair(delta, j));
                    delta = 0;
                }
                cur += best.first;
                last = best.second;
                s[i] = 'A' + last;
            }
        }
        cout << cur << '\n' << s << '\n';
    }
    return 0;
}

/**
4
BBBC
????
A?B?C?D
YYYYY?
**/
