#include <bits/stdc++.h>

#define int long long
#define all(x) x.begin(), x.end()

using namespace std;

const int MAXN = 550;

int dp[MAXN][MAXN];

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, q;
    cin >> n >> q;
    vector<int> x(n + 2), h(n + 2);
    for (int i = 0; i < n; i++) {
        cin >> x[i + 1] >> h[i + 1];
    }
    x[0] = x[1];
    x[n + 1] = x[n];
    for (int i = 0; i <= n + 2; i++) {
        dp[i][i] = 1;
    }
    for (int l = n; l >= 1; l--) {
        for (int r = l + 1; r <= n + 1; r++) {
            for (int k = l; k < r; k++) {
                if (dp[l][k] && dp[k + 1][r] && (x[l - 1] <= x[k] - h[k] || x[r] >= x[k] + h[k])) {
                    dp[l][r] = 1;
                }
            }
        }
    }
    while (q--) {
        int l, r;
        cin >> l >> r;
        vector<int> dp2(n + 1);
        for (int i = l; i <= r; i++) {
            for (int j = i; j >= l; j--) {
                if (dp[j][i + 1]) {
                    dp2[i] = max(dp2[i], dp2[j - 1] + (i - j + 1));
                }
            }
        }
        cout << dp2[r] << '\n';
    }
}