#include <bits/stdc++.h>

#define int long long
#define all(x) x.begin(), x.end()

using namespace std;

const int INF = (int) 1e15;
const int MAXN = 300500;

vector<pair<int, int>> g[MAXN];
int res[MAXN];

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m;
    cin >> n >> m;
    for (int i = 1; i <= n; i++) {
        res[i] = 0;
    }
    vector<tuple<int, int, int>> edges(m);
    for (auto &el : edges) {
        int u, v, w;
        cin >> u >> v >> w;
        g[u].emplace_back(v, w);
        g[v].emplace_back(u, w);
    }
    res[1] = 0;
    set<pair<int, int>> heap = {{0, 1}};
    while (!heap.empty()) {
        auto now = *heap.begin();
        heap.erase(heap.begin());
        int dist = now.first, v = now.second;
        for (auto el : g[v]) {
            int u = el.first, w = el.second;
            int val = max(dist, w);
            if (val > res[u]) {
                res[u] = val;
                heap.insert({val, u});
            }
        }
    }
    for (int i = 2; i <= n; i++) {
        cout << res[i] << '\n';
    }
}