#define _CRT_SECURE_NO_WARNINGS

#pragma GCC optimize("Ofast")

#include <iostream>
#include <algorithm>
#include <fstream>
#include <cmath>
#include <math.h>
#include <fstream>
#include <set>
#include <vector>
#include <queue>
#include <iomanip>
#include <string>

using namespace std;

#define ll long long
#define BE(x) x.begin(), x.end()
#define endl '\n'

const int N = 4e5;
const ll bes = 2e18;

struct Node
{
	Node* r, * l;
	int x, h;
	int ind;
	Node() :l(nullptr), r(nullptr) {}
};

const int M = 1e7;
Node buf[M];
int CNT;

Node* new_Node()
{
	return buf + CNT++;
}

int h[N];
int x[N];
bool p[N];

Node gg[N];

int l, r;

void del(Node* root)
{
	if (root->r && root->r->ind <= r)
	{
		root->r->l = root->l;
	}
	if (root->l && root->l->ind >= l)
	{
		root->l->r = root->r;
	}
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int n, q;
	cin >> n >> q;
	for (int i = 0; i < n; i++)
	{
		cin >> x[i] >> h[i];
		gg[i].x = x[i];
		gg[i].h = h[i];
		gg[i].ind = i;
		if (i > 0)
		{
			gg[i].l = &gg[i - 1];
			gg[i - 1].r = &gg[i];
		}
	}
	while (q--)
	{
		cin >> l >> r;
		l--;
		r--;
		int cnt = 0;
		Node* st = nullptr;
		for (int i = l; i <= r; i++)
		{
			if (st == nullptr)
			{
				st = new_Node();
				*st = gg[i];
			}
			else
			{
				auto now = new_Node();
				*now = gg[i];
				now->l = st;
				st->r = now;
				st = now;
			}
		}
		while (true)
		{
			if (st == nullptr || st->ind < l)
			{
				break;
			}
			bool fl = false;
			if (st->r != nullptr && st->r->x - st->x >= st->h)
			{
				fl = true;
			}
			if (st->l != nullptr && st->x - st->l->x >= st->h)
			{
				fl = true;
			}
			Node* now =st->l;
			if (fl)
			{
				cnt++;
			cont:;
				int L, R;
				if (st->l)
				{
					L = st->l->x;
				}
				else
				{
					L = x[0];
				}
				if (st->r)
				{
					R = st->r->x;
				}
				else
				{
					R = x[n - 1];
				}
				if (st->r != nullptr && st->r->ind <= r && st->r->x - L >= st->r->h)
				{
					cnt++;
					del(st->r);
					goto cont;
				}
				if (st->l != nullptr && st->l->ind >= l && R - st->l->x >= st->l->h)
				{
					cnt++;
					del(st->l);
					goto cont;
				}
				now = st->l;
				del(st);
			}
			st = now;
		}
		cout << cnt << endl;
	}
}