#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

const int N = 3e5 + 7;

int n, m;
vector<int> g[N];
vector<pair<int, int>> e;
int p[N];
bool vis[N];
int up[N], down[N];
vector<pair<pair<int, int>, pair<int, int>>> ans;

void dfs(int v, int par = -1) {
    p[v] = par;
    vis[v] = true;
    vector<int> gg;
    for (int u : g[v]) {
        if (u != par) {
            dfs(u, v);
            gg.push_back(u);
        }
    }
    g[v] = gg;
}

void solve(int v) {
    vector<int> ups, downs;
    for (int u : g[v]) {
        solve(u);
        if (up[u]) ups.push_back(u);
        if (down[u]) downs.push_back(u);
    }
    int can = min(ups.size(), downs.size());
    for (int i = 0; i < can; ++i) {
        ans.push_back({{ups[i], v}, {v, downs[i]}});
    }
    reverse(ups.begin(), ups.end());
    reverse(downs.begin(), downs.end());
    for (int i = 0; i < can; ++i) ups.pop_back(), downs.pop_back();
    if (up[v] < ups.size() || down[v] < downs.size()) {
        cout << "No" << endl;
        exit(0);
    }
    if (!ups.empty()) {
        ans.push_back({{v, p[v]}, {ups[0], v}});
        up[v] = 0;
    }
    if (!downs.empty()) {
        ans.push_back({{p[v], v}, {v, downs[0]}});
        down[v] = 0;
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    cin >> n >> m;
    while (m--) {
        int u, v;
        cin >> u >> v;
        --u;
        --v;
        e.push_back({u, v});
        g[u].push_back(v);
        g[v].push_back(u);
    }
    for (int i = 0; i < n; ++i) {
        sort(g[i].begin(), g[i].end());
        g[i].erase(unique(g[i].begin(), g[i].end()), g[i].end());
    }
    for (int i = 0; i < n; ++i) {
        if (!vis[i]) {
            dfs(i);
        }
    }
    for (auto x : e) {
        if (p[x.second] == x.first) {
            down[x.second] = 1;
        } else {
            up[x.first] = 1;
        }
    }
    for (int i = 0; i < n; ++i) {
        if (p[i] == -1) {
            solve(i);
            if (up[i] != 0 || down[i] != 0) {
                cout << "No" << endl;
                exit(0);
            }
        }
    }
    cout << "Yes" << endl;
    for (auto x : ans) cout << x.first.first + 1 << " " << x.first.second + 1 << " " << x.second.first + 1 << " " << x.second.second + 1 << '\n';
    return 0;
}
