#include<bits/stdc++.h>

using std::cin;
using std::cout;
using std::cerr;
using std::vector;
using std::pair;
using std::string;

using ll = long long;
using ld = long double;

const int INF = 1e9;

vector<vector<pair<int, int>>> g;
vector<int> ans;

void dfs (int u, pair<int, int> cur = {0, INF}, int p = -1) {
	ans[u] = cur.first + cur.second;
	for (auto pr : g[u]) {
		int v = pr.first;
		int t = pr.second;
		if (v != p) {
			dfs(v, (pair<int, int>){std::max(cur.first, t), std::min(cur.second, t)}, u);
		}
	}
}

int main() {
	std::ios_base::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	int n, m;
	cin >> n >> m;
	g.resize(n), ans.resize(n);

	for (int i = 0; i < m; ++i) {
		int u, v, t;
		cin >> u >> v >> t;
		--u, --v;
		g[u].push_back({v, t});
		g[v].push_back({u, t});
	}

	dfs(0);
	for (int i = 1; i < n; ++i)
		cout << ans[i] << ' ';



	return 0;
}