#pragma GCC target("avx2")
#pragma GCC optimize("O3")
#include <bits/stdc++.h>
#define int long long
using namespace std;

const int maxn = 3e5 + 228;
vector<pair<int, int> > g[maxn];
int ans[maxn];
int link[maxn];
int sizex[maxn];

int find(int a){
    return (link[a] == a ? a : link[a] = find(link[a]));
}

void unite(int a, int b){
    a = find(a);
    b = find(b);
    if(sizex[a] > sizex[b])
        swap(a, b);
    link[a] = b;
    sizex[b] += a;
}

bool same(int a, int b){
    return find(a) == find(b);
}

bool cmp(pair<int, pair<int, int> > a, pair<int, pair<int, int> > b){
    return a.second.second < b.second.second;
}

void dfs(int v, int p = -1, int mn = 1e9, int mx = 0){
    ans[v] = mn + mx;
//    cout << v << " " << mn << " " << mx << endl;
    for(pair<int, int> i:g[v]){
        if(i.first == p)
            continue;
        dfs(i.first, v, min(mn, i.second), max(mx, i.second));
    }
}

int dp[1<<20];
pair<int, int> p[1<<20];

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    vector<pair<int, int> > kek(m);
    for(int i=0; i<m; i++){
        int a, b;
        cin >> a >> b;
//        a--, b--;
        kek[i] = make_pair(a, b);
    }
    dp[0] = 1;
    for(int i=1; i<(1<<m); i++){
        for(int j=0; j<m; j++){
            if(dp[i])
                continue;
            for(int l=j + 1; l<m; l++){
                if(((1<<l) & i) && ((1<<j) & i) && dp[i ^ (1<<j) ^ (1<<l)] && (kek[j].second == kek[l].first || kek[j].first == kek[l].second)){
                    dp[i] = 1;
//                    cout << i << endl;
                    p[i] = make_pair(j, l);
                }
            }
        }
    }
    if(dp[(1<<m) - 1]){
        cout << "Yes" << endl;
        int cur = (1<<m) - 1;
        while(cur){
            if(kek[p[cur].first].second == kek[p[cur].second].first)
                cout << kek[p[cur].first].first << " " << kek[p[cur].first].second << " " << kek[p[cur].second].first << " " << kek[p[cur].second].second << endl;
            else
                cout << kek[p[cur].first].second << " " << kek[p[cur].first].first << " " << kek[p[cur].second].second << " " << kek[p[cur].second].first << endl;
            cur ^= (1<<p[cur].first) ^ (1<<p[cur].second);
        }
    } else{
        cout << "No" << endl;
    }

    return 0;
}
/*
3 3
1 2 2
1 3 1
2 3 1
==========
4 4
1 2 2
3 2 0
2 4 3
4 3 1
========
5 6
1 2
2 1
1 5
2 3
2 4
4 2
 */