#include <iostream>
#include <unordered_map>
#include <vector>
#include <algorithm>
using namespace std;
vector<long long> order;

vector<long long> tin, vis;
vector<unordered_map<long long, long long> > a;
vector<unordered_map<long long, long long> > nums;
vector<long long> depth;

vector<long long> tout;
long long ctr = -1;
void dfs(long long v, long long p) {
	tin[v] = ++ctr;
	vis[v] = true;
	if (p == -1) {
		depth[v] = 0;
	}
	else {
		depth[v] = depth[p] + 1;
	}
	for (auto h : a[v]) {
		if (!vis[h.first])
			dfs(h.first, v);
	}
	tout[v] = ctr;
}
vector<long long> d, c;
void push(long long v) {
	if (c[v] != -1) {
		if (c[2 * v + 1] == -1) {
			c[2 * v + 1] = c[v];
		}
		else {
			c[2 * v + 1] = min(c[2 * v + 1], c[v]);
		}

		if (c[2 * v + 2] == -1) {
			c[2 * v + 2] = c[v];
		}
		else {
			c[2 * v + 2] = min(c[2 * v + 2], c[v]);
		}
	}
	c[v] = -1;
}
void update(long long v) {
	d[v] = min(d[2 * v + 1], d[2 * v + 2]);
	if (c[2 * v + 1] != -1) {
		d[v] = min(d[v], c[2 * v + 1]);
	}
	if (c[2 * v + 2] != -1) {
		d[v] = min(d[v], c[2 * v + 2]);
	}

}
long long ask(long long v, long long l, long long r, long long askl, long long askr) {
	if (l > askr || r < askl) {
		return 1e9;
	}
	if (l >= askl && r <= askr) {
		if (c[v] == -1)
			return d[v];
		return min(d[v], c[v]);
	}
	push(v);
	long long aa = ask(2 * v + 1, l, (l + r) / 2, askl, askr);
	long long bb = ask(2 * v + 2, (l + r) / 2 + 1, r, askl, askr);
	update(v);
	return min(aa, bb);

}
void add(long long v, long long l, long long r, long long addl, long long addr, long long val) {
	if (l > addr || r < addl) {
		return;
	}
	if (l >= addl && r <= addr) {
		if (c[v] == -1) {
			c[v] = val;
		}
		else {
			c[v] = min(c[v], val);
		}
		return;
	}
	push(v);
	add(2 * v + 1, l, (l + r) / 2, addl, addr, val);
	add(2 * v + 2, (l + r) / 2 + 1, r, addl, addr, val);
	update(v);
}
long long n, m;
void dfs2(long long v, long long way, long long p) {
	vis[v] = true;
	add(0, 0, n - 1, tin[v], tout[v], way);
	vector<pair<long long, long long> > rvrs;
	for (auto h : a[v]) {
		if (!vis[h.first]) {
			dfs2(h.first, h.second, v);
		}
		else {
			if (h.first != p && depth[h.first] < depth[v])
				rvrs.push_back(h);
		}

	}
	for (auto h : rvrs) {
		if (1) {
			add(0, 0, n - 1, tin[h.first], tout[h.first], min(ask(0, 0, n - 1, tin[v], tout[v]), h.second));
		}
	}
	if (p != -1 && nums[v][p] > 1) {
		add(0, 0, n - 1, tin[p], tout[p], min(ask(0, 0, n - 1, tin[v], tout[v]), way));

	}
}
int main() {
	cin >> n >> m;
	a.resize(n);
	tin.resize(n);
	tout.resize(n);
	vis.resize(n);
	d.resize(4 * n);
	d.assign(4 * n, 1e9);
	c.resize(4 * n);
	c.assign(4 * n, -1);
	nums.resize(n);
	depth.resize(n);
	for (long long i = 0; i < m; i++) {
		long long t1, t2, t3;
		cin >> t1 >> t2 >> t3;
		t1--;
		t2--;
		nums[t1][t2]++;
		nums[t2][t1]++;
		if (a[t1].find(t2) == a[t1].end()) {
			a[t1][t2] = t3;
		}
		else {
			a[t1][t2] = min(a[t1][t2], t3);
		}

		if (a[t2].find(t1) == a[t2].end()) {
			a[t2][t1] = t3;
		}
		else {
			a[t2][t1] = min(a[t2][t1], t3);
		}
	}
	dfs(0, -1);
	vis.assign(n, 0);;
	dfs2(0, 1e9, -1);
	for (long long i = 1; i < n; i++) {
		long long aaa= ask(0, 0, n - 1, tin[i], tin[i])+1e9;
		cout << aaa << '\n';
	}

}