#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ft first
#define sd second
#define pb push_back
#define eb emplace_back
#define all(x) (x).begin(), (x).end()

bool check(int i, vector<int> &xs, vector<int> &hs, vector<bool> &dead){
    //cout << "i: " << i << endl;
    if (xs[i] - hs[i] >= xs[0]){
        //cout << "left" << endl;
        bool ok = true;
        for (int j = i - 1; j >= 0 && xs[j] > xs[i] - hs[i]; j--)
            if (!dead[j]){
                ok = false;
                break;
            }
        if (ok)
            return true;
    }
    if (xs[i] + hs[i] <= xs.back()){
        //cout << "right" << endl;
        bool ok = true;
        for (int j = i + 1; j < xs.size() && xs[j] < xs[i] + hs[i]; j++)
            if (!dead[j]){
                ok = false;
                break;
            }
        if (ok)
            return true;
    }
    return false;
}

signed main(){
    cin.tie(0);
    ios_base::sync_with_stdio(false);
    int n, q;
    cin >> n >> q;
    vector<int> xs(n);
    vector<int> hs(n);
    for (int i = 0; i < n; i++)
        cin >> xs[i] >> hs[i];

    int lt, rt;
    for (int quest = 0; quest < q; quest++){
        cin >> lt >> rt;
        lt--; rt--;
        int cnt = 0; bool run = true;
        vector<bool> dead(n);
        while (run){
            run = false;
            for (int i = lt; i <= rt; i++)
                if (!dead[i] && check(i, xs, hs, dead)){
                    dead[i] = true;
                    cnt++;
                    run = true;
                }
//            cout << "dead:\n";
//            for (bool el : dead)
//                cout << el << ' ';
//            cout << endl;
        }
        cout << cnt << "\n";
    }
    return 0;
}