#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

const long long INF = 1e18;

void solve() {
	string s;
	cin >> s;
	int n = s.size();
	vector<long long> dp(26);
	vector<long long> val(26, 1);
	vector<vector<pair<char, int>>> last(n, vector<pair<char, int>> (26));
	for (int i = 1; i < 26; ++i) {
		if (i % 2 == 1)
			val[i] = val[i - 1] * 5;
		else
			val[i] = val[i - 1] * 2;
	}
	// cout << s << ':' << n << '\n';
	// for (auto i : val)
	// 	cout << i << ' ';
	// cout << '\n';

	for (int i = n - 1; i >= 0; --i) {
		vector<long long> _dp(26, -INF);
		if (s[i] == '?') {
			for (int k = 0; k < 26; ++k) {
				for (int j = 0; j <= k; ++j) {
					if (dp[j] + val[k] > _dp[k]) {
						last[i][k] = {k + 'A', j};
						_dp[k] = dp[j] + val[k];
					}
				}
				for (int j = k + 1; j < 26; ++j) {
					if (dp[j] - val[k] > _dp[j]) {
						last[i][j] = {k + 'A', j};
						_dp[j] = dp[j] - val[k];
					}
				}
			}
		} else {
			for (int k = 0; k <= s[i] - 'A'; ++k) {
				if (dp[k] + val[s[i] - 'A'] > _dp[s[i] - 'A']) {
					last[i][s[i] - 'A'] = {s[i], k};
					_dp[s[i] - 'A'] = dp[k] + val[s[i] - 'A'];
				}
			}
			for (int k = s[i] - 'A' + 1; k < 26; ++k) {
				if (dp[k] - val[s[i] - 'A'] > _dp[k]) {
					last[i][k] = {s[i], k};
					_dp[k] = dp[k] - val[s[i] - 'A'];
				}
			}
		}
		dp = _dp;
	}
	string res;
	pair<int, int> now = {0, 0};
	pair<long long, int> ans = {-INF, 0};
	for (int i = 0; i < 26; ++i)
		ans = max(ans, make_pair(dp[i], i));
	cout << ans.first << '\n';
	now.second = ans.second;
	while (now.first < n) {
		res += last[now.first][now.second].first;
		now.second = last[now.first][now.second].second;
		now.first++;
	}
	cout << res << '\n';
}

int main() {
	// ios_base::sync_with_stdio(0);
	// cin.tie(0);
	// cout.tie(0);

	int t;
	cin >> t;
	while (t--)
		solve();
}