#include <iostream>
#include <vector>
#include <algorithm>
#include <array>
#include <set>

using namespace std;

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

const int INF = 1e9 + 228;

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n, m;
	cin >> n >> m;
	vector<int> to(n - 1);
	for (int i = 0; i < m; ++i) {
		int a, b, t;
		cin >> a >> b >> t;
		if (b < a)
			swap(a, b);
		--a, --b;
		if (b - a == 1)
			to[a] = min(to[a], t);
	}
	int res1 = INF;
	int res2 = 0;
	for (int i = 0; i < n - 1; ++i) {
		res1 = min(res1, to[i]);
		res2 = max(res2, to[i]);
		cout << res1 + res2 << '\n';
	}
}