#include <iostream>
#include <iomanip>
#include <cstdlib>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <string>
#include <vector>
#include <map>
#include <random>
#include <set>
#include <queue>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> pll;
typedef vector<ll> vi;
typedef vector<vi> vvi;

const ll mx1 = 3e5, inff = 1e18;

#define ff first
#define ss second
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define pb push_back
#define vec vector

vec<pll> ans(mx1, { inff, 0 });
vec<vec<pll>> g(mx1);
vi t(mx1);

void dfs(ll v, ll p = -1) {
	for (auto u : g[v]) {
		if (u.ff != p) {
			ans[u.ff] = { min(ans[v].ff, t[u.ss]), max(ans[v].ss, t[u.ss]) };
			dfs(u.ff, v);
		}
	}
}

void run() {
	ll n, m;
	cin >> n >> m;
	for (ll i = 0, v, u; i < m; ++i) {
		cin >> v >> u >> t[i];
		v--, u--;
		g[v].pb({ u, i });
		g[u].pb({ v, i });
	}
	dfs(0, -1);
	for (ll i = 1; i < n; ++i)
		cout << ans[i].ff + ans[i].ss << '\n';
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	ll tkk = 1, kk = 0;
	//cin >> tkk;
	while (kk++ < tkk) {
		run();
		//cout << '\n';
	}
	return 0;
}

/*
3 3
1 2 2
1 3 1
2 3 1

4 4
1 2 2
3 2 0
2 4 3
4 3 1

3 3
1 3
3 1
4 2
1 1
2 3
1 3
*/