#include <iostream>
#include <iomanip>
#include <cstdlib>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <string>
#include <vector>
#include <map>
#include <random>
#include <set>
#include <queue>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> pll;
typedef vector<ll> vi;
typedef vector<vi> vvi;

const ll mx1 = 3e5, inff = 1e18;

#define ff first
#define ss second
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define pb push_back
#define vec vector

vec<pll> ans(mx1, { inff, 0 });
vec<vec<pll>> g(mx1);
vi t(mx1);

void run() {
	ll n, m;
	cin >> n >> m;
	for (ll i = 0, v, u; i < m; ++i) {
		cin >> v >> u >> t[i];
		v--, u--;
		g[v].pb({ u, i });
		g[u].pb({ v, i });
	}
	vi dist(n, inff);
	dist[0] = 0;
	set<pll> s;
	for (auto v : g[0]) {
		dist[v.ff] = 0;
		s.insert({ 0, v.ff });
	}
	while (!s.empty()) {
		ll v = s.begin()->ss;
		s.erase(s.begin());
		for (auto u : g[v]) {
			if (dist[u.ff] > max(dist[v], t[u.ss])) {
				s.erase({ dist[u.ff], u.ff });
				dist[u.ff] = max(dist[v], t[u.ss]);
				s.insert({ dist[u.ff], u.ff });
			}
		}
	}
	for (ll i = 1; i < n; ++i)
		cout << dist[i] << '\n';
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	ll tkk = 1, kk = 0;
	//cin >> tkk;
	while (kk++ < tkk) {
		run();
		//cout << '\n';
	}
	return 0;
}

/*
5 5
1 2 0
1 3 0
1 4 0
2 5 0
3 5 3

3 3
1 2 2
1 3 1
2 3 1

4 4
1 2 2
3 2 0
2 4 3
4 3 1

3 3
1 3
3 1
4 2
1 1
2 3
1 3
*/