#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <cassert>
#include <cmath>
#include <cstring>

using namespace std;

#define int long long
#define fi first
#define se second
#define all(x) x.begin(),x.end()

vector<vector<int>> gr;
vector<int> ans;


int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    int inf = 1e15;
    gr.resize(n, vector<int>(n, inf));
    ans.resize(n, inf);
    vector<vector<int>> E;
    for (int i = 0; i < m; ++i) {
        int u, v, c;
        cin >> u >> v >> c;
        u--; v--;
        gr[u][v] = c;
        gr[v][u] = c;
        E.push_back({u, v, c});
    }

    vector<int> p(m);
    for (int i = 0; i < m; ++i) {
        p[i] = i;
    }

    do {
        if (E[p[0]][0] != 0 && E[p[0]][1] != 0) continue;
        int last;
        if (E[p[0]][0] == 0) last = E[p[0]][1];
        else  last = E[p[0]][0];
        int mn = E[p[0]][2], mx = E[p[0]][2];
        ans[last] = min(ans[last], mn + mx);


        for (int i = 1; i < m; ++i) {
            if (E[p[i]][1] == last) swap(E[p[i]][0], E[p[i]][1]);

            if (E[p[i]][0] != last) break;
            last = E[p[i]][1];

            mn = min(mn, E[p[i]][2]);
            mx = max(mx, E[p[i]][2]);
            ans[last] = min(ans[last], mn + mx);
        }
    } while (next_permutation(all(p)));

    for (int i = 1; i < n; ++i) {
        cout << ans[i] << ' ';
    }
}