#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define mp make_pair
#define pii pair <int, int>
#define sz(a) (int)(a).size()
#define ff first
#define ss second
#define all(a) (a).begin(), (a).end()

typedef long long ll;
#define int ll

const int inf = 1e9 + 100;
const int inf64 = 1ll * inf * inf;

int n, m;

vector <vector <int>> g;
vector <unordered_set <int>> rs;
vector <char> used;

vector <pair <pii, pii>> ans;


// 0 - ok; 1 - up; 2 - down; 3 - not ok
pair <int, pii> dfs(int v, int p = -1){
    used[v] = 1;
    multiset <pii> up;
    multiset <pii> down;
    for(int i = 0; i < sz(g[v]); ++i){
        auto u = g[v][i];
        if(u == p)
            continue;
        auto t = dfs(u, v);
        if(t.ff == 3){
            return t;
        }
        else if(t.ff == 0){
            if(rs[v].find(u) != rs[v].end())
                down.insert(mp(v, u));
            if(rs[u].find(v) != rs[u].end())
                up.insert(mp(u, v));
        }
        else if(t.ff == 1){
            if(rs[u].find(v) != rs[u].end()){
                ans.pb(mp(t.ss, mp(u, v)));
            }
            if(rs[v].find(u) != rs[v].end()){
                down.insert(mp(v, u));
            }
        }
        else if(t.ff == 2){
            if(rs[v].find(u) != rs[v].end()){
                ans.pb(mp(t.ss, mp(v, u)));
            }
            if(rs[u].find(v) != rs[u].end()){
                up.insert(mp(u, v));
            }
        }
    }
    while(up.size() && down.size()){
        ans.pb(mp(*up.begin(), *down.begin()));
        up.erase(up.begin());
        down.erase(down.begin());
    }
    if(up.size() > 1){
        return mp(3, pii());
    }
    if(down.size() > 1){
        return mp(3, pii());
    }
    if(up.size() == 1){
        return mp(1, *up.begin());
    }
    if(down.size() == 1){
        return mp(2, *down.begin());
    }
    if(up.size() == 0 && down.size() == 0){
        return mp(0, pii());
    }
    assert(0);
}

void run(){
    cin >> n >> m;
    g.resize(n);
    rs.resize(n);
    for(int i = 0; i < m; ++i){
        int v, u;
        cin >> v >> u;
        --v;
        --u;
        rs[v].insert(u);
        g[v].pb(u);
        g[u].pb(v);
    }
    for(int v = 0; v < n; ++v){
        sort(all(g[v]));
        g[v] = vector <int>(g[v].begin(), unique(all(g[v])));
    }
    used.resize(n);
    for(int i = 0; i < n; ++i){
        if(!used[i]){
            auto t = dfs(i);
            if(t.ff != 0){
                cout << "No";
                return;
            }
        }
    }
    cout << "Yes\n";
    sort(all(ans));
    ans = vector <pair <pii, pii>>(ans.begin(), unique(all(ans)));
    assert(sz(ans) < m / 2);
    for(auto & an : ans){
        if(an.ff.ss != an.ss.ff)
            swap(an.ff, an.ss);
        assert(an.ff.ss == an.ss.ff);
        cout << an.ff.ff + 1 << ' ' << an.ff.ss + 1 << ' ' << an.ss.ff + 1 << ' ' << an.ss.ss + 1 << '\n';
    }
}

signed main(){
    cin.tie(0);
    cout.tie(0);
    iostream::sync_with_stdio(0);
    int t = 1;
    //cin >> t;
    while(t--){
        run();
    }
}