#include <bits/stdc++.h>

#define int long long

using namespace std;

void solve() {
    string input;
    cin >> input;
    int n = input.size();
    vector<int> a(n);
    vector<int> questions;
    for (int i = 0; i < n; ++i) {
        if (input[i] == '?') {
            a[i] = 26;
            questions.push_back(i);
        } else {
            a[i] = input[i] - 'A';
        }
    }
    vector<double> dsums = {1, 5, 10, 50, 100, 500, 1000, 5e3, 1e4, 5e4, 1e5, 5e5, 1e6, 5e6, 1e7, 5e7, 1e8, 5e8, 1e9,
                            5e9, 1e10, 5e10, 1e11, 5e11, 1e12, 5e12};
    vector<int> sums(dsums.size());
    for (int i = 0; i < sums.size(); ++i) {
        sums[i] = (int) dsums[i];
    }
    vector<int> bests(n);
    int best = INT64_MIN;
    for (int j = 0; j < 26; ++j) {
        int last_question = -2;
        for (auto question : questions) {
            int cur_mx = 0;
            int cur = 0;
            for (int i = n - 1; i >= 0; --i) {
                int cur_char;
                if (a[i] == 26 && i > question) {
                    cur_char = bests[i];
                } else if (a[i] == 26) {
                    if (j < cur_mx) {
                        cur_char = cur_mx;
                    } else {
                        cur_char = j;
                    }
                } else {
                    cur_char = a[i];
                }
                if (cur_char < cur_mx) {
                    cur -= sums[cur_char];
                } else {
                    cur += sums[cur_char];
                    cur_mx = cur_char;
                }
            }
            if (best < cur) {
                last_question = question;
                best = cur;
            }
        }
        for (int i = 0; i < last_question + 1; ++i) {
            if (a[i] == 26) {
                bests[i] = j;
            }
        }
    }
    int cur_mx = 0;
    vector<int> ans(n);
    int nans = 0;
    string sans;
    for (int i = n - 1; i >= 0; --i) {
        int cur_ch;
        if (a[i] == 26) {
            if (bests[i] < cur_mx) {
                cur_ch = cur_mx;
            } else {
                cur_ch = bests[i];
            }
        } else {
            cur_ch = a[i];
        }
        ans[i] = cur_ch;
        if (cur_ch < cur_mx) {
            nans -= sums[cur_ch];
        } else {
            nans += sums[cur_ch];
            cur_mx = cur_ch;
        }
        sans.push_back((char) (cur_ch + 'A'));
    }
    cout << nans << '\n';
    reverse(sans.begin(), sans.end());
    cout << sans;
//    for (int i = 0; i < n; ++i) {
//        cout << (char) (ans[i] + 'A');
//    }
    cout << '\n';
}

int32_t main() {

    int t;
    cin >> t;
    while (t--) {
        solve();
    }

    return 0;
}
