#include <bits/stdc++.h>

#define ll long long
#define int ll
#define pii pair<int, int>
#define all(a) a.begin(), a.end()
#define pb push_back
#define ff first
#define ss second
#define mp make_pair
#define rep(i, n) for(int i = 0; i < (n); ++i)
#define files(in, out) freopen(in, "r", stdin); freopen(out, "w", stdout)

using namespace std;

const int inf = 2e9;

vector<vector<pii>> g;
vector<int> mx, mn;

void dfs(int v, int p = -1) {
    for (auto edge : g[v]) {
        int to = edge.ff;
        int w = edge.ss;
        if (to == p) continue;
        mx[to] = max(mx[v], w);
        mn[to] = min(mn[v], w);
        dfs(to, v);
    }
}

void run() {
    int n, m;
    cin >> n >> m;
    g.resize(n);
    rep(i, m) {
        int v, to, w;
        cin >> v >> to >> w;
        v--;
        to--;
        g[v].pb({to, w});
        g[to].pb({v, w});
    }
    mx.resize(n, -inf);
    mn.resize(n, inf);
    dfs(0);
    rep(i, n) {
        if (i == 0) continue;
        cout << mx[i] + mn[i] << '\n';
    }
}

signed main() {
//    files("input.txt", "output.txt");
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
//    cin >> t;
    while (t--)
        run();
    return 0;
}
