#include <bits/stdc++.h>

#define ll long long
#define int ll
#define pii pair<int, int>
#define all(a) a.begin(), a.end()
#define pb push_back
#define ff first
#define ss second
#define mp make_pair
#define rep(i, n) for(int i = 0; i < (n); ++i)
#define files(in, out) freopen(in, "r", stdin); freopen(out, "w", stdout)

using namespace std;

const int inf = 2e9;

vector<vector<pii>> g;
vector<int> mx, mn;
//vector<bool> used;
vector<vector<bool>> used;

void dfs(int v, int cur_mn, int cur_mx) {
    mx[v] = max(mx[v], cur_mx);
    mn[v] = min(mn[v], cur_mn);
    for (auto edge : g[v]) {
        int to = edge.ff;
        int w = edge.ss;
        used[v][to] = 1;
        used[to][v] = 1;
        dfs(to, min(cur_mn, w), max(cur_mx, w));
        used[v][to] = 0;
        used[to][v] = 0;
    }
}

void run() {
    int n, m;
    cin >> n >> m;
    g.resize(n);
    used.resize(n, vector<bool> (n, 0));
    rep(i, m) {
        int v, to, w;
        cin >> v >> to >> w;
        v--;
        to--;
        g[v].pb({to, w});
        g[to].pb({v, w});
    }
    mx.resize(n, -inf);
    mn.resize(n, inf);
    dfs(0);
    rep(i, n) {
        if (i == 0) continue;
        cout << mx[i] + mn[i] << '\n';
    }
}

signed main() {
    files("input.txt", "output.txt");
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
//    cin >> t;
    while (t--)
        run();
    return 0;
}
