#include <bits/stdc++.h>

using namespace std;
#define int long long
const int MAXN = 3e5, lg = 19;

vector<vector<pair<int, int> > > g;
vector<int> mi, ma;
void dfs(int v, int p = 0, int cmn = 1e9, int cmx = -1){
    mi[v] = cmn;
    ma[v] = cmx;
    for(auto to: g[v]){
        if(to.first == p) continue;
        dfs(to.first, v, min(cmn, to.second), max(cmx, to.second));
    }
}

vector<int> pr;

int get(int v){
    if(pr[v] == v) return v;
    else return pr[v] = get(pr[v]);
}

void merge(int u, int v){
    u = get(u);
    v = get(v);
    if(rand() % 2) pr[u] = v;
    else pr[v] = u;
}

signed main() {
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    vector<pair<int, pair<int, int> > > edges(m);
    for(int i = 0; i < m; i++){
        cin >> edges[i].second.first >> edges[i].second.second >> edges[i].first;
        edges[i].second.first--;
        edges[i].second.second--;
    }
    sort(edges.begin(), edges.end());
    pr.resize(n);
    g.resize(n);
    iota(pr.begin(), pr.end(), 0);
    for(int i = 0; i < m; i++){
        int u = edges[i].second.first, v = edges[i].second.second, w = edges[i].first;
        if(get(u) == get(v)) continue;
        g[u].push_back({v, w});
        g[v].push_back({u, w});
        merge(u, v);
    }
    mi.resize(n);
    ma.resize(n);
    dfs(0);
    for(int i = 1; i < n; i++){
        cout << mi[i] + ma[i] << endl;
    }
}