#include <bits/stdc++.h>

using namespace std;
#define int long long
const int MAXN = 3e5, lg = 19;

vector<vector<pair<pair<int, int>, int> > > g;
vector<int> ans, used;
void dfs(int v, int p = -1, int cmn = 2e9, int cmx = -1){
    //cout << v << ' ' << cmn << ' ' << cmx << endl;
    ans[v] = min(ans[v], cmn + cmx);
    for(auto to: g[v]){
        if(used[to.second]) continue;
        used[to.second] = true;
        dfs(to.first.first, v, min(cmn, to.first.second), max(cmx, to.first.second));
        used[to.second] = false;
    }
}

signed main() {
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    g.resize(n);
    used.resize(m);
    for(int i = 0; i < m; i++){
        int u, v, w;
        cin >> u >> v >> w;
        u--, v--;
        g[u].push_back({{v, w}, i});
        g[v].push_back({{u, w}, i});
    }
    ans.resize(n, 2e9);
    dfs(0);
    for(int i = 1; i < n; i++){
        cout << ans[i] << '\n';
    }
}