#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <string>
#include <cstring>
#include <iomanip>
#include <random>
#include <cassert>
#include <bitset>
#include <queue>
#include <deque>

//#pragma GCC target("avx2")

#define int long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define ld long double

using namespace std;
inline void fastio() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

const int inf = 4e18 + 123;

inline void mr(int &a, int b) {
    a = max(a, b);
}

void solve() {
    vector<int> mas(26, 1);
    for (int i = 1; i < 26; ++i) {
        if (i % 2 == 1) {
            mas[i] = 5 * mas[i - 1];
        } else {
            mas[i] = 2 * mas[i - 1];
        }
    }
    string s;
    cin >> s;
    int n = (int) s.size();
    vector<vector<int> > dp(n, vector<int>(26, -inf));
    vector<vector<int> > chosen(n, vector<int>(26, -1));
    vector<vector<int> > previous(n, vector<int>(26, -1));
    // base
    if (s[n - 1] == '?') {
        for (int i = 0; i < 26; ++i) {
            dp[n - 1][i] = mas[i];
            chosen[n - 1][i] = i;
        }
    } else {
        dp[n - 1][s[n - 1] - 'A'] = mas[s[n - 1] - 'A'];
        chosen[n - 1][s[n - 1] - 'A'] = s[n - 1] - 'A';
    }
    for (int i = n - 2; i >= 0; --i) {
        for (int now = 0; now < 26; ++now) {
            if (s[i] != '?' && s[i] - 'A' != now) continue;
            for (int prev = 0; prev < 26; ++prev) {
                if (now < prev) {
                    if (dp[i][prev] < dp[i + 1][prev] - mas[now]) {
                        dp[i][prev] = dp[i + 1][prev] - mas[now];
                        chosen[i][prev] = now;
                        previous[i][prev] = prev;
                    }
                } else {
                    if (dp[i][now] < dp[i + 1][prev] + mas[now]) {
                        dp[i][now] = dp[i + 1][prev] + mas[now];
                        chosen[i][now] = now;
                        previous[i][now] = prev;
                    }
                }
            }
        }
    }
    int ans = -inf;
    int b = -1;
    for (int i = 0; i < 26; ++i) {
        if (ans < dp[0][i]) {
            ans = dp[0][i];
            b = i;
        }
    }
    cout << ans << '\n';
    for (int i = 0; i < n; ++i) {
        cout << (char) ((int) 'A' + chosen[i][b]);
        b = previous[i][b];
    }
    cout << '\n';
}

signed main() {
#ifdef lolipop
    freopen("input.txt", "r", stdin);
#else
    fastio();
#endif
    int T = 1;
    cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}
