#include <iostream>
#include <vector>
#include <set>
using namespace std;

int main()
{
    long long n, m;
    cin >> n >> m;
    vector <vector <bool>> g(n);
    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < n; j++)
        {
            g[i].push_back(false);
        }
    }
    for (int i = 0; i < m; i++)
    {
        long long u, v;
        cin >> u >> v;
        g[u - 1][v - 1] = true;
    }
    bool flag = true;
    vector < pair <long long, long long>> ans;
    for (int i = 0; i < n; i++)
    {
        for (int j = i; j < n; j++)
        {
            if (g[i][j] && g[j][i])
            {
                ans.push_back(make_pair(i, j));
            }
            else
            {
                flag = false;
                break;
            }
        }
        if (!(flag))
        {
            break;
        }
    }
    if (flag)
    {
        cout << "Yes" << endl;
        for (auto elem : ans)
        {
            cout << elem.first << ' ' << elem.second << ' ' << elem.second << ' ' << elem.first << endl;
        }
    }
    else
        cout << "No" << endl;
    return 0;
}
