#include <bits/stdc++.h>

using namespace std;

#define int long long

const int MAXN = 3e5 + 25;

vector<vector<pair<int, int>>> g(MAXN);

int used[MAXN];

int dp1[MAXN];
int dp2[MAXN];

const int INF = 1e18 + 118;

void dfs(int u)
{
    used[u] = true;
    for (auto el : g[u])
    {
        int v = el.first;
        int w = el.second;
        if (!used[v])
        {
            dp1[v] = min(dp1[u], w);
            dp2[v] = max(dp2[u], w);
            dfs(v);
        }
    }
}

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; ++i)
    {
        int u, v, w;
        cin >> u >> v >> w;
        --u; --v;
        g[u].push_back({v, w});
        g[v].push_back({u, w});
    }
    dp1[0] = INF;
    dp2[0] = -INF;
    dfs(0);
    for (int i = 1; i < n; ++i)
    {
        cout << dp1[i] + dp2[i] << endl;
    }
    return 0;
}

