#include <bits/stdc++.h>

using namespace std;

#define int long long

const int MAXN = 3e5 + 25;
const int INF = 1e18 + 118;

vector<vector<pair<int, int>>> g(MAXN);

int dist[MAXN];

const int K = 1e9;

int dp[MAXN];

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    vector<pair<pair<int, int>, int>> edges;
    for (int i = 0; i < m; ++i)
    {
        int u, v, w;
        cin >> u >> v >> w;
        --u; --v;
        edges.push_back({{u, v}, w});
    }
    vector<int> a(m);
    for (int i = 0; i < m; ++i)
    {
        a[i] = i;
    }
    for (int i = 0; i < n; ++i)
    {
        dp[i] = INF;
    }
    do
    {
        int u = 0;
        int mn = INF;
        int mx = -INF;
        for (int ii = 0; ii < m; ++ii)
        {
            int i = a[ii];
            if (edges[i].first.first != u && edges[i].first.second != u)
            {
                break;
            }
            else
            {
                int v = edges[i].first.first + edges[i].first.second - u;
                int w = edges[i].second;
                mx = max(mx, w);
                mn = min(mn, w);
                dp[v] = min(dp[v], mx + mn);
                u = v;
            }
        }
    } while (next_permutation(a.begin(), a.end()));
    for (int i = 1; i < n; ++i)
    {
        cout << dp[i] << endl;
    }
    return 0;
}


