#include <bits/stdc++.h>

using namespace std;

void bfs(int x, vector<vector<pair<int, int> > > &a, vector<int> &d, int minn, int maxx, set<pair<pair<int, int>, pair<int, int> > > &s)
{
    d[x] = minn + maxx;
    for (int i = 0; i < a[x].size(); ++i)
    {
        int y = a[x][i].first;
        int c = a[x][i].second;
        int minn1 = min(minn, c);
        int maxx1 = max(maxx, c);
        if (d[y] == -1)
        {
            s.insert({{minn1 + maxx1, y}, {minn1, maxx1}});
        }
    }
    while (s.size() > 0)
    {
        pair<pair<int, int>, pair<int, int> > p = *s.begin();
        s.erase(s.begin());
        if (d[p.first.second] == -1)
        {
            bfs(p.first.second, a, d, p.second.first, p.second.second, s);
        }
    }
}

void dfs(int x, vector<vector<pair<int, int> > > &a, vector<int> &d, int minn, int maxx)
{
    d[x] = minn + maxx;
    for (int i = 0; i < a[x].size(); ++i)
    {
        int y = a[x][i].first;
        if (d[y] == -1)
        {
            dfs(y, a, d, min(minn, a[x][i].second), max(maxx, a[x][i].second));
        }
    }
}

int main()
{
    int n, m;
    cin >> n >> m;
    vector<vector<pair<int, int> > > a(n, vector<pair<int, int> > (0));
    for (int i = 0; i < m; ++i)
    {
        int u, v, t;
        cin >> u >> v >> t;
        u -= 1;
        v -= 1;
        a[u].push_back({v, t});
        a[v].push_back({u, t});
    }
    vector<int> d(n, -1);
    set<pair<pair<int, int>, pair<int, int> > > s;
    bfs(0, a, d, 1e9 + 1, -1, s);
    for (int i = 1; i < n; ++i)
    {
        cout << d[i] << "\n";
    }
}
