#pragma GCC optimize ("Ofast")
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <array>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <deque>
#include <queue>
#include <iomanip>
#define ios ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define debug(x) cout << #x << " = " << x << endl;
#define debug2(x, y) cout << x << ", " << y << endl;
#define debug_a(a) cout << #a << endl; for(auto e: a) cout << "( " << e[0] << ' ' << e[1] << ' ' << e[2] << " )"; cout << endl;
#define sz(a) (long long)(a).size()
#define all(a) a.begin(), a.end()
#define pikachu push_back
using namespace std;
typedef long long ll;
typedef long double ld;
const ll N = 30, INF = 1e12;
ll ans[N];
vector<pair<ll, ll>> g[N], g2[N];
ll boss[N], rang[N];
ll get(ll a) {
	if (boss[a] == a) return a;
	boss[a] = get(boss[a]);
	return boss[a];
}
void unite(ll a, ll b) {
	ll x = get(a), y = get(b);
	if (rang[x] > rang[y]) swap(x, y);
	if (x != y) {
		boss[x] = y;
		rang[y] += rang[x];
	}
}
bool used[N];
ll n, m;
ll v, u, t;
void dfs(ll v, ll p, ll mx) {
	for (auto [w, u] : g2[v]) {
		//debug2(v, u);
		if (u == p) continue;
		ans[u] = min(ans[u], max(mx, w));
		dfs(u, v, max(mx, w));
	}
}
int main() {
	fill(ans, ans + N, INF);
	for (ll i = 0; i < N; i++) boss[i] = i;
	fill(rang, rang + N, 1);
	ios;
	cin >> n >> m;
	for (ll i = 1; i <= m; i++) {
		cin >> v >> u >> t;
		g[v].pikachu({ t, u });
		g[u].pikachu({ t, v });
	}
	set<array<ll, 3>> s;
	s.insert({ 0, 0, 1 });
	while (sz(s)) {
		auto [w, v, u] = *s.begin();
		//debug2(v, u);
		//debug_a(s);
		s.erase(s.begin());
		if (get(v) != get(u)) {
			if (v != 0) g2[v].pikachu({ w, u });
			if (v != 0) g2[u].pikachu({ w, v });
			//debug("ADD");
			//debug2(v, u);
			unite(v, u);
			for (auto [wc, e] : g[u]) s.insert({ wc, u, e });
		}
	}
	dfs(1, -1, -INF);
	for (ll i = 2; i <= n; i++) cout << ans[i] << ' ';
}
