#include <iostream>
#include <map>

using namespace std;

int main() {
	ios_base::sync_with_stdio(false);

	int n, q, l, r, x, h;
	map <int, int> forest;

	cin >> n >> q;
	for (int i = 0; i < n; i++) {
		cin >> x >> h;
		forest[x] = h;
	}

	cout << "FOREST:\n";
	for (pair<int, int> a : forest) {
		cout << a.first << "=====>>" << a.second << " ";
	}
	cout << "\n";

	for (int i = 0; i < q; i++) {
		cin >> l >> r;
		map <int, int> part;
		auto beg = forest.lower_bound(l), last = forest.upper_bound(r);
		auto curr = beg;
		/* if (last == forest.end()) {
			cout << ">>" << (*curr).first << " last\n";
		}
		else {
			cout << ">>" << (*curr).first << " " << (*last).first << "\n";
		} */
		int max_h = 0;
		while (curr != last) {
			if (max_h < (*curr).second) {
				max_h = (*curr).second;
			}
			curr++;
		}
		cout << ">>.." << max_h << "\n";
	}

	return 0;
}