#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
#define int long long
const int MAX = 400000;
const int INF = 1e18;
int n, m;
int a, b, vol;
int used[MAX], dep[MAX], down[MAX], mst[MAX], elem[MAX];
int used2[MAX], mi[MAX], co[MAX], ans[MAX], real_ans[MAX];
vector<pair<int, int>> all_edges;
vector<pair<pair<int, int>, pair<int, int>>> sort_edges;
vector<pair<int, int>> edges[MAX], edges2[MAX];
bool in[MAX];
void dfs(int v, int pred, int de) {
	used[v] = 1;
	dep[v] = de;
	down[v] = de;
	for (auto i : edges[v]) {
		if (!used[i.first]) {
			dfs(i.first, i.second, de + 1);
			down[v] = min(down[v], down[i.first]);
		}
		else if(i.second != pred){
			down[v] = min(down[v], dep[i.first]);
		}
	}
	if (pred != -1) {
		if (down[v] == de) {
			mst[pred] = 1;
		}
	}
	return;
}
void dfs2(int v, int col) {
	used2[v] = 1;
	co[v] = col;
	for (auto i : edges[v]) {
		if (mst[i.second]) {
			continue;
		}
		mi[col] = min(mi[col], elem[i.second]);
		if (!used2[i.first]) {
			dfs2(i.first, col);
		}
	}
	return;
}
void dfs3(int v, int pred, int mini) {
	mini = min(mini, mi[v]);
	ans[v] = mini;
	for (auto i : edges2[v]) {
		if (i.first != pred) {
			dfs3(i.first, v, min(mini, i.second));
		}
	}
}
signed main() {
	cin >> n >> m;
	for (int i = 0; i < m; i++) {
		cin >> a >> b >> vol;
		a--;
		b--;
		sort_edges.push_back({ {vol, i}, {a, b} });
		all_edges.push_back({ a, b });
		real_ans[a] = 2 * INF;
		real_ans[b] = 2 * INF;
		in[i] = false;
	}
	sort(sort_edges.begin(), sort_edges.end());
	for (auto i2 : sort_edges) {
		in[i2.first.second] = true;
		elem[i2.first.second] = i2.first.first;
		edges[i2.second.first].push_back({ i2.second.second, i2.first.second });
		edges[i2.second.second].push_back({ i2.second.first, i2.first.second });
		for (int j = 0; j <= n; j++) {
			used[j] = 0;
			used2[j] = 0;
			mst[j] = 0;
			edges2[j].clear();
		}
		dfs(0, -1, 0);
		int col = 1;
		for (int i = 0; i < n; i++) {
			if (!used2[i] && used[i]) {
				mi[col] = INF;
				dfs2(i, col);
				col++;
			}
		}
		for (int i = 0; i < m; i++) {
			if (mst[i] && in[i]) {
				edges2[co[all_edges[i].first]].push_back({ co[all_edges[i].second], elem[i] });
				edges2[co[all_edges[i].second]].push_back({ co[all_edges[i].first], elem[i] });
			}
		}
		dfs3(1, -1, INF);
		for (int i = 1; i < n; i++) {
			if (used[i]) {
				real_ans[i] = min(real_ans[i], i2.first.first + ans[co[i]]);
			}
		}
	}
	for (int i = 1; i < n; i++) {
		cout << real_ans[i] << endl;
	}
	return 0;
}