#include <bits/stdc++.h>

using namespace std;

const int MAXN = 3e5;
vector<pair<int, int>> graph[MAXN];

signed main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  int n, m;
  cin >> n >> m;
  for (int i = 0; i < m; i++) {
    int v, u, t;
    cin >> v >> u >> t;
    v--;
    u--;
    graph[v].emplace_back(u, t);
    graph[u].emplace_back(v, t);
  }
  vector<int> dist(n, INT_MAX);
  set<pair<int, int>> q;
  q.emplace(dist[0], 0);
  while (!q.empty()) {
    auto [d, v] = *q.begin();
    q.erase(q.begin());
    for (auto [u, w] : graph[v]) {
      int new_d = min(d, w);
      if (dist[u] > new_d) {
        dist[u] = new_d;
        q.emplace(dist[u], u);
      }
    }
  }
  for (int i = 1; i < n; i++) {
    cout << (int) 1e9 + dist[i] << '\n';
  }
  return 0;
}