#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
// #define int ll
#define rep(i, n) for (int i = 0; i < int(n); ++i)
#define all(a) (a).begin(), (a).end()

ll d[26] = {
	1,
	5,
	10,
	50,
	100,
	500,
	(ll)1e3,
	(ll)5e3,
	(ll)1e4,
	(ll)5e4,
	(ll)1e5,
	(ll)5e5,
	(ll)1e6,
	(ll)5e6,
	(ll)1e7,
	(ll)5e7,
	(ll)1e8,
	(ll)5e8,
	(ll)1e9,
	(ll)5e9,
	(ll)1e10,
	(ll)5e10,
	(ll)1e11,
	(ll)5e11,
	(ll)1e12,
	(ll)5e12
};

ll calc(string s) {
	reverse(all(s));
	ll mx = -1;
	ll ans = 0;
	for (char c_ : s) {
		ll c = d[c_ - 'A'];
		if (mx > c) {
			ans -= c;
		} else {
			ans += c;
		}
		mx = max(mx, c);
	}
	return ans;
}

const int N = 3e5 + 10;
ll dp[N][26];
pair<int, int> p[N][26];

void solve() {
	string s;
	cin >> s;
	int n = s.size();

	rep(j, n) {
		rep(i, 26) {
			dp[j][i] = LLONG_MIN;
		}
	}
	dp[n][0] = 0;
	for (int i = n - 1; i >= 0; --i) {
		if (s[i] != '?') {
			int c = s[i] - 'A';
			for (int k = 0; k < 26; ++k) {
				if (dp[i + 1][k] != LLONG_MIN) {
					dp[i][max(k, c)] = max(dp[i][max(k, c)], dp[i + 1][k] + (k <= c ? 1LL : -1LL) * d[c]);
					if (dp[i + 1][k] + (k <= c ? 1LL : -1LL) * d[c] == dp[i][max(k, c)]) {
						p[i][max(k, c)] = make_pair(c, k);
					}
				}
			}
		} else {
			for (int k = 0; k < 26; ++k) {
				for (int l = 0; l < 26; ++l) {
					if (dp[i + 1][l] != LLONG_MIN) {
						dp[i][max(k, l)] = max(dp[i][max(k, l)], dp[i + 1][l] + (k <= l ? 1LL : -1LL) * d[k]);
						if (dp[i][max(k, l)] == dp[i + 1][l] + (k <= l ? 1LL : -1LL) * d[k]) {
							p[i][max(k, l)] = make_pair(k, l);
						}
					}
				}
			}
		}
	}

	int i = 0;
	int j = 0;
	rep(j0, 26) {
		if (dp[i][j0] > dp[i][j]) {
			j = j0;
		}
	}

	cout << dp[i][j] << '\n';
	string ans;
	while (i != n) {
		// cout << char(p[i][j].first + 'A');
		ans.push_back(char(p[i][j].first + 'A'));
		// cerr << i << ' ' << j << ' ' << dp[i][j] << endl;
		j = p[i][j].second;
		i++;
	}
	cout << ans;
	cout << '\n';
	// cout << ans.first << '\n' << ans.second << '\n';
}

signed main() {
	// ios_base::sync_with_stdio(false);
	// cin.tie(nullptr);
	// cout.tie(nullptr);
	int t;
	cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}