#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ld long double
#define fi first
#define se second
#define pb emplace_back
#define all(x) (x).begin(), (x).end()
#define pii pair<int, int>

const int INF = 1e9 + 1;
const ll INFLL = 2e18 + 1;

vector<vector<int>> g;
vector<int> usd;

void dfs(int v, int c) {
    usd[v] = c;
    for (auto &to : g[v]) {
        if (!usd[to]) dfs(to, 3 - c);
    }
}

vector<int> with;
vector<int> usd1;

int dfs1(int v) {
    if (usd1[v]) return 0;
    usd1[v] = 1;
    for (auto &to : g[v]) {
        if (with[to] == -1) {
            with[to] = v;
            return 1;
        }
    }
    for (auto &to : g[v]) {
        if (dfs1(with[to])) {
            with[to] = v;
            return 1;
        }
    }
    return 0;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    vector<pii> edges;
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        a--; b--;
        edges.pb(a, b);
    }
    g.resize(m);
    usd.resize(m);
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < m; j++) {
            if (edges[i].se == edges[j].fi) {
                g[i].pb(j);
                g[j].pb(i);
            }
        }
    }
    for (int i = 0; i < m; i++) {
        if (!usd[i]) dfs(i, 1);
    }
    with.resize(m, -1);
    int ans = 0;
    for (int i = 0; i < m; i++) {
        if (usd[i] == 2) continue;
        usd1.assign(m, 0);
        ans += dfs1(i);
    }
    if (ans == m / 2) {
        cout << "Yes\n";
        for (int i = 0; i < m; i++) {
            if (with[i] == -1) continue;
            cout << edges[i].fi + 1 << " " << edges[i].se + 1 << " " << edges[with[i]].fi + 1 << " " << edges[with[i]].se + 1 << "\n";
        }
        return 0;
    }
    cout << "No";
    return 0;
}
/*
5 6
1 2
2 1
1 5
2 3
2 4
4 2
*/
