#include <bits/stdc++.h>

using namespace std;

#define  int long long
#define  x first
#define  y second

map<char, int> val;

const int INF = 1e18;

void solve() {
    string s;
    cin >> s;
    vector<vector<int>> dp(s.size(), vector<int> (26, -INF));
    vector<vector<pair<int, char>>> from(s.size(), vector<pair<int, char>> (26));
    for (int j = 0; j < 26; ++j) {
        if (s.back() == '?') {
            dp[s.size() - 1][j] = val[char('A' + j)];
            from[s.size() - 1][j] = {j, char('A' + j)};
        } else {
            if (j == s.back() - 'A') {
                dp[s.size() - 1][j] = val[s.back()];
                from[s.size() - 1][j] = {j, s.back()};
            } else if (j > s.back() - 'A') {
                dp[s.size() - 1][j] = -val[s.back()];
                from[s.size() - 1][j] = {j, s.back()};
            }
        }
    }
    int n = s.size();
    for (int i = n - 2; i >= 0; --i) {
        int pref_max = -INF;
        pair<int, char> froms;
        for (int j = 0; j < 26; ++j) {
            if (dp[i + 1][j] == -INF)
                continue;
            if (pref_max < dp[i + 1][j]) {
                pref_max = dp[i + 1][j];
                froms = {j, 'A'};
            }
            if (s[i] == '?') {
                if (dp[i][j] < pref_max + val[char('A' + j)]) {
                    dp[i][j] = pref_max + val[char('A' + j)];
                    from[i][j] = {froms.x, char('A' + j)};
                }
            } else {
                if (j > s[i] - 'A') {
                    if (dp[i][j] < pref_max - val[s[i]]) {
                        dp[i][j] = pref_max - val[s[i]];
                        from[i][j] = {froms.x, s[i]};
                    }
                } else if (j == s[i] - 'A') {
                    if (dp[i][j] < pref_max + val[s[i]]) {
                        dp[i][j] = pref_max + val[s[i]];
                        from[i][j] = {froms.x, s[i]};
                    }
                } else {
                    continue;
                }
            }
        }
    }
    int id = 0;
    for (int i = 0; i < 26; ++i)
        if (dp[0][id] < dp[0][i])
            id = i;
    cout << dp[0][id] << '\n';
    for (int i = 0; i < n; ++i) {
        cout << from[i][id].y;
        id = from[i][id].x;
    }
    cout << '\n';
}

void precalc() {
    int vala = 1;
    for (int i = 0; i < 26; ++i) {
        val[char('A' + i)] = vala;
        if (i % 2 == 0)
            vala *= 5ll;
        else
            vala *= 2ll;
    }
}

signed main() {
    precalc();
#ifdef  LOCAL
    freopen("input.txt", "r", stdin);
#else
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
#endif
    int t = 1; cin >> t;
    while (t--)
        solve();
    return 0;
}