#include <bits/stdc++.h>

using namespace std;

#define int long long
typedef long double ld;

auto seed = chrono::high_resolution_clock::now().time_since_epoch().count();
mt19937 _mt(seed);

const int INF = 2e18;

int32_t main()
{
    #ifdef LOCAL
    #else
        ios_base::sync_with_stdio(false);
        cin.tie(0); cout.tie(0);
    #endif
    int q; cin >> q;
    vector <int> a = {1};
    for (int i = 0; i < 12; i++) {
        a.push_back(a.back() * 5);
        a.push_back(a.back() * 2);
    }
    a.push_back(a.back() * 5);
    while (q--) {
        string s; cin >> s;
        int n = s.size(), cnt = 0;
        for (auto &c : s)
            if (c == '?')
                cnt++;
        if (!cnt) {
            int ans = 0;
            char mx = 'A';
            for (int i = n - 1; i >= 0; i--) {
                if (s[i] >= mx)
                    ans += a[s[i] - 'A'];
                else
                    ans -= a[s[i] - 'A'];
                mx = max(mx, s[i]);
            }
            cout << ans << "\n" << s << "\n";
            continue;
        }
        vector <vector <int> > dp(n + 1, vector <int>(26, -INF));
        vector <vector <pair <int, int> > > p(n, vector <pair <int, int> >(26));
        for (int j = 0; j < 26; j++)
            dp[n][j] = 0;
        for (int i = n - 1; i >= 0; i--) {
            for (int j = 0; j < 26; j++) {
                for (int k = 0; k <= j; k++) {
                    if (s[i] == '?') {
                        if (dp[i][j] < dp[i + 1][k] + a[j]) {
                            dp[i][j] = dp[i + 1][k] + a[j];
                            p[i][j] = {j, k};
                        }
                    } else {
                        if (max((int)(s[i] - 'A'), k) != j) continue;
                        if ((s[i] - 'A') < k) {
                            if (dp[i][j] < dp[i + 1][k] - a[s[i] - 'A']) {
                                dp[i][j] = dp[i + 1][k] - a[s[i] - 'A'];
                                p[i][j] = {s[i] - 'A', k};
                            }
                        } else {
                            if (dp[i][j] < dp[i + 1][k] + a[s[i] - 'A']) {
                                dp[i][j] = dp[i + 1][k] + a[s[i] - 'A'];
                                p[i][j] = {s[i] - 'A', k};
                            }
                        }
                    }
                }
            }
        }
        int i = 0, j = 0;
        for (int k = 0; k < 26; k++)
            if (dp[0][k] > dp[0][j])
                j = k;
        while (i < n) {
            s[i] = (char)('A' + p[i][j].first);
            j = p[i][j].second;
            i++;
        }
        int ans = 0;
        char mx = 'A';
        for (int i = n - 1; i >= 0; i--) {
            if (s[i] >= mx)
                ans += a[s[i] - 'A'];
            else
                ans -= a[s[i] - 'A'];
            mx = max(mx, s[i]);
        }
        cout << ans << "\n" << s << "\n";
    }
    return 0;
}
