#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("vtm")
#include <bits/stdc++.h>

using namespace std;

//#define int long long
typedef long double ld;

auto seed = chrono::high_resolution_clock::now().time_since_epoch().count();
mt19937 _mt(seed);

const int INF = 1e9;

int n, m, tmp1, tmp2;
vector <vector <pair <int, int> > > g;
vector <int> used, ans;

void dfs1(int v, int mn, int mx) {
    used[v] = 1;
    for (auto &e : g[v]) {
        if (!used[e.first]) {
            tmp1 = min(mn, e.second), tmp2 = max(mx, e.second);
            ans[e.first] = tmp1 + tmp2;
            dfs1(e.first, tmp1, tmp2);
        }
    }
}

int32_t main()
{
    #ifdef LOCAL
    #else
        ios_base::sync_with_stdio(false);
        cin.tie(0); cout.tie(0);
    #endif
    cin >> n >> m;
    g.resize(n); used.resize(n);
    ans.resize(n);
    bool diff1 = true;
    for (int i = 0; i < m; i++) {
        int v, u, w;
        cin >> v >> u >> w;
        v--; u--;
        g[v].push_back({u, w});
        g[u].push_back({v, w});
        if (abs(v - u) > 1)
            diff1 = false;
    }
    bool allmn = true, allmx = true;
    for (auto &e : g[0]) {
        if (e.second)
            allmn = false;
        if (e.second < INF)
            allmx = false;
    }
    if (m == n - 1) {
        dfs1(0, INF, -INF);
    } else if (allmn) {
        fill(ans.begin() + 1, ans.end(), INF);
        set <pair <int, int> > s;
        s.insert({0, 0});
        while (!s.empty()) {
            auto p = *s.begin();
            s.erase(s.begin());
            for (auto &e : g[p.second]) {
                if (ans[e.first] > max(ans[p.second], e.second)) {
                    s.erase({ans[e.first], e.first});
                    ans[e.first] = max(ans[p.second], e.second);
                    s.insert({ans[e.first], e.first});
                }
            }
        }
    } else if (diff1 && 0) {
        vector <int> mn(n), mx(n);
        vector <int> emn(n), cnt(n);
        mn[0] = INF;
        for (int i = 1; i < n; i++) {
            int emin = emn[i] = INF;
            for (auto &e : g[i]) {
                if (e.first < i) {
                    if (e.second <= emin) {
                        emn[i] = emin;
                        emin = e.second;
                    } else if (e.second <= emn[i]) {
                        emn[i] = e.second;
                    }
                    cnt[i]++;
                }
            }
            mn[i] = min(mn[i - 1], emin);
            mx[i] = max(mx[i - 1], emin);
        }
        for (int i = 1; i < n; i++) {
            ans[i] = mn[i] + mx[i];
            int j = i + 1, cur = mx[i];
            while (j < n && cnt[j] > 1) {
                cur = max(cur, emn[j]);
                ans[i] = min(ans[i], mn[j] + cur);
                j++;
            }
        }
    } else {
        vector <vector <int> > edges;
        for (int i = 0; i < n; i++)
            for (auto &e : g[i])
                if (i < e.first)
                    edges.push_back({i, e.first, e.second});
        fill(ans.begin(), ans.end(), 2 * INF);
        vector <int> cnt(n);
        int mn, mx, k, ok;
        for (int mask = 0; mask < (1 << m); mask++) {
            fill(cnt.begin(), cnt.end(), 0);
            mn = INF, mx = 0;
            for (int i = 0; i < m; i++) {
                if (mask & (1 << i)) {
                    mn = min(mn, edges[i][2]);
                    mx = max(mx, edges[i][2]);
                    cnt[edges[i][0]]++;
                    cnt[edges[i][1]]++;
                }
            }
            if (cnt[0] % 2 == 0) continue;
            k = -1; ok = 1;
            for (int i = 1; i < n; i++) {
                if (cnt[i] % 2) {
                    if (k < 0)
                        k = i;
                    else
                        ok = 0;
                }
            }
            if (ok)
                ans[k] = min(ans[k], mn + mx);
        }
    }
    for (int i = 1; i < n; i++)
        cout << ans[i] << "\n";
    return 0;
}
