#define ll long long

#include<iostream>
#include<vector>
#include<string>
#include<algorithm>
#include<cmath>

using namespace std;

ll num(char c) {
	return (ll)(c - 'A');
}

ll cost(ll x) {
	ll ans = pow(10, x / 2);
	if (x % 2 != 0) {
		ans *= 5;
	}
	return ans;
}

void true_main() {
	string s = "";
	cin >> s;
	/*for (ll i = 0; i < 3 * 1e5; i++) {
		s += "?";
	}*/
	ll n = s.size();
	/*ll n = 3 + rand() % 7;

	for (int i = 0; i < n; i++) {
		if ((i) % 3 != 0) {
			s += char('A' + 21 + (rand() % 5));
		}
		else {
			s += '?';
		}
	}*/

	vector<vector<ll>> a(n, vector<ll>(26, 0));
	vector<vector<ll>> mt(26, vector<ll>(26));
	vector<vector<ll>> cr(n, vector<ll>(26, -1));
	ll last = 0;

	if (s[0] == '?') {
		for (int i = 0; i < 26; i++) {
			a[0][i] = cost(i);
		}
	}
	else {
		ll now = num(s[0]);
		ll now_cost = cost(now);
		for (ll j = 0; j < 26; j++) {
			for (ll k = now; k < 26; k++) {
				mt[j][k] += now_cost;
			}
			a[0][j] += now_cost;
		}
	}

	for (ll i = 1; i < n; i++) {
		if (s[i] == '?') {
			for (int k = 0; k < 26; k++) {
				ll pos = -1;
				ll mx = -5e18;
				for (int j = k; j < 26; j++) {
					if (cost(k) - (k == 0 ? 0 : 2 * mt[j][k - 1]) + a[i - 1][j] > mx) {
						mx = cost(k) - (k == 0 ? 0 : 2 * mt[j][k - 1]) + a[i - 1][j];
						pos = j;
					}
				}
				
				cr[i][k] = pos;
				a[i][k] = mx;
				mt[k] = mt[pos];
				ll cost_now = cost(k);

				for (int j = k; j < 26; j++) {
					if (k > 0) {
						mt[k][j] -= mt[k][k - 1];
					}
					mt[k][j] += cost_now;
				}

				for (int j = 0; j < k; j++) {
					mt[k][j] = 0;
				}
			}
		}
		else {
			ll now = num(s[i]);
			ll now_cost = cost(now);
			for (ll j = 0; j < 26; j++) {
				a[i][j] = a[i - 1][j];
				if (now > 0) {
					a[i][j] -= 2 * mt[j][now - 1];
				}
				for (ll k = now; k < 26; k++) {
					mt[j][k] += now_cost;
					if (now > 0) {
						mt[j][k] -= mt[j][now - 1];
					}
				}
				for (ll k = 0; k < now; k++) {
					mt[j][k] = 0;
				}
				a[i][j] += now_cost;
			}
		}
	}

	ll ans = -5e18;
	ll max_now = 0;
	for (ll i = 0; i < 26; i++) {
		if (a.back()[i] > ans) {
			ans = a.back()[i];
			max_now = i;
		}
	}
	string h = "";
	cout << ans << "\n";
	ll now = max_now;
	for (int i = n - 1; i >= 0; i--) {
		if (s[i] == '?') {
			h.push_back((char('A' + now)));
			now = cr[i][now];
		}
		else {
			h += s[i];
		}
	}
	reverse(h.begin(), h.end());
	cout << h;
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	ll t;
	cin >> t;
	
	while (t--) {
		true_main();
		cout << "\n";
	}
}
