//#define _GLIBCXX_DEBUG
#include <iostream>
#include <string>
#include <queue>
#include <climits>
#include <set>
#include <random>
#include <cmath>
#include <cstdio>
#include <vector>
#include <array>

struct tree
{
	int x, h;
};
int main(int argc, char*argv[])
{
	int n, Q; std::cin >> n >> Q;
	std::vector<tree> data(n);
	for(auto&[x,h] : data) scanf("%d%d", &x, &h);
	n += 2;
	data.insert(data.begin(), {data[0].x, INT_MAX});
	data.push_back({data.back().x, INT_MAX});
	//int Q; std::cin >> Q;
	while(Q --> 0)
	{
		//find gap to the right and to the left of every tree
		//if it is small enough, merge the gaps
		int l, r; scanf("%d%d", &l, &r);
		//printf("l=%d, r=%d\n", l, r);
		l--;
		l++; r++;
		std::vector<int> gap(n-1); //right gap
		for(int i = 0; i < n-1; i++)
			gap[i] = data[i+1].x - data[i].x;
		gap.push_back(0);
		std::vector<int> ltr(n, -1), rtr(n, -1);
		for(int i = 1; i < n; i++)
			ltr[i] = i - 1;
		for(int i = 0; i < n-1; i++)
			rtr[i] = i + 1;
		//std::vector<char> ready(n);
		std::vector<char> dead(n, false);
		std::queue<int> ready;
#define retry(ti) if(ltr[ti] != -1) if(gap[ltr[ti]] >= data[ti].h || gap[ti] >= data[ti].h) if(l <= ti && ti < r) ready.push(ti);
		for(int i = l; i < r; i++)
		{
			retry(i);
			//if(gap[i-1] >= data[i].h || gap[i] >= data[i].h) ready[i] = true;
		}
		int ans = 0;
		//bool ok = true;
		//while(ok)
		while(!ready.empty())
		{
			int i = ready.front(); ready.pop();
			//ok = false;
			//for(int i = l; i < r; i++)
			//{
			if(dead[i]) continue;
			//if(!ready[i]) continue;
			dead[i] = true;
			gap[ltr[i]] += gap[i];
			//int pl = ltr[i], pr = rtr[i];
			ltr[rtr[i]] = ltr[i];
			rtr[ltr[i]] = rtr[i];
			//printf("i=%d, ltr=%d, rtr=%d\n", i, ltr[i], rtr[i]);
			//printf("cut %d\n", i);		
			//for(int el : dead) printf("%3d", el); printf("\n");
			//for(int el : ltr) printf("%3d", el); printf("\n");
			//for(int el : rtr) printf("%3d", el); printf("\n");
			retry(ltr[i]);
			retry(rtr[i]);
			ans++;
			//ok = true;
			//}
		}
		printf("%d\n", ans);
	}
}
