#include <bits/stdc++.h>

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define sz(a) (int)(a).size()
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

#define x first
#define y second

#define pub push_back
#define pob pop_back
#define puf push_front
#define pof pop_front

#define int long long
#define double long double


using namespace std;
using namespace __gnu_pbds;

typedef pair<int, int> pii;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ord_set;

mt19937 gen(chrono::high_resolution_clock::now().time_since_epoch().count());

const int NMAX = 150010;

vector<int> G[NMAX];
vector<int> g[NMAX];

vector<pair<pii, pii> > ans;
vector<pii> up[NMAX], down[NMAX];

int used[NMAX];

void dfs2(int v, int p) {

    used[v] = 1;
    //cout << "START " << v << " " << p << "\n";

    for (int u : G[v]) {
        if (u == p) {
            continue;
        }

        if (!used[u]) {
            dfs2(u, v);
        }
    }

    for (int u : g[v]) {
        if (u == p) {
            up[v].pub({v, u});
        } else {
            if (!down[u].empty()) {
                ans.pub({down[u].back(), {v, u}});
                down[u].pob();

                if (!down[u].empty()) {
                    cout << "No\n";
                    exit(0);
                }
            } else {
                down[v].pub({v, u});
            }
        }
    }

    /*
    cout << "OK1 " << v << " " << p << "\n" ;
    cout << "down = \n";
    for (auto it : down[v]) {
        cout << it.x << " " << it.y << "\n";
    }
    cout << "up = \n";
    for (auto it : up[v]) {
        cout << it.x << " " << it.y << "\n";
    }
    cout << "END\n";
    */

    for (int u : g[v]) {
        if (u == p) {

        } else {
            if (!up[u].empty()) {
                if (!down[v].empty()) {
                    ans.pub({up[u].back(), down[v].back()});
                    up[u].pob(), down[v].pob();
                } else if (!up[v].empty()) {
                    ans.pub({up[u].back(), up[v].back()});
                    up[u].pob(), up[v].pob();
                } else {
                    cout << "No\n";
                    exit(0);
                }
            }
        }
    }
    /*
    cout << "OK2 " << v << " " << p << "\n" ;
    cout << "down = \n";
    for (auto it : down[v]) {
        cout << it.x << " " << it.y << "\n";
    }
    cout << "up = \n";
    for (auto it : up[v]) {
        cout << it.x << " " << it.y << "\n";
    }
    cout << "END\n";
    */
}


void solve_solve_solve() {
    int n, m;
    cin >> n >> m;

    for (int i = 0; i < m; i++) {
        int v, u;
        cin >> v >> u;

        v--, u--;

        g[v].pub(u);
        G[v].pub(u), G[u].pub(v);
    }

    /*
    cout << "G = \n";
    for (int i = 0; i < n; i++) {
        for (int j : G[i]) {
            cout << j << " ";
        }
        cout << "\n";
    }
    cout << "END\n";
    */

    memset(used, 0, sizeof(used));

    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            dfs2(i, i);
        }
    }

    for (int i = 0; i < NMAX; i++) {
        if (!(up[i].empty() && down[i].empty())) {
            cout << "No\n";
            exit(0);
        }
    }

    cout << "Yes\n";

    //cout << "ANS = " << sz(ans) << "\n";
    for (auto it : ans) {
        cout << it.x.x + 1 << " " << it.x.y + 1 << " " << it.y.x + 1 << " " << it.y.y + 1 << "\n";
    }
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);

    int Q = 1;
    //cin >> Q;

    while (Q--) {
        solve_solve_solve();
    }

    return 0;
}
