#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
typedef long long ll;
#define int long long

ll num[26];

int t;
string s;

int dp[300010][26];
int ch[300010][26];

inline void solve()
{
	cin >> s;
	int n = s.size();
	s = ' ' + s + ' ';

	for (int i = 0; i < 26; ++i) dp[n + 1][i] = -4e18;
	dp[n + 1][0] = 0;

	for (int i = n; i >= 1; --i)
	{
		for (int j = 0; j < 26; ++j)
		{
			dp[i][j] = -4e18;
			for (int x = 0; x < 26; ++x)
			{
				if (s[i] != '?' && s[i] - 'A' != x) continue;

				for (int y = 0; y < 26; ++y)
				{
					if (max(x, y) != j) continue;

					ll nans;
					if (y > x) nans = dp[i + 1][y] - num[x];
					else nans = dp[i + 1][y] + num[x];

					if (nans > dp[i][j])
					{
						dp[i][j] = nans;
						ch[i][j] = x;
					}
				}
			}
		}
	}

	int t = 1;
	int mx = 0;

	for (int i = 0; i < 26; ++i)
	{
		if (dp[t][i] > dp[t][mx]) mx = i;
	}

	cout << dp[t][mx] << '\n';

	while (t <= n)
	{
		s[t] = ch[t][mx] + 'A';

		for (int j = 0; j < 26; ++j)
		{
			if (max(j, ch[t][mx]) == mx && dp[t + 1][j] + num[ch[t][mx]] == dp[t][mx])
			{
				mx = j;
				break;
			}
		}
		++t;
	}

	for (int i = 1; i <= n; ++i)
	{
		cout << s[i];
	}
	cout << '\n';
}

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	num[0] = 1;
	for (int i = 1; i < 26; ++i)
	{
		if (i % 2) num[i] = num[i - 1] * 5;
		else num[i] = num[i - 1] * 2;
	}

	cin >> t;
	while (t--) solve();
	return 0;
}