#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;
typedef long long ll;
#define int long long

int n, m;
vector <pair <int, int>> g[300010];

pair <int, int> ans[300010];

pair <int, int> operator+(const pair<int, int>& a, int b)
{
	return { min(a.first, b), max(a.second, b) };
}

void dfs(int u, int p)
{
	for (auto v : g[u]) if (v.first != p)
	{
		ans[v.first] = ans[u] + v.second;
		dfs(v.first, u);
	}
}

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	cin >> n >> m;

	for (int i = 1; i <= m; ++i)
	{
		int u, v, w;
		cin >> u >> v >> w;
		g[u].push_back({ v, w });
		g[v].push_back({ u, w });
	}

	ans[1] = { 1e9 + 1, 0 };

	dfs(1, 1);
	for (int i = 2; i <= n; ++i)
	{
		cout << ans[i].first + ans[i].second << '\n';
	}
	return 0;
}