#include <bits/stdc++.h>

#define eb emplace_back

using namespace std;

typedef long long ll;

const int MAXN = 10003;
int x[MAXN];
int h[MAXN];
int n, Q;

void read(){
    cin >> n >> Q;
    for (int i = 1; i <= n; i++){
        cin >> x[i] >> h[i];
    }
    x[0] = x[1];
    x[n+1] = x[n];
}


int used[MAXN];
int l[MAXN];
int r[MAXN];

int getl(int v){
    while (used[l[v]]){
        l[v] = l[l[v]];
    }
    return l[v];
}

int getr(int v){
    while (used[r[v]]){
        r[v] = r[r[v]];
    }
    return r[v];
}


bool check(int i){
    //cerr << "ch: " << i <<' ' << getl(i)<< '\n';
    for (int j = getl(i); j >= 0; j--){
        //cerr << i << ' ' << j << '\n';
        //if (used[j]) continue;
        if (x[i] >= x[j] + h[i]) return true;
        break;
    }
    for (int j = getr(i); j <= n+1; j++){
        //if (used[j]) continue;
        if (x[i] + h[i] <= x[j]) return true;
        break;
    }
    return false;
}

void go(deque<int> q, int l, int r){
    while (!q.empty()){
        int v = q.front();
        q.pop_front();
        //cerr << v << ' ' << l << ' ' << r << '\n';
        //used[v] = 1;
        //for (int i = v; i <= r; i++){
        for (int j = getr(v); j <= r; j++){
            //if (used[j]) continue;
            //cerr << j << '\n';
            if (check(j)){
                used[j] = 1;
                q.eb(j);
            }
            break;
        }
        for (int j = getl(v); j >= l; j--){
            //if (used[j]) continue;
            if (check(j)){
                used[j] = 1;
                q.eb(j);
            }
            break;
        }
        //}
    }
}

void solve(){
    read();
    while (Q--){
        memset(used, 0, sizeof used);
        for (int i = 0; i <= n + 1; i++){
            l[i] = i - 1;
            r[i] = i + 1;
        }
        //l[0] = 0;
        //r[n+1] = n+1;
        int lt, rt;
        cin >> lt >> rt;
        deque<int> q;
        for (int i = lt; i <= rt; i++){
            if (check(i)){
                used[i] = 1;
                q.eb(i);
            }
        }
        go(q, lt ,rt);
        int ok = 0;
        for (int i = lt; i <= rt; i++){
            if (used[i]) ok++;
        }
        cout << ok << '\n';
    }
}

signed main() {

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    solve();

    return 0;
}

/*
3 3
1 3
3 1
4 2
1 1
2 3
1 3

1 1
100 100
1 1

5 3
1 5
3 1
4 2
5 3
6 1
1 5
5 5
1 1
 *///
// Created by roi on 09.04.2021.
//

