#include <bits/stdc++.h>

using namespace std;

#define nl '\n'
#define all(a) a.begin(), a.end()
#define vi vector<int>
#define forn(i, n) for (int i = 0; i < n; i++)
#define sz(a) ((int)a.size())
#define pb push_back
#define vpi vector<pair<int, int>>
#define minq(mi, a) mi = min(mi, a)
#define maxq(ma, a) ma = max(ma, a)
#define pi pair<int, int>

typedef long long ll;

void IO() {
#ifdef Dmitry07
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#endif
}

auto seed = chrono::high_resolution_clock::now().time_since_epoch().count();
mt19937 rnd(seed);

const int INF = 1e9 + 7;
const ll INFL = 4e18;
const int MAXN = 3e3 + 10;

// #define int ll

vi g[MAXN];
vector<tuple<int, int, int>> ans;
multiset<pi > taken;
int n, m;

void rec(int dep) {
    if (dep * 2 == m) {
        cout << "Yes" << nl;
        for (auto[a, b, c] : ans) {
            cout << a + 1 << ' ' << b + 1 << ' ' << b + 1 << ' ' << c + 1 << nl;
        }
        exit(0);
    }
    forn (i, n) {
        for (auto to : g[i]) {
            if (taken.count({i, to}) == 0) {
                for (auto to1 : g[to]) {
                    if (taken.count({to, to1}) == 0) {
                        taken.insert({i, to});
                        taken.insert({to, to1});
                        ans.pb({i, to, to1});
                        rec(dep + 1);
                        ans.pop_back();
                        taken.erase({i, to});
                        taken.erase({to, to1});
                    }
                }
            }
        }
    }
}

void Solve() {
    cin >> n >> m;
    if (m & 1) {
        cout << "No";
        exit(0);
    }
    forn (i, m) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        g[a].pb(b);
    }
    rec(0);
    cout << "No";
}

signed main() {
    IO();
    int t = 1;
//    cin >> t;
    while (t--) {
        Solve();
    }
}