#include <bits/stdc++.h>

using namespace std;

#define nl '\n'
#define all(a) a.begin(), a.end()
#define vi vector<int>
#define forn(i, n) for (int i = 0; i < n; i++)
#define sz(a) ((int)a.size())
#define pb push_back
#define vpi vector<pair<int, int>>

typedef long long ll;

void IO() {
#ifdef Dmitry07
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#endif
}

auto seed = chrono::high_resolution_clock::now().time_since_epoch().count();
mt19937 rnd(seed);

const int INF = 1e9 + 7;
const ll INFL = 4e18;
const int MAXN = 3e5 + 10;

// #define int ll

vpi g[MAXN];
int mi[MAXN], ma[MAXN];

void dfs(int v, int par) {
    for (auto[to, c] : g[v]) {
        if (to != par) {
            mi[to] = min(mi[v], c);
            ma[to] = max(ma[v], c);
            dfs(to, v);
        }
    }
}

void Solve() {
    int n, m;
    cin >> n >> m;
    fill(mi, mi + MAXN, INF);
    fill(ma, ma + MAXN, 0);
    forn (i, m) {
        int a, b, c;
        cin >> a >> b >> c;
        a--;
        b--;
        g[a].pb({b, c});
        g[b].pb({a, c});
    }
    if (m == n - 1) {
        dfs(0, -1);
        for (int i = 1; i < n; i++) {
            cout << mi[i] + ma[i] << nl;
        }
        exit(0);
    }
}

signed main() {
    IO();
    int t = 1;
//    cin >> t;
    while (t--) {
        Solve();
    }
}