#include <bits/stdc++.h>

using namespace std;

#define nl '\n'
#define all(a) a.begin(), a.end()
#define vi vector<int>
#define forn(i, n) for (int i = 0; i < n; i++)
#define sz(a) ((int)a.size())
#define pb push_back
#define vpi vector<pair<int, int>>
#define minq(mi, a) mi = min(mi, a)
#define maxq(ma, a) ma = max(ma, a)
#define pi pair<int, int>

typedef long long ll;

void IO() {
#ifdef Dmitry07
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#endif
}

auto seed = chrono::high_resolution_clock::now().time_since_epoch().count();
mt19937 rnd(seed);

const int INF = 1e9 + 7;
const ll INFL = 4e18;
const int MAXN = 3e5 + 10;

#define int ll

vpi g[MAXN];
int mi[MAXN], ma[MAXN], d[MAXN], n, m, ans[MAXN];

void dfs(int v, int par) {
    for (auto[to, c] : g[v]) {
        if (to != par) {
            mi[to] = min(mi[v], c);
            ma[to] = max(ma[v], c);
            dfs(to, v);
        }
    }
}

void dij() {
    set<pi > s;
    forn (i, n) {
        d[i] = INF;
        s.insert({d[i], i});
    }
    d[0] = 0;
    while (sz(s)) {
        auto[dd, v] = *s.begin();
        s.erase(s.begin());
        for (auto[to, c] : g[v]) {
            if (d[to] > d[v] + c) {
                s.erase({d[to], to});
                d[to] = d[v] + c;
                s.insert({d[to], to});
            }
        }
    }
}

set<pi > ss;

void rec(int v, int mn, int mx) {
    minq(ans[v], mn + mx);
    for (auto[to, c] : g[v]) {
        if (ss.count({min(v, to), max(v, to)}) == 0) {
            ss.insert({min(v, to), max(v, to)});
            rec(to, min(mn, c), max(mx, c));
            ss.erase({min(v, to), max(v, to)});
        }
    }
}

void Solve() {
    cin >> n >> m;
    fill(mi, mi + MAXN, INF);
    fill(ma, ma + MAXN, 0);
    fill(ans, ans + MAXN, INF);
    int minC = INF, maxC = 0;
    forn (i, m) {
        int a, b, c;
        cin >> a >> b >> c;
        a--;
        b--;
        g[a].pb({b, c});
        g[b].pb({a, c});
        if (min(a, b) == 0) {
            minq(minC, c);
            maxq(maxC, c);
        }
    }
    if (m == n - 1) {
        dfs(0, -1);
        for (int i = 1; i < n; i++) {
            cout << mi[i] + ma[i] << nl;
        }
        exit(0);
    }
    if (n <= 10) {
        rec(0, INF, 0);
        for (int i = 1; i < n; i++) {
            cout << ans[i] << nl;
        }
        exit(0);
    }
}

signed main() {
    IO();
    int t = 1;
//    cin >> t;
    while (t--) {
        Solve();
    }
}