#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <queue>
#include <set>
#include <map>
#include <iomanip>
#include <cassert>
using namespace std;
#define int long long
#define debug(x) cout << #x << " is " << x << '\n';
#define ld long double
map <char, int> mp;
vector <int> ids;
string s, ans1 = "";
int res;
void gen(int sz) {
	if (sz == ids.size()) {
		int n = s.size(), get = mp[s.back()];
		char mx = s.back();
		for (int i = n - 2; i >= 0; --i) {
			if (mx > s[i]) get -= mp[s[i]];
			else get += mp[s[i]];
			mx = max(mx, s[i]);
		}
		if (get > res) {
			ans1 = s, res = get;
		}
		return;
	}
	for (auto x = 'A'; x <= 'Z'; ++x) {
		s[ids[sz]] = x;
		gen(sz + 1);
	}
}
/*
4
BBBC
????
A?B?C?D
YYYYY?
*/
signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout << fixed << setprecision(6);
	mp['A'] = 1;
	int cur = 5;
	for (auto x = 'B'; x <= 'Z'; x++) {
		mp[x] = mp[x - 1] * cur;
		cur = 7 - cur;
	}
	int testcases;
	cin >> testcases;
	while (testcases-- > 0) {
		cin >> s; int n = s.size();
		vector <int> suf(n + 1);
		int ans = 0;
		for (int i = n - 1; i >= 0; --i) {
			if (s[i] == '?') {
				vector <int> cnt(26);
				for (int j = 0; j < i; ++j) {
					if (s[j] == '?') continue;
					cnt[s[j] - 'A']++;
				}
				int cur = 0;
				for (int j = 0; j < suf[i + 1]; ++j) {
					cur += mp[j + 'A'] * cnt[j];
				}
				int mx = -1e18, ind = -1;
				for (int j = suf[i + 1]; j < 26; ++j) {
					if (mp[j + 'A'] - cur > mx)
						mx = mp[j + 'A'] - cur, ind = j;
					cur += mp[j + 'A'] * cnt[j];
				}
				s[i] = (char)(ind + 'A');
			}
			suf[i] = max((int)s[i] - 'A', suf[i + 1]);
			if (suf[i] > s[i] - 'A') ans -= mp[s[i]];
			else ans += mp[s[i]];
		}
		cout << ans << '\n';
		cout << s << '\n';
	}
}