#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <queue>
#include <set>
#include <map>
#include <iomanip>
#include <cassert>
using namespace std;
#define int long long
#define debug(x) cout << #x << " is " << x << '\n';
#define ld long double
vector <vector <pair <int, int>>> g;
vector <int> ans;
void dfs(int v, int mn, int mx, int p) {
	ans[v] = mn + mx;
	for (auto u : g[v]) {
		if (u.first == p) continue;
		dfs(u.first, min(mn, u.second), max(mx, u.second), v);
	}
}
signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout << fixed << setprecision(6);
	int n, m; cin >> n >> m;
	g.resize(n + 1);
	ans.resize(n + 1);
	for (int i = 0; i < m; ++i) {
		int u, v, w;
		cin >> u >> v >> w;
		g[u].push_back({v, w});
		g[v].push_back({ u, w });
	}
	dfs(1, 1e18, -1e18, 1);
	for (int i = 2; i <= n; ++i) cout << ans[i] << '\n';
}