#include <bits/stdc++.h>

///#define int ll

using namespace std;

#define ff first
#define ss second
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define _ << " " <<

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

ll pw(ll x, ll y) {
    if (y == 0) return 1;
    if (y&1) return x*pw(x, y-1);
    return pw(x*x, y/2);
}

const int MXN = 3e5+111;
const int MXK = 26;

ll rm[MXK];

ll from_str(string s) {
    ll ans = 0;
    reverse(all(s));
    char mx = 'A';
    for (auto to: s) {
        if (mx <= to) {
            ans += rm[to - 'A'];
        } else {
            ans -= rm[to - 'A'];
        }
        mx = max(mx, to);
    }
    return ans;
}

ll dp[MXN][MXK];
char opt[MXN][MXK];
int par[MXN][MXK];
string s;

ll f(int mx, char c) {
    if (mx <= (int)(c - 'A')) {
        return rm[c - 'A'];
    } else {
        return -rm[c - 'A'];
    }
}

void calc(int i, int j) {
    if (dp[i][j] == -1e18) return;
    //cout << "calc" _ i _ j << endl;
    //cout << "dp[" << i << "][" << j << "]=" << dp[i][j] << endl;
    if (s[i] != '?') {
        //cout << "A" << endl;
        char c = s[i];
        ll lans = dp[i][j] + f(j, c);
        if (dp[i+1][max(j, (int)(c-'A'))] < lans) {
            //cout << "!" _ c << endl;
            dp[i+1][max(j, (int)(c-'A'))] = lans;
            opt[i+1][max(j, (int)(c-'A'))] = c;
            par[i+1][max(j, (int)(c-'A'))] = j;
        }
    } else {
        //cout << "B" << endl;
        for (char c = 'A'; c <= 'Z'; ++c) {
            ll lans = dp[i][j] + f(j, c);
            if (dp[i+1][max(j, (int)(c-'A'))] < lans) {
                //cout << "!" _ c << endl;
                dp[i+1][max(j, (int)(c-'A'))] = lans;
                opt[i+1][max(j, (int)(c-'A'))] = c;
                par[i+1][max(j, (int)(c-'A'))] = j;
            }
        }
    }
}

void solve() {
    cin >> s;
    int n = s.size();
    reverse(all(s));
    for (int i = 0; i <= n; ++i) {
        for (int j = 0; j < MXK; ++j) {
            dp[i][j] = -1e18;
            opt[i][j] = '#';
            par[i][j] = -1;
        }
    }
    dp[0][0] = 0;
    for (int i = 0; i+1 <= n; ++i) {
        for (int j = 0; j < MXK; ++j) {
            calc(i, j);
        }
    }
    int x = n;
    int y = 0;
    for (int j = 1; j < MXK; ++j) {
        if (dp[x][y] < dp[x][j]) {
            y = j;
        }
    }
    cout << dp[x][y] << "\n";
    string ans = "";
    while (x > 0) {
        //cout << "x=" << x _ "y=" << y << endl;
        //cout << "opt[" << x << "][" << y << "]=" << opt[x][y] << endl;
        ans.push_back(opt[x][y]);
        y = par[x][y];
        --x;
    }
    cout << ans << "\n";
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    ///
    for (int i = 0; i < 26; i += 2) {
        rm[i] = pw(10, i/2);
        rm[i+1] = 5*rm[i];
    }
    /*for (int i = 0; i < 26; ++i) {
        cout << "rm[" << i << "]=" << rm[i] << endl;
    }//*/
    ///
    int tests = 1;
    cin >> tests;
    while (tests--) {
        solve();
    }
}
