#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

//#pragma GCC target("avx2");
//#pragma GCC optimize("Ofast");
//#pragma GCC optimize("unrol-loops");

typedef long long ll;
typedef long double ld;
/*
typedef tree <
int,
null_type,
less<int>,
rb_tree_tag,
tree_order_statistics_node_update>
oredered_set;
*/

#define _ << " " <<
#define ff first
#define ss second
#define pb push_back

#ifdef LOCAL
    #define err cerr
#else
    #define err if (0) cerr
#endif // LOCAL

int cost(int pos, int l, int r, vector<ll> &h, vector<ll> &x) {
    int n = h.size();
    if (l >= 0) {
        if (x[l] <= x[pos] - h[pos]) return 1;
    } else {
        if (x[pos] - h[pos] >= x[0]) return 1;
    }
    if (r < n) {
        if (x[r] >= x[pos] + h[pos]) return 1;
    } else {
        if (x[pos] + h[pos] <= x[n - 1]) return 1;
    }
    return 0;
}

void solve() {
    int n, q;
    cin >> n >> q;

    vector<ll> h(n), x(n);
    for (int i = 0; i < n; ++i) {
        cin >> x[i] >> h[i];
    }

    int l, r;
    while (q--) {
        cin >> l >> r;
        --l;
        --r;

        int ans = 0;
        bool fl = true;
        vector<int> lft(n), rght(n);
        for (int i = 0; i < n; ++i) {
            lft[i] = i - 1;
            rght[i] = i + 1;
        }

        vector<bool> used(n);
        while (fl) {
            fl = false;
            for (int i = l; i <= r; ++i) {
                if (!used[i] && cost(i, lft[i], rght[i], h, x)) {
                    if (rght[i] != n) lft[rght[i]] = lft[i];
                    if (lft[i] != -1) rght[lft[i]] = rght[i];

                    used[i] = true;
                    ans++;
                    fl = true;
                }
            }
        }

        cout << ans << "\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL

    int tests = 1;
    //cin >> tests;
    while (tests--) {
        solve();
    }
}

