#include <bits/stdc++.h>

using namespace std;

const int N = 150000;
vector<int> g_both[N];
vector<int> g[N];


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie();

    int n, m;
    cin >> n >> m;

    vector<int> in_e[n];
    vector<int> out_e[n];
    vector<pair<int, int>> edges;

    for (int i = 0; i < m; ++i) {
        int v, u;
        cin >> v >> u;
        v--;
        u--;

        edges.emplace_back(v, u);
    }

    for (int mask = 0; mask < (1 << m); ++mask) {
        int tmp = mask;
        for (int i = 0; i < n; ++i) {
            in_e[i].clear();
            out_e[i].clear();
        }
        for (int i = 0; i < m; ++i) {
            if (tmp % 2 == 1) {
                out_e[edges[i].first].push_back(i);
            } else {
                in_e[edges[i].second].push_back(i);
            }
            tmp /= 2;
        }
        bool flag = true;
        vector<pair<int, int>> res;
        for (int i = 0; i < n; ++i) {
            if (in_e[i].size() != out_e[i].size()) {
                flag = false;
                break;
            } else {
                for (int j = 0; j < in_e[i].size(); ++j) {
                    res.emplace_back(in_e[i][j], out_e[i][j]);
                }
            }
        }
        if (flag) {
            cout << "Yes\n";
            for (auto el : res) {
                cout << edges[el.first].first + 1 << ' ' << edges[el.first].second + 1 << ' '
                     << edges[el.second].first + 1 << ' ' << edges[el.second].second + 1 << '\n';
            }

            return 0;
        }
    }

    cout << "No\n";
}
