#include <iostream>
#include <set>
#include <vector>

using namespace std;

vector <pair <int, int> > g[301000];
set <int> used;

void dfs(int v, int mid)
{
    used.insert(v);
    for (int i = 0; i < g[v].size(); i++)
        if (used.find(g[v][i].first) == used.end() && g[v][i].second <= mid)
            dfs(g[v][i].first, mid);
}
int main()
{
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; i++){
        int u, v, t;
        cin >> u >> v >> t;
        g[u].push_back(make_pair(v, t));
        g[v].push_back(make_pair(u, t));
    }
    for (int i = 2; i <= n; i++){
        int l = -1, r = 1000000000;
        while (r - l > 1){
            used.clear();
            int mid = (l + r) / 2;
            dfs(1, mid);
            if (used.find(i) != used.end())
                r = mid;
            else
                l = mid;
        }
        cout << r << '\n';
    }
    return 0;
}
