#include <bits/stdc++.h>
using namespace std;

#define ioBoost ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define all(x) begin(x), end(x)
#define rall(x) rbegin(x), rend(x)
#define Please return
#define AC 0

typedef long long ll;

array<ll, 26> vals;

ll count(string str, const vector<char> &reprs) {
    ll mx = 0, res = 0, cnt = 0;

    for (int i = (int) str.size() - 1; i >= 0; --i) {
        if (str[i] == '?' && cnt >= reprs.size())
            continue;
        else if (str[i] == '?') {
            str[i] = reprs[cnt++];
        }

        if (mx > (str[i] - 'A'))
            res -= vals[str[i] - 'A'];
        else
            res += vals[str[i] - 'A'];
        mx = max(mx, (ll) (str[i] - 'A'));
    }

    return res;
}

pair<ll, vector<char>> gen(string s) {
    stack<pair<vector<char>, int>> st;

    pair<ll, vector<char>> ans = {LLONG_MIN, vector<char>()};

    st.emplace(vector<char>(), 0);

    while (!st.empty()) {
        pair<vector<char>, int> up = st.top();
        st.pop();
        int pos = up.second;

        if (pos == s.size()) {
            ans = max(ans, {count(s, up.first), up.first});
            continue;
        }

        if (s[pos] != '?') {
            st.emplace(up.first, pos + 1);
            continue;
        }

        for (int i = 0; i < 26; ++i) {
            auto vec = up.first;

            vec.push_back((char)(i + 'A'));

            st.emplace(vec, pos + 1);
        }
    }

    return ans;
}

void solve() {
    string s;
    cin >> s;

    vals[0] = 1;
    for (int i = 1; i < 26; ++i) {
        if (i % 2)
            vals[i] = vals[i - 1] * 5;
        else
            vals[i] = vals[i - 1] * 2;
    }

    auto[cnt, ans] = gen(s);

    int cntq = 0;

    for (auto &en: s) {
        if (en == '?') {
            en = ans[cntq++];
        }
    }

    cout << cnt << '\n' << s << '\n';
}

signed main() {
    ioBoost;
    int tt = 1;
    cin >> tt;

    while (tt--)
        solve();

    Please AC;
}
