#include <bits/stdc++.h>
using namespace std;

#define ioBoost ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define all(x) begin(x), end(x)
#define rall(x) rbegin(x), rend(x)
#define Please return
#define AC 0

typedef long long ll;

array<ll, 26> vals;

ll count(string str, const vector<char> &reprs) {
    ll mx = 0, res = 0, cnt = 0;

    for (ll i = (int) str.size() - 1; i >= 0; --i) {
        if (str[i] == '?' && cnt >= reprs.size())
            continue;
        else if (str[i] == '?') {
            str[i] = reprs[cnt++];
        }

        if (mx > (str[i] - 'A'))
            res -= vals[str[i] - 'A'];
        else
            res += vals[str[i] - 'A'];
        mx = max(mx, (ll) (str[i] - 'A'));
    }

    return res;
}


pair<ll, vector<char>> gen(const string& s, vector<char> repr, int pos) {
    pair<ll, vector<char>> ans = {LLONG_MIN, vector<char>()};

    if (pos == s.size()) return {count(s, repr), repr};

    if (s[pos] != '?') return gen(s, repr, pos + 1);

    for (int i = 0; i < 26; ++i) {
        repr.push_back((char)('A' + i));
        ans = max(ans, gen(s, repr, pos + 1));
        repr.pop_back();
    }

    return ans;
}

void solve() {
    string s;
    cin >> s;

    vals[0] = 1;
    for (ll i = 1; i < 26; ++i) {
        if (i % 2)
            vals[i] = vals[i - 1] * 5;
        else
            vals[i] = vals[i - 1] * 2;
    }

    auto[cnt, ans] = gen(s, vector<char>(), 0);

    ll cntq = 0;

    for (auto &en: s) {
        if (en == '?') {
            en = ans[cntq++];
        }
    }

    cout << cnt << '\n' << s << '\n';
}

signed main() {
    ioBoost;
    int tt = 1;
    cin >> tt;

    while (tt--)
        solve();

    Please AC;
}
