#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;


struct e {
    int to, rev, ind;
};
const int maxn = 3e5 + 2;
vector<int> g[maxn];
vector<e> lst[maxn];
vector<int> dp[maxn];
int d[maxn], vis[maxn], col[maxn];
vector<pair<int, int>> ans;
int cnt = 0;
int BL = 0;

void dfs(int st, int pr = -1) {
    vis[st] = 1;
    col[st] = cnt;
    for (int to : g[st]) {
        if (!vis[to]) {
            d[to] = d[st] + 1;
            dfs(to, st);
        }
    }
}

vector<int> used;

void dfs2(int st) {
    vector<int> up, dow;
    vis[st] = 1;
    if (lst[st].size() == 0) {
        dp[st][0] = 1;
        return;
    }
    for (int i = 0; i < lst[st].size(); i++) {
        if (!vis[lst[st][i].to]) {
            dfs2(lst[st][i].to);
        }
        if (lst[st][i].rev == 0) {
            if (dp[lst[st][i].to][1] != -1) {
                ans.push_back({lst[st][i].ind, dp[lst[st][i].to][1]});
            } else {
                dow.push_back(lst[st][i].ind);
            }
        } else {
            if (dp[lst[st][i].to][2] != -1) {
                ans.push_back({dp[lst[st][i].to][2], lst[st][i].ind});

            } else {
                up.push_back(lst[st][i].ind);
            }
        }
    }
    if (up.size() == dow.size()) {
        dp[st][0] = 1;
        for (int i = 0; i < up.size(); i++) {
            ans.push_back({up[i], dow[i]});
        }
    } else if (up.size() == dow.size() + 1) {
        for (int i = 0; i < dow.size(); i++) {
            ans.push_back({up[i], dow[i]});
        }
        dp[st][2] = up.back();
    } else if (up.size() + 1 == dow.size()) {
        for (int i = 0; i < up.size(); i++) {
            ans.push_back({up[i], dow[i]});
        }
        dp[st][1] = dow.back();
    } else {
        BL = 1;
    }
}


signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; i++){
        dp[i].push_back(-1);
        dp[i].push_back(-1);
        dp[i].push_back(-1);
        vis[i]= 0;
        d[i] = 0;
        col[i] = -1;
    }
    vector<pair<int, int>> edg;

    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        g[a].push_back(b);
        g[b].push_back(a);
        edg.push_back({a, b});
    }
    vector<int> vv;
    for (int i = 0; i < n; i++) {
        if (col[i] == -1) {
            dfs(i);
            cnt++;
            vv.push_back(i);
        }
        vis[i] = 0;
    }

    for (int i = 0; i < m; i++) {
        int a = edg[i].first, b = edg[i].second;
        if (d[a] < d[b]) {
            lst[a].push_back({b, 0, i});
        } else {
            lst[b].push_back({a, 1, i});
        }
    }
//    for (int i =0; i < n; i++){
//        cerr << "V: " << i << ":\n";
//        for (int j =0; j < lst[i].size(); j++){
//            cerr << lst[i][j].to << " " << lst[i][j].rev << '\n';
//        }
//    }
    for (int i : vv) {
        dfs2(i);
        if (dp[i][0] == -1 || BL == 1) {
            cout << "No";
            return 0;
        }
    }
    cout << "Yes\n";
    for (int i = 0; i < ans.size(); i++) {
        cout << edg[ans[i].first].first + 1 << " " << edg[ans[i].first].second + 1 << " "
             << edg[ans[i].second].first + 1 << " " << edg[ans[i].second].second + 1 << '\n';
    }
    return 0;
}