#include <bits/stdc++.h>
#define f first
#define s second
#define _ << ' ' <<
#define all(x) x.begin(), x.end()
#define mp make_pair
//define int long long
#define time() clock() / (ld)CLOKS_PER_SEC

using namespace std;

typedef pair<int, int> pii;
typedef long long ll;
typedef long double ld;

const int MAXN = 21, INF = 1e9;

struct Edge {
    int to, w, us;

    Edge (int to = 0, int w = 0, int us = 0): to(to), w(w), us(us) {}
};

vector<Edge> g[MAXN];

int ans[MAXN];

void dfs(int v, int mn, int mx) {
    ans[v] = min(ans[v], mn + mx);
    for (auto &e : g[v]) {
        if (e.us) continue;
        e.us = 1;
        dfs(e.to, min(mn, e.w), max(mx, e.w));
        e.us = 0;
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    int v, to, w;
    for (int i = 0; i < m; i++) {
        cin >> v >> to >> w;
        v--;
        to--;
        g[v].push_back(Edge(to, w));
        g[to].push_back(Edge(v, w));
    }
    fill(ans, ans + n, INF * 2);
    dfs(0, INF, 0);
    for (int i = 1; i < n; i++) cout << ans[i] << ' ';
}

signed main() {
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
    #endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int tests = 1;
    //cin >> tests;
    while (tests--) {
        solve();
    }
}

