#include <bits/stdc++.h>
using namespace std;

//#define int long long
#define F first
#define S second
#define mp make_pair
#define pb push_back
#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()
#ifdef MY
    #define endl '\n'
#endif // MY

typedef long long ll;
typedef double db;
typedef pair < int, int > pii;

struct Edge {
    int v, u, t;
    Edge (int v = 0, int u = 0, int t = 0) : v(v), u(u), t(t) {}
};

const int N = 3e5 + 5;
const int inf = 1e9 + 7;
vector < pii > gr[N];
Edge edge[N];
int ans[N];
int mn[N], mx[N];

void dfs(int v, int a = inf, int b = 0, int prv = -1) {
    if (v) {
        a = min(a, mn[v]);
        b = max(b, mn[v]);
    }
    ans[v] = a + b;
//    bool fl = 0;
    for (auto p : gr[v]) {
        int u = p.F, t = p.S;
        if (u == prv) {
            continue;
        }
        mn[u] = min(mn[u], t);
        dfs(u, a, b, v);
    }
}

signed main() {
#ifdef MY
    freopen("f.in", "r", stdin);
#endif // MY
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; i++) {
        int v, u, t;
        cin >> v >> u >> t;
        v--, u--;
        gr[v].pb({u, t});
        gr[u].pb({v, t});
//        edge[i] = {v, u, t};
    }
    fill(mn, mn + n, inf);
    dfs(0);
    for (int i = 1; i < n; i++) {
        cout << ans[i] << endl;
    }
    return 0;
}
