#include <bits/stdc++.h>
using namespace std;
using ll = long long;

ll pw10[] = {1, 10, 100, 1000, 10000, 1'00'000, 1'000'000, 1'0'000'000, 1'00'000'000, 1'000'000'000, 1'000'000'000'0, 1'000'000'000'00, 1'000000'0000'00, 1'0000000000000};

ll get_letter(char x) {
    if (x % 2 == 1) {
        return pw10[(x - 'A') / 2];
    }
    else {
        return 5 * pw10[(x - 'A') / 2];
    }
}

char ans[300228];

ll solve(string& s, int start, char max_met = 'A') {
    if (start == -1) return 0;
    if (s[start] != '?') {
        ans[start] = s[start];
        ll ret = get_letter(s[start]);
        if (s[start] < max_met) {
            ret = -ret;
        }
        return ret + solve(s, start - 1, max(max_met, s[start]));
    }
    ll mx = 0;
    for (char cur = max_met; cur <= 'Z'; ++cur) {
        ll v = solve(s, start - 1, cur) + get_letter(cur);
        if (v > mx) {
            ans[start] = cur;
            mx = v;
        }
    }
    return mx;
}

int main() {
    int t;
    cin >> t;
    while (t --> 0) {
        string s;
        cin >> s;
        ans[s.size()] = '\0';
        cout << solve(s, s.size() - 1) << '\n' << ans << '\n';
    }
    return 0;
}