#include <bits/stdc++.h>

using namespace std;
using ll = long long;

struct Tree {
    int x, h;
};

ll makepair(int x, int y) {
    return (long long)x << 32 | y;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, q;
    cin >> n >> q;
    Tree trees[n];
    unordered_map<int, int> x_to_i;
    for (int i = 0; i < n; ++i) {
        cin >> trees[i].x >> trees[i].h;
        x_to_i[trees[i].x] = i;
    }
    unordered_map<ll, int> cache;
    while (q --> 0) {
        int l, r;
        cin >> l >> r;

        --l;
        --r;

        if (cache.find(makepair(l, r)) != cache.end()) {
            cout << cache[makepair(l, r)] << '\n';
            continue;
        }
        set<int> xs;
        for (int i = l; i <= r; ++i) {
            xs.insert(trees[i].x);
        }
        while (!xs.empty()) {
            bool fl = false;
            for (auto now: xs) {
                auto it2 = xs.upper_bound(now);
                auto it = xs.lower_bound(now);
                --it;
                int h = trees[x_to_i[now]].h;
                //*it + h <= now
                if ((now - h >= trees[  0  ].x && (x_to_i[now] == l ? now - h >= trees[l - 1].x : *it  + h <= now)) ||
                    (now + h <= trees[n - 1].x && (x_to_i[now] == r ? trees[r + 1].x >= now + h : *it2 - h >= now))) {
                    xs.erase(now);
                    fl = true;
                    break;
                }
            }
            if (!fl) break;
        }
        cout << r - l + 1 - xs.size() << '\n';
        cache[makepair(l, r)] = r + l + 1 - xs.size();
    }
    return 0;
}