#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>

using namespace std;

#define ll long long
bool ok = true;
vector<pair<pair<int,int>,pair<int,int>>> ans;
vector<pair<int,int>> g[300000];
set<pair<int,int>> se;
char used[300000];

int dfs(int v, int pr, int r){
    used[v] = 1;
    vector<int> a;
    vector<int> b;
    for(auto i : g[v]){
        if(!used[i.first]) {
            int nw = dfs(i.first, v, i.second);
            if(nw == 1){
                a.push_back(i.first);
            }
            if(nw == 2){
                b.push_back(i.first);
            }
        }
    }
    if(abs((int)a.size() - (int)b.size()) >= 2){
        ok = false;
        return 0;
    }

    int diff = (int)a.size() - (int)b.size();
    for(int i = 0; i < min(a.size(),b.size()); ++i){
        ans.push_back({{v,a[i]},{b[i],v}});
    }

    if(diff == 1){
        if(r == 0 || r == 2){
            ok = false;
            return 0;
        }
        ans.push_back({{pr,v},{v,a.back()}});
        if(r == 3){
            r = 2;
        }
        else{
            r = 0;
        }
    }

    if(diff == -1){
        if(r == 0 || r == 1){
            ok = false;
            return 0;
        }
        ans.push_back({{b.back(),v},{v,pr}});
        if(r == 3){
            r = 1;
        }
        else{
            r = 0;
        }
    }
    if(r == 3){
        ans.push_back({{v,pr},{pr,v}});
        r = 0;
    }
    return r;

}

void solve(){
    int n,m;
    cin >> n >> m;

    for(int i = 0; i < m; ++i){
        int u,v;
        cin >> u >> v;
        --u;
        --v;
        se.insert({u,v});
    }

    for(auto i : se) {
        if (se.count({i.second, i.first})) {
            if (i.first < i.second) {
                g[i.second].emplace_back(i.first, 3);
                g[i.first].emplace_back(i.second, 3);
            }
        }
        else {
            g[i.first].emplace_back(i.second, 1);
            g[i.second].emplace_back(i.first, 2);
        }
    }

    for(int i = 0; i < n; ++i){
        if(!used[i]){
            dfs(i,-1,0);
        }
    }

    if(!ok){
        cout << "No";
        return;
    }
    cout << "Yes\n";
    for(auto i : ans){
        cout << i.first.first + 1 << ' ' << i.first.second + 1 << ' ' << i.second.first + 1 << ' ' << i.second.second + 1 << '\n';
    }

}

signed main(){
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#ifdef Debugg
    freopen("ain.txt","r",stdin);
    freopen("aout.txt","w",stdout);
#endif
    solve();
}