#pragma GCC optimize("Ofast")

#include <bits/stdc++.h>

using namespace std;

#define ll long long

int ans[300000];
vector<pair<int,int>> g[300000];
char used[300000];

void dfs(int v, int pr, int minn, int maxx){
    ans[v] = minn + maxx;
    for(auto to : g[v]){
        if(to.first != pr){
            dfs(to.first,v,min(minn,to.second), max(maxx,to.second));
        }
    }
}

int dsu[300000];


int get_root(int v){
    if(dsu[v] ==v) return v;
    return dsu[v] = get_root(dsu[v]);
}


void solve(){
    fill(ans,ans + 3000000, 2000000000);
    int n,m;
    cin >> n >> m;
    if(m == n - 1){
        for(int i = 0; i < m; ++i){
            int u,v,t;
            cin >> u >> v >> t;
            g[--u].emplace_back(--v,t);
            g[v].emplace_back(u,t);
        }
        dfs(0,-1,2e9,-1);
        for(int i = 1; i < n; ++i){
            cout << ans[i] << '\n';
        }
        return;
    }
    else if(m <= 10) {
        vector<int> nw(m);
        for (int i = 0; i < m; ++i) {
            nw[i] = i;
        }
        vector<pair<pair<int, int>, int>> d;
        for (int i = 0; i < m; ++i) {
            int u, v, t;
            cin >> u >> v >> t;
            d.push_back({{--u, --v}, t});
        }
        for (int _ = 0; _ < 4628800; ++_) {
            next_permutation(nw.begin(), nw.end());
            int minn = 1e9 + 1;
            int maxx = -1;
            int last = 0;
            for (int i = 0; i < m; ++i) {
                if (d[nw[i]].first.first != last && d[nw[i]].first.second != last) {
                    break;
                }
                if (d[nw[i]].first.second == last) {
                    swap(d[nw[i]].first.first, d[nw[i]].first.second);
                }
                last = d[nw[i]].first.second;
                minn = min(minn, d[nw[i]].second);
                maxx = max(maxx, d[nw[i]].second);
                ans[last] = min(ans[last], minn + maxx);
            }

        }
        for (int i = 1; i < n; ++i) {
            cout << ans[i] << '\n';
        }
    }
    else{
        bool aaa = false;
        vector<pair<int,pair<int,int>>> reb;
        for(int i = 0; i < m; ++i){
            int u,v,t;
            cin >> u >> v >> t;
            if((u == 1 || v == 1) && t == 1000000000){
                aaa = true;
            }
            g[--u].emplace_back(--v,t);
            g[v].emplace_back(u,t);
            reb.push_back({t,{u,v}});
        }
        if(aaa){
            sort(reb.begin(), reb.end());
            for(int i = 0; i < n; ++i){
                dsu[i] = i;
            }
            for(int i = 0; i < m; ++i){
                int r1 = get_root(reb[i].second.first);
                int r2 = get_root(reb[i].second.second);
                if(r1 != r2){
                    dsu[r1] = r2;
                }
                int r3 = get_root(0);
                r1 = get_root(reb[i].second.first);
                r2 = get_root(reb[i].second.second);
                if(r1 == r3){
                    ans[reb[i].second.first] = min(ans[reb[i].second.first],reb[i].first);
                }
                if(r2 == r3){
                    ans[reb[i].second.second] = min(ans[reb[i].second.second],reb[i].first);
                }
            }
            for(int i = 1; i < n; ++i){
                cout << ans[i] << '\n';
            }
        }
        else {
            set<pair<int, int>> dj;
            vector<bool> used(n);
            vector<int> dist(n, 2e9);
            dist[0] = 0;
            for (int i = 0; i < n; ++i) {
                dj.insert({dist[i], i});
            }
            for (int i = 0; i < n; ++i) {
                auto nw = *dj.begin();
                dj.erase(dj.begin());
                dist[nw.second] = nw.first;
                for (auto to : g[nw.second]) {
                    if (max(dist[nw.second], to.second) < dist[to.first]) {
                        dj.erase({dist[to.first], to.first});
                        dist[to.first] = max(dist[nw.second], to.second);
                        dj.insert({dist[to.first], to.first});
                    }
                }
            }
            for(int i = 1; i < n; ++i){
                cout << dist[i] << '\n';
            }
        }
    }

}

signed main(){
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#ifdef Debugg
    freopen("ain.txt","r",stdin);
    freopen("aout.txt","w",stdout);
#endif
    solve();
}