#include "bits/stdc++.h"

using namespace std;

typedef long long ll;

#define fi first
#define se second

ll n, m;
vector<vector<pair<ll, ll>>> g;

vector<ll> ans;

void dfstree(ll v, ll mn, ll mx, ll p) {
    if(v != 0) {
        ans[v - 1] = mn + mx;
    }

    for(auto x: g[v]) {
        if(x.fi != p) {
            dfstree(x.fi, min(mn, x.se), max(mx, x.se), v);
        }
    }
}

int main() {
    cin >> n >> m;
    g.resize(n);
    for(ll i = 0; i < m; ++i) {
        ll x, y, t; cin >> x >> y >> t; --x; --y;
        g[x].push_back({y, t});
        g[y].push_back({x, t});
    }

    ans.resize(n - 1);
/*
    if(m == n - 1) {
        dfstree(0, 1e9, 0, -1);
        for(auto x: ans) cout << x << '\n';
        return 0;
    }
*/
    ll mx = -1e18, mn = 1e18;

    for(ll i = 1; i < n; ++i) {
        ll a = 1e18;
        for(auto x: g[i]) {
            if(x.fi == i - 1) {
                a = min(a, x.se);
            }
        }
        //cout << a << '\n';
        mx = max(mx, a);
        mn = min(mn, a);
        ans[i-1] = mx + mn;
    }
    for(auto x: ans) cout << x << '\n';

    return 0;
}
