#include <bits/stdc++.h>
#include <ctime>
#include <random>

using namespace std;

typedef long long ll;
typedef long double ld;
#define mp make_pair
#define pb push_back
#define all(x) x.begin(), x.end()
#define rall(x) x.begin(), x.end()


ll calc_sum(vector<ll> &a, string &s) {
    ll res = 0;
    int n = s.length();
    vector<char> suff(n);
    for (int i = n - 1; i >= 0; --i) {
        suff[i] = s[i];
        if (i + 1 < n)
            suff[i] = max(suff[i], suff[i + 1]);
    }
    for (int i = 0; i < n; ++i) {
        if (suff[i] > s[i]) {
            res -= a[s[i] - 'A'];
        } else
            res += a[s[i] - 'A'];
    }
    return res;
}

inline void SOLVE() {
    string s;
    cin >> s;
    vector<ll> a(26);
    a[0] = 1;
    a[1] = 5;
    const int sz = 26;
    for (int i = 2; i < sz; ++i) {
        a[i] = a[i - 2] * 10;
    }
    int n = s.length();
    vector<int> id;
    for (int i = 0; i < n; ++i) {
        if (s[i] == '?')
            id.pb(i);
    }
    string ans = s;
    if (id.size() == 1) {
        ll best = -1;
        for (int i = 0; i < sz; ++i) {
            int v = id[0];
            s[v] = i + 'A';
            ll res = calc_sum(a, s);
            if (res > best) {
                ans = s;
                best = res;
            }
        }
    } else if (id.size() == 2) {
        ll best = -1;
        for (int i = 0; i < sz; ++i) {
            for (int j = 0; j < sz; ++j) {
                int v = id[0];
                int u = id[1];
                s[v] = i + 'A';
                s[u] = j + 'A';
                ll res = calc_sum(a, s);
                if (res > best) {
                    ans = s;
                    best = res;
                }
            }

        }
    } else if (id.size() == 3) {
        ll best = -1;
        for (int i = 0; i < sz; ++i) {
            for (int j = 0; j < sz; ++j) {
                for (int k = 0; k < sz; ++k) {
                    int v = id[0];
                    int u = id[1];
                    int w = id[2];
                    s[v] = i + 'A';
                    s[u] = j + 'A';
                    s[w] = k + 'A';
                    ll res = calc_sum(a, s);
                    if (res > best) {
                        ans = s;
                        best = res;
                    }
                }
            }
        }
    }
    cout << calc_sum(a, ans) << '\n';
    cout << ans << '\n';
}


inline void FASTIO() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
}


int main() {
#ifdef GOSHA
    freopen("../IO/input.txt", "r", stdin);
    freopen("../IO/output.txt", "w", stdout);
#endif
    FASTIO();
    int T = 1;
    cin >> T;
    while (T--) {
        SOLVE();
    }
}