#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <list>
#include <algorithm>
#include <cmath>
using namespace std;

int main()
{
	int n, q; cin >> n >> q;
	vector<int> x(n + 2), h(n + 2);
	for (int i = 1; i <= n; ++i)
		cin >> x[i] >> h[i];

	x[0] = x[1]; x[n + 1] = x[n];

	while (q--)
	{
		int l, r; cin >> l >> r;
		list<int> tek;
		for (int i = l - 1; i <= r + 1; ++i)
			tek.push_back(i);

		for (auto it = tek.begin(); it != tek.end() && next(it) != tek.end();)
		{
			if (it == tek.begin())
			{
				++it;
				continue;
			}

			int l = *prev(it), m = *it, r = *next(it);
			if (x[l] <= x[m] - h[m] || x[m] + h[m] <= x[r])
				it = prev(tek.erase(it));
			else
				++it;
		}

		cout << r - l + 3 - (int)tek.size() << '\n';
	}

	return 0;
}