#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <cmath>
#include <numeric>
using namespace std;

long long n, m;
vector<vector<pair<long long, long long>>> graph;

int main()
{
	cin >> n >> m;
	graph.resize(n);
	
	vector<long long> t1(n, 1e9 + 1), t2(n, 1e9 + 1);
	for (long long i = 0; i < m; ++i)
	{
		long long a, b, t; cin >> a >> b >> t; --a; --b;
		if (a > b) swap(a, b);
		t2[b] = min(t2[b], t);
		if (t1[b] > t2[b]) swap(t1[b], t2[b]);
	}

	for (long long i = 1; i < n; ++i)
	{
		long long mn = 1e9 + 1, mx = -1;
		for (int j = 1; j <= i; ++j)
		{
			mn = min(mn, t1[j]);
			mx = max(mx, t1[j]);
		}

		long long res = mn + mx;
		for (int j = i + 1; j < n; ++j)
		{
			//mn = min(mn, t1[j]);
			mx = max(mx, t1[j]);
			mn = min(mn, t2[j]);
			mx = max(mx, t2[j]);
			res = min(res, mn + mx);
		}
		
		cout << res << '\n';
	}

	return 0;
}