#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <functional>
#include <map>
#include <bitset>
#include <utility>
#include <cstring>
#include <algorithm>
#include <chrono>
#include <random>

#define int long long
#define fi(a, b) for (int i = a; i < b; ++i)
#define fj(a, b) for (int j = a; j < b; ++j)
#define fk(a, b) for (int k = a; k < b; ++k)
#define fx(x, a) for (auto &x : a)
#define mp make_pair
#define pb push_back
#define lb lower_bound
#define ub upper_bound
#define ppb pop_back()


#ifdef LOCAL
	#define dbg(x) cout << #x << " : " << x << endl
#else
	#define dbg(x)
#endif

using namespace std;


template<typename T1, typename T2> inline void mine(T1 &x, const T2 &y) {if (y < x) x = y;}
template<typename T1, typename T2> inline void maxe(T1 &x, const T2 &y) {if (x < y) x = y;}

typedef vector<int> vi;
typedef char ch;
typedef string str;
typedef pair<int, int> pii;
typedef vector<char> vch;
typedef vector<pii> vpii;
typedef vector<vi> vvi;
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;


mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

const int N = 300100;
const int INF = 1e9 + 228;
int ans[N];
vpii g[N];

void dfs(int v, int pr, int mn, int mx) {
	ans[v] = mn + mx;
	for (auto[to, t] : g[v]) {
		if (to == pr) continue;
		dfs(to, v, min(t, mn), max(t, mx));
	}
}

int32_t main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int n, m;
	cin >> n >> m;	
	fi(0, m) {
		int a, b, t;
		cin >> a >> b >> t;
		--a, --b;
		g[a].pb({b, t});
		g[b].pb({a, t});
	}
	dfs(0, 0, INF, 0);
	fi(1, n) cout << ans[i] << '\n';
}
