#include <bits/stdc++.h>
using namespace std;

vector<int> colors;
vector<vector<int>> graph;
vector<int> parsoch;

void dfs(int v, int c)
{
    colors[v] = c;
    for(int j : graph[v])
    {
        if(colors[j] == 0) dfs(j, -c);
    }
}
vector<bool> kuhn_used;
bool kuhn(int v)
{
    // cout << v << "\n";
    // for(bool i : kuhn_used) cout << i << " ";
    // cout << "\n";
    for(int i : graph[v])
    {
        if(!kuhn_used[i])
        {
            kuhn_used[i] = true;
            if(parsoch[i] == -1)
            {
                parsoch[i] = v;
                // kuhn_used[i] = false;
                return true;
            }
            else 
            {
                // cout << "Flex";
                if(kuhn(parsoch[i]))
                {
                    parsoch[i] = v;
                    // kuhn_used[i] = false;
                    return true;
                }
                // kuhn_used[i] = false;
                return false;
            }
            // kuhn_used[i] = false;
        }
    }
    return false;
}

int main()
{
    int n, m;
    cin >> n >> m;
    graph.resize(m);
    colors.resize(m, 0);
    vector<vector<int>> to(n);
    vector<vector<int>> from(n);
    vector<pair<int, int>> edges(m);
    for(int i = 0; i < m; i++)
    {
        int a, b;
        cin >> a >> b;
        edges[i] = {a-1,b-1};
        from[a-1].push_back(i);
        to[b-1].push_back(i);  
    }
    for(int i = 0; i < m; i++)
    {
        for(int j : to[edges[i].first]) graph[i].push_back(j);
        for(int j : from[edges[i].second]) graph[i].push_back(j);
    }
    for(int i = 0; i < m; i++)
    {
        if(colors[i] == 0)
            dfs(i, 1);
    }
    vector<int> dole1;
    vector<int> dole2;
    for(int i = 0; i < m; i++) if(colors[i] == 1) dole1.push_back(i);
                               else if(colors[i] == -1) dole2.push_back(i);
    if(dole1.size() != dole2.size())
    {
        cout << "No";
        exit(0);
    }
    parsoch.resize(m, -1);
    int ct = 0;
    kuhn_used.resize(m, false);
    for(int i : dole2)
    {
        if(kuhn(i)) ct ++; 
        kuhn_used.assign(m, false);
        // for(bool i : kuhn_used) cout << i << " ";
        // cout << "\n";  
    }
    // cout << ct << "\n";
    // for(int i : dole1) cout << parsoch[i] << " ";
    // cout << "\n";
    if(ct == dole1.size())
    {
        cout << "Yes\n";
        // for(int i : kuhn_used) cout << i << " ";
        for(int i : dole1)
        {
            int a = edges[i].first , b = edges[i].second, c = edges[parsoch[i]].first, d = edges[parsoch[i]].second;
            if(b != c)
            {
                swap(a, c);
                swap(b, d);
            }
            cout << a +1<< " " << b+1 << " " << c+1 << " " << d +1<< "\n";
        }
    }
    else cout << "No";
}