#include <iostream>
#include <map>
#include <set>
#include <vector>
#include <algorithm>
#include <cassert>

using namespace std;
#define int long long
#define mp make_pair
const int SZ = 3e5 + 4;
const int inf = 2e18;

int n, q;
int x[SZ];
int h[SZ];

void read() {
    cin >> n >> q;
    for (int i = 0; i < n; ++i) {
        cin >> x[i] >> h[i];
    }
}

void solve() {
    for (int i = 0; i < q; ++i) {
        int l, r;
        cin >> l >> r;
        --l;
        set<int> y;
        for (int j = l; j < r; ++j) {
            y.insert(j);
        }
        int ans = 0;
        while (!y.empty()) {
            int k = -1;
            for (auto p : y) {
                auto it = y.lower_bound(p);
                if (it == y.begin()) {
                    if (x[p] - h[p] >= x[0]) {
                        if (l == 0 || x[p] - h[p] >= x[l - 1]) {
                            k = p;
                            break;
                        }
                    }
                } else {
                    --it;
                    if (x[p] - h[p] >= x[*it]) {
                        k = p;
                        break;
                    }
                    ++it;
                }

                ++it;
                if (it == y.end()) {
                    if (x[p] + h[p] <= x[n - 1]) {
                        if (r == n || x[p] + h[p] <= x[r]) {
                            k = p;
                            break;
                        }
                    }
                } else {
                    if (x[p] + h[p] <= x[*it]) {
                        k = p;
                        break;
                    }
                }
            }
            if (k == -1) break;
            ++ans;
            y.erase(k);
        }

        cout << ans << "\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    read();
    solve();

    return 0;
}
