//#pragma GCC optimize("O3", "Ofast", "unroll-loops", "unswitch-loops", "fast-math", "no-stack-protector")

#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define size(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()

struct edge {
    int u, v, w;
};

bool cmp(edge &a, edge &b) {
    if (a.w < b.w)return true;
    return false;
}

int n, m;
vector<edge> e;

const int maxn = 300000;
vector<int> adj[maxn];
vector<int> ans;

int mx = 0;

void dii() {
    set<pair<int, int> > st;
    st.insert({0, 0});
    vector<int> dist(n, 1e9);
    dist[0] = 0;
    map<int, int> mp;
    while (!st.empty()) {
        auto cur = *st.begin();
        st.erase(st.begin());
        for (auto num : adj[cur.second]) {
            if (mp[num] == 1) continue;
            int to = e[num].v + e[num].u - cur.second;
            int w = max(e[num].w, cur.first);
            if (w < dist[to]) {
                mp[num] = 1;
                dist[to] = w;
                st.insert({dist[to], to});
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        ans[i] = dist[i];
    }
}

signed main() {
#ifdef _LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);

    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        u--, v--;
        e.push_back({u, v, w});
    }

    sort(all(e), cmp);
    for (int i = 0; i < size(e); ++i) {
        adj[e[i].u].push_back(i);
        adj[e[i].v].push_back(i);
    }
    ans.resize(n);
    for (int i = 0; i < n; ++i) {
        ans[i] = 2e9;
    }

    mx = 1e9;
    dii();
    for (int i = 1; i < n; ++i) {
        cout << ans[i] << "\n";
    }

}