#include <iostream>
#include <vector>
#include <map>
#include <set>

#define int long long

using namespace std;

signed main(){
    int n, q;
    cin >> n >> q;
    n += 2;
    vector<int> x(n);
    vector<int> h(n);
    for (int i = 1; i < n - 1; ++i){
        cin >> x[i] >> h[i];
    }
    x[0] = x[1];
    h[0] = 1e18;
    x[n - 1] = x[n - 2];
    h[n - 1] = 1e18;
    vector<int> can_r(n, -1);
    vector<int> can_l(n, -1);
    vector<int> left(n);
    vector<int> right(n);
    for (int i = 0; i < n; ++i){
        left[i] = i - 1;
        right[i] = i + 1;
    }
    vector<int> cut(n);
    for (int q = 0; q < n; ++q){
        for (int i = 0; i < n; ++i){
            if (cut[i]){
                continue;
            }
            if (left[i] != -1 && x[left[i]] + h[i] <= x[i]){
                can_l[i] = i - left[i];
                cut[i] = 2;
            }
            if (right[i] != n && x[right[i]] >= x[i] + h[i]){
                can_r[i] = right[i] - i;
                cut[i] = 2;
            }
        }
        for (int i = 0; i < n; ++i){
            if (cut[i] == 2){
                cut[i] = 1;
                if (left[i] != -1){
                    right[left[i]] = right[i];
                }
                if (right[i] != n){
                    left[right[i]] = left[i];
                }
            }
        }
    }
    /*for (int i = 0; i < n; ++i){
        cout << can_l[i] << "  " << can_r[i] << endl;
    }*/
    while (q--){
        int left, right;
        cin >> left >> right;
        right++;
        int ans = 0;
        for (int i = left; i < right; ++i){
            if (can_l[i] != -1 && i - can_l[i] + 1 >= left){
                ans++;
            } else if (can_r[i] != -1 && i + can_r[i] -1 < right){
                ans++;
            }
        }
        cout << ans << endl;
    }
    return 0;
}
/*
5 6
1 2
2 1
1 5
2 3
2 4
4 2
*/
