#include <iostream>
#include <algorithm>
#include <vector>
#include <set>

#define all(x) (x).begin(), (x).end()
#define pb emplace_back
#define mp make_pair
#define fi first
#define se second

using namespace std;

typedef long long ll;
typedef vector <int> vi;
typedef pair <int, int> pii;
typedef vector <pii> vii;
typedef vector <long long> vll;

const long long INFll = 2e18;
const int N = 6e5;

vi g[N];
vi t[N];
int ans[N];

void solve() {
    int n, m; cin >> n >> m;
    for (int i = 0; i < m; i++) {
        int x, y, tt; cin >> x >> y >> tt;
        g[x].pb(y); t[x].pb(tt);
        g[y].pb(x); t[y].pb(tt);
    }

    set <pii> q;
    q.insert(mp(0, 1));
    fill(ans, ans + n + 1, 2e9 + 10);
    ans[1] = 0;

    while (!q.empty()) {
        int v = q.begin()->se;
        q.erase(q.begin());
        for (int i = 0; i < g[v].size(); i++) {
            int u = g[v][i], c = t[v][i];
            if (ans[u] > max(c, ans[v])) {
                q.erase(mp(ans[u], u));
                ans[u] = max(c, ans[v]);
                q.insert(mp(ans[u], u));
            }
        }
    }

    for (int i = 2; i <= n; i++)
        cout << ans[i] << "\n";
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    solve();
}
