#include <bits/stdc++.h>

using namespace std;

const int ALF = 26;
const long long MAXC = 5e12, INF = 1e18;

vector<long long> a;

void solve() {
    string s;
    cin >> s;
    long long cnt[ALF] = {};
    for (int i = 0; i < s.size(); i++) {
        if (s[i] != '?') {
            cnt[s[i] - 'A']++;
        } else {
            long long maxsum = -INF;
            int id = -1;
            for (int c = 0; c < ALF; c++) {
                long long local_sum = a[c];
                for (int cc = 0; cc < c; cc++) {
                    local_sum -= a[cc] * cnt[cc];
                }
                for (int cc = c; cc < ALF; cc++) {
                    local_sum += a[cc] * cnt[cc];
                }
                if (local_sum >= maxsum) {
                    id = c;
                    maxsum = local_sum;
                }
            }
            s[i] = 'A' + id;
            cnt[id]++;
        }
        for (int cc = 0; cc < s[i] - 'A'; cc++) {
            cnt[cc] = 0;
        }
    }
    memset(cnt, 0, sizeof(cnt));
    long long sum = 0;
    for (int i = 0; i < s.size(); i++) {
        for (int cc = 0; cc < s[i] - 'A'; cc++) {
            sum -= cnt[cc] * a[cc];
            cnt[cc] = 0;
        }
        cnt[s[i] - 'A']++;
    }
    for (int c = 0; c < ALF; c++) {
        sum += cnt[c] * a[c];
    }
    cout << sum << endl << s << endl;
}

signed main() {
    a.push_back(1);
    int k = 5;
    while (a.back() != MAXC) {
        a.push_back(a.back() * k);
        k = (k == 2 ? 5 : 2);
    }
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}
