#include <iostream>
#include <vector>
//#include <algorithm>

using namespace std;

#define FOR(i, a, b) for(__typeof(b) i = (a); i < (b); ++i)
#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()

//#define int long long

typedef long long ll;
typedef long double ld;
typedef int32_t i32;
typedef pair<int, int> pii;
typedef vector<int> vi;

vector<vector<pii>> g;
vi w, vis, ans;

void dfs(int v, int mx, int mn){
    ans[v] = min(ans[v], mx + mn);
    for(auto [u, i] : g[v]){
        if(vis[i]) continue;
        vis[i] = 1;
        dfs(u, max(mx, w[i]), min(mn, w[i]));
        vis[i] = 0;
    }
}

void solve(){
    int n, m; cin >> n >> m;
    g.resize(n);
    w.resize(m);
    vis.assign(m, 0);
    ans.assign(n, INT32_MAX);
    FOR(i, 0, m){
        int v, u, t; cin >> v >> u >> t;
        v--, u--;
        w[i] = t;
        g[v].emplace_back(u, i);
        g[u].emplace_back(v, i);
    }
    dfs(0, -2e9, 2e9);
    FOR(i, 1, n){
        cout << ans[i] << '\n';
    }
}

i32 main(){
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
//    int t; cin >> t; while(t--) solve();
}