#include <bits/stdc++.h>

#define ll long long
#define pii pair <int, int>
#define vi vector <int>
#define pb push_back
#define all(c) (c).begin(), (c).end()
#define x first
#define y second
#define vpi vector <pii>

using namespace std;

const int N = 3e5 + 7, inf = 2e9 + 7, K = 26;

struct edge{
    int to, w, id;
};

int is[N];

vector <edge> v[N];
int d[N];

int tin[N], fup[N], t = 0, used[N];

void pre(int x, int p) {
    tin[x] = fup[x] = t++;
    used[x] = 1;
    for (auto u : v[x]) {
        if(u.to == p)
            continue;
        if(!used[u.to]) {
            pre(u.to, x);
            fup[x] = min(fup[x], fup[u.to]);
            if(fup[u.to] > tin[x]) {
                is[u.id] = 1;
            }
        }
        else {
            fup[x] = min(fup[x], tin[u.to]);
        }
    }
}

void dfs(int x, int mn) {
    used[x] = 1;
    d[x] = min(d[x], mn);
    for (auto u : v[x]) {
        if(used[u.to])
            continue;
        if(is[u.id]) {
            dfs(u.to, min(mn, u.w));
        }
        else
            dfs(u.to, mn);
    }
}

void solve() {
    int n, m, mn = 2e9;
    cin >> n >> m;
    fill(d, d + n, inf);
    vector <array<int, 3> > e;
    for (int i = 0; i < m; i++) {
        int a, b, w;
        cin >> a >> b >> w;
        a--, b--;
        v[a].pb({b, w, i});
        v[b].pb({a, w, i});
        e.pb({a, b, w});
    }

    pre(0, -1);

    for (int i = 0; i < m; i++) {
        if(!is[i])
            mn = min(mn, e[i][2]);
    }

    for (int i = 0; i < n; i++)
        d[i] = mn;

    fill(used, used + n, 0);
    dfs(0, 2e9);

    for (int i = 1; i < n; i++)
        cout << 1000000000 + d[i] << ' ';

}


signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    solve();
}