#include <bits/stdc++.h>

#define ll long long
#define pii pair <int, int>
#define vi vector <int>
#define pb push_back
#define all(c) (c).begin(), (c).end()
#define x first
#define y second
#define vpi vector <pii>

using namespace std;

const int N = 3e5 + 7, inf = 2e9 + 7, K = 26;

struct edge{
    int to, w, id;
};

int is[N];

vector <edge> v[N];
int d[N];

int tin[N], fup[N], t = 0, used[N];

map <pii, int> mp;

void pre(int x, int p) {
    tin[x] = fup[x] = t++;
    used[x] = 1;
    for (auto u : v[x]) {
        if(u.to == p)
            continue;
        if(!used[u.to]) {
            pre(u.to, x);
            fup[x] = min(fup[x], fup[u.to]);
            if(fup[u.to] > tin[x] && mp[{u.to, x}] == 1) {
                is[u.id] = 1;
            }
        }
        else {
            fup[x] = min(fup[x], tin[u.to]);
        }
    }
}

int p[N], mn[N];

int get(int x) {
    if(p[x] == x)
        return x;
    return p[x] = get(p[x]);
}

vpi r[N];

void dfs(int x, int m) {
    m = min(m, mn[x]);
    d[x] = m;
    used[x] = 1;
    for (auto u : r[x]) {
        if(!used[u.x]) {
            dfs(u.x, min(m, u.y));
        }
    }
}


void solve() {
    int n, m;
    cin >> n >> m;
    fill(d, d + n, inf);
    vector <array<int, 3> > e;
    for (int i = 0; i < m; i++) {
        int a, b, w;
        cin >> a >> b >> w;
        a--, b--;
        v[a].pb({b, w, i});
        v[b].pb({a, w, i});
        mp[{a, b}]++;
        mp[{b, a}]++;
        e.pb({a, b, w});
    }

    pre(0, -1);

    for (int i = 0; i < n; i++) {
        p[i] = i;
        mn[i] = 2e9;
    }

    for (int i = 0; i < m; i++) {
        if(!is[i]) {
            int a = e[i][0], b = e[i][1], w = e[i][2];
            a = get(a);
            b = get(b);
            if (a != b) {
                p[b] = a;
                mn[a] = min(mn[a], mn[b]);
            }
            mn[a] = min(mn[a], w);
        }
    }
    for (int i = 0; i < m; i++) {
        if(is[i]) {
            int a = e[i][0], b = e[i][1], w = e[i][2];
            a = get(a);
            b = get(b);
            r[a].pb({b, w});
            r[b].pb({a, w});
        }
    }
    fill(used, used + n, 0);
    dfs(get(0), 2e9);
    for (int i = 1; i < n; i++)
        cout << d[get(i)] + 1000000000 << ' ';
}


signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    solve();
}