#include <bits/stdc++.h>

using namespace std;

#define next my_next

const int MAXN = 300000, MAXC = 26;
const long long INF = 2e18;

long long cost[26], dp[MAXN + 1][MAXC];
int next[MAXN][MAXC];
char letter[MAXN][MAXC];

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    long long cur = 1, mul = 5;
    for (int i = 0; i < MAXC; i++) {
        cost[i] = cur;
        cur *= mul;
        if (mul == 5) {
            mul = 2;
        } else {
            mul = 5;
        }
    }
    for (int i = 0; i <= MAXN; i++) {
        for (int j = 0; j < MAXC; j++) {
            dp[i][j] = -INF;
        }
    }
    int t;
    cin >> t;
    while (t--) {
        string s;
        cin >> s;
        int n = s.size();
        dp[n][0] = 0;
        for (int i = n - 1; i >= 0; i--) {
            if (s[i] == '?') {
                for (int c = 0; c < MAXC; c++) {
                    for (int j = 0; j <= c; j++) {
                        if (dp[i + 1][j] != -INF && dp[i][c] < dp[i + 1][j] + cost[c]) {
                            next[i][c] = j;
                            letter[i][c] = c + 'A';
                            dp[i][c] = dp[i + 1][j] + cost[c];
                        }
                    }
                    for (int j = c + 1; j < MAXC; j++) {
                        if (dp[i + 1][j] != -INF && dp[i][j] < dp[i + 1][j] - cost[c]) {
                            next[i][j] = j;
                            letter[i][j] = c + 'A';
                            dp[i][j] = dp[i + 1][j] - cost[c];
                        }
                    }
                }
            } else {
                int c = s[i] - 'A';
                for (int j = 0; j <= c; j++) {
                    if (dp[i + 1][j] != -INF && dp[i][c] < dp[i + 1][j] + cost[c]) {
                        next[i][c] = j;
                        letter[i][c] = c + 'A';
                        dp[i][c] = dp[i + 1][j] + cost[c];
                    }
                }
                for (int j = c + 1; j < MAXC; j++) {
                    if (dp[i + 1][j] != -INF && dp[i][j] < dp[i + 1][j] - cost[c]) {
                        next[i][j] = j;
                        letter[i][j] = c + 'A';
                        dp[i][j] = dp[i + 1][j] - cost[c];
                    }
                }
//                cout << dp[i][c] << '\n';
            }
        }
        int id = 0;
        for (int i = 0; i < MAXC; i++) {
            if (dp[0][i] > dp[0][id]) {
                id = i;
            }
        }
        cout << dp[0][id] << '\n';
        for (int i = 0; i < n; i++) {
            cout << letter[i][id];
            id = next[i][id];
        }
        cout << '\n';
        for (int i = 0; i <= n; i++) {
            for (int j = 0; j < MAXC; j++) {
                dp[i][j] = -INF;
            }
        }
    }
    return 0;
}
/*
4
BBBC
????
A?B?C?D
YYYYY?
*/