#include <bits/stdc++.h>

using namespace std;

const int MAXN = 1.5e5;

vector<int> g[MAXN];

map<pair<int, int>, int> type;
int dp[MAXN][4];
bool used[MAXN];

vector<tuple<int, int, int, int>> ans;

void dfs(int v, int prev = -1) {
    used[v] = true;
    vector<int> in, out;
    for (auto &u : g[v]) {
        if (u != prev) {
            dfs(u, v);
            if (type[{v, u}] == 0) {
                if (dp[u][0] == -1) {
                    if (dp[u][1] == -1) {
                        cout << "No\n";
                        exit(0);
                    } else {
                        ans.emplace_back(v, u, u, dp[u][1]);
                    }
                } else {
                    out.emplace_back(u);
                }
            } else if (type[{v, u}] == 1) {
                if (dp[u][0] == -1) {
                    if (dp[u][2] == -1) {
                        cout << "No\n";
                        exit(0);
                    } else {
                        ans.emplace_back(dp[u][2], u, u, v);
                    }
                } else {
                    in.emplace_back(u);
                }
            } else {
                if (dp[u][0] == -1) {
                    if (dp[u][1] == -1 && dp[u][2] == -1) {
                        cout << "No\n";
                        exit(0);
                    }
                    if (dp[u][1]) {
                        ans.emplace_back(v, u, u, dp[u][1]);
                        in.emplace_back(u);
                    } else if (dp[u][2]) {
                        ans.emplace_back(dp[u][2], u, u, v);
                        out.emplace_back(u);
                    } else {
                        cout << "No\n";
                        exit(0);
                    }
                } else {
                    ans.emplace_back(u, v, v, u);
                }
            }
        }
    }
    if (in.size() == out.size()) {
        dp[v][0] = 0;
        for (int i = 0; i < in.size(); i++) {
            ans.emplace_back(in[i], v, v, out[i]);
        }
    } else {
        for (int i = 0; i < min(in.size(), out.size()); i++) {
            ans.emplace_back(in[i], v, v, out[i]);
        }
        if (in.size() == out.size() + 1) {
            dp[v][2] = in.back();
        } else if (in.size() + 1 == out.size()) {
            dp[v][1] = out.back();
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    memset(dp, 255, sizeof(dp));
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; i++) {
        int v, u;
        cin >> v >> u;
        v--, u--;
        if (type.find({u, v}) != type.end()) {
            type[{v, u}] = type[{u, v}] = 2;
        } else {
            type[{v, u}] = 0, type[{u, v}] = 1;
            g[v].emplace_back(u);
            g[u].emplace_back(v);
        }
    }
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            dfs(i);
            if (dp[i][0] == -1) {
                cout << "No\n";
                return 0;
            }
        }
    }
    cout << "Yes\n";
    for (auto &[a, b, c, d] : ans) {
        cout << a + 1 << ' ' << b + 1 << ' ' << c + 1 << ' ' << d + 1 << '\n';
    }
    return 0;
}

/*
5 6
1 2
2 1
1 5
2 3
2 4
4 2

4 4
2 1
2 3
2 4
4 2

4 4
1 2
2 1
3 4
4 3
 */