#include <bits/stdc++.h>

#define endl "\n"
using namespace std;

#define double long double
#define int long long

#ifdef int
#define IMIN INT64_MIN
#define IMAX INT64_MAX
#else
#define IMIN INT32_MIN
#define IMAX INT32_MAX
#endif

#ifdef LOCAL
ifstream fin; // NOLINT(cert-err58-cpp)
#define cin fin
#endif

void dfs(int v, int p, vector<pair<int, int>> *gr, int mx, int mn, int *res) {
    res[v] = mx + mn;
    for (auto gc : gr[v]) {
        int g = gc.first;
        int c = gc.second;
        if (g == p) {
            continue;
        }
        dfs(g, v, gr, max(mx, c), min(mn, c), res);
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<pair<int, int>> gr[n];
    for (int i = 0; i < n; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        a--;
        b--;
        gr[a].emplace_back(b, c);
        gr[b].emplace_back(a, c);
    }
    int res[n];
    dfs(0, -1, gr, IMIN, IMAX, res);
    for (int i = 1; i < n; i++) {
        cout << res[i] << endl;
    }
}

//#define MULTITEST

int32_t main() {
#ifdef LOCAL
    fin.open("in.txt");
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef MULTITEST
    int32_t _t;
    cin >> _t;
    while (_t--)
#endif
    solve();
    return 0;
}
