#include <bits/stdc++.h>

#define endl "\n"
using namespace std;

#define double long double
#define int long long

#ifdef int
#define IMIN INT64_MIN
#define IMAX INT64_MAX
#else
#define IMIN INT32_MIN
#define IMAX INT32_MAX
#endif

#ifdef LOCAL
ifstream fin; // NOLINT(cert-err58-cpp)
#define cin fin
#endif

void solve() {
    int n, m;
    cin >> n >> m;
    vector<pair<int, int>> gr[n];
    for (int i = 0; i < m; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        a--;
        b--;
        gr[a].emplace_back(b, c);
        gr[b].emplace_back(a, c);
    }
    multiset<pair<int, pair<int, int>>> q;
    for (auto gc : gr[0]) {
        q.emplace(gc.second, make_pair(0, gc.first));
    }
    int res[n];
    memset(res, -1, sizeof(res));
    res[0] = 0;

    while (!q.empty()) {
        auto f = *q.begin();
        q.erase(q.begin());
        if (res[f.second.second] != -1) {
            continue;
        }
        res[f.second.second] = max(f.first, res[f.second.first]);
        for (auto gc : gr[f.second.second]) {
            if (res[gc.first] != -1) {
                continue;
            }
            q.emplace(gc.second, make_pair(f.second.second, gc.first));
        }
    }

    for (int i = 1; i < n; i++) {
        cout << res[i] << endl;
    }
}

//#define MULTITEST

int32_t main() {
#ifdef LOCAL
    fin.open("in.txt");
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef MULTITEST
    int32_t _t;
    cin >> _t;
    while (_t--)
#endif
    solve();
    return 0;
}
