#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cmath>
#include <algorithm>
#include <string>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <assert.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
const ll INF = (ll)1e18;
const double PI = acos(-1.0);



int main()
{
	//freopen(".in", "r", stdin);
	//freopen(".out", "w", stdout);
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int tp;
	string s;
	cin >> tp >> s;
	int n = s.size();

	if (tp == 1)
	{
		string t = s;
		for (int i = 0; i < 17; i++)
		{
			int sum = 0;
			for (int j = 1; j <= n; j++)
			{
				if (j & (1 << i))
				{
					sum += (s[j - 1] == '1');
				}
			}
			t += '0' + (sum % 2);
		}
		int sum = 0;
		for (int i = 0; i < 17; i++)
		{
			sum += (t[n + i] == '1');
		}
		t += '0' + (sum % 2);
		cout << t;
	}
	else
	{
		int bad = 0;
		for (int i = 0; i < 17; i++)
		{
			int sum = 0;
			for (int j = 1; j <= n - 18; j++)
			{
				if (j & (1 << i))
				{
					sum += (s[j - 1] == '1');
				}
			}
			if ((sum % 2) != s[n - 18 + i] - '0')
			{
				bad += (1 << i);
			}
		}
		int sum = 0;
		for (int i = 0; i < 17; i++)
		{
			sum += (s[n - 18 + i] == '1');
		}

		string t = s.substr(0, n - 18);
		if ((sum % 2) == s[n - 1] - '0' && bad > 0)
		{
			t[bad - 1] = '0' + (1 - (t[bad - 1] - '0'));
		}
		cout << t;
	}

	return 0;
}