#include <iostream>
#include <string>
#include <vector>

using namespace std;
using ll = long long;

const int p = 179;
const int mod = 13793;
const int LG = 17;

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	int t = 0;
	string s;
	cin >> t >> s;

	int n = s.length();
	if (t == 1)
	{
		string ans = s;
		int numS = 0;
		for (int i = 0; i < n; i++)
			numS = ((ll)numS * p + s[i] - '0') % mod;

		for (int i = 0; i < LG; ++i)
			ans.push_back((numS & 1) + '0'), numS >>= 1;

		cout << ans;
	}
	else
	{
		n -= LG;
		int numS = 0;
		for (int i = 0; i < n; ++i)
			numS = ((ll)numS * p + s[i] - '0') % mod;

		int numS1 = numS;

		string s1;
		for (int i = 0; i < LG; ++i)
			s1.push_back((numS & 1) + '0'), numS >>= 1;

		vector<int> pos;
		for (int i = n; i < s.length(); ++i)
			if (s[i] != s1[i - n])
				pos.push_back(i);

		if (pos.size() == 1)
		{
			s[pos[0]] = '1' - s[pos[0]] + '0';
			cout << s.substr(0, n);
			return 0;
		}

		numS = 0;
		for (int i = s.size() - 1; i >= n; --i)
			numS = (numS * 2 + s[i] - '0');

		vector<int> pPow(n, 1);
		for (int i = n - 2; i >= 0; --i)
			pPow[i] = ((ll)pPow[i + 1] * p) % mod;

		s = s.substr(0, n);
		for (int i = 0; i < n; ++i)
		{
			if (s[i] == '0')
			{
				if ((numS1 + pPow[i]) % mod == numS)
				{
					s[i] = '1';
					cout << s;
					return 0;
				}
			}
			else
			{
				if ((numS1 - pPow[i] + mod) % mod == numS)
				{
					s[i] = '0';
					cout << s;
					return 0;
				}
			}
		}

		cout << s;
	}

	return 0;
}