#include <bits/stdc++.h>

#define int long long
#define all(x) x.begin(), x.end()

using namespace std;

const int mod = 1LL << 17;
int x = 179;

void sol1() {
    string s;
    cin >> s;
    int h = 0;
    for (char el : s) {
        h = (h * x + (el - '0')) % mod;
    }
    for (int i = 0; i < 17; i++) {
        s += '0' + (h % 2);
        h /= 2;
    }
    cout << s << '\n';
}

void sol2() {
    string s;
    cin >> s;
    int n = s.size();
    string res;
    for (int i = 0; i < n - 17; i++) {
        res += s[i];
    }
    int h = 0;
    for (int i = 0; i < 17; i++) {
        h = (h * 2 + (s[n - i - 1] - '0'));
    }
    int now_h = 0;
    for (char el : res) {
        now_h = (now_h * x + (el - '0')) % mod;
    }
    if (now_h == h) {
        cout << res << '\n';
        return;
    }
    int pw = 1;
    for (int i = n - 18; i >= 0; i--) {
        if (s[i] == '0') {
            int val = ((now_h + pw) % mod + mod) % mod;
            if (val == h) {
                res[i] = '1';
                cout << res << '\n';
                return;
            }
        } else {
            int val = ((now_h - pw) % mod + mod) % mod;
            if (val == h) {
                res[i] = '0';
                cout << res << '\n';
                return;
            }
        }
        pw = pw * x % mod;
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t;
    cin >> t;
    if (t == 1) {
        sol1();
    } else {
        sol2();
    }
}