#include <iostream>
#include <vector>
#include <random>
#include <algorithm>

using namespace std;

// mt19937 rnd(777);

// struct node {
// 	node *L = 0, *R = 0;
// 	int x, y = rnd();
// 	node() {}
// 	node(int a) {x = a;} 
// };

// node* merge(node* a, node* b) {
// 	if (a == 0)
// 		return b;
// 	if (b == 0)
// 		return a;

// 	if (a->y > b->y) {
// 		a->R = merge(a->R, b);
// 		return a;
// 	} else {
// 		b->L = merge(a, b->L);
// 		return b;
// 	}
// }

// pair<node*, node*> split(node* a, int k) {
// 	if (a == 0)
// 		return {0, 0};
// 	if (a->x <= k) {
// 		auto z = split(a->R, k);
// 		a->R = z.first;
// 		return {a, z.second};
// 	} else {
// 		auto z = split(a->L, k);
// 		a->L = z.second;
// 		return {z.first, a};
// 	}
// }

// node* insert(node *a, node *b) {
// 	if (a == 0)
// 		return b;
// 	if (a->y > b->y) {
// 		return insert((a->x < b->x) ? a->R : a->L, b);
// 	} else {
// 		auto z = split(a, b->x);
// 		b->L = z.first, b->R = z.second;
// 		return b;
// 	}
// }

// struct SegTree {
// 	vector<int> t, mod;
// 	int n;

// 	void build(int v, int l, int r, vector<int> &a) {
// 		if (r - l == 1) {
// 			t[v] = a[l];
// 			return;
// 		}

// 		int m = (l + r) / 2;
// 		build(v * 2 + 1, l, m, a);
// 		build(v * 2, m, r, a);
// 		t[v] = min(t[v * 2 + 1], t[v * 2]);
// 	}

// 	SegTree(vector<int> a) {
// 		n = a.size();
// 		int sz = 1;
// 		while (sz < 2 * n)
// 			sz *= 2;
// 		t.resize(sz);
// 		mod.resize(sz);
// 		build(1, 0, n, a);
// 	}

// 	int get(int v, int l, int r, int L, int R) {
// 		if (R <= l || r <= L)
// 			return 1e9 + 228;
// 		if (L <= l && r <= R)
// 			return t[v];

// 		int m = (l + r) / 2;
// 		return min(get(v * 2 + 1, l, m, L, R), get(v * 2, m, r, L, R)) + mod[v];
// 	}

// 	void update(int v, int l, int r, int L, int R, int val) {
// 		if (R <= l || r <= L)
// 			return;
// 		if (L <= l && r <= R) {
// 			t[v] += val, mod[v] += val;
// 			return;
// 		}

// 		int m = (l + r) / 2;
// 		update(v * 2 + 1, l, m, L, R, val);
// 		update(v * 2, m, r, L, R, val);
// 		t[v] = min(t[v * 2 + 1], t[v * 2]) + mod[v];
// 	}

// 	int get(int l, int r) {
// 		return get(1, 0, n, l, r);
// 	}

// 	void update(int l, int r, int val) {
// 		update(1, 0, n, l, r, val);
// 	}
// };

// struct dsu {
// 	vector<int> p, sz;
// 	dsu(int n) {
// 		p.resize(n);
// 		sz.resize(n, 1);
// 		iota(p.begin(), p.end(), 0);
// 	}

// 	int get(int a) {
// 		if (a == p[a])
// 			return a;
// 		return p[a] = get(p[a]);
// 	}

// 	void merge(int a, int b) {
// 		a = get(a), b = get(b);
// 		if (a == b)
// 			return;
// 		if (sz[a] < sz[b])
// 			p[a] = b, sz[b] += sz[a];
// 		else
// 			p[b] = a, sz[a] += sz[b];
// 	}
// };

// struct node {
// 	int link = -1, p = -1;
// 	int go[26];
// 	node() {fill(go, go + 26, -1)};
// };

// vector<node> t;

// int add_char(int last, int c) {
// 	int v = t.size();
// 	t.emplace_back();
// 	t[v].p = last;
// 	while (last != -1 && t[last].go[c] == -1) {
// 		t[last].go[c] = v;
// 		last = t[last].link;
// 	}
// 	if (last != -1) {
// 		int now = t[last].go[c];
// 		if (t[now].p == last) {
// 			t[v].link = now;
// 		} else {
// 			int u = t.size();
// 			t.emplace_back();
// 			for (int i = 0; i < 26; ++i)
// 				t[u].go[i] = t[now].go[i];
// 			t[u].p = last, t[now].link = t[v].link = u;
// 			while (last != -1 && t[last].go[c] == now) {
// 				t[last].go[c] = u;
// 				last = t[last].link;
// 			}
// 		}
// 	}
// }

// vector<int> t;
// int n;

// int get(int pos) {
// 	int res = 0;
// 	for (; pos >= 0; pos = (pos & (pos + 1)) - 1)
// 		res += t[pos];
// 	return res;
// }

// void update(int pos, int val) {
// 	for (; pos < n; pos = pos | (pos + 1))
// 		t[pos] += val;
// }

// const int N = 1e5 + 228;
// const int K = 17;

// int sp[K][N];

// for (int i = 0; i < n; ++i)
// 	sp[0][i] = a[i];

// int pw[N];
// for (int i = 2; i < N; ++i)
// 	pw[i] = pw[i / 2] + 1;

// int get(int l, int r) {
// 	int k = pw[r - l];
// 	return min(sp[k][l], sp[k][r - (1 << k)]);
// }

int main() {
	ios_base::sync_with_stdio(0);
	cout.tie(0);
	cin.tie(0);

	int type;
	cin >> type;
	int n;
	cin >> n;
	if (type == 1) {
		__int128_t l = 0, r = n + 1;
		while (r - l > 1) {
			int m = (l + r) / 2;
			cout << m << endl;
			int res;
			cin >> res;
			if (res == 0)
				return 0;
			else if (res == -1)
				r = m;
			else
				l = m;
		}
	} else {
		int q;
		cin >> q;
		int l = 0, r = n + 1;
		for (int i = 0; i < q; ++i) {
			int m = (l + r) / 2;
			int res;
			cin >> res;
			if (res == 0) {
				cout << m << '\n';
				return 0;
			}
			else if (res == -1)
				r = m;
			else
				l = m;
		}
	}
}