#include <iostream>
#include <algorithm>
#include <vector>
#include <iomanip>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <cstring>
#include <string>
#include <queue>
#include <deque>
#include <random>
#include <cassert>
#include <bitset>

#define int long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define ld long double

using namespace std;
inline void fastio() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

const int maxN = 3e5 + 123;
int _2[maxN];
const int mod = (1 << 18) - 123;
void go() {
    _2[0] = 1;
    for (int i = 1; i < maxN; ++i) {
        _2[i] = (_2[i - 1] * 2) % mod;
    }
}

void solve1() {
    string s;
    cin >> s;
    // + 17 chars
    int n = (int) s.size();
    int __2 = 1;
    int sum = 0;
    for (int i = 0; i < n; ++i) {
        sum += __2 * (s[i] - '0');
        __2 *= 2;
        sum %= mod;
        __2 %= mod;
    }
    cout << s;
    for (int i = 0; i < 17; ++i) {
        cout << ((sum >> i) & 1);
    }
}

int get_total(const string &s) {
    int n = (int) s.size();
    int __2 = 1;
    int sum = 0;
    for (int i = 0; i < n; ++i) {
        sum += __2 * (s[i] - '0');
        __2 *= 2;
        sum %= mod;
        __2 %= mod;
    }
    return sum;
}

void inv(char &c) {
    if (c == '0') c = '1'; else c = '0';
}

void solve2() {
    string s;
    cin >> s;
    int n = (int) s.size();
    int ss = 0;
    int __2 = 1;
    for (int i = n - 17; i < n; ++i) {
        ss += __2 * (s[i] - '0');
        __2 *= 2;
        ss %= mod;
        __2 %= mod;
    }
    for (int i = 0; i < 17; ++i) {
        s.pop_back();
    }
    int sum = get_total(s);
    if (ss == sum) {
        cout << s << '\n';
        return;
    }
    n -= 17;
    for (int i = 0; i < n; ++i) {
        sum -= _2[i] * (s[i] - '0');
        sum += mod;
        sum %= mod;
        inv(s[i]);
        sum += _2[i] * (s[i] - '0');
        sum += mod;
        sum %= mod;
        if (sum == ss) {
            cout << s << '\n';
            return;
        }
        sum -= _2[i] * (s[i] - '0');
        sum -= mod;
        sum %= mod;
        inv(s[i]);
        sum += _2[i] * (s[i] - '0');
        sum += mod;
        sum %= mod;
    }
    cout << s << '\n';
}

signed main() {
#ifdef lolipop
    freopen("input.txt", "r", stdin);
#else
    fastio();
#endif
    int T;
    go();
    cin >> T;
    if (T == 1) {
        solve1();
    } else {
        solve2();
    }
    return 0;
}