#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

using namespace std;

#define double long double

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n = 500;
    double matr[n][n];
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            matr[i][j] = 0;
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            int a = rand() % 100000;
            int b = rand() % 100000 + 1;
            matr[i][j] = matr[j][i] = a * 1.0 / b;
        }
    }
    for (int k = 0; k < n; ++k) {
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n; ++j) {
                matr[i][j] = min(matr[i][j], matr[i][k] + matr[k][j]);
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            cout << matr[i][j] << ' ';
        }
        cout << endl;
    }
}