#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <algorithm>
typedef long long LL;

using namespace std;

void solveSmall1(string s) {
	string ans = "";

	for (int i = 0; i < s.length(); i++)
	{
		for (int j = 0; j < 3; j++)
		{
			ans += s[i];
		}
	}

	cout << ans << endl;
}

void solveSmall2(string s) {
	string ans = "";
	for (int i = 0; i < s.length() / 3; i++)
	{
		int cnt0 = 0, cnt1 = 0;
		for (int j = 0; j < 3; j++)
		{
			if (s[i * 3 + j] == '0') {
				cnt0++;
			}
			else {
				cnt1++;
			}
		}

		if (cnt0 > cnt1) {
			ans += '0';
		}
		else {
			ans += '1';
		}
	}

	cout << ans << endl;
}

void solveFirst(string s) {
	if (s.length() == 10) {
		solveSmall1(s);
	}
	string ans = s;

	LL zerosums = 0;
	for (int i = 0; i < s.length(); i++)
	{
		if (s[i] == '0') {
			zerosums += i + 1;
		}
	}

	for (int i = 0; i < 17; i++)
	{
		int q = (zerosums >> i) % 2;
		ans += ('0' + q);
		ans += ('0' + q);
		ans += ('0' + q);
	}

	cout << ans << endl;
}

void solveSecond(string s) {
	if (s.length() == 30) {
		solveSmall2(s);
	}
	LL zerosums = 0;
	LL rightsums = 0;

	for (int i = 0; i < s.length() - 17; i++)
	{
		if (s[i] == '0') {
			zerosums += i + 1;
		}
	}

	for (int i = 0; i < 17; i++)
	{
		int fIdx = s.length() - 51 + i * 3;
		int cnt0 = 0, cnt1 = 0;
		for (int j = 0; j < 3; j++)
		{
			if (s[fIdx + j] == '0') {
				cnt0++;
			}
			else {
				cnt1++;
			}
		}

		int c = cnt0 > cnt1 ? 0 : 1;

		rightsums += (1ll <<(i - s.length() + 17)) * c;
	}

	//cout << rightsums << endl;

	string ans = "";

	for (int i = 0; i < s.length() - 17; i++)
	{
		ans += s[i];
		if (zerosums > rightsums) {
			if (s[i] == '0') {
				if (zerosums - i - 1 == rightsums) {
					ans[i] = '1';
					zerosums -= i;
				}
			}
		}
		if (zerosums < rightsums) {
			if (s[i] == '1') {
				if (zerosums + i + 1 == rightsums) {
					ans[i] = '0';
					zerosums += i;
				}
			}
		}
	}

	cout << ans << endl;
}

int main() {
	int type;
	cin >> type;
	string s;
	cin >> s;

	string ans = "";

	if (type == 1) {
		solveFirst(s);
	}
	else {
		solveSecond(s);
	}

	return 0;
}