#include <bits/stdc++.h>
using namespace std;

using ll = long long;
#define vec vector
#define ar array

#define all(a) (a).begin(), (a).end()
#define len(a) ((int)((a).size()))

template<typename A, typename B>
ostream& operator<<(ostream &out, pair<A, B> p) { return out << '(' << p.first << ", " << p.second << ')'; }

template<typename A, typename B = typename enable_if<!is_same<A, string>::value, typename A::value_type>::type>
ostream& operator<<(ostream &out, A vec) { out << '{'; string sep; for (auto x : vec) out << sep << x, sep = ", "; return out << '}'; }

void dbg_print() { cerr << endl; }
template<typename A, typename...B> void dbg_print(A a, B... b) { cerr << ' ' << a; dbg_print(b...); }

#ifdef LOCAL
	#define dbg(...) cerr << '#' << __LINE__ << " [" << #__VA_ARGS__ << "]:", dbg_print(__VA_ARGS__)
#else
	#define dbg(...)
#endif

const int mx = 1e5;
const int md = 103743;
const int lg = 17;
const int base = 239;
const int where = 1582;
const string kek = "101001110101";

inline string to_binary_string(int x) {
	string s(lg, 0);
	for (int i = 0; i < lg; i++) {
		s[i] = (x >> i) % 2 + '0';
	}
	return s;
}

int main() {
	ios::sync_with_stdio(false), cin.tie(nullptr);

	int t;
	cin >> t;
	if (t == 1) {
		string s;
		cin >> s;
		if (len(s) * 3 <= mx) {
			cout << kek + s + s + s << '\n';
		} else {
			assert(len(s) > where);
			int hash = 0;
			for (auto c : s) {
				hash *= base;
				hash %= md;
				hash += c;
				hash %= md;
			}
			string cur = to_binary_string(hash);
			cout << s.substr(0, where) << cur << s.substr(where, len(s) - where);
		}
	} else {
		string s;
		cin >> s;
		int n = len(s);
		if (len(s) > len(kek) && s.substr(0, len(kek)) == kek) {
			s.erase(s.begin(), s.begin() + len(kek));
			n -= len(kek);
			assert(n % 3 == 0);
			for (int i = 0; i < n / 3; i++) {
				int a = s[i] - '0';
				int b = s[i + n / 3] - '0';
				int c = s[i + 2 * (n / 3)] - '0';
				if (a == b && b == c) {
					cout << a;
				} else {
					cout << !(a ^ b ^ c);
				}
			}
			cout << '\n';
		} else {
			string hash = s.substr(where, lg);
			int need = 0;
			for (int i = 0; i < lg; i++) {
				need = need * 2 + hash[i] - '0';
			}
			s.erase(s.begin() + where, s.begin() + where + lg);
			n -= lg;
			int cur_hash = 0;
			for (auto c : s) {
				cur_hash *= base;
				cur_hash %= md;
				cur_hash += c;
				cur_hash %= md;
			}
			vec<int> powers(n + 1, 1);
			for (int i = 1; i <= n; i++) {
				powers[i] = powers[i - 1] * base % md;
			}
			for (int i = 0; i < n; i++) {
				int without = cur_hash - s[i] * powers[n - 1 - i] % md;
				int with = without + (s[i] == '0' ? '1' : '0') * powers[n - 1 - i] % md;
				with = (with % md + md) % md;
				if (with == need) {
					s[i] = (s[i] == '0' ? '1' : '0');
					cout << s << '\n';
					return 0;
				}
			}
			cout << s << '\n';
		}
	}
}
