#pragma GCC target("avx2")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <immintrin.h>
using namespace std;
using namespace __gnu_pbds;

#define x first
#define y second
#define all(x) begin(x), end(x)
#define sz(x) ((int) (x).size())
typedef long long ll;
typedef long double ld;

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

template<typename T>
using normal_queue = priority_queue<T, vector<T>, greater<T>>;

const int N = 1000;

unsigned c[N][N];

mt19937 rnd;

signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	int a, b;
	cin >> a >> b;

	__m256i x = _mm256_set1_epi32(a),
			y = _mm256_set1_epi32(b);
	x = _mm256_add_epi32(x, y);
	int ans[8];
	_mm256_storeu_si256((__m256i*) ans, x);
	cout << ans[0];

	for (int i = 0; i < N; ++i)
		for (int j = 0; j < N; ++j)
			c[i][j] = rnd();
	for (int i = 0; i < N; ++i)
		for (int j = 0; j < N; ++j)
			for (int h = 0; h < N; ++h)
				c[j][h] = min(c[j][i] + c[i][h], c[j][h]);
	return 0;
}