#include "bits/stdc++.h"
#include "ext/rope"
#include "ext/pb_ds/assoc_container.hpp"
#include "ext/pb_ds/tree_policy.hpp"

using namespace std;
using namespace __gnu_cxx;
using namespace __gnu_pbds;

typedef long long ll;
typedef long double ld;
typedef tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update, allocator<char>> ordered_set;

#define speed ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define all(x) x.begin(), x.end()

//const int MAX_MEM = 2e8;
//int mpos = 0;
//char mem[MAX_MEM];
//
//inline void* operator new(size_t n) {
//    char* res = mem + mpos;
//    mpos += n;
//    assert(mpos < MAX_MEM);
//    return res;
//}
//
//inline void operator delete(void* a) {}

void solve();

signed main() {
    int t1 = clock();
    solve();
    int t2 = clock();
    cerr << t2 - t1 << " ms\n";
}

void solve() {
    vector<int> das = {1, 2, 3};
    rope<int> oo;
    oo.insert(1);
    oo.insert(3);
    oo.insert(2);

    assert(oo.substr(1, 1).size() == 1);

    ordered_set uu;
    vector<int> add = {1, 2, 3, 4, 4, 5, 5, 2};
    for (int e : add)
        uu.insert(e);
    assert(uu.order_of_key(4) == 3);

    // floyd
    int n = 1700;
    srand(24467854);
    vector<vector<int>> graph(n, vector<int>(n));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++)
            graph[i][j] = rand() % 1000;
    }

    for (int i = 0; i < n; i++)
        for (int j = 0; j < n; j++)
            for (int k = 0; k < n; k++)
                graph[i][j] = min(graph[i][j], graph[i][k] + graph[k][j]);

    if (graph[0][1] == 239566)
        cout << "GOVNO\n";

    ll a, b;
    cin >> a >> b;
    cout << a + b << '\n';
}