#include "bits/stdc++.h"
#include "ext/rope"
#include "ext/pb_ds/assoc_container.hpp"
#include "ext/pb_ds/tree_policy.hpp"

using namespace std;
using namespace __gnu_cxx;
using namespace __gnu_pbds;

typedef long long ll;
typedef long double ld;
typedef tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update, allocator<char>> ordered_set;

#define speed ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define all(x) x.begin(), x.end()

#ifndef LOCAL_BUILD
#pragma GCC optimize("Ofast,unroll-loops,fast-math")
#pragma GCC optimize("O3")
#endif

const int MAX_MEM = 2e8;
int mpos = 0;
char mem[MAX_MEM];

inline void* operator new(size_t n) {
    char* res = mem + mpos;
    mpos += n;
    assert(mpos < MAX_MEM);
    return res;
}

inline void operator delete(void* a) {}

void solve();

signed main() {
    int t1 = clock();
    solve();
    int t2 = clock();
    cerr << t2 - t1 << " ms\n";
}

void solve() {
    int n;
    cin >> n;
    int l = 1, r = n + 1;
    while (r - l > 1) {
        int mid = (l + r) / 2;
        cout << mid << endl;
        int res;
        cin >> res;
        if (res == -1)
            r = mid;
        else if (res == 1)
            l = mid;
        else
            return;
    }
    cout << l << endl;
}