#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include "bits/stdc++.h"

using namespace std;

#define ll long long
#define vi vector<ll>
#define pb push_back
#define mp make_pair
#define pii pair<ll, ll>
#define vvi vector<vi>
#define mn(a, b) a = min(a, b)
#define mx(a, b) a = max(a, b)
#define all(x) x.begin(), x.end()
#define ld long double

const ll INF = 2e9;
const ll inf = 1e18;
const ld eps = 1e-12;
const ld pi = atan2(0, -1);


istream &operator >>(istream &in, pii &x) {
    cin >> x.first >> x.second;
    return in;
}

ostream &operator <<(ostream &out, pii &x) {
    cout << x.first << " " << x.second << "\n";
    return out;
}

template <class T>
istream &operator >>(istream &in, vector<T> &a) {
    for (T &i : a) in >> i;
    return in;
}

template <class T>
ostream &operator <<(ostream &out, vector<T> &a) {
    for (T &i : a) out << i << " ";
    out << "\n";
    return out;
}

vi norm(string s) {
    reverse(all(s));
    vi ret(s.size());
    for (int i = 0; i < s.size(); ++i) ret[i] = s[i] - '0';
    return ret;
}

bool comp(vi a, vi b) {
    if (a.size() < b.size()) a.resize(b.size());
    else b.resize(a.size());
    for (int i = b.size() - 1; i > -1; --i) {
        if (a[i] < b[i]) return 1;
        if (a[i] == b[i]) continue;
        if (a[i] > b[i]) return 0;
    }
    return 0;
}

vi pls(vi a, vi b) {
    int car = 0;
    vi ret(max(a.size(), b.size()) + 1);
    if (a.size() < b.size()) a.resize(b.size());
    else b.resize(a.size());
    a.push_back(0);
    b.push_back(0);
    for (int i = 0; i < a.size(); ++i) {
        ret[i] = (a[i] + b[i] + car) % 10;
        car = (a[i] + b[i] + car) / 10;
    }
    return ret;
}

vi mns(vi a, vi b) {
    for (int i = 0; i < min(a.size(), b.size()); ++i) {
        if (a[i] < b[i]) a[i] += 10, a[i - 1]--;
        a[i] -= b[i];
    }
    return a;
}

void out(vi a, bool minus) {
    while (a.size() && a.back() == 0) a.pop_back();
    if (a.size() == 0) cout << 0;
    if (minus) {
        cout << '-';
    }
    reverse(all(a));
    for (int i : a) cout << i;
}

void solve() {
    string a, b; cin >> a >> b;
    if (a[0] == '-' && b[0] == '-') {
        a.erase(a.begin());
        b.erase(b.begin());
        vi f = norm(a), s = norm(b);
        out(pls(f, s), 1);
        return;
    }
    if (b[0] == '-' && a[0] != '-') swap(a, b);
    if (a[0] == '-' && b[0] != '-') {
        a.erase(a.begin());
        vi f = norm(a), s = norm(b);
        if (comp(s, f)) out(mns(f, s), 1);
        else out(mns(s, f), 0);
        return;
    } else {
        vi f = norm(a), s = norm(b);
        out(pls(f, s), 0);
        return;
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#endif

    cout.precision(30);
    solve();

    return 0;
}
