#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
//#pragma GCC optimize("avx,sse,sse2,ssse3,sse4,popcnt,unroll-loops")

using namespace std;

#define ll int
#define ld long double

mt19937 rng(1234);

ll rnd(ll l, ll r) {
    uniform_int_distribution<ll> gen(l, r);
    return gen(rng);
}

const int N = 1000;
int g[N][N];

void solve() {
    for (int i = 0; i < N; i++) {
        for (int j = 0; j < N; j++) {
            if (i == j) {
                continue;
            }
            g[i][j] = (i + j * i + 4);
        }
    }
    for (int k = 0; k < N; k++) {
        for (int j = 0; j < N; j++) {
            for (int i = 0; i < N; i++) {
                g[i][j] = min(g[i][j], g[i][k] + g[k][j]);
            }
        }
    }
    if (g[0][N - 1] == 28313) {
        return;
    }
    vector<ll> arr;
    ll x;
    while (cin >> x) {
        arr.push_back(x);
    }
    reverse(arr.begin(), arr.end());
    for (auto i : arr) {
        cout << i << " ";
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    solve();
    return 0;
}
