#include<iostream>
#include<vector>
#include<cmath>

using namespace std;

typedef long long int ll;

void swap(ll a, ll b) {
	ll c = a;
	a = b;
	b = c;
}

void out_vec(vector<ll>& a) {
	for (ll i = 0; i < a.size(); i++) cout << a[i];
	cout << endl;
}

void reverse(vector<ll>& s) {
	for (ll i = 0; 2 * i < s.size(); i++) {
		ll t = s[s.size() - i - 1];
		s[s.size() - i - 1] = s[i];
		s[i] = t;
	}
}

void plus_and_out(string s1, string s2) {
	vector<ll> a1(0);
	for (ll i = 0; i < s1.size(); i++) {
		a1.push_back(int(s1[i] - '0'));
	}
	vector<ll> a2(0);
	for (ll i = 0; i < s2.size(); i++) {
		a2.push_back(int(s2[i] - '0'));
	}
	//out_vec(a1);
	//out_vec(a2);
	reverse(a1);
	reverse(a2);
	//out_vec(a1);
	//out_vec(a2);
	if (a1.size() > a2.size()) {
		vector<ll> res(a1.size() + 1, 0);
		for (ll i = 0; i < a1.size(); i++) res[i] += a1[i];
		for (ll i = 0; i < a2.size(); i++) {
			res[i] += a2[i];
			if (res[i] > 9) {
				res[i] -= 10;
				res[i + 1]++;
			}
		}
		if (res[a1.size()] == 0) res.pop_back();
		reverse(res);
		for (ll i = 0; i < res.size(); i++) cout << res[i];
	}
	else {
		vector<ll> res(a2.size() + 1, 0);
		for (ll i = 0; i < a2.size(); i++) res[i] += a2[i];
		for (ll i = 0; i < a1.size(); i++) {
			res[i] += a1[i];
			if (res[i] > 9) {
				res[i] -= 10;
				res[i + 1]++;
			}
		}
		if (res[a2.size()] == 0) res.pop_back();
		reverse(res);
		for (ll i = 0; i < res.size(); i++) cout << res[i];
	}
}

ll string_to_ll(string s) {
	ll t = 0;
	if (s[0] == '-') {
		for (ll i = 1; i < s.size(); i++) t = (t * 10) + (s[i] - '0');
		t *= -1;
		return t;
	}
	else {
		for (ll i = 0; i < s.size(); i++) t = (t * 10) + (s[i] - '0');
		return t;
	}
}

int main() {
	string s1, s2;
	cin >> s1 >> s2;
	if (((s1[0] == '-' && s1.size() < 11) || s1.size() < 10) && ((s2[0] == '-' && s2.size() < 11) || s2.size() < 10)) {
		ll a = string_to_ll(s1), b = string_to_ll(s2);
		cout << a + b;
	}
	else {
		plus_and_out(s1, s2);
	}
}


