#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

void solve1() {
	int n;
	cin >> n;

	long long l = 1, r = n;
	while (l < r) {
		long long mid = (l + r) / 2;
		cout << mid << endl;
		int q;
		cin >> q;
		if (q == 0)
			return;
		if (q == 1)
			l = mid + 1;
		else
			r = mid;
	}
	cout << l << endl;
	int q;
	cin >> q;
	return;
}

void solve2() {
	int n;
	cin >> n;
	int q;
	cin >> q;
	vector < int > a(q);
	for (auto& e : a) cin >> e;
	int l = 1, r = n;
	for (int i = 0; i < q; i++) {
		int mid = (l + r) / 2;
		if (a[i] == 0) {
			cout << mid << endl;
			return;
		}
		if (a[i] == 1)
			l = mid + 1;
		else
			r = mid;
	}
	cout << l << endl;
}

int main()
{
	int t;
	cin >> t;

	if (t == 1)
		solve1();
	else
		solve2();
}