#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#define int long long

#define all(c) (c).begin(), (c).end()
#define sqr(c) (c) * (c)
#define x first
#define y second
#define ld long double
#define ll long long
#define vi vector <int>
#define pb push_back
#define vld vector <ld>
#define pii pair <int, int>
#define vpi vector <pii>

using namespace std;
using namespace __gnu_pbds;

template <typename T1, typename T2>
void amin(T1 &a, T2 b) {
    if(a > b)
        a = b;
}

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

clock_t START;

void TIME() {
    auto CUR = clock();
    cout << fixed << setprecision(4) << ' ' << (ld) (CUR - START) / CLOCKS_PER_SEC << endl;
}

const int N = 100000, C = 17;

int a[N];

void solve() {
    int t;
    cin >> t;
    if(t == 1) {
        string s;
        cin >> s;
        int cur = 0, pw = (1 << C);
        for (int i = 0; i < s.size(); i++) {
            if(s[i] == '1') {
                cur += i;
                cur %= pw;
            }
        }

        cout << s << bitset<C>(cur);

    }
    else {
        string s;
        cin >> s;
        int cur = 0, need = 0, pw = 1;
        {
            for (int i = 0; i < C; i++) {
                if (s[s.size() - i - 1] == '1') {
                    need += pw;
                }
                pw *= 2;
            }
            for (int i = 0; i < s.size() - C; i++) {
                if (s[i] == '1') {
                    cur += i;
                    cur %= pw;
                }
            }
            if (cur == need) {
                for (int i = 0; i < s.size() - C; i++)
                    cout << s[i];
                return;
            }
            for (int i = 0; i < s.size() - C; i++) {
                if (s[i] == '0') {
                    int now = (cur + i) % pw;
                    if (now == need) {
                        s[i] = '1';
                        for (int j = 0; j < s.size() - C; j++)
                            cout << s[j];
                        break;
                    }
                } else {
                    int now = (cur - i + pw) % pw;
                    if (now == need) {
                        s[i] = '0';
                        for (int j = 0; j < s.size() - C; j++)
                            cout << s[j];
                        break;
                    }
                }
            }
        }
        assert(0);
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    solve();
}
