#pragma comment(linker, "/STACK:1000000000")
#pragma GCC optimize("O3")
#pragma GCC optimize("Ofast")
#pragma GCC target("avx,avx2,fma")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;
using namespace std;

const int MAX_MEM = 1e8;
int mpos = 0;
char mem[MAX_MEM];
inline void * operator new(size_t n) {
    assert((mpos += n) <= MAX_MEM);
    return (void *) (mem + mpos - n);
}
inline void operator delete (void *) noexcept {}
#define int long long
#define sz(a) (int) (a).size()
#define all(a) (a).begin(), (a).end()
#define x first
#define y second
#define debug(x) cout << #x << ": " << x << "\n";
#define sqr(a) (a) * (a)

template<class t, class u> bool amax(t &a, u b) {if (a < b) {a = b; return true;} return false;}
template<class t, class u> bool amin(t &a, u b) {if (a > b) {a = b; return true;} return false;}
template<class t> using vc = vector<t>;
template<class t> using vvc = vector<vector<t>>;

using pi = pair<int, int>;
using vi = vc<int>;
using vpi = vc<pi>;

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

gp_hash_table<int, int> mp;
cc_hash_table<int, int> mp2;

const int maxn = 920;
const int inf = 1e9;

int dp[maxn][maxn];

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
//    freopen("input.txt", "r", stdin);

    for (int i = 0; i < maxn; i++) {
        for (int j = 0; j < maxn; j++) {
            dp[i][j] = inf;
            if (i == j) dp[i][j] = rnd();
        }
    }
    for (int k = 0; k < maxn; k++) {
        for (int i = 0; i < maxn; i++) {
            for (int j = 0; j < maxn; j++) {
                amin(dp[i][j], dp[i][k] + dp[k][j]);
            }
        }
    }
    int a, b;
    cin >> a >> b;
    cout << a + b << "\n";


    return 0;
}
